unit Foreval;

{******************************************************************************}
{                                                                              }
{               SOREL  (C)CopyRight 2000. Russia                               }
{                                                                              }
{                          TForeval interface unit.(component)                 }
{                               ver. 8.4.17.249                                }
{******************************************************************************}


{      "USEDLL"   Foreval_Lib.pas}


{At package compilation to disable  key "USEDLL" in Foreval_Lib.pas unit}

 //{$RangeChecks Off}
 //{$OverFlowChecks Off}
 //{$ZEROBASEDSTRINGS Off}
{$R-}
{$Q-}


interface


uses
Classes,Foreval_Lib;

type
TExternalException = procedure ;



type
TAddFuncStruct =Foreval_Lib.TAddFuncStruct;
{
type
TAddFuncStruct = record
                  addr:  Pointer;
                   Arg:  Cardinal;
              CallType:  Cardinal;
               ArgType:  Cardinal;
           ArgTypeList:  Pointer;
            ClearStack:  Cardinal;
                 Arrow:  Cardinal;
               DeepFPU:  Cardinal;
                Set_ID:  Cardinal;
               Id_Func:  Cardinal;
               SaveReg:  Cardinal;
            CodeInline:  Pointer;
              SizeCode:  Cardinal;
              AdrDeriv:  Pointer;
                NDeriv:  Cardinal;
             CalcConst:  Cardinal;
                RetNum:  Cardinal;
              ReplFunc:  Cardinal;
                 Rsrv1:  Cardinal;
                 Rsrv2:  Cardinal;
                 Rsrv3:  Cardinal;
                  end;
}

type
TAttrib = record
           Adr:   Cardinal;
           RType: Cardinal;
          end;

const
{flSet}
fl_DISABLE              = 0;
fl_ENABLE               = 1;
fl_AUTO                 = 2;
fl_YES                  = 3;
fl_NO                   = 4;
fl_SYNTAX_EXTENSION     = 10;
fl_LEAD_TO_LOWER_CASE   = 11;       {.245}
fl_CALC_CONST_EXPR_IN_MULTI_EXPR = 12;   {.245}
fl_CALC_CONST_FUNC      = 13;
fl_EXTERNAL_EXCEPTION   = 14;
fl_REPLACE_FUNCTION     = 15;
fl_DINAMIC_LOAD         = 16;
fl_SAVE_EAX             = 17;
fl_SAVE_EBX             = 18;
fl_SAVE_ECX             = 19;
fl_SAVE_EDX             = 20;
fl_SAVE_ESP             = 21;
fl_SAVE_EBP             = 22;
fl_SAVE_ESI             = 23;
fl_SAVE_EDI             = 24;
fl_STACK_DEEP           = 25;
fl_SINGLE               = 26;
fl_INTEGER              = 27;
fl_DOUBLE               = 28;
fl_EXTENDED             = 29;
fl_DIFFER               = 30;
fl_DATA_TYPE            = 31;
fl_PARAM_TYPE           = 32;
fl_SKIPPED_IF           = 33;  {.243}
fl_EXCHANGE_BRANCH      = 34;
fl_GLOBAL_OPTIMIZATION  = 35;
fl_SET_ID               = 36;
fl_CLST                 = 37;
fl_ADDRESS              = 38;
fl_INLINE               = 39;
fl_FUNC_STACK_DEEP      = 40;
fl_FUNC_ID              = 41;
fl_NUM_ARG              = 42;
fl_ARROW                = 43;
fl_ARG_TYPE             = 44;
fl_ARG_TYPE_LIST        = 45;
fl_SAVE_REG             = 46;
fl_CALL_TYPE            = 47;
fl_CLEAR                = 48;
fl_PARAM_LIST           = 49;
fl_VAR_LIST             = 50;
fl_FREE                 = 51;
fl_ADD_FUNC_LIST        = 54;
fl_CMPL_FUNC_LIST       = 55;
fl_CLEAR_NAMES_FUNC     = 56;
fl_EAX                  = 57;
fl_EBX                  = 58;
fl_ECX                  = 59;
fl_EDX                  = 60;
fl_ESP                  = 61;
fl_STRING_TYPE          = 62;
fl_STRING               = 63;
fl_STRING_UTF16         = 63;
fl_PCHAR                = 64;
fl_ANSISTRING           = 65;
fl_CLOSE_ARG            = 66;
fl_PACKAGE_COMPILE      = 67;
fl_TRIG_OPTIMIZATION    = 68;
fl_HYP_OPTIMIZATION     = 69;
fl_SHOW_EXCEPTION       = 99;
fl_ARRAY_DOUBLE         = 70;
fl_ARRAY_EXTENDED       = 71;
fl_ARRAY_SINGLE         = 72;
fl_ARRAY_INTEGER        = 73;
fl_STRING_INTERNAL      = 74;
fl_ERROR_CODE           = 75;
fl_VAR_PRESENT          = 76;
fl_CALC_CONST_EXPR      = 77;
fl_WIDESTRING           = 78;
fl_PWIDECHAR            = 79;
fl_PANSICHAR            = 80;
fl_RawByteString        = 81;
fl_FUNCTION             = 82;
fl_EXTENDED_COMMAND     = 83;  //procedure: if, for, fordown, while
fl_STRING_UTF8          = 84;
fl_SAVE                 = 85;
fl_RESTORE              = 86;
fl_Diff_Num_Precision   = 87;
fl_REPLACE_MULDIV       = 88; {.199}
fl_REPLACE_ADDSUB       = 89; {.199}
fl_REPLACE_OPERATION    = 90;
fl_REPLACE_MULTI_EXPR   = 91;
fl_USE_VIRTUAL_ALLOC    = 92;   //only for exe code
fl_REPLACE_ARGF         = 93;
fl_ACCURATE_SPEC_FUNC   = 94;
fl_CHECK_INCORRECT_SPACE  = 95;  {.203}
fl_REPLACE_AT_IF        = 96; {.205}
fl_CONVERT_ATAN_TO_ATAN2  = 97; {.209}
fl_FPU_CW                 = 98; {.209}
fl_FPU_CW_DEFAULT         = 99; {.209} { = $1372 }
fl_MULDIV_OPTIMIZATION    = 100; {.243}
fl_ADDSUB_OPTIMIZATION    = 101; {.243}
fl_PRECISION              = 102; {.243}
fl_MASK_FPU_EXCEPTION     = 103;  {.248}
fl_CLEAR_FPU_EXCEPTION    = 104;  {.248}
fl_FUNC_ARG_OPTIMIZATION  = 105;  {.249}
fl_ADDRESS_EXCEPTION_FLAG = 106; {.249}
fl_FREE_CODE_AT_REPLACE   = 107; {.249}







{flAddNewFunction}
fl_MEMORY_EAX           = 100;
fl_MEMORY_EBX           = 101;
fl_MEMORY_ECX           = 102;
fl_MEMORY_EDX           = 103;
fl_MEMORY_STACK_CPU     = 104;
fl_KERNEL_I             = 105;
fl_KERNEL_F             = 106;
fl_KERNEL_FI            = 107;
fl_KERNEL_FF            = 108;
fl_STACK_FPU            = 109;
fl_STACK_CPU            = 110;
fl_INFINITE_EABX        = 111;
fl_INFINITE_EBCX        = 112;
fl_INFINITE_ECDX        = 113;
fl_INFINITE_STACK_CPU   = 114;
fl_RIGHT                = 115;
fl_BACK                 = 116;
fl_UNKNOWN              = 117;
fl_MEMORY_ADDRESSES     = 118;
fl_PRECOMPILED          = 119;



{flGetErrorCode}
fl_ACCESS_VIOLATION           = 200;
fl_OUT_OF_MEMORY              = 201;
fl_STACK_OVERFLOW             = 202;
fl_ZERO_DIVIDE                = 203;
fl_INVALID_OPERATION          = 204;
fl_OVERFLOW                   = 205;
fl_UNDERFLOW                  = 206;
fl_INT_OVERFLOW               = 207;
fl_UNKNOWN_SYMBOL             = 208;
fl_MISSING_ROUND_BRACKET      = 209;
//fl_MISSING_RIGHT_BRACKET      = 210;
fl_MISSING_OPERATION          = 211;
fl_WRONG_NUMBER_ARGUMENTS     = 212;
fl_MISSING_EXPRESSION         = 213;
fl_UNKNOWN_FUNCTION           = 214;
fl_ERROR_AT_ADDITION_FUNCTION = 215;
fl_NONEXISTENT_FUNCTION       = 216;
fl_INCORRECT_ARGUMENT         = 217;
fl_MISSING_ARGUMENT           = 218;
fl_INCORRECT_TYPE             = 219;
fl_SPLAIN_DATA_ERROR          = 220;
fl_MISSING_SEPARATOR          = 221;
fl_WRONG_NAME                 = 222;
fl_MISSING_ABS_BRACKET        = 223;
fl_MISSING_SQUARE_BRACKET     = 224;
fl_MISSING_CURLY_BRACKET      = 225;
fl_NO_DIFF_EXPRESSION         = 226;
fl_WRONG_EXPRESSION           = 227;
fl_INCORRECT_SPACE            = 228;  {.203}
fl_INTERNAL_ERROR             = 229;  {.211}
fl_VARIABLE_REDECLARED        = 230;  {.245}



{flGet}
fl_VERSION                         = 301;
fl_MAJOR                           = 302;
fl_MINOR                           = 303;
fl_RELEASE                         = 304;
fl_ABOUT                           = 305;
fl_AUTHOR                          = 306;
fl_EXCHANGE_BRANCH_STACK_DEEP      = 316;
fl_EXCHANGE_BRANCHE_NUM            = 317;
fl_DINAMIC_LOAD_STACK_DEEP         = 318;
fl_DINAMIC_LOAD_NUM                = 319;
fl_DINAMIC_LOAD_OVFL               = 320;
fl_COMPILE_STACK_DEEP              = 321;
fl_COMPILE_OVFL                    = 322;
fl_REPLACE_FUNCTION_NUM            = 323;
fl_CALC_CONST_NUM                  = 324;
fl_USE_EAX                         = 325;
fl_USE_EBX                         = 326;
fl_USE_ECX                         = 327;
fl_USE_EDX                         = 328;
fl_USE_ESP                         = 329;
fl_USE_EBP                         = 330;
fl_USE_ESI                         = 331;
fl_USE_EDI                         = 332;
fl_MAX_REPLACE_LEVEL               = 333;
fl_LENGTH_CODE                     = 334;
fl_PACKAGE_COMPILE_LAST_ADDR       = 335;
fl_PRECOMPILED_LAST_ADDR           = 336;
fl_ARRAY_LENGTH                    = 337;
fl_BUILD                           = 338;
fl_REPLACE_FUNCTION_NUM_UT         = 339;
fl_COMPILED_BY                     = 340;
fl_SHOW                            = 341;
fl_LAST_STRING                     = 342;
fl_RETURN_NUMBER                   = 343;
fl_ADDRESS_OBJECT                  = 344;
fl_LOAD_STACK_AFTER_CALC           = 345;
fl_COMMENT                         = 346;  {.237}
fl_IS_FPU_EXCEPTION                = 347;  {.248}




{Internal Function}
 fl_SQR     =     15;       //          {flAddNameFunction}
 fl_SQRT =        16;       //          {flAddNameFunction}
 fl_LN =          17;       //          {flAddNameFunction}
 fl_EXP =         18;       //+    {flAddNameFunction,flGet}
 fl_LOG2 =        19;       //          {flAddNameFunction}
 fl_LOG10 =       20;       //          {flAddNameFunction}
 fl_SIN =         35;       //          {flAddNameFunction}
 fl_COS =         36;       //          {flAddNameFunction}
 fl_TAN =         37;       //          {flAddNameFunction}
 fl_COTAN =       38;       //          {flAddNameFunction}
 fl_ARCSIN =      39;       //+    {flAddNameFunction,flGet}
 fl_ARCCOS =      40;       //+    {flAddNameFunction,flGet}
 fl_ARCTAN =      41;       //          {flAddNameFunction}
 fl_ARCCOTAN =    42;       //          {flAddNameFunction}
 fl_SINH =        43;       //+    {flAddNameFunction,flGet}
 fl_COSH =        44;       //+    {flAddNameFunction,flGet}
 fl_TANH =        45;       //+    {flAddNameFunction,flGet}
 fl_COTANH =      46;       //+    {flAddNameFunction,flGet}
 fl_ARCSINH =     47;       //+    {flAddNameFunction,flGet}
 fl_ARCCOSH =     48;       //+    {flAddNameFunction,flGet}
 fl_ARCTANH =     49;       //+    {flAddNameFunction,flGet}
 fl_ARCCOTANH =   50;       //+    {flAddNameFunction,flGet}
 fl_ABS =         51;       //          {flAddNameFunction}
 fl_TRUNC =       52;       //          {flAddNameFunction}
 fl_LOGN =        53;       //+    {flAddNameFunction,flGet}
 fl_FACTORIAL =   55;       //+    {flAddNameFunction,flGet}
 fl_POWER =       59;       //          {flAddNameFunction}
 fl_ROOT =        60;       //          {flAddNameFunction}
 fl_IPOWER =      56;       //        {flGet}
 fl_FPOWER =      54;       //        {flGet}
 fl_FROOT =       61;       //        {flGet}
 fl_IROOT =       62;       //        {flGet}
 fl_FACTORIAL2 =  113;
 C_SEC  =        127;
 C_COSEC  =      128;
 C_ARCSEC   =    129;
 C_ARCCOSEC   =  130;
 C_SECH  =       131;
 C_COSECH  =     132;
 C_ARCSECH   =   133;
 C_ARCCOSECH   = 134;
 C_GAMMA       = 143;
 C_BESSELJ0    = 144;
 C_BESSELJ1    = 145;
 C_BESSELJN    = 146;


 type

  TForeval = class(TComponent)
  private



  protected



  public

 procedure  flSet(Mode,Value1,Value2: Cardinal);                                 stdcall;
 procedure  flCompile(Func: String; Ptr: Pointer; var Addr: Pointer);            stdcall;
 procedure  flCompileDiff(Expr: String;  N: Cardinal; var Addr: Pointer);        stdcall;
 procedure  flSetDiffVar(NName: String);                                         stdcall;
 procedure  flSetDiffExpr(Expr: String);                                         stdcall;
 procedure  flDiffExpr(N: Cardinal);                                              stdcall;
 procedure  flCompileDiffExpr(var Addr: Pointer);                                 stdcall;
 procedure  flSetDiffTemplate(ID: Cardinal; TemplateDiff: String);              stdcall;
 procedure  flPerform(act,subj: Cardinal);                                       stdcall;
 procedure  flSetFunction(Name: String; FAdr: Pointer; var ID: Cardinal);        stdcall;
 procedure  flAddNameFunction(Code: Cardinal; NName: String);                    stdcall;
 procedure  flGetErrorString(var S: String);                                      stdcall;
 procedure  flGetDiffString(var S:  String);                                     stdcall;
 procedure  flGetErrorCode(var ECode: Cardinal);                                 stdcall;
 procedure  flSetVar(Name: String;  ExAddr: Pointer; VType: Cardinal);           stdcall;
 procedure  flSetParam(Name: String; Ptr: Pointer; VType: Cardinal);             stdcall;
 procedure  flGet(What,Func: Cardinal; var Get: Cardinal);                       stdcall;
 procedure  flResultSP(Addr: Pointer;  Res: Pointer);                            stdcall;
 procedure  flResultDP(Addr: Pointer;  Res: Pointer);                            stdcall;
 procedure  flResultEP(Addr: Pointer;  Res: Pointer);                            stdcall;
 procedure  flResultS(Addr: Pointer;  var Res: single);                          stdcall;
 procedure  flResultD(Addr: Pointer;  var Res: double);                          stdcall;
 procedure  flResultE(Addr: Pointer;  var Res: extended);                        stdcall;
 procedure  flResult(Addr: Pointer);                                             stdcall;
 procedure  flSetVarIntrnl(Name: String;  VType: Cardinal; var ExAddr: Pointer);  stdcall;
 procedure  flSetVarValueS(Addr: Pointer;  Val: Single);                          stdcall;
 procedure  flSetVarValueE(Addr: Pointer;  Val: Extended);                        stdcall;
 procedure  flSetVarValueD(Addr: Pointer;  Val: Double);                         stdcall;
 procedure  flSetVarValueI(Addr: Pointer;  Val: Integer);                         stdcall;
 procedure  flSetLength(AdrV: Pointer; TypeV: Cardinal; Len: Cardinal);          stdcall;
 procedure  flSetArrayValueD(AdrV: Pointer; indx: Cardinal; Val: double);         stdcall;
 procedure  flSetArrayValueE(AdrV: Pointer; indx: Cardinal; Val: extended);       stdcall;
 procedure  flSetArrayValueS(AdrV: Pointer; indx: Cardinal; Val: single);        stdcall;
 procedure  flSetArrayValueI(AdrV: Pointer; indx: Cardinal; Val: integer);       stdcall;
 procedure  flGetVarValueS(Addr: Pointer; var Val: Single);                      stdcall;
 procedure  flGetVarValueE(Addr: Pointer; var Val: Extended);                    stdcall;
 procedure  flGetVarValueD(Addr: Pointer; var Val: Double);                       stdcall;
 procedure  flGetVarValueI(Addr: Pointer; var Val: Integer);                     stdcall;

 procedure  flGetArrayValueD(AdrV: Pointer; indx: Cardinal; var Val: double);   stdcall;
 procedure  flGetArrayValueE(AdrV: Pointer; indx: Cardinal; var Val: extended);  stdcall;
 procedure  flGetArrayValueS(AdrV: Pointer; indx: Cardinal; var Val: single);   stdcall;
 procedure  flGetArrayValueI(AdrV: Pointer; indx: Cardinal; var Val: integer);  stdcall;

 procedure  flResultSafe(Addr: Pointer);                                        stdcall;
 procedure  flResultDSafe(Addr: Pointer;  var Res: double);                     stdcall;

 procedure  flCheckSyntax(Expr: String);                                         stdcall;
 procedure  flGetFuncID(Name: String; var IDF: Integer);                        stdcall;

 procedure  flSetSplainFunction(FuncName: String; AdrVX,AdrVY: Pointer; ArrayType: Cardinal; var ID: Cardinal);  stdcall;


    procedure InitFuncStruct(var Func: TAddFuncStruct);
    function  CalcF(Func: Pointer): extended;


  published

  end;


procedure Register;


implementation


procedure Register;
begin
  RegisterComponents('Foreval',[TForeval])
end;

procedure  TForeval.flSet(Mode,Value1,Value2: Cardinal);                            stdcall;
begin
   Foreval_Lib.flSet(Mode,Value1,Value2);
end;

procedure  TForeval.flCompile(Func: String; Ptr: Pointer; var Addr: Pointer);      stdcall;
begin
   Foreval_Lib.flCompile(Func,Ptr,Addr);
end;

procedure  TForeval.flCompileDiff(Expr: String;  N: Cardinal; var Addr: Pointer);   stdcall;
begin
   Foreval_Lib.flCompileDiff(Expr,N,Addr);
end;


procedure  TForeval.flSetDiffVar(NName: String);                                 stdcall;
begin
   Foreval_Lib.flSetDiffVar(NName);
end;


procedure  TForeval.flSetDiffExpr(Expr: String);                                   stdcall;
begin
   Foreval_Lib.flSetDiffExpr(Expr);
end;


procedure  TForeval.flDiffExpr(N: Cardinal);                                      stdcall;
begin
   Foreval_Lib.flDiffExpr(N);
end;


procedure  TForeval.flCompileDiffExpr(var Addr: Pointer);                         stdcall;
begin
   Foreval_Lib.flCompileDiffExpr(Addr);
end;

procedure  TForeval.flSetDiffTemplate(ID: Cardinal; TemplateDiff: String);              stdcall;
begin
  Foreval_Lib.flSetDiffTemplate(ID,TemplateDiff);
end;

procedure  TForeval.flPerform(act,subj: Cardinal);                                stdcall;
begin
   Foreval_Lib.flPerform(act,subj);
end;

procedure  TForeval.flSetFunction(Name: String; FAdr: Pointer; var ID: Cardinal);   stdcall;
begin
   Foreval_Lib.flSetFunction(Name,FAdr,ID);
end;

procedure  TForeval.flAddNameFunction(Code: Cardinal; NName: String);             stdcall;
begin
   Foreval_Lib.flAddNameFunction(Code,NName);
end;

procedure  TForeval.flGetErrorString(var S: String);                             stdcall;
begin
   Foreval_Lib.flGetErrorString(S);
end;

procedure  TForeval.flGetDiffString(var S: String);                               stdcall;
begin
   Foreval_Lib.flGetDiffString(S);
end;

procedure  TForeval.flGetErrorCode(var ECode: Cardinal);                          stdcall;
begin
   Foreval_Lib.flGetErrorCode(ECode);
end;

procedure  TForeval.flSetVar(Name: String;  ExAddr: Pointer; VType: Cardinal);    stdcall;
begin
   Foreval_Lib.flSetVar(Name,ExAddr,VType);
end;

procedure  TForeval.flSetParam(Name: String; Ptr: Pointer; VType: Cardinal);      stdcall;
begin
   Foreval_Lib.flSetParam(Name,Ptr,VType);
end;

procedure  TForeval.flGet(What,Func: Cardinal; var Get: Cardinal);                stdcall;
begin
   Foreval_Lib.flGet(What,Func,Get);
end;


procedure  TForeval.flResultS(Addr: Pointer; var Res: Single);                    stdcall;
asm
  push eax
  call Addr
  mov eax, [res]
  fstp dword ptr [eax]
  pop eax
end;
{
begin
  Foreval_Lib.flResultS(Addr,res);
end;
}

procedure  TForeval.flResultD(Addr: Pointer; var Res: Double);                    stdcall;
asm
  push eax
  call Addr
  mov eax, [res]
  fstp qword ptr [eax]
  pop eax
end;
{begin
  Foreval_Lib.flResultD(Addr,res);
end; }

procedure  TForeval.flResultE(Addr: Pointer; var Res: Extended);                  stdcall;
asm
  push eax
  call Addr
  mov eax, [res]
  fstp tbyte ptr [eax]
  pop eax
end;
{begin
  Foreval_Lib.flResultE(Addr,res);
end; }


procedure  TForeval.flResult(Addr: Pointer);                                       stdcall;
asm
  call Addr
end;



procedure  TForeval.flResultSP(Addr: Pointer;  Res: Pointer);                      stdcall;
asm
  push eax
  call Addr
  mov eax, [res]
  fstp dword ptr [eax]
  pop eax
end;
{begin
  Foreval_Lib.flResultSP(Addr,res);
end; }

procedure  TForeval.flResultDP(Addr: Pointer;  Res: Pointer);                      stdcall;
{begin
  Foreval_Lib.flResultDP(Addr,res);
end;  }
asm
  push eax
  call Addr
  mov eax, [res]
  fstp qword ptr [eax]
  pop eax
end;

procedure  TForeval.flResultEP(Addr: Pointer;  Res: Pointer);                       stdcall;
asm
  push eax
  call Addr
  mov eax, [res]
  fstp tbyte ptr [eax]
  pop eax
end;
{begin
  Foreval_Lib.flResultEP(Addr,res);
end;  }



procedure  TForeval.flResultSafe(Addr: Pointer);                                        stdcall;
begin
  Foreval_Lib.flResultSafe(Addr);
end;

procedure  TForeval.flResultDSafe(Addr: Pointer;  var Res: double);                     stdcall;
begin
  Foreval_Lib.flResultDSafe(Addr,Res);
end;

procedure  TForeval.flSetVarIntrnl(Name: String;  VType: Cardinal; var ExAddr: Pointer);   stdcall;
begin
 Foreval_Lib.flSetVarIntrnl(Name, VType, ExAddr);
end;

procedure  TForeval.flSetVarValueS(Addr: Pointer;  Val: Single);                  stdcall;
begin
  PSingle(Addr)^:=Val
 //Foreval_Lib.flSetVarValueS(Addr,Val);
end;


procedure  TForeval.flSetVarValueE(Addr: Pointer;  Val: Extended);                stdcall;
begin
  PExtended(Addr)^:=Val
 //Foreval_Lib.flSetVarValueE(Addr,Val);
end;


procedure  TForeval.flSetVarValueD(Addr: Pointer;  Val: Double);                 stdcall;
begin
  PDouble(Addr)^:=Val
 //Foreval_Lib.flSetVarValueD(Addr,Val);
end;


procedure  TForeval.flSetVarValueI(Addr: Pointer;  Val: Integer);                 stdcall;
begin
  PInteger(Addr)^:=Val
 //Foreval_Lib.flSetVarValueI(Addr,Val);
end;


procedure  TForeval.flSetLength(AdrV: Pointer; TypeV: Cardinal; Len: Cardinal);   stdcall;
begin
 Foreval_Lib.flSetLength(AdrV,TypeV,Len);
end;


procedure  TForeval.flSetArrayValueD(AdrV: Pointer; indx: Cardinal; Val: double);  stdcall;
begin
  PArrayD(AdrV)^[indx]:=Val;
 //Foreval_Lib.flSetArrayValueD(AdrV,indx,Val);
end;


procedure  TForeval.flSetArrayValueE(AdrV: Pointer; indx: Cardinal; Val: extended); stdcall;
begin
  PArrayE(AdrV)^[indx]:=Val;
 //Foreval_Lib.flSetArrayValueE(AdrV,indx,Val);
end;


procedure  TForeval.flSetArrayValueS(AdrV: Pointer; indx: Cardinal; Val: single);  stdcall;
begin
  PArrayS(AdrV)^[indx]:=Val;
 //Foreval_Lib.flSetArrayValueS(AdrV,indx,Val);
end;


procedure  TForeval.flSetArrayValueI(AdrV: Pointer; indx: Cardinal; Val: integer);  stdcall;
begin
  PArrayI(AdrV)^[indx]:=Val;
 //Foreval_Lib.flSetArrayValueI(AdrV,indx,Val);
end;


procedure  TForeval.flGetVarValueS(Addr: Pointer; var Val: Single);                      stdcall;
begin
  Val:=PSingle(Addr)^
 //Foreval_Lib.flGetVarValueS(Addr,Val);
end;


procedure  TForeval.flGetVarValueE(Addr: Pointer; var Val: Extended);                    stdcall;
begin
  Val:=PExtended(Addr)^
 //Foreval_Lib.flGetVarValueE(Addr,Val);
end;

procedure  TForeval.flGetVarValueD(Addr: Pointer; var Val: Double);                       stdcall;
begin
  Val:=PDouble(Addr)^
 //Foreval_Lib.flGetVarValueD(Addr,Val);
end;

procedure  TForeval.flGetVarValueI(Addr: Pointer; var Val: Integer);                     stdcall;
begin
  Val:=PInteger(Addr)^
 //Foreval_Lib.flGetVarValueI(Addr,Val);
end;

procedure  TForeval.flGetArrayValueD(AdrV: Pointer; indx: Cardinal; var Val: double);  stdcall;
begin
  Val:=PArrayD(AdrV)^[indx];
 //Foreval_Lib.flGetArrayValueD(AdrV,indx,Val);
end;

procedure  TForeval.flGetArrayValueE(AdrV: Pointer; indx: Cardinal; var Val: extended);  stdcall;
begin
  Val:=PArrayE(AdrV)^[indx];
 //Foreval_Lib.flGetArrayValueE(AdrV,indx,Val);
end;

procedure  TForeval.flGetArrayValueS(AdrV: Pointer; indx: Cardinal; var Val: single);  stdcall;
begin
  Val:=PArrayS(AdrV)^[indx];
 //Foreval_Lib.flGetArrayValueS(AdrV,indx,Val);
end;

procedure  TForeval.flGetArrayValueI(AdrV: Pointer; indx: Cardinal; var Val: integer);  stdcall;
begin
  Val:=PArrayI(AdrV)^[indx];
 //Foreval_Lib.flGetArrayValueI(AdrV,indx,Val);
end;


procedure  TForeval.flCheckSyntax(Expr: String);
begin
  Foreval_Lib.flCheckSyntax(Expr);
end;


procedure  TForeval.flSetSplainFunction(FuncName: String; AdrVX,AdrVY: Pointer; ArrayType: Cardinal; var ID: Cardinal);  stdcall;
begin
 Foreval_Lib.flSetSplainFunction(FuncName,AdrVX,AdrVY,ArrayType,ID);
end;

procedure  TForeval.flGetFuncID(Name: String; var IDF: Integer);                        stdcall;
begin
   Foreval_Lib.flGetFuncID(Name, IDF);
end;


//-      - stdcall;
//on-default all functions have call - stdcall;
 procedure TForeval.InitFuncStruct(var Func: TAddFuncStruct);
  begin
   Func.addr:=0;
   Func.Arg:=0;
   Func.CallType:=fl_STACK_CPU;
   Func.ArgType:=fl_DIFFER;
   Func.ArgTypeList:=0;
   Func.ClearStack:=fl_DISABLE;
   Func.Arrow:=fl_RIGHT;
   Func.DeepFPU:=8;      //max 8: better than fl_Unknown
   Func.Set_ID:=fl_DISABLE;
   Func.Id_Func:=0;
   Func.SaveReg:=15;         //=15: save eax,ebx,ecx,edx (Recommend.);  =255 save all reg; see .doc if there are any error
   Func.CodeInline:=0;
   Func.SizeCode:=0;
   Func.AdrDeriv:=0;
   Func.NDeriv:=0;
   Func.CalcConst:=fl_YES;
   Func.RetNum:=fl_YES;
   Func.ReplFunc:=fl_YES;
   Func.Rsrv1:=0;
   Func.Rsrv2:=0;
   Func.Rsrv3:=0;
  end;



function TForeval.CalcF(Func: Pointer): extended;
asm
   Call Func
end;


end.






