//---------------------------------------------------------------------------

/**
                      For full examples see  Builder and MSVC
**/


/**
                               Warning:

        Use only 32bit compiler.
        Foreval does not support multitasking: compiled expression can not be executed simultaneously in multiple threads;
     for each thread needs its own compilation of expression, it also applies to functions such fl_Precompiled (not  thread-safe).
**/



#pragma once
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>
#include <iostream>
#include <sstream>
#include <cstdlib>
#include <string>
#include <vector>
#include <math.h>
#include "Types.h"
#include "Forevaldll.h"
#include "ExtFunc.h"

using namespace std;





 /// #define TESTFASTDYNARRAY  /// <- test dynamic array, see: onLoad (FDynArray) , test()

//---------------------------------------------------------------------------
 typedef   std::vector<double> TArrayD ;
 typedef   std::vector<Extended> TArrayE ;
 typedef   std::vector<int> TArrayI ;
 typedef   std::vector<byte> TArrayB ;
 typedef   std::vector<Pointer32> TArrayP ;

 typedef TFloatType (*PTGccTest)(void);



 struct TFunc2
		   {
				//TStringType    Expr;
				Pointer32      Addr;
				Extended  res;
				Extended  x;
				Extended  y;

		  };

 struct TFunc3
		   {
				//TStringType    Expr;
				Pointer32      Addr;
				Extended  res;
				Extended  x;
				Extended  y;
				Extended  z;

		  };

struct TFuncInt3
	  {
	  Pointer32 FAddr;
	  Extended  x    ;
	  Extended  y     ;
	  Extended  z     ;
	  Extended  a     ;
	  Extended  b     ;
	  Pointer32 F1Addr;
	  Pointer32 F2Addr ;
	  Pointer32 F3Addr ;
	  Pointer32 F4Addr ;
	  };

struct TFuncInt3Ext
	  {
	  Pointer32 FAddr;
	  Pointer32 adrX;
	  Pointer32 adrY;
	  Pointer32 adrZ;
	  Extended  a     ;
	  Extended  b     ;
	  Pointer32 F1Addr;
	  Pointer32 F2Addr;
	  Pointer32 F3Addr;
	  Pointer32 F4Addr;
	  };

//TComplexNum z1,z2,z3,i;

Extended A,B,C,D,resf;


TFloatType x,y,t,z;



//double xd,yd,td;
Pointer32 adrXVD,adrXVE,adrXVE1,adrXVI,adrXAD,adr1,adrVECD,adrVD,FDynArray,adrXSPL,adrYSPL, adrVDX, adrVDY, adrVF, adrVDF;

_int32 n,k,j,m,l;
PDouble  px,py;
PInteger pi1;

INT32 GLT,FpuExc,GNC,Perf;



 TArrayD  vd,xspl,yspl,vecd,vdf;
 TArrayE  ve,vf,vef;
 TArrayI  vi;

 TFunc3  fnc1,fnc2,fnc3;
 Extended  an[16],bn[16];
 _int32  P_Integral,N_Integral;
 TFuncInt3     FInt3;
 TFuncInt3Ext  FInt3Ext;
 TAttrib FAtr;

 BOOLEAN F_CalcError;

  string    ExprE1,ExprE2,ExprE3S,ExprE4S,ExprA5,ExprA6,ExprA6F,ExprP7,ExprP7A,ExprF8,ExprF9,ExprF10S,ExprF11S,ExprF12S,ExprFE13SP,ExprFE13PS,ExprFE13MS,ExprFE13PC,ExprFE14SP,ExprFE14PS,ExprFE14MS,ExprFE14PC;
  Pointer32 FuncE1,FuncE2,FuncE3S,FuncE4S,FuncA5,FuncA6,FuncA6F,FuncP7,FuncP7A,FuncF8,FuncF9,FuncF10S,FuncF11S,FuncF12S,FuncFE13SP,FuncFE13PS,FuncFE13MS,FuncFE13PC,FuncFE14SP,FuncFE14PS,FuncFE14MS,FuncFE14PC;

//#pragma package(smart_init)

Extended trunc(Extended d){ return (d>0) ? floor(d) : ceil(d) ; }

Extended abs(Extended d){ return fabs(d) ; }

std::string IntToStr(INT32 I)
{
    std::stringstream ss;
    ss<<I;
    std::string str1;
    ss>>str1;
    return str1;
};

INT32 StrToInt(std::string Str)
{
    std::stringstream ss;
    INT32   I;

    ss<<Str;
    ss>>I;

    return I;
};


TFloatType  _cdecl sp1(TFloatType x1)
{
 return  x1*x1;
};


TFloatType  _stdcall sp2(TFloatType x1, TFloatType x2)
{
 return  x1-x2;
};


TFloatType  _cdecl sp3(TFloatType x1, TFloatType x2, TFloatType x3)
{
 return  x1+x2-x3;
};




TFloatType _cdecl sp8(TArrayE &vx, Int32 nx, Extended x, TArrayD &vd, Int32 nd, double d,  TArrayI &vi, Int32 ni)
{

return  (vx[nx]*x-vd[nd]*d)*vi[ni];

}


double avg(TArrayD &vx)
{
     INT32 i,L;
     double res;

     res = 0;
     L = vx.size()-1;
     for(i = 1; i <= L; i++ )  /// in C++ count from 1  !! (if array in Foreval as "fast connect")
     {
       res=res+vx[i] ;
     }

 return res/L;
}


void InitIntegral(void)
{
 P_Integral=10;
 N_Integral=15;

 an[1]=0.03075324199611726835; an[2]=0.07036604748810812471;
 an[3]=0.10715922046717193501; an[4]=0.13957067792615431445;
 an[5]=0.16626920581699393355; an[6]=0.18616100001556221103;
 an[7]=0.19843148532711157646; an[8]=0.20257824192556127288;
 an[9]=an[7];  an[10]=an[6];  an[11]=an[5]; an[12]=an[4];
 an[13]=an[3]; an[14]=an[2];  an[15]=an[1];
 bn[1]=0.98799251802048542849; bn[2]=0.93727339240070590431;
 bn[3]=0.84820658341042721620; bn[4]=0.72441773136017004742;
 bn[5]=0.57097217260853884754; bn[6]=0.39415134707756336990;
 bn[7]=0.20119409399743452230; bn[8]=0;
 bn[9]=-bn[7]; bn[10]=-bn[6]; bn[11]=-bn[5]; bn[12]=-bn[4];
 bn[13]=-bn[3];bn[14]=-bn[2]; bn[15]=-bn[1];
};



Extended  Integral3FF(Pointer32 Func, Pointer32 PV1 , Pointer32 PV2, Pointer32 PV3, Extended a, Extended b , Pointer32 Func1, Pointer32 Func2, Pointer32 Func3, Pointer32 Func4)

{
Int32 R, j1, i1, j2, i2, j3, i3, n1, n2, n3;
Extended int1, int2, int3, HV1, HV2, HV3, h1, h2, h3, x1, x2, c, d, e, f, h, r;
Extended ax1, ax2, ax3, sx1, sx2, sx3;



int3 = 0;


n1 = abs(P_Integral);
if (n1 == 0) {n1 = 1;};
n2 = abs(P_Integral);
if (n2 == 0) {n2 = 1;};
n3 = abs(P_Integral);
if (n3 == 0) {n3 = 1;};
h3 = (b - a) / n3 ;


for(j3 = 0; j3 <= n3-1; j3++)
{
 x1 = a + j3 * h3 ;
 x2 = a + (j3 + 1) * h3 ;
 ax3 = (x1 + x2) * 0.5 ;
 sx3 = (x2 - x1) * 0.5 ;

  for(i3 = 1; i3 <= N_Integral; i3++)
  {
   *PExtended(PV1)= sx3 * bn[i3] + ax3 ;


   int2 = 0;
   d = flResultF(Func2);
   //flResultE(Func2,d);
   c = flResultF(Func1);
   //flResultE(Func1,c);

   h2 = (d - c) / n2 ;

   for(j2 = 0; j2 <= n2-1; j2++)
   {
	x1 = c + j2 * h2;
	x2 = c + (j2 + 1) * h2;
	ax2 = (x1 + x2) * 0.5 ;
	sx2 = (x2 - x1) * 0.5 ;

	for(i2 = 1; i2 <= N_Integral; i2++)
	{
	 *PExtended(PV2)= sx2 * bn[i2] + ax2 ;

	 int1 = 0;

	 f = flResultF(Func4);
	 //flResultE(Func4,f);
	 e = flResultF(Func3);
	 //flResultE(Func3,e);

	 h1 = (f - e) / n1  ;

	 for(j1 = 0; j1 <= n1-1; j1++)
	 {
	   x1 = e + j1 * h1 ;
	   x2 = e + (j1 + 1) * h1 ;
	   ax1 = (x1 + x2) * 0.5 ;
	   sx1 = (x2 - x1) * 0.5 ;

	   for(i1 = 1; i1 <= N_Integral; i1++)
	   {
		*PExtended(PV3)= sx1 * bn[i1] + ax1 ;

		  int1 = int1 + an[i1] * flResultF(Func) * sx1 ;
		  /*
		  flResultE(Func,r);
		  int1 = int1 + an[i1] * r * sx1 ;
		  */
	   }

	 }

	 int2 = int2 + an[i2] * int1 * sx2 ;

	}
   }

  int3 = int3 + an[i3] * int2 * sx3;
  }
}


return int3 ;

};



void  ShowError(void)
{

_int32 CError;
Pointer32 PS;
string strE,strOut,strTmp,S;
TStringType chE,chTmp;



flGetErrorCode(CError);

switch ( CError )
 {
   case  fl_SPLAIN_DATA_ERROR:                    S="SPLAIN DATA ERROR";break;
   case  fl_NO_DIFF_EXPRESSION:                   S="NO DIFF EXPRESSION";break;
   case  fl_WRONG_NAME:                           S="WRONG NAME";break;
   case  fl_INCORRECT_ARGUMENT:                   S="INCORRECT ARGUMENT";break;
   case  fl_INVALID_OPERATION:                    S="INVALID OPERATION";break;
   case  fl_OVERFLOW:                             S="OVERFLOW";break;
   case  fl_UNDERFLOW:                            S="UNDERFLOW";break;
   case  fl_INT_OVERFLOW:                         S="INTEGER OVERFLOW";break;
   case  fl_ACCESS_VIOLATION:                     S="INTERNAL ERROR or UNCATCHABLE SYNTAX ERROR";break;
   case  fl_OUT_OF_MEMORY:                        S="OUT OF MEMORY";break;
   case  fl_STACK_OVERFLOW:                       S="STACK OVERFLOW";break;
   case  fl_ZERO_DIVIDE:                          S="DIVIDE ON ZERO";break;
   case  fl_UNKNOWN_SYMBOL:                       S ="UNKNOWN SYMBOL or INCORRECT ARGUMENT or WRONG EXPRESSION"; break;
   case  fl_MISSING_ROUND_BRACKET:                S ="MISSING ROUND BRACKET"; break;
   case  fl_MISSING_OPERATION:                    S="MISSING OPERATION";   break;
   case  fl_WRONG_NUMBER_ARGUMENTS:               S="WRONG NUMBER ARGUMENTS";  break;
   case  fl_MISSING_EXPRESSION:                   S="MISSING EXPRESSION";  break;
   case  fl_UNKNOWN_FUNCTION:                     S="UNKNOWN FUNCTION"; break;
   case  fl_ERROR_AT_ADDITION_FUNCTION:           S="ERROR AT ADDITION FUNCTION";   break;
   case  fl_MISSING_ARGUMENT:                     S="MISSING ARGUMENT";  break;
   case  fl_INTERNAL_ERROR:                       S="INTERNAL ERROR or  UNCATCHABLE SYNTAX ERROR"; break;
   case  fl_INCORRECT_TYPE:                       S="WRONG TYPE" ;   break;
   case  fl_MISSING_SQUARE_BRACKET:               S="MISSING SQUARE BRACKET";  break;
   case  fl_MISSING_CURLY_BRACKET:                S="MISSING CURLY BRACKET";  break;
   case  fl_MISSING_ABS_BRACKET:                  S="MISSING ABS BRACKET";  break;
   case  fl_WRONG_EXPRESSION:                     S="WRONG EXPRESSION";  break;
   case  fl_MISSING_SEPARATOR:                    S="MISSING SEPARATOR";   break;
   case  fl_INCORRECT_SPACE:                      S="INCORRECT SPACE";  break;
   case  fl_VARIABLE_REDECLARED:                  S="VARIABLE REDECLARED";  break;
   default:                                       S="UNKNOWN SYNTAX ERROR"; break;


}
   /** it's best to make coping throw auxiliary string **/
       flGetErrorString(PS);
	   chTmp=(TStringType)(PS);
	   strTmp=(string)(chTmp);
	   strOut=strTmp;
	   strTmp="";
	   cout << "Foreval Syntax Error:" << S << endl;
       cout << strOut << endl;



}


void CopyArrayExt(Pointer32 psrc, Pointer32 pdest,  _int32 SZ)
{
/**
 Copy array of extended (Gcc) => array of extended (Foreval)
   In Foreval elements of array of extended are placed through throw 10 byte
   in Gcc - 12 byte.
**/
 _int32 ic;

   for(ic = 1;ic <= SZ; ic++)
   {
    *(PExtended)pdest = *(PExtended)psrc;
    psrc = psrc+12;
    pdest = pdest+10;
   }

};

void RefReshVar()
{
    Int32 ni,L;

     n = 1; k = 2; j = 5; m = -3;
     x = 2.123000000000000000000000;
     y = 5.456000000000000000000000;
     t = -3.78900000000000000000000;

}


Extended GccIntMain()
{
 return  x*y+2*y*z-z*x;
};


Extended GccIntFY1()
{
 return  -2*x;
};


Extended GccIntFY2()
{
 return  x*x+1;
};


Extended GccIntFZ1()
{
 return  x-y;
};


Extended GccIntFZ2()
{
 return  x+y;
};



Extended GccIntMainT()
{
 //return  (2.11*x*y-5.72*z)*(1.23*y*z-3.24*x*(1.55*x-4.56*y+3.17*z))-1.123*z*(2.58*x+1.79*y+3.21*z)*(1.42*z-2.53*y*(1.124*x+1.155*y-1.176*z)+1.79*x);
 return (2.12*x+1.23*y-1.14*z)*(1.31*x-1.45*y+2.21*z)*(1.51*x*y-2.17*y*z+2.15*x*z)-(1.17*x-2.43*y-1.54*z)*(2.14*x+1.75*y-1.41*z)*(2.19*x*y+1.27*y*z-1.45*x*z);

};


Extended GccIntFY1T()
{
 //return  -1.21*x*(1.11*x+2.15);
 return (1.32*x-2.17)*x;
};


Extended GccIntFY2T()
{
 //return  2.15*x*(2.41*x-1.25);
 return (2.16*x+1.52)*x;
};


Extended GccIntFZ1T()
{
 //return  (1.12*x-2.15*y)*x*1.15-1.7*y*(1.31*y+1.53*x);
 return (1.71*x-2.95*y)*(1.34*x+2.97*y)-2.51*x*y;
};


Extended GccIntFZ2T()
{
 //return  (2.21*x-2.15*y)*x*y*2.11+3.7*y*(2.14*y+3.23*x);
 return (2.41*x+5.15*y)*(2.54*x+3.17*y)-3.17*x*y;
};





int onLoad()
{
      _int32       flLoad,ic,ECode,FType;
	  TStringType  Expr;
	  //TStringType   Sid,Sid1,Sid2,Sid3,Sid4,Expr1,Expr2,SRes;
	  TStringType   Expr1,Expr2,SRes;
	  Pointer32     Func1,ve0,vd0,FS1,pa1,psrc,pdest,pf1,pf2,pf3,pf4,pf5,pf6;
	  Extended      ax,bx,hx,sx,fx,dx,dy,res,r;
	  Extended      xt1,xt2,xt3,xt4,xt5;
	  double        resd;
	  TAddFuncStruct Func;
	  //_int32       VT[10];
	  TArrayI      VT;
      TArrayB      Code;
	  _int32       ni, NR, lv, IDF;
	  _int32       ID,ID1,ID2,ID3,ID4,SZ;
	  PInteger     pint1,P_C;
	  PDouble      pdbl1;
	  string       Sid,Sid1,Sid2,Sid3,Sid4,SText;
      char*        Ch32;
      byte*        pb1;
      _int32       T1,T2;



     //***********************************************************
	  InitIntegral();

     flLoad=flInit();
     if (flLoad != 0)
     {
         flGet(fl_COMPILED_BY,0,ID);
         if (ID >= 100 ) {GLT=2;} else {GLT=1;};

         flSet(fl_STRING_TYPE, fl_ANSISTRING,0); /// example only for ansi,for other string types see Builder's example
         //flSet(fl_STRING_TYPE, fl_WIDESTRING,0);
		 //flSet(fl_STRING_TYPE, fl_STRING_UTF16,0);

	   //flSet(fl_ENABLE, fl_SHOW_EXCEPTION,0);
	   //flSet(fl_ENABLE,fl_CHECK_INCORRECT_SPACE,0);
       //flSet(fl_DISABLE,fl_LEAD_TO_LOWER_CASE,0);

       if(GLT == 2){ flSet(fl_ENABLE,fl_MASK_FPU_EXCEPTION,0);}; /// <- if Foreval is compiled in FPC, then need to set it.
       /// If will crash program at catching of computational exception in parsing  (x/(2-2), sqrt(-2)*x, pow(-2.1,7.8),...) then also set it


	   //flSet(fl_ENABLE,fl_USE_VIRTUAL_ALLOC,0); /// <- with this, more performance for fl_Precompiled functions



		/** for most speed of calculations: (so as in MSVC)  **/
        /*
        flSet(fl_PARAM_TYPE,fl_DOUBLE,0);
		flSet(fl_DATA_TYPE,fl_DOUBLE,0);
        */
		/** on default: Extended - for most exact  of calculations: **/
        /*
		flSet(fl_PARAM_TYPE,fl_EXTENDED,0);
		flSet(fl_DATA_TYPE,fl_EXTENDED,0);
        */

       #ifdef   EXTENDED_VAR
           flSet(fl_PARAM_TYPE,fl_EXTENDED,0);
		   flSet(fl_DATA_TYPE,fl_EXTENDED,0);
		   FType = fl_EXTENDED;
       #else
           flSet(fl_PARAM_TYPE,fl_DOUBLE,0);
		   flSet(fl_DATA_TYPE,fl_DOUBLE,0);
		   FType = fl_DOUBLE;
       #endif // EXTENDED_VAR

        flSet(fl_ADDRESS_EXCEPTION_FLAG , _int32(&FpuExc),0);	/// uses in flResultSafe, flResultDSafe







  //flSetVar("ad",&ad,fl_ARRAY_DOUBLE);
  flSetVar("vd",&vd,fl_ARRAY_DOUBLE);
  flSetVar("ve",&ve,fl_ARRAY_EXTENDED);
  flSetVar("vi",&vi,fl_ARRAY_INTEGER);




  flSetDiffVar("x");
  A=2.54321;
  B=-3.98765;
  C=4.12345;
  D=-5.6789;

  flSetParam("a",&A,fl_EXTENDED);
  flSetParam("b",&B,fl_EXTENDED);
  flSetParam("c",&C,fl_EXTENDED);
  flSetParam("d",&D,fl_EXTENDED);

  flSetVar("res",&resf,fl_EXTENDED);
  flSetVar("result",&resf,fl_EXTENDED);


  #ifdef   EXTENDED_VAR
   flSetVar("x",&x,fl_EXTENDED);
   flSetVar("y",&y,fl_EXTENDED);
   flSetVar("t",&t,fl_EXTENDED);
   flSetVar("z",&z,fl_EXTENDED);
 #else
   flSetVar("x",&x,fl_DOUBLE);
   flSetVar("y",&y,fl_DOUBLE);
   flSetVar("t",&t,fl_DOUBLE);
   flSetVar("z",&z,fl_EXTENDED);
 #endif // EXTENDED_VAR



  flSetVar("n",&n,fl_INTEGER);
  flSetVar("k",&k,fl_INTEGER);
  flSetVar("j",&j,fl_INTEGER);
  flSetVar("m",&m,fl_INTEGER);



  n = 1; k = 2; j = 5; m = -3;

  x = 2.123; y = 5.456; t = -3.789; z = -1.654;
 // x1 = 2.123; y1 = 5.456; t1 = -3.789;



  /*
  ad.set_length(3);
  ad[0]=3.5; ad[1]=-1.4;  ad[2]=7.6;
*/




  /*
  vd=new double[11];
  vd[0]=1.1; vd[1]=2.2; vd[2]=3.3;
  adr1=&vd[0];
  int adr2 = 0;
  px=&vd[0];
  pi1=(PInteger)px;
  pi1=pi1-1;
  //px=px-4;
  //pi1=(PInteger)px;
  n=*pi1;


  LPF->Text= n.ToString();
  */
  //px=px+1;
  //T=*px;
  //LPF->Text= T.ToString();

  //n=(int)(adr2-4);
  //T= (*double)(n);
 /*
  vecd.push_back(1.1);
  vecd.push_back(2.2);
  vecd.push_back(3.3);
  vecd.push_back(4.4);
  vecd.push_back(5.5);
*/
  //vecd[0]=0;





  flSetVarIntrnl("ad",fl_ARRAY_DOUBLE,adrXAD);   flSetLength(adrXAD, fl_ARRAY_DOUBLE, 3);
  flSetVarIntrnl("vd",fl_ARRAY_DOUBLE,adrXVD);   //flSetLength(adrXVD, fl_ARRAY_DOUBLE, 100);
  flSetVarIntrnl("ve",fl_ARRAY_EXTENDED,adrXVE); flSetLength(adrXVE, fl_ARRAY_EXTENDED, 100);
  flSetVarIntrnl("ve1",fl_ARRAY_EXTENDED,adrXVE1); flSetLength(adrXVE1, fl_ARRAY_EXTENDED, 100);
  flSetVarIntrnl("vi",fl_ARRAY_INTEGER,adrXVI);  flSetLength(adrXVI, fl_ARRAY_INTEGER, 100);


   vd.resize(100);
   ve.resize(100);
   vi.resize(100);
   vf.resize(101);  /// for "fast connect": see below

    for (ni = 0; ni <=99; ni++)
	{
       vd[ni]=ni+1;
       ve[ni]=ni+5;



      vd[ni]=pow((double)(-1),(Int32)(ni+1))*vd[ni]*0.5;
      ve[ni]=powl((Extended)(-1),(Int32)(ni+5))*ve[ni]*0.5;
      vi[ni]=trunc(ve[ni]);
	  vf[ni+1]=ve[ni];

       flSetArrayValueE(adrXVE,ni,ve[ni]);
	   //flSetArrayValueD(adrXVD,ni,vd[ni]);
       flSetArrayValueI(adrXVI,ni,vi[ni]);
	}

	/**
	   to set "vd" array through copy to memory from vd[]
	   pint1=(PInteger)adrXVD;
	   vd0=(Pointer32)(*pint1);  //= &vd[0]
   **/

    flSetLength(adrXVD, fl_ARRAY_DOUBLE, vd.size());
	vd0=(Pointer32)(*((PInteger)adrXVD));  /// = &vd[0] in Foreval
    CopyMemory(vd0,&vd[0],8*vd.size());   /// 8 - sizeof(double)


 /** if data and length of vd is changed, that need reinstall XVD  without recompiling expression , consisting of 'vd' **/
	/*
	 vd.resize(1000);
	  for (ni = 0; ni <=999; ni++)
	{
		vd[ni]=ni+1.123;
	  }

	 flSetLength(adrXVD, fl_ARRAY_DOUBLE, vd.size());
	 vd0=(Pointer32)(*((PInteger)adrXVD));
	 CopyMemory(vd0,&vd[0],8*vd.size());
	*/



    /**
        For array of Extended type (ve1: TArrayE), setting it by CopyMemory don't work,
            so as size of cell for element (TArrayE)  in Foreval = 10,  in Gcc = 12
        Need write procedure of copying (CopyArrayExt)
    **/

                /**  ve(Gcc) => ve1(Foreval) **/


  flSetLength(adrXVE1, fl_ARRAY_EXTENDED, ve.size());

  SZ=ve.size();
  psrc = &ve[0];
  pdest =(Pointer32)(*((PInteger)adrXVE1));  /// = &ve0[0] in Foreval
  //pdest = (PInteger)adrXVE1;
  CopyArrayExt(psrc,pdest,SZ);




/**************   Other way to adding external dynamic array: more fast (without using   flSetArrayValueD or CopyMemory)  ******************************************************************/
                                            /** "fast connecting"  **/
/**
                       Array in C++ count from '1', in Foreval count from '0'   !!!
                       Zero element is using for saving of length, begin array from '1'
                       Array and pointer to it (adrVECD) must placing in 'unmanaged memory' !!!
**/

  flSetVar("vecd", &adrVECD ,fl_ARRAY_DOUBLE);

   /**     compile  of expression for  test "TESTFASTDYNARRAY": see  void test() with key TESTFASTDYNARRAY **/

  /// flCompile("len(vecd)*(sumq(vecd)/sqr(norm(vecd)))",0, FDynArray);  ///   always = len(vecd)
   flCompile("k:int=0; len:int=len(vecd); s:dbl=0; for(k,0,len-1,s=s+vecd[k]); s/sum(vecd)", 0,FDynArray);  ///   always = 1

   //vecd.push_back(0);// reserve for length
  //vecd.push_back(0); // begin of array vecd[1]
  vecd.resize(2); /// reserve for length (vecd[0]) + begin of array vecd[1] (for creating pointer to array: adrVECD)
  //vecd.reserve(2);
  adrVECD=&vecd[1];  /// to set a  reference to the array.  adrVECD always: placing in 'unmanaged memory' and pointer only to vecd, so, as address of adrVECD using at compilation !!!

  /**to write length: **/
  pint1 = (PInteger)adrVECD;
  pint1=pint1-1;   /// = &vecd[1]-4b; or = &vecd[0]+4b;  sizeof(double) = 8
  if (GLT == 1) {SZ = vecd.size()-1;} else {SZ=vecd.size()-2;};  /// GLT=1(Delphi); GLT=2(FPC),  in FPC Length=High
  *pint1 = SZ;  /// pint1 = &vecd[1]-4b;  *pint1 <- length



///********************************************************************************************************************************
   /**

        For array of Extended type (vf: TArrayE), setting it by CopyMemory or "fast connecting" don't work,
            so as size of cell for element (TArrayE)  in Foreval = 10,  in Gcc = 12
                           Need write procedure of copying (CopyArrayExt)
						   Array in C++ count from '1', in Foreval count from '0'   !!!
                       Zero element is using for saving of length, begin array from '1'
    **/
                              /**  ve(Gcc) => vf(Foreval) **/

  flSetVar("vf", &adrVF,fl_ARRAY_EXTENDED);

  adrVF=&vf[1];  /// to set a  reference to the array.  adrVF always: placing in 'unmanaged memory' and pointer only to vf, so, as address of adrVF using at compilation !!!

  //to write length:
  pint1 = (PInteger)adrVF;
  pint1=pint1-1;   /// = &vf[1]-4b; or = &vf[0]+4b;  sizeof(double) = 8
  if (GLT == 1) {SZ = vf.size()-1;} else {SZ=vf.size()-2;};  /// GLT=1(Delphi); GLT=2(FPC),  in FPC Length=High
  *pint1 = SZ;  /// pint1 = &vf[1]-4b;  *pint1 <- length

  SZ=vf.size();
  psrc = &vf[1];
  pdest = (PInteger)adrVF;
  CopyArrayExt(psrc,pdest,SZ);


///**************************************************************************************************************************************
                                                     ///  "fast connect" for double array
				                /**
								Array in C++ count from '1', in Foreval count from '0'   !!!
                             Zero element is using for saving of length, begin array from '1'
							    **/

  flSetVar("vdf", &adrVDF ,fl_ARRAY_DOUBLE);
  vdf.resize(101);
  adrVDF=&vdf[1];  /// to set a  reference to the array.  adrVDF always: placing in 'unmanaged memory' and pointer only to vdf, so, as address of adrVECD using at compilation !!!

  /**to write length: **/
  pint1 = (PInteger)adrVDF;
  pint1=pint1-1;   /// = &vdf[1]-4b; or = &vdf[0]+4b;  sizeof(double) = 8
  if (GLT == 1) {SZ = vdf.size()-1;} else {SZ=vdf.size()-2;};  /// GLT=1(Delphi); GLT=2(FPC),  in FPC Length=High
  *pint1 = SZ;  /// pint1 = &vdf[1]-4b;  *pint1 <- length
   //------------------------------------
   CopyMemory(&vdf[1],&vd[0],8*(vd.size()-1));   ///  vd=>vdf;  8 - sizeof(double)

///**************************************************************************************************************************************











 /************************  Addition external functions: **********************/
                    /**For full examples see  Builder**/
/************************************************************************************
func1(arg1)=arg1^2; func2(arg1,arg2)=arg1-arg2; func3(arg1,arg2,arg3)=arg1+arg2-arg3;





ms1, ms2, ms3      fl_MEMORY_STACK_CPU
sp1, sp2, sp3      fl_STACK_CPU
ps1, ps2, ps3      fl_MEMORY_ADDRESSES
pc1, pc2, pc3      fl_PreCompiled

all with diff templates besides pc1,pc2,pc3 - will be diff. numeric (for comparison)


fdif(x)-with derivative
spl1,spl2 -through splain


infs(infsum)       fl_INFINITE_STACK_CPU;


idsin,idcos with ID  fl_STACK_CPU;


krsin,krcos,krdiv with diff templates

FillArrayD(TArrayD vd, Double x)   =   vd[all] = x
FillArrayE(TArrayE ve, Extended x) =   ve[all] = x



func8(TArrayE vx, Int32 nx, Extended x, TArrayD vd, Int32 nd, double d,  TArrayI vi, Int32 ni) = (vx[nx]*x-vd[nd]*d)*vi[ni]

 sp8      fl_STACK_CPU
 ps8      fl_MEMORY_ADDRESSES
 ms8      fl_MEMORY_STACK_CPU
 pc8      fl_PreCompiled


********************************************************************************/


/**                        SPLAIN:



                        spl1(x) = (sin(3*x)-cos(2*x))*exp(-x/10);    -15<=x<=15
**/

/**using internal arrays:**/

hx=0.1;      //<=1!!!
ax=-15.0; bx=15.0; sx=ax;
lv=trunc(abs(bx-ax)/hx)+1;
flSetVarIntrnl("svdx",fl_ARRAY_EXTENDED,adrVDX);
flSetVarIntrnl("svdy",fl_ARRAY_EXTENDED,adrVDY);
flSetLength(adrVDX,fl_ARRAY_EXTENDED,lv);
flSetLength(adrVDY,fl_ARRAY_EXTENDED,lv);


for(ic=0;ic <= lv-1; ic++)
{
  flSetArrayValueE(adrVDX,ic,sx);
  fx=(sin(3*sx)-cos(2*sx))*exp(-sx/10);
  flSetArrayValueE(adrVDY,ic,fx);
  sx=sx+hx;
};



flSetSplainFunction("spl1",adrVDX,adrVDY,fl_ARRAY_EXTENDED,IDF);
//flGetErrorCode(ECode); if (ECode != 0){ShowError();}





/**                         spl2(x) = x*(sin(x)+cos(x));          -10<=x<=10  **/

/**using external arrays with "fast connection": arrays (xspl,yspl) must placing in 'unmanaged memory' !!! **/


hx=0.1;      //<=1!!!
ax=-10; bx=10; sx=ax;
lv=trunc(abs(bx-ax)/hx)+1;
xspl.resize(lv+2);  /// +1: in "0" - length
yspl.resize(lv+2);  /// +1: in "0" - length



for (ic = 1; ic <= xspl.size()-1; ic++)
{
  xspl[ic]=sx;
  yspl[ic]=sx*(sin(sx)+cos(sx));
  sx=sx+hx;
}

adrXSPL=&xspl[1];  /// to set a  reference to the array.  adrXSPL  always: placing in 'unmanaged memory'
adrYSPL=&yspl[1];  /// to set a  reference to the array.  adrYSPL  always: placing in 'unmanaged memory'

  /// to write length:
  pint1 = (PInteger)adrXSPL;
  pint1=pint1-1; // = &xspl[1]-4b; or = &xspl[0]+4b;  sizeof(double) = 8
  if (GLT == 1) {SZ = xspl.size()-1;} else {SZ=xspl.size()-2;};  // GLT=1(Delphi); GLT=2(FPC),  in FPC Length=High
  *pint1 = SZ;  // pint1 = &xspl[1]-4b;  *pint1 <- length

  pint1 = (PInteger)adrYSPL;
  pint1=pint1-1; // = &yspl[1]-4b; or = &yspl[0]+4b;  sizeof(double) = 8
  if (GLT == 1) {SZ = yspl.size()-1;} else {SZ=yspl.size()-2;};  // GLT=1(Delphi); GLT=2(FPC),  in FPC Length=High
  *pint1 = SZ;  // pint1 = &yspl[1]-4b;  *pint1 <- length

flSetSplainFunction("spl2",&adrXSPL,&adrYSPL,fl_ARRAY_DOUBLE,IDF);
//flGetErrorCode(ECode); if (ECode != 0){ShowError();}

   /**
         NOTE!:
         xspl,yspl: TArrayD

	     For an array of Extended type (TArrayE), setting it this way does not work

	     For (TArrayE) setting  as in spl1
	   **/



InitFuncStruct(Func);
Func.addr=(Pointer32)&SP1;
Func.Arg=1;
Func.ArgType=FType;
Func.CallType=fl_STACK_CPU;
Func.DeepFPU=1;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
flSetFunction("sp1",&Func,ID);
flSetDiffTemplate(ID,"2*$arg1*$dfarg1");

InitFuncStruct(Func);
Func.addr=(Pointer32)&SP2;
Func.Arg=2;
Func.ArgType=FType;
Func.CallType=fl_STACK_CPU;
Func.DeepFPU=1;
Func.ClearStack=fl_DISABLE;     //stdcall
Func.Arrow=fl_RIGHT;            //stdcall
flSetFunction("sp2",&Func,ID);
flSetDiffTemplate(ID,"$dfarg1-$dfarg2");

InitFuncStruct(Func);
Func.addr=(Pointer32)&SP3;
Func.Arg=3;
Func.ArgType=FType;
Func.CallType=fl_STACK_CPU;
Func.DeepFPU=1;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
flSetFunction("sp3",&Func,ID);
flSetDiffTemplate(ID,"$dfarg1+$dfarg2-$dfarg3");
//sp3(sp3(x,y,sp1(t))*sp2(t*sp1(x),t),sp2(sp1(y),-sp3(y,sp2(x,t),sp1(x*sp1(t)))),-sp2(sp3(-y,t,x-sp2(t,y)),sp3(t,y*sp1(sp2(t,-y)),-sp2(y,x))))
//x*sp3(x*sp3(x,y,x/sp1(t*x))*sp2(x*sp1(x),t),x/sp2(sp1(y),-x/sp3(y,x*sp2(x,t),sp1(x*sp1(t)))),-sp2(-x*sp3(-y,t,x-x/sp2(t,y/x)),x*sp3(t,y*sp1(-x/sp2(t,-y-x/sp1(x*y))),-sp2(y/(x+t),x))))


InitFuncStruct(Func);
Func.addr=(Pointer32)&MS1;
Func.Arg=1;
Func.ArgType=FType;
Func.CallType=fl_MEMORY_STACK_CPU;
Func.DeepFPU=1;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
flSetFunction("MS1",&Func,ID);                     //MS1(x1double)=x1^2
flSetDiffTemplate(ID,"2*$arg1*$dfarg1");


InitFuncStruct(Func);
Func.addr=(Pointer32)&MS2;
Func.Arg=2;
Func.ArgType=FType;
Func.CallType=fl_MEMORY_STACK_CPU;
Func.DeepFPU=1;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
flSetFunction("MS2",&Func,ID);                   //MS2(x1,x2double)=x1-x2
flSetDiffTemplate(ID,"$dfarg1-$dfarg2");


InitFuncStruct(Func);
Func.addr=(Pointer32)&MS3;
Func.Arg=3;
Func.ArgType=FType;
Func.CallType=fl_MEMORY_STACK_CPU;
Func.DeepFPU=1;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
flSetFunction("MS3",&Func,ID);                    //MSP3(x1,x2,x3double)=x1+x2-x3
flSetDiffTemplate(ID,"$dfarg1+$dfarg2-$dfarg3");
//ms3(ms3(x,y,ms1(t))*ms2(t*ms1(x),t),ms2(ms1(y),-ms3(y,ms2(x,t),ms1(x*ms1(t)))),-ms2(ms3(-y,t,x-ms2(t,y)),ms3(t,y*ms1(ms2(t,-y)),-ms2(y,x))))


InitFuncStruct(Func);
Func.addr=(Pointer32)&PS1;  //=&PS1
Func.Arg=1;
Func.ArgType=FType;
Func.CallType=fl_MEMORY_ADDRESSES;
Func.DeepFPU=1;
Func.ClearStack=fl_ENABLE;
Func.Arrow=fl_RIGHT;
flSetFunction("ps1",&Func,ID);
flSetDiffTemplate(ID,"2*$arg1*$dfarg1");



InitFuncStruct(Func);
Func.addr=(Pointer32)&PS2;    //=&PS2
Func.Arg=2;
Func.ArgType=FType;
Func.CallType=fl_MEMORY_ADDRESSES;
Func.DeepFPU=1;
Func.ClearStack=fl_ENABLE;
Func.Arrow=fl_RIGHT;
flSetFunction("ps2",&Func,ID);
flSetDiffTemplate(ID,"$dfarg1-$dfarg2");


InitFuncStruct(Func);
Func.addr=(Pointer32)&PS3;    //=&PS3
Func.Arg=3;
Func.ArgType=FType;
Func.CallType=fl_MEMORY_ADDRESSES;
Func.DeepFPU=1;
Func.ClearStack=fl_DISABLE;     //stdcall
Func.Arrow=fl_RIGHT;            //stdcall
flSetFunction("ps3",&Func,ID);
flSetDiffTemplate(ID,"$dfarg1+$dfarg2-$dfarg3");
//ps3(ps3(x,y,ps1(t))*ps2(t*ps1(x),t),ps2(ps1(y),-ps3(y,ps2(x,t),ps1(x*ps1(t)))),-ps2(ps3(-y,t,x-ps2(t,y)),ps3(t,y*ps1(ps2(t,-y)),-ps2(y,x))))


//func(TArrayE vx, Int32 nx, Extended x, TArrayD vd, Int32 nd, double d,  TArrayI vi, Int32 ni) = (vx[nx]*x-vd[nd]*d)*vi[ni]
InitFuncStruct(Func);
Func.Arg=8;
//VT.set_length(Func.Arg);
VT.resize(Func.Arg);
VT[0]=fl_ARRAY_EXTENDED; VT[1]=fl_INTEGER; VT[2]=fl_EXTENDED; VT[3]=fl_ARRAY_DOUBLE; VT[4]=fl_INTEGER;
VT[5]=fl_DOUBLE; VT[6]=fl_ARRAY_INTEGER; VT[7]=fl_INTEGER;
Func.ArgTypeList=&VT[0];
Func.addr=(Pointer32)&SP8;
Func.ArgType=fl_DIFFER;
Func.CallType=fl_STACK_CPU;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
Func.DeepFPU=3;
flSetFunction("sp8",&Func,ID);
//sp8(ve,n+3,x*t,vd,j+k,x-y,vi,n+k+j)


//func(TArrayE *vx, Int32 *nx, Extended *x, TArrayD *vd, Int32 *nd, double *d,  TArrayI *vi, Int32 *ni) = (vx[nx]*x-vd[nd]*d)*vi[ni]
InitFuncStruct(Func);
Func.Arg=8;
VT.resize(Func.Arg);
VT[0]=fl_ARRAY_EXTENDED; VT[1]=fl_INTEGER; VT[2]=fl_EXTENDED; VT[3]=fl_ARRAY_DOUBLE; VT[4]=fl_INTEGER;
VT[5]=fl_DOUBLE; VT[6]=fl_ARRAY_INTEGER; VT[7]=fl_INTEGER;
Func.ArgTypeList=&VT[0];
Func.addr=(Pointer32)&PS8;  //ps8
Func.ArgType=fl_DIFFER;
Func.CallType=fl_MEMORY_ADDRESSES;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
Func.DeepFPU=3;
flSetFunction("ps8",&Func,ID);
//ps8(ve,n+3,x*t,vd,j+k,x-y,vi,n+k+j)


//func(TArrayE vx, Int32 nx, Extended x, TArrayD vd, Int32 nd, double d,  TArrayI vi, Int32 ni) = (vx[nx]*x-vd[nd]*d)*vi[ni]
//func(adr) = (vx[nx]*x-vd[nd]*d)*vi[ni]
InitFuncStruct(Func);
Func.Arg=8;
VT.resize(Func.Arg);
VT[0]=fl_ARRAY_EXTENDED; VT[1]=fl_INTEGER; VT[2]=fl_EXTENDED; VT[3]=fl_ARRAY_DOUBLE; VT[4]=fl_INTEGER;
VT[5]=fl_DOUBLE; VT[6]=fl_ARRAY_INTEGER; VT[7]=fl_INTEGER;
Func.ArgTypeList=&VT[0];
Func.addr=(Pointer32)&MS8;
Func.ArgType=fl_DIFFER;
Func.CallType=fl_MEMORY_STACK_CPU;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
Func.DeepFPU=3;
flSetFunction("ms8",&Func,ID);
//ms8(ve,n+3,x*t,vd,j+k,x-y,vi,n+k+j)


InitFuncStruct(Func);
Func.addr=(Pointer32)&infsum;
//Func.ArgType=fl_DOUBLE;
Func.ArgType=FType;
Func.ClearStack=fl_ENABLE;
Func.Arrow=fl_RIGHT;
Func.CallType=fl_INFINITE_STACK_CPU;
Func.DeepFPU=2;
flSetFunction("infsum",&Func,IDF);
flAddNameFunction(IDF,"infs") ;
//infsum(x,y,t,x-y-infsum(x,infsum(x,x*y,-x*y*t),t,x*y),t*x)
//infs(x,y,t,x-y-infs(x,infs(x,x*y,-x*y*t),t,x*y),t*x)


InitFuncStruct(Func);           //fdif(x*fdif(x/fdif(x/y)))/fdif(y/x)
Func.addr=(Pointer32)&fp3d;
Func.Arg=1;
Func.ArgType=FType;
Func.CallType=fl_STACK_CPU;
Func.DeepFPU=2;
Func.ClearStack=fl_DISABLE;
Func.Arrow=fl_RIGHT;
Func.NDeriv=4;
VT.resize(Func.NDeriv);
VT[0]=_int32(&fp3d1);
VT[1]=_int32(&fp3d2);
VT[2]=_int32(&fp3d3);
VT[3]=_int32(&fp3d4);
Func.AdrDeriv=&VT[0];
flSetFunction("fdif",&Func,ID);



InitFuncStruct(Func);                   //idsin(x)^2+idcos(x)^2
Func.addr=(Pointer32)&idfunc;
Func.Arg=1;
Func.ArgType=FType;
Func.CallType=fl_STACK_CPU;
Func.DeepFPU=0;
Func.ClearStack=fl_DISABLE;
Func.Set_ID=fl_ENABLE;
Func.Id_Func=1;
flSetFunction("idsin",&Func,ID);
Func.Id_Func=2;
flSetFunction("idcos",&Func,ID);



/// FillArrayD(TArrayD vd, Double x) = vd[all]=x
InitFuncStruct(Func);
Func.Arg=2;
//VT.set_length(Func.Arg);
VT.resize(Func.Arg);
VT[0]=fl_ARRAY_DOUBLE;  VT[1]=fl_DOUBLE;
Func.ArgTypeList=&VT[0];
Func.addr=(Pointer32)&FillArrayD;
Func.ArgType=fl_DIFFER;
Func.CallType=fl_STACK_CPU;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
Func.DeepFPU=2;
Func.RetNum=fl_NO;
flSetFunction("FillArrayD",&Func,ID);



/// FillArrayE(TArrayE ve, Extended x) = ve[all]=x
InitFuncStruct(Func);
Func.Arg=2;
//VT.set_length(Func.Arg);
VT.resize(Func.Arg);
VT[0]=fl_ARRAY_EXTENDED;  VT[1]=fl_EXTENDED;
Func.ArgTypeList=&VT[0];
Func.addr=(Pointer32)&FillArrayE;
Func.ArgType=fl_DIFFER;
Func.CallType=fl_STACK_CPU;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
Func.DeepFPU=2;
Func.RetNum=fl_NO;
flSetFunction("FillArrayE",&Func,ID);



InitFuncStruct(Func);
Func.Arg=2;
//VT.set_length(Func.Arg);
VT.resize(Func.Arg);
VT[0]=fl_ARRAY_DOUBLE;  VT[1]=fl_DOUBLE;
Func.ArgTypeList=&VT[0];
Func.addr=(Pointer32)&retl;
Func.ArgType=fl_DIFFER;
Func.CallType=fl_STACK_CPU;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
Func.DeepFPU=2;
flSetFunction("retl",&Func,ID);



//krsin(x) = sin(x);
InitFuncStruct(Func);
Code.resize(2);
Code[0]=0xD9; Code[1]=0xFE;     //fsin
Func.CallType=fl_KERNEL_F;
Func.DeepFPU=0;
Func.SizeCode=2;
Func.CodeInline=&Code[0];
flSetFunction("krsin",&Func,ID);
flSetDiffTemplate(ID,"krcos($arg1)*$dfarg1");

//krcos(x) = cos(x);
InitFuncStruct(Func);
Code.resize(2);
Code[0]=0xD9; Code[1]=0xFF;     //fcos
Func.CallType=fl_KERNEL_F;
Func.DeepFPU=0;
Func.SizeCode=2;
Func.CodeInline=&Code[0];
flSetFunction("krcos",&Func,ID);
flSetDiffTemplate(ID,"-krsin($arg1)*$dfarg1");


 //krdiv(x,y) = x/y;
InitFuncStruct(Func);
Code.resize(2);
Code[0]=0xDE; Code[1]=0xF1;    //fdivrp
Func.CallType=fl_KERNEL_FF;
Func.DeepFPU=0;
Func.SizeCode=2;
Func.CodeInline=&Code[0];
flSetFunction("krdiv",&Func,ID);
//flSetDiffTemplate(ID,"($dfarg1*$arg2-$arg1*$dfarg2)/sqr($arg2)");
flSetDiffTemplate(ID,"krdiv(($dfarg1*$arg2-$arg1*$dfarg2),sqr($arg2))");
/*
 sin(x/y)/cos(y/x)
 krdiv(sin(krdiv(x,y)),cos(krdiv(y,x)))
 krdiv(krsin(krdiv(x,y)),krcos(krdiv(y,x)))
*/

 flSet(fl_ENABLE,fl_USE_VIRTUAL_ALLOC,0); /// <- with this, more performance for fl_Precompiled functions

  #ifdef   EXTENDED_VAR
    flSetFunction("pc1(x:ext)=x^2",0,IDF);     flSetDiffTemplate(IDF,"2*$arg1*$dfarg1");
    flSetFunction("pc2(x,y:ext):real=x-y",0,IDF);   flSetDiffTemplate(IDF,"$dfarg1-$dfarg2");
    flSetFunction("pc3(x1,x2,x3:ext)=x1+x2-x3",0,IDF);  flSetDiffTemplate(IDF,"$dfarg1+$dfarg2-$dfarg3");
 #else
    flSetFunction("pc1(x:dbl)=x^2",0,IDF);     flSetDiffTemplate(IDF,"2*$arg1*$dfarg1");
    flSetFunction("pc2(x,y:dbl)=x-y",0,IDF);   flSetDiffTemplate(IDF,"$dfarg1-$dfarg2");
    flSetFunction("pc3(x1,x2,x3:dbl)=x1+x2-x3",0,IDF);  flSetDiffTemplate(IDF,"$dfarg1+$dfarg2-$dfarg3");
 #endif

  flSetFunction("pc8(vx: arrayExt; nx:int; x: ext; vd: arrayDbl; nd: int; d: dbl; vi: arrayInt; ni: int)=(vx[nx]*x - vd[nd]*d)*vi[ni]",0,IDF);

 flSet(fl_DISABLE,fl_USE_VIRTUAL_ALLOC,0);




  flSetFunction("pcdiv(x1,x2:dbl) = x1/x2", 0, IDF);
  flSetDiffTemplate(0, "diff(pcdiv) =pcdiv (($dfarg1*$arg2-$arg1*$dfarg2),sqr($arg2))");

  flSetFunction("pcsin(x:dbl) = sin(x)", 0, IDF);
  flSetDiffTemplate(0, "diff(pcsin) = pccos($arg1)*$dfarg1");

  flSetFunction("pccos(x:dbl) = cos(x)", 0, IDF);
  flSetDiffTemplate(0, "diff(pccos) = -pcsin($arg1)*$dfarg1");

  flSetFunction("pcln(x:dbl) = ln(x)", 0, IDF);
  flSetDiffTemplate(0, "diff(pcln) = $dfarg1/$arg1");

  flSetFunction("pcpow(x1,x2:dbl) = x1^x2", 0, IDF);
  flSetDiffTemplate(0, "diff(pcpow) = pcpow($arg1,$arg2)*(($arg2)*($dfarg1)/($arg1)+($dfarg2)*pcln($arg1))");

  flSetFunction("pcipow(x:dbl; n:int)=x^n", 0, IDF);
  flSetDiffTemplate(0, "diff(pcipow) = pcipow($arg1,$arg2-1)*$arg2*$dfarg1");

   // (sin(x/(x+y))^cos(y/(x+y)))^(n+2)
   //  pcipow(pcpow(pcsin(x/(x+y)),pccos(y/(x+y))),n+2)
   //  pcipow(pcpow(pcsin(pcdiv(x,x+y)),pccos(pcdiv(y,x+y))),n+2)







/***************  several expressions: ****************************************/

/**
fs3(x,y,z)=x*(y+z)+y*(x+z); fs2(x,y)=x+y; fs1(x)=1-x
sum(x=1..5, dx=0.5; y=1..10; dy=0.2; fs3(f1(x-y),fs2(x+1,y-1),x+y));
**/

flPerform(fl_SAVE, fl_VAR_LIST);//push global var.


// fnc1.Expr= "1-x";
// fnc2.Expr= "x+y";
// fnc3.Expr= "x*(y+z)+y*(x+z)";

flSetVar("x", &fnc1.x, fl_DOUBLE);
flCompile("1-x", 0, fnc1.Addr);

flSetVar("x", &fnc2.x, fl_DOUBLE);
flSetVar("y", &fnc2.y, fl_DOUBLE);
flCompile("x+y", 0, fnc2.Addr);

flSetVar("x", &fnc3.x, fl_DOUBLE);
flSetVar("y", &fnc3.y, fl_DOUBLE);
flSetVar("z", &fnc3.z, fl_DOUBLE);
flCompile("x*(y+z)+y*(x+z)", 0, fnc3.Addr);

flPerform(fl_RESTORE, fl_VAR_LIST);  // pop global var.
//flSet(fl_FPU_CW_DEFAULT,0x1332,0);
//flSet(fl_FPU_CW_DEFAULT,0,0)

	x = 1.0;
	y = 1.0;
	dx = 0.5;
	dy = 0.2;
	res = 0.0;

while (x <= 5)
{
	y = 1.0;
	while (y <= 10.0)
	{
		fnc1.x = x - y;

		fnc2.x = x + 1;
		fnc2.y = y - 1;

		//fnc3.x =  ResultF(fnc1.Addr);
		flResultE(fnc1.Addr,fnc3.x);
		//fnc3.y =  ResultF(fnc2.Addr);
		flResultE(fnc2.Addr,fnc3.y);
		fnc3.z = x + y;

		//res = res +  ResultF(fnc3.Addr);
		flResultE(fnc3.Addr,r);
		res = res +r;

		y = y + dy;
	};

	x = x + dx;
};

//printf("several expressions: %.15f\n", res);


/************   Triple integral   **************************************************************************

 int3(F(x,y,z)=x*y+2*y*z-z*x, x = -1..2; y = -2*x...x^2+1; z = x-y...x+y
 in wolframalpha representation: Integrate[x*y+2*y*z-z*x, {x,-1,2}, {y,-2*x,x^2+1}, {z, x-y, x+y}]
**/
  flPerform(fl_SAVE, fl_VAR_LIST);

  flSetVar("x", &FInt3.x, fl_EXTENDED);
  flSetVar("y", &FInt3.y, fl_EXTENDED) ;
  flSetVar("z", &FInt3.z, fl_EXTENDED)  ;
  flCompile("x*y+2*y*z-z*x", 0, FInt3.FAddr);
  flCompile("-2*x", 0, FInt3.F1Addr) ;
  flCompile("x^2+1", 0, FInt3.F2Addr) ;
  flCompile("x-y", 0, FInt3.F3Addr);
  flCompile("x+y", 0, FInt3.F4Addr) ;
  FInt3.a = -1;
  FInt3.b = 2 ;

  flPerform(fl_RESTORE, fl_VAR_LIST) ;
      //P_Integral = 30;
      //T1=GetTickCount();
  resd = Integral3FF(FInt3.FAddr, &FInt3.x, &FInt3.y, &FInt3.z, FInt3.a, FInt3.b, FInt3.F1Addr, FInt3.F2Addr, FInt3.F3Addr, FInt3.F4Addr);
      // T2=GetTickCount();
  //printf("Triple integral: %.15f\n", resd);
      // printf("Time Foreval Integral ms:  %5d\n", T2-T1);

/*****************  Triple integral with internal var. **********************************************************/

  flPerform(fl_SAVE, fl_VAR_LIST);

  flSetVarIntrnl("x", fl_EXTENDED, FInt3Ext.adrX);
  flSetVarIntrnl("y", fl_EXTENDED, FInt3Ext.adrY);
  flSetVarIntrnl("z", fl_EXTENDED, FInt3Ext.adrZ);

  flCompile("x*y+2*y*z-z*x", 0, FInt3Ext.FAddr);
  flCompile("-2*x", 0, FInt3Ext.F1Addr) ;
  flCompile("x^2+1", 0, FInt3Ext.F2Addr) ;
  flCompile("x-y", 0, FInt3Ext.F3Addr);
  flCompile("x+y", 0, FInt3Ext.F4Addr) ;
  FInt3Ext.a = -1;
  FInt3Ext.b = 2 ;

  flPerform(fl_RESTORE, fl_VAR_LIST) ;
     //P_Integral = 30;
     // T1=GetTickCount();
  resd = Integral3FF(FInt3Ext.FAddr, FInt3Ext.adrX, FInt3Ext.adrY, FInt3Ext.adrZ, FInt3Ext.a, FInt3Ext.b, FInt3Ext.F1Addr, FInt3Ext.F2Addr, FInt3Ext.F3Addr, FInt3Ext.F4Addr);
     // T2=GetTickCount();
  //printf("Triple integral with internal var.: %.15f\n", resd);
     // printf("Time Foreval Integral ms:  %5d\n", T2-T1);


///*************************** Triple integral: GCC functions ************************************************
                       /** use only with Extended x,y,z **/
/**
  pf1 = Pointer32(&GccIntMain); pf2 = Pointer32(&GccIntFY1); pf3 = Pointer32(&GccIntFY2);
  pf4 = Pointer32(&GccIntFZ1);  pf5 = Pointer32(&GccIntFZ2);
     //P_Integral = 30;
     //T1=GetTickCount();
  resd = Integral3FF(pf1, &x, &y, &z, FInt3.a, FInt3.b, pf2, pf3, pf4, pf5);
     //T2=GetTickCount();
  printf("Triple integral Gcc: %.15f\n", resd);
     //printf("Time GCC Integral ms:  %5d\n", T2-T1);
**/

///******************************************************************************

/*
  //flSet(fl_ENABLE,fl_USE_VIRTUAL_ALLOC,0);
  flPerform(fl_SAVE, fl_VAR_LIST);

  flSetVarIntrnl("x", fl_EXTENDED, FInt3Ext.adrX);
  flSetVarIntrnl("y", fl_EXTENDED, FInt3Ext.adrY);
  flSetVarIntrnl("z", fl_EXTENDED, FInt3Ext.adrZ);

  //flCompile("(2.11*x*y-5.72*z)*(1.23*y*z-3.24*x*(1.55*x-4.56*y+3.17*z))-1.123*z*(2.58*x+1.79*y+3.21*z)*(1.42*z-2.53*y*(1.124*x+1.155*y-1.176*z)+1.79*x)", 0, FInt3Ext.FAddr);
  //flCompile("-1.21*x*(1.11*x+2.15)", 0, FInt3Ext.F1Addr) ;
  //flCompile("2.15*x*(2.41*x-1.25)", 0, FInt3Ext.F2Addr) ;
  //flCompile("(1.12*x-2.15*y)*x*1.15-1.7*y*(1.31*y+1.53*x)", 0, FInt3Ext.F3Addr);
  //flCompile("(2.21*x-2.15*y)*x*y*2.11+3.7*y*(2.14*y+3.23*x)", 0, FInt3Ext.F4Addr) ;
  //FInt3Ext.a = -1.119;
  //FInt3Ext.b = 1.516 ;

  flCompile("(2.12*x+1.23*y-1.14*z)*(1.31*x-1.45*y+2.21*z)*(1.51*x*y-2.17*y*z+2.15*x*z)-(1.17*x-2.43*y-1.54*z)*(2.14*x+1.75*y-1.41*z)*(2.19*x*y+1.27*y*z-1.45*x*z)", 0, FInt3Ext.FAddr);
  flCompile("(1.32*x-2.17)*x", 0, FInt3Ext.F1Addr) ;
  flCompile("(2.16*x+1.52)*x", 0, FInt3Ext.F2Addr) ;
  flCompile("(1.71*x-2.95*y)*(1.34*x+2.97*y)-2.51*x*y", 0, FInt3Ext.F3Addr);
  flCompile("(2.41*x+5.15*y)*(2.54*x+3.17*y)-3.17*x*y", 0, FInt3Ext.F4Addr) ;

  FInt3Ext.a = -1.35;
  FInt3Ext.b = 1.27 ;

  //flPerform(fl_RESTORE, fl_VAR_LIST) ;
      P_Integral = 30;
      T1=GetTickCount();
  resd = Integral3FF(FInt3Ext.FAddr, FInt3Ext.adrX, FInt3Ext.adrY, FInt3Ext.adrZ, FInt3Ext.a, FInt3Ext.b, FInt3Ext.F1Addr, FInt3Ext.F2Addr, FInt3Ext.F3Addr, FInt3Ext.F4Addr);
      //resd = Integral3FF(FInt3Ext.FAddr,  &x, &y, &z, FInt3Ext.a, FInt3Ext.b, FInt3Ext.F1Addr, FInt3Ext.F2Addr, FInt3Ext.F3Addr, FInt3Ext.F4Addr);

      T2=GetTickCount();
  printf("Triple integral Foreval: %.15e\n", resd);
      printf("Time Foreval Integral ms:  %5d\n", T2-T1);



  pf1 = Pointer32(&GccIntMainT); pf2 = Pointer32(&GccIntFY1T); pf3 = Pointer32(&GccIntFY2T);
  pf4 = Pointer32(&GccIntFZ1T);  pf5 = Pointer32(&GccIntFZ2T);
     //P_Integral = 30;
     T1=GetTickCount();
  resd = Integral3FF(pf1, &x, &y, &z, FInt3Ext.a, FInt3Ext.b, pf2, pf3, pf4, pf5);
     T2=GetTickCount();
  printf("Triple integral Gcc: %.15e\n", resd);
  printf("Time GCC Integral ms:  %5d\n", T2-T1);

*/

///******************************************************************************



/*************************** mixed derivatives******************************/
//d5/dy3dx2
flSetDiffVar("y");
flSetDiffExpr("cos(x^2)*sin(y*x)");
flDiffExpr(3);    //d3/dy3
flSetDiffVar("x");
flDiffExpr(2);    //d2/dx2
flCompileDiffExpr(FS1);
x = 2.123; y = 5.456; t = -3.789;
flResultE(FS1,res);
//printf("mixed derivatives: %.15f\n", res);





/**************************Use Attrib (set function)********************************************/

   //fnc1(x,y)=x+y ; fnc2(x,y,z)=x*y*z ; fnc2(5.5,7.7,fnc1(1.1,2.2))

   //fnc1.Expr = "x + y";
   //fnc2.Expr = "x * y * z";

   //push global var.
   flPerform(fl_SAVE, fl_VAR_LIST);

   flSetVar("x", &fnc1.x, fl_DOUBLE);
   flSetVar("y", &fnc1.y, fl_DOUBLE);
   FAtr.Addr = &fnc1.res;
   FAtr.RType = fl_DOUBLE;
   flCompile("x+y", &FAtr, fnc1.Addr);
   //flCompile(fnc1.Expr, &FAtr, fnc1.Addr);

   flSetVar("x", &fnc2.x, fl_DOUBLE);
   flSetVar("y", &fnc2.y, fl_DOUBLE);
   flSetVar("z", &fnc2.z, fl_DOUBLE);
   FAtr.Addr = &fnc2.res;
   FAtr.RType = fl_DOUBLE;
   flCompile("x*y*z", &FAtr, fnc2.Addr);
   //flCompile(fnc2.Expr, &FAtr, fnc2.Addr);

    //pop global var.
    flPerform(fl_RESTORE, fl_VAR_LIST);


   fnc1.x = 1.1;
   fnc1.y = 2.2;
   //Result(fnc1.Addr);
   flResult(fnc1.Addr);

   fnc2.x = 5.5;
   fnc2.y = 7.7;
   fnc2.z = fnc1.res;
   //Result(fnc2.Addr);
   flResult(fnc2.Addr);

   //printf("Use Attrib: %.15f\n", fnc2.res);



//*********************************************************************************************************







flGet(fl_VERSION,fl_MAJOR,ID1);    Sid1=IntToStr(ID1);
flGet(fl_VERSION,fl_MINOR,ID2);    Sid2=IntToStr(ID2);
flGet(fl_VERSION,fl_RELEASE,ID3);  Sid3=IntToStr(ID3);
flGet(fl_VERSION,fl_BUILD,ID4);    Sid4=IntToStr(ID4);
Sid=Sid1+"."+Sid2+"."+Sid3+"."+Sid4;



SText="Foreval.dll  (v."+Sid+")";
flGet(fl_COMPILED_BY,0,ID);


if (ID >= 100) {SText=SText+".  Compiled by FPC v." + IntToStr(ID); GLT=2;}
else
{
 GLT=1;
 switch  (ID)
 {

  case 7: SText=SText+".   Compiled by Delphi7"; break;
  case 8: SText=SText+".   Compiled by Delphi8";   break;
  case 9: SText=SText+".   Compiled by Delphi2005"; break;
  case 10: SText=SText+".  Compiled by Delphi2006"; break;
  case 11: SText=SText+".  Compiled by Delphi2007";  break;
  case 12:  SText=SText+".   Compiled by Delphi 2009"; break;
  case 13:  SText=SText+".   Compiled by Delphi 2010"; break;
  case 14:  SText=SText+".   Compiled by Delphi XE"; break;
  case 15:  SText=SText+".   Compiled by Delphi XE2";  break;
  case 16:  SText=SText+".   Compiled by Delphi XE3";  break;
  case 17:  SText=SText+".   Compiled by Delphi XE4";  break;
  case 18:  SText=SText+".   Compiled by Delphi XE5"; break;
  case 19:  SText=SText+".   Compiled by Delphi XE6";  break;
  case 20:   SText=SText+".   Compiled by Delphi XE7";  break;
  }
}
   cout <<  "" << endl;
   cout <<  SText << endl;

   cout <<  "" << endl;
   cout <<  "Test connection Foreval.dll to GCC"<< endl;
   cout <<  "on default: Extended var.: x=2.123; y=5.456; t=-3.789;"  << endl;
   cout <<  "on default: Int32 var.: n=1; k=2; j=5;"  << endl;
   cout <<  "on default: Array of Extended: ve(0-99);" << endl;
   cout <<  "on default: Array of double: ad(0-2); vd(0-99);" << endl;
   cout <<  "on default: Array of Int32: vi(0-99);" << endl;
   cout <<  "*****************************************************************************" << endl;
   printf("\n");
}


return flLoad;
}


                                        /// arithmetic expressions:
TFloatType GccE1()
{
 return  x*(y*x+t*(-x-(-y-x*(-y/x+x*(x*y+y*(t+x)))/(-y*(x*y*t*(x+t)*(y+t)/(y/t+x/(t-y))))/(y*(y/(x+y+t)-x/(x*y+t/(y+x*(y-x))))-x*(t/(t-x)+y*x/(y-x*(t/y-t)-t*(x*(-t-y-x))))))));
};


TFloatType GccE2()
{
 return x*y*(2.2*x+1)*(2.3*x*y/t-2.5*x*(3.7*t-1)/(2.7*x-3.6*y-4.7)*(x/(3.6*x-1)-4.1/x+5.8*(2.6*x*y*t-1.7)/(y+1.7)-7.1*(2.8*x*(y+1.1)*(3.4*y+2.2)*(3.1/(x+1.5)-2.3*t/(2.4*x*y*t-1.7)+(4.7*x-1.164)*(5.7*y-7.4)/(x-2.7*y-1.7-2.4*t/(3.8-7.6*x-8.1*y*(4.2*x/(2.9*t+1.6)-7.198*x-8.9/t+9.9*(2.1*x-1.261)*(3.1*x+4.9*y+5.8)*(2.1*x*y*t-7.1)*x*y*t/(x-y*2.8-3.6/(x/(t-1.7)-7.8/(y+2.5)+8.3/(2.8*x*y*t+1.7)-9.4)))))/(x-1.5)))));
};

///with common subexpr.
TFloatType GccE3S()
{
 return  x*(y/(x/y-y/x)-x/(x*y/(x+y)+t/(y/x-x/(x+y)))+t*(-y/(t/(x-y)-x*y/(x+y))+x*y*t/(x/(x+y)-y/(x+y))))*(x/(x/(x-y)-y/(t/(y/x-x/(x+y))+y/(t/(x-y)-x*y/(x+y))))-y/(x*y*t/(x/(x+y)-y/(x+y))-y/(x/y-y/x)))/(x/(x-y)+y/(x/(x/y-y/x)+x/(x*y/(x+y)+t/(y/x-x/(x+y)))));;
};


///with common subexpr.
TFloatType GccE4S()
{
 return  (2.1*x/(3.2*y-1.1*x+t)-1.1/(3.2*x*y-1.5)+5.7/(2.1/(x+2.4)-1.4/(y+1.2))-x/(-1.1/(1.5*x*y-3.7)+x*y/(1.2*x+2.3*y+3.3*t-4.5)))*(-y*x/(-3.5/(-1.5*y-t/(1.7*x*y*t-7.7))+2.1/(x+2.4))-t/(1.4/(y+1.2)+1.1/(3.2*x*y-1.5)))/(x*(1.1/(1.5*x*y-3.7)-2.1*x/(3.2*y-1.1*x+t))+y*(x*y/(1.2*x+2.3*y+3.3*t-4.5)+y*x/(-3.5/(-1.5*y-t/(1.7*x*y*t-7.7))+2.1/(x+2.4)))-5.7/(2.1/(x+2.4)-1.4/(y+1.2)));;
};

                                               /// indexing array
TFloatType GccA5()
{
 return  (x*vd[n+1]*ve[k+n]-y*vd[2*n+1]*ve[k+3*n]+t*vi[2*k+n+1])*(t*vd[4*n+k-3]*ve[j+5]+x*ve[5*n+3*k-4]*vd[j+k-n]-y*vi[2*j+k-1]);
};




TFloatType GccA6()
{
     INT32 i,j,L;
     double avr,res;


L = vd.size()-1;
     //L = 99;
     res = 0;
     for(i=0; i <= L; i++)
     {
          if(vd[i] > 0)
          {
             for(j=0; j <= L; j++)
               {
                 if((j > i)&&(vd[j] > vd[i]))
                    {
                        res=res-x*vd[j-i];
                    }
                    else
                    {
                        res=res+x*vd[j];
                    };

               }
          }
          else
          {
              res=res-y*vd[L-i];
         }
     };

  return res;

};



TFloatType GccA6F()
{
     INT32 i,j,L;
     double avr,res;


L = vdf.size()-1;
     //L = 99;
     res = 0;
     for(i=1; i <= L; i++)  /// in C++ count from 1  !! (if array in Foreval as "fast connect")
     {
          if(vdf[i] > 0)
          {
             for(j=1; j <= L; j++)  /// in C++ count from 1  !! (if array in Foreval as "fast connect")
               {
                 if((j > i)&&(vdf[j] > vdf[i]))
                    {
                        res=res-x*vdf[j-i+1];  /// in C++ count from 1  !! (if array in Foreval as "fast connect")
                    }
                    else
                    {
                        res=res+x*vdf[j];

                    };

               }
          }
          else
          {
              res=res-y*vdf[L+1-i];  /// in C++ count from 1  !! (if array in Foreval as "fast connect")
         }
     };

  return res;

};


                                                 /// polynom
TFloatType GccP7()
{
       #ifdef   EXTENDED_VAR
          return  1.1*powl(x,12)-2.1*powl(x,11)-3.1*powl(x,10)+2.2*powl(x,9)-3.3*powl(x,8)-5.7*powl(x,7)+2.3*powl(x,6)-9.8*powl(x,5)+1.7*powl(x,4)+1.4*powl(x,3)-7.5*powl(x,2)+7.7*x+12.3;
       #else
          return  1.1*pow(x,12)-2.1*pow(x,11)-3.1*pow(x,10)+2.2*pow(x,9)-3.3*pow(x,8)-5.7*pow(x,7)+2.3*pow(x,6)-9.8*pow(x,5)+1.7*pow(x,4)+1.4*pow(x,3)-7.5*pow(x,2)+7.7*x+12.3;
       #endif
};


                                                  /// function
TFloatType GccF8()
{
 #ifdef   EXTENDED_VAR
    return  sinl(cosl(x+y))*cosl(y*sinl(x-y))*(2.15*cosl(sinl(3.53*cosl(t-x)))-tanl(x+y)*(tanl(t+x)-cosl(sinl(t+y))*((1.76*asinl(x/(x+y))+2.97*acosl(y/(x+y)))*(2.12*atanl(x-y)*atan2l(x-y,x+y)-asinl(t/(x+y))*acosl(t/(y+x-t))/(atanl(x+y)+atan2l(t-x-y,x-t))))));
   #else
    return  sin(cos(x+y))*cos(y*sin(x-y))*(2.15*cos(sin(3.53*cos(t-x)))-tan(x+y)*(tan(t+x)-cos(sin(t+y))*((1.76*asin(x/(x+y))+2.97*acos(y/(x+y)))*(2.12*atan(x-y)*atan2(x-y,x+y)-asin(t/(x+y))*acos(t/(y+x-t))/(atan(x+y)+atan2(t-x-y,x-t))))));
  #endif
};

/// mixed
TFloatType GccF9()
{
    #ifdef   EXTENDED_VAR
       return  (powl(x-sinl(x),y-cosl(y))/(tanl(1.5*asinl(1.1*x/(1.2*x+y))))+powl(y-sinl(x*1.2)/cosl(y+1.1),n+k)/(x+2.1*y))*(2.1*sinhl(x/y)*sinl(x+y)-3.2*coshl(x/(x+y)*cosl(x-y))-tanhl(y/(x+y))/(expl(2.1*x/y))*asinl(1.1*x/(2.1*x+y))-2.1*atanl(1.1*x-y)*atan2l(x-y,1.3*x+y));
    #else
       return  (pow(x-sin(x),y-cos(y))/(tan(1.5*asin(1.1*x/(1.2*x+y))))+pow(y-sin(x*1.2)/cos(y+1.1),n+k)/(x+2.1*y))*(2.1*sinh(x/y)*sin(x+y)-3.2*cosh(x/(x+y)*cos(x-y))-tanh(y/(x+y))/(exp(2.1*x/y))*asin(1.1*x/(2.1*x+y))-2.1*atan(1.1*x-y)*atan2(x-y,1.3*x+y));
    #endif

};

                                         /// function with common subexpr.
/// trig. func.
TFloatType GccF10S()
{
  #ifdef   EXTENDED_VAR
       return  (cosl(x*sinl(x))*sinl(y*cosl(y))-sinl(cosl(x*cosl(x+y)))*cosl(y*cosl(x*sinl(x*y))))*(cosl(sinl(y)*y+x*cosl(x))*sinl(x*sinl(x+y))-cosl(y*cosl(x*y))*sinl(x*cosl(x+y))+sinl(y*cosl(x*sinl(x*y)))*sinl(cosl(x*cosl(x+y)))/(sinl(x*sinl(x))*cosl(y*cosl(y))+cosl(cosl(x*cosl(x+y)))*sinl(sinl(y)*y+x*cosl(x))-sinl(y*cosl(x*sinl(x*y)))*sinl(cosl(x*cosl(x+y)))));
   #else
       return  (cos(x*sin(x))*sin(y*cos(y))-sin(cos(x*cos(x+y)))*cos(y*cos(x*sin(x*y))))*(cos(sin(y)*y+x*cos(x))*sin(x*sin(x+y))-cos(y*cos(x*y))*sin(x*cos(x+y))+sin(y*cos(x*sin(x*y)))*sin(cos(x*cos(x+y)))/(sin(x*sin(x))*cos(y*cos(y))+cos(cos(x*cos(x+y)))*sin(sin(y)*y+x*cos(x))-sin(y*cos(x*sin(x*y)))*sin(cos(x*cos(x+y)))));
  #endif


};


/// mixed
TFloatType GccF11S()
{
  #ifdef   EXTENDED_VAR
    return (sinl(x/(x+y))-sinhl(x/(x+y))*asinl(x/(x+y)))*(coshl(x/(x+y))*acosl(x/(x+y))+cosl(x/(x+y)))*(tanhl(x/(x+y))-expl(x/(x+y)));
   #else
    return (sin(x/(x+y))-sinh(x/(x+y))*asin(x/(x+y)))*(cosh(x/(x+y))*acos(x/(x+y))+cos(x/(x+y)))*(tanh(x/(x+y))-exp(x/(x+y)));
  #endif


};



TFloatType GccF12S()
{
 #ifdef   EXTENDED_VAR
    return (powl(sinl(x+y),k+2*n)*powl(cosl(x*y),n+k)-powl(x-sinl(x*y),powl(cosl(x*y),n+k))*powl(y-cosl(x+y),powl(sinl(x+y),k+2*n)))/(y-sinl(powl(x-sinl(x),y-cosl(y)))/cosl(powl(x-sinl(x),y-cosl(y)))) ;
   #else
    return (pow(sin(x+y),k+2*n)*pow(cos(x*y),n+k)-pow(x-sin(x*y),pow(cos(x*y),n+k))*pow(y-cos(x+y),pow(sin(x+y),k+2*n)))/(y-sin(pow(x-sin(x),y-cos(y)))/cos(pow(x-sin(x),y-cos(y)))) ;
  #endif

 };


                            /// external functions.
TFloatType GccFE13()
{
 return sp3(x-sp3(sp1(y),sp3(x+y,x+t,y+t)-2.1*sp2(sp1(t),1.1-sp2(sp1(1.1+x),y-sp3(x+1.2,y+1.3,t+1.4))),t-sp2(sp3(x-y,y-t,t-x),sp2(2.1-x,3.2-y))),y-sp3(-x,-y,t-sp3(-t,x,-y-sp2(t-sp2(t,-y+x),y-sp3(x-y,y,x)))),1.5*y-sp3(x,-y,-t)*sp3(sp2(x,y),-sp2(-x,t),sp3(y,t,x))) ;
};


TFloatType GccFE14()
{
  return sp8(ve,j+3,t+sp8(ve,n,y-sp8(ve,k,x-y,vd,j+n,y-sp8(ve,k,t-y,vd,j+n,y,vi,j+2),vi,j+2),vd,k+2,t,vi,n+2*j),vd,j+n,x-sp8(ve,n,-x,vd,j+n-1,-y,vi,k+2*n-1)/sp8(ve,j,x+sp8(ve,k,t+sp8(ve,n,y-t,vd,j+n+1,y,vi,k+5),vd,n+3,x+sp8(ve,j+k,y,vd,j+k*2,y+1.1,vi,n+k+3*j),vi,k+j*2-1),vd,j-1,y,vi,n+2*k),vi,n+2);
};




TFloatType GccFuncEx()
{
     TFloatType res;

//res = (2.1*x/(3.2*y-1.1*x+t)-1.1/(3.2*x*y-1.5)+5.7/(2.1/(x+2.4)-1.4/(y+1.2))-x/(-1.1/(1.5*x*y-3.7)+x*y/(1.2*x+2.3*y+3.3*t-4.5)))*(-y*x/(-3.5/(-1.5*y-t/(1.7*x*y*t-7.7))+2.1/(x+2.4))-t/(1.4/(y+1.2)+1.1/(3.2*x*y-1.5)))/(x*(1.1/(1.5*x*y-3.7)-2.1*x/(3.2*y-1.1*x+t))+y*(x*y/(1.2*x+2.3*y+3.3*t-4.5)+y*x/(-3.5/(-1.5*y-t/(1.7*x*y*t-7.7))+2.1/(x+2.4)))-5.7/(2.1/(x+2.4)-1.4/(y+1.2)));

     //res = x*(y*x+t*(-x-(-y-x*(-y/x+x*(x*y+y*(t+x)))/(-y*(x*y*t*(x+t)*(y+t)/(y/t+x/(t-y))))/(y*(y/(x+y+t)-x/(x*y+t/(y+x*(y-x))))-x*(t/(t-x)+y*x/(y-x*(t/y-t)-t*(x*(-t-y-x))))))));

     //res = x*y*(2.2*x+1)*(2.3*x*y/t-2.5*x*(3.7*t-1)/(2.7*x-3.6*y-4.7)*(x/(3.6*x-1)-4.1/x+5.8*(2.6*x*y*t-1.7)/(y+1.7)-7.1*(2.8*x*(y+1.1)*(3.4*y+2.2)*(3.1/(x+1.5)-2.3*t/(2.4*x*y*t-1.7)+(4.7*x-1.164)*(5.7*y-7.4)/(x-2.7*y-1.7-2.4*t/(3.8-7.6*x-8.1*y*(4.2*x/(2.9*t+1.6)-7.198*x-8.9/t+9.9*(2.1*x-1.261)*(3.1*x+4.9*y+5.8)*(2.1*x*y*t-7.1)*x*y*t/(x-y*2.8-3.6/(x/(t-1.7)-7.8/(y+2.5)+8.3/(2.8*x*y*t+1.7)-9.4)))))/(x-1.5)))));

     //res = x*(y/(x/y-y/x)-x/(x*y/(x+y)+t/(y/x-x/(x+y)))+t*(-y/(t/(x-y)-x*y/(x+y))+x*y*t/(x/(x+y)-y/(x+y))))*(x/(x/(x-y)-y/(t/(y/x-x/(x+y))+y/(t/(x-y)-x*y/(x+y))))-y/(x*y*t/(x/(x+y)-y/(x+y))-y/(x/y-y/x)))/(x/(x-y)+y/(x/(x/y-y/x)+x/(x*y/(x+y)+t/(y/x-x/(x+y)))));



//res =  x*y-x/(x/y-t/y-(-x-y*(x*y-t*x/(x/y-t/y-(-x-(-y-(-t-(x*(y-t)-y*(-x*(-y-x)-y/(x+y*t)))*x)*y)/(x+y*(-t-x/t))-x*(y/t-(-y*(t/x)/(x-y/t)-(-x-(-y/(-x*(-x-y)*y)+x/y*(-(-t/y-x)*x+y*(-t/x)-x/(x-y/t))-x/(y-x-y/x)*(x/y+(-x/(-y+x)-t/y+x-y*(x/y-x/t)))))+x*(-y-t)*(-t-x+y)*(x+y/t))))))));

//     x*y*(2.251*x+1)*(2.243*x*y/t-2.353*x*(3.475*t-1)/(2.575*x-3.675*y-4.766)*(x/(3.767*x-1)-4.176/x+5.186*(2.866*x*y*t-1.766)/(y+1.876)-7.165*(2.874*x*(y+1.641)*(3.864*y+2.162)*(3.171/(x+1.765)-2.173*t/(2.174*x*y*t-1.171)+(4.171*x-1.164)*(5.172*y-7.174)/(x-2.175*y-1.747-2.174*t/(3.618-7.716*x-8.181*y*(4.612*x/(2.189*t+1.165)-7.198*x-8.149/t+9.912*(2.199*x-1.261)*(3.107*x+4.179*y+5.108)*(2.271*x*y*t-7.179)*x*y*t/(x-y*2.282-3.621/(x/(t-1.147)-7.198/(y+2.245)+8.233/(2.288*x*y*t+1.247)-9.174)))))/(x-1.525)))));
//        res =
 //    res = (x*y*t)/((y*x*t)/(x*t*y));
//        res = 2.12*x+3.56*y+t;
//res = (x*y+t*(x+y))/(x*t-y*x*t);
//        res = x*y+t*y*(x*y+y*t*(x*y+t*y*(x*y+y*t*(x*y+t*y*(x*y+y*t*(x*y+t*y*(x*y+y*t*(x*y+t*y*(x*y+y*t*(x*y+t*y*(x*y+y*t)))))))))));
 //       res = (x+0.1)*(y-0.01)+t*(y+0.01)*((x+0.2)*y+(y-0.2)*t*((x-0.3)*y+t*(y-0.3)*((x+0.4)*y+(y-0.4)*t*((x-0.5)*y+t*(y+0.5)*((x+0.6)*y+(y-0.6)*t*((x+0.7)*y+t*(y-0.7)*((x+0.8)*y+(y-0.8)*t*((x+0.9)*y+t*(y-0.9)*((x-0.11)*y+(y+0.11)*t*((x-0.12)*y+t*(y-0.12)*((x-0.13)*y+(y-0.14)*t)))))))))));
//        res = x*y+y*x*(t*y-x*t*(t*x+(x+y)*(x-y)*(y*t-x*(x+t)*((x-t)*y-y*(y+t)*((y-t)*t-t*(t-x)*(t*(t-y)-x*(y-x+t)*(x*(x-y-t)*t-y*(y*(x+y*t)*t+x*(t+y-x)))))))));
//        res = (y/x-x/(x+y)-y/(x-y)+t/(x/y+t+y/x)+x/(x/(x+y)-y/(x-t)))*(y/(x/y-x/(x+y))-t/(y/(x-t)+y/x-x/y))/(t/(t/(x/y+t+y/x)-y/(x-t))-x/(x/(x+y)-y/(x-t)));
//        res = x*y-x/(x/y-t/y-(-x-y*(x*y-t*x/(x/y-t/y-(-x-(-y-(-t-(x*(y-t)-y*(-x*(-y-x)-y/(x+y*t)))*x)*y)/(x+y*(-t-x/t))-x*(y/t-(-y*(t/x)/(x-y/t)-(-x-(-y/(-x*(-x-y)*y)+x/y*(-(-t/y-x)*x+y*(-t/x)-x/(x-y/t))-x/(y-x-y/x)*(x/y+(-x/(-y+x)-t/y+x-y*(x/y-x/t)))))+x*(-y-t)*(-t-x+y)*(x+y/t))))))));


// 		  res = x*y*t*(t*x*(x*y-t*x)-x*y*(x*t-y*t)+y*x*(y*x-t*y)-(x+y)*(x-y)*(t-y)*(x*y-t*x*(x-y*(t-x*(t-x)*(x-t)*(t-y)-x*y-y))))-(x*t*y*(x*y-x*(y-y*(t-t*(x-x*t*(x*y-t*x-(x*y-t*x)*(x-y)*(y-t)*(t-y)-(x+t*y)*(y-x*t)+(t-y*t)*(y-t*x))))))) ;
//		  res = -x/(x/y-t/(x+t)+x*y*(x*y-y*t+x/(x/(x+y)+y/(t+x))))*(y*(x-y/(x*y-y/(x*y+y*t)*(y*t-x*y)))+x-y*(x-t-t/(x-y)*(y/(y-t*(x+y*t)*(y-x*t)/(x*t-y*(x+t))))))*(x*y-t*y-t*(x*t-y*(t-x)/(x*y*t-x-y-t)));
//		  res = x*y*(2.111*x+1)*(2.211*x*y/t-2.311*x*(3.422*t-1)/(2.511*x-3.611*y-4.22)*(x/(3.711*x-1)-4.111/x+5.111*(2.611*x*y*t-1.23)/(y+1.12)-7.132*(2.812*x*(y+1.123)*(3.832*y+2.121)*(3.112/(x+1.123)-2.133*t))));
//		  res = x*y*(x-t*(2.123*x-3.222*y-5.323)/(t*x*y/(2.234-x*y)+(2.455*x+3.632)*(3.734*y-4.832*t-5.923)-(1.134-x)/(-t-y))+x*(y-(-x-(-y/(-t*x*(x*y*t*(2.745*x-3.345*y-t))-y*(x*y-y*t*3.167+2.965*(x/t-t/(x-y*(2.467-x-y-t)))*(y-t)-2.376*x)*(y-x)-7.154/x)*(-1.943/t+x*y*t*5.334))-3.556*x-5.657)-7.243*y-3.459)/(x-t)+x*(t*y/(x-2.834*t)-y*(x*(t-2.756*y-x-5.676))));
//		  res = (x*y+t*(x*y-y*t*x-x+y-t))*(x+y+t)*(x-y-t)*(t-x*(t-y*(x-y-t)))*x*y*t-x*t*(x*t-y*t+x-t)*(y*x+t*x+t*y-y-x)*(x*t-y*(x-y*t-t-x)*(x-y-t)-y*(y+y*x-t-x)+t*(x*y-x*(t+y*(x*y-t*y*x-y*t*(y+x*(x-t+y*(x-y+t-x*(x*y-t*x)*(x*y-t*(x+y+t)*(x-y-t)-t*(-x-y*(-t*(-x*(y-t))))))))))));
 //res=(sin(x/(x+y))-sinh(y/(x+y))*asin(x/(x+y)))*(cosh(y/(x+y))*acos(x/(x+y))+cos(x/(x+y)));
//		  res = x*y-x/(x/y-t/y-(-x-y*(x*y-t*x/(x/y-t/y-(-x-(-y-(-t-(x*y-y*(-x*y-y/(x+y*t)))*x)*y)/(x+y*t)-x*(y/t-(-y*x/(x-y*t)-(-x-(-y/(-x*y*(-x-y))+x/y*(y*x+y*t-x/(x+y*t))-x*y*(x*y+(-x*y-t/y+x-y*x)))))+x*y*t*(x+y*t)))))));
//		  res = x*y*(x-t*(2.154*x-3.253*y-5.353)/(t*x*y/(2.544-x*y)+(2.143*x+3.556)*(3.343*y-4.153*t-5.456)-(1.153-x)/(-t-y))+x*(y-(-x-(-y/(-t*x*(x*y*t*(2.644*x-3.364*y-t))-y*(x*y-y*t*3.164+2.267*(x/t-t/(x-y*(2.533-x-y-t)))*(y-t)-2.453*x)*(y-x)-7.535/x)*(-1.253/t+x*y*t*5.353))-3.433*x-5.455)-7.466*y-3.577)/(x-t)+x*(t*y/(x-2.699*t)-y*(x*(t-2.767*y-x-5.854)-y*(-1.549-x/(-t-y))/(x/y-x/(t/x-y/t)+t*(1/x-5.344/y-x*y*(2.435*x-1.456)*(t*y*3.326-5.347)*(1.943-x*y*t*3.245)*(x+y))))));
//		  res = (x*y+t*(x*y-y*t*x-x+y-t))*(x+y+t)*(x-y-t)*(t-x*(t-y*(x-y-t)))*x*y*t-x*t*(x*t-y*t+x-t)*(y*x+t*x+t*y-y-x)*(x*t-y*(x-y*t-t-x)*(x-y-t)-y*(y+y*x-t-x)+t*(x*y-x*(t+y*(x*y-t*y*x-y*t*(y+x*(x-t+y*(x-y+t-x*(x*y-t*x)*(x*y-t*(x+y+t)*(x-y-t*(x-y*(t-x*y-y*(x*y-t*x)-t*(t*x+y))))-t*(-x-y*(-t*(-x*(y-t*(x*y*t-y*x*t*(-x*(y*x-t*y-x-y-t)))))))))))))));
//        res = (x*y+t/(x*y-y*t/x-x+y-t))*(x+y+t)/(x-y-t)*(t-x*(t-y/(x-y-t)))*x/y*t-x*t*(x*t-y*t+x-t)/(y*x+t*x+t/y-y-x)*(x*t-y*(x-y*t-t-x)*(x-y-t)-y*(y+y*x-t-x)+t*(x*y-x*(t+y/(x*y-t*y*x-y*t*(y+x*(x-t+y*(x-y+t-x*(x*y-t*x)*(x*y-t*(x+y+t)*(x-y-t/(x-y*(t-x*y-y/(x*y-t*x)-t/(t/x+y))))-t*(-x-y*(-t/(-x*(y-t*(x*y/t-y*x*t/(-x*(y*x-t*y-x-y-t)))))))))))))));
//		  res = x*y*(x-t*(2.156*x-3.652*y-5.653)/(t*x*y/(2.664-x*y)+(2.155*x+3.543)*(3.345*y-4.431*t-5.443)-(1.451-x)/(-t-y))+x*(y-(-x-(-y/(-t*x*(x*y*t*(2.453*x-3.353*y-t))-y*(x*y-y*t*3.153+2.253*(x/t-t/(x-y*(2.533-x-y-t)))*(y-t)-2.453*x)*(y-x)-7.553/x)*(-1.253/t+x*y*t*5.533))-3.453*x-5.453)-7.453*y-3.553)/(x-t)+x*(t*y/(x-2.653*t)-y*(x*(t-2.753*y-x-5.853)-y*(-1.539-x/(-t-y))/(x/y-x/(t/x-y/t)+t*(1/x-5.553/y-x*y*(2.535*x-1.53)*(t*y*3.536-5.753)*(1.539-x*y*t*3.665)*(x+y*(t-(-x-y*t/(x*y-2.863*(x*y*(x-y*(x*t+y/t*(2.623*x-1.352-t*y))))))))))))) ;
 //       res = x*y*(2.251*x+1)*(2.243*x*y/t-2.353*x*(3.475*t-1)/(2.575*x-3.675*y-4.766)*(x/(3.767*x-1)-4.176/x+5.186*(2.866*x*y*t-1.766)/(y+1.876)-7.165*(2.874*x*(y+1.641)*(3.864*y+2.162)*(3.171/(x+1.765)-2.173*t/(2.174*x*y*t-1.171)+(4.171*x-1.164)*(5.172*y-7.174)/(x-2.175*y-1.747-2.174*t/(3.618-7.716*x-8.181*y*(4.612*x/(2.189*t+1.165)-7.198*x-8.149/t+9.912*(2.199*x-1.261)*(3.107*x+4.179*y+5.108)*(2.271*x*y*t-7.179)*x*y*t/(x-y*2.282-3.621/(x/(t-1.147)-7.198/(y+2.245)+8.233/(2.288*x*y*t+1.247)-9.174)))))/(x-1.525)))));
//        res = (x/y+y/x)*(x/(x+y)-y/(x-y)-(t/(x/y-y/x))/(x/(y-t/(x/y-y/x)))-(y/(x-y)-t/(y/x-x/(x+y))+x/(x+y)));
//        res  = (x*y+t*(x*y-y*t*x-x+y-t))*(x+y+t)*(x-y-t)*(t-x*(t-y*(x-y-t)))*x*y*t-x*t*(x*t-y*t+x-t)*(y*x+t*x+t*y-y-x)*(x*t-y*(x-y*t-t-x)*(x-y-t)-y*(y+y*x-t-x)+t*(x*y-x*(t+y*(x*y-t*y*x-y*t*(y+x*(x-t+y*(x-y+t-x*(x*y-t*x)*(x*y-t*(x+y+t)*(x-y-t)-t*(-x-y*(-t*(-x*(y-t))))))))))));
//res = sp8(ve,j,t,vd,k,y,vi,j);
//res = sp8(ve,j+1,t+x,vd,k+2*j,y-t,vi,j+k+1);

//res = sp8(ve,j+3,t+sp8(ve,n,y-sp8(ve,k,x-y,vd,j+n,y-sp8(ve,k,t-y,vd,j+n,y,vi,j+2),vi,j+2),vd,k+2,t,vi,n+2*j),vd,j+n,x-sp8(ve,n,-x,vd,j+n-1,-y,vi,k+2*n-1)/sp8(ve,j,x+sp8(ve,k,t+sp8(ve,n,y-t,vd,j+n+1,y,vi,k+5),vd,n+3,x+sp8(ve,j+k,y,vd,j+k*2,y+1.1,vi,n+k+3*j),vi,k+j*2-1),vd,j-1,y,vi,n+2*k),vi,n+2);

res = (x*vd[n+1]*ve[k+n]-y*vd[2*n+1]*ve[k+3*n]+t*vi[k+n])*(t*vd[n+k+3]*ve[j+5]+x*ve[2*n+3*k+4]*vd[j+k-n]-y*vi[j+k-1]);

     // res = sp8(ve,n+3,x/sp8(ve,n+7,x-t,vd,j+3,-y+sp8(ve,k+3,-t,vd,j+3*k,x-sp8(ve,j+3,t,vd,j+n,t+x,vi,n+2*j),vi,k+j),vi,n+2*k),vd,j+k,x*sp8(ve,n+7,t/sp8(ve,j+6,x-t,vd,j+n-1,x-y,vi,n+3*k+j),vd,j+9,x+sp8(ve,n,t,vd,k,y,vi,j),vi,j+5),vi,n+k+j)/sp8(ve,k+3,t,vd,n+3,x,vi,k+2*j);
		   // pc8(ve,n+3,x/pc8(ve,n+7,x-t,vd,j+3,-y+pc8(ve,k+3,-t,vd,j+3*k,x-pc8(ve,j+3,t,vd,j+n,t+x,vi,n+2*j),vi,k+j),vi,n+2*k),vd,j+k,x*pc8(ve,n+7,t/pc8(ve,j+6,x-t,vd,j+n-1,x-y,vi,n+3*k+j),vd,j+9,x+pc8(ve,n,t,vd,k,y,vi,j),vi,j+5),vi,n+k+j)/pc8(ve,k+3,t,vd,n+3,x,vi,k+2*j);
		   // ms8(ve,n+3,x/ms8(ve,n+7,x-t,vd,j+3,-y+ms8(ve,k+3,-t,vd,j+3*k,x-ms8(ve,j+3,t,vd,j+n,t+x,vi,n+2*j),vi,k+j),vi,n+2*k),vd,j+k,x*ms8(ve,n+7,t/ms8(ve,j+6,x-t,vd,j+n-1,x-y,vi,n+3*k+j),vd,j+9,x+ms8(ve,n,t,vd,k,y,vi,j),vi,j+5),vi,n+k+j)/ms8(ve,k+3,t,vd,n+3,x,vi,k+2*j);
		   // ps8(ve,n+3,x/ps8(ve,n+7,x-t,vd,j+3,-y+ps8(ve,k+3,-t,vd,j+3*k,x-ps8(ve,j+3,t,vd,j+n,t+x,vi,n+2*j),vi,k+j),vi,n+2*k),vd,j+k,x*ps8(ve,n+7,t/ps8(ve,j+6,x-t,vd,j+n-1,x-y,vi,n+3*k+j),vd,j+9,x+ps8(ve,n,t,vd,k,y,vi,j),vi,j+5),vi,n+k+j)/ps8(ve,k+3,t,vd,n+3,x,vi,k+2*j);

		   //res=sp8(ve,j,t,vd,k,y,vi,j);
		   //res=sp1(x)*sp2(x,y)*sp3(x,y,t);
		  //res=sp1(-x)/(-(-(-1-sp2(-1-x,sp1(x))))-sp1(-sp1(-x)-1)*(2-sp2(-x,-1)*3))/(-sp1(sp1(-x)*2-3)*3-5)/(sp1(-x-1)*3-5)+(-(-sp1(-1-x))*(-(-(-sp1(-x)*2+5)))*(-sp1(x+1)))+sp1(2*sp1(-x-1)-1)-sp1(-1-x)/((sp1(2*sp1(-x-1)-1)*3-5)+(-(-(-sp1(-1+2*sp1(-x-1)))))-(-sp1(-2*sp1(-x-1)+1)-5)*(sp1(1-2*sp1(-x-1))))+(-sp1(2*sp1(-x-1)-1)-5)*(-2*sp1(1-2*sp1(-x-1))-3)/(sp1(-1+2*sp1(-x-1))*3-sp1(2*sp1(-x-1)-1)*5)/sp1(2*sp1(-x-1)-1)-(-sp1(2*sp1(-x-1)-1)/sp1(x+1))+sp2(-x,x)+2*sp2(x,-x)/(-sp2(-x-1,x+1)-5*sp2(x+1,-x-1)*sp1(sp2(x+1,-x-1)))*(sp1(sp2(x+1,-x-1))-sp1(sp2(1-2*sp1(-x-1),-1-x)))-sp2(x+1,2*sp1(-x)-1)/(-(-3*sp2(1-2*sp1(-x-1),-1-x)))*((-2*sp2(sp1(x+1)*2-1,-1-2*sp1(x+1))-(-5*sp2(-sp1(x+1)*2-1,1-sp1(-x-1)*2))))+(-sp2(-x,x)+(7-3*sp2(x,-x)-5)/(-sp2(-x-1,x+1))/sp2(x+1,-x-1))/(-9/sp2(1-2*sp1(-x-1),-1-x)-sp1(-7*sp2(x+1,2*sp1(-x)-1))-3)+(-sp1(-sp2(sp1(x+1)*2-1,-1-2*sp1(x+1))-7)+(3*sp2(-sp1(x+1)*2-1,1-sp1(-x-1)*2)-5));

//		  res=sp3(x*sp2(sp1(y-x),sp2(x-sp2(x*t,x-t),sp2(t*x,y+t))),sp1(t-y)+sp2(sp3(sp2(t-x-y,y*x),t,sp2(t-x,x-y)),sp3(sp3(x-y,y*x,y*t),x*sp2(t+y,y-t),t*sp1(x+y))),sp3(sp1(t+x),sp2(x+t*x,t*y),sp1(x+y+t)))
            //ps3(x*ps2(ps1(y-x),ps2(x-ps2(x*t,x-t),ps2(t*x,y+t))),ps1(t-y)+ps2(ps3(ps2(t-x-y,y*x),t,ps2(t-x,x-y)),ps3(ps3(x-y,y*x,y*t),x*ps2(t+y,y-t),t*ps1(x+y))),ps3(ps1(t+x),ps2(x+t*x,t*y),ps1(x+y+t)))
            //ms3(x*ms2(ms1(y-x),ms2(x-ms2(x*t,x-t),ms2(t*x,y+t))),ms1(t-y)+ms2(ms3(ms2(t-x-y,y*x),t,ms2(t-x,x-y)),ms3(ms3(x-y,y*x,y*t),x*ms2(t+y,y-t),t*ms1(x+y))),ms3(ms1(t+x),ms2(x+t*x,t*y),ms1(x+y+t)))
            //pc3(x*pc2(pc1(y-x),pc2(x-pc2(x*t,x-t),pc2(t*x,y+t))),pc1(t-y)+pc2(pc3(pc2(t-x-y,y*x),t,pc2(t-x,x-y)),pc3(pc3(x-y,y*x,y*t),x*pc2(t+y,y-t),t*pc1(x+y))),pc3(pc1(t+x),pc2(x+t*x,t*y),pc1(x+y+t)))

         //res = 1.1*pow(x,12)-2.*pow(x,11)-3.1*pow(x,10)+2.2*pow(x,9)-3.3*pow(x,8)-5.7*pow(x,7)+2.3*pow(x,6)-9.8*pow(x,5)+1.7*pow(x,4)+1.4*pow(x,3)-7.5*pow(x,2)+7.7*x+12.3;
//
            //res = 2.15*pow(x,12)-4.541*pow(x,11)-3.65*pow(x,10)+6.75*pow(x,9)+2.2*pow(x,8)-2.84*pow(x,7)+5.2*pow(x,6)-3.9*pow(x,5)+4.765*pow(x,4)+2.63*pow(x,3)+2.8*pow(x,2)+2.11*x+12.754;
//            res = (pow(x-1.5,2*n-3*k+1)*0.05-15.1*pow(t*x,n-2*k)-21.1*pow(y*t,k-3*n-7))/(2.1*pow(x+y,2*k+1)-y*pow(x-t,n+5))*(3.2*pow(x-y,n+k)-x*pow(t+x*y,n+k+2)) ;
//            res = sin(cos(x+y))*cos(y*sin(x-y))*(2.15*cos(sin(3.53*cos(t-x)))-tan(x+y)*(tan(t+x)-cos(sin(t+y))*((1.76*asin(x/(x+y))+2.97*acos(y/(x+y)))*(2.12*atan(x-y)*atan2(x-y,x+y)-asin(t/(x+y))*acos(t/(y+x-t))/(atan(x+y)+atan2(t-x-y,x-t))))));
//            res = (sin(x)+cos(sin(x)))/(cos(sin(x)+sin(x)));
             // res = (sin(x*cos(y)+y)*sin(y)-cos(y)*cos(x*cos(y)+y)-sin(x+y)*sin(x*cos(x+y)))*(sin(x*cos(y*sin(x*cos(x+y))))*cos(sin(x+y))-cos(y*sin(x*cos(x+y)))*cos(x*cos(y*sin(x*cos(x+y)))));

//            res = sp3(x-sp3(sp1(y),sp3(x+y,x+t,y+t)-2.1*sp2(sp1(t),1.1-sp2(sp1(1.1+x),y-sp3(x+1.2,y+1.3,t+1.4))),t-sp2(sp3(x-y,y-t,t-x),sp2(2.1-x,3.2-y))),y-sp3(-x,-y,t-sp3(-t,x,-y-sp2(t-sp2(t,-y+x),y-sp3(x-y,y,x)))),1.5*y-sp3(x,-y,-t)*sp3(sp2(x,y),-sp2(-x,t),sp3(y,t,x)));


 //res = (pow(x-sin(x),y-cos(y))/(tan(1.5*asin(1.1*x/(1.2*x+y))))+pow(y-sin(x*1.2)/cos(y+1.1),n+k)/(x+2.1*y))*(2.1*sinh(x/y)*sin(x+y)-3.2*cosh(x/(x+y)*cos(x-y))-tanh(x/(x+y))/(exp(2.1*x/y))*asin(1.1*x/(2.1*x+y))-2.1*atan(1.1*x-y)*atan2(x-y,1.3*x+y));


        //res =  (cos(x*sin(x))*sin(y*cos(y))-sin(cos(x*cos(x+y)))*cos(y*cos(x*sin(x*y))))*(cos(sin(y)*y+x*cos(x))*sin(x*sin(x+y))-cos(y*cos(x*y))*sin(x*cos(x+y))+sin(y*cos(x*sin(x*y)))*sin(cos(x*cos(x+y)))/(sin(x*sin(x))*cos(y*cos(y))+cos(cos(x*cos(x+y)))*sin(sin(y)*y+x*cos(x))-sin(y*cos(x*sin(x*y)))*sin(cos(x*cos(x+y)))));
         //res = (sin(x*cos(y)+y)*sin(y)-cos(y)*cos(x*cos(y)+y)-sin(x+y)*sin(x*cos(x+y)))*(sin(x*cos(y*sin(x*cos(x+y))))*cos(sin(x*y)+cos(x*y))-cos(y*sin(x*cos(x+y)))*cos(x*cos(y*sin(x*cos(x+y)))))*(cos(sin(x*y)+cos(x*y))*y-x*sin(sin(x*y)+cos(x*y)));




          // res = (cos(x*sin(x))*sin(y*cos(y))-sin(cos(x*cos(x+y)))*cos(y*cos(x*sin(x*y))))*(cos(sin(y)*y+x*cos(x))*sin(x*sin(x+y))-cos(y*cos(x*y))*sin(x*cos(x+y))+sin(y*cos(x*sin(x*y)))*sin(cos(x*cos(x+y)))/(sin(x*sin(x))*cos(y*cos(y))+cos(cos(x*cos(x+y)))*sin(sin(y)*y+x*cos(x))));

//		      res=pow(x,y)/pow(y+x,y-x);
//              res = (x*(y*(x*y-x/y)-x)-y)/(y*x-(x*(y*(x*y-x/y)-x)-y));
             //res=pow(x-sin(x),y-cos(y))/(x-pow(x-sin(x),y-cos(y))+y);

           // res = (pow(sin(x+y),k+2*n)*pow(cos(x*y),n+k)-pow(x-sin(x*y),pow(cos(x*y),n+k))*pow(y-cos(x+y),pow(sin(x+y),k+2*n)))/(y-sin(pow(x-sin(x),y-cos(y)))/cos(pow(x-sin(x),y-cos(y))));

              //res = (pow(sin(x+y),k+2*n)*pow(cos(x*y),n+k)-pow(x-sin(x*y),pow(cos(x*y),n+k))*pow(y-cos(x+y),pow(sin(x+y),k+2*n)))/(x-(pow(x-sin(x),y-cos(y)))/(pow(x-sin(x),y-cos(y))+y));


//            res=sin(x/y)*(sin(y/(x+y))+cos(x/(x+y))+cos(y/x))+cos(x/y)*(sin(y/x)+cos(y/(x+y))+sin(x/(x+y)));
//              res = sin(x/y)+cos(y/x);

			//res=(sin(x/(x+y))-sinh(x/(x+y))*asin(x/(x+y)))*(cosh(x/(x+y))*acos(x/(x+y))+cos(x/(x+y)));
    //   res=(sin(x/(x+y))-sinh(x/(x+y))*asin(x/(x+y)))*(cosh(x/(x+y))*acos(x/(x+y))+cos(x/(x+y)))*(tanh(x/(x+y))-exp(x/(x+y)));
//            res=exp(y/(x+y))*(cosh(x/(x+y))-sinh(y/(x+y)))-(tanh(y/(x+y))-sinh(x/(x+y)))*exp(x/(x+y));
              //res = (asin(x/(x+y))*sin(x/y)-acos(x/(x+y))*cos(x/y))*(tan(y/x)+1/tan(y/x));
              //res=(vd[n+1]*x-ve[k+n]*y)*(vd[n+k+3]*(x-y)+ve[2*n+3*k+4]*t);
             // res = (x*vd[n+1]*ve[k+n]-y*vd[2*n+1]*ve[k+3*n])*(t*vd[n+k+3]*ve[j+5]+x*ve[2*n+3*k+4]*vd[j+k-n]-y);
//        res = x/t*y +y*x/t+y/t*x;
		  /*
		  sp8(ve,j,t,vd,k,y,vi,j)
		  ps8(ve,j,t,vd,k,y,vi,j)
		  ms8(ve,j,t,vd,k,y,vi,j)
		  pc8(ve,j,t,vd,k,y,vi,j)
		  */


 return res;
};


void TestEvalCmp(PTGccTest GccFunc, Pointer32 FFunc)
{
       TFloatType resG,resF,h;
       Extended dh,dx,dy,dt;
       double dresG,dresF,si;
       INT32 t1,t2,i,PerfG,PerfF,dn,dk,dj;


       RefReshVar();
       si=log10(GNC)/3;
       dn=(INT32)trunc(si+3);
       dk=(INT32)trunc(si+2);
       dj=(INT32)trunc(si+1);

       resG=0.0; //h=0.0000001;
       dh=(Extended)1/GNC;
       dx=dh*0.123; dy=dh*0.456; dt=0.321*dh;


       t1=GetTickCount();
       for(i=0; i <= GNC; i++)
       {
		  x=x+dx; y=y-dy; t=t+dt;
		  n=n+dn; k=k+dk; j=j+dj;

	    resG=resG+GccFunc();

          j=j-dj; k=k-dk;  n=n-dn;
          //t=t-dt;  y=y+dy; x=x-dx;
       }
       t2=GetTickCount();

       if (t1 == t2)
       {
         PerfG=0;
       }
       else
       {
        PerfG=INT32(GNC/(t2-t1));
       };

       RefReshVar();
       resF=0.0;
       t1=GetTickCount();
       for(i=0; i <= GNC; i++)
       {
		  x=x+dx; y=y-dy; t=t+dt;
		  n=n+dn; k=k+dk; j=j+dj;

	    resF=resF+flResultF(FFunc);

          j=j-dj; k=k-dk;  n=n-dn;
          //t=t-dt;  y=y+dy; x=x-dx;
       }
       t2=GetTickCount();

       if (t1 == t2)
       {
         PerfF=0;
       }
       else
       {
        PerfF=INT32(GNC/(t2-t1));
       };


   // dresG=resG; dresF=resF;
    printf("\n");
    printf("Result GCC    : %.12e\n", (double)resG/GNC);
    printf("Result Foreval: %.12e\n", (double)resF/GNC);
    printf("Perfomance GCC  Expr/ms    :  %5d\n", PerfG);
    printf("Perfomance Foreval  Expr/ms:  %5d\n", PerfF);
    printf("\n");
};



void TestEvalF(Pointer32 FFunc)
{
       TFloatType resG,resF,h;
       Extended dh,dx,dy,dt;
       double dresG,dresF,si;
       INT32 t1,t2,i,PerfG,PerfF,dn,dk,dj;



       RefReshVar();
       si=log10(GNC)/3;
       dn=(INT32)trunc(si+3);
       dk=(INT32)trunc(si+2);
       dj=(INT32)trunc(si+1);

       resF=0.0; //h=0.0000001;
       dh=(Extended)1/GNC;
       dx=dh*0.123; dy=dh*0.456; dt=0.321*dh;
       t1=GetTickCount();
       for(i=0; i <= GNC; i++)
       {
		 x=x+dx; y=y-dy; t=t+dt;
		 n=n+dn; k=k+dk; j=j+dj;

	    resF=resF+flResultF(FFunc);

	     j=j-dj; k=k-dk;  n=n-dn;
         //t=t-dt;  y=y+dy; x=x-dx;
       }
       t2=GetTickCount();

       if (t1 == t2)
       {
         PerfF=0;
       }
       else
       {
        PerfF=INT32(GNC/(t2-t1));
       };


   // dresF=resF;
    printf("\n");
    printf("Result : %.12e\n", (double)resF/GNC);
    printf("Perfomance   Expr/ms:  %5d\n", PerfF);
    printf("\n");
};



void TestEvalCmpV(PTGccTest GccFunc, Pointer32 FFunc)
{
       TFloatType resG,resF,h;
       Extended dh,dx,dy,dt;
       double dresG,dresF,si;
       INT32 t1,t2,ni,i,PerfG,PerfF,dn,dk,dj,ar,br,SZ,L;
       PInteger     pint1;

       SZ = rand() % 10+100 ;  /// size array changed in rand[95,105]

       vdf.resize(SZ+2);  ///change size
       ar=1; br=50; L = vdf.size()-1;

       for(ni=1; ni <= L; ni++)  /// in C++ count from 1  !! (if array in Foreval as "fast connect")
       {
           vdf[ni]=ni+1;
           vdf[ni]=pow((double)(-1),(Int32)(ni+1))*vdf[ni]*0.5;
       };


       /// to write length: (If the size of the array does not change, this is not necessary)**/
           adrVDF=&vdf[1];
           pint1 = (PInteger)adrVDF;
           pint1=pint1-1;   /// = &vdf[1]-4b; or = &vdf[0]+4b;  sizeof(double) = 8
           if (GLT == 1) {SZ = vdf.size()-1;} else {SZ=vdf.size()-2;};  /// GLT=1(Delphi); GLT=2(FPC),  in FPC Length=High
           *pint1 = SZ;  /// pint1 = &vdf[1]-4b;  *pint1 <- length


       RefReshVar();
       si=log10(GNC)/3;
       dn=(INT32)trunc(si+3);
       dk=(INT32)trunc(si+2);
       dj=(INT32)trunc(si+1);
       resG=0.0; //h=0.0000001;
       dh=(Extended)1/GNC;
       dx=dh*0.123; dy=dh*0.456; dt=0.321*dh;

       t1=GetTickCount();
       for(i=0; i <= GNC; i++)
       {
		  x=x+dx; y=y-dy; t=t+dt;
          n=n+dn; k=k+dk; j=j-dj;

	    resG=resG+GccFunc();

           k=k-dk; j=j+dj; n=n-dn;
          //t=t-dt;  y=y+dy; x=x-dx;
       }
       t2=GetTickCount();

       if (t1 == t2)
       {
         PerfG=0;
       }
       else
       {
        PerfG=INT32(GNC/(t2-t1));
       };

       RefReshVar();
       resF=0.0; //h=0.0000001;

       t1=GetTickCount();
       for(i=0; i <= GNC; i++)
       {
		  x=x+dx; y=y-dy; t=t+dt;
          n=n+dn; k=k+dk; j=j-dj;

        resF=resF+flResultF(FFunc);
	     k=k-dk; j=j+dj; n=n-dn;
          //t=t-dt;  y=y+dy; x=x-dx;
       }
       t2=GetTickCount();

       if (t1 == t2)
       {
         PerfF=0;
       }
       else
       {
        PerfF=INT32(GNC/(t2-t1));
       };


   // dresG=resG; dresF=resF;
    //printf("\n");
    printf("Result GCC    : %.12e\n", (double)resG/GNC);
    printf("Result Foreval: %.12e\n", (double)resF/GNC);
    printf("Perfomance GCC  Expr/ms    :  %5d\n", PerfG);
    printf("Perfomance Foreval  Expr/ms:  %5d\n", PerfF);
    //printf("\n");
};


void CompileTest()
{


                                       /// arithmetic expressions:

ExprE1 = "x*(y*x+t*(-x-(-y-x*(-y/x+x*(x*y+y*(t+x)))/(-y*(x*y*t*(x+t)*(y+t)/(y/t+x/(t-y))))/(y*(y/(x+y+t)-x/(x*y+t/(y+x*(y-x))))-x*(t/(t-x)+y*x/(y-x*(t/y-t)-t*(x*(-t-y-x))))))))";

ExprE2 = "x*y*(2.2*x+1)*(2.3*x*y/t-2.5*x*(3.7*t-1)/(2.7*x-3.6*y-4.7)*(x/(3.6*x-1)-4.1/x+5.8*(2.6*x*y*t-1.7)/(y+1.7)-7.1*(2.8*x*(y+1.1)*(3.4*y+2.2)*(3.1/(x+1.5)-2.3*t/(2.4*x*y*t-1.7)+(4.7*x-1.164)*(5.7*y-7.4)/(x-2.7*y-1.7-2.4*t/(3.8-7.6*x-8.1*y*(4.2*x/(2.9*t+1.6)-7.198*x-8.9/t+9.9*(2.1*x-1.261)*(3.1*x+4.9*y+5.8)*(2.1*x*y*t-7.1)*x*y*t/(x-y*2.8-3.6/(x/(t-1.7)-7.8/(y+2.5)+8.3/(2.8*x*y*t+1.7)-9.4)))))/(x-1.5)))))";

/// with common subexpr.
ExprE3S ="x*(y/(x/y-y/x)-x/(x*y/(x+y)+t/(y/x-x/(x+y)))+t*(-y/(t/(x-y)-x*y/(x+y))+x*y*t/(x/(x+y)-y/(x+y))))*(x/(x/(x-y)-y/(t/(y/x-x/(x+y))+y/(t/(x-y)-x*y/(x+y))))-y/(x*y*t/(x/(x+y)-y/(x+y))-y/(x/y-y/x)))/(x/(x-y)+y/(x/(x/y-y/x)+x/(x*y/(x+y)+t/(y/x-x/(x+y)))))";

/// with common subexpr.
ExprE4S =  "(2.1*x/(3.2*y-1.1*x+t)-1.1/(3.2*x*y-1.5)+5.7/(2.1/(x+2.4)-1.4/(y+1.2))-x/(-1.1/(1.5*x*y-3.7)+x*y/(1.2*x+2.3*y+3.3*t-4.5)))*(-y*x/(-3.5/(-1.5*y-t/(1.7*x*y*t-7.7))+2.1/(x+2.4))-t/(1.4/(y+1.2)+1.1/(3.2*x*y-1.5)))/(x*(1.1/(1.5*x*y-3.7)-2.1*x/(3.2*y-1.1*x+t))+y*(x*y/(1.2*x+2.3*y+3.3*t-4.5)+y*x/(-3.5/(-1.5*y-t/(1.7*x*y*t-7.7))+2.1/(x+2.4)))-5.7/(2.1/(x+2.4)-1.4/(y+1.2)))";


                                               /// indexing of arrays

//ExprA5 = "(x*vd[n+1]*ve[k+n]-y*vd[2*n+1]*ve[k+3*n]+t*vi[k+n+1])*(t*vd[n+k+3]*ve[j+5]+x*ve[2*n+3*k+4]*vd[j+k-n]-y*vi[j+k-1])";
ExprA5 = "(x*vd[n+1]*ve[k+n]-y*vd[2*n+1]*ve[k+3*n]+t*vi[2*k+n+1])*(t*vd[4*n+k-3]*ve[j+5]+x*ve[5*n+3*k-4]*vd[j+k-n]-y*vi[2*j+k-1])";


  //ExprA6 = "avr:dbl=avr(vdf); i:int=0; L:int=Len(vdf)-1; res:dbl=0; for(i,0,L,if(vdf[i]>avr,res=res+vdf[i])); res*x+y";
//ExprA6 = "res:dbl=0; i:int=0; j:int=0; L:int=Len(vd)-1;  for(i,0,L,ifp(vd[i]>0,for(j,0,L,ifp((j > i)and(vd[j] > vd[i]),res=res-vd[j],res=res+vd[i])),vd[L-i] = vd[i]-vd[L-i])); res";

  //ExprA6 = "res:dbl=0; i:int=0; j:int=0; L:int=Len(vd)-1;  for(i,0,L,ifp(vd[i]>0,for(j,0,L,ifp((j > i)and(vd[j] > vd[i]),res=res-x*vd[j],res=res+x*vd[i])),res=res+y*vd[L-i])); res";
  //ExprA6R = "res:dbl=0; i:int=0; j:int=0; L:int=Len(vdf)-1;  for(i,0,L,ifp(vdf[i]>0,for(j,0,L,ifp((j > i)and(vdf[j] > vdf[i]),res=res-x*vdf[j],res=res+x*vdf[i])),res=res-y*vdf[L-i])); res";
  //ExprA6 = "res:dbl=0; i:int=0; j:int=0; L:int=Len(vdf)-1;  for(i,0,L,ifp(vdf[i]>0,for(j,i,L,ifp((i+j<L)and(vdf[j] > vdf[i]),res=res-x*vdf[j],res=res+x*vdf[i])),res=res+y*vdf[L-i])); res";

   ExprA6 = "res:dbl=0; i:int=0; j:int=0; L:int=Len(vd)-1;  for(i,0,L,ifp(vd[i]>0,for(j,0,L,ifp((j > i)and(vd[j] > vd[i]),res=res-x*vd[j-i],res=res+x*vd[j])),res=res-y*vd[L-i])); res";
   ExprA6F = "res:dbl=0; i:int=0; j:int=0; L:int=Len(vdf)-1;  for(i,0,L,ifp(vdf[i]>0,for(j,0,L,ifp((j > i)and(vdf[j] > vdf[i]),res=res-x*vdf[j-i],res=res+x*vdf[j])),res=res-y*vdf[L-i])); res";

                                               /// polynom
ExprP7 = "1.1*pow(x,12)-2.1*pow(x,11)-3.1*pow(x,10)+2.2*pow(x,9)-3.3*pow(x,8)-5.7*pow(x,7)+2.3*pow(x,6)-9.8*pow(x,5)+1.7*pow(x,4)+1.4*pow(x,3)-7.5*pow(x,2)+7.7*x+12.3";

ExprP7A = "poly(1.1,-2.1,-3.1,2.2,-3.3,-5.7,2.3,-9.8,1.7,1.4,-7.5,7.7,12.3,x)";

                                                  /// function
ExprF8 =  "sin(cos(x+y))*cos(y*sin(x-y))*(2.15*cos(sin(3.53*cos(t-x)))-tan(x+y)*(tan(t+x)-cos(sin(t+y))*((1.76*asin(x/(x+y))+2.97*acos(y/(x+y)))*(2.12*atan(x-y)*atan2(x-y,x+y)-asin(t/(x+y))*acos(t/(y+x-t))/(atan(x+y)+atan2(t-x-y,x-t))))))";


/// mixed
ExprF9 = "(pow(x-sin(x),y-cos(y))/(tan(1.5*asin(1.1*x/(1.2*x+y))))+pow(y-sin(x*1.2)/cos(y+1.1),n+k)/(x+2.1*y))*(2.1*sinh(x/y)*sin(x+y)-3.2*cosh(x/(x+y)*cos(x-y))-tanh(y/(x+y))/(exp(2.1*x/y))*asin(1.1*x/(2.1*x+y))-2.1*atan(1.1*x-y)*atan2(x-y,1.3*x+y))";


                                         /// function with common subexpr.
/// trig. func.
ExprF10S  = "(cos(x*sin(x))*sin(y*cos(y))-sin(cos(x*cos(x+y)))*cos(y*cos(x*sin(x*y))))*(cos(sin(y)*y+x*cos(x))*sin(x*sin(x+y))-cos(y*cos(x*y))*sin(x*cos(x+y))+sin(y*cos(x*sin(x*y)))*sin(cos(x*cos(x+y)))/(sin(x*sin(x))*cos(y*cos(y))+cos(cos(x*cos(x+y)))*sin(sin(y)*y+x*cos(x))-sin(y*cos(x*sin(x*y)))*sin(cos(x*cos(x+y)))))";


/// mixed
ExprF11S = "(sin(x/(x+y))-sinh(x/(x+y))*asin(x/(x+y)))*(cosh(x/(x+y))*acos(x/(x+y))+cos(x/(x+y)))*(tanh(x/(x+y))-exp(x/(x+y)))";


ExprF12S = "(pow(sin(x+y),k+2*n)*pow(cos(x*y),n+k)-pow(x-sin(x*y),pow(cos(x*y),n+k))*pow(y-cos(x+y),pow(sin(x+y),k+2*n)))/(y-sin(pow(x-sin(x),y-cos(y)))/cos(pow(x-sin(x),y-cos(y))))";


                            /// external functions.
ExprFE13SP = "sp3(x-sp3(sp1(y),sp3(x+y,x+t,y+t)-2.1*sp2(sp1(t),1.1-sp2(sp1(1.1+x),y-sp3(x+1.2,y+1.3,t+1.4))),t-sp2(sp3(x-y,y-t,t-x),sp2(2.1-x,3.2-y))),y-sp3(-x,-y,t-sp3(-t,x,-y-sp2(t-sp2(t,-y+x),y-sp3(x-y,y,x)))),1.5*y-sp3(x,-y,-t)*sp3(sp2(x,y),-sp2(-x,t),sp3(y,t,x)))";
ExprFE13PS = "ps3(x-ps3(ps1(y),ps3(x+y,x+t,y+t)-2.1*ps2(ps1(t),1.1-ps2(ps1(1.1+x),y-ps3(x+1.2,y+1.3,t+1.4))),t-ps2(ps3(x-y,y-t,t-x),ps2(2.1-x,3.2-y))),y-ps3(-x,-y,t-ps3(-t,x,-y-ps2(t-ps2(t,-y+x),y-ps3(x-y,y,x)))),1.5*y-ps3(x,-y,-t)*ps3(ps2(x,y),-ps2(-x,t),ps3(y,t,x)))";
ExprFE13MS = "ms3(x-ms3(ms1(y),ms3(x+y,x+t,y+t)-2.1*ms2(ms1(t),1.1-ms2(ms1(1.1+x),y-ms3(x+1.2,y+1.3,t+1.4))),t-ms2(ms3(x-y,y-t,t-x),ms2(2.1-x,3.2-y))),y-ms3(-x,-y,t-ms3(-t,x,-y-ms2(t-ms2(t,-y+x),y-ms3(x-y,y,x)))),1.5*y-ms3(x,-y,-t)*ms3(ms2(x,y),-ms2(-x,t),ms3(y,t,x)))";
ExprFE13PC = "pc3(x-pc3(pc1(y),pc3(x+y,x+t,y+t)-2.1*pc2(pc1(t),1.1-pc2(pc1(1.1+x),y-pc3(x+1.2,y+1.3,t+1.4))),t-pc2(pc3(x-y,y-t,t-x),pc2(2.1-x,3.2-y))),y-pc3(-x,-y,t-pc3(-t,x,-y-pc2(t-pc2(t,-y+x),y-pc3(x-y,y,x)))),1.5*y-pc3(x,-y,-t)*pc3(pc2(x,y),-pc2(-x,t),pc3(y,t,x)))";


ExprFE14SP = "sp8(ve,j+3,t+sp8(ve,n,y-sp8(ve,k,x-y,vd,j+n,y-sp8(ve,k,t-y,vd,j+n,y,vi,j+2),vi,j+2),vd,k+2,t,vi,n+2*j),vd,j+n,x-sp8(ve,n,-x,vd,j+n-1,-y,vi,k+2*n-1)/sp8(ve,j,x+sp8(ve,k,t+sp8(ve,n,y-t,vd,j+n+1,y,vi,k+5),vd,n+3,x+sp8(ve,j+k,y,vd,j+k*2,y+1.1,vi,n+k+3*j),vi,k+j*2-1),vd,j-1,y,vi,n+2*k),vi,n+2)";
ExprFE14PS = "ps8(ve,j+3,t+ps8(ve,n,y-ps8(ve,k,x-y,vd,j+n,y-ps8(ve,k,t-y,vd,j+n,y,vi,j+2),vi,j+2),vd,k+2,t,vi,n+2*j),vd,j+n,x-ps8(ve,n,-x,vd,j+n-1,-y,vi,k+2*n-1)/ps8(ve,j,x+ps8(ve,k,t+ps8(ve,n,y-t,vd,j+n+1,y,vi,k+5),vd,n+3,x+ps8(ve,j+k,y,vd,j+k*2,y+1.1,vi,n+k+3*j),vi,k+j*2-1),vd,j-1,y,vi,n+2*k),vi,n+2)";
ExprFE14MS = "ms8(ve,j+3,t+ms8(ve,n,y-ms8(ve,k,x-y,vd,j+n,y-ms8(ve,k,t-y,vd,j+n,y,vi,j+2),vi,j+2),vd,k+2,t,vi,n+2*j),vd,j+n,x-ms8(ve,n,-x,vd,j+n-1,-y,vi,k+2*n-1)/ms8(ve,j,x+ms8(ve,k,t+ms8(ve,n,y-t,vd,j+n+1,y,vi,k+5),vd,n+3,x+ms8(ve,j+k,y,vd,j+k*2,y+1.1,vi,n+k+3*j),vi,k+j*2-1),vd,j-1,y,vi,n+2*k),vi,n+2)";
ExprFE14PC = "pc8(ve,j+3,t+pc8(ve,n,y-pc8(ve,k,x-y,vd,j+n,y-pc8(ve,k,t-y,vd,j+n,y,vi,j+2),vi,j+2),vd,k+2,t,vi,n+2*j),vd,j+n,x-pc8(ve,n,-x,vd,j+n-1,-y,vi,k+2*n-1)/pc8(ve,j,x+pc8(ve,k,t+pc8(ve,n,y-t,vd,j+n+1,y,vi,k+5),vd,n+3,x+pc8(ve,j+k,y,vd,j+k*2,y+1.1,vi,n+k+3*j),vi,k+j*2-1),vd,j-1,y,vi,n+2*k),vi,n+2)";


flCompile(ExprE1.c_str(),0,FuncE1);
flCompile(ExprE2.c_str(),0,FuncE2);
flCompile(ExprE3S.c_str(),0,FuncE3S);
flCompile(ExprE4S.c_str(),0,FuncE4S);
flCompile(ExprA5.c_str(),0,FuncA5);
flCompile(ExprA6.c_str(),0,FuncA6);
flCompile(ExprA6F.c_str(),0,FuncA6F);
flCompile(ExprP7.c_str(),0,FuncP7);
flCompile(ExprP7A.c_str(),0,FuncP7A);
flCompile(ExprF8.c_str(),0,FuncF8);
flCompile(ExprF9.c_str(),0,FuncF9);
flCompile(ExprF10S.c_str(),0,FuncF10S);
flCompile(ExprF11S.c_str(),0,FuncF11S);
flCompile(ExprF12S.c_str(),0,FuncF12S);
flCompile(ExprFE13SP.c_str(),0,FuncFE13SP);
flCompile(ExprFE13PS.c_str(),0,FuncFE13PS);
flCompile(ExprFE13MS.c_str(),0,FuncFE13MS);
flCompile(ExprFE13PC.c_str(),0,FuncFE13PC);
flCompile(ExprFE14SP.c_str(),0,FuncFE14SP);
flCompile(ExprFE14PS.c_str(),0,FuncFE14PS);
flCompile(ExprFE14MS.c_str(),0,FuncFE14MS);
flCompile(ExprFE14PC.c_str(),0,FuncFE14PC);

};

void CompareTest()
{
  TFloatType resG,resF,h,dh,dx,dy,dt;
  double dresG,dresF;
  //TFloatType resG,resF;
  INT32 rt,FpuExc,t1,t2,i,ECode,PerfG,PerfF,GNCt;
  Pointer32 Func;
  string Expr;

  PTGccTest GccFunc;
  //string    ExprE0,ExprE1,ExprE2S,ExprE3S,ExprA4,ExprP5,ExprF6,ExprF7,ExprF8S,ExprF9S,ExprF10S,ExprFE11SP,ExprFE11PS,ExprFE11MS,ExprFE12SP,ExprFE12PS,ExprFE12MS;
  //Pointer32 FuncE0,FuncE1,FuncE2S,FuncE3S,FuncA4,FuncP5,FuncF6,FuncF7,FuncF8S,FuncF9S,FuncF10S,FuncFE11SP,FuncFE11PS,FuncFE11MS,FuncFE12SP,FuncFE12PS,FuncFE12MS;






printf("\n");
printf("**********************************  arithmetic expressions: ****************************************\n");

printf("\n");
printf("x*(y*x+t*(-x-(-y-x*(-y/x+x*(x*y+y*(t+x)))/(-y*(x*y*t*(x+t)*(y+t)/(y/t+x/(t-y))))/(y*(y/(x+y+t)-x/(x*y+t/(y+x*(y-x))))-x*(t/(t-x)+y*x/(y-x*(t/y-t)-t*(x*(-t-y-x))))))))\n");
printf("\n");
printf("********************************** RUN ****************************************\n");
TestEvalCmp(GccE1,FuncE1);
printf("\n");
printf("*******************************************************************************\n");

printf("x*y*(2.2*x+1)*(2.3*x*y/t-2.5*x*(3.7*t-1)/(2.7*x-3.6*y-4.7)*(x/(3.6*x-1)-4.1/x+5.8*(2.6*x*y*t-1.7)/(y+1.7)-7.1*(2.8*x*(y+1.1)*(3.4*y+2.2)*(3.1/(x+1.5)-2.3*t/(2.4*x*y*t-1.7)+(4.7*x-1.164)*(5.7*y-7.4)/(x-2.7*y-1.7-2.4*t/(3.8-7.6*x-8.1*y*(4.2*x/(2.9*t+1.6)-7.198*x-8.9/t+9.9*(2.1*x-1.261)*(3.1*x+4.9*y+5.8)*(2.1*x*y*t-7.1)*x*y*t/(x-y*2.8-3.6/(x/(t-1.7)-7.8/(y+2.5)+8.3/(2.8*x*y*t+1.7)-9.4)))))/(x-1.5)))))\n");
printf("\n");
printf("********************************** RUN ****************************************\n");
TestEvalCmp(GccE2,FuncE2);
printf("\n");
printf("*******************************************************************************\n");

printf("**********************************  arithmetic expressions with common subexpressions ****************************************\n");
printf("\n");
printf("x*(y/(x/y-y/x)-x/(x*y/(x+y)+t/(y/x-x/(x+y)))+t*(-y/(t/(x-y)-x*y/(x+y))+x*y*t/(x/(x+y)-y/(x+y))))*(x/(x/(x-y)-y/(t/(y/x-x/(x+y))+y/(t/(x-y)-x*y/(x+y))))-y/(x*y*t/(x/(x+y)-y/(x+y))-y/(x/y-y/x)))/(x/(x-y)+y/(x/(x/y-y/x)+x/(x*y/(x+y)+t/(y/x-x/(x+y)))))\n");
printf("\n");
printf("********************************** RUN ****************************************\n");
TestEvalCmp(GccE3S,FuncE3S);
printf("\n");
printf("*******************************************************************************\n");

printf("(2.1*x/(3.2*y-1.1*x+t)-1.1/(3.2*x*y-1.5)+5.7/(2.1/(x+2.4)-1.4/(y+1.2))-x/(-1.1/(1.5*x*y-3.7)+x*y/(1.2*x+2.3*y+3.3*t-4.5)))*(-y*x/(-3.5/(-1.5*y-t/(1.7*x*y*t-7.7))+2.1/(x+2.4))-t/(1.4/(y+1.2)+1.1/(3.2*x*y-1.5)))/(x*(1.1/(1.5*x*y-3.7)-2.1*x/(3.2*y-1.1*x+t))+y*(x*y/(1.2*x+2.3*y+3.3*t-4.5)+y*x/(-3.5/(-1.5*y-t/(1.7*x*y*t-7.7))+2.1/(x+2.4)))-5.7/(2.1/(x+2.4)-1.4/(y+1.2)))\n");
printf("\n");
printf("********************************** RUN ****************************************\n");
TestEvalCmp(GccE4S,FuncE4S);
printf("\n");
printf("*******************************************************************************\n");


printf("*********************  indexing of arrays  ***********************************************\n");
printf("\n");
printf("(x*vd[n+1]*ve[k+n]-y*vd[2*n+1]*ve[k+3*n]+t*vi[k+n])*(t*vd[n+k+3]*ve[j+5]+x*ve[2*n+3*k+4]*vd[j+k-n]-y*vi[j+k-1])\n");
printf("\n");
printf("********************************** RUN ****************************************\n");
TestEvalCmpV(GccA5,FuncA5);
printf("\n");
printf("*******************************************************************************\n");

GNCt = GNC;
GNC = GNC/100;
printf("*********************  calculations with arrays  ***********************************************\n");
printf("\n");
printf("res:dbl=0; i:int=0; j:int=0; L:int=Len(vd)-1;  for(i,0,L,ifp(vd[i]>0,for(j,0,L,ifp((j > i)and(vd[j] > vd[i]),res=res-x*vd[j-i],res=res+x*vd[j])),res=res-y*vd[L-i])); res \n");
printf("\n");
printf("********************************** RUN ****************************************\n");
TestEvalCmpV(GccA6,FuncA6);
printf("\n");
printf("*******************************************************************************\n");


printf("*********************  calculations with arrays  ***********************************************\n");
printf("\n");
printf("analogous expression with vd->vdf ; see source \n");
printf("\n");
printf("********************************** RUN ****************************************\n");
TestEvalCmpV(GccA6F,FuncA6F);
printf("\n");
printf("*******************************************************************************\n");


GNC = GNCt;
printf("*********************  polynom  ***********************************************\n");
printf("\n");
printf("1.1*pow(x,12)-2.1*pow(x,11)-3.1*pow(x,10)+2.2*pow(x,9)-3.3*pow(x,8)-5.7*pow(x,7)+2.3*pow(x,6)-9.8*pow(x,5)+1.7*pow(x,4)+1.4*pow(x,3)-7.5*pow(x,2)+7.7*x+12.3\n");
printf("\n");
printf("********************************** RUN ****************************************\n");
TestEvalCmp( GccP7,FuncP7);
printf("\n");
printf("calculation through 'poly' function using Horner's method.\n");
printf("poly(1.1,-2.1,-3.1,2.2,-3.3,-5.7,2.3,-9.8,1.7,1.4,-7.5,7.7,12.3,x)\n");

TestEvalF(FuncP7A);
printf("\n");
printf("*******************************************************************************\n");


printf("*********************  trigonometric functions  ***********************************************\n");
printf("\n");
printf("sin(cos(x+y))*cos(y*sin(x-y))*(2.15*cos(sin(3.53*cos(t-x)))-tan(x+y)*(tan(t+x)-cos(sin(t+y))*((1.76*asin(x/(x+y))+2.97*acos(y/(x+y)))*(2.12*atan(x-y)*atan2(x-y,x+y)-asin(t/(x+y))*acos(t/(y+x-t))/(atan(x+y)+atan2(t-x-y,x-t))))))\n");
printf("\n");
printf("********************************** RUN ****************************************\n");
TestEvalCmp(GccF8,FuncF8);
printf("\n");
printf("*******************************************************************************\n");


printf("*********************  trigonometric+hyperbolic+pow functions  ***********************************************\n");
printf("\n");
printf("(pow(x-sin(x),y-cos(y))/(tan(1.5*asin(1.1*x/(1.2*x+y))))+pow(y-sin(x*1.2)/cos(y+1.1),n+k)/(x+2.1*y))*(2.1*sinh(x/y)*sin(x+y)-3.2*cosh(x/(x+y)*cos(x-y))-tanh(y/(x+y))/(exp(2.1*x/y))*asin(1.1*x/(2.1*x+y))-2.1*atan(1.1*x-y)*atan2(x-y,1.3*x+y))\n");
printf("\n");
printf("********************************** RUN ****************************************\n");
TestEvalCmp(GccF9,FuncF9);
printf("\n");
printf("*******************************************************************************\n");


printf("*********************  trigonometric functions with common subexpressions ***********************************************\n");
printf("\n");
printf("(cos(x*sin(x))*sin(y*cos(y))-sin(cos(x*cos(x+y)))*cos(y*cos(x*sin(x*y))))*(cos(sin(y)*y+x*cos(x))*sin(x*sin(x+y))-cos(y*cos(x*y))*sin(x*cos(x+y))+sin(y*cos(x*sin(x*y)))*sin(cos(x*cos(x+y)))/(sin(x*sin(x))*cos(y*cos(y))+cos(cos(x*cos(x+y)))*sin(sin(y)*y+x*cos(x))-sin(y*cos(x*sin(x*y)))*sin(cos(x*cos(x+y)))))\n");
printf("\n");
printf("********************************** RUN ****************************************\n");
TestEvalCmp(GccF10S,FuncF10S);
printf("\n");
printf("*******************************************************************************\n");



printf("*********************  mixed functions with common subexpressions ***********************************************\n");
printf("\n");
printf("(sin(x/(x+y))-sinh(x/(x+y))*asin(x/(x+y)))*(cosh(x/(x+y))*acos(x/(x+y))+cos(x/(x+y)))*(tanh(x/(x+y))-exp(x/(x+y)))\n");
printf("\n");
printf("********************************** RUN ****************************************\n");
TestEvalCmp(GccF11S,FuncF11S);
printf("\n");
printf("*******************************************************************************\n");



printf("*********************  mixed functions with common subexpressions ***********************************************\n");
printf("\n");
printf("(pow(sin(x+y),k+2*n)*pow(cos(x*y),n+k)-pow(x-sin(x*y),pow(cos(x*y),n+k))*pow(y-cos(x+y),pow(sin(x+y),k+2*n)))/(y-sin(pow(x-sin(x),y-cos(y)))/cos(pow(x-sin(x),y-cos(y))))\n");
printf("\n");
printf("********************************** RUN ****************************************\n");
TestEvalCmp(GccF12S,FuncF12S);
printf("\n");
printf("*******************************************************************************\n");




printf("*********************   external functions  ***********************************************\n");
printf("\n");
printf("sp3(x-sp3(sp1(y),sp3(x+y,x+t,y+t)-2.1*sp2(sp1(t),1.1-sp2(sp1(1.1+x),y-sp3(x+1.2,y+1.3,t+1.4))),t-sp2(sp3(x-y,y-t,t-x),sp2(2.1-x,3.2-y))),y-sp3(-x,-y,t-sp3(-t,x,-y-sp2(t-sp2(t,-y+x),y-sp3(x-y,y,x)))),1.5*y-sp3(x,-y,-t)*sp3(sp2(x,y),-sp2(-x,t),sp3(y,t,x)))\n");
printf("\n");
printf("********************************** RUN ****************************************\n");
TestEvalCmp(GccFE13,FuncFE13SP);
printf("other call type: sp->ps\n");
TestEvalF(FuncFE13PS);
printf("other call type: sp->ms\n");
TestEvalF(FuncFE13MS);
printf("\n");
printf("other call type: sp->pc\n");
TestEvalF(FuncFE13PC);
printf("\n");
printf("*******************************************************************************\n");




printf("*********************   external functions with arrays  ***********************************************\n");
printf("\n");
printf("sp8(ve,j+3,t+sp8(ve,n,y-sp8(ve,k,x-y,vd,j+n,y-sp8(ve,k,t-y,vd,j+n,y,vi,j+2),vi,j+2),vd,k+2,t,vi,n+2*j),vd,j+n,x-sp8(ve,n,-x,vd,j+n-1,-y,vi,k+2*n-1)/sp8(ve,j,x+sp8(ve,k,t+sp8(ve,n,y-t,vd,j+n+1,y,vi,k+5),vd,n+3,x+sp8(ve,j+k,y,vd,j+k*2,y+1.1,vi,n+k+3*j),vi,k+j*2-1),vd,j-1,y,vi,n+2*k),vi,n+2)\n");
printf("\n");
printf("********************************** RUN ****************************************\n");
TestEvalCmp(GccFE14,FuncFE14SP);
printf("other call type: sp->ps\n");
TestEvalF(FuncFE14PS);
printf("other call type: sp->ms\n");
TestEvalF(FuncFE14MS);
printf("\n");
printf("other call type: sp->pc\n");
TestEvalF(FuncFE14PC);
printf("\n");



printf("********************************** END ****************************************\n");
printf("\n");


};



TFloatType CalcExpr(Pointer32 Func)
{
  TFloatType res;
  INT32 rt,FpuExc,t1,t2,i;


/**
        this construction dont't catch fpu exception !!?
  try
  {
    flResult(Func,resf)
  }
  catch(...)
  {
    //error
  }

**/
   res=0; resf=0;

   flPerform(fl_MASK_FPU_EXCEPTION,0);

   flGet(fl_RETURN_NUMBER,INT32(Func),rt);

   if (rt == fl_NO)            /// no return number: return result in inner 'result' or 'res' variable  ( x1: ext=x+y; x1=x1*x; result=x1  )
   {
       t1=GetTickCount();
       for(i=0; i <= GNC; i++)
       {
         //Result(Func);  //more fast then:
		flResult(Func);
	    res=resf;
       }
       t2=GetTickCount();

   }
    else
   {
        t1=GetTickCount();
        for(i=0; i<=GNC; i++)
        {
	   	 //res=ResultF(Func);  //more fast then:
         res=flResultF(Func);

          /*** Test for GCC ***/
         //res=GccFunc();
        }
        t2=GetTickCount();

   }

   flGet(fl_IS_FPU_EXCEPTION,0,FpuExc);
   if(FpuExc == fl_YES)
	 {
	     cout <<"Invalid operation" << endl;
	     F_CalcError = TRUE;
	 }

  if (t1 == t2)
   {
       Perf=0;
   }
   else
   {
      Perf=INT32(GNC/(t2-t1));
   }

  return res;

}




TFloatType CalcExprSafe(Pointer32 Func)
{
  TFloatType res;
  double  resd;
  INT32 rt,t1,t2,i;
  string SCE;


/**
        this construction dont't catch fpu exception !!?
  try
  {
    flResult(Func,resf)
  }
  catch(...)
  {
    //error
  }

**/

  // flSet(fl_ADDRESS_EXCEPTION_FLAG , _int32(&FpuExc),0);	//uses in flResultSafe, flResultDSafe
   res=0; resf=0; resd=0;

   flGet(fl_RETURN_NUMBER,INT32(Func),rt);

   if (rt == fl_NO)            /// no return number: return result in inner 'result' or 'res' variable  ( x1: ext=x+y; x1=x1*x; result=x1  )
   {

	     /**
		      res=sqrt(-x)
              res=x/sin(x-x)
		      x=10000; res=x^x
		   **/
	   t1=GetTickCount();
       for(i=0; i <= GNC; i++)
       {
		  //FpuExc=ResultSafe(Func);  // more fast then:
          flResultSafe(Func);
		  if (FpuExc != 0) { goto endc;}
       }
        t2=GetTickCount();
   }
    else
   {
	   	 /**
		       sqrt(-x)
               x/sin(x-x)
		       x=10000; x^x
        **/
		   //FpuExc=ResultFSafe(Func,res); //more fast then:
       t1=GetTickCount();
       for(i=0; i <= GNC; i++)
       {
		   flResultDSafe(Func,resd);
		   if (FpuExc != 0) { goto endc;}
       }
       t2=GetTickCount();
       res=resd;
   }



 endc:

   if (FpuExc != 0)
   {

	   switch ( FpuExc)
      {
       case  1:    SCE="Invalid operation";break;          ///  sqrt(-x)
	   case  4:    SCE="Divizion on Zero";break;           ///  x/sin(x-x)
	   case  8:    SCE="Overflow in float point";break;    ///  x=10000; x^x
	   default:    SCE="Invalid operation";
      }
	   cout << SCE << endl;
	   F_CalcError = TRUE;
   }

 if (t1 == t2)
   {
       Perf=0;
   }
   else
   {
      Perf=INT32(GNC/(t2-t1));
   }

  return res;

}



void test()
{
    int flLoad,ECode,NC,ni,SZ,GNCmin;
	string Expr,strOut,strTmp;

	TStringType chE,chTmp;
	PInteger     pint1;

	int ndx,SafeCalc;
	//AnsiChar* chS = new char;
    TFloatType res;
    double resd;

	Pointer32 Func,FuncDx,PS;
	char cht;
	char* Schr;



/**
        this construction dont't catch fpu exception !!?
  try
  {
    flResult(Func,resf)
  }
  catch(...)
  {
    //error
  }

**/

/**
Calculations goes with masking of interruptions to (1) CalcExpr(Func); (2) CalcExprSafe(Func);
It is a slow method. Besides, if in expression there is incorrectly written function,
 in which there is a reset of FPU masks and/or flags of exceptions, interception of an error will not work.
It is better to use catch of errors  through  interrupts in the design:

 try
  {
    flResult(Func,resf)
  }
  catch(...)
  {
    //error
  };

,if you are able to force it to work! :(
**/

 flLoad=onLoad();


 if (flLoad != 0)
 {

  n = 1; k = 2; j = 5; m = -3;
  x = 2.123; y = 5.456; t = -3.789;
  GNC = 20000000;
  GNCmin = 20000000;



/********************  test  fast connecting of dynamic array (in VisualC++ count from '1', in foreval count from '0'   !!!)  ****************************
                        without using   flSetArrayValueD or CopyMemory
                        Expression FDynArray compiled in Form1_Load
**/
	#ifdef   TESTFASTDYNARRAY
       /// set randomize size of array (VECD) and fill it 1.0
dynarray:

    NC = rand()+2;
    vecd.clear();


	/// ****************** first way to write array:*********************
	/*
	     vecd.push_back(0);//reserve for length
         for (ni = 1; ni <= NC; ni++)  //count from 1 !!!
     	 {
         vecd.push_back(1.0);
	     }
	*/

	/// ******************* second way to write array:*********************

    	vecd.resize(NC+1); /// NC+1=length(VC++); NC = length(foreval); (>0 !!!); 1 - reserve for length (vecd[0])
       //vecd.reserve(NC+1);

       for (ni = 1; ni <= NC; ni++)  //count from 1 !!!
       {
	    vecd[ni]=1.0;
	   }


    /// set length
	adrVECD=&vecd[1]; /// to set a new reference to the array so , as  memory location of  vecd is changed  ; after full load of array!!!
	pint1 = (PInteger)adrVECD;
	pint1=pint1-1; /// = &vecd[1]-4b; or = &vecd[0]+4b;  sizeof(double) = 8
	if (GLT == 1) {SZ = vecd.size()-1;} else {SZ=vecd.size()-2;};  /// GLT=1(Delphi); GLT=2(FPC),  in FPC Length=High
	*pint1 = SZ;  /// pint1 = &vecd[1]-4b;  *pint1 <- length


	//  len(vecd)*(sum(vecd)/len(vecd))
	//  k:int=0; len:int=len(vecd); s:dbl=0; for(k,0,len-1,s=s+vecd[k]); s/sum(vecd)
     flResultD(FDynArray, resd);   /// without recompiling expression
     printf("result: %.17f\n", resd);

     system("pause");
     goto dynarray;
	#endif // TESTFASTDYNARRAY



newtest:

    fflush(stdin);
    printf("\n");
    printf("Run a benchmark test Foreval/GCC, Y/N: ");
    cht=getchar();
    //scanf("%d", &GNC);
    if(tolower(cht) == 'y')
    {
        CompileTest();
        printf("\n");
        printf("14 examples. Each example is calculation in loop with changed of variables\n");
        printf("Enter number of loops: 2E7 - 2E9. On default(Enter) = 2E7: ");
        fflush(stdin);
        //cht=getchar();
        //scanf("%s", Schr);
        getline(cin,strTmp);
        if(strTmp == "\0")
            {GNC = GNCmin;}
            else
            {
                GNC = StrToInt(strTmp);
                if(GNC < GNCmin){GNC = 20000000;} else if(GNC > 2000000000){GNC = 2000000000;} ;
            };

        CompareTest();
        goto newtest;
    }




newexpr:

    F_CalcError = FALSE;

    printf("**************************************************************************\n");
    printf("\n");
    printf("Enter number of loops: 2E7 - 2E9. On default(Enter) = 2E7: ");
    fflush(stdin);
    getline(cin,strTmp);
        if(strTmp == "\0")
            {GNC = GNCmin;}
            else
            {
                GNC = StrToInt(strTmp);
                if(GNC <  GNCmin){GNC = 20000000;} else if(GNC > 2000000000){GNC = 2000000000;} ;
            };
    fflush(stdin);
    printf("Input expression:\n");
	getline(cin, Expr);



    flCompile(Expr.c_str(),0,Func);
	flGetErrorCode(ECode);

	if (ECode == 0)
    {
           /** two way of safe calculations**/
           ///res=CalcExpr(Func);         ///(1)
            res=CalcExprSafe(Func);  ///(2)

           if (F_CalcError == FALSE)
           {
               printf("Result: %.12e\n",(double)res);
               printf("Perfomance  Expr/ms:  %5d\n", Perf);
           }

    }
	else
    {
        ShowError();

    };



   F_CalcError = FALSE;
   ndx=1; ///  d/dx(Expr)
   flCompileDiff(Expr.c_str(), ndx, FuncDx);
   flGetErrorCode(ECode);

	if (ECode == 0)
    {

            flGetDiffString(PS);

            chTmp=(TStringType)(PS);
	        strTmp=(string)(chTmp);
	        strOut=strTmp;
	        strTmp="";
	        cout << "diff. expression (d/dx):   " << strOut << endl;

	        /** two way of safe calculations**/
            res=CalcExpr(FuncDx);   ///(1)
            ///res=CalcExprSafe(FuncDx);   ///(2)

            if (F_CalcError == FALSE)
            {
               printf("result d/dx: %.12e\n", (double)res);
               printf("Perfomance  Expr/ms:  %5d\n", Perf);
               printf("\n");
            }


    }
	else
    {
        ShowError();

    };

    flPerform(fl_FREE,(INT32)Func);   // not necessary. After closing Foreval.dll, the memory is automatically released
    flPerform(fl_FREE,(INT32)FuncDx); // not necessary. After closing Foreval.dll, the memory is automatically released

    printf("**************************************************************************\n");

	goto newexpr;



	system("pause");
 }
}

