﻿'*************************************************************************************************************************

'rus:
'В .net память под статические объекты выделяется динамически и является перемещаемой.
'По этой причине задание переменных и подключаемых функций через их адреса невозможно: работать будет, но недолго, 
'   пока менеджер памяти не переместит их в другое место (проверено!)
'Поэтому, установка переменных только командой: flSetVarIntrnl
'Задание внешних функций только как тип fl_PRECOMPILED

'eng:
'In .net memory for static objects are allocated dynamically and is movable.
'For this reason the define of variables and the external  functions through their addresses is impossible: will work,  but not for long, 
'   until the manager of memory moves them to other place (it is checked!)
'Therefore, the installation of variables only by command: flSetVarIntrnl
'Setting external functions only as a type of flPRECOMPILED

'************************************************************************************************************************


Imports System.Math
Imports System.Globalization
Imports System.Runtime.InteropServices.Marshal
Imports System.Runtime.InteropServices

Structure TFuncInt3
    Public FAddr As UInteger
    Public x As Double
    Public y As Double
    Public z As Double
    Public a As Double
    Public b As Double
    Public F1Addr As UInteger
    Public F2Addr As UInteger
    Public F3Addr As UInteger
    Public F4Addr As UInteger
End Structure

Structure TFuncInt3Ex
    Public FAddr As UInteger
    Public adrX As UInteger
    Public adrY As UInteger
    Public adrZ As UInteger
    Public a As Double
    Public b As Double
    Public F1Addr As UInteger
    Public F2Addr As UInteger
    Public F3Addr As UInteger
    Public F4Addr As UInteger
End Structure



Public Class Form1

   

    Dim x As Double
    Dim y As Double
    Dim t As Double
    Dim a As Double
    Dim b As Double
    Dim c As Double
    Dim d As Double
    Dim d1 As Double
    Dim resf As Double
    Dim n As Integer
    Dim k As Integer
    Dim i As Integer
    Dim j As Integer
    Dim AdrX, adrY, adrT, adrN, adrK, adrJ, adrI, adrRes As UInteger
    Dim FC1, FC2, FC3 As UInteger
    Dim VBA1() As Double
    Dim VBA2() As Double
    Dim mxd1() As Double
    Dim mxd2() As Double
    Dim adrVD As UInteger
    Dim adrVD0 As UInteger
    Dim adrVD10 As UInteger
    Dim adrAD As UInteger
    Dim AdrVI As UInteger
    Dim AdrVD1 As UInteger
    Dim AdrVD2 As UInteger
    Dim adrVDY As UInteger
    Dim adrVDX As UInteger
    Dim LenVBA2 As Integer
    Dim adrVBA2 As UInteger
    Dim adrMXD1, adrMXD2, adrMXD10, adrMXD20 As UInteger
    Dim lenMX1 As Integer
    Dim fs1 As TFunc1
    Dim fs2 As TFunc2
    Dim fs3 As TFunc3
    Dim fnc1 As TFunc2
    Dim fnc2 As TFunc3
    Dim FAtr As TAttrib
    Dim FInt3 As TFuncInt3
    Dim FInt3Ex As TFuncInt3Ex
    Dim TArg4 As TExtArg4


    Private Declare Function GetTickCount Lib "kernel32" () As UInteger
    Public Declare Sub CopyMem Lib "kernel32" Alias "RtlMoveMemory" (ByVal Dst As UInteger, ByVal Src As UInteger, ByVal Length As Integer)



    Public Function GetFuncAddr(ByVal FAddr As UIntPtr) As UInteger
        GetFuncAddr = FAddr
    End Function

    'Actual calculation with  changing of variables
    Public Function CalcFunc() As Double

        x = -x + 0.5
        y = -y + 0.5
        t = -t + 0.5

        'internal:
        'resf = resf + x + y + t
        'resf = resf + sp3(x - y, t - y, t * sp2(x * y - y, y - t)) - sp2(x - sp1(t - x), y * sp2(x * y - y, y * t - x) - sp2(sp1(y - t), sp1(x - y)))
        'resf = resf + sp3(t * sp2(x, t), -sp3(x, 2, 5), sp3(-x, y * sp1(x * sp2(x, y * sp3(1, 2, t * sp1(5) + sp2(-x, y)))), 1 - sp2(-x, -1 - y)) * t) * sp2(x - sp3(x, -y, -5), sp3(x, y * x, -t - 5) - sp2(x, -t - 3 * sp3(3, x, y)) * x) + sp1(sp3(x, y, t * sp1(-x)) - sp2(-y * sp1(x), -x + sp2(x + y, x * y - y)))
        'resf = resf + x * y * (2 * x + 1) * (2 * x * y / t - 2 * x * (3 * t - 1) / (2 * x - 3 * y - 4) * (x / (3 * x - 1) - 4 / x + 5 * (2 * x * y * t - 1) / (y + 1) - 7 * (2 * x * (y + 1) * (3 * y + 2) * (3 / (x + 1) - 2 * t / (2 * x * y * t - 1) + (4 * x - 1) * (5 * y - 7) / (x - 2 * y - 1 - 2 * t / (3 - 7 * x - 8 * y * (4 * x / (2 * t + 1) - 7 * x - 8 / t + 9 * (2 * x - 1) * (3 * x + 4 * y + 5) * (2 * x * y * t - 7) * x * y * t / (x - y * 2 - 3 / (x / (t - 1) - 7 / (y + 2) + 8 / (2 * x * y * t + 1) - 9))))) / (x - 1)))))
        'resf = resf - (-x - x / (x + y) - (-x / (-y) + x / (x / y + y / x)) * y * x / (x + y) - (-x / (x - y) + y / (x - y)) * Sin(x / (x + y)) - x / Cos(x / y + y / x) * (-x * y / (y - x) * Cos(y / (x + y)))) - (-(-x) / (x - y) + Sin(x / (x / y + y / x)) * x / (x + y) * Cos(y / (x / y + y / x)) - (-y) * x / (x / y - y / x)) / (Sin(y / (x + y)) - x / Cos(x / (x / y - y / x))) + x * y / (Cos(x / y + y / x) * Sin(x / y - y / x) - Cos(x / (x + y)) / Sin(y / (x + y)) + Sin(x / (x / y - y / x)) / Cos(y / (x / y + x / y))) + Cos(x / (x / y - y / x)) * Sin(y / (y / x - x / y)) / (x / (x + y) - y / (x / y - y / x) * Cos(y / (y / x - x / y)))
        'resf = resf + 2.1 * x ^ 9 + 3.5 * x ^ 8 - 7.7 * x ^ 7 + 6.5 * x ^ 6 - 1.2 * x ^ 5 - 1.7 * x ^ 4 + 3.1 * x ^ 3 - 5.7 * x ^ 2 + 3.5 * x - 10.5
        'resf = resf + 2.1 * ((x + t) / x) ^ 14 + 3.5 * ((x - y) / t) ^ 12 - 7.7 * ((y + t - x) / y) ^ 11 + 6.5 * ((y - x) / (x + t)) ^ 9 - 1.2 * ((t + y) / (x + y)) ^ 8 - 1.7 * ((x - y) / (x + y + t)) ^ 7 + 3.1 * ((y + t) / (x + t - y)) ^ 6 - 5.7 * ((y + t) / (x - y + t)) ^ 5
        'resf = resf + sp2(sp1(x / y), sp1(y / x)) * sp1(x / y) / sp1(y / x) - 1.1 * sp2(-sp1(-y / x) * 3.1, sp2(-x / sp1(-x / y), y - 1.5 * sp1(y / x))) + 2.1 * sp2(1.5 * sp2(sp1(x / y), sp1(y / x)), -sp1(-y / x) / (3.1 * sp1(-x / y) + x * sp1(-y / x))) + 5.1 * sp2(sp2(y / x, x / y) * x, sp1(sp2(y / x, x / y) * 1.1 + x * sp2(x / y, y / x))) * (-sp1(-y / x) * sp2(x / y, y / x) * 1.5 + 3.5 * sp1(x / y) / sp1(sp1(y / x) * sp2(x / y, y / x)))



        'external(Foreval: need to compile):
        'x + y + t
        'pc3(x - y, t - y, t * pc2(x * y - y, y - t)) - pc2(x - pc1(t - x), y * pc2(x * y - y, y * t - x) - pc2(pc1(y - t), pc1(x - y)))
        'pc3(t * pc2(x, t), -pc3(x, 2, 5), pc3(-x, y * pc1(x * pc2(x, y * pc3(1, 2, t * pc1(5) + pc2(-x, y)))), 1 - pc2(-x, -1 - y)) * t) * pc2(x - pc3(x, -y, -5), pc3(x, y * x, -t - 5) - pc2(x, -t - 3 * pc3(3, x, y)) * x) + pc1(pc3(x, y, t * pc1(-x)) - pc2(-y * pc1(x), -x + pc2(x + y, x * y - y)))
        'x * y * (2 * x + 1) * (2 * x * y / t - 2 * x * (3 * t - 1) / (2 * x - 3 * y - 4) * (x / (3 * x - 1) - 4 / x + 5 * (2 * x * y * t - 1) / (y + 1) - 7 * (2 * x * (y + 1) * (3 * y + 2) * (3 / (x + 1) - 2 * t / (2 * x * y * t - 1) + (4 * x - 1) * (5 * y - 7) / (x - 2 * y - 1 - 2 * t / (3 - 7 * x - 8 * y * (4 * x / (2 * t + 1) - 7 * x - 8 / t + 9 * (2 * x - 1) * (3 * x + 4 * y + 5) * (2 * x * y * t - 7) * x * y * t / (x - y * 2 - 3 / (x / (t - 1) - 7 / (y + 2) + 8 / (2 * x * y * t + 1) - 9))))) / (x - 1)))))
        '- (-x - x / (x + y) - (-x / (-y) + x / (x / y + y / x)) * y * x / (x + y) - (-x / (x - y) + y / (x - y)) * Sin(x / (x + y)) - x / Cos(x / y + y / x) * (-x * y / (y - x) * Cos(y / (x + y)))) - (-(-x) / (x - y) + Sin(x / (x / y + y / x)) * x / (x + y) * Cos(y / (x / y + y / x)) - (-y) * x / (x / y - y / x)) / (Sin(y / (x + y)) - x / Cos(x / (x / y - y / x))) + x * y / (Cos(x / y + y / x) * Sin(x / y - y / x) - Cos(x / (x + y)) / Sin(y / (x + y)) + Sin(x / (x / y - y / x)) / Cos(y / (x / y + x / y))) + Cos(x / (x / y - y / x)) * Sin(y / (y / x - x / y)) / (x / (x + y) - y / (x / y - y / x) * Cos(y / (y / x - x / y)))
        '2.1 * x ^ 9 + 3.5 * x ^ 8 - 7.7 * x ^ 7 + 6.5 * x ^ 6 - 1.2 * x ^ 5 - 1.7 * x ^ 4 + 3.1 * x ^ 3 - 5.7 * x ^ 2 + 3.5 * x - 10.5
        '2.1 * ((x+t)/x) ^ 14 + 3.5 * ((x-y)/t) ^ 12 - 7.7 * ((y+t-x)/y) ^ 11 + 6.5 * ((y-x)/(x+t)) ^ 9 - 1.2 * ((t+y)/(x+y)) ^ 8 - 1.7 * ((x-y)/(x+y+t)) ^ 7   + 3.1 * ((y+t)/(x+t-y)) ^ 6 - 5.7 * ((y+t)/(x-y+t)) ^ 5 
        'pc2(pc1(x / y), pc1(y / x)) * pc1(x / y) / pc1(y / x) - 1.1 * pc2(-pc1(-y / x) * 3.1, pc2(-x / pc1(-x / y), y - 1.5 * pc1(y / x))) + 2.1 * pc2(1.5 * pc2(pc1(x / y), pc1(y / x)), -pc1(-y / x) / (3.1 * pc1(-x / y) + x * pc1(-y / x))) + 5.1 * pc2(pc2(y / x, x / y) * x, pc1(pc2(y / x, x / y) * 1.1 + x * pc2(x / y, y / x))) * (-pc1(-y / x) * pc2(x / y, y / x) * 1.5 + 3.5 * pc1(x / y) / pc1(pc1(y / x) * pc2(x / y, y / x)))



        'Call flSetVarValueD(AdrX, x)
        'Call flSetVarValueD(adrY, y)
        'Call flSetVarValueD(adrT, t)
        'resf = resf + flResultF(FC1)
       


        CalcFunc = resf

    End Function



    Public Sub ErrorHandle()
        Dim ECode As Integer
        Dim S As String
        Dim ErStr As String
        Dim ErStrTmp As String


        Call flGetErrorCode(ECode)

        If ECode = 0 Then GoTo endp

        Select Case ECode

            Case fl_ZERO_DIVIDE
                S = "DIVIDE ON ZERO"
            Case fl_INVALID_OPERATION
                S = "INVALID OPERATION"
            Case fl_OVERFLOW
                S = "OVERFLOW"
            Case fl_UNDERFLOW
                S = "UNDERFLOW"
            Case fl_INT_OVERFLOW
                S = "INTEGER OVERFLOW"
            Case fl_ACCESS_VIOLATION
                S = "INTERNAL ERROR or UNCATCHABLE SYNTAX ERROR"
            Case fl_OUT_OF_MEMORY
                S = "OUT OF MEMORY"
            Case fl_STACK_OVERFLOW
                S = "STACK OVERFLOW"
            Case fl_UNKNOWN_SYMBOL
                S = "UNKNOWN SYMBOL or INCORRECT ARGUMENT or  WRONG EXPRESSION"
            Case fl_WRONG_NUMBER_ARGUMENTS
                S = "INCOINCIDENCE NUMBER OF   ARGUMENTS"
            Case fl_MISSING_OPERATION
                S = "MISSING OPERATION"
            Case fl_MISSING_EXPRESSION
                S = "MISSING EXPRESSION"
            Case fl_UNKNOWN_FUNCTION
                S = "UNKNOWN FUNCTION"
            Case fl_ERROR_AT_ADDITION_FUNCTION
                S = "ERROR AT ADDITION FUNCTION"
            Case fl_NONEXISTENT_FUNCTION
                S = "NONEXISTENT FUNCTION"
            Case fl_INCORRECT_ARGUMENT
                S = "INCORRECT ARGUMENT"
            Case fl_MISSING_ARGUMENT
                S = "MISSING ARGUMENT"
            Case fl_INCORRECT_TYPE
                S = "INCORRECT TYPE"
            Case fl_MISSING_SEPARATOR
                S = "MISSING SEPARATOR "
            Case fl_WRONG_NAME
                S = "WRONG NAME"
            Case fl_MISSING_ABS_BRACKET
                S = "MISSING ABS BRACKET"
            Case fl_MISSING_SQUARE_BRACKET
                S = "MISSING SQUARE BRACKET"
            Case fl_MISSING_CURLY_BRACKET
                S = "MISSING CURLY BRACKET"
            Case fl_MISSING_ROUND_BRACKET
                S = "MISSING ROUND BRACKET"
            Case fl_NO_DIFF_EXPRESSION
                S = "NO DIFF EXPRESSION"
            Case fl_WRONG_EXPRESSION
                S = "WRONG EXPRESSION"
            Case fl_SPLAIN_DATA_ERROR
                S = "SPLAIN DATA ERROR"
            Case fl_INCORRECT_SPACE
                S = "INCORRECT SPACE"
            Case fl_INTERNAL_ERROR
                S = "INTERNAL ERROR"
            Case fl_VARIABLE_REDECLARED
                S = "VARIABLE REDECLARED"
            Case Else : S = "UNKNOWN SYNTAX ERROR"

        End Select

        Call flGetErrorString(ErStrTmp)
        ErStr = ErStrTmp
        ErStrTmp = ""
        '  it's better: at first,  copying of a string then reset - will help to avoid the possible mistakes connected with transfer of strings  (the conflict of different managers of memory)


        MsgBox("Foreval:SyntaxError" + Chr(13) + S + Chr(13) + ErStr + Chr(13))

endp:
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim AdrTmp As UInteger
        Dim id As Integer
        Dim str As String
        Dim FHandle As TAddFuncStruct
        Dim AdrFS As UInteger
        Dim AdrFnc As UInteger
        Dim FCAddr As UInteger
        Dim IDF As Integer
        Dim lenVD As Integer
        Dim rd As Double
        Dim ri, fi As Integer
        Dim res As Double
        Dim TArg3 As TExtArg3
        Dim i64 As Int64
        Dim ax, bx, hx, sx, fx, dx, dy, int3 As Double
        Dim Lv As Integer
        Dim AddrDeriv As TDiffFunc4
        Dim DiffFunc5 As String
        Dim DiffFuncTmp5 As String
        Dim FD5 As UInteger




        'First of all need to set type of strings !!!!!!!!!!!!!!!
        'String type  - ANSISTRING
        'To set type of string (ANSISTRING) in foreval.dll:
        Call flSet(fl_STRING_TYPE, fl_ANSISTRING, 0)
        'Call flSet(fl_ENABLE, fl_SHOW_EXCEPTION, 0)

        'to check the correct of transmission strings enable error messages commando flSet (fl_ENABLE, fl_SHOW_EXCEPTION, 0)
        'and pass the string with the error, such as: flCompile ("1+2+3+",0,AdrFS);
        'has to be a message with this string without distortions


        'Call flSet(fl_ENABLE, fl_CHECK_INCORRECT_SPACE, 0)

        'set types all constants and results of intermediate calculations (on default - extended):
        Call flSet(fl_PARAM_TYPE, fl_DOUBLE, 0)
        Call flSet(fl_DATA_TYPE, fl_DOUBLE, 0)


        Call flSetDiffVar("x")


        'Call flSetVar("x", GetAddr(x), fl_DOUBLE)
        'Call flSetVar("y", GetAddr(y), fl_DOUBLE)
        'Call flSetVar("t", GetAddr(t), fl_DOUBLE)
        'Call flSetVar("res", GetAddr(resf), fl_DOUBLE)
        'Call flSetVar("i", GetAddr(i), fl_INTEGER)
        'Call flSetVar("j", GetAddr(j), fl_INTEGER)
        'Call flSetVar("k", GetAddr(k), fl_INTEGER)
        'Call flSetVar("n", GetAddr(n), fl_INTEGER)

        Call flSetVarIntrnl("x", fl_DOUBLE, AdrX)
        Call flSetVarIntrnl("y", fl_DOUBLE, adrY)
        Call flSetVarIntrnl("t", fl_DOUBLE, adrT)
        Call flSetVarIntrnl("res", fl_DOUBLE, adrRes)
        Call flSetVarIntrnl("result", fl_DOUBLE, adrRes)
        Call flSetVarIntrnl("i", fl_INTEGER, AdrI)
        Call flSetVarIntrnl("j", fl_INTEGER, adrJ)
        Call flSetVarIntrnl("k", fl_INTEGER, adrK)
        Call flSetVarIntrnl("n", fl_INTEGER, adrN)




        'x = -9.123456789012345E-301
        'i64 = ReadInt64(GetAddr(x))
        'x = 123.4464564
        'WriteInt64(GetAddr(x), i64)
        'y = x + 1

        'x = 2.123
        'CopyMem(GetAddr(y), GetAddr(x), 8)
        'x = y + 1


        x = 2.123
        y = 5.456
        t = -3.789
        n = 1
        k = 2
        i = 5
        j = 5

        Call flSetVarValueD(AdrX, x)
        Call flSetVarValueD(adrY, y)
        Call flSetVarValueD(adrT, t)


        Call flSetVarValueI(adrI, x)
        Call flSetVarValueI(adrJ, j)
        Call flSetVarValueI(adrK, k)
        Call flSetVarValueI(adrN, n)



        'param value set before define
        a = 2.54321
        b = -3.98765
        c = 4.12345
        d = -5.6789
        d1 = 12.34567

        Call flSetParam("a", GetAddr(a), fl_DOUBLE)
        Call flSetParam("b", GetAddr(b), fl_DOUBLE)
        Call flSetParam("c", GetAddr(c), fl_DOUBLE)
        Call flSetParam("d", GetAddr(d), fl_DOUBLE)

        Call flSetVarIntrnl("vd", fl_ARRAY_DOUBLE, adrVD)
        Call flSetVarIntrnl("ad", fl_ARRAY_DOUBLE, adrAD)
        Call flSetVarIntrnl("vi", fl_ARRAY_INTEGER, AdrVI)
        lenVD = 100
        Call flSetLength(adrVD, fl_ARRAY_DOUBLE, lenVD)
        Call flSetLength(adrAD, fl_ARRAY_DOUBLE, 3)
        Call flSetLength(AdrVI, fl_ARRAY_INTEGER, lenVD)

        For fi = 0 To lenVD - 1  'array - dinamic count from 0 to length - 1
            rd = ((-1) ^ (fi + 1)) * (fi + 1) * 0.5
            Call flSetArrayValueD(adrVD, fi, rd)

            ri = Fix((-1) ^ (fi + 5) * (fi + 5) * 0.5)
            Call flSetArrayValueI(AdrVI, fi, ri)
        Next

        'in the work, you can dynamically change the size of the array without recompiling the function containing it
        Call flSetVarIntrnl("vd1", fl_ARRAY_DOUBLE, AdrVD1)
        Call flCompile("sum(vd1)*len(vd1)", 0, FCAddr)
        Call flSetLength(AdrVD1, fl_ARRAY_DOUBLE, 3)
        Call flSetArrayValueD(AdrVD1, 0, 1.1)
        Call flSetArrayValueD(AdrVD1, 1, 2.2)
        Call flSetArrayValueD(AdrVD1, 2, 3.3)
        Call flResultD(FCAddr, res)

        str = CStr(res)
        'MsgBox(str)  '=(1.1+2.2+3.3)*3=19.8

        Call flSetLength(AdrVD1, fl_ARRAY_DOUBLE, 5)
        Call flSetArrayValueD(AdrVD1, 3, 4.4)
        Call flSetArrayValueD(AdrVD1, 4, 5.5)
        Call flResultD(FCAddr, res)

        str = CStr(res)
        'MsgBox(str)  '=(1.1+2.2+3.3+4.4+5.5)*5=82.5



        '******************* Adding of external functions********************************

        '*******************************************************************************************
        'Calling of external functions in .net is very slow!!!(slowly even than in vb6 in times!) 
        'so, if it is possible, use precompiled call for external functions
        '*******************************************************************************************

        'sp1
        Call InitFuncStruct(FHandle)
        'flGetAdr(fl_GET_VAR_ADDR, AddressOf sp1, AdrFnc)
        FHandle.Addr = GetAddr(AddressOf sp1)
        FHandle.arg = 1
        FHandle.ArgType = fl_DOUBLE
        FHandle.DeepFPU = 1
        'flGetAdr(fl_GET_VAR_ADDR, FHandle, AdrFS)
        Call flSetFunction("sp1", GetAddr(FHandle), IDF)

        'sp2
        Call InitFuncStruct(FHandle)
        'flGetAdr(fl_GET_VAR_ADDR, AddressOf sp2, AdrFnc)
        FHandle.Addr = GetAddr(AddressOf sp2)
        FHandle.arg = 2
        FHandle.ArgType = fl_DOUBLE
        FHandle.DeepFPU = 1
        'flGetAdr(fl_GET_VAR_ADDR, FHandle, AdrFS)
        Call flSetFunction("sp2", GetAddr(FHandle), IDF)

        'sp3
        Call InitFuncStruct(FHandle)
        'flGetAdr(fl_GET_VAR_ADDR, AddressOf sp2, AdrFnc)
        FHandle.Addr = GetAddr(AddressOf sp3)
        FHandle.arg = 3
        FHandle.ArgType = fl_DOUBLE
        FHandle.DeepFPU = 2
        'flGetAdr(fl_GET_VAR_ADDR, FHandle, AdrFS)
        Call flSetFunction("sp3", GetAddr(FHandle), IDF)


        'ps1
        Call InitFuncStruct(FHandle)
        FHandle.Addr = GetAddr(AddressOf ps1)
        FHandle.arg = 1
        FHandle.ArgType = fl_DOUBLE
        FHandle.DeepFPU = 1
        FHandle.CallType = fl_MEMORY_ADDRESSES
        Call flSetFunction("ps1", GetAddr(FHandle), IDF)

        'ps2
        Call InitFuncStruct(FHandle)
        FHandle.Addr = GetAddr(AddressOf ps2)
        FHandle.arg = 2
        FHandle.ArgType = fl_DOUBLE
        FHandle.DeepFPU = 1
        FHandle.CallType = fl_MEMORY_ADDRESSES
        Call flSetFunction("ps2", GetAddr(FHandle), IDF)


        'ps3
        Call InitFuncStruct(FHandle)
        FHandle.Addr = GetAddr(AddressOf ps3)
        FHandle.arg = 3
        FHandle.ArgType = fl_DOUBLE
        FHandle.DeepFPU = 1
        FHandle.CallType = fl_MEMORY_ADDRESSES
        Call flSetFunction("ps3", GetAddr(FHandle), IDF)

        'fvd3                        fvd3(vd,n+1,x*y)
        Call InitFuncStruct(FHandle)
        TArg3.TypeArg1 = fl_ARRAY_DOUBLE
        TArg3.TypeArg2 = fl_INTEGER
        TArg3.TypeArg3 = fl_DOUBLE
        FHandle.Addr = GetAddr(AddressOf fvd3)
        FHandle.arg = 3
        FHandle.ArgType = fl_DIFFER
        FHandle.ArgTypeList = GetAddr(TArg3)
        FHandle.DeepFPU = 1
        Call flSetFunction("fvd3", GetAddr(FHandle), IDF)

        'infs - with infinite number of arg.     InfSum(x,y,3.5,InfSum(3.7,x*t,x,-y,-t*x,3.1,1.5)*x,t+x)*2.1
        Call InitFuncStruct(FHandle)
        FHandle.Addr = GetAddr(AddressOf InfSum)
        FHandle.ArgType = fl_DOUBLE
        FHandle.CallType = fl_INFINITE_STACK_CPU
        FHandle.DeepFPU = 2
        Call flSetFunction("infsum", GetAddr(FHandle), IDF)



        'copy(VS,VD): VS->VD
        'vd1: array double=len(vd); copy(vd,vd1); sum(vd1)      
        Call InitFuncStruct(FHandle)
        FHandle.ArgType = fl_ARRAY_DOUBLE
        FHandle.Addr = GetAddr(AddressOf CopyV)
        FHandle.RetNum = fl_NO 'sub
        FHandle.arg = 2
        FHandle.DeepFPU = 1
        FHandle.SaveReg = 207 'eax,ebx,ecx,edx,esi,edi
        FHandle.ReplFunc = fl_NO
        Call flSetFunction("Copy", GetAddr(FHandle), IDF) 'vd1: array double=len(vd); copy(vd,vd1); sum(vd1)

        'FillArray(VD,x): VD[all]=x
        Call InitFuncStruct(FHandle)
        FHandle.ArgType = fl_DIFFER
        FHandle.arg = 2
        TArg3.TypeArg1 = fl_ARRAY_DOUBLE
        TArg3.TypeArg2 = fl_DOUBLE
        FHandle.ArgTypeList = GetAddr(TArg3)
        FHandle.Addr = GetAddr(AddressOf FillArray)
        FHandle.RetNum = fl_NO 'sub
        FHandle.arg = 2
        FHandle.DeepFPU = 1
        FHandle.SaveReg = 207 'eax,ebx,ecx,edx,esi,edi
        FHandle.ReplFunc = fl_NO
        Call flSetFunction("FillArray", GetAddr(FHandle), IDF)



        'set the same functions with precompiled call
        Call flSetFunction("pc0()=pi", 0, IDF)
        Call flSetFunction("pc1(x:  double)=x^2", 0, IDF)
        Call flSetDiffTemplate(IDF, "2*$arg1*$dfarg1")
        Call flSetFunction("pc2(x,y:  double)=x-y", 0, IDF)
        Call flSetDiffTemplate(IDF, "$dfarg1-$dfarg2")
        Call flSetFunction("pc3(x,y,t: double)=x+y-t", 0, IDF)
        Call flSetDiffTemplate(IDF, "$dfarg1+$dfarg2-$dfarg3")
        Call flSetFunction("pvd3(vd:array double; n:integer; x:double)=vd[n]*x", 0, IDF)
        Call flSetFunction("{$CC-}pccopy(vs,vd: array double):none = l:int=0; ls:int=len(vs); ld:int=len(vd); l=min(ls,ld); i:int=0; for(i,0,l-1,vd[i]=vs[i])", 0, IDF)
        Call flSetFunction("{$CC-}pcfillarray(vd: array double; x: double):none = l:int=len(vd); i:int=0; for(i,0,l-1,vd[i]=x)", 0, IDF)


        'init integral coeff:
        InitInt()


        '******************* Functions wih identifier: ******************

        'idsin
        Call InitFuncStruct(FHandle)
        FHandle.Addr = GetAddr(AddressOf idfunc)
        FHandle.arg = 1
        FHandle.ArgType = fl_DOUBLE
        FHandle.DeepFPU = 1
        FHandle.Set_ID = fl_ENABLE
        FHandle.Id_Func = 1
        FHandle.arg = 1
        Call flSetFunction("idsin", GetAddr(FHandle), IDF)

        'idcos
        Call InitFuncStruct(FHandle)
        FHandle.Addr = GetAddr(AddressOf idfunc)
        FHandle.arg = 1
        FHandle.ArgType = fl_DOUBLE
        FHandle.DeepFPU = 1
        FHandle.Set_ID = fl_ENABLE
        FHandle.Id_Func = 2
        FHandle.arg = 1
        Call flSetFunction("idcos", GetAddr(FHandle), IDF)


        'idsin(x)^2+idcos(x)^2



        '*************************  functions with symbolic derivatives: ********************************

        Call flSetFunction("pcdiv(x1,x2:ext) = x1/x2", 0, IDF)
        Call flSetDiffTemplate(0, "diff(pcdiv) =pcdiv (($dfarg1*$arg2-$arg1*$dfarg2),sqr($arg2))")

        Call flSetFunction("pcsin(x:ext) = sin(x)", 0, IDF)
        Call flSetDiffTemplate(0, "diff(pcsin) = pccos($arg1)*$dfarg1")

        Call flSetFunction("pccos(x:ext) = cos(x)", 0, IDF)
        Call flSetDiffTemplate(0, "diff(pccos) = -pcsin($arg1)*$dfarg1")

        Call flSetFunction("pcln(x:ext) = ln(x)", 0, IDF)
        Call flSetDiffTemplate(0, "diff(pcln) = $dfarg1/$arg1")

        Call flSetFunction("pcpow(x1,x2:ext) = x1^x2", 0, IDF)
        Call flSetDiffTemplate(0, "diff(pcpow) = pcpow($arg1,$arg2)*(($arg2)*($dfarg1)/($arg1)+($dfarg2)*pcln($arg1))")

        Call flSetFunction("pcipow(x:ext; n:int)=x^n", 0, IDF)
        Call flSetDiffTemplate(0, "diff(pcipow) = pcipow($arg1,$arg2-1)*$arg2*$dfarg1")

        'pcipow(pcpow(pcsin(x/(x+y)),pccos(y/(x+y))),n+2)
        '(sin(x/(x+y))^cos(y/(x+y)))^(n+2)



        '*******************Set function with derivatives****************************

        Call InitFuncStruct(FHandle)
        FHandle.Addr = GetAddr(AddressOf fp3)
        FHandle.arg = 1
        FHandle.ArgType = fl_DOUBLE
        FHandle.DeepFPU = 2 'max of all: fp3,...,fpd4
        AddrDeriv.Addr1 = GetAddr(AddressOf fp3d1)
        AddrDeriv.Addr2 = GetAddr(AddressOf fp3d2)
        AddrDeriv.Addr3 = GetAddr(AddressOf fp3d3)
        AddrDeriv.Addr4 = GetAddr(AddressOf fp3d4)
        FHandle.AdrDeriv = GetAddr(AddrDeriv)
        FHandle.NDeriv = 4
        Call flSetFunction("fdif", GetAddr(FHandle), IDF)

        'fdif(x*fdif(x/fdif(x/y)))/fdif(y/x)
        '(x*(x/(x/y)^3)^3)^3/(y/x)^3




        '**********************Set splain function**************************
        'spl1(x)=(Sin(3 * x) - Cos(2 * x)) * Exp(-x / 10)        -15 <= x <= 15 ; step = 0.1

        hx = 0.1
        ax = -15
        bx = 15
        sx = ax
        Lv = Fix(Abs(bx - ax) / hx) + 1

        Call flSetVarIntrnl("svdx", fl_ARRAY_DOUBLE, adrVDX)
        Call flSetVarIntrnl("svdy", fl_ARRAY_DOUBLE, adrVDY)
        Call flSetLength(adrVDX, fl_ARRAY_DOUBLE, Lv)
        Call flSetLength(adrVDY, fl_ARRAY_DOUBLE, Lv)

        For fi = 0 To Lv - 1
            Call flSetArrayValueD(adrVDX, fi, sx)
            fx = (Sin(3 * sx) - Cos(2 * sx)) * Exp(-sx / 10)
            Call flSetArrayValueD(adrVDY, fi, fx)
            sx = sx + hx
        Next

        Call flSetSplainFunction("spl1", adrVDX, adrVDY, fl_ARRAY_DOUBLE, id)



        'spl2(x)=x*(Sin(x) + Cos(x))         -10 <= x <= 10  ; step = 0.1

        hx = 0.1
        ax = -10
        bx = 10
        sx = ax
        Lv = Fix(Abs(bx - ax) / hx) + 1


        Call flSetLength(adrVDX, fl_ARRAY_DOUBLE, Lv)
        Call flSetLength(adrVDY, fl_ARRAY_DOUBLE, Lv)

        For fi = 0 To Lv - 1
            Call flSetArrayValueD(adrVDX, fi, sx)
            fx = sx * (Sin(sx) + Cos(sx))
            Call flSetArrayValueD(adrVDY, fi, fx)
            sx = sx + hx
        Next

        Call flSetSplainFunction("spl2", adrVDX, adrVDY, fl_ARRAY_DOUBLE, id)

        'spl1(x)/spl2(x) 
        '((Sin(3 * x) - Cos(2 * x)) * Exp(-x / 10)) / (x * (Sin(x) + Cos(x))) 




        '*************** How to work with Foreval dinamic array ********************************

        'adrVD - address of address of vd[0]
        'If Length of array = 0 then adrVD = 0 !!!
        'If adrVD <> 0 then:

        adrVD0 = ReadInt32(adrVD)                    'adrVD0=@vd[0]
        CopyMem(GetAddr(res), adrVD0, 8)             'res=vd[0]
        str = CStr(res)
        'MsgBox(str)

        CopyMem(GetAddr(res), adrVD0 + 75 * 8, 8)    'res=vd[75];  8- sizeof(double)
        str = CStr(res)
        'MsgBox(str)

        ri = ReadInt32(adrVD0 - 4)                'ri=Length(vd); +1 if Foreval compiled in FPC !!!!!!
        str = CStr(ri)
        'MsgBox(ri)

        'set and copy VB dinamic array (VBA1) to Foreval dinamic array  (VD1)
        Call flSetLength(AdrVD1, fl_ARRAY_DOUBLE, lenVD)

        ReDim VBA1(lenVD - 1)
        For fi = 0 To lenVD - 1
            VBA1(fi) = fi
        Next

        adrVD10 = ReadInt32(AdrVD1)                    'adrVD0=@vd[0]
        CopyMem(adrVD10, GetAddr(VBA1(0)), lenVD * 8)  'VBA1->VD1; 8- sizeof(double)





        '************************* Imitation of calculations with matrixes *************************

        'matrix size 3x4=12: strings=3; columns=4
        'in '0' cell of array put number of strings
        'in '1' cell of array put number of columns

        lenMX1 = 14 ' 12(3x4)+2
        ReDim mxd1(lenMX1)
        ReDim mxd2(lenMX1)
        mxd1(0) = 3 'strings
        mxd1(1) = 4 'columns
        mxd2(0) = 3 'strings
        mxd2(1) = 4 'columns

        'mxd1 = [st, cl, (1,2,3,4) ; (5,6,7,8) ; (9,10,11,12) ]
        For fi = 2 To lenMX1 - 1
            mxd1(fi) = fi - 1
        Next

        'mxd2 = [st, cl, (0,0,0,0) ; (0,0,0,0) ; (0,0,0,0) ]
        For fi = 2 To lenMX1 - 1
            mxd2(fi) = 0
        Next


        'set and copy
        Call flSetVarIntrnl("mxd1", fl_ARRAY_DOUBLE, adrMXD1)
        Call flSetLength(adrMXD1, fl_ARRAY_DOUBLE, lenMX1)

        Call flSetVarIntrnl("mxd2", fl_ARRAY_DOUBLE, adrMXD2)
        Call flSetLength(adrMXD2, fl_ARRAY_DOUBLE, lenMX1)

        'copy: vb(mxd1)->foreval(mxd1)
        adrMXD10 = ReadInt32(adrMXD1)                    'adrMXD10=@mxd1[0]
        CopyMem(adrMXD10, GetAddr(mxd1(0)), lenMX1 * 8)  'copy

     
        'copy: vb(mxd2)->foreval(mxd2)
        adrMXD20 = ReadInt32(adrMXD2)                    'adrMXD20=@mxd2[0]
        CopyMem(adrMXD20, GetAddr(mxd2(0)), lenMX1 * 8)  'copy



        'readmxd(mxd1,i,j)=mxd1[i,j];            readmxd(mxd1,1,1)=1; readmxd(mxd1,3,4)=12
        Call InitFuncStruct(FHandle)
        TArg3.TypeArg1 = fl_ARRAY_DOUBLE
        TArg3.TypeArg2 = fl_INTEGER
        TArg3.TypeArg3 = fl_INTEGER
        FHandle.Addr = GetAddr(AddressOf readmxd)
        FHandle.arg = 3
        FHandle.ArgType = fl_DIFFER
        FHandle.ArgTypeList = GetAddr(TArg3)
        FHandle.DeepFPU = 1
        FHandle.ReplFunc = fl_NO
        Call flSetFunction("readmxd", GetAddr(FHandle), IDF)

        'writemxd(mxd1,i,j,x); mxd1[i,j]=x;          writemxd(mxd1,2,4,pi); readmxd(mxd1,2,4);
        Call InitFuncStruct(FHandle)
        TArg4.TypeArg1 = fl_ARRAY_DOUBLE
        TArg4.TypeArg2 = fl_INTEGER
        TArg4.TypeArg3 = fl_INTEGER
        TArg4.TypeArg4 = fl_DOUBLE
        FHandle.Addr = GetAddr(AddressOf writemxd)
        FHandle.arg = 4
        FHandle.ArgType = fl_DIFFER
        FHandle.ArgTypeList = GetAddr(TArg4)
        FHandle.DeepFPU = 1
        FHandle.RetNum = fl_NO
        FHandle.ReplFunc = fl_NO
        Call flSetFunction("writemxd", GetAddr(FHandle), IDF)

        'summxd(mxd1,mxd2,mxdr)=mxdr=mxd1+mxd2;
        Call InitFuncStruct(FHandle)
        FHandle.Addr = GetAddr(AddressOf summxd)
        FHandle.arg = 3
        FHandle.ArgType = fl_ARRAY_DOUBLE
        FHandle.DeepFPU = 2
        FHandle.RetNum = fl_NO
        FHandle.ReplFunc = fl_NO
        Call flSetFunction("summxd", GetAddr(FHandle), IDF)

        'more fast:
        Call flSetFunction("pcreadmxd(mx:arrayd; i,j: integer):dbl = mx[(i-1)*mx[1]+j+1];", 0, id)
        Call flSetFunction("pcwritemxd(mx:arrayd; i,j: integer; val:double):none= mx[(i-1)*mx[1]+j+1]=val;", 0, id)
        Call flSetFunction("pcsummxd(mx1,mx2,rmx: arrayd):none=  st:integer=mx1[0]; cl:integer=mx1[1]; i:int=0; j:int=0; indx:int=0; for(i,1,st,for(j,1,cl,indx=(i-1)*cl+j+1; rmx[indx]=mx2[indx]+mx1[indx]))", 0, id)


        'smx=2*mxd1; mxd2=smx+mxd1; mxd2->mxd1; mxd1[2,3]=mxd2[3,2]+mxd1[2,4]
        ' Call flCompile("smx: arrayd=len(mxd1); smx[0]=mxd1[0]; smx[1]=mxd1[1]; i:int=0; for(i,2,len(mxd1)-1,smx[i]=2*mxd1[i]); summxd(smx,mxd1,mxd2); copy(mxd2,mxd1); x:dbl=readmxd(mxd2,3,2)+readmxd(mxd1,2,4); writemxd(mxd1,2,3,x)", 0, FC2)
        Call flCompile("smx: arrayd=len(mxd1); smx[0]=mxd1[0]; smx[1]=mxd1[1]; i:int=0; for(i,2,len(mxd1)-1,smx[i]=2*mxd1[i]); pcsummxd(smx,mxd1,mxd2); pccopy(mxd2,mxd1); x:dbl=pcreadmxd(mxd2,3,2)+pcreadmxd(mxd1,2,4); pcwritemxd(mxd1,2,3,x)", 0, FC2)


        '3*mxd1=[st,cl, (3,6,9,12) ; (15,18,21,24) ; (27,30,33,36) ]
        'mxd1[2,3]=mxd2[3,2]+mxd1[2,4]=30+24=54

        Call flResultP(FC2)

        'foreval(mxd1)->VB(mxd2)
        adrMXD10 = ReadInt32(adrMXD1)                    'adrMD10=@mxd1[0]
        CopyMem(GetAddr(mxd2(0)), adrMXD10, lenMX1 * 8)  'foreval(mxd1)->VB(mxd2); 8- sizeof(double)


        'mxd2[2,3];  indx=(i-1)*cl+j+1 (i=2,j=3,cl=4)
        res = mxd2((2 - 1) * 4 + 3 + 1)
        'MsgBox(res) '=54



       

        '************************** Several expressions ********************************************

        'fs3(x,y,z)=x*(y+z)+y*(x+z); fs2(x,y)=x+y; fs1(x)=1-x
        'sum(x=1..5, dx=0.5; y=1..10; dy=0.2; fs3(f1(x-y),fs2(x+1,y-1),x+y));

        'push global var.
        Call flPerform(fl_SAVE, fl_VAR_LIST)

        fs1.Expr = "1-x"
        fs2.Expr = "x+y"
        fs3.Expr = "x*(y+z)+y*(x+z)"

        'Call flSetVar("x", GetAddr(fs1.x), fl_DOUBLE)
        Call flSetVarIntrnl("x", fl_DOUBLE, fs1.adrX)
        Call flCompile(fs1.Expr, 0, fs1.Addr)

        'Call flSetVar("x", GetAddr(fs2.x), fl_DOUBLE)
        'Call flSetVar("y", GetAddr(fs2.y), fl_DOUBLE)
        Call flSetVarIntrnl("x", fl_DOUBLE, fs2.adrX)
        Call flSetVarIntrnl("y", fl_DOUBLE, fs2.adrY)       
        Call flCompile(fs2.Expr, 0, fs2.Addr)

        Call flSetVarIntrnl("x", fl_DOUBLE, fs3.adrX)
        Call flSetVarIntrnl("y", fl_DOUBLE, fs3.adrY)
        Call flSetVarIntrnl("z", fl_DOUBLE, fs3.adrZ)
        'Call flSetVar("x", GetAddr(fs3.x), fl_DOUBLE)
        'Call flSetVar("y", GetAddr(fs3.y), fl_DOUBLE)
        'Call flSetVar("z", GetAddr(fs3.z), fl_DOUBLE)
        
        Call flCompile(fs3.Expr, 0, fs3.Addr)

        'pop global var.
        Call flPerform(fl_RESTORE, fl_VAR_LIST)




        x = 1
        y = 1
        res = 0

        dx = 0.5
        dy = 0.2

        Do
            y = 1
            Do
                fs1.x = x - y
                Call flSetVarValueD(fs1.adrX, fs1.x)

                fs2.x = x + 1
                fs2.y = y - 1
                Call flSetVarValueD(fs2.adrX, fs2.x)
                Call flSetVarValueD(fs2.adrY, fs2.y)


                fs3.x = flResultF(fs1.Addr)
                fs3.y = flResultF(fs2.Addr)
                fs3.z = x + y
                Call flSetVarValueD(fs3.adrX, fs3.x)
                Call flSetVarValueD(fs3.adrY, fs3.y)
                Call flSetVarValueD(fs3.adrZ, fs3.z)


                res = res + flResultF(fs3.Addr)

                y = y + dy
            Loop While y <= 10

            x = x + dx
        Loop While x <= 5

        'MsgBox(res)


        'in Foreval one line:
        'fs1x:dbl=0; fs2x:dbl=0; fs2y:dbl=0; fs3x:dbl=0; fs3y:dbl=0; fs3z:dbl=0; fs1:dbl=0;  fs2:dbl=0; fs3:dbl=0; res:dbl=0; dx:dbl=0.5; dy:dbl=0.2; x:dbl=0; y:dbl=0;    for(x,1,x<=5,x+dx,for(y,1,y<=10,y+dy, fs1x=x-y; fs2x=x+1; fs2y=y-1; fs1=1-fs1x; fs2=fs2x+fs2y; fs3x=fs1; fs3y=fs2; fs3z=x+y;  res=res+fs3x*(fs3y+fs3z)+fs3y*(fs3x+fs3z) )); res





        '*****************  Triple integral with internal var. **********************************************************
        'int3(F(x,y,z)=x*y+2*y*z-z*x, x = -1..2; y = -2*x...x^2+1; z = x-y...x+y
        'in wolframalpha representation: Integrate[x*y+2*y*z-z*x, {x,-1,2}, {y,-2*x,x^2+1}, {z, x-y, x+y}]

        Call flPerform(fl_SAVE, fl_VAR_LIST)

        Call flSetVarIntrnl("x", fl_DOUBLE, FInt3Ex.adrX)
        Call flSetVarIntrnl("y", fl_DOUBLE, FInt3Ex.adrY)
        Call flSetVarIntrnl("z", fl_DOUBLE, FInt3Ex.adrZ)


        Call flCompile("x*y+2*y*z-z*x", 0, FInt3Ex.FAddr)
        Call flCompile("-2*x", 0, FInt3Ex.F1Addr)
        Call flCompile("x^2+1", 0, FInt3Ex.F2Addr)
        Call flCompile("x-y", 0, FInt3Ex.F3Addr)
        Call flCompile("x+y", 0, FInt3Ex.F4Addr)
        FInt3Ex.a = -1
        FInt3Ex.b = 2

        Call flPerform(fl_RESTORE, fl_VAR_LIST)

        int3 = Integral3FF(FInt3Ex.FAddr, FInt3Ex.adrX, FInt3Ex.adrY, FInt3Ex.adrZ, FInt3Ex.a, FInt3Ex.b, FInt3Ex.F1Addr, FInt3Ex.F2Addr, FInt3Ex.F3Addr, FInt3Ex.F4Addr)
        'MsgBox(int3)





        '************************* mixed derivative  d5/dy3dx2(cos(x^2)*sin(y*x))  ***************************

        Call flSetDiffVar("y")
        Call flSetDiffExpr("cos(x^2)*sin(y*x)")
        Call flDiffExpr(3)      'd3/dy3
        Call flSetDiffVar("x")
        Call flDiffExpr(2)       'd2/dx2
        Call flCompileDiffExpr(FD5)   'FD5-> d5/dy3dx2(cos(x^2)*sin(y*x))

        Call flGetDiffString(DiffFuncTmp5)
        DiffFunc5 = DiffFuncTmp5
        DiffFuncTmp5 = ""
        '  it's better: at first,  copying of a string then reset - will help to avoid the possible mistakes connected with transfer of strings  (the conflict of different managers of memory)

        'MsgBox(DiffFunc5)
        'MsgBox(flResultF(FD5))




        '***************************************************************************************

        Call flGet(fl_VERSION, fl_MAJOR, id)
        str = CStr(id)

        Call flGet(fl_VERSION, fl_MINOR, id)
        str = str + "." + CStr(id)

        Call flGet(fl_VERSION, fl_RELEASE, id)
        str = str + "." + CStr(id)

        Call flGet(fl_VERSION, fl_BUILD, id)
        str = str + "." + CStr(id)

        str = "Foreval.dll v." + str
        Me.Text = str

        Call flGet(fl_COMPILED_BY, 0, id)

        If id >= 100 Then
            Me.Text = Me.Text + ".  Compiled by FPC v." + CStr(id)
        Else
            If id = 7 Then Me.Text = Me.Text + ".  Compiled by Delphi7" Else 
            If id = 12 Then Me.Text = Me.Text + ".  Compiled by Delphi 2009" Else 
            If id = 16 Then Me.Text = Me.Text + ".  Compiled by Delphi XE3"
        End If

        Call flGetStr(fl_COMMENT, 0, str)
        Me.Text = Me.Text + "   " + str


        Call flGetStr(fl_ABOUT, 0, str)
        'MsgBox(str)

    End Sub



    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        Dim res As Double
        Dim S As String
        Dim ECode As Integer
        Dim T1 As Single
        Dim T2 As Single
        Dim perf As Double
        Dim nc As Integer
        Dim nd As Integer
        Dim rd As Double
        Dim rt As Integer
        Dim i As Integer

        'Dim FC1 As UInteger

        'S = "sp1(1+x)+sp2(x)"
        S = ETF.Text

        nc = ETC.Text
        resf = 0




        x = Convert.ToDouble(ETX.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))
        y = Convert.ToDouble(ETY.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))
        t = Convert.ToDouble(ETT.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))

        n = Convert.ToInt32(ETN.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))
        k = Convert.ToInt32(ETK.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))
        j = Convert.ToInt32(ETJ.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))

        Call flSetVarValueD(AdrX, x)
        Call flSetVarValueD(adrY, y)
        Call flSetVarValueD(adrT, t)


        Call flSetVarValueI(adrI, x)
        Call flSetVarValueI(adrJ, j)
        Call flSetVarValueI(adrK, k)
        Call flSetVarValueI(adrN, n)

        rd = Convert.ToDouble(ETad0.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))
        Call flSetArrayValueD(adrAD, 0, rd)
        rd = Convert.ToDouble(ETad1.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))
        Call flSetArrayValueD(adrAD, 1, rd)
        rd = Convert.ToDouble(ETad2.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))
        Call flSetArrayValueD(adrAD, 2, rd)

   
        Call flCompile(S, 0, FC1)
        'res = flResultF(FC1)
        'LRes.Text = res
        'x = res + 7.875
        'res = flResultF(FC1)
        'LRes.Text = res
        Call flGetErrorCode(ECode)
        'Call flGetErrorString(ErStr)

        If ECode = 0 Then


            Call flGet(fl_RETURN_NUMBER, FC1, rt)

            'if expression doesn't return number:
            'x=1; y=2; result=x+y
            's:dbl=0; k:int=0; for(k,1,10,s=s+k); result=s;

           Try

           
            If rt = fl_NO Then

            
                If Ch1.Checked Then
                    flResultP(FC1)

                Else

                    T1 = GetTickCount
                    For i = 1 To nc
                        flResultP(FC1)
                    Next
                    T2 = GetTickCount
                End If

                flGetVarValueD(adrRes, res)

                'res = resf
                GoTo endcf

            End If


            If Ch1.Checked Then
                res = flResultF(FC1)


            Else


                T1 = GetTickCount() 'Timer
                For i = 0 To nc
                    res = flResultF(FC1)
                    'res = CalcFunc() 'with changing of variables


                    'Call flResultD(FC1, res)


                    'res = x * y
                    'x = i * 0.00123
                    'Res = Res + flResult(FS)
                    'res = x * y + x * y * (x * y + x * y)
                    'res = x * y * (2 * x + 1) * (2 * x * y / t - 2 * x * (3 * t - 1) / (2 * x - 3 * y - 4) * (x / (3 * x - 1) - 4 / x + 5 * (2 * x * y * t - 1) / (y + 1) - 7 * (2 * x * (y + 1) * (3 * y + 2) * (3 / (x + 1) - 2 * t / (2 * x * y * t - 1) + (4 * x - 1) * (5 * y - 7) / (x - 2 * y - 1 - 2 * t / (3 - 7 * x - 8 * y * (4 * x / (2 * t + 1) - 7 * x - 8 / t + 9 * (2 * x - 1) * (3 * x + 4 * y + 5) * (2 * x * y * t - 7) * x * y * t / (x - y * 2 - 3 / (x / (t - 1) - 7 / (y + 2) + 8 / (2 * x * y * t + 1) - 9))))) / (x - 1)))))
                    'res = a * x * y * t - b * (a * x - b * y + c * t + 1) / x + (a * x - b) * (-x - b * y - c * (-x - y * (-t * c - (-(-x - a) - b - y * (-x - (-a / y - b / (-x))) * (-x / (-y - (-a / x)))))) * y * t)
                    'res = x * y + x * y * (x * y + x * y * (x * y + x * y * (x * y + x * y * (x * y + x * y * (x * y + x * y * (x * y + x * y * (x * y + x * y * (x * y + x * y))))))))
                    'res = ((x / (x / y + y / x) + y / (x / y + y / x) * x * y - x * y * (x / y + y / x)) * (x / (y / x - x / y) - y / (x / y - y / x))) + (x / y + y / x) * (y / x + x / y) / ((x / y - y / x) * x * y + (y / x - x / y) * (x / (x / y + y / x)))
                    'res = sp1(x / y) * sp2(sp1(y / x), sp1(x / y) * sp2(x + y, x - y)) * sp3(y / x, x / y, sp1(x / y) * sp1(y / x) + sp2(x + y, x - y) * sp2(x - y, x + y)) + sp3(sp2(x / y, sp1(y / x)) + sp2(x - y, x + y), sp2(x + y, x - y) / sp2(x - y, x + y), sp1(x / y) * sp1(y / x))
                    'res = sp3(sp1(x * sp1(-sp2(x * (x + y), -x * 2) - 3 - y) / x) - sp2(x * sp1(x * y) - sp2(x * (x - y), x + y), sp2(-x, -y - x - 1) * 2 - 3), x * y, -sp2(x * 2 - y * x / 2, x * y))
                    'res = sp3(t * sp2(x, t), -sp3(x, 2, 5), sp3(-x, y * sp1(x * sp2(x, y * sp3(1, 2, t * sp1(5) + sp2(-x, y)))), 1 - sp2(-x, -1 - y)) * t) * sp2(x - sp3(x, -y, -5), sp3(x, y * x, -t - 5) - sp2(x, -t - 3 * sp3(3, x, y)) * x) + sp1(sp3(x, y, t * sp1(-x)) - sp2(-y * sp1(x), -x + sp2(x + y, x * y - y)))
                    'res = (Sin(x / Cos(x)) + Cos(Cos(y) / y)) / (Sin(Cos(y) / y) + Cos(x / Cos(x))) * (x / Cos(x) + Cos(y) / y)
                    'res = -(-x - x / (x + y) - (-x / (-y) + x / (x / y + y / x)) * y * x / (x + y) - (-x / (x - y) + y / (x - y)) * Sin(x / (x + y)) - x / Cos(x / y + y / x) * (-x * y / (y - x) * Cos(y / (x + y)))) - (-(-x) / (x - y) + Sin(x / (x / y + y / x)) * x / (x + y) * Cos(y / (x / y + y / x)) - (-y) * x / (x / y - y / x)) / (Sin(y / (x + y)) - x / Cos(x / (x / y - y / x))) + x * y / (Cos(x / y + y / x) * Sin(x / y - y / x) - Cos(x / (x + y)) / Sin(y / (x + y)) + Sin(x / (x / y - y / x)) / Cos(y / (x / y + x / y))) + Cos(x / (x / y - y / x)) * Sin(y / (y / x - x / y)) / (x / (x + y) - y / (x / y - y / x) * Cos(y / (y / x - x / y)))
                    'res = 2.1 * x ^ 9 + 3.5 * x ^ 8 - 7.7 * x ^ 7 + 6.5 * x ^ 6 - 1.2 * x ^ 5 - 1.7 * x ^ 4 + 3.1 * x ^ 3 - 5.7 * x ^ 2 + 3.5 * x - 10.5
                    'res = (Sin(x / Cos(x)) + Cos(Cos(y) / y)) / (Sin(Cos(y) / y) + Cos(x / Cos(x))) * (x / Cos(x) + Cos(y) / y)
                    'res = 1.54 * x ^ 12 - 3.54 * x ^ 11 - 7.65 * x ^ 10 + 2.1 * x ^ 9 + 3.5 * x ^ 8 - 7.7 * x ^ 7 + 6.5 * x ^ 6 - 1.2 * x ^ 5 - 1.7 * x ^ 4 + 3.1 * x ^ 3 - 5.7 * x ^ 2 + 3.5 * x - 10.5
                    'res = x ^ y
                    'res = x ^ y * (Sin(x) * x + Cos(x) * y)
     
                    'res = sp2(sp1(x / y), sp1(y / x)) * sp1(x / y) / sp1(y / x) - 1.1 * sp2(-sp1(-y / x) * 3.1, sp2(-x / sp1(-x / y), y - 1.5 * sp1(y / x))) + 2.1 * sp2(1.5 * sp2(sp1(x / y), sp1(y / x)), -sp1(-y / x) / (3.1 * sp1(-x / y) + x * sp1(-y / x))) + 5.1 * sp2(sp2(y / x, x / y) * x, sp1(sp2(y / x, x / y) * 1.1 + x * sp2(x / y, y / x))) * (-sp1(-y / x) * sp2(x / y, y / x) * 1.5 + 3.5 * sp1(x / y) / sp1(sp1(y / x) * sp2(x / y, y / x)))
               
                Next
                T2 = GetTickCount() 'Timer

endcf:
                If Abs(T2 - T1) = 0 Then
                    LPerf.Text = "no define"
                Else
                    LPerf.Text = Int((nc / (T2 - T1)) / 1)
                End If




         End If

            LRes.Text = res

          Catch ex As Exception
             LRes.Text=ex.ToString
          End Try

        Else : Call ErrorHandle()
        End If




        If ECode = 0 Then Call flPerform(fl_FREE, FC1)

    End Sub


    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim FS As UInteger
        Dim res As Double
        Dim ErStr As String
        Dim DiffFunc As String
        Dim DiffFuncTmp As String
        Dim SPtr As UInteger
        Dim ECode As Integer
        Dim i As Integer
        Dim T1 As Single
        Dim T2 As Single
        Dim perf As Double
        Dim nc As Integer
        Dim nd As Integer
        Dim rd As Double


        x = Convert.ToDouble(ETX.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))
        y = Convert.ToDouble(ETY.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))
        t = Convert.ToDouble(ETT.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))

        n = Convert.ToInt32(ETN.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))
        k = Convert.ToInt32(ETK.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))
        j = Convert.ToInt32(ETJ.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))

        Call flSetVarValueD(AdrX, x)
        Call flSetVarValueD(adrY, y)
        Call flSetVarValueD(adrT, t)


        Call flSetVarValueI(adrI, x)
        Call flSetVarValueI(adrJ, j)
        Call flSetVarValueI(adrK, k)
        Call flSetVarValueI(adrN, n)

        rd = Convert.ToDouble(ETad0.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))
        Call flSetArrayValueD(adrAD, 0, rd)
        rd = Convert.ToDouble(ETad1.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))
        Call flSetArrayValueD(adrAD, 1, rd)
        rd = Convert.ToDouble(ETad2.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))
        Call flSetArrayValueD(adrAD, 2, rd)

        nd = 1

        res = 0
        nc = ETC.Text
        nd = ETND.Text

        


        Call flCompileDiff(ETF.Text, nd, FS)
        Call flGetErrorCode(ECode)

        If (ECode = 0) And (Check1.Checked) Then
            Call flGetDiffString(DiffFuncTmp)
            DiffFunc = DiffFuncTmp
            DiffFuncTmp = ""
            '  it's better: at first,  copying of a string then reset - will help to avoid the possible mistakes connected with transfer of strings  (the conflict of different managers of memory)

            MsgBox(DiffFunc)
        End If

        Try

            If ECode = 0 Then

                If Ch1.Checked Then
                    res = flResultF(FS)

                Else

                    T1 = GetTickCount
                    For i = 0 To nc
                        res = flResultF(FS)
                    Next
                    T2 = GetTickCount


                    If Abs(T2 - T1) = 0 Then
                        LPDF.Text = "no define"
                    Else
                        LPDF.Text = Int((nc / (T2 - T1)) / 1)
                    End If



                End If

                LRDF.Text = res



            Else : Call ErrorHandle()
            End If

        Catch ex As Exception
            LRDF.Text = ex.ToString
        End Try

        If ECode = 0 Then Call flPerform(fl_FREE, FS)

    End Sub

  
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim IDF As Long
        Dim ECode As Long

        Call flSetFunction(ETEF.Text, 0, IDF)
        Call flGetErrorCode(ECode)
        If ECode <> 0 Then Call ErrorHandle()
    End Sub

    Private Sub LPDF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LPDF.Click

    End Sub
End Class
