Attribute VB_Name = "Module2"
Private Declare Sub PutMem1 Lib "msvbvm60" (ByVal Addr As Long, ByVal NewVal As Byte)
Private Declare Sub PutMem2 Lib "msvbvm60" (ByVal Addr As Long, ByVal NewVal As Integer)
Private Declare Sub PutMem4 Lib "msvbvm60" (ByVal Addr As Long, ByVal NewVal As Long)
Private Declare Sub PutMem8 Lib "msvbvm60" (ByVal Addr As Long, ByVal NewVal As Double)
Private Declare Sub GetMem1 Lib "msvbvm60" (ByVal Addr As Long, RetVal As Byte)
Private Declare Sub GetMem2 Lib "msvbvm60" (ByVal Addr As Long, RetVal As Integer)
Private Declare Sub GetMem4 Lib "msvbvm60" (ByVal Addr As Long, RetVal As Long)
Private Declare Sub GetMem8 Lib "msvbvm60" (ByVal Addr As Long, RetVal As Double)
Private Declare Sub CopyMem Lib "kernel32" Alias "RtlMoveMemory" (ByVal Dst As Long, ByVal Src As Long, ByVal Length As Long)


Type TExtArg3
     TypeArg1 As Long
     TypeArg2 As Long
     TypeArg3 As Long
End Type

Type TExtArg4
     TypeArg1 As Long
     TypeArg2 As Long
     TypeArg3 As Long
     TypeArg4 As Long
End Type

Type TDiffFunc4
     Addr1 As Long
     Addr2 As Long
     Addr3 As Long
     Addr4 As Long
End Type

Type TFunc1
      Expr   As String
      Addr   As Long
      res    As Double
      x      As Double
End Type

Type TFunc2
      Expr   As String
      Addr   As Long
      res    As Double
      x      As Double
      y      As Double
End Type

Type TFunc3
      Expr   As String
      Addr   As Long
      res    As Double
      x      As Double
      y      As Double
      z      As Double
End Type

Dim an(16) As Double
Dim bn(16) As Double
Dim P_Integral As Long
Dim N_Integral As Long



Public Function sp0() As Double
 sp0 = 3.14159265358979
End Function

Public Function sp1(ByVal arg As Double) As Double
 sp1 = arg * arg
End Function

Public Function sp2(ByVal arg1 As Double, ByVal arg2 As Double) As Double
 sp2 = arg1 - arg2
End Function

Public Function sp3(ByVal arg1 As Double, ByVal arg2 As Double, ByVal arg3 As Double) As Double
 sp3 = arg1 + arg2 - arg3
End Function

Public Function ps0() As Double
 ps0 = 3.14159265358979
End Function

Public Function ps1(ByRef arg As Double) As Double
 ps1 = arg * arg
End Function

Public Function ps2(ByRef arg1 As Double, ByRef arg2 As Double) As Double
 ps2 = arg1 - arg2
End Function

Public Function ps3(ByRef arg1 As Double, ByRef arg2 As Double, ByRef arg3 As Double) As Double
 ps3 = arg1 + arg2 - arg3
End Function

'pcvd3(vd:array double; n:integer; x:double)=vd[n]*x
Public Function fvd3(ByVal adrV As Long, ByVal argi As Long, ByVal argf As Double) As Double
 Dim rd As Double
 Dim lenV As Long
 
  Call flGetArrayValueD(VarPtr(adrV), argi, rd)   'transfer address of address !!!
  'GetMem8 (adrV + 8 * argi), rd   '8-size of double
  
  'Call flGet(fl_ARRAY_LENGTH, VarPtr(adrV), lenV)
 
  
  fvd3 = rd * argf
End Function



Public Function pvd3(ByRef adrV As Long, ByRef argi As Long, ByRef argf As Double) As Double
 Dim rd As Double
 Dim lenV As Long
 
  Call flGetArrayValueD(VarPtr(adrV), argi, rd)   'transfer address of address !!!
  'GetMem8 (adrV + 8 * argi), rd   '8-size of double
  
  'Call flGet(fl_ARRAY_LENGTH, VarPtr(adrV), lenV)
 
  
  pvd3 = rd * argf
End Function


'ms1(argr: double)=argr^2
Public Function ms1(ByVal Addr As Long) As Double
Dim r As Double

 'Addr    ->   AddrOf(argr)
  
   'GetMem8 Addr, r
   Call flGetVarValueD(Addr, r)
   

  ms1 = r * r
End Function

Public Function ms2(ByVal Addr As Long) As Double
Dim r1 As Double
Dim r2 As Double



 'Addr    ->   AddrOf(r1)
 'Addr+16 ->   AddrOf(r2)
  
   'GetMem8 Addr, r1
   'GetMem8 Addr + 16, r2
   Call flGetVarValueD(Addr, r1)
   Call flGetVarValueD(Addr + 16, r2)
     
   
  ms2 = r1 - r2
End Function


Public Function ms3(ByVal Addr As Long) As Double
Dim r1 As Double
Dim r2 As Double
Dim r3 As Double



 'Addr    ->   AddrOf(r1)
 'Addr+16 ->   AddrOf(r2)
 'Addr+32 ->   AddrOf(r3)
  
   'GetMem8 Addr, r1
   'GetMem8 Addr + 16, r2
   'GetMem8 Addr + 32, r3
   
   Call flGetVarValueD(Addr, r1)
   Call flGetVarValueD(Addr + 16, r2)
   Call flGetVarValueD(Addr + 32, r3)
     
   
  ms3 = r1 + r2 - r3
End Function


'msd3(vd:array double; n:integer;  x:double )=vd[n]*x
Public Function msd3(ByVal Addr As Long) As Double
 Dim rd As Double
 Dim x As Double
 Dim lenV As Long
 Dim n As Long
 
 
 'Addr    ->   AddrOf(vd)
 'Addr+16 ->   AddrOf(n)
 'Addr+32 ->   AddrOf(x)

 
 
   Call flGetVarValueI(Addr + 16, n)
   Call flGetArrayValueD(Addr, n, rd)
   'Call flGet(fl_ARRAY_LENGTH, Addr, lenV)
   Call flGetVarValueD(Addr + 32, x)
   
  msd3 = rd * x
End Function



'sum of infinite arg:
Public Function InfSum(ByVal AdrL As Long, ByVal LenL As Long) As Double
 Dim i As Long
 Dim S As Double
 Dim VArg As Double
 Dim Vaddr As Long
 
 S = 0
 
 For i = 1 To LenL
  Vaddr = AdrL + 16 * (i - 1)      'calc. addr. of current arg.
  
  Call flGetVarValueD(Vaddr, VArg) 'get arg. on addr.
  'GetMem8 Vaddr, VArg
  
  S = S + VArg
 Next

 InfSum = S
End Function

'Functions wih identifier:
Public Function idfunc(ByVal arg As Double, ByVal id As Long) As Double
 
    Select Case id
            Case 1
                 idfunc = Sin(arg)
            Case 2
                 idfunc = Cos(arg)
    End Select
End Function


'copyV(VS,VD): VS->VD
Public Sub CopyV(ByVal adrVS As Long, ByVal adrVD As Long)
 Dim rd As Double
 Dim lenV As Long
 Dim lenVS As Long
 Dim lenVD As Long
 Dim adrVD0 As Long
 Dim adrVS0 As Long
 Dim i As Long
 Dim res As Double
 
 
  
  
  'copy(vd,vd1); 1
  
  '************* 1 - slow way ***********
  'Call flGet(fl_ARRAY_LENGTH, VarPtr(adrVS), lenVS)
  'Call flGet(fl_ARRAY_LENGTH, VarPtr(adrVD), lenVD)
  
  'If lenVS < lenVD Then lenV = lenVS Else lenV = lenVD
 
  'For i = 0 To lenV - 1
    'Call flGetArrayValueD(VarPtr(adrVS), i, rd) 'transfer address of address !!!
    'Call flSetArrayValueD(VarPtr(adrVD), i, rd) 'transfer address of address !!!
  'Next
  
  '*************************************
  
  
  
 '************* 2 - more fast ***********
 'If adrVD <> 0 Then
        'GetMem4 VarPtr(adrVD), adrVD0 'adrVD0=@vd[0] ;transfer address of address !!!
        'GetMem4 (adrVD0 - 4), lenVD   '+1 if Foreval compiled in FPC !!!!!!
    'Else
        'lenVD = 0
   'End If
   
   'If adrVS <> 0 Then
      'GetMem4 VarPtr(adrVS), adrVS0  'adrVD0=@vd[0] ;transfer address of address !!!
      'GetMem4 (adrVS0 - 4), lenVS    '+1 if Foreval compiled in FPC !!!!!!
    'Else
        'lenVS = 0
   'End If
   
   ' 'lenVD = lenVD + 1     'if Foreval compiled in FPC !!!!!!
   ' 'lenVS = lenVS + 1     'if Foreval compiled in FPC !!!!!!
   
   'If lenVS < lenVD Then lenV = lenVS Else lenV = lenVD
   
 
  
  
  'For i = 0 To lenV - 1
    'GetMem8 (adrVS0 + i * 8), res   '8-sizeOf(double)
    'PutMem8 (adrVD0 + i * 8), res   '8-sizeOf(double)
  'Next
  
 '*************************************
  
  
  
 '************* 3 - most fast ***********
 
  If adrVD <> 0 Then
        GetMem4 VarPtr(adrVD), adrVD0 'adrVD0=@vd[0] ;transfer address of address !!!
        GetMem4 (adrVD0 - 4), lenVD   '+1 if Foreval compiled in FPC !!!!!!
    Else
        lenVD = 0
   End If
   
   If adrVS <> 0 Then
      GetMem4 VarPtr(adrVS), adrVS0  'adrVS0=@vs[0] ;transfer address of address !!!
      GetMem4 (adrVS0 - 4), lenVS    '+1 if Foreval compiled in FPC !!!!!!
    Else
        lenVS = 0
   End If
   
   'lenVD = lenVD + 1     'if Foreval compiled in FPC !!!!!!
   'lenVS = lenVS + 1     'if Foreval compiled in FPC !!!!!!
   
   If lenVS < lenVD Then lenV = lenVS Else lenV = lenVD
   
  CopyMem adrVD0, adrVS0, lenV * 8   '8-sizeOf(double)
  
 '*************************************
 
  
End Sub

'FillArray(VD): VD[all]=x
Public Sub FillArray(ByVal adrVD As Long, ByVal x As Double)

 Dim lenV As Long
 Dim adrVD0 As Long
 Dim i As Long
 
 
 '******************* 1 - slow way ******************************
  'Call flGet(fl_ARRAY_LENGTH, VarPtr(adrVD), lenV)
  'For i = 0 To lenV - 1
   'Call flSetArrayValueD(VarPtr(adrVD), i, x)
  'Next
'****************************************************************



 '************* 2 - more fast ***********
   If adrVD <> 0 Then
        GetMem4 VarPtr(adrVD), adrVD0 'adrVD0=@vd[0] ;transfer address of address !!!
        GetMem4 (adrVD0 - 4), lenV    '+1 if Foreval compiled in FPC !!!!!!
    Else
        lenV = 0
   End If
   
  'lenV = lenV + 1     'if Foreval compiled in FPC !!!!!!
  
  For i = 0 To lenV - 1
    PutMem8 (adrVD0 + i * 8), x   '8-sizeOf(double)
  Next
  
'****************************************************************
End Sub


'external. func. with derivatives:  x^3
Public Function fp3(ByVal arg As Double) As Double
 fp3 = arg * arg * arg
End Function
'1-deriv.
Public Function fp3d1(ByVal arg As Double) As Double
 fp3d1 = 3 * arg * arg
End Function
'2-deriv.
Public Function fp3d2(ByVal arg As Double) As Double
 fp3d2 = 6 * arg
End Function
'3-deriv.
Public Function fp3d3(ByVal arg As Double) As Double
 fp3d3 = 6
End Function
'4-deriv.
Public Function fp3d4(ByVal arg As Double) As Double
 fp3d4 = 0
End Function


'readmxd(mx:arrayd; i,j: integer):dbl = mx[(i-1)*mx[1]+j+1];
Public Function readmxd(ByVal adrM As Long, ByVal argi As Long, ByVal argj As Long) As Double
 Dim rd As Double
 Dim r1 As Double
 
 
  Call flGetArrayValueD(VarPtr(adrM), 1, r1)
  Call flGetArrayValueD(VarPtr(adrM), (argi - 1) * r1 + argj + 1, rd) 'transfer address of address !!!
  
  'GetMem8 (adrM + 8 * 1), r1   '8-size of double
  'GetMem8 (adrM + 8 * ((argi - 1) * (r1) + argj + 1)), rd  '8-size of double
  
  
    
  readmxd = rd
End Function

'writemxd(mx:arrayd; i,j: integer; val:double):none= mx[(i-1)*mx[1]+j+1]=val
Public Sub writemxd(ByVal adrM As Long, ByVal argi As Long, ByVal argj As Long, ByVal val As Double)
 Dim rd As Double
 Dim r1 As Double
 
 
  Call flGetArrayValueD(VarPtr(adrM), 1, r1)
  Call flSetArrayValueD(VarPtr(adrM), (argi - 1) * r1 + argj + 1, val)
  
   
  'GetMem8 (adrM + 8 * 1), r1   '8-size of double
  'PutMem8 (adrM + 8 * ((argi - 1) * r1 + argj + 1)), val   '8-size of double
  
    
End Sub


'rmx=mx1+mx2
'summxd(mx1,mx2,rmx: arrayd):none=  st:integer=mx1[0]; cl:integer=mx1[1]; i:int=0; j:int=0; indx:int=0; for(i,1,st,for(j,1,cl,indx=(i-1)*cl+j+1; rmx[indx]=mx2[indx]+mx1[indx]))

Public Sub summxd(ByVal adrM1 As Long, ByVal adrM2 As Long, ByVal adrMR As Long)
 Dim r1 As Double
 Dim r2 As Double
 Dim st As Double
 Dim cl As Double
 Dim i As Long
 Dim j As Long
 Dim indx As Long
 
 'dimensions of matrix is equal !
 
 Call flGetArrayValueD(VarPtr(adrM1), 0, st)
 Call flGetArrayValueD(VarPtr(adrM1), 1, cl)
 
 
 For i = 1 To st
    For j = 1 To cl
      indx = (i - 1) * cl + j + 1
      
      Call flGetArrayValueD(VarPtr(adrM1), indx, r1)
      Call flGetArrayValueD(VarPtr(adrM2), indx, r2)
      Call flSetArrayValueD(VarPtr(adrMR), indx, r1 + r2)
    Next
 Next
    
End Sub


Sub InitInt()
    
'Gausse on 15 nodes:

    an(1) = 3.07532419961173E-02
    an(2) = 7.03660474881081E-02
    an(3) = 0.107159220467172
    an(4) = 0.139570677926154
    an(5) = 0.166269205816994
    an(6) = 0.186161000015562
    an(7) = 0.198431485327112
    an(8) = 0.202578241925561
    an(9) = an(7)
    an(10) = an(6)
    an(11) = an(5)
    an(12) = an(4)
    an(13) = an(3)
    an(14) = an(2)
    an(15) = an(1)
    bn(1) = 0.987992518020485
    bn(2) = 0.937273392400706
    bn(3) = 0.848206583410427
    bn(4) = 0.72441773136017
    bn(5) = 0.570972172608539
    bn(6) = 0.394151347077563
    bn(7) = 0.201194093997435
    bn(8) = 0
    bn(9) = -bn(7)
    bn(10) = -bn(6)
    bn(11) = -bn(5)
    bn(12) = -bn(4)
    bn(13) = -bn(3)
    bn(14) = -bn(2)
    bn(15) = -bn(1)
    
    P_Integral = 10 'partition on each integral: 1...2^31
    N_Integral = 15

End Sub


Function Integral3FF(ByVal Func As Long, ByVal PV1 As Long, ByVal PV2 As Long, ByVal PV3 As Long, ByVal a As Double, ByVal b As Double, ByVal Func1 As Long, ByVal Func2 As Long, ByVal Func3 As Long, ByVal Func4 As Long) As Double

Dim r, j1, i1, j2, i2, j3, i3, n1, n2, n3 As Long
Dim Int1, Int2, int3, HV1, HV2, HV3, h1, h2, h3, x1, x2, c, d, e, f, h As Double
Dim ax1, ax2, ax3, sx1, sx2, sx3 As Double



int3 = 0


n1 = Abs(P_Integral)
If n1 = 0 Then n1 = 1
n2 = Abs(P_Integral)
If n2 = 0 Then n2 = 1
n3 = Abs(P_Integral)
If n3 = 0 Then n3 = 1
h3 = (b - a) / n3

For j3 = 0 To n3 - 1

 x1 = a + j3 * h3
 x2 = a + (j3 + 1) * h3
 ax3 = (x1 + x2) * 0.5
 sx3 = (x2 - x1) * 0.5
 
  For i3 = 1 To N_Integral
     
   
   PutMem8 PV1, sx3 * bn(i3) + ax3 'more fast than
   'Call flSetVarValueD(PV1, sx3 * bn(i3) + ax3)
    
   Int2 = 0
   d = flResultF(Func2)
   c = flResultF(Func1)
   h2 = (d - c) / n2
   
   For j2 = 0 To n2 - 1
 
    x1 = c + j2 * h2
    x2 = c + (j2 + 1) * h2
    ax2 = (x1 + x2) * 0.5
    sx2 = (x2 - x1) * 0.5
    
    For i2 = 1 To N_Integral
    
       
     PutMem8 PV2, sx2 * bn(i2) + ax2 'more fast than
     'Call flSetVarValueD(PV2, sx2 * bn(i2) + ax2)

     Int1 = 0
     f = flResultF(Func4)
     e = flResultF(Func3)
     h1 = (f - e) / n1
  
     For j1 = 0 To n1 - 1
  
       x1 = e + j1 * h1
       x2 = e + (j1 + 1) * h1
       ax1 = (x1 + x2) * 0.5
       sx1 = (x2 - x1) * 0.5
  
       For i1 = 1 To N_Integral
        
        
        PutMem8 PV3, sx1 * bn(i1) + ax1 'more fast than
        'Call flSetVarValueD(PV3, sx1 * bn(i1) + ax1)
        
        Int1 = Int1 + an(i1) * flResultF(Func) * sx1
       Next i1
   
     Next j1

     Int2 = Int2 + an(i2) * Int1 * sx2
 
    Next i2
   Next j2

  int3 = int3 + an(i3) * Int2 * sx3
  Next i3
Next j3


Integral3FF = int3

End Function








