
#include  "FBforevalZdll.bas"
Declare Sub CopyMem Lib "kernel32" Alias "RtlMoveMemory" (ByVal Dst As Long, ByVal Src As Long, ByVal Length As Long)



Type TExtArg4
     TypeArg1 As Long
     TypeArg2 As Long
     TypeArg3 As Long
     TypeArg4 As Long
End Type

Type TFuncExt4
      Expr   As String
      Addr   As Long
      res    As TComplex
      z1     As TComplex
      z2     As TComplex
      x      As Double
      n      As Long
End Type

 


Public Function sp1(ByVal arg As Double) As Double
 sp1 = arg * arg
End Function


Public Function sp2(ByVal arg1 As Double, ByVal Arg2 As Double) As Double
 sp2 = arg1 - Arg2
End Function


Public Function sp3(ByVal arg1 As Double, ByVal Arg2 As Double, ByVal arg3 As Double) As Double
 sp3 = arg1 + Arg2 - arg3
End Function


'pc1(z: complex double):complex=z*z
Public Sub ps1z(ByRef arg As TComplex) 'as TComplex
 Dim rez As TComplex
 
 rez.re = arg.re * arg.re - arg.im * arg.im
 rez.im = 2 * arg.re * arg.im
  'fzLoadFPUDP(rez)
  'fzLoadFPUD(rez.re, rez.im)
  Asm
   fld qword Ptr [rez+8]
  	fld qword Ptr [rez]
  End Asm
End Sub


'pc2(z1,z2: complex double):complex=z1-z2
Public Sub ps2z(ByRef z1 As TComplex, ByRef z2 As TComplex) 'as TComplex
 Dim rez As TComplex
 
 rez.re = z1.re - z2.re
 rez.im = z1.im - z2.im

  'fzLoadFPUDP(rez)
 ' fzLoadFPUD(rez.Re, rez.Im)
  Asm
  	fld qword Ptr [rez+8]
  	fld qword Ptr [rez]
  End Asm
End Sub


'pc2(x,y:  double)=x-y
Public Function ps2r(ByRef x As Double, ByRef y As Double) As Double
 ps2r = x - y
End Function


'pc2(x:  double; z: complex double):complex=x-z
Public Sub ps2rz(ByRef x As Double, ByRef z As TComplex) 'as TComplex
 Dim rez As TComplex
 
 rez.re = x - z.re
 rez.im = -z.im
 
  'fzLoadFPUDP(rez)
  'fzLoadFPUD(rez.Re, rez.Im)
  Asm
  	fld qword Ptr [rez+8]
 	fld qword Ptr [rez]
  End Asm
End Sub


'pc2(z: complex double; x:  double):complex=z-x
Public Sub ps2zr(ByRef z As TComplex, ByRef x As Double) 'as TComplex
 Dim rez As TComplex
 
 rez.re = z.re - x
 rez.im = z.im
 
 'fzLoadFPUDP(rez)
  'fzLoadFPUD(rez.Re, rez.Im)
   Asm
     fld qword Ptr [rez+8]
  	  fld qword Ptr [rez]
   End Asm
End Sub



'pc1(x:  double):complex=x^2
Public Function ps1(ByRef arg As Double) As Double
 ps1 = arg * arg
End Function


'pc2(x,y:  double)=x-y
Public Function ps2(ByRef arg1 As Double, ByRef Arg2 As Double) As Double
 ps2 = arg1 - Arg2
End Function


Public Function ps3(ByRef arg1 As Double, ByRef Arg2 As Double, ByRef arg3 As Double) As Double
 ps3 = arg1 + Arg2 - arg3
End Function


'fvd4(vd,n,z1,x)
'pvd4(vd:array double; n:integer; z: complex double; x:double ):complex=vd[n]+x+z
Public Sub fvd4(ByRef adrV As Long, ByRef argi As Long, ByRef ArgZ As TComplex, ByRef argr As Double) 'as TComplex
 Dim rd As Double
 Dim lenV As Long
 Dim rez As TComplex
 
  fzGetArrayValueD(VarPtr(adrV), argi, rd)   'transfer address of address !!!
       'fzGet(fz_ARRAY_LENGTH, VarPtr(adrV), lenV)
  rez.re = argr + ArgZ.re + rd
  rez.im = ArgZ.im
  'fzLoadFPUDP(rez)
   Asm
  	 fld qword Ptr [rez+8]
  	 fld qword Ptr [rez]
   End Asm
End Sub


'pvd3(vd:array double; n:integer; x:double)=vd[n]*x
Public Function fvd3(ByVal adrV As Long, ByVal argi As Long, ByVal argf As Double) As Double
 Dim rd As Double
 Dim lenV As Long
 
  'fzGetArrayValueD(@adrV, argi, rd)   'transfer address of address !!!
  rd=Peek(Double,adrV+argi*8) '8-size of double
  
  'fzGet(fz_ARRAY_LENGTH, VarPtr(adrV), lenV)
  fvd3 = rd * argf
End Function






'ms1z(argz: TComplex)=argz^2
Public Sub ms1z(ByVal Addr As Long) 'as TComplex
 Dim rez As TComplex
 Dim arg As TComplex
  
  
 'Addr    ->   AddrOf(z.re)
 'Addr+16 ->   AddrOf(z.im)
 
  
   
   'arg.re=Peek(Double,Addr)
   'arg.im=Peek(Double,Addr+16)
   
   fzGetVarValueD(Addr, arg.re)
   fzGetVarValueD(Addr + 16, arg.im)
   
   
  rez.re = arg.re * arg.re - arg.im * arg.im
  rez.im = 2 * arg.re * arg.im
 
 
  fzLoadFPUDP(rez)
  'fzLoadFPUD(rez.re, rez.im)
  
End Sub


'ms1r(argr: double)=argr^2
Public Function ms1r(ByVal Addr As Long) As Double
Dim r As Double

 'Addr    ->   AddrOf(argr)
  
   'r=Peek(Double,Addr)
   fzGetVarValueD(Addr, r)
   

  ms1r = r * r

End Function


'ms2r(x,y: double)=x-y
Public Function ms2r(ByVal Addr As Long) As Double
Dim r1 As Double
Dim r2 As Double
'Dim argz As TComplex


 'Addr    ->   AddrOf(r1)
 'Addr+16 ->   AddrOf(r2)
  
   
   'r1=Peek(Double,Addr)
   'r2=Peek(Double,Addr+16)
   
   fzGetVarValueD(Addr, r1)
   fzGetVarValueD(Addr + 16, r2)
     
   
  ms2r = r1 - r2
End Function


'ms2z(z1,z2: TComplex)=z1-z2
Public Sub ms2z(ByVal Addr As Long) 'as TComplex
 Dim z1 As TComplex
 Dim z2 As TComplex
 Dim rez As TComplex
  
  
 'Addr    ->   AddrOf(z1.re)
 'Addr+16 ->   AddrOf(z1.im)
 'Addr+32 ->   AddrOf(z2.re)
 'Addr+48 ->   AddrOf(z2.im)
 
   
   'z1.re=Peek(Double,Addr)
   'z1.im=Peek(Double,Addr+16)
   'z2.re=Peek(Double,Addr+32)
   'z2.im=Peek(Double,Addr+48)
   
   fzGetVarValueD(Addr, z1.re)
   fzGetVarValueD(Addr + 16, z1.im)
   fzGetVarValueD(Addr + 32, z2.re)
   fzGetVarValueD(Addr + 48, z2.im)
   
   
   rez.re = z1.re - z2.re
   rez.im = z1.im - z2.im
 
 
  fzLoadFPUDP(rez)
  'fzLoadFPUD(rez.re, rez.im)
  
End Sub


'ms2rz(r1: double; z2: TComplex)=r1-z2
Public Sub ms2rz(ByVal Addr As Long) 'as TComplex
 Dim r1 As Double
 Dim z2 As TComplex
 Dim rez As TComplex
  
  
 'Addr    ->   AddrOf(r1)
 'Addr+16 ->   AddrOf(z2.re)
 'Addr+32 ->   AddrOf(z2.im)
  
   
   
   fzGetVarValueD(Addr, r1)
   fzGetVarValueD(Addr + 16, z2.re)
   fzGetVarValueD(Addr + 32, z2.im)
   
   rez.re = r1 - z2.re
   rez.im = -z2.im
 
 
  fzLoadFPUDP(rez)
  'fzLoadFPUD(rez.re, rez.im)
  
End Sub

'ms2zr( z1: TComplex; r2: double)=z1-r2
Public Sub ms2zr(ByVal Addr As Long) 'as TComplex
 Dim r2 As Double
 Dim z1 As TComplex
 Dim rez As TComplex
  
  
 'Addr    ->   AddrOf(z1.re)
 'Addr+16 ->   AddrOf(z1.im)
 'Addr+32 ->   AddrOf(r2)
  
   
   fzGetVarValueD(Addr, z1.re)
   fzGetVarValueD(Addr + 16, z1.im)
   fzGetVarValueD(Addr + 32, r2)
  
   rez.re = z1.re - r2
   rez.im = z1.im
 
 
  fzLoadFPUDP(rez)
  'fzLoadFPUD(rez.re, rez.im)
  
End Sub


'msd4(vd:array double; n:integer; z: complex double; x:double ):complex=vd[n]+x+z
Public Sub msd4(ByVal Addr As Long) 'as TComplex
 Dim rd As Double
 Dim argr As Double
 Dim lenV As Long
 Dim argi As Long
 Dim rez As TComplex
 Dim argz As TComplex
 
 'Addr    ->   AddrOf(vd)
 'Addr+16 ->   AddrOf(n)
 'Addr+32 ->   AddrOf(z.re)
 'Addr+48 ->   AddrOf(z.im)
 'Addr+64 ->   AddrOf(x)
 
 
    'argi=Peek(Integer,Addr+16)
    'rd=Peek(Double,Addr+argi*8)
    'argz.re=Peek(Double,Addr+32)
    'argz.im=Peek(Double,Addr+64)
    'argr=Peek(Double,Addr+32)
   
   fzGetVarValueI(Addr + 16, argi)
   fzGetArrayValueD(Addr, argi, rd)
   'fzGet(fz_ARRAY_LENGTH, Addr, lenV)
   fzGetVarValueD(Addr + 32, argz.re)
   fzGetVarValueD(Addr + 48, argz.im)
   fzGetVarValueD(Addr + 64, argr)
   
 
   
   rez.re = argr + argz.re + rd
   rez.im = argz.im
 
 
  fzLoadFPUDP(rez)
  'fzLoadFPUD(rez.re, rez.im)
  
End Sub


Public Function InfSum(ByVal AdrL As Long, ByVal LenL As Long) As Double
 Dim i As Long
 Dim S As Double
 Dim VArg As Double
 Dim Vaddr As Long
 
 S = 0
 
 For i = 1 To LenL
  Vaddr = AdrL + 16 * (i - 1)      'calc. addr. of current arg.
  'fzGetVarValueD(Vaddr, VArg) 'get arg. on addr.
  VArg=Peek(Double,Vaddr) 
  S = S + VArg
 Next

 InfSum = S
End Function


Public Sub InfSumZ(ByVal AdrL As Long, ByVal LenL As Long) 'as TComplex
 Dim i As Long
 Dim S As Double
 Dim VArg As Double
 Dim Vaddr As Long
 Dim ReAddr As Long
 Dim ImAddr As Long
 Dim rez As TComplex
 Dim re As Double
 Dim im As Double
 
 rez.re = 0
 rez.im = 0
 
 For i = 0 To LenL - 1
   ReAddr = AdrL + 32 * i      'calc. addr. of current arg.
   ImAddr = ReAddr + 16
 
   fzGetVarValueD(ReAddr, re)
   fzGetVarValueD(ImAddr, im)
  
   rez.re = rez.re + re
   rez.im = rez.im + im
 Next

 'fzLoadFPUDP(rez)
  Asm
   fld qword Ptr [rez+8]
  	fld qword Ptr [rez]
  End Asm
End Sub



'copyV(VS,VD): VS->VD; only array of double type !!!
Public Sub CopyV(ByVal adrVS As Long, ByVal adrVD As Long)
 Dim rd As Double
 Dim lenV As Long
 Dim lenVS As Long
 Dim lenVD As Long
 Dim i As Long
 Dim adrVD0 As Long
 Dim adrVS0 As Long  
  
  'copy(vd,vd1); 1
  'copy(svdy,vd); 1
  'copy(vd,svdy); 1
  
  
  
  
  
  '************* 1 - slow way ***********
  'flGet(fl_ARRAY_LENGTH, VarPtr(adrVS), lenVS)
  'flGet(fl_ARRAY_LENGTH, VarPtr(adrVD), lenVD)
  
  'If lenVS < lenVD Then lenV = lenVS Else lenV = lenVD
  
  'For i = 0 To lenV - 1
    'flGetArrayValueD(VarPtr(adrVS), i, rd) 'transfer address of address !!!
    'flSetArrayValueD(VarPtr(adrVD), i, rd) 'transfer address of address !!!
  'Next
  
  '*************************************
  
  
  
  '************* 2 - much fast ***********
  
   'If adrVD <> 0 Then 
    	'adrVD0=Peek(Integer,VarPtr(adrVD)) 'adrVD0=@vd[0] ;transfer address of address !!!
    	'LenVD=Peek(Integer,adrVD0-4)       '+1 if Foreval compiled in FPC !!!!!!
    	'LenVD=LenVD+1                      'if Foreval compiled in FPC !!!!!!
    'Else
    	'LenVD=0
   'EndIf
   
   'If adrVS <> 0 Then 
      'adrVS0=Peek(Integer,VarPtr(adrVS)) 'adrVD0=@vd[0] ;transfer address of address !!!
      'LenVS=Peek(Integer,adrVS0-4)       '+1 if Foreval compiled in FPC !!!!!!
      'LenVS=LenVS+1                      'if Foreval compiled in FPC !!!!!!
    'Else
    	'LenVS=0
   'EndIf
  
   'If lenVS < lenVD Then lenV = lenVS Else lenV = lenVD
         
    
   'CopyMem adrVD0, adrVS0, lenV * 8   '8-sizeOf(double)
  
 '*************************************
 
 
 
 '************* 3 - most fast ***********
 Asm
 	push eax 
 	push ecx
 	push esi
 	push edi
 	
   
 	cld
   mov esi, dword Ptr [adrVS]  
   cmp esi, 0    
   jz  @@endp1
   mov edi, dword Ptr [adrVD]  
   cmp edi, 0    
   jz  @@endp1
   mov ecx, dword Ptr [edi-4]  'LenVD->ecx  'ecx+1 if Foreval compiled in FPC !!!!!!
   mov eax, dword Ptr [esi-4]  'LenVS->eax  'eax+1 if Foreval compiled in FPC !!!!!!
   cmp ecx,eax
   jl @@ckl1
   mov ecx,eax   'ecx=min(lenVD,lenVS)
   @@ckl1:
   lea ecx, [ecx*2]    '64(double)=32*2
 	rep movsd
   
   @@endp1:
 	pop  edi
 	pop  esi
 	pop  ecx
 	pop  eax
 End Asm
 '*************************************
  
End Sub





'FillArray(VD): VD[all]=x
Public Sub FillArray(ByVal adrVD As Long, ByVal x As Double)

 Dim lenV As Long
 Dim adrVD0 As Long
 Dim i As Long
 
  'FillArray(vd,t); 1
  
'******************* 1 - slow way ******************************  
  'flGet(fl_ARRAY_LENGTH, VarPtr(adrVD), lenV)
  'For i = 0 To lenV - 1
   'flSetArrayValueD(VarPtr(adrVD), i, x)
  'Next
'****************************************************************    
  
    
'*********************2 - much fast ******************************   
    'If adrVD <> 0 Then 
    	'adrVD0=Peek(Integer,VarPtr(adrVD)) 'adrVD0=@vd[0] ;transfer address of address !!!
    	'LenV=Peek(Integer,adrVD0-4) 
    	' 'LenV=LenV+1             'if Foreval compiled in FPC !!!!!!
    'Else
    	'Lenv=0
    'EndIf
  
   
    'For i = 0 To lenV - 1
     'Poke Double, (adrVD0 + i * 8), x  '8-sizeOf(double)
    'Next
'***************************************************************  


'******************3 - most fast *******************************    

  Asm
 	push eax 
 	push ecx
 	push edx
 	
 	
   mov eax, dword Ptr [adrVD]
   cmp eax, 0    
   jz  @@endp
   
   mov edx, dword Ptr [eax-4] 'Len 
   'add edx,1               // <- edx+1 if Foreval compiled in FPC !!!!!!
   fld qword Ptr [x]
   Xor ecx, ecx
         
   @@ckl:
   fst qword Ptr [eax+8*ecx]
   inc ecx
   cmp ecx, edx
   jnz @@ckl
   
   fstp st(0)
   
   @@endp:
   pop  edx 	
 	pop  ecx
 	pop  eax
 	
  End Asm
  
'*************************************************************************    

End Sub









