
/**
                      For full examples see Builder
**/

/**
           Very stupid inline assembler. If you can, rewrite asm. insertion in procedures self (more higher speed). My excuse.
**/


#pragma once
#include "ForevalZdll.h"
#include "Types.h"


TFloatType  _cdecl SP1(TFloatType x1)
{
 return  x1*x1;
};


TFloatType  _stdcall SP2(TFloatType x1, TFloatType x2)
{
 return  x1-x2;
};


TFloatType _cdecl SP3(TFloatType x1, TFloatType x2, TFloatType x3)
{
 return  x1+x2-x3;
};



void  _cdecl SP1Z(TComplexF z1)
{
TFloatType re,im;
TComplex rez;

 rez.re=z1.re*z1.re-z1.im*z1.im;
 rez.im=2*z1.re*z1.im;
 /*
 _asm
 {
   //fld qword ptr [rez+8]
   //fld qword ptr [rez]
	 fld qword ptr [rez.im]
     fld qword ptr [rez.re]
 }
 */

#ifdef   EXTENDED_VAR
  fzLoadFPUEP(&rez);
 //fzLoadFPUE(rez.re,rez.im);
#else
  fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif

}



void  _cdecl SP2Z(TComplexF z1,TComplexF z2)
{
TFloatType re,im;
TComplex rez;

 rez.re=z1.re-z2.re;
 rez.im=z1.im-z2.im;
/*
 _asm
 {
  fld qword ptr [rez.im]
  fld qword ptr [rez.re]
 }
*/

#ifdef   EXTENDED_VAR
  fzLoadFPUEP(&rez);
 //fzLoadFPUE(rez.re,rez.im);
#else
  fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}




void  _stdcall SP3Z(TComplexF z1, TComplexF z2, TComplexF z3)
{
TFloatType re,im;
TComplex rez;

 rez.re=z1.re+z2.re-z3.re;
 rez.im=z1.im+z2.im-z3.im;

/*
 _asm
 {
  fld qword ptr [rez.im]
  fld qword ptr [rez.re]
 }
*/

#ifdef   EXTENDED_VAR
  fzLoadFPUEP(&rez);
 //fzLoadFPUE(rez.re,rez.im);
#else
  fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif

}





void  _cdecl SP2ZR(TComplexF z1, TFloatType x)
{
//double re,im;
TComplex rez;

 rez.re=z1.re-x;
 rez.im=z1.im;

/*
 _asm
 {
  fld qword ptr [rez.im]
  fld qword ptr [rez.re]
 }
 */

#ifdef   EXTENDED_VAR
  fzLoadFPUEP(&rez);
 //fzLoadFPUE(rez.re,rez.im);
#else
  fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif

}



void  _cdecl SP2RZ(TFloatType x, TComplexF z2)
{
TFloatType re,im;
TComplex rez;

 rez.re=x-z2.re;
 rez.im=-z2.im;
/*
 _asm
 {
  fld qword ptr [rez.im]
  fld qword ptr [rez.re]
 }
*/

#ifdef   EXTENDED_VAR
  fzLoadFPUEP(&rez);
 //fzLoadFPUE(rez.re,rez.im);
#else
  fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif

}






TFloatType  _cdecl PS1(TFloatType *x1)
{
 return  (*x1)*(*x1);
}


TFloatType  _cdecl PS2(TFloatType *x1,TFloatType *x2)
{
 return  (*x1)-(*x2);
}


TFloatType _stdcall PS3(TFloatType *x1, TFloatType *x2, TFloatType *x3)
{
 return  (*x1)+(*x2)-(*x3);
}




void  _cdecl PS1Z(TComplex *z1)
{
TFloatType re,im;
TComplex rez;

 rez.re=(*z1).re*(*z1).re-(*z1).im*(*z1).im;
 rez.im=2*(*z1).re*(*z1).im;
/*
 _asm
 {
  fld qword ptr [rez.im]
  fld qword ptr [rez.re]
 }

*/

#ifdef   EXTENDED_VAR
  fzLoadFPUEP(&rez);
 //fzLoadFPUE(rez.re,rez.im);
#else
  fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}



void  _cdecl PS2Z(TComplex *z1,TComplex *z2)
{
TFloatType re,im;
TComplex rez;

 rez.re=(*z1).re-(*z2).re;
 rez.im=(*z1).im-(*z2).im;
/*
_asm
 {
  fld qword ptr [rez.im]
  fld qword ptr [rez.re]
 }
*/

#ifdef   EXTENDED_VAR
  fzLoadFPUEP(&rez);
 //fzLoadFPUE(rez.re,rez.im);
#else
  fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif

}



void  _stdcall PS3Z(TComplex *z1, TComplex *z2, TComplex *z3)
{
double re,im;
TComplex rez;

 rez.re=(*z1).re+(*z2).re-(*z3).re;
 rez.im=(*z1).im+(*z2).im-(*z3).im;
/*
 _asm
 {
  fld qword ptr [rez.im]
  fld qword ptr [rez.re]
 }
*/

#ifdef   EXTENDED_VAR
  fzLoadFPUEP(&rez);
 //fzLoadFPUE(rez.re,rez.im);
#else
  fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}


void  _cdecl PS2ZR(TComplex *z1, TFloatType *x)
{
TFloatType re,im;
TComplex rez;

 rez.re=(*z1).re-(*x);
 rez.im=(*z1).im;
/*
_asm
 {
  fld qword ptr [rez.im]
  fld qword ptr [rez.re]
 }
*/

#ifdef   EXTENDED_VAR
  fzLoadFPUEP(&rez);
 //fzLoadFPUE(rez.re,rez.im);
#else
  fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif

}



void  _cdecl PS2RZ(TFloatType *x,TComplex *z2)
{
TFloatType re,im;
TComplex rez;

 rez.re=(*x)-(*z2).re;
 rez.im=-(*z2).im;
/*
 _asm
 {
  fld qword ptr [rez.im]
  fld qword ptr [rez.re]
 }
*/

#ifdef   EXTENDED_VAR
  fzLoadFPUEP(&rez);
 //fzLoadFPUE(rez.re,rez.im);
#else
  fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif

}





double  _cdecl MS1(_int32 addr)
{
 return  (*PFloatType(addr))*(*PFloatType(addr));
}



double  _cdecl MS2(_int32 addr)
{
 return  (*PFloatType(addr))-(*PFloatType(addr+16));
}



double  _cdecl MS3(_int32 addr)
{
 return  (*PFloatType(addr))+(*PFloatType(addr+16))-(*PFloatType(addr+32));
}





void  _cdecl MS1Z(_int32 addr)
{
double re,im;
TComplex rez;

/*
#ifdef   EXTENDED_VAR
  rez.re=(*PExtended(addr))*(*PExtended(addr))-(*PExtended(addr+16))*(*PExtended(addr+16));
  rez.im=2*(*PExtended(addr))*(*PExtended(addr+16));
#else
  rez.re=(*PDouble(addr))*(*PDouble(addr))-(*PDouble(addr+16))*(*PDouble(addr+16));
  rez.im=2*(*PDouble(addr))*(*PDouble(addr+16));
#endif
*/

  rez.re=(*PFloatType(addr))*(*PFloatType(addr))-(*PFloatType(addr+16))*(*PFloatType(addr+16));
  rez.im=2*(*PFloatType(addr))*(*PFloatType(addr+16));

 /*
_asm
 {
  fld qword ptr [rez.im]
  fld qword ptr [rez.re]
 }
*/

#ifdef   EXTENDED_VAR
  fzLoadFPUEP(&rez);
 //fzLoadFPUE(rez.re,rez.im);
#else
  fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}



void  _cdecl MS2Z(_int32 addr)
{
double re,im;
TComplex rez;

/*
#ifdef   EXTENDED_VAR
   rez.re=(*PExtended(addr))-(*PExtended(addr+32));
   rez.im=(*PExtended(addr+16))-(*PExtended(addr+48));
#else
   rez.re=(*PDouble(addr))-(*PDouble(addr+32));
   rez.im=(*PDouble(addr+16))-(*PDouble(addr+48));
#endif
*/

rez.re=(*PFloatType(addr))-(*PFloatType(addr+32));
rez.im=(*PFloatType(addr+16))-(*PFloatType(addr+48));



/*
_asm
 {
  fld qword ptr [rez.im]
  fld qword ptr [rez.re]
 }
*/

#ifdef   EXTENDED_VAR
  fzLoadFPUEP(&rez);
 //fzLoadFPUE(rez.re,rez.im);
#else
  fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}


void  _cdecl MS3Z(_int32 addr)
{
double re,im;
TComplex rez;

/*
#ifdef   EXTENDED_VAR
  rez.re=(*PExtended(addr))+(*PExtended(addr+32))-(*PExtended(addr+64));
  rez.im=(*PExtended(addr+16))+(*PExtended(addr+48))-(*PExtended(addr+80));
#else
  rez.re=(*PDouble(addr))+(*PDouble(addr+32))-(*PDouble(addr+64));
  rez.im=(*PDouble(addr+16))+(*PDouble(addr+48))-(*PDouble(addr+80));
#endif
*/

rez.re=(*PFloatType(addr))+(*PFloatType(addr+32))-(*PFloatType(addr+64));
rez.im=(*PFloatType(addr+16))+(*PFloatType(addr+48))-(*PFloatType(addr+80));



/*
_asm
 {
  fld qword ptr [rez.im]
  fld qword ptr [rez.re]
 }
*/

#ifdef   EXTENDED_VAR
  fzLoadFPUEP(&rez);
 //fzLoadFPUE(rez.re,rez.im);
#else
  fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}



void  _cdecl MS2ZR(_int32 addr)
{
double re,im;
TComplex rez;

/*
#ifdef   EXTENDED_VAR
   rez.re=(*PExtended(addr))-(*PExtended(addr+32));
   rez.im=(*PExtended(addr+16));
#else
   rez.re=(*PDouble(addr))-(*PDouble(addr+32));
   rez.im=(*PDouble(addr+16));
#endif
*/

rez.re=(*PFloatType(addr))-(*PFloatType(addr+32));
rez.im=(*PFloatType(addr+16));


/*
_asm
 {
  fld qword ptr [rez.im]
  fld qword ptr [rez.re]
 }
*/

#ifdef   EXTENDED_VAR
  fzLoadFPUEP(&rez);
 //fzLoadFPUE(rez.re,rez.im);
#else
  fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}



void  _cdecl MS2RZ(_int32 addr)
{
double re,im;
TComplex rez;

/*
#ifdef   EXTENDED_VAR
   rez.re=(*PExtended(addr))-(*PExtended(addr+16));
   rez.im=-(*PExtended(addr+32));
#else
   rez.re=(*PDouble(addr))-(*PDouble(addr+16));
   rez.im=-(*PDouble(addr+32));
#endif
*/

rez.re=(*PFloatType(addr))-(*PFloatType(addr+16));
rez.im=-(*PFloatType(addr+32));


/*
_asm
 {
  fld qword ptr [rez.im]
  fld qword ptr [rez.re]
 }
*/

#ifdef   EXTENDED_VAR
  fzLoadFPUEP(&rez);
 //fzLoadFPUE(rez.re,rez.im);
#else
  fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}







//infsum(z1,z2,z3,z3-z2,z2-z1,z1*z2)
void _cdecl sumz(__int32 addr, __int32 len)
{
 __int32 N,ni;
 TComplexE Sz;
 Extended re,im;


  Sz.re=0; Sz.im=0;
  //re=0; im=0;
  for (ni = 0; ni <= len-1; ni++)
  {
   Sz.re=Sz.re+(*PExtended(addr+32*ni));
   Sz.im=Sz.im+(*PExtended(addr+32*ni+16));
   }


 /*
 _asm
 {
  fld qword ptr [Sz.im]
  fld qword ptr [Sz.re]
 }
 */

fzLoadFPUEP(&Sz);
}



//infsum(x,y,t,x-y-infsum(x,y,t,x*y),t*x)
Extended _cdecl sumr(__int32 addr, __int32 len)
{
 __int32 N,ni;
 Extended S;

  S=0;
  for (ni = 0; ni <= len-1; ni++)
  {
   S=S+(*PExtended(addr+16*ni));
  }

 return S;
}

//spall(ve,n+3,z1,vd,j+k,x,z2+z3,t-y,vi,n+k+j)


void _cdecl SPALL(__int32 vx, __int32 nx, TComplexE zx, __int32 vd, __int32 nd, double d, TComplexD zd, Extended x, __int32 vi, __int32 ni)
//void _cdecl spall(Pointer32 vx, __int32 nx, TComplexE zx, Pointer32 vd, __int32 nd, double d, TComplexD zd, Extended x, Pointer32 vi, __int32 ni)
{
//rez=(vx[nd]*d*zd - vd[nx]*x*zx)*vi[ni]
//spall(ve,n,z1,vd,k,y,z2,x,vi,j) = (ve[k]*y*z2 - vd[n]*x*z1)*vi[j]
/*
  vd: array of double;
  vx: array of Extended;
  vi: array of integer;
  d: double;
  x: Extended;
  nd,nx,ni: integer;
  zd: TComplexD;
  zx: TComplexE;
*/
 TComplex rez;
 //spall(ve,n+3,z1,vd,j+k,x,z2+z3,t-y,vi,n+k+j)


 Extended fvx;
 double  fvd;
 __int32  fvi,adr1;


 fvx=*PExtended(vx+nx*10);  //vx[nx]
 fvd=*PDouble(vd+nd*8);  //vd[nd]
 fvi=*PInteger(vi+ni*4); //vi[ni]

 rez.re=(fvd*d*zd.re-fvx*x*zx.re)*fvi;
 rez.im=(fvd*d*zd.im-fvx*x*zx.im)*fvi;


 /*
 _asm
 {
  fld qword ptr [rez.im]
  fld qword ptr [rez.re]
 }
*/

#ifdef   EXTENDED_VAR
  fzLoadFPUEP(&rez);
 //fzLoadFPUE(rez.re,rez.im);
#else
  fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}




void _cdecl PSALL(__int32 *vx, __int32 *nx, TComplexE *zx, __int32 *vd, __int32 *nd, double *d, TComplexD *zd, Extended *x, __int32 *vi, __int32 *ni)
{
//rez=(vx[nd]*d*zd - vd[nx]*x*zx)*vi[ni]
//spall(ve,n,z1,vd,k,y,z2,x,vi,j) = (ve[k]*y*z2 - vd[n]*x*z1)*vi[j]
/*
  vd: array of double;
  vx: array of Extended;
  vi: array of integer;
  d: double;
  x: Extended;
  nd,nx,ni: integer;
  zd: TComplexD;
  zx: TComplexE;
*/
 TComplex rez;
 //spall(ve,n+3,z1,vd,j+k,x,z2+z3,t-y,vi,n+k+j)


 Extended fvx;
 double   fvd;
 __int32  fni,fnd,fnx,fvi;


 fvx=*PExtended((*vx)+(*nx)*10);  //vx[nx]
 fvd=*PDouble((*vd)+(*nd)*8);     //vd[nd]
 fvi=*PInteger((*vi)+(*ni)*4);    //vi[ni]

 rez.re=(fvd*(*d)*(*zd).re-fvx*(*x)*(*zx).re)*fvi;
 rez.im=(fvd*(*d)*(*zd).im-fvx*(*x)*(*zx).im)*fvi;




 /*
 _asm
 {
  fld qword ptr [rez.im]
  fld qword ptr [rez.re]
 }
*/

#ifdef   EXTENDED_VAR
  fzLoadFPUEP(&rez);
 //fzLoadFPUE(rez.re,rez.im);
#else
  fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}



//msall(ve,n+3,z1,vd,j+k,x,z2+z3,t-y,vi,n+k+j)
void _cdecl MSALL(__int32 addr)
{
  //msall(vx,nx,zd,vd2,nd,d,zx,x,vi,ni) = (vx[nd]*d*zd - vd2[nx]*x*zx)*vi[ni]
 TComplex rez;

 double vd,d;
 Extended vx,x;
 INT32 nx,nd,ni,vi;
 TComplexD zd;
 TComplexE zx;

 /*
  vd: array of double;
  vx: array of Extended;
  vi: array of integer;
  d: double;
  x: Extended;
  nd,nx,ni: integer;
  zd: TComplexD;
  zx: TComplexE;
*/


/*
   nx = *PInteger(addr+16);
  //vx[nx] = (*PArrayE(addr))[(*PInteger(addr+16))]       =    (*PExtended(*PInteger(addr)+(*PInteger(addr+16))*10));
  //zx.re =  (*PExtended(addr+32));
  //zx.im =  (*PExtended(addr+48));
   nd = *PInteger(addr+80);
  //vd[nd] = (*PArrayD(addr+64))[(*PInteger(addr+80))]    =   (*PDouble(*PInteger(addr+64)+(*PInteger(addr+80))*8));
  //d =      (*PDouble(addr+96));
  //zd.re =  (*PDouble(addr+112));
  //zd.im =  (*PDouble(addr+128));
  //x =      (*PExtended(addr+144));
    ni = *PInteger(addr+176);
  //vi[ni] = (*PArrayI(addr+160))[(*PInteger(addr+176))]   = (*PInteger(*PInteger(addr+160)+(*PInteger(addr+176))*4));
*/

/*
   //nx =     (*PInteger(addr+16));
   vx =     (*PExtended(*PInteger(addr)+(*PInteger(addr+16))*10));
   zx.re =  (*PExtended(addr+32));
   zx.im =  (*PExtended(addr+48));
   //nd    =  (*PInteger(addr+80));
   vd   =   (*PDouble(*PInteger(addr+64)+(*PInteger(addr+80))*8));
   d =      (*PDouble(addr+96));
   zd.re =  (*PDouble(addr+112));
   zd.im =  (*PDouble(addr+128));
   x =      (*PExtended(addr+144));
   //ni =     (*PInteger(addr+176));
   vi     = (*PInteger(*PInteger(addr+160)+(*PInteger(addr+176))*4));

 rez.re=(vd*d*zd.re-vx*x*zx.re)*vi;
 rez.im=(vd*d*zd.im-vx*x*zx.im)*vi;
*/


rez.re  =  ((*PDouble(*PInteger(addr+64)+(*PInteger(addr+80))*8))*(*PDouble(addr+96))*(*PDouble(addr+112))-(*PExtended(*PInteger(addr)+(*PInteger(addr+16))*10))*(*PExtended(addr+144))*(*PExtended(addr+32)))*(*PInteger(*PInteger(addr+160)+(*PInteger(addr+176))*4));
rez.im  =  ((*PDouble(*PInteger(addr+64)+(*PInteger(addr+80))*8))*(*PDouble(addr+96))*(*PDouble(addr+128))-(*PExtended(*PInteger(addr)+(*PInteger(addr+16))*10))*(*PExtended(addr+144))*(*PExtended(addr+48)))*(*PInteger(*PInteger(addr+160)+(*PInteger(addr+176))*4));


/*
 _asm
 {
  fld qword ptr [rez.im]
  fld qword ptr [rez.re]
 }
*/
#ifdef   EXTENDED_VAR
  fzLoadFPUEP(&rez);
 //fzLoadFPUE(rez.re,rez.im);
#else
  fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}





/// FillArrayD(VD): VD[all]=x
void _cdecl FillArrayD(_int32 adrVD , double x)
{
 _int32 lenV;
 _int32 adrVD0,tmp;
 _int32 ni,i;
 PInteger pi1;
 Pointer32 pvd0;



/// ******************* 1 - slow way ******************************


/**
  fzGet(fz_ARRAY_LENGTH, (_int32)(&adrVD), lenV);

    for(ni = 0; ni <= lenV-1; ni++)
	{
       fzSetArrayValueD((Pointer32)(&adrVD), ni, x);
	}
**/

//***************************************************************


/// *********************2 - much fast ******************************



  if (adrVD != 0)
     {
		adrVD0=*PInteger(&adrVD);  //adrVD0=@vd[0] ; address of address !!!

       //pi1=PInteger(adrVD);
       //pi1=pi1-1;
       //lenV=*pi1;


	  lenV=*PInteger((PInteger(adrVD)-1));
	  /// lenV=lenV+1;  // <- if Foreval compiled in FPC !!!

     }
  else
     {lenV=0;};

  for(ni = 0; ni <= lenV-1; ni++)
	{
       *PDouble(adrVD0 + ni * 8) = x;  //8-sizeOf(double)
	}



//***************************************************************


/// ******************3 - most fast *******************************
/*
  _asm
  {
 	push eax
 	push ecx
 	push edx


   mov eax, dword Ptr [adrVD]
   cmp eax, 0
   jz  endp

   mov edx, dword Ptr [eax-4]  // <- Len
   /// add edx,1               // <- edx+1 if Foreval compiled in FPC !!!!!!
   fld qword Ptr [x]
   Xor ecx, ecx

   ckl:
   fst qword Ptr [eax+8*ecx]
   inc ecx
   cmp ecx, edx
   jnz ckl

   fstp st(0)

   endp:
   pop  edx
   pop  ecx
   pop  eax

  }
*/

//*************************************************************************

};



/// FillArrayE(VE): VE[all]=x
void _cdecl FillArrayE(_int32 adrVE , Extended x)
{
 _int32 lenV;
 _int32 adrVE0,tmp;
 _int32 ni,i;
 PInteger pi1;
 Pointer32 pvd0;



/// ******************* 1 - slow way ******************************

/**
  fzGet(fz_ARRAY_LENGTH, (_int32)(&adrVE), lenV);

    for(ni = 0; ni <= lenV-1; ni++)
	{
       fzSetArrayValueE((Pointer32)(&adrVE), ni, x);
	}
**/

//****************************************************************


/// *********************2 - much fast ******************************



  if (adrVE != 0)
     {
		adrVE0=*PInteger(&adrVE);  //adrVE0=@ve[0] ; address of address !!!

       //pi1=PInteger(adrVE);
       //pi1=pi1-1;
       //lenV=*pi1;


	  lenV=*PInteger((PInteger(adrVE)-1));
	  /// lenV=lenV+1;  // <- if Foreval compiled in FPC !!!

     }
  else
     {lenV=0;};

  for(ni = 0; ni <= lenV-1; ni++)
	{
       *PExtended(adrVE0 + ni * 10) = x;  //10-sizeOf(extended)
	}



//***************************************************************


/// ******************3 - most fast *******************************
/*
  _asm
  {

  }
*/

//*************************************************************************

};




/*
void  _cdecl anyf(_int32 ni, TComplexE z1, double x, TArrayE vx)
{
double re,im;
TComplexE rez;
 //anyf(j+k,z1*z2,x+y,ve)


 rez.re=ni+z1.re+x+vx[ni];
 rez.im=z1.im;
 //rez.re=vx[ni];

 _asm
{
   fld tbyte ptr [rez+16]
   fld tbyte ptr [rez]
 }

 //fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);

}



void  _cdecl anyf1(_int32 ni, TComplexE z1, double x, TArrayI vi)
{
double re,im;
TComplexE rez;
 //anyf1(j+k,z1*z2,x+y,vi)


 rez.re=ni+z1.re+x+vi[ni];
 rez.im=z1.im;
 //rez.re=vx[ni];

 _asm
{
   fld tbyte ptr [rez+16]
   fld tbyte ptr [rez]
 }

 //fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);

}



//vems(ve,n)= ve[n]
double  _cdecl VEMS(_int32 addr)
{
 return  (*PArrayE(addr))[(*PInteger(addr+16))];
}
*/
