//---------------------------------------------------------------------------

/**
                      For full examples see Builder MSVC
**/


/**
                               Warning:

        Use only 32bit compiler.
        ForevalZ does not support multitasking: compiled expression can not be executed simultaneously in multiple threads;
     for each thread needs its own compilation of expression, it also applies to functions such fz_Precompiled (not  thread-safe).

        External functions and procedures by calling type fz_STACK_VAL with passed types TComplexE are not work
         (reason unknown, may be error at compiler Gcc. In Builder, Delphi and Lazarus all work)
        With TComplexE use other calling types:  fz_ESP, fz_STACK_ADR; (sp -> ps,ms)


**/


#pragma once
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>
#include <iostream>
#include <sstream>
#include <cstdlib>
#include <string>
#include <vector>
#include <math.h>
#include "Types.h"
#include "ForevalZdll.h"
#include "stComplexNum.h"
#include "ExtFunc.h"

using namespace std;


/// #define TESTFASTDYNARRAY  // <- test dynamic array, see: onLoad (FDynArray) , test()
/// #define OVERLOADCOMPLEX   //calc. with overload complex num.: TComplexNum (see Button1)


typedef   std::vector<double> TArrayD ;
typedef   std::vector<Extended> TArrayE ;
typedef   std::vector<int> TArrayI ;
typedef   std::vector<byte> TArrayB ;
typedef   std::vector<Pointer32> TArrayP ;
typedef   TComplexNum (*PTGccTest)(void);

struct TFunc4
       {
		 TComplexD   z1;
		 TComplexD   z2;
		 double      x;
		 _int32       n;
		 TComplexD   res;
		 Pointer32   addr;
		 //TStringType Expr;
		 PCHAR      PchExpr;
       };


//TComplexNum z1,z2,z3,i;
//TComplexD z1d,z2d,z3d,resf;
TComplex z1f,z2f,z3f,resf;
TComplexNum z1,z2,z3,i,i0;
TFloatType x,y,t;
_int32 n,k,j,m,l;

TFunc4 fnc1,fnc2;

Pointer32 adrXVD,adrXVE,adrXVE1,adrVF,adrVDF,adrXVI,adrXAD,adr1,adrVECD,adrVD,FDynArray;

string    ExprE1,ExprE2,ExprE3S,ExprE4S,ExprA5,ExprA6,ExprA6F,ExprP7,ExprP7A,ExprF8,ExprF9,ExprF10S,ExprF11S,ExprF12S,ExprFE13SP,ExprFE13PS,ExprFE13MS,ExprFE13PC,ExprFE14SP,ExprFE14PS,ExprFE14MS,ExprFE14PC;
Pointer32 FuncE1,FuncE2,FuncE3S,FuncE4S,FuncA5,FuncA6,FuncA6F,FuncP7,FuncP7A,FuncF8,FuncF9,FuncF10S,FuncF11S,FuncF12S,FuncFE13SP,FuncFE13PS,FuncFE13MS,FuncFE13PC,FuncFE14SP,FuncFE14PS,FuncFE14MS,FuncFE14PC;


PDouble  px,py;
PInteger pi1;
Int32 ct;






double A,B,C,D;



//Pointer32 adrXVD,adrXVE,adrXVI,adrXAD,adr1,adrVECD,adrVD,FDynArray,adrXSPL,adrYSPL, adrVDX, adrVDY, adrVF;


INT32 GLT,FpuExc,GNC,Perf,rt,PerfG;
BOOLEAN F_CalcError;


 TArrayD  vd,vecd,vdf;
 TArrayE  ve,vf;
 TArrayI  vi;

//--------------------------------------------------------------------------------


double trunc(double d){ return (d>0) ? floor(d) : ceil(d) ; }

double abs(double d){ return fabs(d) ; }


std::string IntToStr(INT32 I)
{
    std::stringstream ss;
    ss<<I;
    std::string str1;
    ss>>str1;
    return str1;
};

INT32 StrToInt(std::string Str)
{
    std::stringstream ss;
    INT32   I;

    ss<<Str;
    ss>>I;

    return I;
};



std::string FloatToStr(double F)
{

    std::stringstream ss;
    ss<<F;
    std::string str1;
    ss>>str1;
    return str1;
 }


void RefReshVar()
{
     n = 1; k = 2; j = 5; m = -3;
     x = 2.123;
     y = 5.456;
     t = -3.789;
     z1f.re=2.123;  z1f.im=-1.456;
     z2f.re=5.456;  z2f.im=2.789;
     z3f.re=-3.789; z3f.im=-3.123;

     z1.re=2.123;   z1.im=-1.456;
     z2.re=5.456;   z2.im=2.789;
     z3.re=-3.789;  z3.im=-3.123;

}


void CopyArrayExt(Pointer32 psrc, Pointer32 pdest,  _int32 SZ)
{
/**
 Copy array of extended (Gcc) => array of extended (Foreval)
   In Foreval elements of array of extended are placed through throw 10 byte
   in Gcc - 12 byte.
**/
 _int32 ic;

   for(ic = 1;ic <= SZ; ic++)
   {
    *(PExtended)pdest = *(PExtended)psrc;
    psrc = psrc+12;
    pdest = pdest+10;
   }

};

TFloatType  _cdecl sp1(TFloatType x1)
{
 return  x1*x1;
};


TFloatType  _stdcall sp2(TFloatType x1, TFloatType x2)
{
 return  x1-x2;
};


TFloatType  _cdecl sp3(TFloatType x1, TFloatType x2, TFloatType x3)
{
 return  x1+x2-x3;
};




//********     same  functions for overloading complex: TComplexNum  ***********

TComplexNum  __fastcall sp1(TComplexNum z1)
{

  return z1*z1;
}


TComplexNum  __fastcall sp2(TComplexNum z1, TComplexNum z2)
{

  return z1-z2;
}

TComplexNum  __fastcall sp2(TComplexNum z1, TFloatType x)
{

  return z1-x;
}


TComplexNum  __fastcall sp2(TFloatType x, TComplexNum z1)
{
 return x-z1;
}

TComplexNum  __fastcall sp3(TComplexNum z1, TComplexNum z2, TComplexNum z3)
{
  return z1+z2-z3;
}




TComplexNum _cdecl spall(TArrayE &vx, _int32 nx, TComplexNum zx, TArrayD &vd, _int32 nd, double d, TComplexNum zd, Extended x, TArrayI &vi, _int32 ni)
{
//rez=(vd[nd]*d*zd - vx[nx]*x*zx)*vi[ni]
//spall(ve,n,z1,vd,k,y,z2,x,vi,j) = (vd[k]*y*z2 - ve[n]*x*z1)*vi[j]
 TComplexNum rez;

 //spall(ve,n+3,z1,vd,j+k,x,z2+z3,t-y,vi,n+k+j)


 rez.re=(vd[nd]*d*zd.re-vx[nx]*x*zx.re)*vi[ni];
 rez.im=(vd[nd]*d*zd.im-vx[nx]*x*zx.im)*vi[ni];


return rez;


}


void  ShowError(void)
{
Int32 CError;
Pointer32 PS;
string strE,strOut,strTmp,S;
TStringType chE,chTmp;


fzGetSyntaxErrorCode(CError);

switch ( CError )
 {
   case  fz_UNKNOWN_SYMBOL:                       S ="UNKNOWN SYMBOL or INCORRECT ARGUMENT or WRONG EXPRESSION"; break;
   case  fz_MISSING_ROUND_BRACKET:                S ="MISSING ROUND BRACKET"; break;
   case  fz_MISSING_OPERATION:                    S="MISSING OPERATION";   break;
   case  fz_WRONG_NUMBER_ARGUMENTS:               S="WRONG NUMBER ARGUMENTS";  break;
   case  fz_MISSING_EXPRESSION:                   S="MISSING EXPRESSION";  break;
   case  fz_UNKNOWN_FUNCTION:                     S="UNKNOWN FUNCTION"; break;
   case  fz_ERROR_AT_ADDITION_FUNCTION:           S="ERROR AT ADDITION FUNCTION";   break;
   case  fz_NOT_DEFINED_OPERATOR:                 S="NOT DEFINED OPERATOR"; break;
   case  fz_NOT_DEFINED_FUNCTION:                 S="NOT DEFINED FUNCTION";  break;
   case  fz_INCORRECT_ARGUMENT:                   S="WRONG TYPE OF ARGUMENT";   break;
   case  fz_MISSING_ARGUMENT:                     S="MISSING ARGUMENT";  break;
   case  fz_INTERNAL_ERROR:                       S="INTERNAL ERROR or  UNCATCHABLE SYNTAX ERROR"; break;
   case  fz_CALCULATION_ERROR:                    S="INTERNAL ERROR AT CALCULATION";  break;
   case  fz_INCORRECT_TYPE:                       S="WRONG TYPE" ;   break;
   case  fz_WRONG_NAME:                           S="WRONG NAME";  break;
   case  fz_MISSING_SQUARE_BRACKET:               S="MISSING SQUARE BRACKET";  break;
   case  fz_MISSING_CURLY_BRACKET:                S="MISSING CURLY BRACKET";  break;
   case  fz_MISSING_ABS_BRACKET:                  S="MISSING ABS BRACKET";  break;
   case  fz_WRONG_EXPRESSION:                     S="WRONG EXPRESSION";  break;
   case  fz_ABSENT_LOAD_FUNCTION_FOR_TYPE:        S="ABSENT LOAD FUNCTION FOR TYPE"; break;
   case  fz_MISSING_SEPARATOR:                    S="MISSING SEPARATOR";   break;
   case  fz_INCORRECT_SPACE:                      S="INCORRECT SPACE";  break;
   case  fz_VARIABLE_REDECLARED:                  S="VARIABLE REDECLARED";  break;
   default:                                       S="UNKNOWN SYNTAX ERROR"; break;
}


   /** it's best to make coping throw auxiliary string **/
       fzGetSyntaxErrorString(PS);
	   chTmp=(TStringType)(PS);
	   strTmp=(string)(chTmp);
	   strOut=strTmp;
	   strTmp="";
	   cout << "Foreval Syntax Error:" << S << endl;
       cout << strOut << endl;


}




int onLoad()
{
      _int32       fzLoad,ic,ECode;
	  TStringType  Expr;
	  //TStringType   Sid,Sid1,Sid2,Sid3,Sid4,Expr1,Expr2,SRes;
	  TStringType   Expr1,Expr2;
	  Pointer32    Func1,ve0,FS1,vd0,pa1,psrc,pdest;
	  double       ax,bx,hx,sx,fx,dx,dy,res,r;

	  //TArrayI      VT;
      TArrayB      Code;
	  _int32       ni, NR;
	  _int32       ID,ID1,ID2,ID3,ID4,SZ,IDF;
	  PInteger     pint1,P_C;
	  PDouble      pdbl1;
	  string       Sid,Sid1,Sid2,Sid3,Sid4,SText,SRes;
      char*        Ch32;

	  TComplexD    rezCx;
	  TZAddFuncStruct FS;

	  Int32        VT[10];
	  Int32        RType, CxType;




     //***********************************************************
     fzLoad=fzInit();
     if (fzLoad != 0)
     {


         fzGet(fz_COMPILED_BY,0,ID);
         if (ID >= 100 ) {GLT=2;} else {GLT=1;};

         fzSet(fz_STRING_TYPE, fz_ANSISTRING); //example only for ansi,for other string types see Builder's example
         //fzSet(fz_CALC_TYPE, fz_REAL);
         //fzSet(fz_ENABLE, fz_SHOW_EXCEPTION);
         //fzSet(fz_STACK_TYPE,fz_EXTENDED);
         //fzSet(fz_STRING_TYPE, fz_WIDESTRING);
		 //fzSet(fz_STRING_TYPE, fz_STRING_UTF16);

		 /**set type for const. & temporary results:  **/
		 //fzSet(fz_STACK_TYPE,fz_DOUBLE);      //for more speed
		 //fzSet(fz_STACK_TYPE,fz_EXTENDED);  //for more precision


          if(GLT == 2){ fzSet(fz_ENABLE,fz_MASK_FPU_EXCEPTION);}; /// <- if ForevalZ is compiled in FPC, then need to set it.
       /// If will crash program at catching of computational exception in parsing  (x/(2-2), sqrt(-2)*x, pow(-2.1,7.8),...) then also set it



		 //fzSet(fz_ENABLE,fz_USE_VIRTUAL_ALLOC);

         fzSet(fz_ADDRESS_EXCEPTION_FLAG , _int32(&FpuExc));	/// uses in fzResultSafe, fzResultDSafe, fzResultCxDSafe,fzResultCxDPSafe


         #ifdef   EXTENDED_VAR
           fzSet(fz_STACK_TYPE,fz_EXTENDED);
         #else
           fzSet(fz_STACK_TYPE,fz_DOUBLE);
         #endif // EXTENDED_VAR


         #ifdef   EXTENDED_VAR
           RType = fz_REAL_EXTENDED; CxType = fz_COMPLEX_EXTENDED;
         #else
            RType = fz_REAL_DOUBLE; CxType = fz_COMPLEX_DOUBLE;
         #endif // EXTENDED_VAR




  //fzSetVar("x",&xd,fz_REAL_DOUBLE);
  //fzSetVar("y",&yd,fz_REAL_DOUBLE);
  //fzSetVar("t",&td,fz_REAL_DOUBLE);

  fzSetVar("n",&n,fz_REAL_INTEGER);
  fzSetVar("k",&k,fz_REAL_INTEGER);
  fzSetVar("j",&j,fz_REAL_INTEGER);

  #ifdef   EXTENDED_VAR
   fzSetVar("x",&x,fz_REAL_EXTENDED);
   fzSetVar("y",&y,fz_REAL_EXTENDED);
   fzSetVar("t",&t,fz_REAL_EXTENDED);
   fzSetVar("z1",&z1f,fz_COMPLEX_EXTENDED);
   fzSetVar("z2",&z2f,fz_COMPLEX_EXTENDED);
   fzSetVar("z3",&z3f,fz_COMPLEX_EXTENDED);
   fzSetVar("res",&resf,fz_COMPLEX_EXTENDED);
   fzSetVar("result",&resf,fz_COMPLEX_EXTENDED);
   fzSetVar("rez",&resf,fz_COMPLEX_EXTENDED);
   fzSetVar("rezult",&resf,fz_COMPLEX_EXTENDED);
 #else
   fzSetVar("x",&x,fz_REAL_DOUBLE);
   fzSetVar("y",&y,fz_REAL_DOUBLE);
   fzSetVar("t",&t,fz_REAL_DOUBLE);
   fzSetVar("z1",&z1f,fz_COMPLEX_DOUBLE);
   fzSetVar("z2",&z2f,fz_COMPLEX_DOUBLE);
   fzSetVar("z3",&z3f,fz_COMPLEX_DOUBLE);
   fzSetVar("res",&resf,fz_COMPLEX_DOUBLE);
   fzSetVar("result",&resf,fz_COMPLEX_DOUBLE);
   fzSetVar("rez",&resf,fz_COMPLEX_DOUBLE);
   fzSetVar("rezult",&resf,fz_COMPLEX_DOUBLE);
 #endif // EXTENDED_VAR

  //fzSetVar("z1",&z1d,fz_COMPLEX_DOUBLE);
  //fzSetVar("z2",&z2d,fz_COMPLEX_DOUBLE);
  //fzSetVar("z3",&z3d,fz_COMPLEX_DOUBLE);


  n = 1; k = 2; j = 5;
  z1f.re=2.123;  z1f.im=-1.456;
  z2f.re=5.456;  z2f.im=2.789;
  z3f.re=-3.789; z3f.im=-3.123;
  x = 2.123; y = 5.456; t = -3.789;


  /*
  ad.set_length(3);
  ad[0]=3.5; ad[1]=-1.4;  ad[2]=7.6;
*/
  z1.re = z1f.re;  z1.im = z1f.im;
  z2.re = z2f.re;  z2.im = z2f.im;
  z3.re = z3f.re;  z3.im = z3f.im;

  i.re=0; i.im=1;
  i0.re=0; i0.im=0;



  /*
  vd=new double[11];
  vd[0]=1.1; vd[1]=2.2; vd[2]=3.3;
  adr1=&vd[0];
  int adr2 = 0;
  px=&vd[0];
  pi1=(PInteger)px;
  pi1=pi1-1;
  //px=px-4;
  //pi1=(PInteger)px;
  n=*pi1;


  LPF->Text= n.ToString();
  */
  //px=px+1;
  //T=*px;
  //LPF->Text= T.ToString();

  //n=(int)(adr2-4);
  //T= (*double)(n);
 /*
  vecd.push_back(1.1);
  vecd.push_back(2.2);
  vecd.push_back(3.3);
  vecd.push_back(4.4);
  vecd.push_back(5.5);
*/
  //vecd[0]=0;




  fzSetVarIntrnl("ad",fz_ARRAY_REAL_DOUBLE,adrXAD);     fzSetLength(adrXAD, fz_ARRAY_REAL_DOUBLE, 3);
  fzSetVarIntrnl("vd",fz_ARRAY_REAL_DOUBLE,adrXVD);     //fzSetLength(adrXVD, fz_ARRAY_REAL_DOUBLE, 100);
  fzSetVarIntrnl("ve",fz_ARRAY_REAL_EXTENDED,adrXVE);   fzSetLength(adrXVE, fz_ARRAY_REAL_EXTENDED, 100);
  fzSetVarIntrnl("ve1",fz_ARRAY_REAL_EXTENDED,adrXVE1); fzSetLength(adrXVE1, fz_ARRAY_REAL_EXTENDED, 100);
  fzSetVarIntrnl("vi",fz_ARRAY_REAL_INTEGER,adrXVI);    fzSetLength(adrXVI, fz_ARRAY_REAL_INTEGER, 100);


   vd.resize(100);
   ve.resize(100);
   vi.resize(100);
   vf.resize(101);  /// for "fast connect": see below

    for (ni = 0; ni <=99; ni++)
	{
       vd[ni]=ni+1;
       ve[ni]=ni+5;



      vd[ni]=pow((double)(-1),(Int32)(ni+1))*vd[ni]*0.5;
      ve[ni]=powl((Extended)(-1),(Int32)(ni+5))*ve[ni]*0.5;
      vi[ni]=trunc(ve[ni]);
      vf[ni+1]=ve[ni];



	   //fzSetArrayValueD(adrXVD,ni,vd[ni]);
       fzSetArrayValueE(adrXVE,ni,ve[ni]);
       fzSetArrayValueI(adrXVI,ni,vi[ni]);
	}


/**
	   to set "vd" array through copy to memory from vd[]
	   pint1=(PInteger)adrXVD;
	   vd0=(Pointer32)(*pint1);  //= &vd[0]
   **/

    fzSetLength(adrXVD, fz_ARRAY_REAL_DOUBLE, vd.size());
	vd0=(Pointer32)(*((PInteger)adrXVD));  /// = &vd[0] in Foreval
    CopyMemory(vd0,&vd[0],8*vd.size());   /// 8 - sizeof(double)


 /** if data and length of vd is changed, that need reinstall XVD  without recompiling expression , consisting of 'vd' **/
	/*
	 vd.resize(1000);
	  for (ni = 0; ni <=999; ni++)
	{
		vd[ni]=ni+1.123;
	  }

	 fzSetLength(adrXVD, fz_ARRAY_REAL_DOUBLE, vd.size());
	 vd0=(Pointer32)(*((PInteger)adrXVD));
	 CopyMemory(vd0,&vd[0],8*vd.size());
	*/



    /**
        For array of Extended type (ve1: TArrayE), setting it by CopyMemory don't work,
            so as size of cell for element (TArrayE)  in ForevalZ = 10,  in Gcc = 12
        Need write procedure of copying (CopyArrayExt)
    **/

                /**  ve(Gcc) => ve1(ForevalZ) **/


  fzSetLength(adrXVE1, fz_ARRAY_REAL_EXTENDED, ve.size());

  SZ=ve.size();
  psrc = &ve[0];
  pdest =(Pointer32)(*((PInteger)adrXVE1));  /// = &ve0[0] in ForevalZ
  //pdest = (PInteger)adrXVE1;
  CopyArrayExt(psrc,pdest,SZ);



/**************   Other way to adding external dynamic array: more fast (without using   fzSetArrayValueD or CopyMemory)  ******************************************************************

                 Array in C++ count from '1', in ForevalZ count from '0'   !!!
                 Zero element is using for saving of length, begin array from '1'
                 Array and pointer to it (adrVECD) must placing in 'unmanaged memory' !!!

***/

  fzSetVar("vecd", &adrVECD ,fz_ARRAY_REAL_DOUBLE);

    /**     compile  of expression for  test "TESTFASTDYNARRAY": see  void test() with key TESTFASTDYNARRAY **/

  /// fzCompile("len(vecd)*(sumq(vecd)/sqr(norm(vecd)))", FDynArray);  ///  always = len(vecd)
   fzCompile("k:int=0; len:int=len(vecd); s:dbl=0; for(k,0,len-1,s=s+vecd[k]); s/sum(vecd)", FDynArray);  ///  always = 1

   //vecd.push_back(0);//reserve for length
  //vecd.push_back(0);//begin of array vecd[1]
  vecd.resize(2); /// reserve for length (vecd[0]) + begin of array vecd[1] (for creating pointer to array: adrVECD)
  //vecd.reserve(2);
  vecd[1]=1.23456789;
  adrVECD=&vecd[1];  /// to set a  reference to the array.  adrVECD always: placing in 'unmanaged memory' and pointer only to vecd, so, as address of adrVECD using at compilation !!!

  /** to write length: **/
  pint1 = (PInteger)adrVECD;
  pint1=pint1-1;
  if (GLT == 1) {SZ = vecd.size()-1;} else {SZ=vecd.size()-2;};  /// GLT=1(Delphi); GLT=2(FPC),  in FPC Length=High
  *pint1 = SZ;  /// pint1 = &vecd[1]-4b;  *pint1 <- length
///  "fast connect" for double array

///**************************************************************************************************************************************
                              ///  "fast connect" for Extended array
   /**

        For array of Extended type (vf: TArrayE), setting it by CopyMemory or "fast connecting" don't work,
            so as size of cell for element (TArrayE)  in ForevalZ = 10,  in Gcc = 12
                           Need write procedure of copying (CopyArrayExt)
                           Array in C++ count from '1', in ForevalZ  count from '0'   !!!
                       Zero element is using for saving of length, begin array from '1'
    **/
                              /**  ve(Gcc) => vf(ForevalZ) **/

  fzSetVar("vf", &adrVF,fz_ARRAY_REAL_EXTENDED);

  adrVF=&vf[1];  /// to set a  reference to the array.  adrVF always: placing in 'unmanaged memory' and pointer only to vf, so, as address of adrVF using at compilation !!!

  //to write length:
  pint1 = (PInteger)adrVF;
  pint1=pint1-1;   /// = &vf[1]-4b; or = &vf[0]+4b;  sizeof(double) = 8
  if (GLT == 1) {SZ = vf.size()-1;} else {SZ=vf.size()-2;};  /// GLT=1(Delphi); GLT=2(FPC),  in FPC Length=High
  *pint1 = SZ;  /// pint1 = &vf[1]-4b;  *pint1 <- length

  SZ=vf.size();
  psrc = &vf[1];
  pdest = (PInteger)adrVF;
  CopyArrayExt(psrc,pdest,SZ);

///**************************************************************************************************************************************
                                                     ///  "fast connect" for double array
				                /**
								Array in C++ count from '1', in ForevalZ count from '0'   !!!
                             Zero element is using for saving of length, begin array from '1'
							    **/

  fzSetVar("vdf", &adrVDF ,fz_ARRAY_REAL_DOUBLE);
  vdf.resize(101);
  adrVDF=&vdf[1];  /// to set a  reference to the array.  adrVDF always: placing in 'unmanaged memory' and pointer only to vdf, so, as address of adrVDF using at compilation !!!

  /**to write length: **/
  pint1 = (PInteger)adrVDF;
  pint1=pint1-1;   /// = &vdf[1]-4b; or = &vdf[0]+4b;  sizeof(double) = 8
  if (GLT == 1) {SZ = vdf.size()-1;} else {SZ=vdf.size()-2;};  /// GLT=1(Delphi); GLT=2(FPC),  in FPC Length=High
  *pint1 = SZ;  /// pint1 = &vdf[1]-4b;  *pint1 <- length
  // --------------------------------------------------------------------------
   CopyMemory(&vdf[1],&vd[0],8*vd.size());   ///  vd=>vdf;  8 - sizeof(double)

///**************************************************************************************************************************************








/******************************************************************************


                         Addition external functions:

*******************************************************************************/



/**


func1(arg1)=arg1^2; func2(arg1,arg2)=arg1-arg2; func3(arg1,arg2,arg3)=arg1+arg2-arg3;
arg1,arg2,arg3 - real/complex
arg2 - mixed real/complex

ms1, ms2, ms3      fz_ESP
sp1, sp2, sp3      fz_STACK_VAL
ps1, ps2, ps3      fz_STACK_ADR
pc1, pc2, pc3      fz_PreCompiled


infsum             fz_INFINITE;

FillArrayD(TArrayD vd, Double x)   =   vd[all] = x
FillArrayE(TArrayE ve, Extended x) =   ve[all] = x



with arg. of all types:
func10(TArrayE vx, Int32 nx, TComplexE zx, TArrayD vd, Int32 nd, double d, TComplexD zd, Extended x, TArrayI vi, Int32 ni) = (vd[k]*y*z2 - ve[n]*x*z1)*vi[j]

spall    fz_STACK_VAL
psall    fz_STACK_ADR
msall    fz_ESP
pcall    fz_PreCompiled


********************************************************************************
**/

/**
         External functions and procedures by calling type fz_STACK_VAL with passed types TComplexE are not work
         (reason unknown, may be error at compiler Gcc. In Builder, Delphi and Lazarus all work)
        With TComplexE use other calling types:  fz_ESP, fz_STACK_ADR; (sp -> ps,ms)
**/

  //x=vecd[0];

  InitFuncStructZ(FS);
  FS.addr=(Pointer32)&SP1;
  FS.CallType=fz_CDECL;
  FS.Arg=1;
  FS.ArgType=RType; //fz_REAL_DOUBLE;
  FS.ResultType=fz_REAL;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=1;
  fzSetFunction("sp1",&FS);

  InitFuncStructZ(FS);
  FS.addr=(Pointer32)&SP2;
  FS.CallType=fz_STDCALL;
  FS.Arg=2;
  FS.ArgType=RType; // fz_REAL_DOUBLE;
  FS.ResultType=fz_REAL;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=1;
  fzSetFunction("sp2",&FS);

  InitFuncStructZ(FS);
  FS.addr=(Pointer32)&SP3;
  FS.CallType=fz_CDECL;
  FS.Arg=3;
  FS.ArgType=RType; //fz_REAL_DOUBLE;
  FS.ResultType=fz_REAL;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=1;
  fzSetFunction("sp3",&FS);

  InitFuncStructZ(FS);
  FS.addr=(Pointer32)&SP1Z;
  FS.CallType=fz_CDECL;
  FS.Arg=1;
  FS.ArgType=CxType;//fz_COMPLEX_DOUBLE;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=2;
  fzSetFunction("sp1",&FS);


  InitFuncStructZ(FS);
  FS.addr=(Pointer32)&SP2Z;
  FS.CallType=fz_CDECL;
  FS.Arg=2;
  FS.ArgType=CxType;//fz_COMPLEX_DOUBLE;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=2;
  fzSetFunction("sp2",&FS);

  //mixed
  //sp2(z,x)=z-x
  InitFuncStructZ(FS);
  FS.Arg=2;
  //VT.set_length(FS.Arg);
  VT[0]=CxType;//fz_COMPLEX_DOUBLE;
  VT[1]=RType; //fz_REAL_DOUBLE;
  FS.ArgTypeList=&VT[0];
  FS.addr=(Pointer32)&SP2ZR;
  FS.CallType=fz_CDECL;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=2;
  fzSetFunction("sp2",&FS);

  //sp2(x,z)=x-z
  InitFuncStructZ(FS);
  FS.Arg=2;
  //VT.set_length(FS.Arg);
  VT[0]=RType; //fz_REAL_DOUBLE;
  VT[1]=CxType;//fz_COMPLEX_DOUBLE;
  FS.ArgTypeList=&VT[0];
  FS.addr=(Pointer32)&SP2RZ;
  FS.CallType=fz_CDECL;
  FS.Arg=2;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=2;
  fzSetFunction("sp2",&FS);

  InitFuncStructZ(FS);
  FS.addr=(Pointer32)&SP3Z;
  FS.CallType=fz_STDCALL;
  FS.Arg=3;
  FS.ArgType=CxType;//fz_COMPLEX_DOUBLE;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=2;
  fzSetFunction("sp3",&FS);



  //ps1(x)
  InitFuncStructZ(FS);
  FS.addr=(Pointer32)&PS1;
  FS.CallType=fz_CDECL;
  FS.Arg=1;
  FS.ArgType=RType; //fz_REAL_DOUBLE;
  FS.ResultType=fz_REAL;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=1;
  fzSetFunction("ps1",&FS);

  InitFuncStructZ(FS);
  FS.addr=(Pointer32)&PS2;
  FS.CallType=fz_CDECL;
  FS.Arg=2;
  FS.ArgType=RType; //fz_REAL_DOUBLE;
  FS.ResultType=fz_REAL;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=1;
  fzSetFunction("ps2",&FS);

  InitFuncStructZ(FS);
  FS.addr=(Pointer32)&PS3;
  FS.CallType=fz_STDCALL;
  FS.Arg=3;
  FS.ArgType=RType; //fz_REAL_DOUBLE;
  FS.ResultType=fz_REAL;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=1;
  fzSetFunction("ps3",&FS);

  InitFuncStructZ(FS);
  FS.addr=(Pointer32)&PS1Z;
  FS.CallType=fz_CDECL;
  FS.Arg=1;
  FS.ArgType=CxType;//fz_COMPLEX_DOUBLE;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=1;
  fzSetFunction("ps1",&FS);

  InitFuncStructZ(FS);
  FS.addr=(Pointer32)&PS2Z;
  FS.CallType=fz_CDECL;
  FS.Arg=2;
  FS.ArgType=CxType;//fz_COMPLEX_DOUBLE;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=2;
  fzSetFunction("ps2",&FS);

  InitFuncStructZ(FS);
  FS.addr=(Pointer32)&PS3Z;
  FS.CallType=fz_STDCALL;
  FS.Arg=3;
  FS.ArgType=CxType;//fz_COMPLEX_DOUBLE;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=2;
  fzSetFunction("ps3",&FS);

    //mixed
  //ps2(z,x)=z-x
  InitFuncStructZ(FS);
  FS.Arg=2;
  VT[0]=CxType;//fz_COMPLEX_DOUBLE;
  VT[1]=RType; //fz_REAL_DOUBLE;
  FS.ArgTypeList=&VT[0];
  FS.addr=(Pointer32)&PS2ZR;
  FS.CallType=fz_CDECL;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=2;
  fzSetFunction("ps2",&FS);

  //ps2(x,z)=x-z
  InitFuncStructZ(FS);
  FS.Arg=2;
  VT[0]=RType; //fz_REAL_DOUBLE;
  VT[1]=CxType;//fz_COMPLEX_DOUBLE;
  FS.ArgTypeList=&VT[0];
  FS.addr=(Pointer32)&PS2RZ;
  FS.CallType=fz_CDECL;
  FS.Arg=2;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=2;
  fzSetFunction("ps2",&FS);



  //ms1
  InitFuncStructZ(FS);
  FS.addr=(Pointer32)&MS1;
  FS.ArgType=RType; //fz_REAL_DOUBLE;
  FS.Arg=1;
  FS.CallFunc=fz_ESP;
  FS.CallType=fz_CDECL;
  FS.DeepFPU=1;
  FS.ResultType=fz_REAL;
  fzSetFunction("ms1",&FS);

  InitFuncStructZ(FS);
  FS.addr=(Pointer32)&MS2;
  FS.ArgType=RType; //fz_REAL_DOUBLE;
  FS.Arg=2;
  FS.CallFunc=fz_ESP;
  FS.CallType=fz_CDECL;
  FS.DeepFPU=1;
  FS.ResultType=fz_REAL;
  fzSetFunction("ms2",&FS);

  InitFuncStructZ(FS);
  FS.addr=(Pointer32)&MS3;
  FS.ArgType=RType; //fz_REAL_DOUBLE;
  FS.Arg=3;
  FS.CallFunc=fz_ESP;
  FS.CallType=fz_CDECL;
  FS.DeepFPU=1;
  FS.ResultType=fz_REAL;
  fzSetFunction("ms3",&FS);

   //ms2z
  InitFuncStructZ(FS);
  FS.addr=(Pointer32)&MS1Z;
  FS.ArgType=CxType;//fz_COMPLEX_DOUBLE;
  FS.Arg=1;
  FS.CallFunc=fz_ESP;
  FS.CallType=fz_CDECL;
  FS.DeepFPU=2;
  FS.ResultType=fz_COMPLEX;
  fzSetFunction("ms1",&FS);

   //ms2z
  InitFuncStructZ(FS);
  FS.addr=(Pointer32)&MS2Z;
  FS.ArgType=CxType;//fz_COMPLEX_DOUBLE;
  FS.Arg=2;
  FS.CallFunc=fz_ESP;
  FS.CallType=fz_CDECL;
  FS.DeepFPU=2;
  FS.ResultType=fz_COMPLEX;
  fzSetFunction("ms2",&FS);

   //ms3z
  InitFuncStructZ(FS);
  FS.addr=(Pointer32)&MS3Z;
  FS.ArgType=CxType;//fz_COMPLEX_DOUBLE;
  FS.Arg=3;
  FS.CallFunc=fz_ESP;
  FS.CallType=fz_CDECL;
  FS.DeepFPU=2;
  FS.ResultType=fz_COMPLEX;
  fzSetFunction("ms3",&FS);

  //mixed
  //ms2(z,x)=z-x
  InitFuncStructZ(FS);
  FS.Arg=2;
  VT[0]=CxType;//fz_COMPLEX_DOUBLE;
  VT[1]=RType; //fz_REAL_DOUBLE;
  FS.ArgTypeList=&VT[0];
  FS.addr=(Pointer32)&MS2ZR;
  FS.CallType=fz_CDECL;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_ESP;
  FS.DeepFPU=2;
  fzSetFunction("ms2",&FS);

  //ms2(x,z)=x-z
  InitFuncStructZ(FS);
  FS.Arg=2;
  VT[0]=RType; //fz_REAL_DOUBLE;
  VT[1]=CxType;//fz_COMPLEX_DOUBLE;
  FS.ArgTypeList=&VT[0];
  FS.addr=(Pointer32)&MS2RZ;
  FS.CallType=fz_CDECL;
  FS.Arg=2;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_ESP;
  FS.DeepFPU=2;
  fzSetFunction("ms2",&FS);


  InitFuncStructZ(FS);
  FS.addr=(Pointer32)&sumr;
  FS.ArgType=fz_REAL_EXTENDED;
  FS.CallFunc=fz_INFINITE;
  FS.CallType=fz_CDECL;
  FS.ResultType=fz_REAL;
  FS.DeepFPU=2;
  fzSetFunction("infsum",&FS);


  InitFuncStructZ(FS);
  FS.addr=(Pointer32)&sumz;
  FS.ArgType=fz_COMPLEX_EXTENDED;
  FS.CallFunc=fz_INFINITE;
  FS.CallType=fz_CDECL;
  FS.ResultType=fz_COMPLEX;
  FS.DeepFPU=2;
  fzSetFunction("infsum",&FS);




  InitFuncStructZ(FS);
  FS.Arg=10;
  FS.addr=(Pointer32)&SPALL;
  VT[0]=fz_ARRAY_REAL_EXTENDED; VT[1]=fz_REAL_INTEGER; VT[2]=fz_COMPLEX_EXTENDED; VT[3]=fz_ARRAY_REAL_DOUBLE;
  VT[4]=fz_REAL_INTEGER; VT[5]=fz_REAL_DOUBLE; VT[6]=fz_COMPLEX_DOUBLE;  VT[7]=fz_REAL_EXTENDED;
  VT[8]=fz_ARRAY_REAL_INTEGER; VT[9]=fz_REAL_INTEGER;
  FS.ArgTypeList=&VT[0];
  FS.CallType=fz_CDECL;
  //FS.ArgType=fz_DIFFER;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=3;
  fzSetFunction("spall",&FS);


  InitFuncStructZ(FS);
  FS.Arg=10;
  FS.addr=(Pointer32)&PSALL;
  VT[0]=fz_ARRAY_REAL_EXTENDED; VT[1]=fz_REAL_INTEGER; VT[2]=fz_COMPLEX_EXTENDED; VT[3]=fz_ARRAY_REAL_DOUBLE;
  VT[4]=fz_REAL_INTEGER; VT[5]=fz_REAL_DOUBLE; VT[6]=fz_COMPLEX_DOUBLE;  VT[7]=fz_REAL_EXTENDED;
  VT[8]=fz_ARRAY_REAL_INTEGER; VT[9]=fz_REAL_INTEGER;
  FS.ArgTypeList=&VT[0];
  FS.CallType=fz_CDECL;
  //FS.ArgType=fz_DIFFER;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=3;
  fzSetFunction("psall",&FS);


  InitFuncStructZ(FS);
  FS.Arg=10;
  FS.addr=(Pointer32)&MSALL;
  VT[0]=fz_ARRAY_REAL_EXTENDED; VT[1]=fz_REAL_INTEGER; VT[2]=fz_COMPLEX_EXTENDED; VT[3]=fz_ARRAY_REAL_DOUBLE;
  VT[4]=fz_REAL_INTEGER; VT[5]=fz_REAL_DOUBLE; VT[6]=fz_COMPLEX_DOUBLE;  VT[7]=fz_REAL_EXTENDED;
  VT[8]=fz_ARRAY_REAL_INTEGER; VT[9]=fz_REAL_INTEGER;
  FS.ArgTypeList=&VT[0];
  FS.CallType=fz_CDECL;
  //FS.ArgType=fz_DIFFER;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_ESP;
  FS.DeepFPU=3;
  fzSetFunction("msall",&FS);




  /// FillArrayD(TArrayD vd, Double x) = vd[all]=x
  InitFuncStructZ(FS);
  FS.Arg=2;
  //VT.set_length(FS.Arg);
  //VT.resize(FS.Arg);
  VT[0]=fz_ARRAY_REAL_DOUBLE;  VT[1]=fz_REAL_DOUBLE;
  FS.ArgTypeList=&VT[0];
  FS.addr=(Pointer32)&FillArrayD;
  FS.CallFunc=fz_STACK_VAL;
  FS.CallType=fz_CDECL;
  FS.DeepFPU=2;
  FS.ResultType=fz_NONE;
  fzSetFunction("FillArrayD",&FS);



  /// FillArrayE(TArrayE ve, Extended x) = ve[all]=x
  InitFuncStructZ(FS);
  FS.Arg=2;
  //VT.set_length(FS.Arg);
  //VT.resize(FS.Arg);
  VT[0]=fz_ARRAY_REAL_EXTENDED;  VT[1]=fz_REAL_EXTENDED;
  FS.ArgTypeList=&VT[0];
  FS.addr=(Pointer32)&FillArrayE;
  FS.CallFunc=fz_STACK_VAL;
  FS.CallType=fz_CDECL;
  FS.DeepFPU=2;
  FS.ResultType=fz_NONE;
  fzSetFunction("FillArrayE",&FS);


//***************  several expressions: ****************************************
   /**
	  fnc1(z1,z2,n,x) = z1+z2+n*x;
	  fnc2(z1,z2,n,x)=  z1*z2+(i*n+x);

	  fnc2(fnc1(2-i,5+3i,3,1.1),1-i,5,fnc1(2-i,5+3i,3,1.1).re)=
   **/


	fzPerform(fz_SAVE, fz_VAR_LIST);

    //fnc1.Expr= "z1+z2+n*x";
	Expr1= "z1+z2+n*x";
	fzSetVar("x", &fnc1.x, fz_REAL_DOUBLE);
	fzSetVar("n", &fnc1.n, fz_REAL_INTEGER);
	fzSetVar("z1", &fnc1.z1, fz_COMPLEX_DOUBLE);
	fzSetVar("z2", &fnc1.z2, fz_COMPLEX_DOUBLE);
	fzCompile(Expr1, fnc1.addr);

	//fnc2.Expr= "z1*z2+(i*n+x)";
	Expr2= "z1*z2+(i*n+x)";
	fzSetVar("x", &fnc2.x, fz_REAL_DOUBLE);
	fzSetVar("n", &fnc2.n, fz_REAL_INTEGER);
	fzSetVar("z1", &fnc2.z1, fz_COMPLEX_DOUBLE);
	fzSetVar("z2", &fnc2.z2, fz_COMPLEX_DOUBLE);
	fzCompile(Expr2, fnc2.addr);

	fzPerform(fz_RESTORE, fz_VAR_LIST);

	fnc1.x= 1.1;  fnc1.n= 3; fnc1.z1.re= 2;  fnc1.z1.im= -1;  fnc1.z2.re= 5; fnc1.z2.im= 3;
				  fnc2.n= 5;                                  fnc2.z2.re= 1; fnc2.z2.im= -1;

	fzResultCxDP(fnc1.addr, &fnc1.res) ;    //fnc1.res=fnc1(2-i,5+3i,3,1.1)
	fnc2.z1= fnc1.res; fnc2.x= fnc1.res.re;

	fzResultCxDP(fnc2.addr, &fnc2.res);

	SRes=FloatToStr(fnc2.res.re)+"   "+FloatToStr(fnc2.res.im)+"i";
    //cout <<  SRes << endl;



//******************************************************************************

 fzSet(fz_ENABLE,fz_USE_VIRTUAL_ALLOC); /// with this fz_Precompiled functions run faster.

  fzSetFunction("pcall(vx: arrayExt; nx:int; zx: extCx; vd: arrayDbl; nd: int; d: dbl; zd: dblCx; x: ext; vi: arrayInt; ni: int):complex=(vd[nd]*d*zd - vx[nx]*x*zx)*vi[ni]",0);



#ifdef   EXTENDED_VAR
    fzSetFunction("pc1(x:ext):real=x^2",0);
    fzSetFunction("pc2(x,y:ext):real=x-y",0);
    fzSetFunction("pc3(x1,x2,x3:ext):real=x1+x2-x3",0);
    fzSetFunction("pc1(z:extCx):complex=z^2",0);
    fzSetFunction("pc2(x:ext;z:extCx):complex=x-z",0);
    fzSetFunction("pc2(z:extCx; x:ext):complex=z-x",0);
    fzSetFunction("pc2(z1,z2:extCx):complex=z1-z2",0);
    fzSetFunction("pc3(z1,z2,z3:extCx):complex=z1+z2-z3",0);
  #else
    fzSetFunction("pc1(x:dbl):real=x^2",0);
    fzSetFunction("pc2(x,y:dbl):real=x-y",0);
    fzSetFunction("pc3(x1,x2,x3:dbl):real=x1+x2-x3",0);
    fzSetFunction("pc1(z:dblCx):complex=z^2",0);
    fzSetFunction("pc2(x:dbl;z:dblCx):complex=x-z",0);
    fzSetFunction("pc2(z:dblCx; x:dbl):complex=z-x",0);
    fzSetFunction("pc2(z1,z2:dblCx):complex=z1-z2",0);
    fzSetFunction("pc3(z1,z2,z3:dblCx):complex=z1+z2-z3",0);
#endif

 fzSet(fz_DISABLE,fz_USE_VIRTUAL_ALLOC);




//fzSetNameImUnit("ii");

 /*
fzGetFuncID("sh",IDF);
fzSet(fz_DISABLE_FUNCTION,IDF);
*/

/*
fzSetFunction("pwr(x,y: ext):complex= if( (x < 0) and ([y] <> y),(x+0i)^y,x^y+0i)",0);
fzSetFunction("pwr(x: ext; z: extcx):complex= x^z",0);
fzSetFunction("pwr(z: extcx; x: ext):complex= z^x",0);
fzSetFunction("pwr(z1,z2: extcx):complex= z1^z2",0);


fzGetFuncID("power",IDF);
fzSet(fz_DISABLE_FUNCTION,IDF);
fzGetFuncID("pwr",IDF);
fzAddNameFunction(IDF,"power");
fzAddNameFunction(IDF,"pow");
fzSet(fz_POWER_SYMBOL,IDF);
*/
//(-x)^2.5
//(-4)^(0.5)







fzGet(fz_VERSION,fz_MAJOR,ID1);    Sid1=IntToStr(ID1);
fzGet(fz_VERSION,fz_MINOR,ID2);    Sid2=IntToStr(ID2);
fzGet(fz_VERSION,fz_RELEASE,ID3);  Sid3=IntToStr(ID3);
fzGet(fz_VERSION,fz_BUILD,ID4);    Sid4=IntToStr(ID4);
Sid=Sid1+"."+Sid2+"."+Sid3+"."+Sid4;



SText="ForevalZ.dll  (v."+Sid+")";
fzGet(fz_COMPILED_BY,0,ID);


if (ID >= 100) {SText=SText+".  Compiled by FPC v." + IntToStr(ID); GLT=2;}
else
{
 GLT=1;
 switch  (ID)
 {

  case 7: SText=SText+".   Compiled by Delphi7"; break;
  case 8: SText=SText+".   Compiled by Delphi8";   break;
  case 9: SText=SText+".   Compiled by Delphi2005"; break;
  case 10: SText=SText+".  Compiled by Delphi2006"; break;
  case 11: SText=SText+".  Compiled by Delphi2007";  break;
  case 12:  SText=SText+".   Compiled by Delphi 2009"; break;
  case 13:  SText=SText+".   Compiled by Delphi 2010"; break;
  case 14:  SText=SText+".   Compiled by Delphi XE"; break;
  case 15:  SText=SText+".   Compiled by Delphi XE2";  break;
  case 16:  SText=SText+".   Compiled by Delphi XE3";  break;
  case 17:  SText=SText+".   Compiled by Delphi XE4";  break;
  case 18:  SText=SText+".   Compiled by Delphi XE5"; break;
  case 19:  SText=SText+".   Compiled by Delphi XE6";  break;
  case 20:   SText=SText+".   Compiled by Delphi XE7";  break;
  }
}
   cout <<  "" << endl;
   cout <<  SText << endl;

  cout <<  "" << endl;
  cout <<  "Test  ForevalZ.dll on GCC" << endl;
  cout <<  "*****************************************"<< endl;
  cout << "on default:" << endl;
  cout << "" << endl;
  cout <<  "  real var.: x=2.123; y=5.456; t=-3.789"<< endl;
  cout <<  ""<< endl;
  cout <<  "  int. var.: n=1; k=2; j=5" << endl;
  cout <<  ""<< endl;
  cout <<  "  complex var.: z1.re=2.123; z1.im= -1.456; z2.re=5.456; z2.im=2.789; z3.re= -3.789; z3.im= -3.123; "<< endl;
  cout <<  ""<< endl;
  cout <<  "  array of extended: ve (0-99)"<< endl;
  cout <<  "  array of double:   vd (0-99)"<< endl;
  cout <<  "  array of int.:     vi (0-99)"<< endl;
  cout <<  ""<< endl;
  cout <<  "*****************************************"<< endl;
  cout <<  "examples:"<< endl;
  cout <<  ""<< endl;
  cout <<  "  root(z1,3)+(z2.re/z1.im)^2"<< endl;
  cout <<  ""<< endl;
  cout <<  "  zi1:dblCx = |z1|^n*cossin(arg(z1)*n); zi2:dblCx = |z1|*exp(i*arg(z1)); zi1/zi2"<< endl;
  cout <<  ""<< endl;
  cout <<  "  z1:dblCx = 1+2i; z2:dblCx = 3-5i; result = z1^log(z1,z2)/z2 "<< endl;

  cout <<  "******************************************************************************" << endl;

}


return fzLoad;
}



TComplexNum GccE1()
{
    return (z1-z2)*(z2-z3)*(z3-z1)*(z1+z2)*(z2+z3)*(z1+z3)*(z2*z1-z3)-z2*(z1*z3+z2)*(z1+z2*z3);
 //return  z1*z2-z3*(z1+z2-z3);
 //return  z1*z2-z3*(z1+z2-z3*(z1-z2*(z2-z1))-z1*z3*(z3-z2)*z2)+z2*(z1+z3+z2*(z1-z3)-z1*(z3-z1))*z1;
 //return z1*z2*(z2*z1-z3*z2*(z1*z3+z2*z3*(z3*z1+z1*z2)));
// return z1*(2.1*z2-3.5*z3)*1.5-3.2*(4.7-z1-z3*(2.2*z1*z3-1.7*z2)+1.2*z2*z1*(2.1*z2*z3-3.2*z1)*(1.6*z1-3.9*z2));
//return ((z3/(z1*z2-z3/z1+2.5)-2.1*z2*z1/(1.5-z1-z2/z3)+(-z1-2.3/z3+1.7/(z1/z2-z3*z1))/(z2-z3*z1*2.7)*(2.1*z1-z2*1.9-2.5/z3-1.1))/((-z2/z1)/z2-z3/(z1*1.1/z2*(z3-z1)-z1/(-z3))-2.7/(-2.1-(-z1-z3/z2))+z1*1.2*z2/(z2-1.5)*z3*(-1.1/z1-z2)/(z1-z2))-(-z1*(-z1/(1.1/z3-z1/(-z2-3.1/(-z1))))*z2/(z2-z3*z1)-(z1*z2/(-z1-z2/(z3-1.2/(-z1*1.5))))*z3*(-z2-z3/z1)+z2/(2.1/(-z1)-1.5/(-z1))*5.5-z1*z2*(z3/(-z1)+z1*(z2-z3/z1)))/(-z1*z2/z3-z3/z1*z2*(-1.1*z1/z2*z3-2.3/(-z1-(z2/z3-z1/z2)/(z1-2.5-z2*3.2)))+z3*(z3/(z1-z2-2.1)-(z1*z3-2.5/z1+3.7)/z2)*z1/(z2*z1-z3/(-2.5/z1-3.7*(z1*z2-z3/(-1.5-z2*z1))/(2.1*z1-3.2*z2-2.5*z3+2.7/z3)))))*(z1*z2-z3*z2/(z1-z2/(z1*z3-z3*(z2-z1*z2/(z2/z3-z1)))));
//return (z3/(z1*z2-z3/z1+2.5)-2.1*z2*x/(1.5-z1-z2/t)+(-z1-2.3/z3+1.7/(y/z2-z3*z1))/(z2*x-z3*z1*2.7)*(2.1*z1-z2*1.9-2.5/z3-1.1))/((-y*z2/z1)/z2-z3/(z1*1.1/z2*(t/z3-z1/(x+y))-x*z1/(-z3*y))-2.7/(-2.1-(-z1-z3/z2-y))+z1*1.2*z2/(t-z2-1.5)*z3*(-1.1/z1-t*z2*y)/(y+z1-z2+x))-(-z1*(-z1/(y-1.1/z3-z1/(-z2-3.1/(-z1)-x)))*z2/(z2-z3*z1)-(z1*z2/(-z1-z2/(z3-1.2/(-z1*1.5+2.1*y))))*z3*(-z2-z3/z1-x*3.5)+z2/(2.1/(-z1)-1.5/(-z1))*5.5-z1*z2*(z3/(-z1)+z1*(z2-z3/(y-z1/z3-x)))/(-z1*y*z2/z3-z3/z1*z2*(-1.1*z1/z2*z3*(y+x/z2)*(-t+1.5)-2.3/(-z1-(z2/z3-z1/z2-x/(z1+t)+(y+z2)/y)/(z1-2.5-z2*3.2)))+z3*(z3/(z1-z2-2.1)-(z1*z3-2.5/z1+3.7)/z2)*z1/(z2*z1-z3/(-2.5/z1-3.7*(z1*z2-z3/(-1.5-z2*z1))/(2.1*z1-3.2*z2-2.5*z3+2.7/z3)))))*(z1*z2-z3*z2/(z1-z2/(z1*z3-z3*(z2-z1*z2/(z2/z3-z1)))));
//return (z3/(z1*z2-z3/z1)-z2*x/(-z1-z2/t)+(-z1-z3+x/(y/z2-z3*z1))/(z2*x-z3*z1)*(z1-z2-t/z3))/((-y*z2/z1)/z2-z3/(z1/z2*(t/z3-z1/(x+y))-x*z1/(-z3*y))-t/(-x-(-z1-z3/z2-y))+z1*z2/(t-z2-y)*z3*(-x/z1-t*z2*y)/(y+z1-z2+x))-(-z1*(-z1/(y-t/z3-z1/(-z2-y/(-z1)-x)))*z2/(z2-z3*z1)-(z1*z2/(-z1-z2/(z3-y/(-z1*t+y))))*z3*(-z2-z3/z1-x)+z2/(x/(-z1)-y/(-z1))*t-z1*z2*(z3/(-z1)+z1*(z2-z3/(y-z1/z3-x)))/(-z1*y*z2/z3-z3/z1*z2*(-z1/z2*z3*(y+x/z2)*(-t+z3*y)-y/(-z1-(z2/z3-z1/z2-x/(z1+t)+(y+z2)/y)/(z1-z2)))+z3*(z3/(z1-z3)-(z1*z3-t/z1+x)/z2)*z1/(z2*z1-z3/(-y/z1-t*(z1*z2-z3/(-x-z2*z1))/(z1-z2*t-x*z3+y/z3)))))*(z1*z2-z3*z2/(z1-z2/(z1*z3-z3*(z2-z1*z2/(z2/z3-z1)))));


//return z1*x*(z1*z2/(z3+y/z2))-z3/(y-x/z2-z1/(x+y)+t)+z3*z2/(z3-z2*x)+z1*(z2/z3-y)*(x-z1);

//return z1*(x*2.1*z1*z2/(z3*1.1+2.1*y/z2))-z3/(1.5/y-x/z2-z1/(x+y)+t*3.2)+z3*z2/(3.7-z2*x)-z1/(z2*1.2-3.2/z3+x*(y-2.1*z3)/t)+z3/(2.5/z1+z3/1.7);



//return (z1/(z2-z3)-(z1+z2)/(z3-z1)+z1*z2*(z1-z2+z3)/(z1-z3)-z2*(z1+z3)*(z2-z1))*(z1/(z2*z3+z1)-z2)*(z1/z3-z3)/(z1*(z1*z3+z3+z2*z1)+z3*z2+z2);
//return (z1*z2/(z1+z2)+z1/(x/z1+z2/y)-z2*(z3*t-x*z2)*(z1+x)*(y+z3)+z3*z2*(z3-y)/(y+z1))*(1.5*z1-3.7/z2+2.5*x*z3)*(z3/(1.7-z3*y)-y/z1)*((x*z1+z2*t+1.5)/(z1*z3+t)+z3)/(z3*(z1*2.5+1.7*t*z2)+z2*z3*t*2.7);
//return (z1/z2-z1*z2)*((z3-z1)*(z1+z2)-z3/z2)*(z1*z3/(z1-z2+z3))/((z3-z2/(z3-z1))*(z2*z3-z1/(z3/z1-z2/(z2-z1))));
//return ((z1-z2)/(z3-z1)-(z1+(z3-z2*z1)/(z1-z3+z2))*(z3-z2))*(z3+z2-(z1-z2)*(z3-z1/z3));
//return (z1/z3-z2/(z1*z2-z3)+z3*(z2/(z3/z1-z1/z3)-z1/(z1*z2-z2/z3))+(z2*z3-z3*(z1+z2)/(z2/(z1*z2-z3)-z1/(z1*z2-z2/z3))))/((z2*z3-z1*z2)/(z3*(z2/z3+z3*(z2/(z3/z1-z1/z3)-z1/(z1*z2-z2/z3)))));

//return z1*(z2/i-i*Im(z1-z2/z3)-Re(z3*z2-z1/(z3+z2))/i)*(2.5/i-i/3.7-Re(z1/(z2+z3))/Im(z1/i-i*z2));

//return z1*z3*z2-z1*(z2-z3*z1*(z2-z1)*(z3+z1)*(z1*z2-z2+z3));
//return z3*z2-z1*(z2-z3*z1*(z2-z1)*(z3+z1));
//return (z1-z2)*(z2-z3)*(z3-z1)*(z1+z2)*(z2+z3)*(z1+z3);
//return (z1-z2)*(z2-z3)*(z3-z1)*(z1+z2)*(z2+z3)*(z1+z3)*(z2*z1-z3)*(z1*z3+z2);
};



TComplexNum GccE2()
{
    return  (z1*z2/(z1+z2)+z1/(x/z1+z2/y)-z2*(z3*t-x*z2)*(z1+x)*(y+z3)+z3*z2*(z3-y)/(y+z1))*(1.5*z1-3.7/z2+2.5*x*z3)*(z3/(1.7-z3*y)-y/z1)*((x*z1+z2*t+1.5)/(z1*z3+t)+z3)/(z3*(z1*2.5+1.7*t*z2)+z2*z3*t*2.7);

}



TComplexNum GccE3S()
{
    return  (z1*z2+z3/z1+z2/(z1*z2-z3/z1))/(z2/z3-z3/z1)-z1*z2*z3*(z2/z3-z3/z1)/(z3-z2/(z1*z2-z3/z1));

}


TComplexNum GccE4S()
{
    return  z1*(z2/z3-x/(z1+z2))-i/(z1*i-i/z2)+z2*(y*i-Re(z2/z3)*Im(i/z2))-z3/(i/(z1*i-i/z2)-z1*(z2/z3-x/(z1+z2)))+(z2-z3)/(z2*(y*i-Re(z2/z3)*Im(i/z2))-z3/(i/(z1*i-i/z2)-z1*(z2/z3-x/(z1+z2))));

}




//sp3(z1,sp2(z1+z3,x+z2)+sp2(sp2(z1+z2,t+y)+z2,sp3(z1,z3,z2)+sp2(x+y,z1+z2)),z3+z1+sp2(z3+x,y+z1))+sp2(sp2(x+t,y+x),sp1(z2+z3)+sp1(x+t))+sp3(x,y,y+t+x)+sp2(z1+z2+sp2(z2,t+z3),sp1(z3)+x+z2)+sp2(sp2(z3+y,x+z2),z2);


TComplexNum GccFE13()
{
return sp3(z1,sp2(z1+z3,x-z2)-sp2(sp2(z1+z2,t+y)-z2,sp3(z1,z3,-z2)*sp2(x+y,z1-z2)),z3-z1*sp2(z3*x,-y*z1))*sp2(-sp2(x*t,-y*x),sp1(z2+z3)*sp1(x-t))-sp3(x,y,y-t*x)*sp2(z1-z2*sp2(z2,t+z3),sp1(z3)*x-z2)*sp2(-sp2(z3+y,x+z2),z2);
//return   sp3(z1,sp2(z1+z3,x-z2)-sp2(sp2(z1+z2,t+y)-z2,sp3(z1,z3,z2)*sp2(x+y,z1-z2)),z3-z1*sp2(z3*x,y*z1))*sp2(sp2(x*t,y*x),sp1(z2+z3)*sp1(x-t))-sp3(x,y,y-t*x)*sp2(z1-z2*sp2(z2,t+z3),sp1(z3)*x-z2)*sp2(sp2(z3+y,x+z2),z2);
  //return   sp3(z1,sp2(z1+z3,x+z2)+sp2(sp2(z1+z2,t+y)+z2,sp3(z1,z3,z2)+sp2(x+y,z1+z2)),z3+z1+sp2(z3+x,y+z1))+sp2(sp2(x+t,y+x),sp1(z2+z3)+sp1(x+t))+sp3(x,y,y+t+x)+sp2(z1+z2+sp2(z2,t+z3),sp1(z3)+x+z2)+sp2(sp2(z3+y,x+z2),z2);
  //return sp2(sp2(x+t,y+x),sp1(z2+z3)+sp1(x+t))+sp3(x,y,y+t+x)+sp2(z1+z2+sp2(z2,t+z3),sp1(z3)+x+z2)+sp2(sp2(z3+y,x+z2),z2);
  //return sp2(sp2(x+t,y+x),sp1(z2+z3))+sp2(z1+z2+sp2(z2,t+z3),sp1(z3)+x+z2);
  //return sp2(sp2(x+t,y+x),sp1(z2+z3))+sp2(z1+z2+sp2(z2,t+z3),x+z2);
  //return sp2(y+x,z2+z3)+sp2(z1+z2+t+z3,x+z2);
  //return sp2(z1+z2+t+z3,x+z2);
  //return sp2(y,z2)+sp2(z3,z1)+x;
}



TComplexNum GccFE14()
{
  //return spall(ve,n,z1,vd,n,x,z2,y,vi,k);
  return spall(ve,n+3,spall(ve,n+1,z1/z2,vd,j+k-1,x,z2/spall(ve,j+3,z3-spall(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/spall(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-spall(ve,k+3,z1/spall(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*spall(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j);

}



TComplexNum GccA6()
{
     INT32 ci,cj,L;
     TComplexNum res;


L = vd.size()-1;
     //L = 99;
     res.re = 0; res.im = 0;
     for(ci=0; ci <= L; ci++)
     {
          if(vd[ci] > 0)
          {
             for(cj=0; cj <= L; cj++)
               {
                 if((cj > ci)&&(vd[cj] > vd[ci]))
                    {
                        res=res-z1*vd[cj-ci];
                    }
                    else
                    {
                        res=res+z1*vd[cj];
                    };

               }
          }
          else
          {
              //res=res-z2*vd[L-i];
              res.re=res.re-z2.re*vd[L-ci];
              res.im=res.im-z2.im*vd[ci];
         }
     };

  return res;

};






TComplexNum GccA6F()
{
     INT32 ci,cj,L;
      TComplexNum res;


L = vdf.size()-1;
     //L = 99;
     res.re = 0; res.im = 0;

     for(ci=1; ci <= L; ci++)  /// in C++ count from 1  !! (if array in Foreval as "fast connect")
     {
          if(vdf[ci] > 0)
          {
             for(cj=1; cj <= L; cj++)  /// in C++ count from 1  !! (if array in Foreval as "fast connect")
               {
                 if((cj > ci)&&(vdf[cj] > vdf[ci]))
                    {
                        res=res-z1*vdf[cj-ci+1];  /// in C++ count from 1  !! (if array in Foreval as "fast connect")
                    }
                    else
                    {
                        res=res+z1*vdf[cj];

                    };

               }
          }
          else
          {
              //res=res-z2*vdf[L+1-i];  /// in C++ count from 1  !! (if array in Foreval as "fast connect")
              res.re=res.re-z2.re*vdf[L-ci+1]; /// in C++ count from 1  !! (if array in Foreval as "fast connect")
              res.im=res.im-z2.im*vdf[ci];
         }
     };

  return res;

};



void TestEvalCmp(PTGccTest GccFunc, Pointer32 FFunc)
{

       Extended resGr,resGi,resFr,resFi,h,dh,dx,dy,dt,dz1,dz2,dz3;
       double dresG_re,dresG_im,dresF_re,dresF_im,si;
       INT32 t1,t2,i,PerfG,PerfF,dn,dk,dj;
       TComplexNum resG;
       TComplex resF;
       string S1r,S2r,SResG,SResF;



       RefReshVar();
       si=log10(GNC)/3;
       dn=(INT32)trunc(si+3);
       dk=(INT32)trunc(si+2);
       dj=(INT32)trunc(si+1);

       resG.re=0.0; resG.im=0.0; //h=0.0000001;
       dh=(Extended)1/GNC;
       dx=dh*0.123; dy=dh*0.456; dt=0.321*dh;
       dz1=dh*0.135; dz2=dh*0.357; dz3=0.531*dh;


       t1=GetTickCount();
       for(i=0; i <= GNC; i++)
       {
		   x=x+dx; y=y-dy; t=t+dt;
		  //n=n+dn; k=k+dk; j=j+dj;
          z1.re=z1.re+dz1; z2.re=z2.re+dz2; z3.re=z3.re+dz3; z1.im=z1.im-dz1; z2.im=z2.im-dz2; z3.im=z3.im-dz3;
	    resG=resG+GccFunc();
	    //resG=GccFunc();
           //z3.im=z3.im+dt; z3.re=z3.re-dt; z1.re=z1.re-dx; z2.re=z2.re-dy; z2.im=z2.im+dy;  z1.im=z1.im+dx;
          //j=j-dj; k=k-dk;  n=n-dn;
           //t=t-dt;  y=y+dy; x=x-dx;
       }
       t2=GetTickCount();

       if (t1 == t2)
       {
         PerfG=0;
       }
       else
       {
        PerfG=INT32(GNC/(t2-t1));
       };

       RefReshVar();
       resf.re=0.0; resf.im = 0.0;//h=0.0000001;

       t1=GetTickCount();
       for(i=0; i <= GNC; i++)
       {


	    //resF=resF+flResultF(FFunc);
          x=x+dx; y=y-dy; t=t+dt;
		  //n=n+dn; k=k+dk; j=j+dj;
	      z1f.re=z1f.re+dz1; z2f.re=z2f.re+dz2; z3f.re=z3f.re+dz3; z1f.im=z1f.im-dz1; z2f.im=z2f.im-dz2; z3f.im=z3f.im-dz3;
	    fzResult(FFunc);
	      //z3f.im=z3f.im+dt; z3f.re=z3f.re-dt; z1f.re=z1f.re-dx; z2f.re=z2f.re-dy; z2f.im=z2f.im+dy;  z1f.im=z1f.im+dx;
          //j=j-dj; k=k-dk;  n=n-dn;
          //t=t-dt;  y=y+dy; x=x-dx;
       }
       t2=GetTickCount();

       if (t1 == t2)
       {
         PerfF=0;
       }
       else
       {
        PerfF=INT32(GNC/(t2-t1));
       };
/*
    dresG_re=resG.re/GNC; dresG_im=resG.im/GNC;
    dresF_re=resf.re/GNC; dresF_im=resf.im/GNC;

    S1r=FloatToStr(dresG_re);
    S2r=FloatToStr(dresG_im);
    SResG=S1r+"  "+S2r+"i";

    S1r=FloatToStr(dresF_re);
    S2r=FloatToStr(dresF_im);
    SResF=S1r+"  "+S2r+"i";





    printf("\n");
    printf("Result GCC     :  %.12f", dresG_re); printf(" "); printf("%.12f", dresG_im); printf("i\n");
    printf("Result ForevalZ:  %.12f", dresF_re); printf(" "); printf("%.12f", dresF_im); printf("i\n");
 */

    printf("Result GCC      :  %.12e", (double)(resG.re/GNC)); printf(" "); printf("%.12e",  (double)(resG.im/GNC)); printf("i\n");
    printf("Result ForevalZ :  %.12e", (double)(resf.re/GNC)); printf(" "); printf("%.12e",  (double)(resf.im/GNC)); printf("i\n");


    //printf("Result ForevalZ:  %.17f\n", SResF.c_str());
    printf("Perfomance GCC  Expr/ms     :  %5d\n", PerfG);
    printf("Perfomance ForevalZ  Expr/ms:  %5d\n", PerfF);
    printf("\n");

};




void TestEvalCmpFE(PTGccTest GccFunc, Pointer32 FFunc)
{

       Extended resGr,resGi,resFr,resFi,h,dh,dx,dy,dt,si,dz1,dz2,dz3;
       double dresG_re,dresG_im,dresF_re,dresF_im;
       INT32 t1,t2,i,PerfG,PerfF,dn,dk,dj;
       TComplexNum resG;
       TComplex resF;
       string S1r,S2r,SResG,SResF;



       RefReshVar();
       si=log10((Extended)GNC)/3;
       dn=(INT32)trunc(si+3);
       dk=(INT32)trunc(si+2);
       dj=(INT32)trunc(si+1);

       resG.re=0.0; resG.im=0.0; //h=0.0000001;
       dh=(Extended)1/(GNC);
       dx=dh*0.123; dy=dh*0.456; dt=0.321*dh;
       dz1=dh*0.135; dz2=dh*0.357; dz3=0.531*dh;


       t1=GetTickCount();
       for(i=0; i <= GNC; i++)
       {
		   x=x+dx; y=y-dy; t=t+dt;
		   n=n+dn; k=k+dk; j=j+dj;
           z1.re=z1.re+dz1; z2.re=z2.re+dz2; z3.re=z3.re+dz3; z1.im=z1.im-dz1; z2.im=z2.im-dz2; z3.im=z3.im-dz3;
	    resG=resG+GccFunc();
           //z1.re=z1.re-dx; z2.re=z2.re-dy; z3.re=z3.re-dt; z1.im=z1.im+dx; z2.im=z2.im+dy; z3.im=z3.im+dt;
           j=j-dj; k=k-dk;  n=n-dn;
           //t=t-dt;  y=y+dy; x=x-dx;
       }
       t2=GetTickCount();

       if (t1 == t2)
       {
         PerfG=0;
       }
       else
       {
        PerfG=INT32(GNC/(t2-t1));
       };

       RefReshVar();
       resf.re=0.0; resf.im = 0.0;//h=0.0000001;

       t1=GetTickCount();
       for(i=0; i <= GNC; i++)
       {
		  x=x+dx; y=y-dy; t=t+dt;
		  n=n+dn; k=k+dk; j=j+dj;
	      z1f.re=z1f.re+dz1; z2f.re=z2f.re+dz2; z3f.re=z3f.re+dz3; z1f.im=z1f.im-dz1; z2f.im=z2f.im-dz2; z3f.im=z3f.im-dz3;
	   fzResult(FFunc);
	      //z1f.re=z1f.re-dx; z2f.re=z2f.re-dy; z3f.re=z3f.re-dt; z1f.im=z1f.im+dx; z2f.im=z2f.im+dy; z3f.im=z3f.im+dt;
          j=j-dj; k=k-dk;  n=n-dn;
          //t=t-dt;  y=y+dy; x=x-dx;
       }
       t2=GetTickCount();

       if (t1 == t2)
       {
         PerfF=0;
       }
       else
       {
        PerfF=INT32(GNC/(t2-t1));
       };
/*
    dresG_re=resG.re/GNC; dresG_im=resG.im/GNC;
    dresF_re=resf.re/GNC; dresF_im=resf.im/GNC;

    S1r=FloatToStr(dresG_re);
    S2r=FloatToStr(dresG_im);
    SResG=S1r+"  "+S2r+"i";

    S1r=FloatToStr(dresF_re);
    S2r=FloatToStr(dresF_im);
    SResF=S1r+"  "+S2r+"i";

*/



    printf("\n");
    printf("Result GCC      :  %.12e", (double)(resG.re/GNC)); printf(" "); printf("%.12e",  (double)(resG.im/GNC)); printf("i\n");
    printf("Result ForevalZ :  %.12e", (double)(resf.re/GNC)); printf(" "); printf("%.12e",  (double)(resf.im/GNC)); printf("i\n");

    //printf("Result ForevalZ:  %.17f\n", SResF.c_str());
    printf("Perfomance GCC  Expr/ms     :  %5d\n", PerfG);
    printf("Perfomance ForevalZ  Expr/ms:  %5d\n", PerfF);
    printf("\n");

};




void TestEvalF(Pointer32 FFunc)
{

       Extended resGr,resGi,resFr,resFi,h,dh,dx,dy,dt,dz1,dz2,dz3;
       double dresG_re,dresG_im,dresF_re,dresF_im,si;
       INT32 t1,t2,i,PerfG,PerfF,dn,dk,dj;
       TComplexNum resG;
       TComplex resF;
       string S1r,S2r,SResG,SResF;



       RefReshVar();
       si=log10(GNC)/3;
       dn=(INT32)trunc(si+3);
       dk=(INT32)trunc(si+2);
       dj=(INT32)trunc(si+1);

       resf.re=0.0; resf.im = 0.0;//h=0.0000001;
       dh=(Extended)1/(GNC);
       dx=dh*0.123; dy=dh*0.456; dt=0.321*dh;
       dz1=dh*0.135; dz2=dh*0.357; dz3=0.531*dh;

       t1=GetTickCount();
       for(i=0; i <= GNC; i++)
       {

           x=x+dx; y=y-dy; t=t+dt;
           n=n+dn; k=k+dk; j=j+dj;
	       z1f.re=z1f.re+dz1; z2f.re=z2f.re+dz2; z3f.re=z3f.re+dz3; z1f.im=z1f.im-dz1; z2f.im=z2f.im-dz2; z3f.im=z3f.im-dz3;
	     fzResult(FFunc);
	      //z1f.re=z1f.re-dx; z2f.re=z2f.re-dy; z3f.re=z3f.re-dt; z1f.im=z1f.im+dx; z2f.im=z2f.im+dy; z3f.im=z3f.im+dt;
           j=j-dj; k=k-dk;  n=n-dn;
           //t=t-dt;  y=y+dy; x=x-dx;
       }
       t2=GetTickCount();

       if (t1 == t2)
       {
         PerfF=0;
       }
       else
       {
        PerfF=INT32(GNC/(t2-t1));
       };

/*
    dresF_re=resf.re/GNC; dresF_im=resf.im/GNC;


    S1r=FloatToStr(dresF_re);
    S2r=FloatToStr(dresF_im);
    SResF=S1r+"  "+S2r+"i";





    printf("\n");
    printf("Result ForevalZ:  %.12f", dresF_re); printf(" "); printf("%.12f", dresF_im); printf("i\n");
*/
    printf("\n");
    printf("Result ForevalZ     :  %.12e", (double)(resf.re/GNC)); printf(" "); printf("%.12e",  (double)(resf.im/GNC)); printf("i\n");

    //printf("Result ForevalZ:  %.17f\n", SResF.c_str());
    printf("Perfomance ForevalZ  Expr/ms:  %5d\n", PerfF);
    printf("\n");

};



void TestEvalCmpV(PTGccTest GccFunc, Pointer32 FFunc)
{
       TFloatType resF,h;
       TComplexNum resG;
       //Extended resG;
       Extended dh,dx,dy,dt,dz1,dz2,dz3;
       double dresG,dresF,si;
       INT32 t1,t2,ni,ci,PerfG,PerfF,dn,dk,dj,ar,br,SZ,L;
       PInteger     pint1;

       SZ = rand() % 10+100 ;  /// size array changed in rand[95,105]

       vdf.resize(SZ+2);  ///change size
       ar=1; br=50; L = vdf.size()-1;

       for(ni=1; ni <= L; ni++)  /// in C++ count from 1  !! (if array in Foreval as "fast connect")
       {
           vdf[ni]=ni+1;
           vdf[ni]=pow((double)(-1),(Int32)(ni+1))*vdf[ni]*0.5;
       };


       /// to write length: (If the size of the array does not change, this is not necessary)**/
           adrVDF=&vdf[1];
           pint1 = (PInteger)adrVDF;
           pint1=pint1-1;   /// = &vdf[1]-4b; or = &vdf[0]+4b;  sizeof(double) = 8
           if (GLT == 1) {SZ = vdf.size()-1;} else {SZ=vdf.size()-2;};  /// GLT=1(Delphi); GLT=2(FPC),  in FPC Length=High
           *pint1 = SZ;  /// pint1 = &vdf[1]-4b;  *pint1 <- length


       RefReshVar();
       si=log10(GNC)/3;
       dn=(INT32)trunc(si+3);
       dk=(INT32)trunc(si+2);
       dj=(INT32)trunc(si+1);
       resG.re=0.0; resG.im=0.0;
       dh=(Extended)1/GNC;
       dx=dh*0.123; dy=dh*0.456; dt=0.321*dh;
       dz1=dh*0.135; dz2=dh*0.357; dz3=0.531*dh;

       t1=GetTickCount();
       for(ci=0; ci <= GNC; ci++)
       {
          //x=x+dx; y=y-dy; t=t+dt;
          //n=n+dn; k=k+dk; j=j-dj;
		  z1.re=z1.re+dz1; z2.re=z2.re+dz2; z3.re=z3.re+dz3; z1.im=z1.im-dz1; z2.im=z2.im-dz2; z3.im=z3.im-dz3;
	    //resG=resG+GccFunc();
	    resG.re=resG.re+GccFunc().re;
          //k=k-dk; j=j+dj; n=n-dn;

       }
       t2=GetTickCount();

       if (t1 == t2)
       {
         PerfG=0;
       }
       else
       {
        PerfG=INT32(GNC/(t2-t1));
       };

       RefReshVar();

       resf.re=0; resf.im=0;
       t1=GetTickCount();
       for(ci=0; ci <= GNC; ci++)
       {
          //x=x+dx; y=y-dy; t=t+dt;
          //n=n+dn; k=k+dk; j=j-dj;
		  z1f.re=z1f.re+dz1; z2f.re=z2f.re+dz2; z3f.re=z3f.re+dz3; z1f.im=z1f.im-dz1; z2f.im=z2f.im-dz2; z3f.im=z3f.im-dz3;
        fzResult(FFunc);
         //k=k-dk; j=j+dj; n=n-dn;

       }
       t2=GetTickCount();

       if (t1 == t2)
       {
         PerfF=0;
       }
       else
       {
        PerfF=INT32(GNC/(t2-t1));
       };


   // dresG=resG; dresF=resF;
    //printf("\n");


    printf("Result GCC      :  %.12e", (double)(resG.re/GNC)); printf(" "); printf("%.12e",  (double)(resG.im/GNC)); printf("i\n");
    printf("Result ForevalZ :  %.12e", (double)(resf.re/GNC)); printf(" "); printf("%.12e",  (double)(resf.im/GNC)); printf("i\n");

    //printf("Result ForevalZ:  %.17f\n", SResF.c_str());
    printf("Perfomance GCC  Expr/ms     :  %5d\n", PerfG);
    printf("Perfomance ForevalZ  Expr/ms:  %5d\n", PerfF);
    printf("\n");
    //printf("\n");
};


void CompileTest()
{


                                       /// arithmetic expressions:

//ExprE1 = " res=res+z1*z2-z3*(z1+z2-z3*(z1-z2*(z2-z1))-z1*z3*(z3-z2)*z2)+z2*(z1+z3+z2*(z1-z3)-z1*(z3-z1))*z1";
//ExprE1 = "x*(y*x+t*(-x-(-y-x*(-y/x+x*(x*y+y*(t+x)))/(-y*(x*y*t*(x+t)*(y+t)/(y/t+x/(t-y))))/(y*(y/(x+y+t)-x/(x*y+t/(y+x*(y-x))))-x*(t/(t-x)+y*x/(y-x*(t/y-t)-t*(x*(-t-y-x))))))))";

//ExprE1 = " res=res+z1*(z3-z2+z1)*z2+z2*(z1+z2-z3)*z3";
//ExprE1 = "res=res+z1*(2.1*z2-3.5*z3)*1.5-3.2*(4.7-z1-z3*(2.2*z1*z3-1.7*z2)+1.2*z2*z1*(2.1*z2*z3-3.2*z1)*(1.6*z1-3.9*z2))";
//ExprE1 = "res=res+z1*z2*z3+z3+z1+z2";

//ExprE1 = "res=res+z1*z2*(z2*z1-z3*z2*(z1*z3+z2*z3*(z3*z1+z1*z2)))";

//ExprE1 = "res=res+(z1/z2-z1*z2)*((z3-z1)*(z1+z2)-z3/z2)*(z1*z3/(z1-z2+z3))/((z3-z2/(z3-z1))*(z2*z3-z1/(z3/z1-z2/(z2-z1))))";
//ExprE1 = "res=res+((z1-z2)/(z3-z1)-(z1+(z3-z2*z1)/(z1-z3+z2))*(z3-z2))*(z3+z2-(z1-z2)*(z3-z1/z3))";
//ExprE1 = "res=res+(z1/z3-z2/(z1*z2-z3)+z3*(z2/(z3/z1-z1/z3)-z1/(z1*z2-z2/z3))+(z2*z3-z3*(z1+z2)/(z2/(z1*z2-z3)-z1/(z1*z2-z2/z3))))/((z2*z3-z1*z2)/(z3*(z2/z3+z3*(z2/(z3/z1-z1/z3)-z1/(z1*z2-z2/z3)))))";

//ExprE1 = "res=res+z1*(z2/i-i*Im(z1-z2/z3)-Re(z3*z2-z1/(z3+z2))/i)*(2.5/i-i/3.7-Re(z1/(z2+z3))/Im(z1/i-i*z2))";



//ExprE1 = "res=res+z1*z3*z2-z1*(z2-z3*z1*(z2-z1)*(z3+z1)*(z1*z2-z2+z3))";
//ExprE1 = "res=res+z3*z2-z1*(z2-z3*z1*(z2-z1)*(z3+z1))";
//ExprE1 = "res=res+(z1-z2)*(z2-z3)*(z3-z1)*(z1+z2)*(z2+z3)*(z1+z3)";
//ExprE1 = "res=res+(z1-z2)*(z2-z3)*(z3-z1)*(z1+z2)*(z2+z3)*(z1+z3)*(z2*z1-z3)*(z1*z3+z2)";


ExprE1 = "res=res+(z1-z2)*(z2-z3)*(z3-z1)*(z1+z2)*(z2+z3)*(z1+z3)*(z2*z1-z3)-z2*(z1*z3+z2)*(z1+z2*z3)";
//mix
ExprE2 = "res=res+(z1*z2/(z1+z2)+z1/(x/z1+z2/y)-z2*(z3*t-x*z2)*(z1+x)*(y+z3)+z3*z2*(z3-y)/(y+z1))*(1.5*z1-3.7/z2+2.5*x*z3)*(z3/(1.7-z3*y)-y/z1)*((x*z1+z2*t+1.5)/(z1*z3+t)+z3)/(z3*(z1*2.5+1.7*t*z2)+z2*z3*t*2.7)";

//common subexpr:
ExprE3S = "res=res+(z1*z2+z3/z1+z2/(z1*z2-z3/z1))/(z2/z3-z3/z1)-z1*z2*z3*(z2/z3-z3/z1)/(z3-z2/(z1*z2-z3/z1))";
ExprE4S = "res=res+z1*(z2/z3-x/(z1+z2))-i/(z1*i-i/z2)+z2*(y*i-Re(z2/z3)*Im(i/z2))-z3/(i/(z1*i-i/z2)-z1*(z2/z3-x/(z1+z2)))+(z2-z3)/(z2*(y*i-Re(z2/z3)*Im(i/z2))-z3/(i/(z1*i-i/z2)-z1*(z2/z3-x/(z1+z2))))";



ExprA6 =  "resl:extCx=0; ci:int=0; cj:int=0; L:int=Len(vd)-1;   for(ci,0,L,ifp(vd[ci] >0,for(cj,0,L,ifp((cj > ci)and(vd[cj]  > vd[ci]), resl=resl-z1*vd[cj-ci], resl=resl+z1*vd[cj])),  resl.re=resl.re-z2.re*vd[L-ci];  resl.im=resl.im-z2.im*vd[ci];)); res=res+resl";
ExprA6F = "resl:extCx=0; ci:int=0; cj:int=0; L:int=Len(vdf)-1;  for(ci,0,L,ifp(vdf[ci]>0,for(cj,0,L,ifp((cj > ci)and(vdf[cj] > vdf[ci]),resl=resl-z1*vdf[cj-ci],resl=resl+z1*vdf[cj])), resl.re=resl.re-z2.re*vdf[L-ci]; resl.im=resl.im-z2.im*vdf[ci];)); res=res+resl";



ExprFE13SP = "res=res+sp3(z1,sp2(z1+z3,x-z2)-sp2(sp2(z1+z2,t+y)-z2,sp3(z1,z3,-z2)*sp2(x+y,z1-z2)),z3-z1*sp2(z3*x,-y*z1))*sp2(-sp2(x*t,-y*x),sp1(z2+z3)*sp1(x-t))-sp3(x,y,y-t*x)*sp2(z1-z2*sp2(z2,t+z3),sp1(z3)*x-z2)*sp2(-sp2(z3+y,x+z2),z2)";
ExprFE13PS = "res=res+ps3(z1,ps2(z1+z3,x-z2)-ps2(ps2(z1+z2,t+y)-z2,ps3(z1,z3,-z2)*ps2(x+y,z1-z2)),z3-z1*ps2(z3*x,-y*z1))*ps2(-ps2(x*t,-y*x),ps1(z2+z3)*ps1(x-t))-ps3(x,y,y-t*x)*ps2(z1-z2*ps2(z2,t+z3),ps1(z3)*x-z2)*ps2(-ps2(z3+y,x+z2),z2)";
ExprFE13MS = "res=res+ms3(z1,ms2(z1+z3,x-z2)-ms2(ms2(z1+z2,t+y)-z2,ms3(z1,z3,-z2)*ms2(x+y,z1-z2)),z3-z1*ms2(z3*x,-y*z1))*ms2(-ms2(x*t,-y*x),ms1(z2+z3)*ms1(x-t))-ms3(x,y,y-t*x)*ms2(z1-z2*ms2(z2,t+z3),ms1(z3)*x-z2)*ms2(-ms2(z3+y,x+z2),z2)";
ExprFE13PC = "res=res+pc3(z1,pc2(z1+z3,x-z2)-pc2(pc2(z1+z2,t+y)-z2,pc3(z1,z3,-z2)*pc2(x+y,z1-z2)),z3-z1*pc2(z3*x,-y*z1))*pc2(-pc2(x*t,-y*x),pc1(z2+z3)*pc1(x-t))-pc3(x,y,y-t*x)*pc2(z1-z2*pc2(z2,t+z3),pc1(z3)*x-z2)*pc2(-pc2(z3+y,x+z2),z2)";

//ExprFE14SP = "res=res+spall(ve,n,z1,vd,n,x,z2,y,vi,k)";
ExprFE14PS = "res=res+psall(ve,n+3,psall(ve,n+1,z1/z2,vd,j+k-1,x,z2/psall(ve,j+3,z3-psall(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/psall(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-psall(ve,k+3,z1/psall(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*psall(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j)";
ExprFE14MS = "res=res+msall(ve,n+3,msall(ve,n+1,z1/z2,vd,j+k-1,x,z2/msall(ve,j+3,z3-msall(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/msall(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-msall(ve,k+3,z1/msall(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*msall(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j)";
ExprFE14PC = "res=res+pcall(ve,n+3,pcall(ve,n+1,z1/z2,vd,j+k-1,x,z2/pcall(ve,j+3,z3-pcall(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/pcall(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-pcall(ve,k+3,z1/pcall(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*pcall(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j)";


fzCompile(ExprE1.c_str(),FuncE1);
fzCompile(ExprE2.c_str(),FuncE2);
fzCompile(ExprE3S.c_str(),FuncE3S);
fzCompile(ExprE4S.c_str(),FuncE4S);

fzCompile(ExprA6.c_str(),FuncA6);
fzCompile(ExprA6F.c_str(),FuncA6F);

fzCompile(ExprFE13SP.c_str(),FuncFE13SP);

fzCompile(ExprFE13PS.c_str(),FuncFE13PS);
fzCompile(ExprFE13MS.c_str(),FuncFE13MS);
fzCompile(ExprFE13PC.c_str(),FuncFE13PC);

fzCompile(ExprFE14PS.c_str(),FuncFE14PS);
fzCompile(ExprFE14MS.c_str(),FuncFE14MS);
fzCompile(ExprFE14PC.c_str(),FuncFE14PC);

/*
flCompile(ExprE2.c_str(),0,FuncE2);
flCompile(ExprE3S.c_str(),0,FuncE3S);
flCompile(ExprE4S.c_str(),0,FuncE4S);
flCompile(ExprA5.c_str(),0,FuncA5);
flCompile(ExprA6.c_str(),0,FuncA6);
flCompile(ExprP7.c_str(),0,FuncP7);
flCompile(ExprP7A.c_str(),0,FuncP7A);
flCompile(ExprF8.c_str(),0,FuncF8);
flCompile(ExprF9.c_str(),0,FuncF9);
flCompile(ExprF10S.c_str(),0,FuncF10S);
flCompile(ExprF11S.c_str(),0,FuncF11S);
flCompile(ExprF12S.c_str(),0,FuncF12S);
flCompile(ExprFE13SP.c_str(),0,FuncFE13SP);
flCompile(ExprFE13PS.c_str(),0,FuncFE13PS);
flCompile(ExprFE13MS.c_str(),0,FuncFE13MS);
flCompile(ExprFE14SP.c_str(),0,FuncFE14SP);
flCompile(ExprFE14PS.c_str(),0,FuncFE14PS);
flCompile(ExprFE14MS.c_str(),0,FuncFE14MS);
*/
};


void CompareTest()
{
  Extended resG,resF,h,dh,dx,dy,dt;
  double dresG,dresF;
  //TFloatType resG,resF;
  INT32 rt,FpuExc,t1,t2,i,ECode,PerfG,PerfF,GNCt;
  Pointer32 Func;
  string Expr;

  PTGccTest GccFunc;



printf("\n");
printf("**********************************  arithmetic expressions: complex  ****************************************\n");
printf("\n");
printf("(z1-z2)*(z2-z3)*(z3-z1)*(z1+z2)*(z2+z3)*(z1+z3)*(z2*z1-z3)-z2*(z1*z3+z2)*(z1+z2*z3)\n");
printf("\n");
printf("********************************** RUN ****************************************\n");
TestEvalCmp(GccE1,FuncE1);
printf("\n");

printf("**********************************  arithmetic expressions: complex+real  ****************************************\n");
printf("\n");
printf("(z1*z2/(z1+z2)+z1/(x/z1+z2/y)-z2*(z3*t-x*z2)*(z1+x)*(y+z3)+z3*z2*(z3-y)/(y+z1))*(1.5*z1-3.7/z2+2.5*x*z3)*(z3/(1.7-z3*y)-y/z1)*((x*z1+z2*t+1.5)/(z1*z3+t)+z3)/(z3*(z1*2.5+1.7*t*z2)+z2*z3*t*2.7)\n");
printf("\n");
printf("********************************** RUN ****************************************\n");
TestEvalCmp(GccE2,FuncE2);
printf("\n");


printf("\n");
printf("**********************************  arithmetic expressions: complex, with common subexpression  ****************************************\n");
printf("\n");
printf("(z1*z2+z3/z1+z2/(z1*z2-z3/z1))/(z2/z3-z3/z1)-z1*z2*z3*(z2/z3-z3/z1)/(z3-z2/(z1*z2-z3/z1))\n");
printf("\n");
printf("********************************** RUN ****************************************\n");
TestEvalCmp(GccE3S,FuncE3S);
printf("\n");


printf("\n");
printf("**********************************  arithmetic expressions: complex+real, with common subexpression  ****************************************\n");
printf("\n");
printf("z1*(z2/z3-x/(z1+z2))-i/(z1*i-i/z2)+z2*(y*i-Re(z2/z3)*Im(i/z2))-z3/(i/(z1*i-i/z2)-z1*(z2/z3-x/(z1+z2)))+(z2-z3)/(z2*(y*i-Re(z2/z3)*Im(i/z2))-z3/(i/(z1*i-i/z2)-z1*(z2/z3-x/(z1+z2))))\n");
printf("\n");
printf("********************************** RUN ****************************************\n");
TestEvalCmp(GccE4S,FuncE4S);
printf("\n");

/*
GNCt = GNC;
GNC = GNC/100;
printf("*********************  calculations with arrays  ***********************************************\n");
printf("\n");
printf("resl:extCx=0; ci:int=0; cj:int=0; L:int=Len(vd)-1;   for(ci,0,L,ifp(vd[ci] >0,for(cj,0,L,ifp((cj > ci)and(vd[cj]  > vd[ci]), resl=resl-z1*vd[cj-ci], resl=resl+z1*vd[cj])),  resl.re=resl.re-z2.re*vd[L-ci];  resl.im=resl.im-z2.im*vd[ci];)); res=res+resl \n");
printf("\n");
printf("********************************** RUN ****************************************\n");
TestEvalCmpV(GccA6,FuncA6);
printf("\n");
printf("*******************************************************************************\n");


printf("*********************  calculations with arrays  ***********************************************\n");
printf("\n");
printf("analogous expression with vd->vdf ; see source \n");
printf("\n");
printf("********************************** RUN ****************************************\n");
TestEvalCmpV(GccA6F,FuncA6F);
printf("\n");
printf("*******************************************************************************\n");

GNC = GNCt;
*/


printf("*********************   external functions  ***********************************************\n");
printf("\n");
printf("sp3(z1,sp2(z1+z3,x-z2)-sp2(sp2(z1+z2,t+y)-z2,sp3(z1,z3,-z2)*sp2(x+y,z1-z2)),z3-z1*sp2(z3*x,-y*z1))*sp2(-sp2(x*t,-y*x),sp1(z2+z3)*sp1(x-t))-sp3(x,y,y-t*x)*sp2(z1-z2*sp2(z2,t+z3),sp1(z3)*x-z2)*sp2(-sp2(z3+y,x+z2),z2)\n");
printf("\n");

#ifdef   EXTENDED_VAR
  printf("At Extended type of Complex, fz_STACK_VAL (sp-functions) calling don't work with  Gcc. Use other calling type. \n");
  printf("\n");
#endif


printf("********************************** RUN ****************************************\n");


#ifdef   EXTENDED_VAR
   TestEvalCmpFE(GccFE13,FuncFE13PS);
   printf("other call type: ps->ms\n");
   TestEvalF(FuncFE13MS);
   printf("other call type: ps->pc\n");
   TestEvalF(FuncFE13PC);
#else
   TestEvalCmpFE(GccFE13,FuncFE13SP);
   printf("other call type: sp->ps\n");
   TestEvalF(FuncFE13PS);
   printf("other call type: sp->ms\n");
   TestEvalF(FuncFE13MS);
   printf("other call type: sp->pc\n");
   TestEvalF(FuncFE13PC);
#endif // EXTENDED_VAR


printf("\n");
printf("*******************************************************************************\n");



printf("*********************   external functions with all type of variables  ***********************************************\n");
printf("\n");
printf("all(ve,n+3,all(ve,n+1,z1/z2,vd,j+k-1,x,z2/all(ve,j+3,z3-all(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/all(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-all(ve,k+3,z1/all(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*all(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j)\n");
printf("\n");
printf("********************************** RUN ****************************************\n");
TestEvalCmpFE(GccFE14,FuncFE14PS);
printf("other call type: ps->ms\n");
TestEvalF(FuncFE14MS);
printf("other call type: ps->pc\n");
TestEvalF(FuncFE14PC);
//printf("other call type: sp->ms\n");
//TestEvalF(FuncFE13MS);
//printf("other call type: sp->pc\n");
//TestEvalF(FuncFE13PC);
//printf("\n");
//printf("*******************************************************************************\n");












};




TComplexNum GccFunc()
{
     TComplexNum  rez;

       // rez = z1+z2*z3-z2;
 //     rez =  z2*(z1-(z3-z2+z1)*(z3*z2-z2*z1+z1*z3))+z1*z2-z2*(z1+z2-z3)*z2;
//      rez =  z3*(z1*z3-z2*(z1-z2+z3*z1)-z2*z3)-z1*z2;
//      rez =  z1/z2-z3/(z1+z2)+(z1-z3)/z2;
//      rez =  (y*(z1-z2+z3)-t*z3+(x-t)*(z3*z2*y-z1))*(z1*x-y*z2)*(z2-t+z3*(x+y));
//      rez =  z2*(z1-(z3-z2+z1)*(z3*z2-z2*z1+z1*z3))+z1*z2-z2*(z1+z2-z3)*z2-(z1*(z3+z2)*z3-(z3*z1-z3-z1))*z1;

//      rez =  z1*z2*z3*(z3*z1*(z1*z2-z3*z1)-z1*z2*(z1*z3-z2*z3)+z2*z1*(z2*z1-z3*z2)-(z1+z2)*(z1-z2)*(z3-z2)*(z1*z2-z3*z1*(z1-z2*(z3-z1*(z3-z1)*(z1-z3)*(z3-z2)-z1*z2-z2))))-(z1*z3*z2*(z1*z2-z1*(z2-z2*(z3-z3*(z1-z1*z3*(z1*z2-z3*z1-(z1*z2-z3*z1)*(z1-z2)*(z2-z3)*(z3-z2)-(z1+z3*z2)*(z2-z1*z3)+(z3-z2*z3)*(z2-z3*z1))))))) ;
//      rez = -z1/(z1/z2-z3/(z1+z3)+z1*z2*(z1*z2-z2*z3+z1/(z1/(z1+z2)+z2/(z3+z1))))*(z2*(z1-z2/(z1*z2-z2/(z1*z2+z2*z3)*(z2*z3-z1*z2)))+z1-z2*(z1-z3-z3/(z1-z2)*(z2/(z2-z3*(z1+z2*z3)*(z2-z1*z3)/(z1*z3-z2*(z1+z3))))))*(z1*z2-z3*z2-z3*(z1*z3-z2*(z3-z1)/(z1*z2*z3-z1-z2-z3)));
//      rez = z1*z2*(2.111*z1+1)*(2.211*z1*z2/z3-2.311*z1*(3.422*z3-1)/(2.511*z1-3.611*z2-4.22)*(z1/(3.711*z1-1)-4.111/z1+5.111*(2.611*z1*z2*z3-1.23)/(z2+1.12)-7.132*(2.812*z1*(z2+1.123)*(3.832*z2+2.121)*(3.112/(z1+1.123)-2.133*z3))));
//      rez = z1*z2*(z1-z3*(2.123*z1-3.222*z2-5.323)/(z3*z1*z2/(2.234-z1*z2)+(2.455*z1+3.632)*(3.734*z2-4.832*z3-5.923)-(1.134-z1)/(-z3-z2))+z1*(z2-(-z1-(-z2/(-z3*z1*(z1*z2*z3*(2.745*z1-3.345*z2-z3))-z2*(z1*z2-z2*z3*3.167+2.965*(z1/z3-z3/(z1-z2*(2.467-z1-z2-z3)))*(z2-z3)-2.376*z1)*(z2-z1)-7.154/z1)*(-1.943/z3+z1*z2*z3*5.334))-3.556*z1-5.657)-7.243*z2-3.459)/(z1-z3)+z1*(z3*z2/(z1-2.834*z3)-z2*(z1*(z3-2.756*z2-z1-5.676))));
//      rez = (z1*z2+z3*(z1*z2-z2*z3*z1-z1+z2-z3))*(z1+z2+z3)*(z1-z2-z3)*(z3-z1*(z3-z2*(z1-z2-z3)))*z1*z2*z3-z1*z3*(z1*z3-z2*z3+z1-z3)*(z2*z1+z3*z1+z3*z2-z2-z1)*(z1*z3-z2*(z1-z2*z3-z3-z1)*(z1-z2-z3)-z2*(z2+z2*z1-z3-z1)+z3*(z1*z2-z1*(z3+z2*(z1*z2-z3*z2*z1-z2*z3*(z2+z1*(z1-z3+z2*(z1-z2+z3-z1*(z1*z2-z3*z1)*(z1*z2-z3*(z1+z2+z3)*(z1-z2-z3)-z3*(-z1-z2*(-z3*(-z1*(z2-z3))))))))))));
//      rez = z1*z2-z1/(z1/z2-z3/z2-(-z1-z2*(z1*z2-z3*z1/(z1/z2-z3/z2-(-z1-(-z2-(-z3-(z1*z2-z2*(-z1*z2-z2/(z1+z2*z3)))*z1)*z2)/(z1+z2*z3)-z1*(z2/z3-(-z2*z1/(z1-z2*z3)-(-z1-(-z2/(-z1*z2*(-z1-z2))+z1/z2*(z2*z1+z2*z3-z1/(z1+z2*z3))-z1*z2*(z1*z2+(-z1*z2-z3/z2+z1-z2*z1)))))+z1*z2*z3*(z1+z2*z3)))))));
//      rez = z1*z2*(z1-z3*(2.154*z1-3.253*z2-5.353)/(z3*z1*z2/(2.544-z1*z2)+(2.143*z1+3.556)*(3.343*z2-4.153*z3-5.456)-(1.153-z1)/(-z3-z2))+z1*(z2-(-z1-(-z2/(-z3*z1*(z1*z2*z3*(2.644*z1-3.364*z2-z3))-z2*(z1*z2-z2*z3*3.164+2.267*(z1/z3-z3/(z1-z2*(2.533-z1-z2-z3)))*(z2-z3)-2.453*z1)*(z2-z1)-7.535/z1)*(-1.253/z3+z1*z2*z3*5.353))-3.433*z1-5.455)-7.466*z2-3.577)/(z1-z3)+z1*(z3*z2/(z1-2.699*z3)-z2*(z1*(z3-2.767*z2-z1-5.854)-z2*(-1.549-z1/(-z3-z2))/(z1/z2-z1/(z3/z1-z2/z3)+z3*(1/z1-5.344/z2-z1*z2*(2.435*z1-1.456)*(z3*z2*3.326-5.347)*(1.943-z1*z2*z3*3.245)*(z1+z2))))));
//      rez = (z1*z2+z3*(z1*z2-z2*z3*z1-z1+z2-z3))*(z1+z2+z3)*(z1-z2-z3)*(z3-z1*(z3-z2*(z1-z2-z3)))*z1*z2*z3-z1*z3*(z1*z3-z2*z3+z1-z3)*(z2*z1+z3*z1+z3*z2-z2-z1)*(z1*z3-z2*(z1-z2*z3-z3-z1)*(z1-z2-z3)-z2*(z2+z2*z1-z3-z1)+z3*(z1*z2-z1*(z3+z2*(z1*z2-z3*z2*z1-z2*z3*(z2+z1*(z1-z3+z2*(z1-z2+z3-z1*(z1*z2-z3*z1)*(z1*z2-z3*(z1+z2+z3)*(z1-z2-z3*(z1-z2*(z3-z1*z2-z2*(z1*z2-z3*z1)-z3*(z3*z1+z2))))-z3*(-z1-z2*(-z3*(-z1*(z2-z3*(z1*z2*z3-z2*z1*z3*(-z1*(z2*z1-z3*z2-z1-z2-z3)))))))))))))));
//      rez = (z1*z2+z3/(z1*z2-z2*z3/z1-z1+z2-z3))*(z1+z2+z3)/(z1-z2-z3)*(z3-z1*(z3-z2/(z1-z2-z3)))*z1/z2*z3-z1*z3*(z1*z3-z2*z3+z1-z3)/(z2*z1+z3*z1+z3/z2-z2-z1)*(z1*z3-z2*(z1-z2*z3-z3-z1)*(z1-z2-z3)-z2*(z2+z2*z1-z3-z1)+z3*(z1*z2-z1*(z3+z2/(z1*z2-z3*z2*z1-z2*z3*(z2+z1*(z1-z3+z2*(z1-z2+z3-z1*(z1*z2-z3*z1)*(z1*z2-z3*(z1+z2+z3)*(z1-z2-z3/(z1-z2*(z3-z1*z2-z2/(z1*z2-z3*z1)-z3/(z3/z1+z2))))-z3*(-z1-z2*(-z3/(-z1*(z2-z3*(z1*z2/z3-z2*z1*z3/(-z1*(z2*z1-z3*z2-z1-z2-z3)))))))))))))));
//      rez = z1*z2*(z1-z3*(2.156*z1-3.652*z2-5.653)/(z3*z1*z2/(2.664-z1*z2)+(2.155*z1+3.543)*(3.345*z2-4.431*z3-5.443)-(1.451-z1)/(-z3-z2))+z1*(z2-(-z1-(-z2/(-z3*z1*(z1*z2*z3*(2.453*z1-3.353*z2-z3))-z2*(z1*z2-z2*z3*3.153+2.253*(z1/z3-z3/(z1-z2*(2.533-z1-z2-z3)))*(z2-z3)-2.453*z1)*(z2-z1)-7.553/z1)*(-1.253/z3+z1*z2*z3*5.533))-3.453*z1-5.453)-7.453*z2-3.553)/(z1-z3)+z1*(z3*z2/(z1-2.653*z3)-z2*(z1*(z3-2.753*z2-z1-5.853)-z2*(-1.539-z1/(-z3-z2))/(z1/z2-z1/(z3/z1-z2/z3)+z3*(1/z1-5.553/z2-z1*z2*(2.535*z1-1.53)*(z3*z2*3.536-5.753)*(1.539-z1*z2*z3*3.665)*(z1+z2*(z3-(-z1-z2*z3/(z1*z2-2.863*(z1*z2*(z1-z2*(z1*z3+z2/z3*(2.623*z1-1.352-z3*z2))))))))))))) ;
//      rez = z1*z2*(2.251*z1+1)*(2.243*z1*z2/z3-2.353*z1*(3.475*z3-1)/(2.575*z1-3.675*z2-4.766)*(z1/(3.767*z1-1)-4.176/z1+5.186*(2.866*z1*z2*z3-1.766)/(z2+1.876)-7.165*(2.874*z1*(z2+1.641)*(3.864*z2+2.162)*(3.171/(z1+1.765)-2.173*z3/(2.174*z1*z2*z3-1.171)+(4.171*z1-1.164)*(5.172*z2-7.174)/(z1-2.175*z2-1.747-2.174*z3/(3.618-7.716*z1-8.181*z2*(4.612*z1/(2.189*z3+1.165)-7.198*z1-8.149/z3+9.912*(2.199*z1-1.261)*(3.107*z1+4.179*z2+5.108)*(2.271*z1*z2*z3-7.179)*z1*z2*z3/(z1-z2*2.282-3.621/(z1/(z3-1.147)-7.198/(z2+2.245)+8.233/(2.288*z1*z2*z3+1.247)-9.174)))))/(z1-1.525)))));

//sp3(z1,sp2(z1+z3,x-z2)-sp2(sp2(z1+z2,t+y)-z2,sp3(z1,z3,-z2)*sp2(x+y,z1-z2)),z3-z1*sp2(z3*x,-y*z1))*sp2(-sp2(x*t,-y*x),sp1(z2+z3)*sp1(x-t))
//  	rez = sp3(z1*sp2(sp1(z2-z1),sp2(z1-sp2(z3*z1,z1-z2),sp2(z3*z1,z2+z3))),sp1(z3-z2)+sp2(sp3(sp2(z1*z3,z2*z1),z3,sp2(z3-z1,z2-z1)),sp3(sp3(z1-z2,z2*z1,z2*z3),z1*sp2(z1-z2,z2-z3),z3*sp1(z1+z2))),sp3(sp1(z3+z1),sp2(z1-z2,z2*z3),sp1(z1+z2+z3)));
		 //  ps3(z1*ps2(ps1(z2-z1),ps2(z1-ps2(z3*z1,z1-z2),ps2(z3*z1,z2+z3))),ps1(z3-z2)+ps2(ps3(ps2(z1*z3,z2*z1),z3,ps2(z3-z1,z2-z1)),ps3(ps3(z1-z2,z2*z1,z2*z3),z1*ps2(z1-z2,z2-z3),z3*ps1(z1+z2))),ps3(ps1(z3+z1),ps2(z1-z2,z2*z3),ps1(z1+z2+z3)));
		 //  ms3(z1*ms2(ms1(z2-z1),ms2(z1-ms2(z3*z1,z1-z2),ms2(z3*z1,z2+z3))),ms1(z3-z2)+ms2(ms3(ms2(z1*z3,z2*z1),z3,ms2(z3-z1,z2-z1)),ms3(ms3(z1-z2,z2*z1,z2*z3),z1*ms2(z1-z2,z2-z3),z3*ms1(z1+z2))),ms3(ms1(z3+z1),ms2(z1-z2,z2*z3),ms1(z1+z2+z3)));
		 //  pc3(z1*pc2(pc1(z2-z1),pc2(z1-pc2(z3*z1,z1-z2),pc2(z3*z1,z2+z3))),pc1(z3-z2)+pc2(pc3(pc2(z1*z3,z2*z1),z3,pc2(z3-z1,z2-z1)),pc3(pc3(z1-z2,z2*z1,z2*z3),z1*pc2(z1-z2,z2-z3),z3*pc1(z1+z2))),pc3(pc1(z3+z1),pc2(z1-z2,z2*z3),pc1(z1+z2+z3)));

     //rez = spall(ve,n,z1,vd,n,x,z2,y,vi,k);

	 //rez = spall(ve,n+3,spall(ve,n+1,z1/z2,vd,j+k-1,x,z2/spall(ve,j+3,z3-spall(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/spall(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-spall(ve,k+3,z1/spall(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*spall(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j);
	      // pcall(ve,n+3,pcall(ve,n+1,z1/z2,vd,j+k-1,x,z2/pcall(ve,j+3,z3-pcall(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/pcall(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-pcall(ve,k+3,z1/pcall(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*pcall(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j)
	      // msall(ve,n+3,msall(ve,n+1,z1/z2,vd,j+k-1,x,z2/msall(ve,j+3,z3-msall(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/msall(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-msall(ve,k+3,z1/msall(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*msall(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j)

    //rez = sp3(sp2(sp3(z1,z2,z3-sp2(sp2(z1,z3),sp2(t,z2))),sp2(z2-z3,x*z1)),sp3(sp2(z2,t),sp2(y,z3),sp3(x,y,t)*sp3(z3,z1,z2)),sp3(z1-sp1(z2),z2-sp2(x*y,-z2),z3-sp2(z2-z1,x*y)));
		 // ps3(ps2(ps3(z1,z2,z3-ps2(ps2(z1,z3),ps2(t,z2))),ps2(z2-z3,x*z1)),ps3(ps2(z2,t),ps2(y,z3),ps3(x,y,t)*ps3(z3,z1,z2)),ps3(z1-ps1(z2),z2-ps2(x*y,-z2),z3-ps2(z2-z1,x*y)))
		 // ms3(ms2(ms3(z1,z2,z3-ms2(ms2(z1,z3),ms2(t,z2))),ms2(z2-z3,x*z1)),ms3(ms2(z2,t),ms2(y,z3),ms3(x,y,t)*ms3(z3,z1,z2)),ms3(z1-ms1(z2),z2-ms2(x*y,-z2),z3-ms2(z2-z1,x*y)))
		 // pc3(pc2(pc3(z1,z2,z3-pc2(pc2(z1,z3),pc2(t,z2))),pc2(z2-z3,x*z1)),pc3(pc2(z2,t),pc2(y,z3),pc3(x,y,t)*pc3(z3,z1,z2)),pc3(z1-pc1(z2),z2-pc2(x*y,-z2),z3-pc2(z2-z1,x*y)))


	// rez = (z1/z2*z3/(z1.re-z2.im*(x-i))*(-z1/(-z2-i/(-x+y*i)))/(y/(z1/x-y/z2)+z2.re/(i-z1.im)))*(-i-3.5-i*x*(-z1-z2.im*(-z1.im*i-t/(-i)*(2.5/z1*i/t-i/(-i+x/z2)))));
	 //rez = (z1.re*t-i*x*(z2.im-z1.re/(i-1.5)-i/(-i-3.5/z2-z1*(x*z3.re-t/z2)*(z2.re/z1.im-z3.re/i)+(i*2.5+1.7*z3)*(i*z1+z3/i-z3.re*z1.im*(x-z1-i))+10.5*(i*2.5+5.7))));


		//rez=z1*z2-(-y/x-i-3.6-z1+z2)*7.3;
	   //rez=z1/x;
	  // rez=2*z1*z2-i*x;
	// rez=  z1*z2-z3*(z1-z2-z1*(z2+z3-z1));
		  //rez=x+y+i0;
		  //rez=z1+z2;
	   //rez=-(-(-(-(-(-z1-(-z2-(x-(-2.5-z1-(-(-(-x-z1-(-3.2-i)-i-(-i-4.5))))-i*(-z1-3.7*i-y/i))))-9.5-(-3.5-z2/i)))-i-(-z1/(-i)-(-z2/(-x))))));
	   //rez=sp1(z1*sp2(z2,z1/sp1(z2/x-y/z2)))/sp3(z1-x,sp2(-sp2(-x/i,i/y),-7.5-i/sp3(-z1,-z2/z1,z2*i)),sp1(x*z1-i)/x);
		//rez=Re(z1*sp1(z1)*sp3(z1,z2,z3*sp2(x,z2)-sp2(z3,y)))+i;
		 // rez=sp2(z1,z2)*sp2(x,y);
      //rez=-z1-z2.im*(i*z2.re-z1.im/(z1-i*z2.re*z1.im)-z1/(-1.5-2.7*i-i*(-2.5-x*i)/(x-z1.re-(z2.im*y-i)/i)));
	   //rez=(1.5*i-2.7)*(-3.2-i*(2.7-x-(-z2-i-(-z1.re-3.5-(-x/(z1-z2*i)-i/(x-z2.im-2.3*i)))))/(-i/x*z1-z2*y/i));
	  //rez=(x*z1-z2*y)*(-i-2.1-z1*(x+y*z2.im)+(-z1.re*x-3.2)*z2-z1*(-i-z1*x)-(y-z2*i)*z2*(z1-z2*y*i))/(-z1/(x*y-3.5/(x+y))+(x-y*z2.re*z1.im)/z2);


		//rez=(z1.re-i*(-2.2-z2.im*(-y-3.1*i-i/(x/i-i/z2))-z1*z2*i*x/(-x-2.5*i-z2.im*i)))*(z1*(-i-(y/z1-z2/x*i)/(1.7-i-z2))-z2/(x-i/y))/(-i*(-x/(-z2.im-3.1))+z2*i-4.5/i);
	   //rez=sp3(z1,z2,z3*sp3(z1-x,y-z3,z2-z1*z2))*sp2(sp1(sp2(sp1(z2),sp1(z1))),sp2(z3,z2));
	   //rez=sp3(sp2(z2,sp3(z1,z3,z2)),sp3(z2,sp3(sp3(z3,z2,sp3(z2,z1,z3)),z1,z2),z3),sp1(sp3(z1,sp3(z3,sp3(z2,z3,z1),z1),z3)));
	   rez=spall(ve,n+3,spall(ve,n+1,z1/z2,vd,j+k-1,x,z2/spall(ve,j+3,z3-spall(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/spall(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-spall(ve,k+3,z1/spall(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*spall(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j);
	   //rez=spall(ve,n,z1,vd,n,x,z2,y,vi,k);
	   //rez=z1*sp2(i,x/i-z2*sp3(-x*sp1(z1-i),-3.796-i,x*(-i-z2-5.875))/5.145+sp2(-i-z2,-t-i/z2)/z1)/sp3(z1*sp1(y*i),-sp2(-z1/x,y/(z1/z2-i))/sp3(x*(z1-z2/i),-z3/z1,x/(-z3)),sp2(2.841-t*i,-z2/(-z3-i/(-x-z1)))*sp3(z1*sp1(t/i),x/i-i/y,2.5*z1-7.5/z2)/sp2(z2/x-y*z3/z2,-4.784/i-i/3.752));

	   //rez=-(-(-z1-(-z2-(-(-x-(-2.5-(-x-z1-(-3.2-i)-i-z2)))))));
		  //rez=sp1(x)*sp3(x,y,t)+i0;

 //return z1+z2*z3-z2;
 return rez;
};




CalcExpr(Pointer32 Func, TComplex   &resCx)
{

  INT32 i,t1,t2;


/**
        this construction dont't catch fpu exception !!?
  try
  {
     fzResultCxEP(Func,&resCx);
  }
  catch(...)
  {
    //error
  }

**/
  resCx.re = 0; resCx.im = 0;
  resf.re = 0;  resf.im = 0;


   fzPerform(fz_MASK_FPU_EXCEPTION,0);

   fzGet(fz_RESULT_TYPE,INT32(Func),rt);

   if (rt == fz_NONE)           /// no return number: return result in inner 'result' or 'res' variable  ( zt: complexDbl=z1+z2; zt=zt*x; result=zt  )
   {
     t1=GetTickCount();
     for(i=0; i <= GNC; i++)
     {
		 fzResult(Func);
		  //Result(Func);
     }
     t2=GetTickCount();

	     resCx.re=resf.re;
	     resCx.im=resf.im;
   }
   else
   {
	 if (ct == fz_REAL)  /// return only real result: Re(expr)
	 {

       t1=GetTickCount();
       for(i=0; i <= GNC; i++)
       {

          #ifdef   EXTENDED_VAR
               fzResultE(Func,resCx.re);
           #else
               fzResultD(Func,resCx.re);
          #endif

		 //resCx.re=Result(Func);
       }
       t2=GetTickCount();


	 }
	 else                    /// full complex result
	 {
		/// ct = fz_Complex; rt = fz_Real, fz_Complex

        t1=GetTickCount();
        for(i=0; i <= GNC; i++)
        {

		   #ifdef   EXTENDED_VAR
               fzResultCxEP(Func,&resCx);
               //fzResultCxE(Func,resCx.re,resCx.im);
           #else
               fzResultCxDP(Func,&resCx);
               //fzResultCxD(Func,resCx.re,resCx.im);
          #endif

        }
        t2=GetTickCount();

     }

   }


    fzGet(fz_IS_FPU_EXCEPTION,0,FpuExc);
	 if(FpuExc == fz_YES)
	 {
		 cout <<"Invalid operation" << endl;
		 F_CalcError = TRUE;
	 }

   if (t1 == t2)
   {
       Perf=0;
   }
   else
   {
      Perf=INT32(GNC/(t2-t1));
   }
}




CalcExprSafe(Pointer32 Func, TComplex   &resCx)
{
  Extended res;
  TComplexD   resCxd;
  double resd;
  INT32 t1,t2,i;
  string SCE;

/**
        this construction dont't catch fpu exception !!?
  try
  {
     fzResultCxEP(Func,&resCx);
  }
  catch(...)
  {
    //error
  }

**/
   resCx.re = 0; resCx.im = 0;
   resf.re = 0;  resf.im = 0;


   /// fzSet(fz_ADDRESS_EXCEPTION_FLAG , _int32(&FpuExc));	// uses in fzResultSafe, fzResultDSafe, fzResultCxDSafe,fzResultCxDPSafe;  Is set in "onLoad"

   fzGet(fz_RESULT_TYPE,INT32(Func),rt);
   if (rt == fz_NONE)       /// no return number: return result in inner 'result' or 'res' variable  ( zt: complexDbl=z1+z2; zt=zt*x; result=zt  )
   {

		  /**
		      res=sqrt(-x)
              res=x/sin(x-x)
		      x=10000; res=x^x
		   **/

        t1=GetTickCount();
        for(i=0; i<=GNC; i++)
        {
		  /// FpuExc=ResultSafe(Func);  /// more fast then:
          fzResultSafe(Func);
		  if (FpuExc != 0) { goto endc;}
        }
        t2=GetTickCount();
        resCx.re=resf.re;
        resCx.im=resf.im;
   }
   else
   {
	 if (ct == fz_REAL)  ///return only real result: Re(expr)
	 {
		   /**
		       sqrt(-x)
               x/sin(x-x)
		       x=10000; x^x
		   **/

        t1=GetTickCount();
        for(i=0; i<=GNC; i++)
        {
		   /// FpuExc=ResultFSafe(Func1,resCx.re); ///more fast then:
		   fzResultDSafe(Func,resCxd.re);
		   if (FpuExc != 0) { goto endc;}
        }
        t2=GetTickCount();
        resCx.re = resCxd.re;
	 }
	 else                    ///full complex result
	 {
		///ct = fz_Complex; rt = fz_Real, fz_Complex

        t1=GetTickCount();
        for(i=0; i<=GNC; i++)
        {
		  /// FpuExc=ResultCxDPSafe(Func,&resCxd); //more fast then:
		  /// FpuExc=ResultCxDSafe(Func,rezCxd.re,rezCxd.im);

		   fzResultCxDPSafe(Func,&resCxd);
		   /// fzResultCxDSafe(Func,resCxd.re,resCxd.im);
		   if (FpuExc != 0) { goto endc;}
        }
        t2=GetTickCount();
        resCx.re = resCxd.re; resCx.im = resCxd.im;
     }

   }

   endc:
    if (FpuExc != 0)
      {
	    switch ( FpuExc)
        {
          case  1:    SCE="Invalid operation";break;          ///  sqrt(-x)
	      case  4:    SCE="Divizion on Zero";break;           ///  x/sin(x-x)
		  case  5:    SCE="Divizion on Zero";break;           ///  z1/sin(z1-z1)
	      case  8:    SCE="Overflow in float point";break;    ///  x=10000; x^x
		  default:    SCE="Invalid operation";break;
        }
	      cout << SCE << endl;
	      F_CalcError = TRUE;
      }


   if (t1 == t2)
   {
       Perf=0;
   }
   else
   {
      Perf=INT32(GNC/(t2-t1));
   }
}



void test()
{
    int fzLoad,ECode,NC,ni,SZ,i,t1,t2;
	string Expr,strOut,strTmp,SRes,S1r,S2r;

	TStringType chE,chTmp;
	char cht;

	PInteger     pint1;

	int ndx,SafeCalc,GNCmin;
	//AnsiChar* chS = new char;
    double resd;
    //Extended res;

	Pointer32 Func,FuncDx,PS;
	TComplexD    resCxd;
    TComplex     resCx;
	TComplexNum  res;



/**
        this construction dont't catch fpu exception !!?
  try
  {
    fzResultCxEP(Func,&resCx);
  }
  catch(...)
  {
    //error
  }

**/

/**
Calculations goes with masking of interruptions to (1) CalcExpr(Func); (2) CalcExprSafe(Func);
It is a slow method. Besides, if in expression there is incorrectly written function,
 in which there is a reset of FPU masks and/or flags of exceptions, interception of an error will not work.
It is better to use catch of errors  through  interrupts in the design:

 try
  {
    fzResultCxEP(Func,&resCx);
  }
  catch(...)
  {
    //error
  };

,if you are able to force it to work! :(
**/

 fzLoad=onLoad();


 if (fzLoad != 0)
 {








/****************************  test  fast connecting of dynamic array (in VisualC++ count from '1', in foreval count from '0'   !!!)  ****************************
//                              without using   fzSetArrayValueD or CopyMemory
                               Expression FDynArray compiled in Form1_Load
**/
#ifdef   TESTFASTDYNARRAY

dynarray:
  // set randomize size of array (VECD) and fill it 1.0

	NC = rand()+2;
    vecd.clear();


	//******************first way to write array:
	/*
	     vecd.push_back(0);//reserve for length
         for (ni = 1; ni <= NC; ni++)  //count from 1 !!!
     	 {
         vecd.push_back(1.0);
	     }
	*/

	//*******************second way to write array:
    	vecd.resize(NC+1); // NC+1=length(VC++); NC = length(foreval); (>0 !!!); 1 - reserve for length (vecd[0])
       //vecd.reserve(NC+1);

       for (ni = 1; ni <= NC; ni++)  //count from 1 !!!
       {
	    vecd[ni]=1.0;
	   }

    //set length
	adrVECD=&vecd[1];//to set a new reference to the array so , as  memory location of  vecd is changed  ; after full load of array!!!
	pint1 = (PInteger)adrVECD;
	pint1=pint1-1;
	if (GLT == 1) {SZ = vecd.size()-1;} else {SZ=vecd.size()-2;};  //GLT=1(Delphi); GLT=2(FPC),  in FPC Length=High
	*pint1 = SZ;  //pint1 = &vecd[1]-4b;  *pint1 <- length

	//  len(vecd)*(sumq(vecd)/sqr(norm(vecd)))
	//  k:int=0; len:int=len(vecd); s:dbl=0; for(k,0,len-1,s=s+vecd[k]); s/sum(vecd)
	fzResultCxDP(FDynArray,&resCxd);   //without recompiling expression
	printf("result: %.17f\n", resCxd.re);

     system("pause");
     goto dynarray;

#endif // TESTFASTDYNARRAY
//************************************************************************************************************************************************


GNCmin = 20000000;
GNC = GNCmin;

newtest:



    fflush(stdin);
    printf("Run a benchmark test ForevalZ/Gcc, Y/N: ");
    cht=getchar();
    //scanf("%d", &GNC);
    if(tolower(cht) == 'y')
    {
        CompileTest();
        printf("6 examples. Each example is calculation in loop with changed of variables\n");
        printf("Enter number of loops: 2E7 - 2E9. On default(Enter) = 2E7: ");
        fflush(stdin);
        //cht=getchar();
        //scanf("%s", Schr);
        getline(cin,strTmp);
        if(strTmp == "\0")
            {GNC = GNCmin;}
            else
            {
                GNC = StrToInt(strTmp);
                if(GNC < GNCmin){GNC = 20000000;} else if(GNC > 2000000000){GNC = 2000000000;} ;
            };
        //scanf("%d", &GNC);
        CompareTest();
        goto newtest;
    }








//---------------------------------------------------------------------------------------------------------
                /**!!!!! WITH  OVERLOAD COMPLEX OPERATIONS  !!!!! **/

   #ifdef   OVERLOADCOMPLEX
   printf("  \n");
   printf(" OVERLOADCOMPLEX GCC \n");
   t1=GetTickCount();
   for(i=0; i <= GNC; i++)
   {
      res=GccFunc();
   }

   t2=GetTickCount();
   if (t1 == t2)
   {
       PerfG=0;
   }
   else
   {
      PerfG=INT32(GNC/(t2-t1));
   }
   //S1r=FloatToStr(res.re);
   //S2r=FloatToStr(res.im);
   //SRes=S1r+"  "+S2r+"i";
   //cout << SRes << endl;
   printf("Result Gcc :  %.12e", (double)(res.re)); printf(" "); printf("%.12e",  (double)(res.im)); printf("i\n");
   printf("perfomance  Gcc, Expr/ms:  %5d\n", PerfG);

   #endif
//--------------------------------------------------------------------------------------------------------------------------------------------------------




/**  **********************************************************************************       **/

   GNC=GNCmin;

newexpr:

    F_CalcError = FALSE;
    resCx.re = 0; resCx.im = 0;


    printf("**************************************************************************\n");
    printf("\n");
    printf("Enter number of loops: 2E7 - 2E9. On default(Enter) = 2E7: ");
    fflush(stdin);
    getline(cin,strTmp);
        if(strTmp == "\0")
            {GNC = GNCmin;}
            else
            {
                GNC = StrToInt(strTmp);
                if(GNC <  GNCmin){GNC = GNCmin;} else if(GNC > 2000000000){GNC = 2000000000;} ;
            };
    fflush(stdin);
    printf("Input expression:\n");
	getline(cin, Expr);



    ct=fz_COMPLEX;  /// ct=fz_REAL;
    fzSet(fz_CALC_TYPE, ct);

    fzCompile(Expr.c_str(), Func);

    //fzGet(fz_RESULT_TYPE,0,rt);

	fzGetSyntaxErrorCode(ECode);


	if (ECode == 0)
    {
           /** two way of safe calculations**/

           CalcExpr(Func,resCx);          ///(1)
         /// CalcExprSafe(Func,resCx);   ///(2)

    }
	else
    {
        ShowError();

    };



	S1r=FloatToStr(resCx.re);
    S2r=FloatToStr(resCx.im);
    //SRes=S1r+"  "+S2r+"i";



    if (((ct == fz_COMPLEX) && (rt == fz_COMPLEX)) || (rt == fz_NONE))
        {
            //SRes=S1r+"  "+S2r+"i";
          if( F_CalcError == FALSE)
          {
              printf("Result :  %.12e", (double)(resCx.re)); printf(" "); printf("%.12e",  (double)(resCx.im)); printf("i\n");
          }
        }
      else
        {
            //SRes=S1r;
          if( F_CalcError == FALSE)
          {
           printf("Result :  %.12e", (double)(resCx.re));  printf("i\n");
          }

        };

         //  SRes=S1r+"  "+S2r+"i";
   //cout << SRes << endl;


   printf("perfomance  Expr/ms:  %5d\n", Perf);

   fzPerform(fz_FREE,(Int32)Func);// not necessary. After closing ForevalZ.dll, the memory is automatically released



	goto newexpr;



	system("pause");
 }
}

