﻿Imports System.Runtime.InteropServices

Public Module ForevalZdll
    'Interface module of ForevallZ.dll for vb6  Lib "ForevalZ.dll"  ( v.1.3.5.231)


    Structure TZAddFuncStruct
        Public Addr As UInteger
        Public CallType As Long  'stdcall, cdecl, pascal
        Public arg As Integer
        Public ArgType As Integer
        Public ArgTypeList As UInteger
        Public CallFunc As Integer
        Public ResultType As Integer
        Public DeepFPU As Integer
        Public CalcConst As Integer
        Public SaveReg As Integer
        Public ReplFunc As Integer
        Public Resrv2 As Integer
        Public Resrv3 As Integer
    End Structure


    Structure TComplex
        Public re As Double
        Public im As Double
    End Structure



    Public Const fz_DISABLE As Integer = 0
    Public Const fz_ENABLE As Integer = 1
    Public Const fz_REAL As Integer = 2   'result type
    Public Const fz_COMPLEX As Integer = 3   'result type
    Public Const fz_REAL_DOUBLE As Integer = 4   'var type
    Public Const fz_REAL_EXTENDED As Integer = 5   'var type
    Public Const fz_REAL_INTEGER As Integer = 6   'var type
    Public Const fz_COMPLEX_DOUBLE As Integer = 7   'var type
    Public Const fz_COMPLEX_EXTENDED As Integer = 8   'var type
    Public Const fz_ARRAY_REAL_DOUBLE As Integer = 9   'var type
    Public Const fz_ARRAY_REAL_EXTENDED As Integer = 10  'var type
    Public Const fz_DIFFER_DOUBLE As Integer = 11  'var type
    Public Const fz_DIFFER_EXTENDED As Integer = 12  'var type
    Public Const fz_STACK_VAL As Integer = 13  'call func
    Public Const fz_STACK_ADR As Integer = 14  'call func
    Public Const fz_EAX As Integer = 15  'call func
    Public Const fz_ESP As Integer = 16  'call func
    Public Const fz_CDECL As Integer = 17  'call type
    Public Const fz_STDCALL As Integer = 18  'call type
    Public Const fz_PASCAL As Integer = 19  'call type
    Public Const fz_DOUBLE As Integer = 20  'stack type
    Public Const fz_EXTENDED As Integer = 21  'stack type
    Public Const fz_SHOW_EXCEPTION As Integer = 22
    Public Const fz_OPTIMIZATION As Integer = 23
    Public Const fz_STACK_TYPE As Integer = 24
    Public Const fz_STACK_DEEP As Integer = 25
    Public Const fz_CALC_TYPE As Integer = 26
    Public Const fz_RESULT_TYPE As Integer = 27
    Public Const fz_DIFFER As Integer = 28
    Public Const fz_INFINITE As Integer = 29
    Public Const fz_FREE As Integer = 30
    Public Const fz_CLEAR As Integer = 31
    Public Const fz_VAR_LIST As Integer = 32
    Public Const fz_CMPL_FUNC_LIST As Integer = 33
    Public Const fz_VAR_NAME_LOWER_CASE As Integer = 30
    Public Const fz_FUNC_NAME_LOWER_CASE As Integer = 31
    Public Const fz_STRING As Integer = 32
    Public Const fz_STRING_UTF16 As Integer = 32
    Public Const fz_PCHAR As Integer = 33
    Public Const fz_ANSISTRING As Integer = 34
    Public Const fz_STRING_INTERNAL As Integer = 35
    Public Const fz_UNKNOWN As Integer = 36
    Public Const fz_STRING_TYPE As Integer = 37
    Public Const fz_SYNTAX_EXTENSION As Integer = 38
    Public Const fz_PRESENT_COMPLEX_NUMBER As Integer = 39
    Public Const fz_YES As Integer = 60
    Public Const fz_NO As Integer = 61
    Public Const fz_PRECOMPILED As Integer = 62
    Public Const fz_COMPILE_STACK_DEEP As Integer = 63
    Public Const fz_COMPILE_OVFL As Integer = 64
    Public Const fz_DINAMIC_LOAD_NUM As Integer = 65
    Public Const fz_PANSICHAR As Integer = 66
    Public Const fz_PESENT_VAR As Integer = 67
    Public Const fz_NONE As Integer = 68   'result type
    Public Const fz_WIDESTRING As Integer = 69
    Public Const fz_ARRAY_LENGTH As Integer = 70
    Public Const fz_VERSION As Integer = 71
    Public Const fz_MAJOR As Integer = 72
    Public Const fz_MINOR As Integer = 73
    Public Const fz_RELEASE As Integer = 74
    Public Const fz_ABOUT As Integer = 75
    Public Const fz_BUILD As Integer = 76
    Public Const fz_AUTHOR As Integer = 77
    Public Const fz_EXTENDED_COMMAND As Integer = 78
    Public Const fz_STRING_UTF8 As Integer = 79
    Public Const fz_ERROR_CODE As Integer = 80
    Public Const fz_ARRAY_REAL_INTEGER As Integer = 81
    Public Const fz_SAVE As Integer = 82
    Public Const fz_RESTORE As Integer = 83
    Public Const fz_COMPILED_BY As Integer = 84
    Public Const fz_ENABLE_FUNCTION As Integer = 85
    Public Const fz_DISABLE_FUNCTION As Integer = 86
    Public Const fz_REPLACE_FUNCTIONS As Integer = 87
    Public Const fz_REPLACE_FUNCTIONS_NUM As Integer = 88
    Public Const fz_REPLACE_DIV As Integer = 89
    Public Const fz_REPLACE_MUL As Integer = 90
    Public Const fz_REPLACE_ADDSUB As Integer = 91
    Public Const fz_REPLACE_OPERATIONS As Integer = 92
    Public Const fz_REPLACE_OPERATIONS_NUM As Integer = 93
    Public Const fz_REPLACE_MULTI_EXPR As Integer = 94
    Public Const fz_USE_VIRTUAL_ALLOC As Integer = 95
    Public Const fz_LENGTH_CODE As Integer = 96
    Public Const fz_SAVE_EAX As Integer = 97
    Public Const fz_SAVE_EBX As Integer = 98
    Public Const fz_SAVE_ECX As Integer = 99
    Public Const fz_SAVE_EDX As Integer = 100
    Public Const fz_SAVE_ESP As Integer = 101
    Public Const fz_SAVE_EBP As Integer = 102
    Public Const fz_SAVE_ESI As Integer = 103
    Public Const fz_SAVE_EDI As Integer = 104
    Public Const fz_ACCURATE_SPEC_FUNC As Integer = 105
    Public Const fz_DINAMIC_LOAD As Integer = 106
    Public Const fz_CHECK_INCORRECT_SPACE As Integer = 107
    Public Const fz_POWER_SYMBOL As Integer = 108
    Public Const fz_REPLACE_AT_IF As Integer = 109
    Public Const fz_LOAD_STACK_AFTER_CALC As Integer = 110
    Public Const fz_ADDRESS_OBJECT As Integer = 111
    Public Const fz_FPU_CW As Integer = 112
    Public Const fz_FPU_CW_DEFAULT As Integer = 113
    Public Const fz_FAST_DIV As Integer = 114
    Public Const fz_COMMENT As Integer = 115
    Public Const fz_ENABLE_REPLACE_FUNCTION         As Integer = 116 
    Public Const fz_DISABLE_REPLACE_FUNCTION        As Integer = 117 
    Public Const fz_ENABLE_CALC_CONST               As Integer = 118 
    Public Const fz_DISABLE_CALC_CONST              As Integer = 119    
    Public Const fz_REPLACE_COMPOSITE_FUNCTIONS           As Integer      = 120
    Public Const fz_REPLACE_COMPOSITE_FUNCTIONS_COMPLEX   As Integer      = 121
    Public Const fz_REPLACE_COMPOSITE_FUNCTIONS_REAL      As Integer      = 122
    Public Const fz_DISABLE_REPLACE_FUNCTION_COMPLEX      As Integer      = 123
    Public Const fz_DISABLE_REPLACE_FUNCTION_REAL         As Integer      = 124
    Public Const fz_ENABLE_REPLACE_FUNCTION_COMPLEX       As Integer      = 125
    Public Const fz_ENABLE_REPLACE_FUNCTION_REAL          As Integer      = 126
    Public Const fz_OPTIMIZATION_MUL_DIV                  As Integer      = 127 
    Public Const fz_OPTIMIZATION_A1                       As Integer      = 128
    Public Const fz_OPTIMIZATION_A2                       As Integer      = 129
    Public Const fz_CALC_CONST_EXPRESSION                 As Integer      = 130
    Public Const fz_LEAD_TO_LOWER_CASE                     As Integer = 131
    Public Const fz_SKIPPED_IF                             As Integer = 132
    Public Const fz_CALC_CONST_EXPR_IN_MULTI_EXPR          As Integer = 133
    Public Const fz_PRECISION                              As Integer = 134
    Public Const fz_MASK_FPU_EXCEPTION                     As Integer = 135
    Public Const fz_CLEAR_FPU_EXCEPTION                    As Integer = 136
    Public Const fz_IS_FPU_EXCEPTION                       As Integer = 137
    Public Const fz_FREE_CODE_AT_REPLACE                   As Integer = 138
    Public Const fz_ADDRESS_EXCEPTION_FLAG                 As Integer = 139







    Public Const fz_UNKNOWN_SYMBOL As Integer = 40
    Public Const fz_MISSING_ROUND_BRACKET As Integer = 41
    Public Const fz_MISSING_OPERATION As Integer = 43
    Public Const fz_WRONG_NUMBER_ARGUMENTS As Integer = 44
    Public Const fz_MISSING_EXPRESSION As Integer = 45
    Public Const fz_UNKNOWN_FUNCTION As Integer = 46
    Public Const fz_ERROR_AT_ADDITION_FUNCTION As Integer = 47
    Public Const fz_NOT_DEFINED_OPERATOR As Integer = 48
    Public Const fz_NOT_DEFINED_FUNCTION As Integer = 49
    Public Const fz_INCORRECT_ARGUMENT As Integer = 50
    Public Const fz_MISSING_ARGUMENT As Integer = 51
    Public Const fz_INTERNAL_ERROR As Integer = 52
    Public Const fz_INCORRECT_TYPE As Integer = 53
    Public Const fz_MISSING_SEPARATOR As Integer = 54
    Public Const fz_WRONG_NAME As Integer = 55
    Public Const fz_CALCULATION_ERROR As Integer = 56
    Public Const fz_ABSENT_LOAD_FUNCTION_FOR_TYPE As Integer = 57
    Public Const fz_MISSING_SQUARE_BRACKET As Integer = 58
    Public Const fz_MISSING_CURLY_BRACKET As Integer = 59
    Public Const fz_MISSING_ABS_BRACKET As Integer = 60
    Public Const fz_WRONG_EXPRESSION As Integer = 61
    Public Const fz_INCORRECT_SPACE As Integer = 62
    Public Const fz_VARIABLE_REDECLARED  As Integer = 63






    Public Declare Sub fzCompile Lib "ForevalZ.dll" (ByVal Expr As String, ByRef Func As UInteger)
    Public Declare Sub fzSetVar Lib "ForevalZ.dll" (ByVal Name As String, ByVal Addr As UInteger, ByVal TV As Integer)
    Public Declare Sub fzSetFunction Lib "ForevalZ.dll" (ByVal Name As String, ByVal FAdr As UInteger)
    Public Declare Sub fzSet Lib "ForevalZ.dll" (ByVal mode As Integer, ByVal value As Integer)
    Public Declare Sub fzGet Lib "ForevalZ.dll" (ByVal mode As Integer, ByVal subj As Integer, ByRef value As Integer)
    Public Declare Sub fzGetStr Lib "ForevalZ.dll" Alias "fzGet" (ByVal mode As Integer, ByVal Subj As Integer, ByRef StrInfo As String)
    Public Declare Sub fzGetSyntaxErrorCode Lib "ForevalZ.dll" (ByRef CError As Integer)
    Public Declare Sub fzGetSyntaxErrorString Lib "ForevalZ.dll" (ByRef SError As String)
    Public Declare Sub fzGetFuncID Lib "ForevalZ.dll" (ByVal NameF As String, ByRef IDF As Integer)
    Public Declare Sub fzAddNameFunction Lib "ForevalZ.dll" (ByVal IDF As Integer, ByVal NameF As String)
    'Public Declare Sub fzRenameFunction Lib "ForevalZ.dll" (ByVal Name As String, ByVal NewName As String)
    Public Declare Sub fzPerform Lib "ForevalZ.dll" (ByVal act As Integer, ByVal subj As Integer)
    Public Declare Sub fzResultCxD Lib "ForevalZ.dll" (ByVal Func As UInteger, ByRef re As Double, ByRef im As Double)
    'Public Declare Sub  fzResultCxE Lib "ForevalZ.dll"  (ByVal Func As Integer ByRef Re,Im Extended)
    Public Declare Sub fzResultCxDP Lib "ForevalZ.dll" (ByVal Func As UInteger, ByRef res As TComplex)
    'Public Declare Sub  fzResultCxEP Lib "ForevalZ.dll"  (ByVal Func As Integer  Res As Integer)
    Public Declare Sub fzResultD Lib "ForevalZ.dll" (ByVal Addr As UInteger, ByRef res As Double)
    'Public Declare Sub  fzResultE Lib "ForevalZ.dll"  (ByVal Addr As Integer  ByRef Res extended)
    Public Declare Sub fzResult Lib "ForevalZ.dll" (ByVal Func As UInteger)
    Public Declare Function fzResultR Lib "ForevalZ.dll" Alias "fzResult" (ByVal Addr As UInteger) As Double
    Public Declare Sub fzPolarDP Lib "ForevalZ.dll" (ByVal pz As UInteger, ByVal pz1 As UInteger)
    'Public Declare Sub  fzPolarEP Lib "ForevalZ.dll"  (ByVal pz As Integer  pz1 As Integer)
    Public Declare Sub fzDecartDP Lib "ForevalZ.dll" (ByVal pz As UInteger, ByVal pz1 As UInteger)
    'Public Declare Sub  fzDecartEP Lib "ForevalZ.dll"  (ByVal pz As Integer pz1 As Integer)
    Public Declare Sub fzSetVarIntrnl Lib "ForevalZ.dll" (ByVal Name As String, ByVal VType As Integer, ByRef ExAddr As UInteger)
    Public Declare Sub fzSetVarValueD Lib "ForevalZ.dll" (ByVal Addr As UInteger, ByVal Val As Double)
    'Public Declare Sub  fzSetVarValueE Lib "ForevalZ.dll"  (ByVal Addr As Integer  Val Extended)
    Public Declare Sub fzSetVarValueI Lib "ForevalZ.dll" (ByVal Addr As UInteger, ByVal Val As Integer)
    Public Declare Sub fzSetVarValueCxD Lib "ForevalZ.dll" (ByVal Addr As UInteger, ByVal re As Double, ByVal im As Double)
    'Public Declare Sub  fzSetVarValueCxE Lib "ForevalZ.dll"  (ByVal Addr As Integer  ValRe,ValIm Extended)
    Public Declare Sub fzSetLength Lib "ForevalZ.dll" (ByVal adrV As UInteger, ByVal TypeV As Integer, ByVal lenV As Integer)
    Public Declare Sub fzSetArrayValueD Lib "ForevalZ.dll" (ByVal adrV As UInteger, ByVal indx As Integer, ByVal Val As Double)
    Public Declare Sub fzSetArrayValueI Lib "ForevalZ.dll" (ByVal adrV As UInteger, ByVal indx As Integer, ByVal Val As Integer)
    
    Public Declare Function fzResultFSafe Lib "ForevalZ.dll" Alias "fzResultSafe" (ByVal Addr As UInteger) As Double
    Public Declare Sub fzResultPSafe Lib "ForevalZ.dll" Alias "fzResultSafe" (ByVal Func As UInteger)
    Public Declare Sub fzResultCxDSafe Lib "ForevalZ.dll" (ByVal Func As UInteger, ByRef re As Double, ByRef im As Double)
    Public Declare Sub fzResultCxDPSafe Lib "ForevalZ.dll" (ByVal Func As UInteger, ByRef res As TComplex)


    'Public Declare Sub  fzSetArrayValueE Lib "ForevalZ.dll"  (ByVal AdrV As Integer indx As Integer Val extended)
    Public Declare Sub fzGetArrayValueD Lib "ForevalZ.dll" (ByVal adrV As UInteger, ByVal indx As Integer, ByRef Val As Double)
    Public Declare Sub fzGetArrayValueI Lib "ForevalZ.dll" (ByVal adrV As UInteger, ByVal indx As Integer, ByRef Val As Integer)
    'Public Declare Sub  fzGetArrayValueE Lib "ForevalZ.dll"  (ByVal AdrV As Integer indx As Integer ByRef Val extended)
    Public Declare Sub fzSetNameImUnit Lib "ForevalZ.dll" (ByVal Name As String)

    Public Declare Sub fzGetVarValueD Lib "ForevalZ.dll" (ByVal Addr As UInteger, ByRef Val As Double)

    'Public Declare Sub fzGetVarValueE Lib "ForevalZ.dll"  (Addr: Pointer; ByRef Val: Extended);
    Public Declare Sub fzGetVarValueI Lib "ForevalZ.dll" (ByVal Addr As UInteger, ByRef Val As Integer)
    Public Declare Sub fzGetVarValueCxD Lib "ForevalZ.dll" (ByVal Addr As UInteger, ByRef ValRe As Double, ByRef ValIm As Double)
    'Public Declare Sub fzGetVarValueCxE Lib "ForevalZ.dll"  (Addr: Pointer;  ByRef ValRe,ValIm: Extended);

    Public Declare Sub fzLoadFPUD Lib "ForevalZ.dll" (ByVal VRe As Double, ByVal VIm As Double)
    'Public Declare Sub  fzLoadFPUE Lib "ForevalZ.dll"  (ByVal RE Extended Im Extended)
    Public Declare Sub fzLoadFPUDP Lib "ForevalZ.dll" (ByRef AdrZ As TComplex)
    'Public Declare Sub  fzLoadFPUEP Lib "ForevalZ.dll"  (ByVal RE As Integer{Extended} Im As Integer{Extended})



    'if any arg. in function is complex that all arg. passed  ByRef and CallType=fz_STACK_ADR !!!
    'for stdcall only with real double args return real value
    Public Sub zInitFuncStruct(ByRef FZHandle As TZAddFuncStruct)
        FZHandle.Addr = 0
        FZHandle.CallType = fz_STDCALL    'As stdcall
        FZHandle.arg = 0
        FZHandle.ArgType = fz_REAL_DOUBLE      'arg. only real
        FZHandle.ArgTypeList = 0
        FZHandle.CallFunc = fz_STACK_VAL  'ByVal
        FZHandle.ResultType = fz_REAL     'return real
        FZHandle.CalcConst = fz_YES
        FZHandle.DeepFPU = 8             'max=8: better then fz_UNKNOWN; if return complex than  >=2
        FZHandle.SaveReg = 15            '=15: save eax,ebx,ecx,edx (RECOMMEND.);  =255 save all reg; see .doc if there are any error
        FZHandle.ReplFunc = fz_YES
        FZHandle.Resrv2 = 0
        FZHandle.Resrv3 = 0
    End Sub






End Module
