Attribute VB_Name = "Module2"
Private Declare Sub PutMem1 Lib "msvbvm60" (ByVal Addr As Long, ByVal NewVal As Byte)
Private Declare Sub PutMem2 Lib "msvbvm60" (ByVal Addr As Long, ByVal NewVal As Integer)
Private Declare Sub PutMem4 Lib "msvbvm60" (ByVal Addr As Long, ByVal NewVal As Long)
Private Declare Sub PutMem8 Lib "msvbvm60" (ByVal Addr As Long, ByVal NewVal As Double)
Private Declare Sub GetMem1 Lib "msvbvm60" (ByVal Addr As Long, RetVal As Byte)
Private Declare Sub GetMem2 Lib "msvbvm60" (ByVal Addr As Long, RetVal As Integer)
Private Declare Sub GetMem4 Lib "msvbvm60" (ByVal Addr As Long, RetVal As Long)
Private Declare Sub GetMem8 Lib "msvbvm60" (ByVal Addr As Long, RetVal As Double)
Private Declare Sub CopyMem Lib "kernel32" Alias "RtlMoveMemory" (ByVal Dst As Long, ByVal Src As Long, ByVal Length As Long)



Type TExtArg4
     TypeArg1 As Long
     TypeArg2 As Long
     TypeArg3 As Long
     TypeArg4 As Long
End Type

Type TFuncExt4
      Expr   As String
      Addr   As Long
      res    As TComplex
      z1     As TComplex
      z2     As TComplex
      x      As Double
      n      As Long
End Type

 


'pc1(x:  double):double=x^2
Public Function ps1(ByRef arg As Double) As Double
 ps1 = arg * arg
End Function


'pc1(z: complex double):complex=z*z
Public Sub ps1z(ByRef arg As TComplex) 'as TComplex
 Dim rez As TComplex
 
 rez.re = arg.re * arg.re - arg.im * arg.im
 rez.im = 2 * arg.re * arg.im
 'Call fzLoadFPUDP(rez)
 Call fzLoadFPUD(rez.re, rez.im)
End Sub


'pc2(z1,z2: complex double):complex=z1-z2
Public Sub ps2z(ByRef z1 As TComplex, ByRef z2 As TComplex) 'as TComplex
 Dim rez As TComplex
 
 rez.re = z1.re - z2.re
 rez.im = z1.im - z2.im

 Call fzLoadFPUDP(rez)
 'Call fzLoadFPUD(rez.Re, rez.Im)
End Sub


'pc2(x,y:  double)=x-y
Public Function ps2r(ByRef x As Double, ByRef y As Double) As Double
 ps2r = x - y
End Function



'pc2(x:  double; z: complex double):complex=x-z
Public Sub ps2rz(ByRef x As Double, ByRef z As TComplex) 'as TComplex
 Dim rez As TComplex
 
 rez.re = x - z.re
 rez.im = -z.im
 
 Call fzLoadFPUDP(rez)
 'Call fzLoadFPUD(rez.Re, rez.Im)
End Sub


'pc2(z: complex double; x:  double):complex=z-x
Public Sub ps2zr(ByRef z As TComplex, ByRef x As Double) 'as TComplex
 Dim rez As TComplex
 
 rez.re = z.re - x
 rez.im = z.im
 
 Call fzLoadFPUDP(rez)
  'Call fzLoadFPUD(rez.Re, rez.Im)
End Sub



'pc2(x,y:  double)=x-y
Public Function ps2(ByRef arg1 As Double, ByRef Arg2 As Double) As Double
 ps2 = arg1 - Arg2
End Function


Public Function ps3(ByRef arg1 As Double, ByRef Arg2 As Double, ByRef arg3 As Double) As Double
 ps3 = arg1 + Arg2 - arg3
End Function


'fvd4(vd,n,z1,x)
'pvd4(vd:array double; n:integer; z: complex double; x:double ):complex=vd[n]+x+z
Public Sub fvd4(ByRef adrV As Long, ByRef argi As Long, ByRef argz As TComplex, ByRef argr As Double) 'as TComplex
 Dim rd As Double
 Dim lenV As Long
 Dim rez As TComplex
 
  Call fzGetArrayValueD(VarPtr(adrV), argi, rd)   'transfer address of address !!!
  'Call fzGet(fz_ARRAY_LENGTH, VarPtr(adrV), lenV)
  rez.re = argr + argz.re + rd
  rez.im = argz.im
  Call fzLoadFPUDP(rez)
End Sub

'pvd3(vd:array double; n:integer; x:double)=vd[n]*x
Public Function fvd3(ByVal adrV As Long, ByVal argi As Long, ByVal argf As Double) As Double
 Dim rd As Double
 Dim lenV As Long
  Call fzGetArrayValueD(VarPtr(adrV), argi, rd)   'transfer address of address !!!
  'Call fzGet(fz_ARRAY_LENGTH, VarPtr(adrV), lenV)
  fvd3 = rd * argf
End Function



Public Function sp1(ByVal arg As Double) As Double
 sp1 = arg * arg
End Function



Public Function sp2(ByVal arg1 As Double, ByVal Arg2 As Double) As Double
 sp2 = arg1 - Arg2
End Function


Public Function sp3(ByVal arg1 As Double, ByVal Arg2 As Double, ByVal arg3 As Double) As Double
 sp3 = arg1 + Arg2 - arg3
End Function




'ms1z(argz: TComplex)=argz^2
Public Sub ms1z(ByVal Addr As Long) 'as TComplex
 Dim rez As TComplex
 Dim arg As TComplex
  
  
 'Addr    ->   AddrOf(z.re)
 'Addr+16 ->   AddrOf(z.im)
 
   'GetMem8 Addr, arg.re
   'GetMem8 Addr + 16, arg.im
   
   Call fzGetVarValueD(Addr, arg.re)
   Call fzGetVarValueD(Addr + 16, arg.im)
   
   
  rez.re = arg.re * arg.re - arg.im * arg.im
  rez.im = 2 * arg.re * arg.im
 
 
  Call fzLoadFPUDP(rez)
  'Call fzLoadFPUD(rez.re, rez.im)
  
End Sub


'ms1r(argr: double)=argr^2
Public Function ms1r(ByVal Addr As Long) As Double
Dim r As Double

 'Addr    ->   AddrOf(argr)
  
   'GetMem8 Addr, r
   Call fzGetVarValueD(Addr, r)
   

  ms1r = r * r
End Function

'ms2r(x,y: double)=x-y
Public Function ms2r(ByVal Addr As Long) As Double
Dim r1 As Double
Dim r2 As Double
'Dim argz As TComplex


 'Addr    ->   AddrOf(r1)
 'Addr+16 ->   AddrOf(r2)
  
   'GetMem8 Addr, r1
   'GetMem8 Addr + 16, r2
   Call fzGetVarValueD(Addr, r1)
   Call fzGetVarValueD(Addr + 16, r2)
     
   
  ms2r = r1 - r2
End Function


'ms2z(z1,z2: TComplex)=z1-z2
Public Sub ms2z(ByVal Addr As Long) 'as TComplex
 Dim z1 As TComplex
 Dim z2 As TComplex
 Dim rez As TComplex
  
  
 'Addr    ->   AddrOf(z1.re)
 'Addr+16 ->   AddrOf(z1.im)
 'Addr+32 ->   AddrOf(z2.re)
 'Addr+48 ->   AddrOf(z2.im)
 
   
   
   Call fzGetVarValueD(Addr, z1.re)
   Call fzGetVarValueD(Addr + 16, z1.im)
   Call fzGetVarValueD(Addr + 32, z2.re)
   Call fzGetVarValueD(Addr + 48, z2.im)
   
   
   rez.re = z1.re - z2.re
   rez.im = z1.im - z2.im
 
 
  Call fzLoadFPUDP(rez)
  'Call fzLoadFPUD(rez.re, rez.im)
  
End Sub


'ms2rz(r1: double; z2: TComplex)=r1-z2
Public Sub ms2rz(ByVal Addr As Long) 'as TComplex
 Dim r1 As Double
 Dim z2 As TComplex
 Dim rez As TComplex
  
  
 'Addr    ->   AddrOf(r1)
 'Addr+16 ->   AddrOf(z2.re)
 'Addr+32 ->   AddrOf(z2.im)
  
   
   
   Call fzGetVarValueD(Addr, r1)
   Call fzGetVarValueD(Addr + 16, z2.re)
   Call fzGetVarValueD(Addr + 32, z2.im)
   
   rez.re = r1 - z2.re
   rez.im = -z2.im
 
 
  Call fzLoadFPUDP(rez)
  'Call fzLoadFPUD(rez.re, rez.im)
  
End Sub

'ms2zr( z1: TComplex; r2: double)=z1-r2
Public Sub ms2zr(ByVal Addr As Long) 'as TComplex
 Dim r2 As Double
 Dim z1 As TComplex
 Dim rez As TComplex
  
  
 'Addr    ->   AddrOf(z1.re)
 'Addr+16 ->   AddrOf(z1.im)
 'Addr+32 ->   AddrOf(r2)
  
   
   Call fzGetVarValueD(Addr, z1.re)
   Call fzGetVarValueD(Addr + 16, z1.im)
   Call fzGetVarValueD(Addr + 32, r2)
  
   rez.re = z1.re - r2
   rez.im = z1.im
 
 
  Call fzLoadFPUDP(rez)
  'Call fzLoadFPUD(rez.re, rez.im)
  
End Sub

'msd4(vd:array double; n:integer; z: complex double; x:double ):complex=vd[n]+x+z
Public Sub msd4(ByVal Addr As Long) 'as TComplex
 Dim rd As Double
 Dim argr As Double
 Dim lenV As Long
 Dim argi As Long
 Dim rez As TComplex
 Dim argz As TComplex
 
 'Addr    ->   AddrOf(vd)
 'Addr+16 ->   AddrOf(n)
 'Addr+32 ->   AddrOf(z.re)
 'Addr+48 ->   AddrOf(z.im)
 'Addr+64 ->   AddrOf(x)
 
 
   Call fzGetVarValueI(Addr + 16, argi)
   Call fzGetArrayValueD(Addr, argi, rd)
   'Call fzGet(fz_ARRAY_LENGTH, Addr, lenV)
   Call fzGetVarValueD(Addr + 32, argz.re)
   Call fzGetVarValueD(Addr + 48, argz.im)
   Call fzGetVarValueD(Addr + 64, argr)
   
 
   
   rez.re = argr + argz.re + rd
   rez.im = argz.im
 
 
  Call fzLoadFPUDP(rez)
  'Call fzLoadFPUD(rez.re, rez.im)
  
End Sub


Public Function InfSum(ByVal AdrL As Long, ByVal LenL As Long) As Double
 Dim i As Long
 Dim S As Double
 Dim VArg As Double
 Dim Vaddr As Long
 
 S = 0
 
 For i = 1 To LenL
  Vaddr = AdrL + 16 * (i - 1)      'calc. addr. of current arg.
  Call fzGetVarValueD(Vaddr, VArg) 'get arg. on addr.
  S = S + VArg
 Next

 InfSum = S
End Function


Public Sub InfSumZ(ByVal AdrL As Long, ByVal LenL As Long) 'as TComplex
 Dim i As Long
 Dim S As Double
 Dim VArg As Double
 Dim Vaddr As Long
 Dim ReAddr As Long
 Dim ImAddr As Long
 Dim rez As TComplex
 Dim re As Double
 Dim im As Double
 
 rez.re = 0
 rez.im = 0
 
 For i = 0 To LenL - 1
   ReAddr = AdrL + 32 * i      'calc. addr. of current arg.
   ImAddr = ReAddr + 16
 
   Call fzGetVarValueD(ReAddr, re)
   Call fzGetVarValueD(ImAddr, im)
  
   rez.re = rez.re + re
   rez.im = rez.im + im
 Next

 Call fzLoadFPUDP(rez)
End Sub




'copyV(VS,VD): VS->VD
Public Sub CopyV(ByVal adrVS As Long, ByVal adrVD As Long)
 Dim rd As Double
 Dim lenV As Long
 Dim lenVS As Long
 Dim lenVD As Long
 Dim adrVD0 As Long
 Dim adrVS0 As Long
 Dim i As Long
 Dim res As Double
 
 
  
  
  'copy(vd,vd1); 1
  
  '************* 1 - slow way ***********
  'Call fzGet(fz_ARRAY_LENGTH, VarPtr(adrVS), lenVS)
  'Call fzGet(fz_ARRAY_LENGTH, VarPtr(adrVD), lenVD)
  
  'If lenVS < lenVD Then lenV = lenVS Else lenV = lenVD
 
  'For i = 0 To lenV - 1
    'Call fzGetArrayValueD(VarPtr(adrVS), i, rd) 'transfer address of address !!!
    'Call fzSetArrayValueD(VarPtr(adrVD), i, rd) 'transfer address of address !!!
  'Next
  
  '*************************************
  
  
  
 '************* 2 - more fast ***********
 'If adrVD <> 0 Then
        'GetMem4 VarPtr(adrVD), adrVD0 'adrVD0=@vd[0] ;transfer address of address !!!
        'GetMem4 (adrVD0 - 4), lenVD   '+1 if Foreval compiled in FPC !!!!!!
    'Else
        'lenVD = 0
   'End If
   
   'If adrVS <> 0 Then
      'GetMem4 VarPtr(adrVS), adrVS0  'adrVD0=@vd[0] ;transfer address of address !!!
      'GetMem4 (adrVS0 - 4), lenVS    '+1 if Foreval compiled in FPC !!!!!!
    'Else
        'lenVS = 0
   'End If
  
   'If lenVS < lenVD Then lenV = lenVS Else lenV = lenVD
   
 
  
  
  'For i = 0 To lenV - 1
    'GetMem8 (adrVS0 + i * 8), res   '8-sizeOf(double)
    'PutMem8 (adrVD0 + i * 8), res   '8-sizeOf(double)
  'Next
  
 '*************************************
  
  
  
 '************* 3 - most fast ***********
 
  If adrVD <> 0 Then
        GetMem4 VarPtr(adrVD), adrVD0 'adrVD0=@vd[0] ;transfer address of address !!!
        GetMem4 (adrVD0 - 4), lenVD   '+1 if Foreval compiled in FPC !!!!!!
    Else
        lenVD = 0
   End If
   
   If adrVS <> 0 Then
      GetMem4 VarPtr(adrVS), adrVS0  'adrVD0=@vd[0] ;transfer address of address !!!
      GetMem4 (adrVS0 - 4), lenVS    '+1 if Foreval compiled in FPC !!!!!!
    Else
        lenVS = 0
   End If
  
   If lenVS < lenVD Then lenV = lenVS Else lenV = lenVD
   
  CopyMem adrVD0, adrVS0, lenV * 8   '8-sizeOf(double)
  
 '*************************************
 
  
End Sub

'FillArray(VD): VD[all]=x
Public Sub FillArray(ByVal adrVD As Long, ByVal x As Double)

 Dim lenV As Long
 Dim adrVD0 As Long
 Dim i As Long
 
 
 '******************* 1 - slow way ******************************
  'Call fzGet(fz_ARRAY_LENGTH, VarPtr(adrVD), lenV)
  'For i = 0 To lenV - 1
   'Call fzSetArrayValueD(VarPtr(adrVD), i, x)
  'Next
'****************************************************************



 '************* 2 - more fast ***********
   If adrVD <> 0 Then
        GetMem4 VarPtr(adrVD), adrVD0 'adrVD0=@vd[0] ;transfer address of address !!!
        GetMem4 (adrVD0 - 4), lenV    '+1 if Foreval compiled in FPC !!!!!!
    Else
        lenV = 0
   End If
   
  For i = 0 To lenV - 1
    PutMem8 (adrVD0 + i * 8), x   '8-sizeOf(double)
  Next
  
'****************************************************************
End Sub


