/**
                      Interface Foreval.dll only for  Builder C++ !!!
                                  {9.1.1.365}


**/


#pragma once
#include <windows.h>
#include <oleauto.h>
#include <string>
#include <vcl.h>
#pragma hdrstop


using namespace std;

#ifndef Forevaldll_H
#define Forevaldll_H

// #define STRING
//#define ANSISTRING
 #define WIDESTRING
// #define PANSICHAR
// #define UTF8

#ifdef    ANSISTRING
 typedef  AnsiString TStringType;
#endif


#ifdef   WIDESTRING
 typedef  WideString TStringType;
#endif

#ifdef    STRING
 typedef  String TStringType;      //String = UTF16 for delphi,builder >=2009 else String = AnsiString
#endif

#ifdef    UTF8
 typedef  UTF8String TStringType;
#endif

#ifdef    PANSICHAR
 //typedef  PAnsiChar TStringType;
 typedef  const char* TStringType;
#endif






typedef void*        Pointer32 ;
typedef double*      P_Double;
typedef Extended*    P_Extended;
typedef Int32*       P_Integer;
typedef Single*      P_Single;




const   Int32   fl_DISABLE              = 0;
const   Int32   fl_ENABLE               = 1;
const   Int32   fl_REAL                 = 2;  //var type
const   Int32   fl_COMPLEX              = 3;  //var type
const   Int32   fl_REAL_DOUBLE          = 4;  //var type
const   Int32   fl_REAL_EXTENDED        = 5;  //var type
const   Int32   fl_REAL_INTEGER         = 6;  //var type
const   Int32   fl_COMPLEX_DOUBLE       = 7;  //var type
const   Int32   fl_COMPLEX_EXTENDED     = 8;  //var type
const   Int32   fl_ARRAY_REAL_DOUBLE    = 9;  //var type
const   Int32   fl_ARRAY_REAL_EXTENDED  = 10; //var type
const   Int32   fl_DIFFER_DOUBLE        = 11; //var type
const   Int32   fl_DIFFER_EXTENDED      = 12; //var type
const   Int32   fl_VARS_VALUES          = 13; //call func      //const   Int32   fl_VARS_VALUES
const   Int32   fl_VARS_ADDRS           = 14; //call func      //const   Int32   fl_VARS_ADDRS
const   Int32   fl_VARS_LIST_ADDR_EAX   = 15; //call func      //const   Int32   fl_VARS_LIST_ADDR_EAX
const   Int32   fl_VARS_LIST_ADDR_ESP   = 16; //call func      //const   Int32   fl_VARS_LIST_ADDR_ESP
const   Int32   fl_CDECL                = 17; //call type
const   Int32   fl_STDCALL              = 18; //call type
const   Int32   fl_PASCAL               = 19; //call type
const   Int32   fl_DOUBLE               = 20; //stack type
const   Int32   fl_EXTENDED             = 21; //stack type
const   Int32   fl_SHOW_EXCEPTION       = 22;
const   Int32   fl_OPTIMIZATION         = 23;
const   Int32   fl_STACK_TYPE           = 24;
const   Int32   fl_STACK_DEEP           = 25;
const   Int32   fl_RESULT_LEAD_TO_TYPE  = 26;
const   Int32   fl_RESULT_TYPE          = 27;
const   Int32   fl_DIFFER               = 28;
const   Int32   fl_INFINITE             = 29;
const   Int32   fl_FREE                 = 30;
const   Int32   fl_CLEAR                = 31;
const   Int32   fl_VAR_LIST             = 32;
const   Int32   fl_CMPL_FUNC_LIST       = 33;
const   Int32   fl_STRING               = 32;
const   Int32   fl_STRING_UTF16         = 32;
const   Int32   fl_PCHAR                = 33;
const   Int32   fl_ANSISTRING           = 34;
const   Int32   fl_STRING_INTERNAL      = 35;
const   Int32   fl_UNKNOWN              = 36;
const   Int32   fl_STRING_TYPE          = 37;
const   Int32   fl_SYNTAX_EXTENSION     = 38;
const   Int32   fl_PRESENT_COMPLEX_NUMBER = 39;
const   Int32   fl_YES                  = 60;
const   Int32   fl_NO                   = 61;
const   Int32   fl_PRECOMPILED          = 62;
const   Int32   fl_COMPILE_STACK_DEEP   = 63;
const   Int32   fl_COMPILE_OVFL         = 64;
const   Int32   fl_DINAMIC_LOAD_NUM     = 65;
const   Int32   fl_PANSICHAR            = 66;
const   Int32   fl_PESENT_VAR           = 67;
const   Int32   fl_NONE                 = 68;  //result type
const   Int32   fl_WIDESTRING           = 69;
const   Int32   fl_ARRAY_LENGTH         = 70;
const   Int32   fl_VERSION                         = 71;
const   Int32   fl_MAJOR                           = 72;
const   Int32   fl_MINOR                           = 73;
const   Int32   fl_RELEASE                         = 74;
const   Int32   fl_ABOUT                           = 75;
const   Int32   fl_BUILD                           = 76;
const   Int32   fl_AUTHOR                          = 77;
const   Int32   fl_EXTENDED_COMMAND                = 78;
const   Int32   fl_STRING_UTF8                     = 79;
const   Int32   fl_ERROR_CODE                      = 80;
const   Int32   fl_ARRAY_REAL_INTEGER              = 81;
const   Int32   fl_SAVE                            = 82;
const   Int32   fl_RESTORE                         = 83;
const   Int32   fl_COMPILED_BY                     = 84;
const   Int32   fl_ENABLE_FUNCTION                 = 85;
const   Int32   fl_DISABLE_FUNCTION                = 86;
const   Int32   fl_REPLACE_FUNCTIONS               = 87;
const   Int32   fl_REPLACE_FUNCTIONS_NUM           = 88;
const   Int32   fl_REPLACE_DIV                     = 89;
const   Int32   fl_REPLACE_MUL                     = 90;
const   Int32   fl_REPLACE_ADDSUB                  = 91;
const   Int32   fl_REPLACE_OPERATIONS              = 92;
const   Int32   fl_REPLACE_OPERATIONS_NUM          = 93;
const   Int32   fl_REPLACE_MULTI_EXPR              = 94;
const   Int32   fl_USE_VIRTUAL_ALLOC               = 95;   //only for exe code
const   Int32   fl_LENGTH_CODE                     = 96;
const   Int32   fl_SAVE_EAX                        = 97;
const   Int32   fl_SAVE_EBX                        = 98;
const   Int32   fl_SAVE_ECX                        = 99;
const   Int32   fl_SAVE_EDX                        = 100;
const   Int32   fl_SAVE_ESP                        = 101;
const   Int32   fl_SAVE_EBP                        = 102;
const   Int32   fl_SAVE_ESI                        = 103;
const   Int32   fl_SAVE_EDI                        = 104;
const   Int32   fl_ACCURATE_SPEC_FUNC              = 105;
const   Int32   fl_DINAMIC_LOAD                    = 106;
const   Int32   fl_CHECK_INCORRECT_SPACE           = 107;
const   Int32   fl_SET_POWER_SYMBOL                = 108;
const   Int32   fl_REPLACE_AT_IF                   = 109;
const   Int32   fl_LOAD_STACK_AFTER_CALC           = 110;
const   Int32   fl_ADDRESS_OBJECT                  = 111;
const   Int32   fl_FPU_CW                          = 112;
const   Int32   fl_FPU_CW_DEFAULT                  = 113;  // = $1372
const   Int32   fl_FAST_DIV                        = 114;
const   Int32   fl_COMMENT                         = 115;
const   Int32   fl_ENABLE_REPLACE_FUNCTION         = 116;
const   Int32   fl_DISABLE_REPLACE_FUNCTION        = 117;
const   Int32   fl_ENABLE_CALC_CONST               = 118;
const   Int32   fl_DISABLE_CALC_CONST              = 119;
const   Int32   fl_REPLACE_COMPOSITE_FUNCTIONS                 = 120;
const   Int32   fl_REPLACE_COMPOSITE_FUNCTIONS_COMPLEX         = 121;
const   Int32   fl_REPLACE_COMPOSITE_FUNCTIONS_REAL            = 122;
const   Int32   fl_DISABLE_REPLACE_FUNCTION_COMPLEX            = 123;
const   Int32   fl_DISABLE_REPLACE_FUNCTION_REAL               = 124;
const   Int32   fl_ENABLE_REPLACE_FUNCTION_COMPLEX             = 125;
const   Int32   fl_ENABLE_REPLACE_FUNCTION_REAL                = 126;
const   Int32   fl_OPTIMIZATION_MUL_DIV                        = 127;
const   Int32   fl_OPTIMIZATION_A1                             = 128;
const   Int32   fl_OPTIMIZATION_A2                             = 129;
const   Int32   fl_CALC_CONST_EXPRESSION                       = 130;
const   Int32   fl_LEAD_TO_LOWER_CASE                          = 131;
const   Int32   fl_SKIPPED_IF                                  = 132;
const   Int32   fl_CALC_CONST_EXPR_IN_MULTI_EXPR               = 133;
const   Int32   fl_PRECISION                                   = 134;
const   Int32   fl_MASK_FPU_EXCEPTION                          = 135;
const   Int32   fl_CLEAR_FPU_EXCEPTION                         = 136;
const   Int32   fl_IS_FPU_EXCEPTION                            = 137;
const   Int32   fl_FREE_CODE_AT_REPLACE                        = 138;
const   Int32   fl_ADDRESS_EXCEPTION_FLAG                      = 139;
const   Int32   fl_EXCHANGE_BRANCH_NUM                         = 140;
const   Int32   fl_DINAMIC_LOAD_STACK_DEEP                     = 141;
const   Int32   fl_EXCHANGE_BRANCH_STACK_DEEP                  = 142;
const   Int32   fl_EXCHANGE_BRANCH                             = 143;
const   Int32   fl_ANY                                         = -1;
const   Int32   fl_NOT_FOUND                                   = -1;
const   Int32   fl_AUTO                                        = 144;
const   Int32   fl_DELETE                                      = 145;
const   Int32   fl_CALC_CONST_FUNC                             = 146;
const   Int32   fl_CALC_CONST_ARG                              = 147;
const   Int32   fl_NEW                                         = 148;
const   Int32   fl_ReWRITE                                     = 149;
const   Int32   fl_INTEGER_OPTIMIZATION                        = 150;
const   Int32   fl_CALC_CONST_EXT_FUNC                         = 151;
const   Int32   fl_PARAM_LIST                                  = 152;
const   Int32   fl_CALC_CONST_MUL_DIV                          = 153;
const   Int32   fl_INTEGER_OPTIMIZATION_EXT_FUNC               = 154;
const   Int32   fl_DIFF_NUMERIC_PRECISION                      = 155;
const   Int32   fl_STAY_AS_IS                                  = 156;
const   Int32   fl_DATA_IN_ARRAY                               = 157;
const   Int32   fl_INTERNAL_ERROR_CODE                         = 158;
const   Int32   fl_SPEC_FUNC                                   = 159;
const   Int32   fl_FAST                                        = 160;
const   Int32   fl_ACCURATE                                    = 161;
const   Int32   fl_STD_FUNC_REAL                               = 162;
const   Int32   fl_STD_FUNC_COMPLEX                            = 163;
const   Int32   fl_COMPLEX_DIV                                 = 164;
const   Int32   fl_STD_FUNC                                    = 165;
const   Int32   fl_DISABLE_OPERATION                           = 166;
const   Int32   fl_ENABLE_OPERATION                            = 167;
const   Int32   fl_BETWEEN                                     = 168;
const   Int32   fl_BEFORE                                      = 169;
const   Int32   fl_AFTER                                       = 170;
const   Int32   fl_PIPE_BRACKET_TO_ABS                         = 171;
const   Int32   fl_SQUARE_BRACKET_TO_TRUNC                     = 172;
const   Int32   fl_CURLY_BRACKET_TO_FRACK                      = 173;
const   Int32   fl_REPLACE_FUNC_IN_PART                        = 174;
const   Int32   fl_EXT_NAME_FUNC                               = 175;
const   Int32   fl_SUBST_NUMCX                                 = 176;
const   Int32   fl_PRELIM_SYNT_ERROR                           = 177;
const   Int32   fl_SYNTAX_OPERATORS                            = 178;
const   Int32   fl_OPERATOR                                    = 179;
const   Int32   fl_STANDARD                                    = 180;
const   Int32   fl_EXTRA                                       = 181;
const   Int32   fl_PACKAGE_EXPRESSIONS                         = 182;
const   Int32   fl_USE_POINTER                                 = 183;
const   Int32   fl_USE_INTEGER_POINTER                         = 184;
const   Int32   fl_POINTER                                     = 185;
const   Int32   fl_ARRAY_POINTER                               = 186;
const   Int32   fl_REAL_SINGLE                                 = 187;
const   Int32   fl_ARRAY_REAL_SINGLE                           = 188;
const   Int32   fl_INTEGER                                     = 189;
const   Int32   fl_SINGLE                                      = 190;
const   Int32   fl_ALL_REPLACE                                 = 191;
const   Int32   fl_COMPILE                                     = 192;
const   Int32   fl_PACKAGE_COMPILE_ADDR                        = 193;
const   Int32   fl_CHECK_SYNTAX                                = 194;
const   Int32   fl_DIFF_EXPRESSION                             = 195;
const   Int32   fl_COMPILER_TYPE_EXE                           = 196;
const   Int32   fl_DELPHI                                      = 197;
const   Int32   fl_FREE_PASCAL                                 = 198;
const   Int32   fl_REPLACE_ARRAYS                              = 199;
const   Int32   fl_CHECK_ARRAY_TYPE_CONNECT                    = 200;
const   Int32   fl_COMPLEX_SINGLE                              = 201;
const   Int32   fl_REDUCE_POWER_CONST_ARG                      = 202;
const   Int32   fl_DELETE_ZERO_BRANCH                          = 203;
const   Int32   fl_INSERT_INLINE                               = 204;



const   Int32   fl_UNKNOWN_SYMBOL                 = 40;
const   Int32   fl_MISSING_ROUND_BRACKET          = 41;
const   Int32   fl_MISSING_OPERATION              = 43;
const   Int32   fl_WRONG_NUMBER_ARGUMENTS         = 44;
const   Int32   fl_MISSING_EXPRESSION             = 45;
const   Int32   fl_UNKNOWN_FUNCTION               = 46;
const   Int32   fl_ERROR_AT_ADDITION_FUNCTION     = 47;
const   Int32   fl_NOT_DEFINED_OPERATOR           = 48;
const   Int32   fl_NOT_DEFINED_FUNCTION           = 49;
const   Int32   fl_INCORRECT_ARGUMENT             = 50;
const   Int32   fl_MISSING_ARGUMENT               = 51;
const   Int32   fl_INTERNAL_ERROR                 = 52;
const   Int32   fl_INCORRECT_TYPE                 = 53;
const   Int32   fl_MISSING_SEPARATOR              = 54;
const   Int32   fl_WRONG_NAME                     = 55;
const   Int32   fl_CALCULATION_ERROR              = 56;
const   Int32   fl_ABSENT_LOAD_FUNCTION_FOR_TYPE  = 57;
const   Int32   fl_MISSING_SQUARE_BRACKET         = 58;
const   Int32   fl_MISSING_CURLY_BRACKET          = 59;
const   Int32   fl_MISSING_ABS_BRACKET            = 60;
const   Int32   fl_WRONG_EXPRESSION               = 61;
const   Int32   fl_INCORRECT_SPACE                = 62;
const   Int32   fl_VARIABLE_REDECLARED            = 63;
const   Int32   fl_NO_DIFF_EXPRESSION             = 64;
const   Int32   fl_WRONG_PASSED_DATA              = 65;
const   Int32   fl_UNKNOWN_ARRAY                  = 66;
const   Int32   fl_INTERNAL_ERROR_AT_DIFF         = 67;
const   Int32   fl_VOID_EXPRESSION                = 68;
const   Int32   fl_WRONG_SYMBOL                   = 69;
const   Int32   fl_NO_RETURN_NUMBER               = 70;
const   Int32   fl_PROHIBITED_SYMBOL              = 71;
const   Int32   fl_NO_FUNCTION_ARGUMENT           = 72;
const   Int32   fl_NO_APPLICABLE_TO_EXTERNAL_ARRAY = 73;





const   Int32   fl_ACCESS_VIOLATION           = 200;
const   Int32   fl_ZERO_DIVIDE                = 201;
const   Int32   fl_INVALID_OPERATION          = 202;
const   Int32   fl_OVERFLOW                   = 203;
const   Int32   fl_OUT_OF_MEMORY              = 204;
const   Int32   fl_STACK_OVERFLOW             = 205;
const   Int32   fl_UNDERFLOW                  = 206;
const   Int32   fl_INT_OVERFLOW               = 207;
const   Int32   fl_COMMON_CALCULATON_ERROR    = 210;



struct TAttrib
		 {
			     Int32  MType;  //fl_Double, fl_Extended, ///fl_Single,fl_Integer,
			  Pointer32  AddrRE; //addr of res
              Pointer32  AddrIM; //addr of res
		 };


struct TidFunc       //IDFP = *TidFunc
		 {
			     Int32  idName; //IDFN  id of name of function
			     Int32  idArg;  //IDFA  id on arguments of function
		 };


struct TOperData
          {
                Int32   IdOp;
                Int32   idFunc;   // = TidFunc.idName
                Int32   OpPrior;
                Int32   NArg;
                Int32   Placement;
          }  ;


struct TAddFuncStruct
				{
				   Pointer32    addr;
					  Int32    CallType;
					  Int32    Arg;
					  Int32    ArgType;
				   Pointer32    ArgTypeList;
					  Int32    CallFunc;
					  Int32    ResultType;
					  Int32    DeepFPU;
					  Int32    CalcConst;
					  Int32    SaveReg;
				      Int32    ReplFunc;
				      Int32    Set_ID;
				      Int32    Id_Func;
                   Pointer32    AdrDeriv;
                      Int32    NDeriv;
                      Int32    Place;
                      Int32    ResultTypeMath;
                      Int32    IsInline;
                      Int32    Rsrv1;
                      Int32    Rsrv2;
                      Int32    Rsrv3;
				 };



typedef void (_stdcall *PTflCompile)(TStringType Expression, Pointer32 Attr, Pointer32& Func);
typedef void (_stdcall *PTflSetVar)(TStringType Name, Pointer32 Addr, Int32 TypeVar);
typedef void (_stdcall *PTflSetVarCx)(TStringType Name, Pointer32 AddrRE, Pointer32 AddrIM, Int32 TypeVar);
typedef void (_stdcall *PTflSetParam)(TStringType Name, Pointer32 Addr, Int32 ParamType);
typedef void (_stdcall *PTflSetParamD)(TStringType Name, double Re, double Im,  Int32 ParamType);
typedef void (_stdcall *PTflSetParamE)(TStringType Name, Extended Re, Extended Im,  Int32 ParamType);
typedef void (_stdcall *PTflSetFunction)(TStringType FuncName, Pointer32 FuncAddr, Pointer32 IDFP);
typedef void (_stdcall *PTflSet)(Int32 mode, Int32 value1, Int32 value2);
typedef void (_stdcall *PTflGet)(Int32 mode, Int32 subj, Int32& value);
typedef void (_stdcall *PTflGetP)(Int32 mode, Int32 subj, Pointer32& Func);
typedef void (_stdcall *PTflGetErrorCode)(Int32& CError);
typedef void (_stdcall *PTflGetErrorString)(Pointer32& SError);
typedef void (_stdcall *PTflPerform)(Int32 act, Int32 subj);
typedef void (_stdcall *PTflSetExpression)(TStringType Expr, Pointer32 Attr, Int32  action,  Pointer32& Func,  Int32& CError);


typedef void (_stdcall *PTflResultCxD)(Pointer32 Func, double& Re, double& Im);
typedef void (_stdcall *PTflResultCxE)(Pointer32 Func, Extended& Re, Extended& Im);
typedef void (_stdcall *PTflResultCxDP)(Pointer32 Func, Pointer32 PRezCx);
typedef void (_stdcall *PTflResultCxEP)(Pointer32 Func, Pointer32 PRezCx);
typedef void (_stdcall *PTflResultD)(Pointer32 Func, double& Res);
typedef void (_stdcall *PTflResultE)(Pointer32 Func, Extended& Res);
typedef void (_stdcall *PTflResult)(Pointer32 Func);
typedef Extended (_stdcall *PTflResultR)(Pointer32 Func);


typedef void (_stdcall *PTflPolarDP)(Pointer32 pz, Pointer32 pz1);
typedef void (_stdcall *PTflPolarEP)(Pointer32 pz, Pointer32 pz1);
typedef void (_stdcall *PTflDecartDP)(Pointer32 pz, Pointer32 pz1);
typedef void (_stdcall *PTflDecartEP)(Pointer32 pz, Pointer32 pz1);



typedef void (_stdcall *PTflSetVarIntrnl)(TStringType Name,  Int32 VType, Pointer32& ExAddr);
typedef void (_stdcall *PTflSetVarValueS)(Pointer32 addr, Single Val);
typedef void (_stdcall *PTflSetVarValueD)(Pointer32 addr, double Val);
typedef void (_stdcall *PTflSetVarValueE)(Pointer32 addr, Extended Val);
typedef void (_stdcall *PTflSetVarValueI)(Pointer32 addr, Int32 Val);
typedef void (_stdcall *PTflSetVarValueCxS)(Pointer32 addr, Single ValRe, Single ValIm);
typedef void (_stdcall *PTflSetVarValueCxD)(Pointer32 addr, double ValRe, double ValIm);
typedef void (_stdcall *PTflSetVarValueCxE)(Pointer32 addr, Extended ValRe, Extended ValIm);

typedef void (_stdcall *PTflSetLength)(Pointer32 adrV, Int32 TypeV, Int32 Len);
typedef void (_stdcall *PTflSetArrayValueD)(Pointer32 addr, Int32 indx, double Val);
typedef void (_stdcall *PTflSetArrayValueE)(Pointer32 addr, Int32 indx, Extended Val);
typedef void (_stdcall *PTflSetArrayValueI)(Pointer32 addr, Int32 indx, Int32 Val);
typedef void (_stdcall *PTflSetArrayValueS)(Pointer32 addr, Int32 indx, Single Val);

typedef void (_stdcall *PTflGetVarValueS)(Pointer32 addr,  Single& Val);       //val=single(addr)
typedef void (_stdcall *PTflGetVarValueD)(Pointer32 addr,  double& Val);       //val=double(addr)
typedef void (_stdcall *PTflGetVarValueE)(Pointer32 addr,  Extended& Val);     //val=extended(addr)
typedef void (_stdcall *PTflGetVarValueI)(Pointer32 addr,  Int32& Val);        //val=integer(addr)
typedef void (_stdcall *PTflGetArrayValueI)(Pointer32 addr, Int32 indx, Int32& Val);
typedef void (_stdcall *PTflGetArrayValueD)(Pointer32 addr, Int32 indx, double& Val);
typedef void (_stdcall *PTflGetArrayValueE)(Pointer32 addr, Int32 indx, Extended& Val);
typedef void (_stdcall *PTflGetArrayValueS)(Pointer32 addr, Int32 indx, Single& Val);
typedef void (_stdcall *PTflGetVarValueCxS)(Pointer32 addr,  Single& ValRe, Single& ValIm);        //val=TComplexS(addr)
typedef void (_stdcall *PTflGetVarValueCxD)(Pointer32 addr,  double& ValRe, double& ValIm);        //val=TComplexD(addr)
typedef void (_stdcall *PTflGetVarValueCxE)(Pointer32 addr,  Extended& ValRe, Extended& ValIm);        //val=TComplexE(addr)

typedef void (_stdcall *PTflSetNameImUnit)(TStringType Name);

typedef void (_stdcall *PTflLoadFPUD)(double re, double im);
typedef void (_stdcall *PTflLoadFPUE)(Extended re, Extended im);
typedef void (_stdcall *PTflLoadFPUDP)(Pointer32 addrCx);
typedef void (_stdcall *PTflLoadFPUEP)(Pointer32 addrCx);


typedef void (_stdcall *PTflSetDiffVar)(TStringType Name);
typedef void (_stdcall *PTflSetDiffExpr)(TStringType Name);
typedef void (_stdcall *PTflDiffExpr)(Int32 N);
typedef void (_stdcall *PTflGetDiffString)(Pointer32& DS);
typedef void (_stdcall *PTflCompileDiffExpr)(Pointer32& Addr);
typedef void (_stdcall *PTflCompileDeriv)(TStringType Expression, TStringType VName, Int32 N, Pointer32& Addr);

typedef void (_stdcall *PTflSetDiffTemplate)(Pointer32 IDFP,  TStringType TemplateDiff);
typedef void (_stdcall *PTflSetSplainFunction)(TStringType FuncName,   Pointer32 AdrVX,  Pointer32 AdrVY,  Int32 ArrayType, Pointer32 IDFP);
typedef void (_stdcall *PTflSetDiffNumCurrency)(Int32 Np, double h);


typedef Int32 (_stdcall *PTflResultSafe)(Pointer32 Func);
typedef Int32 (_stdcall *PTflResultSafeD)(Pointer32 Func, double& Res);
typedef Int32 (_stdcall *PTflResultSafeE)(Pointer32 Func, Extended& Res);
typedef Int32 (_stdcall *PTflResultSafeCxD)(Pointer32 Func, double& Re, double& Im);
typedef Int32 (_stdcall *PTflResultSafeCxE)(Pointer32 Func, Extended& Re, Extended& Im);
typedef Int32 (_stdcall *PTflResultSafeCxDP)(Pointer32 Func, Pointer32 PRes);
typedef Int32 (_stdcall *PTflResultSafeCxEP)(Pointer32 Func, Pointer32 PRes);

typedef void   (_stdcall *PTflMaskFPUException)(void);
typedef Int32 (_stdcall *PTflGetFPUException)(void);



typedef void (_stdcall *PTflRenameFunction)(TStringType Name, TStringType NewName);
typedef void (_stdcall *PTflAddNameFunction)( Int32 IDF, TStringType FuncName);
typedef void (_stdcall *PTflGetFuncIDN)(TStringType FuncName, Int32& IDN);
typedef void (_stdcall *PTflGetFunctionIDFP)(TStringType FuncName, Pointer32 FData, Pointer32 IDFP);
typedef void (_stdcall *PTflChangeFunctionProperty)(Int32 Action, Pointer32 IDFP);
typedef void (_stdcall *PTflGetFunctionAddr) (Pointer32 idFP, Pointer32& AddrF);



typedef void (_stdcall *PTflSetOperation)(TStringType OpSymb,   Pointer32 OperData);
typedef void (_stdcall *PTflGetOperation)(TStringType OpSymb,   Pointer32 OperData);

//auxiliary:
typedef void (_stdcall *PTflCopyArrayExt)(Pointer32 SrcAddr, Pointer32 DstAddr, Int32 Len);
typedef void (_stdcall *PTflCopyArrayDbl)(Pointer32 SrcAddr, Pointer32 DstAddr, Int32 Len);
typedef void (_stdcall *PTflCopyArrayInt)(Pointer32 SrcAddr, Pointer32 DstAddr, Int32 Len);
typedef void (_stdcall *PTflCopyArrayExtDSC)(Pointer32 SrcAddr, Pointer32 DstAddr, Int32 CellSizeSrc, Int32 CellSizeDst, Int32 Len);
typedef void (_stdcall *PTflCopyMemory)(Pointer32 SrcAddr, Pointer32 DstAddr, Int32  NBytes);
typedef void (_stdcall *PTflCopyVarCxD)(Pointer32  SrcAddr, Pointer32  DstAddr);
typedef void (_stdcall *PTflCopyVarCxE)(Pointer32  SrcAddr, Pointer32  DstAddr);
typedef void (_stdcall *PTflCopyVarD)(Pointer32  SrcAddr, Pointer32  DstAddr);
typedef void (_stdcall *PTflCopyVarE)(Pointer32  SrcAddr, Pointer32  DstAddr);
typedef void (_stdcall *PTflCopyVarI)(Pointer32  SrcAddr, Pointer32  DstAddr);






//
PTflCompile                flCompile;
PTflSetVar                 flSetVar;
PTflSetVarCx               flSetVarCx;
PTflSetParam               flSetParam;
PTflSetParamD              flSetParamD;
PTflSetParamE              flSetParamE;
PTflSetFunction            flSetFunction;
PTflSet                    flSet;
PTflGet                    flGet;
PTflGetP                   flGetP;
PTflGetErrorCode           flGetErrorCode;
PTflGetErrorString         flGetErrorString;
PTflPerform                flPerform;
PTflSetExpression          flSetExpression;


PTflResultCxD              flResultCxD;
PTflResultCxE              flResultCxE;
PTflResultCxDP             flResultCxDP;
PTflResultCxEP             flResultCxEP;
PTflResultD                flResultD;
PTflResultE                flResultE;
PTflResult                 flResult;
PTflResultR                flResultR;



PTflResultSafe             flResultSafe;
PTflResultSafeD            flResultSafeD;
PTflResultSafeE            flResultSafeE;
PTflResultSafeCxD          flResultSafeCxD;
PTflResultSafeCxE          flResultSafeCxE;
PTflResultSafeCxDP         flResultSafeCxDP;
PTflResultSafeCxEP         flResultSafeCxEP;


PTflPolarDP                flPolarDP;
PTflPolarEP                flPolarEP;
PTflDecartDP               flDecartDP;
PTflDecartEP               flDecartEP;


PTflLoadFPUD               flLoadFPUD;
PTflLoadFPUE               flLoadFPUE;
PTflLoadFPUDP              flLoadFPUDP;
PTflLoadFPUEP              flLoadFPUEP;



PTflSetVarIntrnl           flSetVarIntrnl;
PTflSetVarValueS           flSetVarValueS;
PTflSetVarValueD           flSetVarValueD;
PTflSetVarValueE           flSetVarValueE;
PTflSetVarValueI           flSetVarValueI;
PTflSetVarValueCxS         flSetVarValueCxS;
PTflSetVarValueCxD         flSetVarValueCxD;
PTflSetVarValueCxE         flSetVarValueCxE;

PTflSetLength              flSetLength ;
PTflSetArrayValueD         flSetArrayValueD;
PTflSetArrayValueE         flSetArrayValueE;
PTflSetArrayValueI         flSetArrayValueI;
PTflSetArrayValueS         flSetArrayValueS;


PTflGetVarValueS           flGetVarValueS;
PTflGetVarValueD           flGetVarValueD;
PTflGetVarValueE           flGetVarValueE;
PTflGetVarValueI           flGetVarValueI;
PTflGetVarValueCxS         flGetVarValueCxS;
PTflGetVarValueCxD         flGetVarValueCxD;
PTflGetVarValueCxE         flGetVarValueCxE;
PTflGetArrayValueD         flGetArrayValueD;
PTflGetArrayValueE         flGetArrayValueE;
PTflGetArrayValueI         flGetArrayValueI;
PTflGetArrayValueS         flGetArrayValueS;

PTflSetNameImUnit          flSetNameImUnit;

PTflSetDiffVar             flSetDiffVar;
PTflSetDiffExpr            flSetDiffExpr;
PTflDiffExpr               flDiffExpr;
PTflGetDiffString          flGetDiffString;
PTflCompileDiffExpr        flCompileDiffExpr;
PTflCompileDeriv           flCompileDeriv;


PTflSetDiffTemplate        flSetDiffTemplate;
PTflSetSplainFunction      flSetSplainFunction;
PTflSetDiffNumCurrency     flSetDiffNumCurrency;


PTflMaskFPUException       flMaskFPUException;
PTflGetFPUException        flGetFPUException;


PTflRenameFunction         flRenameFunction;
PTflAddNameFunction        flAddNameFunction;
PTflGetFuncIDN             flGetFuncIDN;
PTflGetFunctionIDFP        flGetFunctionIDFP;
PTflChangeFunctionProperty flChangeFunctionProperty;
PTflGetFunctionAddr        flGetFunctionAddr;


PTflSetOperation           flSetOperation;
PTflGetOperation           flGetOperation;

PTflCopyArrayExt           flCopyArrayExt;
PTflCopyArrayDbl           flCopyArrayDbl;
PTflCopyArrayInt           flCopyArrayInt;
PTflCopyArrayExtDSC        flCopyArrayExtDSC;
PTflCopyMemory             flCopyMemory;
PTflCopyVarCxD             flCopyVarCxD;
PTflCopyVarCxE             flCopyVarCxE;
PTflCopyVarD               flCopyVarD;
PTflCopyVarE               flCopyVarE;
PTflCopyVarI               flCopyVarI;




Int32       DLLCompiledBy, IDL;
const Int32  Delphi  = 1;
const Int32  Lazarus = 2;



Int32 flInit()
{

   static HINSTANCE hDLL;
   hDLL = LoadLibraryA("Foreval.dll");

   if (hDLL == NULL) {return 0;}
   else
   {
	 flCompile = (PTflCompile)GetProcAddress(hDLL, "flCompile");
	 flSet = (PTflSet)GetProcAddress(hDLL, "flSet");
	 flGet  = (PTflGet)GetProcAddress(hDLL, "flGet");
     flGetP  = (PTflGetP)GetProcAddress(hDLL, "flGet");
	 flSetVar = (PTflSetVar)GetProcAddress(hDLL, "flSetVar");
	 flSetVarCx = (PTflSetVarCx)GetProcAddress(hDLL, "flSetVarCx");
     flSetParam = (PTflSetParam)GetProcAddress(hDLL, "flSetParam");
	 flSetParamD = (PTflSetParamD)GetProcAddress(hDLL, "flSetParamD");
	 flSetParamE = (PTflSetParamE)GetProcAddress(hDLL, "flSetParamE");
	 flSetFunction = (PTflSetFunction)GetProcAddress(hDLL, "flSetFunction");
     flPerform = (PTflPerform)GetProcAddress(hDLL, "flPerform");
     flSetExpression = (PTflSetExpression)GetProcAddress(hDLL, "flSetExpression");

	 flGetErrorString = (PTflGetErrorString)GetProcAddress(hDLL, "flGetErrorString");
	 flGetErrorCode = (PTflGetErrorCode)GetProcAddress(hDLL, "flGetErrorCode");




	 flResultCxE = (PTflResultCxE)GetProcAddress(hDLL, "flResultCxE");
	 flResultCxD = (PTflResultCxD)GetProcAddress(hDLL, "flResultCxD");
	 flResultCxEP = (PTflResultCxEP)GetProcAddress(hDLL, "flResultCxEP");
	 flResultCxDP = (PTflResultCxDP)GetProcAddress(hDLL, "flResultCxDP");
	 flResultD = (PTflResultD)GetProcAddress(hDLL, "flResultD");
	 flResultE = (PTflResultE)GetProcAddress(hDLL, "flResultE");
	 flResult = (PTflResult)GetProcAddress(hDLL, "flResult");
	 flResultR = (PTflResultR)GetProcAddress(hDLL, "flResult");




	 flResultSafeCxD = (PTflResultSafeCxD)GetProcAddress(hDLL, "flResultSafeCxD");
	 flResultSafeCxDP = (PTflResultSafeCxDP)GetProcAddress(hDLL, "flResultSafeCxDP");
     flResultSafeCxE = (PTflResultSafeCxE)GetProcAddress(hDLL, "flResultSafeCxE");
	 flResultSafeCxEP = (PTflResultSafeCxEP)GetProcAddress(hDLL, "flResultSafeCxEP");
	 flResultSafeD = (PTflResultSafeD)GetProcAddress(hDLL, "flResultSafeD");
	 flResultSafeE = (PTflResultSafeE)GetProcAddress(hDLL, "flResultSafeE");
	 flResultSafe = (PTflResultSafe)GetProcAddress(hDLL, "flResultSafe");


     flSetVarIntrnl  = (PTflSetVarIntrnl)GetProcAddress(hDLL, "flSetVarIntrnl");
	 flSetVarValueS  = (PTflSetVarValueS)GetProcAddress(hDLL, "flSetVarValueS");
     flSetVarValueD  = (PTflSetVarValueD)GetProcAddress(hDLL, "flSetVarValueD");
	 flSetVarValueE  = (PTflSetVarValueE)GetProcAddress(hDLL, "flSetVarValueE");
	 flSetVarValueI  = (PTflSetVarValueI)GetProcAddress(hDLL, "flSetVarValueI");
	 flSetVarValueCxS  = (PTflSetVarValueCxS)GetProcAddress(hDLL, "flSetVarValueCxS");
	 flSetVarValueCxD  = (PTflSetVarValueCxD)GetProcAddress(hDLL, "flSetVarValueCxD");
	 flSetVarValueCxE  = (PTflSetVarValueCxE)GetProcAddress(hDLL, "flSetVarValueCxE");

     flSetLength  = (PTflSetLength)GetProcAddress(hDLL, "flSetLength");
	 flSetArrayValueD  = (PTflSetArrayValueD)GetProcAddress(hDLL, "flSetArrayValueD");
	 flSetArrayValueE  = (PTflSetArrayValueE)GetProcAddress(hDLL, "flSetArrayValueE");
	 flSetArrayValueI  = (PTflSetArrayValueI)GetProcAddress(hDLL, "flSetArrayValueI");
	 flSetArrayValueS  = (PTflSetArrayValueS)GetProcAddress(hDLL, "flSetArrayValueS");

	 flGetVarValueS  = (PTflGetVarValueS)GetProcAddress(hDLL, "flGetVarValueS");
	 flGetVarValueD  = (PTflGetVarValueD)GetProcAddress(hDLL, "flGetVarValueD");
	 flGetVarValueE  = (PTflGetVarValueE)GetProcAddress(hDLL, "flGetVarValueE");
	 flGetVarValueI  = (PTflGetVarValueI)GetProcAddress(hDLL, "flGetVarValueI");
	 flGetVarValueCxS  = (PTflGetVarValueCxS)GetProcAddress(hDLL, "flGetVarValueCxS");
	 flGetVarValueCxD  = (PTflGetVarValueCxD)GetProcAddress(hDLL, "flGetVarValueCxD");
	 flGetVarValueCxE  = (PTflGetVarValueCxE)GetProcAddress(hDLL, "flGetVarValueCxE");
	 flGetArrayValueD  = (PTflGetArrayValueD)GetProcAddress(hDLL, "flGetArrayValueD");
	 flGetArrayValueE  = (PTflGetArrayValueE)GetProcAddress(hDLL, "flGetArrayValueE");
	 flGetArrayValueI  = (PTflGetArrayValueI)GetProcAddress(hDLL, "flGetArrayValueI");
	 flGetArrayValueS  = (PTflGetArrayValueS)GetProcAddress(hDLL, "flGetArrayValueS");

     flSetDiffVar = (PTflSetDiffVar)GetProcAddress(hDLL, "flSetDiffVar");
     flSetDiffExpr = (PTflSetDiffExpr)GetProcAddress(hDLL, "flSetDiffExpr");
     flDiffExpr = (PTflDiffExpr)GetProcAddress(hDLL, "flDiffExpr");
     flGetDiffString = (PTflGetDiffString)GetProcAddress(hDLL, "flGetDiffString");
     flCompileDiffExpr = (PTflCompileDiffExpr)GetProcAddress(hDLL, "flCompileDiffExpr");
     flCompileDeriv = (PTflCompileDeriv)GetProcAddress(hDLL, "flCompileDeriv");

     flSetDiffTemplate = (PTflSetDiffTemplate)GetProcAddress(hDLL, "flSetDiffTemplate");
     flSetSplainFunction = (PTflSetSplainFunction)GetProcAddress(hDLL, "flSetSplainFunction");
     flSetDiffNumCurrency = (PTflSetDiffNumCurrency)GetProcAddress(hDLL, "flSetDiffNumCurrency");


	 flLoadFPUD = (PTflLoadFPUD)GetProcAddress(hDLL, "flLoadFPUD");
	 flLoadFPUE = (PTflLoadFPUE)GetProcAddress(hDLL, "flLoadFPUE");
	 flLoadFPUDP = (PTflLoadFPUDP)GetProcAddress(hDLL, "flLoadFPUDP");
	 flLoadFPUEP = (PTflLoadFPUEP)GetProcAddress(hDLL, "flLoadFPUEP");

	 flPolarDP = (PTflPolarDP)GetProcAddress(hDLL, "flPolarDP");
	 flPolarEP = (PTflPolarEP)GetProcAddress(hDLL, "flPolarEP");
	 flDecartDP = (PTflDecartDP)GetProcAddress(hDLL, "flDecartDP");
	 flDecartEP = (PTflDecartEP)GetProcAddress(hDLL, "flDecartEP");

     flSetNameImUnit  = (PTflSetNameImUnit)GetProcAddress(hDLL, "flSetNameImUnit");

     flMaskFPUException = (PTflMaskFPUException)GetProcAddress(hDLL, "flMaskFPUException");
     flGetFPUException  = (PTflGetFPUException)GetProcAddress(hDLL, "flGetFPUException");

	 flAddNameFunction  = (PTflAddNameFunction)GetProcAddress(hDLL, "flAddNameFunction");
	 flGetFuncIDN  = (PTflGetFuncIDN)GetProcAddress(hDLL, "flGetFuncIDN");
	 flGetFunctionIDFP  = (PTflGetFunctionIDFP)GetProcAddress(hDLL, "flGetFunctionIDFP");
     flRenameFunction  = (PTflRenameFunction)GetProcAddress(hDLL, "flRenameFunction");
     flChangeFunctionProperty = (PTflChangeFunctionProperty)GetProcAddress(hDLL, "flChangeFunctionProperty");
     flGetFunctionAddr = (PTflGetFunctionAddr)GetProcAddress(hDLL, "flGetFunctionAddr");


     flSetOperation = (PTflSetOperation)GetProcAddress(hDLL, "flSetOperation");
     flGetOperation = (PTflGetOperation)GetProcAddress(hDLL, "flGetOperation");
     flCopyArrayExt = (PTflCopyArrayExt)GetProcAddress(hDLL, "flCopyArrayExt");
     flCopyArrayDbl = (PTflCopyArrayDbl)GetProcAddress(hDLL, "flCopyArrayDbl");
     flCopyArrayInt = (PTflCopyArrayInt)GetProcAddress(hDLL, "flCopyArrayInt");
     flCopyArrayExtDSC = (PTflCopyArrayExtDSC)GetProcAddress(hDLL, "flCopyArrayExtDSC");
     flCopyMemory = (PTflCopyMemory)GetProcAddress(hDLL, "flCopyMemory");
     flCopyVarCxD = (PTflCopyVarCxD)GetProcAddress(hDLL, "flCopyVarCxD");
     flCopyVarCxE = (PTflCopyVarCxE)GetProcAddress(hDLL, "flCopyVarCxE");
     flCopyVarD   = (PTflCopyVarE)GetProcAddress(hDLL, "flCopyVarD");
     flCopyVarE   = (PTflCopyVarD)GetProcAddress(hDLL, "flCopyVarE");
     flCopyVarI   = (PTflCopyVarI)GetProcAddress(hDLL, "flCopyVarI");


     flGet(fl_COMPILED_BY,0,IDL);
     if (IDL >= 100 ) {DLLCompiledBy = Lazarus;} else {DLLCompiledBy = Delphi;};

	return 1;
   }
}


void  InitFuncStruct(TAddFuncStruct& FS)
{
  FS.addr=0;
  FS.CallType=fl_STDCALL;
  FS.Arg=0;
  FS.ArgType=fl_DIFFER;
  FS.ArgTypeList=0;
  FS.CallFunc=0;
  FS.ResultType=0;
  FS.CalcConst=fl_YES;
  FS.DeepFPU=8;   //max value = 8 ! Use, if unknown deep FPU stack of added function. To prevents error overload stack FPU.
  FS.SaveReg=15;  //=15 save eax,ebx,ecx,edx (RECOMMEND.);  =255 save all reg; see .doc if there are any error
  FS.ReplFunc=fl_YES;
  FS.Set_ID=0;
  FS.Id_Func=0;
  FS.AdrDeriv=0;
  FS.NDeriv=0;
  FS.Place=fl_NEW; //fl_ReWRITE;
  FS.ResultTypeMath = fl_EXTENDED;
  FS.IsInline = fl_NO;
  FS.Rsrv1=0;
  FS.Rsrv2=0;
  FS.Rsrv3=0;
}


#endif
