

/*
		  Full translation Forevaldll.pas to C++
          For Builder C++ and compatible
			   8.4.17.249
*/
#pragma once
#include <windows.h>
#include <oleauto.h>
using namespace std;

//#define STRING
//#define ANSISTRING
//#define WIDESTRING
#define PANSICHAR
//#define UTF8

#ifdef    ANSISTRING
 typedef  AnsiString TStringType;
#endif


#ifdef   WIDESTRING
 typedef  WideString TStringType;
#endif

#ifdef    STRING
 typedef  String TStringType;      //String = UTF16 for delphi,builder >=2009 else String = AnsiString
#endif

#ifdef    UTF8
 typedef  UTF8String TStringType;
#endif

#ifdef    PANSICHAR
 typedef  PAnsiChar TStringType;
#endif



const   Int32   fl_DISABLE              = 0;
const   Int32   fl_ENABLE               = 1;
const   Int32   fl_AUTO                 = 2;
const   Int32   fl_YES                  = 3;
const   Int32   fl_NO                   = 4;
const   Int32   fl_SYNTAX_EXTENSION     = 10;
const   Int32   fl_LEAD_TO_LOWER_CASE   = 11;
const   Int32   fl_CALC_CONST_EXPR_IN_MULTI_EXPR = 12;
const   Int32   fl_CALC_CONST_FUNC      = 13;
const   Int32   fl_EXTERNAL_EXCEPTION   = 14;
const   Int32   fl_REPLACE_FUNCTION     = 15;
const   Int32   fl_DINAMIC_LOAD         = 16;
const   Int32   fl_SAVE_EAX             = 17;
const   Int32   fl_SAVE_EBX             = 18;
const   Int32   fl_SAVE_ECX             = 19;
const   Int32   fl_SAVE_EDX             = 20;
const   Int32   fl_SAVE_ESP             = 21;
const   Int32   fl_SAVE_EBP             = 22;
const   Int32   fl_SAVE_ESI             = 23;
const   Int32   fl_SAVE_EDI             = 24;
const   Int32   fl_STACK_DEEP           = 25;
const   Int32   fl_SINGLE               = 26;
const   Int32   fl_INTEGER              = 27;
const   Int32   fl_DOUBLE               = 28;
const   Int32   fl_EXTENDED             = 29;
const   Int32   fl_DIFFER               = 30;
const   Int32   fl_DATA_TYPE            = 31;
const   Int32   fl_PARAM_TYPE           = 32;
const   Int32   fl_SKIPPED_IF           = 33;
const   Int32   fl_EXCHANGE_BRANCH      = 34;
const   Int32   fl_GLOBAL_OPTIMIZATION  = 35;
const   Int32   fl_SET_ID               = 36;
const   Int32   fl_CLST                 = 37;
const   Int32   fl_ADDRESS              = 38;
const   Int32   fl_INLINE               = 39;
const   Int32   fl_FUNC_STACK_DEEP      = 40;
const   Int32   fl_FUNC_ID              = 41;
const   Int32   fl_NUM_ARG              = 42;
const   Int32   fl_ARROW                = 43;
const   Int32   fl_ARG_TYPE             = 44;
const   Int32   fl_ARG_TYPE_LIST        = 45;
const   Int32   fl_SAVE_REG             = 46;
const   Int32   fl_CALL_TYPE            = 47;
const   Int32   fl_CLEAR                = 48;
const   Int32   fl_PARAM_LIST           = 49;
const   Int32   fl_VAR_LIST             = 50;
const   Int32   fl_FREE                 = 51;
const   Int32   fl_ADD_FUNC_LIST        = 54;
const   Int32   fl_CMPL_FUNC_LIST       = 55;
const   Int32   fl_CLEAR_NAMES_FUNC     = 56;
const   Int32   fl_EAX                  = 57;
const   Int32   fl_EBX                  = 58;
const   Int32   fl_ECX                  = 59;
const   Int32   fl_EDX                  = 60;
const   Int32   fl_ESP                  = 61;
const   Int32   fl_STRING_TYPE          = 62;
const   Int32   fl_STRING               = 63;
const   Int32   fl_STRING_UTF16         = 63;
const   Int32   fl_PCHAR                = 64;
const   Int32   fl_ANSISTRING           = 65;
const   Int32   fl_CLOSE_ARG            = 66;
const   Int32   fl_PACKAGE_COMPILE      = 67;
const   Int32   fl_TRIG_OPTIMIZATION    = 68;
const   Int32   fl_HYP_OPTIMIZATION     = 69;
const   Int32   fl_SHOW_EXCEPTION       = 99;
const   Int32   fl_ARRAY_DOUBLE         = 70;
const   Int32   fl_ARRAY_EXTENDED       = 71;
const   Int32   fl_ARRAY_SINGLE         = 72;
const   Int32   fl_ARRAY_INTEGER        = 73;
const   Int32   fl_STRING_INTERNAL      = 74;
const   Int32   fl_ERROR_CODE           = 75;
const   Int32   fl_VAR_PRESENT          = 76;
const   Int32   fl_CALC_CONST_EXPR      = 77;
const   Int32   fl_WIDESTRING           = 78;
const   Int32   fl_PWIDECHAR            = 79;
const   Int32   fl_PANSICHAR            = 80;
const   Int32   fl_RawByteString        = 81;
const   Int32   fl_FUNCTION             = 82;
const   Int32   fl_EXTENDED_COMMAND     = 83;  //procedure: if, for, fordown, while
const   Int32   fl_STRING_UTF8          = 84;
const   Int32   fl_SAVE                 = 85;
const   Int32   fl_RESTORE              = 86;
const   Int32   fl_Diff_Num_Precision   = 87;
const   Int32   fl_REPLACE_MULDIV       = 88;
const   Int32   fl_REPLACE_ADDSUB       = 89;
const   Int32   fl_REPLACE_OPERATION    = 90;
const   Int32   fl_REPLACE_MULTI_EXPR   = 91;
const   Int32   fl_USE_VIRTUAL_ALLOC    = 92;   //only for exe code
const   Int32   fl_REPLACE_ARGF         = 93;
const   Int32   fl_ACCURATE_SPEC_FUNC   = 94;
const   Int32   fl_CHECK_INCORRECT_SPACE  = 95;
const   Int32   fl_REPLACE_AT_IF        = 96;
const   Int32   fl_CONVERT_ATAN_TO_ATAN2  = 97;
const   Int32   fl_FPU_CW                 = 98;
const   Int32   fl_FPU_CW_DEFAULT         = 99;
const   Int32   fl_MULDIV_OPTIMIZATION    = 100;
const   Int32   fl_ADDSUB_OPTIMIZATION    = 101;
const   Int32   fl_PRECISION              = 102;
const   Int32   fl_MASK_FPU_EXCEPTION     = 103;
const   Int32   fl_CLEAR_FPU_EXCEPTION    = 104;
const   Int32   fl_FUNC_ARG_OPTIMIZATION  = 105;
const   Int32   fl_ADDRESS_EXCEPTION_FLAG = 106;
const   Int32   fl_FREE_CODE_AT_REPLACE   = 107;






//{flAddNewFunction}
const   Int32   fl_MEMORY_EAX           = 100;
const   Int32   fl_MEMORY_EBX           = 101;
const   Int32   fl_MEMORY_ECX           = 102;
const   Int32   fl_MEMORY_EDX           = 103;
const   Int32   fl_MEMORY_STACK_CPU     = 104;
const   Int32   fl_KERNEL_I             = 105;
const   Int32   fl_KERNEL_F             = 106;
const   Int32   fl_KERNEL_FI            = 107;
const   Int32   fl_KERNEL_FF            = 108;
const   Int32   fl_STACK_FPU            = 109;
const   Int32   fl_STACK_CPU            = 110;
const   Int32   fl_INFINITE_EABX        = 111;
const   Int32   fl_INFINITE_EBCX        = 112;
const   Int32   fl_INFINITE_ECDX        = 113;
const   Int32   fl_INFINITE_STACK_CPU   = 114;
const   Int32   fl_RIGHT                = 115;
const   Int32   fl_BACK                 = 116;
const   Int32   fl_UNKNOWN              = 117;
const   Int32   fl_MEMORY_ADDRESSES     = 118;
const   Int32   fl_PRECOMPILED          = 119;





//{GetErrorCode}
const   Int32   fl_ACCESS_VIOLATION           = 200;
const   Int32   fl_OUT_OF_MEMORY              = 201;
const   Int32   fl_STACK_OVERFLOW             = 202;
const   Int32   fl_ZERO_DIVIDE                = 203;
const   Int32   fl_INVALID_OPERATION          = 204;
const   Int32   fl_OVERFLOW                   = 205;
const   Int32   fl_UNDERFLOW                  = 206;
const   Int32   fl_INT_OVERFLOW               = 207;
const   Int32   fl_UNKNOWN_SYMBOL             = 208;
const   Int32   fl_MISSING_ROUND_BRACKET      = 209;
const   Int32   fl_MISSING_OPERATION          = 211;
const   Int32   fl_WRONG_NUMBER_ARGUMENTS     = 212;
const   Int32   fl_MISSING_EXPRESSION         = 213;
const   Int32   fl_UNKNOWN_FUNCTION           = 214;
const   Int32   fl_ERROR_AT_ADDITION_FUNCTION = 215;
const   Int32   fl_NONEXISTENT_FUNCTION       = 216;
const   Int32   fl_INCORRECT_ARGUMENT         = 217;
const   Int32   fl_MISSING_ARGUMENT           = 218;
const   Int32   fl_INCORRECT_TYPE             = 219;
const   Int32   fl_SPLAIN_DATA_ERROR          = 220;
const   Int32   fl_MISSING_SEPARATOR          = 221;
const   Int32   fl_WRONG_NAME                 = 222;
const   Int32   fl_MISSING_ABS_BRACKET        = 223;
const   Int32   fl_MISSING_SQUARE_BRACKET     = 224;
const   Int32   fl_MISSING_CURLY_BRACKET      = 225;
const   Int32   fl_NO_DIFF_EXPRESSION         = 226;
const   Int32   fl_WRONG_EXPRESSION           = 227;
const   Int32   fl_INCORRECT_SPACE            = 228;
const   Int32   fl_INTERNAL_ERROR             = 229;
const   Int32   fl_VARIABLE_REDECLARED        = 230;




///{Get,Perform}
const   Int32   fl_VERSION                         = 301;
const   Int32   fl_MAJOR                           = 302;
const   Int32   fl_MINOR                           = 303;
const   Int32   fl_RELEASE                         = 304;
const   Int32   fl_ABOUT                           = 305;
const   Int32   fl_AUTHOR                          = 306;
const   Int32   fl_EXCHANGE_BRANCH_STACK_DEEP      = 316;
const   Int32   fl_EXCHANGE_BRANCHE_NUM            = 317;
const   Int32   fl_DINAMIC_LOAD_STACK_DEEP         = 318;
const   Int32   fl_DINAMIC_LOAD_NUM                = 319;
const   Int32   fl_DINAMIC_LOAD_OVFL               = 320;
const   Int32   fl_COMPILE_STACK_DEEP              = 321;
const   Int32   fl_COMPILE_OVFL                    = 322;
const   Int32   fl_REPLACE_FUNCTION_NUM            = 323;
const   Int32   fl_CALC_CONST_NUM                  = 324;
const   Int32   fl_USE_EAX                         = 325;
const   Int32   fl_USE_EBX                         = 326;
const   Int32   fl_USE_ECX                         = 327;
const   Int32   fl_USE_EDX                         = 328;
const   Int32   fl_USE_ESP                         = 329;
const   Int32   fl_USE_EBP                         = 330;
const   Int32   fl_USE_ESI                         = 331;
const   Int32   fl_USE_EDI                         = 332;
const   Int32   fl_MAX_REPLACE_LEVEL               = 333;
const   Int32   fl_LENGTH_CODE                     = 334;
const   Int32   fl_PACKAGE_COMPILE_LAST_ADDR       = 335;
const   Int32   fl_ARRAY_LENGTH                    = 337;
const   Int32   fl_BUILD                           = 338;
const   Int32   fl_REPLACE_FUNCTION_NUM_UT         = 339;
const   Int32   fl_COMPILED_BY                     = 340;
const   Int32   fl_SHOW                            = 341;
const   Int32   fl_LAST_STRING                     = 342;
const   Int32   fl_RETURN_NUMBER                   = 343;
const   Int32   fl_ADDRESS_OBJECT                  = 344;
const   Int32   fl_LOAD_STACK_AFTER_CALC           = 345;
const   Int32   fl_COMMENT                         = 346;
const   Int32   fl_IS_FPU_EXCEPTION                = 347;














typedef void*        Pointer32 ;
typedef Int32*       PInteger32 ;

typedef DynamicArray < double >    TArrayD;
typedef DynamicArray < Extended >  TArrayE;
typedef DynamicArray < Int32 >     TArrayI;
typedef DynamicArray < byte >      TArrayB;
typedef DynamicArray < Pointer32 > TArrayP;

typedef TArrayD*   PArrayD ;
typedef TArrayE*   PArrayE ;
typedef TArrayI*   PArrayI ;
//typedef double*  PDouble ;
//typedef Int32*  Pointer32 ;




struct TAddFuncStruct
			 {
				  Pointer32  addr;
					  Int32  Arg;
					  Int32  CallType;
					  Int32  ArgType;
				  Pointer32  ArgTypeList;
				      Int32  ClearStack;
					  Int32  Arrow ;
					  Int32  DeepFPU;
					  Int32  Set_ID;
					  Int32  Id_Func;
					  Int32  SaveReg;
				  Pointer32  CodeInline;
					  Int32  SizeCode;
				  Pointer32  AdrDeriv;
					  Int32  NDeriv;
					  Int32  CalcConst;
					  Int32  RetNum;
					  Int32  ReplFunc;
             };

struct TAttrib
		 {
			  Int32  Adr;
			  Int32  RType;
		      Int32  Shift;

		 };





typedef void (_stdcall *PTflCompile)(TStringType Expression, Pointer32 Attr, Pointer32& Func);
typedef void (_stdcall *PTflSetFunction)(TStringType FuncName, Pointer32 FuncAddr, Int32& IDF);
typedef void (_stdcall *PTflCompileDiff)(TStringType Expression,  Int32 N, Pointer32& Addr);
typedef void (_stdcall *PTflSetDiffVar)(TStringType Name);
typedef void (_stdcall *PTflSetDiffExpr)(TStringType Name);
typedef void (_stdcall *PTflSetDiffTemplate)(Int32 ID,  TStringType TemplateDiff);
typedef void (_stdcall *PTflDiffExpr)(Int32 N);
typedef void (_stdcall *PTflCompileDiffExpr)(Pointer32& Addr);
typedef void (_stdcall *PTflGetDiffString)(Pointer32& DS);
typedef void (_stdcall *PTflSetSplainFunction)(TStringType FuncName,   Pointer32 AdrVX,  Pointer32 AdrVY,  Int32 ArrayType, Int32& ID);
typedef void (_stdcall *PTflSet)(Int32 mode, Int32 value1, Int32 value2);
typedef void (_stdcall *PTflGet)(Int32 mode, Int32 subj, Int32& value);
typedef void (_stdcall *PTflGetFuncID)(TStringType FuncName, Int32& IDF);
typedef void (_stdcall *PTflAddNameFunction)( Int32 IDF, TStringType FuncName);
typedef void (_stdcall *PTflSetVar)(TStringType Name, Pointer32 Addr, Int32 TypeVar);
typedef void (_stdcall *PTflCompile)(TStringType Expression, Pointer32 Attr, Pointer32& Func);
typedef void (_stdcall *PTflSetParam)(TStringType Name, Pointer32 Addr, Int32 ParamType);
typedef void (_stdcall *PTflResultD)(Pointer32 Func, double& Res);
typedef void (_stdcall *PTflResultE)(Pointer32 Func, Extended& Res);
typedef void (_stdcall *PTflResultS)(Pointer32 Func, Single& Res);
typedef void (_stdcall *PTflResult)(Pointer32 Func);
typedef void (_stdcall *PTflGetErrorCode)(Int32& CError);
typedef void (_stdcall *PTflGetErrorString)(Pointer32& SError);
typedef void (_stdcall *PTflPerform)(Int32 act, Int32 subj);
typedef void (_stdcall *PTflSetVarIntrnl)(TStringType Name,  Int32 VType, Pointer32& ExAddr);
typedef void (_stdcall *PTflSetVarValueS)(Pointer32 addr, Single Val);
typedef void (_stdcall *PTflSetVarValueD)(Pointer32 addr, double Val);
typedef void (_stdcall *PTflSetVarValueE)(Pointer32 addr, Extended Val);
typedef void (_stdcall *PTflSetVarValueI)(Pointer32 addr, Int32 Val);
typedef void (_stdcall *PTflSetLength)(Pointer32 adrV, Int32 TypeV, Int32 Len);
typedef void (_stdcall *PTflSetArrayValueD)(Pointer32 addr, Int32 indx, double Val);
typedef void (_stdcall *PTflSetArrayValueS)(Pointer32 addr, Int32 indx, Single Val);
typedef void (_stdcall *PTflSetArrayValueE)(Pointer32 addr, Int32 indx, Extended Val);
typedef void (_stdcall *PTflSetArrayValueI)(Pointer32 addr, Int32 indx, Int32 Val);
typedef void (_stdcall *PTflGetArrayValueI)(Pointer32 addr, Int32 indx, Int32& Val);
typedef void (_stdcall *PTflGetArrayValueD)(Pointer32 addr, Int32 indx, double& Val);
typedef void (_stdcall *PTflGetArrayValueS)(Pointer32 addr, Int32 indx, Single& Val);
typedef void (_stdcall *PTflGetArrayValueE)(Pointer32 addr, Int32 indx, Extended& Val);
typedef void (_stdcall *PTflGetVarValueE)(Pointer32 addr,  Extended& Val);     //val=extended(addr)
typedef void (_stdcall *PTflGetVarValueD)(Pointer32 addr,  double& Val);       //val=double(addr)
typedef void (_stdcall *PTflGetVarValueI)(Pointer32 addr,  Int32& Val);        //val=integer(addr)
typedef void (_stdcall *PTflGetVarValueS)(Pointer32 addr,  Single& Val);        //val=integer(addr)
typedef void (_stdcall *PTflResultSafe)(Pointer32 Func);
typedef void (_stdcall *PTflResultDSafe)(Pointer32 Func, double& Res);


/*
 flResult     :
 flResult  may be declared   as:
 */
 //function flResult(Addr: Pointer): single;
 //function flResult(Addr: Pointer): double;
 //function flResult(Addr: Pointer): extended;




//
PTflCompile                flCompile;
PTflSet                    flSet;
PTflAddNameFunction        flAddNameFunction;
PTflGetFuncID              flGetFuncID;
PTflGet                    flGet;
PTflSetVar                 flSetVar;
PTflSetParam               flSetParam;
PTflGetErrorCode           flGetErrorCode;
PTflGetErrorString         flGetErrorString;
PTflSetFunction            flSetFunction;
PTflResultD                flResultD;
PTflResultE                flResultE;
PTflResult                 flResult;
PTflResultSafe             flResultSafe;
PTflResultDSafe            flResultDSafe;
PTflPerform                flPerform;
PTflSetVarIntrnl           flSetVarIntrnl;
PTflSetVarValueS           flSetVarValueS;
PTflSetVarValueD           flSetVarValueD;
PTflSetVarValueE           flSetVarValueE;
PTflSetVarValueI           flSetVarValueI;
PTflGetVarValueS           flGetVarValueS;
PTflGetVarValueD           flGetVarValueD;
PTflGetVarValueE           flGetVarValueE;
PTflGetVarValueI           flGetVarValueI;
PTflSetLength              flSetLength ;
PTflSetArrayValueS         flSetArrayValueS;
PTflSetArrayValueD         flSetArrayValueD;
PTflSetArrayValueE         flSetArrayValueE;
PTflSetArrayValueI         flSetArrayValueI;
PTflGetArrayValueS         flGetArrayValueS;
PTflGetArrayValueD         flGetArrayValueD;
PTflGetArrayValueE         flGetArrayValueE;
PTflGetArrayValueI         flGetArrayValueI;
PTflCompileDiff            flCompileDiff;
PTflSetDiffVar             flSetDiffVar;
PTflSetDiffExpr            flSetDiffExpr;
PTflSetDiffTemplate        flSetDiffTemplate;
PTflDiffExpr               flDiffExpr;
PTflCompileDiffExpr        flCompileDiffExpr;
PTflGetDiffString          flGetDiffString;
PTflSetSplainFunction      flSetSplainFunction;




Int32 flInit()
{

   static HINSTANCE hDLL;
   hDLL = LoadLibraryA("Foreval.dll");

   if (hDLL == NULL) {return 0;}
   else
   {
	 flCompile = (PTflCompile)GetProcAddress(hDLL, "flCompile");
	 flSet = (PTflSet)GetProcAddress(hDLL, "flSet");
	 flSetVar = (PTflSetVar)GetProcAddress(hDLL, "flSetVar");
	 flSetParam = (PTflSetParam)GetProcAddress(hDLL, "flSetParam");
	 flResultD = (PTflResultD)GetProcAddress(hDLL, "flResultD");
	 flResultE = (PTflResultE)GetProcAddress(hDLL, "flResultE");
	 flResult = (PTflResult)GetProcAddress(hDLL, "flResult");
	 flResultDSafe = (PTflResultDSafe)GetProcAddress(hDLL, "flResultDSafe");
	 flResultSafe = (PTflResultSafe)GetProcAddress(hDLL, "flResultSafe");
	 flGetErrorString = (PTflGetErrorString)GetProcAddress(hDLL, "flGetErrorString");
	 flGetErrorCode = (PTflGetErrorCode)GetProcAddress(hDLL, "flGetErrorCode");
	 flSetFunction = (PTflSetFunction)GetProcAddress(hDLL, "flSetFunction");
	 flPerform = (PTflPerform)GetProcAddress(hDLL, "flPerform");
	 flAddNameFunction  = (PTflAddNameFunction)GetProcAddress(hDLL, "flAddNameFunction");
	 flGetFuncID  = (PTflGetFuncID)GetProcAddress(hDLL, "flGetFuncID");
	 flGet  = (PTflGet)GetProcAddress(hDLL, "flGet");
	 flSetVarValueS  = (PTflSetVarValueS)GetProcAddress(hDLL, "flSetVarValueS");
	 flSetVarValueD  = (PTflSetVarValueD)GetProcAddress(hDLL, "flSetVarValueD");
	 flSetVarValueE  = (PTflSetVarValueE)GetProcAddress(hDLL, "flSetVarValueE");
	 flSetVarValueI  = (PTflSetVarValueI)GetProcAddress(hDLL, "flSetVarValueI");
	 flGetVarValueS  = (PTflGetVarValueS)GetProcAddress(hDLL, "flGetVarValueS");
	 flGetVarValueD  = (PTflGetVarValueD)GetProcAddress(hDLL, "flGetVarValueD");
	 flGetVarValueE  = (PTflGetVarValueE)GetProcAddress(hDLL, "flGetVarValueE");
	 flGetVarValueI  = (PTflGetVarValueI)GetProcAddress(hDLL, "flGetVarValueI");
	 flSetLength  = (PTflSetLength)GetProcAddress(hDLL, "flSetLength");
	 flSetArrayValueS  = (PTflSetArrayValueS)GetProcAddress(hDLL, "flSetArrayValueS");
	 flSetArrayValueD  = (PTflSetArrayValueD)GetProcAddress(hDLL, "flSetArrayValueD");
	 flSetArrayValueE  = (PTflSetArrayValueE)GetProcAddress(hDLL, "flSetArrayValueE");
	 flSetArrayValueI  = (PTflSetArrayValueI)GetProcAddress(hDLL, "flSetArrayValueI");
	 flGetArrayValueS  = (PTflGetArrayValueS)GetProcAddress(hDLL, "flGetArrayValueS");
	 flGetArrayValueD  = (PTflGetArrayValueD)GetProcAddress(hDLL, "flGetArrayValueD");
	 flGetArrayValueE  = (PTflGetArrayValueE)GetProcAddress(hDLL, "flGetArrayValueE");
	 flGetArrayValueI  = (PTflGetArrayValueI)GetProcAddress(hDLL, "flGetArrayValueI");
	 flSetVarIntrnl  = (PTflSetVarIntrnl)GetProcAddress(hDLL, "flSetVarIntrnl");
	 flCompileDiff  =     (PTflCompileDiff)GetProcAddress(hDLL, "flCompileDiff");
	 flSetDiffVar  =      (PTflSetDiffVar)GetProcAddress(hDLL, "flSetDiffVar");
	 flSetDiffExpr  =     (PTflSetDiffExpr)GetProcAddress(hDLL, "flSetDiffExpr");
	 flSetDiffTemplate  = (PTflSetDiffTemplate)GetProcAddress(hDLL, "flSetDiffTemplate");
	 flDiffExpr  =        (PTflDiffExpr)GetProcAddress(hDLL, "flDiffExpr");
	 flCompileDiffExpr  = (PTflCompileDiffExpr)GetProcAddress(hDLL, "flCompileDiffExpr");
	 flGetDiffString  = (PTflGetDiffString)GetProcAddress(hDLL, "flGetDiffString");
	 flSetSplainFunction  = (PTflSetSplainFunction)GetProcAddress(hDLL, "flSetSplainFunction");








	return 1;
   }
}



void  InitFuncStruct(TAddFuncStruct& Func)
{
   Func.addr=0;
   Func.Arg=0;
   Func.CallType=fl_STACK_CPU;
   Func.ArgType=fl_DIFFER;
   Func.ArgTypeList=0;
   Func.ClearStack=fl_DISABLE;
   Func.Arrow=fl_RIGHT;
   Func.DeepFPU=8;      //max 8 better than fl_Unknown
   Func.Set_ID=fl_DISABLE;
   Func.Id_Func=0;
   Func.SaveReg=15;         //=15 save eax,ebx,ecx,edx (Recommend.);  =255 save all reg; see .doc if there are any error
   Func.CodeInline=0;
   Func.SizeCode=0;
   Func.AdrDeriv=0;
   Func.NDeriv=0;
   Func.CalcConst=fl_YES;
   Func.RetNum=fl_YES;
   Func.ReplFunc=fl_YES;
};




 void  Result(Pointer32 FuncAddr)
{
_asm
  {

	call FuncAddr
  }
}



 Extended  ResultF(Pointer32 FuncAddr)
{
_asm
  {

	call FuncAddr
  }
};




