//---------------------------------------------------------------------------

/*
   Warning: only for 32bits compilers; all compiled expressions (in Foreval) not support parallel executions(not thread safety)
	  String types defines in Forevaldll.h
	 Foreval.dll compiled in FPC work not correctly with dynamic arrays ; For full compatible  see for source   MSVC
*/
#include <vcl.h>
#include <string>
#include <math.h>
#include <cmath.h>
#include <sysdyn.h>
#pragma hdrstop

#include "Forevaldll.h"
#include "TestF.h"


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

//#define StableTEST

#define EXTENDED_VAR    ///  <- x,y,t: Extended;   STACK&CONST in Foreval : Extended;


#ifdef   EXTENDED_VAR
  typedef  Extended    TFloat;
#else
  typedef  double TFloat;
#endif

typedef TFloat*  PFloat ;




struct TFunc4
	   {
		 double      x;
		 Int32       n;
		 Pointer32   addr;
		 TStringType Expr;
	   };

struct TFunc3
		   {
				TStringType    Expr;
				Pointer32 Addr;
				Extended  res;
				Extended  x;
				Extended  y;
				Extended  z;

		  };

struct TFuncInt3
	  {
	  Pointer32 FAddr;
	  Extended  x    ;
	  Extended  y     ;
	  Extended  z     ;
	  Extended  a     ;
	  Extended  b     ;
	  Pointer32 F1Addr;
	  Pointer32 F2Addr ;
	  Pointer32 F3Addr ;
	  Pointer32 F4Addr ;
	  };


TForm1 *Form1;



TFormatSettings  G_FMT;


TFloat x,y,t;

Extended xe,ye,te,resf,A,B,C,D;
Pointer32 adrXVD,adrXVE,adrXVI,adrVDX,adrVDY,adrXSPL,adrYSPL;
Double xd,yd,td;
Int32 n,k,j,m,l;
TArrayD vd,ad;
TArrayE ve,AInt,BInt,xspl,yspl;
TArrayI vi;
TFunc3 fnc1,fnc2,fnc3;
Extended an[16],bn[16];
Int32 P_Integral,N_Integral;
TFuncInt3  FInt3;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{



}
//---------------------------------------------------------------------------




//void __fastcall TForm1::ConvStr(Pointer32 P, String& S)
void ConvStr(Pointer32 PS, String& S)
{
String S1;
Int32 CError,addr;
//PC: PChar;
AnsiString Ans;
TStringType St;
WideString ws;
PWideString pws;
TByteDynArray utf8b;
//P: Pointer;
PAnsiChar  PAC;
//su8: UTF8String  su8;



#ifdef    WIDESTRING
	St = PWideChar(PS);
#endif
#ifdef    ANSISTRING
	St = PAnsiChar(PS);
#endif
#ifdef    STRING
	St = PChar(PS);
#endif
#ifdef    UTF8
	_asm         //utf8b=AnyPtrToPtrUtf8(PS)
	{
	 push eax
	 push ebx
	 lea eax,utf8b
	 mov ebx,PS
	 mov [eax],ebx
	 pop ebx
	 pop eax
	}
	St = StringOf(utf8b);
#endif
#ifdef    PANSICHAR
  PAC=PAnsiChar(PS);
  Ans=AnsiString(PAC);
  S = Ans.SubString(1, Ans.Length());
  Ans = "";
#endif

#ifndef    PANSICHAR
	S = St.SubString(1, St.Length()); St = "";
#endif

}




double trunc(double d){ return (d>0) ? floor(d) : ceil(d) ; }




void  ShowError(void)
{
String S,S1;
Int32 CError,addr;
//PC: PChar;
AnsiString Ans;
TStringType ErStr;
WideString ws;
PWideString pws;
Pointer32 PS;
TByteDynArray utf8b;
//P: Pointer;
PAnsiChar  PAC;
TFunc3 fnc1,fnc2,fnc3;
//su8: UTF8String  su8;



flGetErrorCode(CError);

switch ( CError )
 {


   case  fl_SPLAIN_DATA_ERROR:                    S="SPLAIN DATA ERROR";break;
   case  fl_NO_DIFF_EXPRESSION:                   S="NO DIFF EXPRESSION";break;
   case  fl_WRONG_NAME:                           S="WRONG NAME";break;
   case  fl_INCORRECT_ARGUMENT:                   S="INCORRECT ARGUMENT";break;
   case  fl_INVALID_OPERATION:                    S="INVALID OPERATION";break;
   case  fl_OVERFLOW:                             S="OVERFLOW";break;
   case  fl_UNDERFLOW:                            S="UNDERFLOW";break;
   case  fl_INT_OVERFLOW:                         S="INTEGER OVERFLOW";break;
   case  fl_ACCESS_VIOLATION:                     S="INTERNAL ERROR or UNCATCHABLE SYNTAX ERROR";break;
   case  fl_OUT_OF_MEMORY:                        S="OUT OF MEMORY";break;
   case  fl_STACK_OVERFLOW:                       S="STACK OVERFLOW";break;
   case  fl_ZERO_DIVIDE:                          S="DIVIDE ON ZERO";break;
   case  fl_UNKNOWN_SYMBOL:                       S ="UNKNOWN SYMBOL or INCORRECT ARGUMENT or WRONG EXPRESSION"; break;
   case  fl_MISSING_ROUND_BRACKET:                S ="MISSING ROUND BRACKET"; break;
   case  fl_MISSING_OPERATION:                    S="MISSING OPERATION";   break;
   case  fl_WRONG_NUMBER_ARGUMENTS:               S="WRONG NUMBER ARGUMENTS";  break;
   case  fl_MISSING_EXPRESSION:                   S="MISSING EXPRESSION";  break;
   case  fl_UNKNOWN_FUNCTION:                     S="UNKNOWN FUNCTION"; break;
   case  fl_ERROR_AT_ADDITION_FUNCTION:           S="ERROR AT ADDITION FUNCTION";   break;
   case  fl_MISSING_ARGUMENT:                     S="MISSING ARGUMENT";  break;
   case  fl_INTERNAL_ERROR:                       S="INTERNAL ERROR or  UNCATCHABLE SYNTAX ERROR"; break;
   case  fl_INCORRECT_TYPE:                       S="WRONG TYPE" ;   break;
   case  fl_MISSING_SQUARE_BRACKET:               S="MISSING SQUARE BRACKET";  break;
   case  fl_MISSING_CURLY_BRACKET:                S="MISSING CURLY BRACKET";  break;
   case  fl_MISSING_ABS_BRACKET:                  S="MISSING ABS BRACKET";  break;
   case  fl_WRONG_EXPRESSION:                     S="WRONG EXPRESSION";  break;
   case  fl_MISSING_SEPARATOR:                    S="MISSING SEPARATOR";   break;
   case  fl_INCORRECT_SPACE:                      S="INCORRECT SPACE";  break;
   case  fl_VARIABLE_REDECLARED:                  S="VARIABLE REDECLARED";  break;
   default:                                       S="UNKNOWN SYNTAX ERROR"; break;
}



   MessageBeep(MB_ICONHAND);
  /*
  {$IFDEF STRINGINT}
	flGetSyntaxErrorString(Str);
	MessageDlg(S+#13#10+'"'+Str+'"',mtError,[mbOk],0);
  {$ELSE}
	flGetSyntaxErrorString(P);
  {$ENDIF}
  */
/*

*/

 // :      -    ,     (   )
 //it's better: at first,  copying of a string then reset - will help to avoid the possible mistakes connected with transfer of strings  (the conflict of different managers of memory)

  //{$IFDEF ANSISTRING}       Ans:=AnsiString(P);    S1:=Copy(Ans,1,Length(Ans)); Ans:=''; MessageDlg(S+#13#10+'"'+S1+'"',mtError,[mbOk],0); {$ENDIF}
  //{$IFDEF STRING}           Str:=String(P);        S1:=Copy(Str,1,Length(Str)); Str:=''; MessageDlg(S+#13#10+'"'+S1+'"',mtError,[mbOk],0); {$ENDIF}
  //{$IFDEF WIDESTRING}       ws:=WideString(P);     S1:=Copy(ws,1,Length(ws));   ws:=''; MessageDlg(S+#13#10+'"'+S1+'"',mtError,[mbOk],0);{$ENDIF}
  //{$IFDEF UTF8}             su8:=UTF8String(P);    S1:=Copy(Su8,1,Length(Su8)); Su8:=''; MessageDlg(S+#13#10+'"'+S1+'"',mtError,[mbOk],0); {$ENDIF}
  //{$IFDEF PANSICHAR}        PAC:=PAnsiChar(P);     Ans:=AnsiString(PAC); S1:=Copy(Ans,1,Length(Ans)); Ans:=''; MessageDlg(S+#13#10+'"'+S1+'"',mtError,[mbOk],0); {$ENDIF}



	flGetErrorString(PS);



#ifdef    WIDESTRING
	ErStr = PWideChar(PS);
#endif
#ifdef    ANSISTRING
	ErStr = PAnsiChar(PS);
#endif
#ifdef    STRING
	ErStr = PChar(PS);
#endif
#ifdef    UTF8
	_asm         //utf8b=AnyPtrToPtrUtf8(PS)
	{
	 push eax
	 push ebx
	 lea eax,utf8b
	 mov ebx,PS
	 mov [eax],ebx
	 pop ebx
	 pop eax
	}
	ErStr = StringOf(utf8b);
#endif
#ifdef    PANSICHAR
 PAC=PAnsiChar(PS);     Ans=AnsiString(PAC);  S1 = Ans.SubString(1, Ans.Length()); Ans = "";
#endif

#ifndef    PANSICHAR
	S1 = ErStr.SubString(1, ErStr.Length()); ErStr = "";
#endif

	MessageDlg(S+(char)13+(char)10+S1,mtError,TMsgDlgButtons() << mbYes,0);

	//MessageDlg("error",mtError,TMsgDlgButtons() << mbYes,0);
}


	  //z1*z2-cos(z1+z2)


//kernel:

void KI1(void)      //n^2
{
 _asm
 {
  imul eax,eax
  push eax
  fild [ESP]
  pop eax
 }
}

void KF1(void)    //x^2
{
 _asm
 {
  fmul st,st
 }
}


void KF2(void)   //x1-x2
{
 _asm
 {
  fsubrp
 }
}

void KFI2(void) //x-n
{
 _asm
 {
  push eax
  fisub [esp]
  add esp,4
 }
}



void FP1(void)
{
 _asm
 {
 fmul st,st
 }
}

void FP2(void)
{
 _asm
 {
 fsubp
 }
}


void FP3(void)
{
 _asm
 {
 fsubp
 faddp
 }
}



void MA1(void)
{
 _asm
 {
 fld    qword ptr [EAX]
 fmul st,st
 }
}


void MA2(void)
{
 _asm
 {
 fld    qword ptr [EAX]
 fsub   qword ptr [EAX+16]
 }
}


void MA3(void)
{
 _asm
 {
 fld    qword ptr [EAX]
 fadd   qword ptr [EAX+16]
 fsub   qword ptr [EAX+32]
 }
}


TFloat  _cdecl sp1(TFloat x1)
{
 return  x1*x1;
}


TFloat  _stdcall sp2(TFloat x1, TFloat x2)
{
 return  x1-x2;
}


TFloat  _pascal sp3(TFloat x1, TFloat x2, TFloat x3)
{
 return  x1+x2-x3;
}


TFloat  _cdecl ps1(TFloat &x1)
{
 return  x1*x1;
}


TFloat  _cdecl ps2(TFloat &x1,TFloat &x2)
{
 return  x1-x2;
}


TFloat  _cdecl ps3(TFloat &x1, TFloat &x2, TFloat &x3)
{
 return  x1+x2-x3;
}



TFloat  _cdecl PS1(TFloat *x1)
{
 return  (*x1)*(*x1);
}


TFloat  _cdecl PS2(TFloat *x1,TFloat *x2)
{
 return  (*x1)-(*x2);
}


TFloat  _cdecl PS3(TFloat *x1, TFloat *x2, TFloat *x3)
{
 return  (*x1)+(*x2)-(*x3);
}




TFloat  _stdcall MS1(Int32 addr)
{
 return  (*PFloat(addr))*(*PFloat(addr));
}



TFloat  _stdcall MS2(Int32 addr)
{
 return  (*PFloat(addr))-(*PFloat(addr+16));
}



TFloat  _stdcall MS3(Int32 addr)
{
 return  (*PFloat(addr))+(*PFloat(addr+16))-(*PFloat(addr+32));
}





Extended _cdecl sp8(TArrayE vx, Int32 nx, Extended x, TArrayD vd, Int32 nd, double d,  TArrayI vi, Int32 ni)
{
//sp8(TArrayE vx, Int32 nx, Extended x, TArrayD vd, Int32 nd, double d,  TArrayI vi, Int32 ni) = (vx[nx]*x-vd[nd]*d)*vi[ni]

//sp8(ve,n,x,vd,k,y,vi,j) = (ve[n]*x - vd[k]*d)*vi[j]

//sp8(ve,n+3,x*t,vd,j+k,x-y,vi,n+k+j)


return (vx[nx]*x-vd[nd]*d)*vi[ni];

}


Extended _cdecl ps8(TArrayE &vx, Int32 &nx, Extended &x, TArrayD &vd, Int32 &nd, double &d,  TArrayI &vi, Int32 &ni)
{
//ps8(TArrayE *vx, Int32 *nx, Extended *x, TArrayD *vd, Int32 *nd, double *d,  TArrayI *vi, Int32 *ni) = (vx[nx]*x-vd[nd]*d)*vi[ni]
																									//((*vx)[*nx]*(*x)-(*vd)[*nd]*(*d))*(*vi)[*ni]
//ps8(ve,n,x,vd,k,y,vi,j) = (ve[n]*x - vd[k]*d)*vi[j]

//ps8(ve,n+3,x*t,vd,j+k,x-y,vi,n+k+j)


return (vx[nx]*x-vd[nd]*d)*vi[ni];


}



Extended _cdecl PS8(TArrayE *vx, Int32 *nx, Extended *x, TArrayD *vd, Int32 *nd, double *d,  TArrayI *vi, Int32 *ni)
{
//ps8(TArrayE *vx, Int32 *nx, Extended *x, TArrayD *vd, Int32 *nd, double *d,  TArrayI *vi, Int32 *ni) = (vx[nx]*x-vd[nd]*d)*vi[ni]
																									//((*vx)[*nx]*(*x)-(*vd)[*nd]*(*d))*(*vi)[*ni]
//ps8(ve,n,x,vd,k,y,vi,j) = (ve[n]*x - vd[k]*d)*vi[j]

//ps8(ve,n+3,x*t,vd,j+k,x-y,vi,n+k+j)


return ((*vx)[*nx]*(*x)-(*vd)[*nd]*(*d))*(*vi)[*ni];


}




Extended _cdecl MS8(Int32 addr)
{
//ms8(vx,nx,x,vd,nd,d,vi,ni) = (vx[nx]*x-vd[nd]*d)*vi[ni]

  //vd: array of double;
  //vx: array of extended;
  //vi: array of integer;
  //d:  double;
  //x:  extended;
  //nd,nx,ni: integer;



  //vx[nx] = (*PArrayE(addr))[(*PInteger(addr+16))]       =  (*PExtended(*PInteger(addr)+(*PInteger(addr+16))*10))
  //x =      (*PExtended(addr+32))
  //vd[nd] = (*PArrayD(addr+48))[(*PInteger(addr+64))]    =  (*PDouble(*PInteger(addr+48)+(*PInteger(addr+64))*8))
  //d =      (*PDouble(addr+80))
  //vi[ni] = (*PArrayI(addr+96))[(*PInteger(addr+112))]   = (*PInteger(*PInteger(addr+96)+(*PInteger(addr+112))*4))



 // return ( (*PArrayE(addr))[(*PInteger(addr+16))]*(*PExtended(addr+32)) - (*PArrayD(addr+48))[(*PInteger(addr+64))]*(*PDouble(addr+80)))*(*PArrayI(addr+96))[(*PInteger(addr+112))];

  //more fast:

  return ( (*PExtended(*PInteger(addr)+(*PInteger(addr+16))*10))*(*PExtended(addr+32)) - (*PDouble(*PInteger(addr+48)+(*PInteger(addr+64))*8))*(*PDouble(addr+80)))*(*PInteger(*PInteger(addr+96)+(*PInteger(addr+112))*4));

}







//infsum(x,y,t,x-y-infsum(x,infsum(x,x*y,-x*y*t),t,x*y),t*x)
//infs(x,y,t,x-y-infs(x,infs(x,x*y,-x*y*t),t,x*y),t*x)
TFloat _cdecl infsum(Int32 addr, Int32 len)
{
 Int32 N,ni;
 TFloat S;

  S=0;
  for (ni = 0; ni <= len-1; ni++)
  {
   S=S+(*PFloat(addr+16*ni));
  }

 return S;
}



TFloat _stdcall fp3d(TFloat x )
{
 return x*x*x;
};

TFloat _stdcall fp3d1(TFloat x )
{
 return 3*x*x;
};


TFloat _stdcall fp3d2(TFloat x )
{
 return 6*x;
};


TFloat _stdcall fp3d3(TFloat x )
{
 return 6;
};

TFloat _stdcall fp3d4(TFloat x )
{
 return 0;
};



TFloat _stdcall idfunc(TFloat x,  Cardinal ID)
{
 if (ID == 1) {return sin(x);} else
   if (ID == 2)  {return cos(x);} ;
};






//FillArray(VD): VD[all]=x
void _cdecl FillArray(Int32 adrVD , double x)
{
 Int32 lenV;
 Int32 adrVD0,tmp;
 Int32 ni,i;
 PInteger pi1;
 Pointer32 pvd0;



//******************* 1 - slow way ******************************

/*
  flGet(fl_ARRAY_LENGTH, (Int32)(&adrVD), lenV);   //adrVD0=@vd[0] ;transfer address of address !!!

	for(ni = 0; ni <= lenV-1; ni++)
	{
	   flSetArrayValueD((Pointer32)(&adrVD), ni, x);
	}
*/

//****************************************************************


//*********************2 - much fast ******************************

/*

  if (adrVD != 0)
	 {
		adrVD0=*PInteger(&adrVD);  //adrVD0=@vd[0] ; address of address !!!

	   //pi1=PInteger(adrVD);
	   //pi1=pi1-1;
	   //lenV=*pi1;


	  lenV=*PInteger((PInteger(adrVD)-1));
	  //lenV=lenV+1;  // <- if Foreval compiled in FPC !!!

	 }
  else
	 {lenV=0;};

  for(ni = 0; ni <= lenV-1; ni++)
	{
	   *PDouble(adrVD0 + ni * 8) = x;  //8-sizeOf(double)
	}
*/

//***************************************************************


//******************3 - most fast *******************************

  _asm
  {
	push eax
	push ecx
	push edx


   mov eax, dword Ptr [adrVD]
   cmp eax, 0
   jz  endp

   mov edx, dword Ptr [eax-4]  // <- Len
   //add edx,1               // <- edx+1 if Foreval compiled in FPC !!!!!!
   fld qword Ptr [x]
   Xor ecx, ecx

   ckl:
   fst qword Ptr [eax+8*ecx]
   inc ecx
   cmp ecx, edx
   jnz ckl

   fstp st(0)

   endp:
   pop  edx
   pop  ecx
   pop  eax

  }

//*************************************************************************

};


void InitIntegral(void)
{
 P_Integral=10;
 N_Integral=15;

 an[1]=0.03075324199611726835; an[2]=0.07036604748810812471;
 an[3]=0.10715922046717193501; an[4]=0.13957067792615431445;
 an[5]=0.16626920581699393355; an[6]=0.18616100001556221103;
 an[7]=0.19843148532711157646; an[8]=0.20257824192556127288;
 an[9]=an[7];  an[10]=an[6];  an[11]=an[5]; an[12]=an[4];
 an[13]=an[3]; an[14]=an[2];  an[15]=an[1];
 bn[1]=0.98799251802048542849; bn[2]=0.93727339240070590431;
 bn[3]=0.84820658341042721620; bn[4]=0.72441773136017004742;
 bn[5]=0.57097217260853884754; bn[6]=0.39415134707756336990;
 bn[7]=0.20119409399743452230; bn[8]=0;
 bn[9]=-bn[7]; bn[10]=-bn[6]; bn[11]=-bn[5]; bn[12]=-bn[4];
 bn[13]=-bn[3];bn[14]=-bn[2]; bn[15]=-bn[1];
};


Extended  Integral3FF(Pointer32 Func, Pointer32 PV1 , Pointer32 PV2, Pointer32 PV3, Extended a, Extended b , Pointer32 Func1, Pointer32 Func2, Pointer32 Func3, Pointer32 Func4)

{
Int32 R, j1, i1, j2, i2, j3, i3, n1, n2, n3;
Extended int1, int2, int3, HV1, HV2, HV3, h1, h2, h3, x1, x2, c, d, e, f, h;
Extended ax1, ax2, ax3, sx1, sx2, sx3;



int3 = 0;


n1 = abs(P_Integral);
if (n1 == 0) {n1 = 1;};
n2 = abs(P_Integral);
if (n2 == 0) {n2 = 1;};
n3 = abs(P_Integral);
if (n3 == 0) {n3 = 1;};
h3 = (b - a) / n3 ;


for(j3 = 0; j3 <= n3-1; j3++)
{
 x1 = a + j3 * h3 ;
 x2 = a + (j3 + 1) * h3 ;
 ax3 = (x1 + x2) * 0.5 ;
 sx3 = (x2 - x1) * 0.5 ;

  for(i3 = 1; i3 <= N_Integral; i3++)
  {
   *PExtended(PV1)= sx3 * bn[i3] + ax3 ;


   int2 = 0;
   d = ResultF(Func2);
   c = ResultF(Func1);
   h2 = (d - c) / n2 ;

   for(j2 = 0; j2 <= n2-1; j2++)
   {
	x1 = c + j2 * h2;
	x2 = c + (j2 + 1) * h2;
	ax2 = (x1 + x2) * 0.5 ;
	sx2 = (x2 - x1) * 0.5 ;

	for(i2 = 1; i2 <= N_Integral; i2++)
	{
	 *PExtended(PV2)= sx2 * bn[i2] + ax2 ;

	 int1 = 0;
	 f = ResultF(Func4);
	 e = ResultF(Func3);
	 h1 = (f - e) / n1  ;

	 for(j1 = 0; j1 <= n1-1; j1++)
	 {
	   x1 = e + j1 * h1 ;
	   x2 = e + (j1 + 1) * h1 ;
	   ax1 = (x1 + x2) * 0.5 ;
	   sx1 = (x2 - x1) * 0.5 ;

	   for(i1 = 1; i1 <= N_Integral; i1++)
	   {
		*PExtended(PV3)= sx1 * bn[i1] + ax1 ;

		int1 = int1 + an[i1] * ResultF(Func) * sx1 ;
	   }

	 }

	 int2 = int2 + an[i2] * int1 * sx2 ;

	}
   }

  int3 = int3 + an[i3] * int2 * sx3;
  }
}


return int3 ;

};




void __fastcall TForm1::FormCreate(TObject *Sender)
{
  TAddFuncStruct Func;
  Int32 flLoad,ic,ID ,IDF,i,Lcs,lv,Len,Sz,Lm,ic1,ECode;
  TArrayI VT;
  TArrayB Code;
  String Sid;
  Extended ax,bx,hx,sx,fx,dx,dy,res;
  double d1,d2;
  PInteger32 P_C;
  Pointer32  FS1;
  TStringType Expr;
  AnsiString ans;
  Int32 FType;






//****************************************************************************


GetLocaleFormatSettings(0,G_FMT);
G_FMT.DecimalSeparator='.';

 flLoad=flInit();
 if (flLoad != 0)
 {

#ifdef    ANSISTRING
  flSet(fl_STRING_TYPE, fl_ANSISTRING,0);
#endif
#ifdef   WIDESTRING
  flSet(fl_STRING_TYPE, fl_WIDESTRING,0);
#endif
#ifdef    STRING
  flSet(fl_STRING_TYPE, fl_STRING_UTF16,0);
#endif
#ifdef    UTF8
  flSet(fl_STRING_TYPE, fl_STRING_UTF8,0);
#endif
#ifdef    PANSICHAR
  flSet(fl_STRING_TYPE, fl_PANSICHAR,0);
#endif


  //flSet(fl_ENABLE, fl_SHOW_EXCEPTION,0);
  //flSet(fl_ENABLE,fl_CHECK_INCORRECT_SPACE,0);
  //flSet(fl_DISABLE,fl_LEAD_TO_LOWER_CASE,0);


 #ifdef   EXTENDED_VAR
   flSet(fl_DATA_TYPE,fl_EXTENDED,0);
   flSet(fl_PARAM_TYPE,fl_EXTENDED,0);
 #else
   flSet(fl_DATA_TYPE,fl_DOUBLE,0);
   flSet(fl_PARAM_TYPE,fl_DOUBLE,0);
 #endif


 #ifdef   EXTENDED_VAR
	FType =   fl_EXTENDED;
 #else
	FType =   fl_DOUBLE;
 #endif

   //flSet(fl_DATA_TYPE,fl_EXTENDED,0);
   //flSet(fl_PARAM_TYPE,fl_EXTENDED,0);

  flSetDiffVar("x");
  A=2.54321;
  B=-3.98765;
  C=4.12345;
  D=-5.6789;

  flSetParam("a",&A,fl_EXTENDED);
  flSetParam("b",&B,fl_EXTENDED);
  flSetParam("c",&C,fl_EXTENDED);
  flSetParam("d",&D,fl_EXTENDED);


  flSetVar("res",&resf,fl_EXTENDED);
  flSetVar("result",&resf,fl_EXTENDED);

  flSetVar("x",&x,FType);
  flSetVar("y",&y,FType);
  flSetVar("t",&t,FType);

  flSetVar("n",&n,fl_INTEGER);
  flSetVar("k",&k,fl_INTEGER);
  flSetVar("j",&j,fl_INTEGER);

  flSetVar("ad",&ad,fl_ARRAY_DOUBLE);
  flSetVar("vd",&vd,fl_ARRAY_DOUBLE);
  flSetVar("ve",&ve,fl_ARRAY_EXTENDED);
  flSetVar("vi",&vi,fl_ARRAY_INTEGER);

  flSetVarIntrnl("xvd",fl_ARRAY_DOUBLE,adrXVD);   flSetLength(adrXVD, fl_ARRAY_DOUBLE, 100);
  flSetVarIntrnl("xve",fl_ARRAY_EXTENDED,adrXVE); flSetLength(adrXVE, fl_ARRAY_EXTENDED, 100);
  flSetVarIntrnl("xvi",fl_ARRAY_INTEGER,adrXVI);  flSetLength(adrXVI, fl_ARRAY_INTEGER, 100);



  n = 1; k = 2; j = 5;

  xe = 2.123; ye = 5.456; te = -3.789;
  xd = 2.123; yd = 5.456; td = -3.789;

  ad.set_length(3);
  ad[0]=3.5; ad[1]=-1.4;  ad[2]=7.6;

 
  x=xe; y=ye; t=te;


  vd.set_length(100);
  ve.set_length(100);
  vi.set_length(100);
  for (ic = 0; ic <= 99; ic++)
  {

   vd[ic]=ic+1;
   ve[ic]=ic+5;

   //vd1[ic]:=ic+2;
   //vd2[ic]:=ic+3;
   //vd3[ic]:=ic+4;

   //ve1[ic]:=ic+2;
   //ve2[ic]:=ic+3;
   //ve3[ic]:=ic+4;


   vd[ic]=pow((double)(-1),(Int32)(ic+1))*vd[ic]*0.5;
   ve[ic]=pow((double)(-1),(Int32)(ic+5))*ve[ic]*0.5;
   vi[ic]=trunc(ve[ic]);

   //vd1[ic]:=power(-1,ic+2)*vd1[ic]*0.7;
   //vd2[ic]:=power(-1,ic+3)*vd2[ic]*0.5;
   //vd3[ic]:=power(-1,ic+4)*vd3[ic]*0.3;

   //ve1[ic]:=power(-1,ic+2)*ve1[ic]*0.7;
   //ve2[ic]:=power(-1,ic+3)*ve2[ic]*0.5;
   //ve3[ic]:=power(-1,ic+4)*ve3[ic]*0.3;

   //vi1[ic]:=Trunc(ve1[ic]);
   //vi2[ic]:=Trunc(ve2[ic]);
   //vi3[ic]:=Trunc(ve3[ic]);

   flSetArrayValueD(adrXVD,ic,vd[ic]);
   flSetArrayValueE(adrXVE,ic,ve[ic]);
   flSetArrayValueI(adrXVI,ic,vi[ic]);
  }



 InitIntegral();


 /************************  Addition external functions: **********************/

/*
func1(arg1)=arg1^2; func2(arg1,arg2)=arg1-arg2; func3(arg1,arg2,arg3)=arg1+arg2-arg3;

ki1                fl_KERNEL_I
kfi2               fl_KERNEL_FI
kf1, kf2           fl_KERNEL_FF
in1, in2           fl_KERNEL_FF+inline
fp1, fp2, fp3      fl_STACK_FPU         fp3: inline
ma1, ma2, ma3      fl_MEMORY_EAX
ms1, ms2, ms3      fl_MEMORY_STACK_CPU
sp1, sp2, sp3      fl_STACK_CPU
ps1, ps2, ps3      fl_MEMORY_ADDRESSES
pc1, pc2, pc3      fl_PreCompiled

all with diff templates besides pc1,pc2,pc3 - will be diff. numeric (for comparison)



fdif(x)-with derivative
spl1,spl2 -through splain


infs(infsum)       fl_INFINITE_STACK_CPU;



idsin,idcos with ID  fl_STACK_CPU;

krsin,krcos,krdiv with diff templates



func8(TArrayE vx, Int32 nx, Extended x, TArrayD vd, Int32 nd, double d,  TArrayI vi, Int32 ni) = (vx[nx]*x-vd[nd]*d)*vi[ni]

 sp8      fl_STACK_CPU
 ps8      fl_MEMORY_ADDRESSES
 ms8      fl_MEMORY_STACK_CPU
 pc8      fl_PreCompiled


********************************************************************************/

  //SPLAIN:

//spl2(x) = x*(sin(x)+cos(x));          -10<=x<=10

//using internal arrays
hx=0.1;      //<=1!!!
ax=-10; bx=10; sx=ax;
lv=trunc(abs(bx-ax)/hx)+1;
xspl.set_length(lv);
yspl.set_length(lv);


for (ic = 0; ic <= xspl.Length-1; ic++)
{
  xspl[ic]=sx;
  yspl[ic]=sx*(sin(sx)+cos(sx));
  sx=sx+hx;
}


flSetSplainFunction("spl2",&xspl,&yspl,fl_ARRAY_EXTENDED,IDF);
//flGetErrorCode(ECode); if (ECode != 0){ShowError();}


//spl1(x) = (sin(3*x)-cos(2*x))*exp(-x/10);    -15<=x<=15

//using external arrays

hx=0.1;      //<=1!!!
ax=-15; bx=15; sx=ax;
lv=trunc(abs(bx-ax)/hx)+1;
flSetVarIntrnl("svdx",fl_ARRAY_DOUBLE,adrVDX);
flSetVarIntrnl("svdy",fl_ARRAY_DOUBLE,adrVDY);
flSetLength(adrVDX,fl_ARRAY_DOUBLE,lv);
flSetLength(adrVDY,fl_ARRAY_DOUBLE,lv);


//flSetArrayValueD(adrVDX,0,sx);
//fx=(sin(3*sx)-cos(2*sx))*exp(-sx/10);
//flSetArrayValueD(adrVDY,0,fx);

for(ic=0;ic <= lv-1; ic++)
{
  flSetArrayValueD(adrVDX,ic,sx);
  fx=(sin(3*sx)-cos(2*sx))*exp(-sx/10);
  flSetArrayValueD(adrVDY,ic,fx);
  sx=sx+hx;
};



flSetSplainFunction("spl1",adrVDX,adrVDY,fl_ARRAY_DOUBLE,IDF);
//flGetErrorCode(ECode); if (ECode != 0){ShowError();}


//kernel:
InitFuncStruct(Func);                      //ki1(i:integer)=i*i;
Func.addr=&KI1;
Func.CallType=fl_KERNEL_I;
Func.DeepFPU=1;
flSetFunction("ki1",&Func,ID);

InitFuncStruct(Func);                     //kf1(x: float)=x^2;
Func.addr=&KF1;
Func.CallType=fl_KERNEL_F;
Func.DeepFPU=0;
flSetFunction("KF1",&Func,ID);

InitFuncStruct(Func);                      //kf2(x,y:float)=x-y
Func.addr=&KF2;
Func.CallType=fl_KERNEL_FF;
Func.DeepFPU=0;
flSetFunction("KF2",&Func,ID);

InitFuncStruct(Func);                     //kfi2(x:float; i:integer)=x-i
Func.addr=&KFI2;
Func.CallType=fl_KERNEL_FI;
Func.DeepFPU=0;
flSetFunction("kfi2",&Func,ID);
//kf1(x-kf2(y,kf1(x-y-kf2(x*y,y-kf1(t*y)))))
//kf1(x)*kf2(x,y)*ki1(n+j)*kfi2(kf1(x)*kf2(x,y)*ki1(n+j),kf1(y)*kf2(t,y)*ki1(n-j))

//kernel+inline
InitFuncStruct(Func);                            //finl(x1,x2) = (x1-x2)*t;
Code.set_length(8);
Code[0]=0xDE; Code[1]=0xE1;                    //fsubrp
Code[2]=0xDC; Code[3]=0x0D;                    //fmul qword ptr
P_C=(PInteger32)&Code[4]; *P_C=(Int32)(&td);   //addr(t)
Func.CallType=fl_KERNEL_FF;
Func.DeepFPU=0;
Func.SizeCode=8;
Func.CodeInline=&Code[0];
flSetFunction("finl",&Func,ID);

InitFuncStruct(Func);                            //IN1(x) = x^2;
Code.set_length(2);
Code[0]=0xD8; Code[1]=0xC8;                     //fmul st(0),st(0)
Func.CallType=fl_KERNEL_F;
Func.DeepFPU=0;
Func.SizeCode=2;
Func.CodeInline=&Code[0];
flSetFunction("in1",&Func,ID);


InitFuncStruct(Func);                            //IN2(x1,x2) = x1-x2;
Code.set_length(2);
Code[0]=0xDE; Code[1]=0xE1;                    //fsubrp
Func.CallType=fl_KERNEL_FF;
Func.DeepFPU=0;
Func.SizeCode=2;
Func.CodeInline=&Code[0];
flSetFunction("in2",&Func,ID);
//in1(x-in2(y,in1(x-y-in2(x*y,y-in1(t*y)))))



//fl_Stack_FPU
InitFuncStruct(Func);                            //fp1(x)=x^2
Func.addr=&FP1;
Func.Arg=1;
Func.ArgType=fl_DOUBLE;
Func.CallType=fl_STACK_FPU;
Func.DeepFPU=0;
flSetFunction("FP1",&Func,ID);
flSetDiffTemplate(ID,"2*$arg1*$dfarg1");

InitFuncStruct(Func);                            //fp2(x,y)=x-y
Func.addr=&FP2;
Func.Arg=2;
Func.ArgType=fl_DOUBLE;
Func.CallType=fl_STACK_FPU;
Func.DeepFPU=0;
flSetFunction("FP2",&Func,ID);
flSetDiffTemplate(ID,"$dfarg1-$dfarg2");

InitFuncStruct(Func);                            //fp3(x1,x2,x3)=x1+x2-x3
//Func.addr=&FP3;
Func.Arg=3;
Func.ArgType=fl_DOUBLE;
Func.CallType=fl_STACK_FPU;
Func.DeepFPU=0;
Func.SizeCode=4;
Code.set_length(Func.SizeCode);
Code[0]=0xDE; Code[1]=0xE9;                    //fsubp
Code[2]=0xDE; Code[3]=0xC1;                    //faddp
Func.CodeInline=&Code[0];
Func.SaveReg=0;
flSetFunction("FP3",&Func,ID);
flSetDiffTemplate(ID,"$dfarg1+$dfarg2-$dfarg3");
//fp1(x-fp2(y,fp1(x-y-fp2(x*y,y-fp1(t*y)))))
//fp3(fp3(x,y,fp1(t))*fp2(t*fp1(x),t),fp2(fp1(y),-fp3(y,fp2(x,t),fp1(x*fp1(t)))),-fp2(fp3(-y,t,x-fp2(t,y)),fp3(t,y*fp1(fp2(t,-y)),-fp2(y,x))))

//fl_Memory_
InitFuncStruct(Func);                         //MA1(x1double)=x1^2
Func.addr=&MA1;
Func.Arg=1;
Func.ArgType=fl_DOUBLE;
Func.CallType=fl_MEMORY_EAX;
Func.DeepFPU=1;
flSetFunction("MA1",&Func,ID);
flSetDiffTemplate(ID,"2*$arg1*$dfarg1");

InitFuncStruct(Func);
Func.addr=&MA2;
Func.Arg=2;
Func.ArgType=fl_DOUBLE;
Func.CallType=fl_MEMORY_EAX;
Func.DeepFPU=1;
flSetFunction("MA2",&Func,ID);               //MA2(x1,x2double)=x1-x2
flSetDiffTemplate(ID,"$dfarg1-$dfarg2");

InitFuncStruct(Func);
Func.addr=&MA3;
Func.Arg=3;
Func.ArgType=fl_DOUBLE;
Func.CallType=fl_MEMORY_EAX;
Func.DeepFPU=1;
flSetFunction("MA3",&Func,ID);               //MA3(x1,x2,x3double)=x1+x2-x3
flSetDiffTemplate(ID,"$dfarg1+$dfarg2-$dfarg3");
//ma3(ma3(x,y,ma1(t))*ma2(t*ma1(x),t),ma2(ma1(y),-ma3(y,ma2(x,t),ma1(x*ma1(t)))),-ma2(ma3(-y,t,x-ma2(t,y)),ma3(t,y*ma1(ma2(t,-y)),-ma2(y,x))))



InitFuncStruct(Func);
Func.addr=&sp1;
Func.Arg=1;
Func.ArgType=FType;
Func.CallType=fl_STACK_CPU;
Func.DeepFPU=1;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
flSetFunction("sp1",&Func,ID);
flSetDiffTemplate(ID,"2*$arg1*$dfarg1");

InitFuncStruct(Func);
Func.addr=&sp2;
Func.Arg=2;
Func.ArgType=FType;
Func.CallType=fl_STACK_CPU;
Func.DeepFPU=1;
Func.ClearStack=fl_DISABLE;     //stdcall
Func.Arrow=fl_RIGHT;            //stdcall
flSetFunction("sp2",&Func,ID);
flSetDiffTemplate(ID,"$dfarg1-$dfarg2");

InitFuncStruct(Func);
Func.addr=&sp3;
Func.Arg=3;
Func.ArgType=FType;
Func.CallType=fl_STACK_CPU;
Func.DeepFPU=1;
Func.ClearStack=fl_DISABLE;   //pascal
Func.Arrow=fl_BACK;           //pascal
flSetFunction("sp3",&Func,ID);
flSetDiffTemplate(ID,"$dfarg1+$dfarg2-$dfarg3");
//sp3(sp3(x,y,sp1(t))*sp2(t*sp1(x),t),sp2(sp1(y),-sp3(y,sp2(x,t),sp1(x*sp1(t)))),-sp2(sp3(-y,t,x-sp2(t,y)),sp3(t,y*sp1(sp2(t,-y)),-sp2(y,x))))
//x*sp3(x*sp3(x,y,x/sp1(t*x))*sp2(x*sp1(x),t),x/sp2(sp1(y),-x/sp3(y,x*sp2(x,t),sp1(x*sp1(t)))),-sp2(-x*sp3(-y,t,x-x/sp2(t,y/x)),x*sp3(t,y*sp1(-x/sp2(t,-y-x/sp1(x*y))),-sp2(y/(x+t),x))))


InitFuncStruct(Func);
Func.addr=&MS1;
Func.Arg=1;
Func.ArgType=FType;
Func.CallType=fl_MEMORY_STACK_CPU;
Func.DeepFPU=1;
Func.ClearStack=fl_DISABLE;
flSetFunction("MS1",&Func,ID);                     //MS1(x1double)=x1^2
flSetDiffTemplate(ID,"2*$arg1*$dfarg1");


InitFuncStruct(Func);
Func.addr=&MS2;
Func.Arg=2;
Func.ArgType=FType;
Func.CallType=fl_MEMORY_STACK_CPU;
Func.DeepFPU=1;
Func.ClearStack=fl_DISABLE;
flSetFunction("MS2",&Func,ID);                   //MS2(x1,x2double)=x1-x2
flSetDiffTemplate(ID,"$dfarg1-$dfarg2");


InitFuncStruct(Func);
Func.addr=&MS3;
Func.Arg=3;
Func.ArgType=FType;
Func.CallType=fl_MEMORY_STACK_CPU;
Func.DeepFPU=1;
Func.ClearStack=fl_DISABLE;
flSetFunction("MS3",&Func,ID);                    //MSP3(x1,x2,x3double)=x1+x2-x3
flSetDiffTemplate(ID,"$dfarg1+$dfarg2-$dfarg3");
//ms3(ms3(x,y,ms1(t))*ms2(t*ms1(x),t),ms2(ms1(y),-ms3(y,ms2(x,t),ms1(x*ms1(t)))),-ms2(ms3(-y,t,x-ms2(t,y)),ms3(t,y*ms1(ms2(t,-y)),-ms2(y,x))))


InitFuncStruct(Func);
Func.addr=&ps1;  //=&PS1
Func.Arg=1;
Func.ArgType=FType;
Func.CallType=fl_MEMORY_ADDRESSES;
Func.DeepFPU=1;
Func.ClearStack=fl_ENABLE;
Func.Arrow=fl_RIGHT;
flSetFunction("ps1",&Func,ID);
flSetDiffTemplate(ID,"2*$arg1*$dfarg1");



InitFuncStruct(Func);
Func.addr=&ps2;    //=&PS2
Func.Arg=2;
Func.ArgType=FType;
Func.CallType=fl_MEMORY_ADDRESSES;
Func.DeepFPU=1;
Func.ClearStack=fl_ENABLE;
Func.Arrow=fl_RIGHT;
flSetFunction("ps2",&Func,ID);
flSetDiffTemplate(ID,"$dfarg1-$dfarg2");


InitFuncStruct(Func);
Func.addr=&ps3;    //=&PS3
Func.Arg=3;
Func.ArgType=FType;
Func.CallType=fl_MEMORY_ADDRESSES;
Func.DeepFPU=1;
Func.ClearStack=fl_ENABLE;
Func.Arrow=fl_RIGHT;
flSetFunction("ps3",&Func,ID);
flSetDiffTemplate(ID,"$dfarg1+$dfarg2-$dfarg3");
//ps3(ps3(x,y,ps1(t))*ps2(t*ps1(x),t),ps2(ps1(y),-ps3(y,ps2(x,t),ps1(x*ps1(t)))),-ps2(ps3(-y,t,x-ps2(t,y)),ps3(t,y*ps1(ps2(t,-y)),-ps2(y,x))))


//func(TArrayE vx, Int32 nx, Extended x, TArrayD vd, Int32 nd, double d,  TArrayI vi, Int32 ni) = (vx[nx]*x-vd[nd]*d)*vi[ni]
InitFuncStruct(Func);
Func.Arg=8;
VT.set_length(Func.Arg);
VT[0]=fl_ARRAY_EXTENDED; VT[1]=fl_INTEGER; VT[2]=fl_EXTENDED; VT[3]=fl_ARRAY_DOUBLE; VT[4]=fl_INTEGER;
VT[5]=fl_DOUBLE; VT[6]=fl_ARRAY_INTEGER; VT[7]=fl_INTEGER;
Func.ArgTypeList=&VT[0];
Func.addr=&sp8;
Func.ArgType=fl_DIFFER;
Func.CallType=fl_STACK_CPU;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
Func.DeepFPU=3;
flSetFunction("sp8",&Func,ID);
//sp8(ve,n+3,x*t,vd,j+k,x-y,vi,n+k+j)


//func(TArrayE *vx, Int32 *nx, Extended *x, TArrayD *vd, Int32 *nd, double *d,  TArrayI *vi, Int32 *ni) = (vx[nx]*x-vd[nd]*d)*vi[ni]
InitFuncStruct(Func);
Func.Arg=8;
VT.set_length(Func.Arg);
VT[0]=fl_ARRAY_EXTENDED; VT[1]=fl_INTEGER; VT[2]=fl_EXTENDED; VT[3]=fl_ARRAY_DOUBLE; VT[4]=fl_INTEGER;
VT[5]=fl_DOUBLE; VT[6]=fl_ARRAY_INTEGER; VT[7]=fl_INTEGER;
Func.ArgTypeList=&VT[0];
Func.addr=&ps8;
Func.ArgType=fl_DIFFER;
Func.CallType=fl_MEMORY_ADDRESSES;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
Func.DeepFPU=3;
flSetFunction("ps8",&Func,ID);
//ps8(ve,n+3,x*t,vd,j+k,x-y,vi,n+k+j)


//func(TArrayE vx, Int32 nx, Extended x, TArrayD vd, Int32 nd, double d,  TArrayI vi, Int32 ni) = (vx[nx]*x-vd[nd]*d)*vi[ni]
//func(adr) = (vx[nx]*x-vd[nd]*d)*vi[ni]
InitFuncStruct(Func);
Func.Arg=8;
VT.set_length(Func.Arg);
VT[0]=fl_ARRAY_EXTENDED; VT[1]=fl_INTEGER; VT[2]=fl_EXTENDED; VT[3]=fl_ARRAY_DOUBLE; VT[4]=fl_INTEGER;
VT[5]=fl_DOUBLE; VT[6]=fl_ARRAY_INTEGER; VT[7]=fl_INTEGER;
Func.ArgTypeList=&VT[0];
Func.addr=&MS8;
Func.ArgType=fl_DIFFER;
Func.CallType=fl_MEMORY_STACK_CPU;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
Func.DeepFPU=3;
flSetFunction("ms8",&Func,ID);
//ms8(ve,n+3,x*t,vd,j+k,x-y,vi,n+k+j)


InitFuncStruct(Func);
Func.addr=&infsum;
Func.ArgType=FType;
Func.ClearStack=fl_ENABLE;
Func.Arrow=fl_RIGHT;
Func.CallType=fl_INFINITE_STACK_CPU;
Func.DeepFPU=2;
flSetFunction("infsum",&Func,IDF);
flAddNameFunction(IDF,"infs") ;
//infsum(x,y,t,x-y-infsum(x,infsum(x,x*y,-x*y*t),t,x*y),t*x)
//infs(x,y,t,x-y-infs(x,infs(x,x*y,-x*y*t),t,x*y),t*x)


InitFuncStruct(Func);           //fdif(x*fdif(x/fdif(x/y)))/fdif(y/x)
Func.addr=&fp3d;
Func.Arg=1;
Func.ArgType=FType;
Func.CallType=fl_STACK_CPU;
Func.DeepFPU=2;
Func.ClearStack=fl_DISABLE;
Func.Arrow=fl_RIGHT;
Func.NDeriv=4;
VT.set_length(Func.NDeriv);
VT[0]=Cardinal(&fp3d1);
VT[1]=Cardinal(&fp3d2);
VT[2]=Cardinal(&fp3d3);
VT[3]=Cardinal(&fp3d4);
Func.AdrDeriv=&VT[0];
flSetFunction("fdif",&Func,ID);



InitFuncStruct(Func);                   //idsin(x)^2+idcos(x)^2
Func.addr=&idfunc;
Func.Arg=1;
Func.ArgType=FType;
Func.CallType=fl_STACK_CPU;
Func.DeepFPU=0;
Func.ClearStack=fl_DISABLE;
Func.Set_ID=fl_ENABLE;
Func.Id_Func=1;
flSetFunction("idsin",&Func,ID);
Func.Id_Func=2;
flSetFunction("idcos",&Func,ID);


//FillArray(TArrayD vd, Double x) = vd[all]=x
InitFuncStruct(Func);
Func.Arg=2;
VT.set_length(Func.Arg);
VT[0]=fl_ARRAY_DOUBLE;  VT[1]=fl_DOUBLE;
Func.ArgTypeList=&VT[0];
Func.addr=&FillArray;
Func.ArgType=fl_DIFFER;
Func.CallType=fl_STACK_CPU;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
Func.DeepFPU=2;
Func.RetNum=fl_NO;
flSetFunction("FillArray",&Func,ID);


//krsin(x) = sin(x);
InitFuncStruct(Func);
Code.set_length(2);
Code[0]=0xD9; Code[1]=0xFE;     //fsin
Func.CallType=fl_KERNEL_F;
Func.DeepFPU=0;
Func.SizeCode=2;
Func.CodeInline=&Code[0];
flSetFunction("krsin",&Func,ID);
flSetDiffTemplate(ID,"krcos($arg1)*$dfarg1");

//krcos(x) = cos(x);
InitFuncStruct(Func);
Code.set_length(2);
Code[0]=0xD9; Code[1]=0xFF;     //fcos
Func.CallType=fl_KERNEL_F;
Func.DeepFPU=0;
Func.SizeCode=2;
Func.CodeInline=&Code[0];
flSetFunction("krcos",&Func,ID);
flSetDiffTemplate(ID,"-krsin($arg1)*$dfarg1");


 //krdiv(x,y) = x/y;
InitFuncStruct(Func);
Code.set_length(2);
Code[0]=0xDE; Code[1]=0xF1;    //fdivrp
Func.CallType=fl_KERNEL_FF;
Func.DeepFPU=0;
Func.SizeCode=2;
Func.CodeInline=&Code[0];
flSetFunction("krdiv",&Func,ID);
//flSetDiffTemplate(ID,"($dfarg1*$arg2-$arg1*$dfarg2)/sqr($arg2)");
flSetDiffTemplate(ID,"krdiv(($dfarg1*$arg2-$arg1*$dfarg2),sqr($arg2))");
/*
 sin(x/y)/cos(y/x)
 krdiv(sin(krdiv(x,y)),cos(krdiv(y,x)))
 krdiv(krsin(krdiv(x,y)),krcos(krdiv(y,x)))
*/



  flSet(fl_ENABLE,fl_USE_VIRTUAL_ALLOC,0); /// <- with this, more performance for fl_Precompiled functions


  #ifdef   EXTENDED_VAR
	flSetFunction("pc1(x:ext):real=x^2",0,IDF);              flSetDiffTemplate(IDF,"2*$arg1*$dfarg1");
	flSetFunction("pc2(x,y:ext):real=x-y",0,IDF);            flSetDiffTemplate(IDF,"$dfarg1-$dfarg2");
	flSetFunction("pc3(x1,x2,x3:ext):real=x1+x2-x3",0,IDF);  flSetDiffTemplate(IDF,"$dfarg1+$dfarg2-$dfarg3");
  #else
	flSetFunction("pc1(x:dbl):real=x^2",0,IDF);              flSetDiffTemplate(IDF,"2*$arg1*$dfarg1");
	flSetFunction("pc2(x,y:dbl):real=x-y",0,IDF);            flSetDiffTemplate(IDF,"$dfarg1-$dfarg2");
	flSetFunction("pc3(x1,x2,x3:dbl):real=x1+x2-x3",0,IDF);  flSetDiffTemplate(IDF,"$dfarg1+$dfarg2-$dfarg3");
  #endif

  flSetFunction("pc8(vx: arrayExt; nx:int; x: ext; vd: arrayDbl; nd: int; d: dbl; vi: arrayInt; ni: int)=(vx[nx]*x - vd[nd]*d)*vi[ni]",0,IDF);

  flSet(fl_DISABLE,fl_USE_VIRTUAL_ALLOC,0);


  flSetFunction("pcsin(x:ext) = sin(x)", 0, IDF);
  flSetDiffTemplate(0, "diff(pcsin) = pccos($arg1)*$dfarg1");

  flSetFunction("pccos(x:ext) = cos(x)", 0, IDF);
  flSetDiffTemplate(0, "diff(pccos) = -pcsin($arg1)*$dfarg1");

  flSetFunction("pcln(x:ext) = ln(x)", 0, IDF);
  flSetDiffTemplate(0, "diff(pcln) = $dfarg1/$arg1");

  flSetFunction("pcpow(x1,x2:ext) = x1^x2", 0, IDF);
  flSetDiffTemplate(0, "diff(pcpow) = pcpow($arg1,$arg2)*(($arg2)*($dfarg1)/($arg1)+($dfarg2)*pcln($arg1))");

  flSetFunction("pcipow(x:ext; n:int)=x^n", 0, IDF);
  flSetDiffTemplate(0, "diff(pcipow) = pcipow($arg1,$arg2-1)*$arg2*$dfarg1");

   //  pcipow(pcpow(pcsin(x/(x+y)),pccos(y/(x+y))),n+2)
   //  (sin(x/(x+y))^cos(y/(x+y)))^(n+2)





//***************  several expressions: ****************************************

/*
fs3(x,y,z)=x*(y+z)+y*(x+z); fs2(x,y)=x+y; fs1(x)=1-x
sum(x=1..5, dx=0.5; y=1..10; dy=0.2; fs3(f1(x-y),fs2(x+1,y-1),x+y));
*/

flPerform(fl_SAVE, fl_VAR_LIST);//push global var.


 fnc1.Expr= "1-x";
 fnc2.Expr= "x+y";
 fnc3.Expr= "x*(y+z)+y*(x+z)";

flSetVar("x", &fnc1.x, fl_EXTENDED);
flCompile(fnc1.Expr, 0, fnc1.Addr);

flSetVar("x", &fnc2.x, fl_EXTENDED);
flSetVar("y", &fnc2.y, fl_EXTENDED);
flCompile(fnc2.Expr, 0, fnc2.Addr);

flSetVar("x", &fnc3.x, fl_EXTENDED);
flSetVar("y", &fnc3.y, fl_EXTENDED);
flSetVar("z", &fnc3.z, fl_EXTENDED);
flCompile(fnc3.Expr, 0, fnc3.Addr);

flPerform(fl_RESTORE, fl_VAR_LIST);  // pop global var.
//flSet(fl_FPU_CW_DEFAULT,0x1332,0);
//flSet(fl_FPU_CW_DEFAULT,0,0)

	x = 1.0;
	y = 1.0;
	dx = 0.5;
	dy = 0.2;
	res = 0.0;

while (x <= 5)
{
	y = 1.0;
	while (y <= 10.000000000000001)    //inexplicable error in compare with 10.0
	{
		fnc1.x = x - y;

		fnc2.x = x + 1;
		fnc2.y = y - 1;

		fnc3.x =  ResultF(fnc1.Addr);
		fnc3.y =  ResultF(fnc2.Addr);
		fnc3.z = x + y;

		res = res +  ResultF(fnc3.Addr);

		y = y + dy;
	};

	x = x + dx;
};

//ShowMessage(FloatToStr(res));

//************   Triple integral   **************************************************************************

// int3(F(x,y,z)=x*y+2*y*z-z*x, x = -1..2; y = -2*x...x^2+1; z = x-y...x+y
// in wolframalpha representation: Integrate[x*y+2*y*z-z*x, {x,-1,2}, {y,-2*x,x^2+1}, {z, x-y, x+y}]

  flPerform(fl_SAVE, fl_VAR_LIST);

  flSetVar("x", &FInt3.x, fl_EXTENDED);
  flSetVar("y", &FInt3.y, fl_EXTENDED) ;
  flSetVar("z", &FInt3.z, fl_EXTENDED)  ;
  flCompile("x*y+2*y*z-z*x", 0, FInt3.FAddr);
  flCompile("-2*x", 0, FInt3.F1Addr) ;
  flCompile("x^2+1", 0, FInt3.F2Addr) ;
  flCompile("x-y", 0, FInt3.F3Addr);
  flCompile("x+y", 0, FInt3.F4Addr) ;
  FInt3.a = -1;
  FInt3.b = 2 ;

  flPerform(fl_RESTORE, fl_VAR_LIST) ;

  res = Integral3FF(FInt3.FAddr, &FInt3.x, &FInt3.y, &FInt3.z, FInt3.a, FInt3.b, FInt3.F1Addr, FInt3.F2Addr, FInt3.F3Addr, FInt3.F4Addr);
  //ShowMessage(FloatToStr(res));


//*************************** mixed derivatives******************************
//d5/dy3dx2
flSetDiffVar("y");
flSetDiffExpr("cos(x^2)*sin(y*x)");
flDiffExpr(3);    //d3/dy3
flSetDiffVar("x");
flDiffExpr(2);    //d2/dx2
flCompileDiffExpr(FS1);
x = 2.123; y = 5.456; t = -3.789;
flResultE(FS1,res);
//ShowMessage(FloatToStr(res));

//******************************************************************************





flGet(fl_VERSION,fl_MAJOR,ID);    Sid=IntToStr(ID);
flGet(fl_VERSION,fl_MINOR,ID);    Sid=Sid+'.'+IntToStr(ID);
flGet(fl_VERSION,fl_RELEASE,ID);  Sid=Sid+'.'+IntToStr(ID);
flGet(fl_VERSION,fl_BUILD,ID);    Sid=Sid+'.'+IntToStr(ID);



Form1->Caption="Test Foreval.dll  (v."+Sid+")";
flGet(fl_COMPILED_BY,0,ID);


if (ID >= 100) {Form1->Caption=Form1->Caption+".  Compiled by FPC v." + IntToStr(ID);}
else
{
 switch  (ID)
 {

  case 7: Form1->Caption=Form1->Caption+".   Compiled by Delphi7"; break;
  case 8: Form1->Caption=Form1->Caption+".   Compiled by Delphi8";   break;
  case 9: Form1->Caption=Form1->Caption+".   Compiled by Delphi2005"; break;
  case 10: Form1->Caption=Form1->Caption+".  Compiled by Delphi2006"; break;
  case 11: Form1->Caption=Form1->Caption+".  Compiled by Delphi2007";  break;
  case 12:  Form1->Caption=Form1->Caption+".   Compiled by Delphi 2009"; break;
  case 13:  Form1->Caption=Form1->Caption+".   Compiled by Delphi 2010"; break;
  case 14:  Form1->Caption=Form1->Caption+".   Compiled by Delphi XE"; break;
  case 15:  Form1->Caption=Form1->Caption+".   Compiled by Delphi XE2";  break;
  case 16:  Form1->Caption=Form1->Caption+".   Compiled by Delphi XE3";  break;
  case 17:  Form1->Caption=Form1->Caption+".   Compiled by Delphi XE4";  break;
  case 18:  Form1->Caption=Form1->Caption+".   Compiled by Delphi XE5"; break;
  case 19:  Form1->Caption=Form1->Caption+".   Compiled by Delphi XE6";  break;
  case 20:   Form1->Caption=Form1->Caption+".   Compiled by Delphi XE7";  break;
  }
}

}
}

//---------------------------------------------------------------------------





 void SetVarValue(void)
{
  xd=StrToFloat(Form1->E_x->Text,G_FMT);
  xe=StrToFloat(Form1->E_x->Text,G_FMT);
  yd=StrToFloat(Form1->E_y->Text,G_FMT);
  ye=StrToFloat(Form1->E_y->Text,G_FMT);
  td=StrToFloat(Form1->E_t->Text,G_FMT);
  te=StrToFloat(Form1->E_t->Text,G_FMT);


  n=StrToInt(Form1->E_n->Text);
  k=StrToInt(Form1->E_k->Text);
  j=StrToInt(Form1->E_j->Text);

  ad[0]=StrToFloat(Form1->E_ad0->Text,G_FMT);
  ad[1]=StrToFloat(Form1->E_ad1->Text,G_FMT);
  ad[2]=StrToFloat(Form1->E_ad2->Text,G_FMT);


  x=xe; y=ye; t=te;
}


Extended __fastcall TForm1::StableTest(void)
{
  const int size = 300;
  int ic,ic1;
  int NExpr,nf,nfd, NExprF, NExprD;
  //Pointer32 cf[size],df[size];
  TArrayP cf,df;
  TStringType Expr,Expr1,Expr2,Expr3,Expr4,Expr5,Expr6;
  Pointer32 FuncF,FuncDF;
  Extended  Resf, Resdf, Rf, Rdf, RFunc, RFuncDF, MR, r1, r2;
  Pointer32 FuncF1,FuncF2,FuncF3,FuncF4,FuncF5,FuncF6;
  Pointer32 FuncDF1,FuncDF2,FuncDF3,FuncDF4,FuncDF5,FuncDF6;
  Extended  ResF, ResDF, RDFunc, ResFunc, SRes, SResD, ResFuncD;


  /*
  //Expr = "(sin(x/(x+y))*sp1(x/(x+y))-sp2(cos(x/(x+y)),cos(y/(x+y))))/(sp3(sin(y/(x+y)),cos(x/y),sin(y/x))*sp2(sp1(x/y),sp1(y/x))-sp1(cos(y/x)))";
  Expr="(sin(x/(x+y))*sp2(cos(x/y)*sp2(cos(x/(x+y)),sin(y/(x+y))),sin(y/x)*sp1(cos(y/x)-sin(x/y)))-cos(y/(x+y))*sp2(sp1(sin(y/(y-x)))/(x+y),sp1(cos(x/(y-x)))/(x-y)))/(sin(cos(y/(y-x)))*sp2(cos(x/y)^2-sin(y/x)^3,sin(x/(y-x))^2-cos(y/(y-x))^3)-cos(sin(x/(y-x)))*sp1(cos(cos(x/(y-x)))-sin(sin(x/(y-x)))))";

   flCompile(Expr, 0, FuncF);
   flResultE(FuncF,RFunc);

   flSetDiffVar("y");
   flSetDiffExpr(Expr);
   flDiffExpr(1);
   flSetDiffVar("x");
   flDiffExpr(1);
   flCompileDiffExpr(FuncDF);
   flResultE(FuncDF,RFuncDF);

  for(ic = 0; ic < size; ic++)
  {

   flCompile(Expr, 0, cf[ic]);

   flSetDiffVar("y");
   flSetDiffExpr(Expr);
   flDiffExpr(1);
   flSetDiffVar("x");
   flDiffExpr(1);
   flCompileDiffExpr(df[ic]);

  }


   Resf = 0; Resdf = 0;
   for(ic = 0; ic < size; ic++)
   {
	 Resf=Resf+ResultF(cf[ic]);
	 Resdf=Resdf+ResultF(df[ic]);
   }

	for(ic = 0; ic < size; ic++)
   {
	 flPerform(fl_FREE,(Int32)cf[ic]);
	 flPerform(fl_FREE,(Int32)df[ic]);
   }


   MR=Resf/(size*RFunc)+Resdf/(size*RFuncDF);      //=2
  // r1=(Resf/size);
  // MR=r1/RFunc;
  */

  //NExpr=100;
  NExpr = StrToInt(ENC->Text);
  nf=6; nfd=3;
  NExprF=nf*NExpr;
  NExprD=nfd*NExpr;
  //cf.resize(NExprF);
  //df.resize(NExprD);

  cf.set_length(NExprF);
  df.set_length(NExprD);

  // Pointer32 *cf = new Pointer32 [NExprF];

  Expr1="(sin(x/(x+y))*sp3(sp1(sin(x/(x-y)))*sin(y/(x+y)),-sp2(cos(y/(y-x)),sin(y/x))/cos(x/(x+y)),cos(y/(x+y))/sp1(cos(x/y)))+cos(y/x)*sp2(-sp1(cos(sin(y/x)))*cos(y/(x-y)),-sp3(cos(y/(y-x)),-sin(x/(x-y)),-cos(sin(y/(x+y))))))/(sp2(-sin(y/(y-x)),cos(x))*cos(y)-sp2(sin(x),cos(y/x))*sin(y))";
  Expr2="x:dbl=1.123; y:ext=3.456; k:int=-5; t:ext=-2.789; n: int=7; x=x*y+n*t*(n-x)/(y/n-x*n*y); y=(x+n+y)*(x*n+k/t)/(y*n-2);n=x+y;  t=x*y*(x*n+y/k*(y/(t-k/(x+y)+(t/x-y/x)/k)+k*x*n/(x-k*n))+x*y*(k*t-n/x*(t/y-k/x*(k-x/y+k*n*(x*(t-n)+y)/(x*y-t*y*(x*(k+2.75)+t*2.75))))))/(2.76*x+7.93*y*k+2.8*n*k*(2.99*y+t*x*k*n)); k=x/y+k*n/t;  x=sin(x)*cos(y)*(n*cos(x)+k*sin(y)-sin(t)*cos(t)*(n+k)); y=sin(y)*(cos(x)*y-x*sin(y)*cos(y)+sin(t)*cos(t)*t);(k*x+n*y)/t";
  Expr3="MinSize:int=10; MaxSize:int=100; vi:arrayInt=0; vd:arrayDbl=0; Sum:ext=0; n:int=0; k:int=0;  itr:int=10; SumVD:Ext=0; for(k,0,itr, SetLen(vd,rnd(MinSize,MaxSize)); L:int=Len(vd); for(n,0,L-1,vd[n]=n; Sum=Sum+n); SumVD=SumVD+sum(vd)); SumVI:Ext=0; for(k,0,itr, SetLen(vi,rnd(MinSize,MaxSize)); L=Len(vi); for(n,0,L-1,vi[n]=n; Sum=Sum+n); SumVI=SumVI+sum(vi)); SetLen(vi,0); SetLen(vd,0); Sum/(SumVD+SumVI)";
  Expr4="-(-x-y/(-y*x/(y-t/(-1.34-x*2.76)))-t/(-2.43*t*x*y/(-x*1.76+1.87*y+t/2.74+2.93)))*(x*(2.76-t*1.75/(2.76/x-2.65)*x)*2.45/t-y*(-x/2.53-y/(-t/x-2.71/(2.43*x-y*2.71-2.76-t)))/(-t/(-y/(2.34-3.52*t/x)))-t/(1.57/y-x/(-t/x-2.12)))/(x/t*y/2.71*(2.76/x-1.65)/(y-t/x))";
  Expr5="min:int=10; max:int=200; limit:ext=max;res:int=0;ifp((min > max)or(max <=1),res=0;goto(end));ifp(max = 3,ifp(min=3,res=1;goto(end),res=2;goto(end)),ifp(max=2,res=1;goto(end))); is_prime:arrayInt=limit+2;jj:ext=0;i:int=0;k:ext=0;x:int=0;y:int=0;n:ext=0;Lsqrt:ext=[sqrt(limit)];for(i,5,limit,is_prime[i]=0); for(x,1,Lsqrt,for(y,1,Lsqrt,n=4*sqr(x)+sqr(y);ifp((n<=limit)and((mod(n,12) = 1)or(mod(n,12) = 5)),is_prime[n]=1-is_prime[n]);n=n-sqr(x);ifp((n<=limit) and (mod(n,12) = 7),is_prime[n]=1-is_prime[n]);n=n-2*sqr(y);ifp((x>y)and(n<=limit)and(mod(n,12)=11),is_prime[n]=1-is_prime[n])));for(i,5,Lsqrt,ifp(is_prime[i]=1,k=sqr(i);n=k; while(n<=limit,is_prime[n]=0; n=n+k)));is_prime[0]=0;is_prime[0]=0;is_prime[1]=0;is_prime[2]=1;is_prime[3]=1;for(i,min,max,ifp(is_prime[i]=1,inc(res)));end>>res";
  Expr6="(y^(x/(x+y))*(-t/x)^(y/(x+y))-x*(x/vd[n+k]^vi[2*n+3]-y*sin(vd[2*k+3]*x)))*((x/y)^((y/x)^((y/(x+y)))^(x/(x+y)))*((y/x)^(y/x)+(x/(x+y))^(y/(x+y))))*((sin(x/y)+x)^cos(y/x)+(cos(x/y)+y)^(sin(x/(x+y))+cos(y/(x+y))))";

   flCompile(Expr1, 0, FuncF1);
   flCompile(Expr2, 0, FuncF2);
   flCompile(Expr3, 0, FuncF3);
   flCompile(Expr4, 0, FuncF4);
   flCompile(Expr5, 0, FuncF5);
   flCompile(Expr6, 0, FuncF6);

   flSetDiffVar("x");
   flSetDiffExpr(Expr1);
   flDiffExpr(1);
   flSetDiffVar("y");
   flDiffExpr(1);
   flCompileDiffExpr(FuncDF1);

   flSetDiffVar("x");
   flSetDiffExpr(Expr4);
   flDiffExpr(1);
   flSetDiffVar("y");
   flDiffExpr(1);
   flCompileDiffExpr(FuncDF4);

   flSetDiffVar("x");
   flSetDiffExpr(Expr6);
   flDiffExpr(1);
   flSetDiffVar("y");
   flDiffExpr(1);
   flCompileDiffExpr(FuncDF6);

   ic=0;
   while (ic < NExpr*nf)
   {
     flCompile(Expr1, 0, cf[ic]);
     flCompile(Expr2, 0, cf[ic+1]);
     flCompile(Expr3, 0, cf[ic+2]);
     flCompile(Expr4, 0, cf[ic+3]);
     flCompile(Expr5, 0, cf[ic+4]);
     flCompile(Expr6, 0, cf[ic+5]);
     ic=ic+6;
   };

   ic=0;
   while (ic < NExpr*nfd)
   {
    flSetDiffVar("x");
    flSetDiffExpr(Expr1);
    flDiffExpr(1);
    flSetDiffVar("y");
    flDiffExpr(1);
    flCompileDiffExpr(df[ic]);

    flSetDiffVar("x");
    flSetDiffExpr(Expr4);
    flDiffExpr(1);
    flSetDiffVar("y");
    flDiffExpr(1);
    flCompileDiffExpr(df[ic+1]);

    flSetDiffVar("x");
    flSetDiffExpr(Expr6);
    flDiffExpr(1);
    flSetDiffVar("y");
    flDiffExpr(1);
    flCompileDiffExpr(df[ic+2]);
    ic=ic+3;
  };

   ResF=1;
   flResultE(FuncF1,RFunc);
   ResF=ResF*RFunc;
   flResultE(FuncF2,RFunc);
   ResF=ResF*RFunc;
   flResultE(FuncF3,RFunc);
   ResF=ResF*RFunc;
   flResultE(FuncF4,RFunc);
   ResF=ResF*RFunc;
   flResultE(FuncF5,RFunc);
   ResF=ResF*RFunc;
   flResultE(FuncF6,RFunc);
   ResF=ResF*RFunc;

   ResDF=1;
   flResultE(FuncDF1,RDFunc);
   ResDF=ResDF*RDFunc;
   flResultE(FuncDF4,RDFunc);
   ResDF=ResDF*RDFunc;
   flResultE(FuncDF6,RDFunc);
   ResDF=ResDF*RDFunc;


   SRes=0;
   ic=0;
   while (ic < NExpr*nf)
   {
      ResFunc=1;

		  RFunc=ResultF(cf[ic]);
      ResFunc=ResFunc*RFunc;

		  RFunc=ResultF(cf[ic+1]);
      ResFunc=ResFunc*RFunc;

		  RFunc=ResultF(cf[ic+2]);
      ResFunc=ResFunc*RFunc;

		  RFunc=ResultF(cf[ic+3]);
      ResFunc=ResFunc*RFunc;

		  RFunc=ResultF(cf[ic+4]);
      ResFunc=ResFunc*RFunc;

		  RFunc=ResultF(cf[ic+5]);
      ResFunc=ResFunc*RFunc;

      SRes=SRes+ResFunc;

       for (ic1 = 0; ic1 < 100; ic1++)
	   {
         RFunc=ResultF(cf[ic]);
         RFunc=ResultF(cf[ic+1]);
         RFunc=ResultF(cf[ic+2]);
         RFunc=ResultF(cf[ic+3]);
         RFunc=ResultF(cf[ic+4]);
         RFunc=ResultF(cf[ic+5]);
	   };
      ic=ic+6;
   };


   SResD=0;
   ic=0;
   while (ic < NExpr*nfd)
   {
      ResFuncD=1;

		  RFunc=ResultF(df[ic]);
      ResFuncD=ResFuncD*RFunc;

		  RFunc=ResultF(df[ic+1]);
      ResFuncD=ResFuncD*RFunc;

		  RFunc=ResultF(df[ic+2]);
      ResFuncD=ResFuncD*RFunc;

      SResD=SResD+ResFuncD;

        for  (ic1 = 0; ic1 < 100; ic1++)
		{
         RFunc=ResultF(df[ic]);
         RFunc=ResultF(df[ic+1]);
         RFunc=ResultF(df[ic+2]);
		};

      ic=ic+3;
   };


   Rf=(SRes/NExpr)/ResF+(SResD/NExpr)/ResDF;  //=2
   MR=Rf;



   for  (ic1 = 0; ic1 < cf.Length; ic1++)
   {
	  flPerform(fl_FREE, (DWORD)(cf[ic1]));
   };

   for  (ic1 = 0; ic1 < df.Length; ic1++)
   {
	  flPerform(fl_FREE,  (DWORD)(df[ic1]));
   };

   flSet(fl_DISABLE,fl_SHOW_EXCEPTION,0);

  return MR;

}


void __fastcall TForm1::Button1Click(TObject *Sender)
{

   //Int32 *Func1;
   Pointer32 Func1;
   //Int32 FuncAddr ;

   Extended res;

   TStringType Expr,ErStr;
   Int32 ECode,ct,rt;
   String SRez,S1r,S2r,S1,S2;
   Int32  ni,NC,T1,T2;
   AnsiString ans;


//*****************************************************************************

   SetVarValue();

   #ifdef StableTEST
	  T1=GetTickCount();
	 LR->Caption=FloatToStrF(StableTest(),ffGeneral,20,4,G_FMT);
	  T2=GetTickCount();
	  LPf->Caption="ms:"+IntToStr(T2-T1);
	  goto endp;
   #endif;

   //NC = 10000000;
   NC = StrToInt(ENC->Text);
   res = 0;


   Func1 = NULL;




  #ifdef PANSICHAR
	ans=(AnsiString)(EF->Text);
	Expr = ans.c_str();
  #else
	Expr = EF->Text;
  #endif;

  flCompile(Expr, 0, Func1);

  if (CB_OM->Checked) { NC=1;} else {NC=abs(trunc(StrToFloat(ENC->Text,G_FMT)));};

  flGetErrorCode(ECode);


  if (ECode != 0)
  {
	  ShowError();
  }
  else
  {
   flGet(fl_RETURN_NUMBER,Int32(Func1),rt);

   if (rt == fl_NO)            //no return number: return result in inner 'result' or 'res' variable  ( x1: ext=x+y; x1=x1*x; result=x1  )
   {
	  T1=GetTickCount();

	  for(ni = 0; ni <= NC; ni++)
	  {
		//flResult(Func1);
		//Result(Func1);
		 _asm
		 {
		  call Func1
		 };
	  };
	 T2=GetTickCount();

	 res=resf;

   }
   else
   {

	   T1=GetTickCount();
	   for(ni = 0; ni <= NC; ni++)
	   {

//		  res = x*y*t*(t*x*(x*y-t*x)-x*y*(x*t-y*t)+y*x*(y*x-t*y)-(x+y)*(x-y)*(t-y)*(x*y-t*x*(x-y*(t-x*(t-x)*(x-t)*(t-y)-x*y-y))))-(x*t*y*(x*y-x*(y-y*(t-t*(x-x*t*(x*y-t*x-(x*y-t*x)*(x-y)*(y-t)*(t-y)-(x+t*y)*(y-x*t)+(t-y*t)*(y-t*x))))))) ;
//		  res = -x/(x/y-t/(x+t)+x*y*(x*y-y*t+x/(x/(x+y)+y/(t+x))))*(y*(x-y/(x*y-y/(x*y+y*t)*(y*t-x*y)))+x-y*(x-t-t/(x-y)*(y/(y-t*(x+y*t)*(y-x*t)/(x*t-y*(x+t))))))*(x*y-t*y-t*(x*t-y*(t-x)/(x*y*t-x-y-t)));
//		  res = x*y*(2.111*x+1)*(2.211*x*y/t-2.311*x*(3.422*t-1)/(2.511*x-3.611*y-4.22)*(x/(3.711*x-1)-4.111/x+5.111*(2.611*x*y*t-1.23)/(y+1.12)-7.132*(2.812*x*(y+1.123)*(3.832*y+2.121)*(3.112/(x+1.123)-2.133*t))));
//		  res = x*y*(x-t*(2.123*x-3.222*y-5.323)/(t*x*y/(2.234-x*y)+(2.455*x+3.632)*(3.734*y-4.832*t-5.923)-(1.134-x)/(-t-y))+x*(y-(-x-(-y/(-t*x*(x*y*t*(2.745*x-3.345*y-t))-y*(x*y-y*t*3.167+2.965*(x/t-t/(x-y*(2.467-x-y-t)))*(y-t)-2.376*x)*(y-x)-7.154/x)*(-1.943/t+x*y*t*5.334))-3.556*x-5.657)-7.243*y-3.459)/(x-t)+x*(t*y/(x-2.834*t)-y*(x*(t-2.756*y-x-5.676))));
//		  res = (x*y+t*(x*y-y*t*x-x+y-t))*(x+y+t)*(x-y-t)*(t-x*(t-y*(x-y-t)))*x*y*t-x*t*(x*t-y*t+x-t)*(y*x+t*x+t*y-y-x)*(x*t-y*(x-y*t-t-x)*(x-y-t)-y*(y+y*x-t-x)+t*(x*y-x*(t+y*(x*y-t*y*x-y*t*(y+x*(x-t+y*(x-y+t-x*(x*y-t*x)*(x*y-t*(x+y+t)*(x-y-t)-t*(-x-y*(-t*(-x*(y-t))))))))))));
//		  res = x*y-x/(x/y-t/y-(-x-y*(x*y-t*x/(x/y-t/y-(-x-(-y-(-t-(x*y-y*(-x*y-y/(x+y*t)))*x)*y)/(x+y*t)-x*(y/t-(-y*x/(x-y*t)-(-x-(-y/(-x*y*(-x-y))+x/y*(y*x+y*t-x/(x+y*t))-x*y*(x*y+(-x*y-t/y+x-y*x)))))+x*y*t*(x+y*t)))))));
//crash at extended var:
//		  res = x*y*(x-t*(2.154*x-3.253*y-5.353)/(t*x*y/(2.544-x*y)+(2.143*x+3.556)*(3.343*y-4.153*t-5.456)-(1.153-x)/(-t-y))+x*(y-(-x-(-y/(-t*x*(x*y*t*(2.644*x-3.364*y-t))-y*(x*y-y*t*3.164+2.267*(x/t-t/(x-y*(2.533-x-y-t)))*(y-t)-2.453*x)*(y-x)-7.535/x)*(-1.253/t+x*y*t*5.353))-3.433*x-5.455)-7.466*y-3.577)/(x-t)+x*(t*y/(x-2.699*t)-y*(x*(t-2.767*y-x-5.854)-y*(-1.549-x/(-t-y))/(x/y-x/(t/x-y/t)+t*(1/x-5.344/y-x*y*(2.435*x-1.456)*(t*y*3.326-5.347)*(1.943-x*y*t*3.245)*(x+y))))));
//crash at all var:
//		  res = (x*y+t*(x*y-y*t*x-x+y-t))*(x+y+t)*(x-y-t)*(t-x*(t-y*(x-y-t)))*x*y*t-x*t*(x*t-y*t+x-t)*(y*x+t*x+t*y-y-x)*(x*t-y*(x-y*t-t-x)*(x-y-t)-y*(y+y*x-t-x)+t*(x*y-x*(t+y*(x*y-t*y*x-y*t*(y+x*(x-t+y*(x-y+t-x*(x*y-t*x)*(x*y-t*(x+y+t)*(x-y-t*(x-y*(t-x*y-y*(x*y-t*x)-t*(t*x+y))))-t*(-x-y*(-t*(-x*(y-t*(x*y*t-y*x*t*(-x*(y*x-t*y-x-y-t)))))))))))))));
//		  res = (x*y+t/(x*y-y*t/x-x+y-t))*(x+y+t)/(x-y-t)*(t-x*(t-y/(x-y-t)))*x/y*t-x*t*(x*t-y*t+x-t)/(y*x+t*x+t/y-y-x)*(x*t-y*(x-y*t-t-x)*(x-y-t)-y*(y+y*x-t-x)+t*(x*y-x*(t+y/(x*y-t*y*x-y*t*(y+x*(x-t+y*(x-y+t-x*(x*y-t*x)*(x*y-t*(x+y+t)*(x-y-t/(x-y*(t-x*y-y/(x*y-t*x)-t/(t/x+y))))-t*(-x-y*(-t/(-x*(y-t*(x*y/t-y*x*t/(-x*(y*x-t*y-x-y-t)))))))))))))));
//		  res = x*y*(x-t*(2.156*x-3.652*y-5.653)/(t*x*y/(2.664-x*y)+(2.155*x+3.543)*(3.345*y-4.431*t-5.443)-(1.451-x)/(-t-y))+x*(y-(-x-(-y/(-t*x*(x*y*t*(2.453*x-3.353*y-t))-y*(x*y-y*t*3.153+2.253*(x/t-t/(x-y*(2.533-x-y-t)))*(y-t)-2.453*x)*(y-x)-7.553/x)*(-1.253/t+x*y*t*5.533))-3.453*x-5.453)-7.453*y-3.553)/(x-t)+x*(t*y/(x-2.653*t)-y*(x*(t-2.753*y-x-5.853)-y*(-1.539-x/(-t-y))/(x/y-x/(t/x-y/t)+t*(1/x-5.553/y-x*y*(2.535*x-1.53)*(t*y*3.536-5.753)*(1.539-x*y*t*3.665)*(x+y*(t-(-x-y*t/(x*y-2.863*(x*y*(x-y*(x*t+y/t*(2.623*x-1.352-t*y))))))))))))) ;
//		  res = x*y*(2.251*x+1)*(2.243*x*y/t-2.353*x*(3.475*t-1)/(2.575*x-3.675*y-4.766)*(x/(3.767*x-1)-4.176/x+5.186*(2.866*x*y*t-1.766)/(y+1.876)-7.165*(2.874*x*(y+1.641)*(3.864*y+2.162)*(3.171/(x+1.765)-2.173*t/(2.174*x*y*t-1.171)+(4.171*x-1.164)*(5.172*y-7.174)/(x-2.175*y-1.747-2.174*t/(3.618-7.716*x-8.181*y*(4.612*x/(2.189*t+1.165)-7.198*x-8.149/t+9.912*(2.199*x-1.261)*(3.107*x+4.179*y+5.108)*(2.271*x*y*t-7.179)*x*y*t/(x-y*2.282-3.621/(x/(t-1.147)-7.198/(y+2.245)+8.233/(2.288*x*y*t+1.247)-9.174)))))/(x-1.525)))));




		  //res=sp8(ve,n+3,x/sp8(ve,n+7,x-t,vd,j+3,-y+sp8(ve,k+3,-t,vd,j+3*k,x-sp8(ve,j+3,t,vd,j+n,t+x,vi,n+2*j),vi,k+j),vi,n+2*k),vd,j+k,x*sp8(ve,n+7,t/sp8(ve,j+6,x-t,vd,j+n-1,x-y,vi,n+3*k+j),vd,j+9,x+sp8(ve,n,t,vd,k,y,vi,j),vi,j+5),vi,n+k+j)/sp8(ve,k+3,t,vd,n+3,x,vi,k+2*j);
			  //ms8(ve,n+3,x/ms8(ve,n+7,x-t,vd,j+3,-y+ms8(ve,k+3,-t,vd,j+3*k,x-ms8(ve,j+3,t,vd,j+n,t+x,vi,n+2*j),vi,k+j),vi,n+2*k),vd,j+k,x*ms8(ve,n+7,t/ms8(ve,j+6,x-t,vd,j+n-1,x-y,vi,n+3*k+j),vd,j+9,x+ms8(ve,n,t,vd,k,y,vi,j),vi,j+5),vi,n+k+j)/ms8(ve,k+3,t,vd,n+3,x,vi,k+2*j);
			  //pc8(ve,n+3,x/pc8(ve,n+7,x-t,vd,j+3,-y+pc8(ve,k+3,-t,vd,j+3*k,x-pc8(ve,j+3,t,vd,j+n,t+x,vi,n+2*j),vi,k+j),vi,n+2*k),vd,j+k,x*pc8(ve,n+7,t/pc8(ve,j+6,x-t,vd,j+n-1,x-y,vi,n+3*k+j),vd,j+9,x+pc8(ve,n,t,vd,k,y,vi,j),vi,j+5),vi,n+k+j)/pc8(ve,k+3,t,vd,n+3,x,vi,k+2*j);
			  //ps8(ve,n+3,x/ps8(ve,n+7,x-t,vd,j+3,-y+ps8(ve,k+3,-t,vd,j+3*k,x-ps8(ve,j+3,t,vd,j+n,t+x,vi,n+2*j),vi,k+j),vi,n+2*k),vd,j+k,x*ps8(ve,n+7,t/ps8(ve,j+6,x-t,vd,j+n-1,x-y,vi,n+3*k+j),vd,j+9,x+ps8(ve,n,t,vd,k,y,vi,j),vi,j+5),vi,n+k+j)/ps8(ve,k+3,t,vd,n+3,x,vi,k+2*j);

		  //res=sp8(ve,j,t,vd,k,y,vi,j);

		  //res=sp1(-x)/(-(-(-1-sp2(-1-x,sp1(x))))-sp1(-sp1(-x)-1)*(2-sp2(-x,-1)*3))/(-sp1(sp1(-x)*2-3)*3-5)/(sp1(-x-1)*3-5)+(-(-sp1(-1-x))*(-(-(-sp1(-x)*2+5)))*(-sp1(x+1)))+sp1(2*sp1(-x-1)-1)-sp1(-1-x)/((sp1(2*sp1(-x-1)-1)*3-5)+(-(-(-sp1(-1+2*sp1(-x-1)))))-(-sp1(-2*sp1(-x-1)+1)-5)*(sp1(1-2*sp1(-x-1))))+(-sp1(2*sp1(-x-1)-1)-5)*(-2*sp1(1-2*sp1(-x-1))-3)/(sp1(-1+2*sp1(-x-1))*3-sp1(2*sp1(-x-1)-1)*5)/sp1(2*sp1(-x-1)-1)-(-sp1(2*sp1(-x-1)-1)/sp1(x+1))+sp2(-x,x)+2*sp2(x,-x)/(-sp2(-x-1,x+1)-5*sp2(x+1,-x-1)*sp1(sp2(x+1,-x-1)))*(sp1(sp2(x+1,-x-1))-sp1(sp2(1-2*sp1(-x-1),-1-x)))-sp2(x+1,2*sp1(-x)-1)/(-(-3*sp2(1-2*sp1(-x-1),-1-x)))*((-2*sp2(sp1(x+1)*2-1,-1-2*sp1(x+1))-(-5*sp2(-sp1(x+1)*2-1,1-sp1(-x-1)*2))))+(-sp2(-x,x)+(7-3*sp2(x,-x)-5)/(-sp2(-x-1,x+1))/sp2(x+1,-x-1))/(-9/sp2(1-2*sp1(-x-1),-1-x)-sp1(-7*sp2(x+1,2*sp1(-x)-1))-3)+(-sp1(-sp2(sp1(x+1)*2-1,-1-2*sp1(x+1))-7)+(3*sp2(-sp1(x+1)*2-1,1-sp1(-x-1)*2)-5));

		  //res=sp3(x*sp2(sp1(y-x),sp2(x-sp2(t*x,x-y),sp2(t*x,y+t))),sp1(t-y)+sp2(sp3(sp2(x*t,y*x),t,sp2(t-x,y-x)),sp3(sp3(x-y,y*x,y*t),x*sp2(x-y,y-t),t*sp1(x+y))),sp3(sp1(t+x),sp2(x-y,y*t),sp1(x+y+t)));
			 // ps3(x*ps2(ps1(y-x),ps2(x-ps2(t*x,x-y),ps2(t*x,y+t))),ps1(t-y)+ps2(ps3(ps2(x*t,y*x),t,ps2(t-x,y-x)),ps3(ps3(x-y,y*x,y*t),x*ps2(x-y,y-t),t*ps1(x+y))),ps3(ps1(t+x),ps2(x-y,y*t),ps1(x+y+t)));
			 // ms3(x*ms2(ms1(y-x),ms2(x-ms2(t*x,x-y),ms2(t*x,y+t))),ms1(t-y)+ms2(ms3(ms2(x*t,y*x),t,ms2(t-x,y-x)),ms3(ms3(x-y,y*x,y*t),x*ms2(x-y,y-t),t*ms1(x+y))),ms3(ms1(t+x),ms2(x-y,y*t),ms1(x+y+t)));
			 // pc3(x*pc2(pc1(y-x),pc2(x-pc2(t*x,x-y),pc2(t*x,y+t))),pc1(t-y)+pc2(pc3(pc2(x*t,y*x),t,pc2(t-x,y-x)),pc3(pc3(x-y,y*x,y*t),x*pc2(x-y,y-t),t*pc1(x+y))),pc3(pc1(t+x),pc2(x-y,y*t),pc1(x+y+t)));

//  		  res = 2.15*pow(x,12)-4.541*pow(x,11)-3.65*pow(x,10)+6.75*pow(x,9)+2.2*pow(x,8)-2.84*pow(x,7)+5.2*pow(x,6)-3.9*pow(x,5)+4.765*pow(x,4)+2.63*pow(x,3)+2.8*pow(x,2)+2.11*x+12.754;
//            res = (pow(x-1.5,2*n-3*k+1)*0.05-15.1*pow(t*x,n-2*k)-21.1*pow(y*t,k-3*n-7))/(2.1*pow(x+y,2*k+1)-y*pow(x-t,n+5))*(3.2*pow(x-y,n+k)-x*pow(t+x*y,n+k+2)) ;
//            res = sin(cos(x+y))*cos(y*sin(x-y))*(2.15*cos(sin(3.53*cos(t-x)))-tan(x+y)*(tan(t+x)-cos(sin(t+y))*((1.76*asin(x/(x+y))+2.97*acos(y/(x+y)))*(2.12*atan(x-y)*atan2(x-y,x+y)-asin(t/(x+y))*acos(t/(y+x-t))/(atan(x+y)+atan2(t-x-y,x-t))))));

//            res=sin(x/y)*(sin(y/(x+y))+cos(x/(x+y))+cos(y/x))+cos(x/y)*(sin(y/x)+cos(y/(x+y))+sin(x/(x+y)));
//			  res=(sin(x/(x+y))-sinh(y/(x+y)))*(cosh(y/(x+y))+cos(x/(x+y)));
//            res=exp(x/(x+y))*(sinh(x/(x+y))+cosh(x/(x+y))+tanh(x/(x+y)));
//		      res=(vd[n+1]*x-ve[k+n]*y)*(vd[n+k+3]*(x-y)+ve[2*n+3*k+4]*t);

		  /*
		  sp8(ve,j,t,vd,k,y,vi,j)
		  ps8(ve,j,t,vd,k,y,vi,j)
		  ms8(ve,j,t,vd,k,y,vi,j)
		  pc8(ve,j,t,vd,k,y,vi,j)
		  */

		 //flResultE(Func1,res);
		 //res=ResultF(Func1);


		 _asm
		 {
		  call Func1
		  fstp tbyte ptr res
		 };


	   }

		T2=GetTickCount();



  }


  S1=FloatToStrF(res,ffGeneral,20,4,G_FMT);


  LR->Caption=S1;

  if ((T2-T1) != 0)
	   { LPf->Caption=IntToStr((Int32)(NC/(T2-T1))); }
	   else { LPf->Caption="no defined" ; };



  flPerform(fl_FREE,(Int32)Func1);

 }

endp:
}

//  sp8(ve,n+3,x/sp8(ve,n+7,x-t,vd,j+3,-y+sp8(ve,k+3,-t,vd,j+3*k,x-sp8(ve,j+3,t,vd,j+n,t+x,vi,n+2*j),vi,k+j),vi,n+2*k),vd,j+k,x*sp8(ve,n+7,t/sp8(ve,j+6,x-t,vd,j+n-1,x-y,vi,n+3*k+j),vd,j+9,x+sp8(ve,n,t,vd,k,y,vi,j),vi,j+5),vi,n+k+j)/sp8(ve,k+3,t,vd,n+3,x,vi,k+2*j)
//  ps8(ve,n+3,x/ps8(ve,n+7,x-t,vd,j+3,-y+ps8(ve,k+3,-t,vd,j+3*k,x-ps8(ve,j+3,t,vd,j+n,t+x,vi,n+2*j),vi,k+j),vi,n+2*k),vd,j+k,x*ps8(ve,n+7,t/ps8(ve,j+6,x-t,vd,j+n-1,x-y,vi,n+3*k+j),vd,j+9,x+ps8(ve,n,t,vd,k,y,vi,j),vi,j+5),vi,n+k+j)/ps8(ve,k+3,t,vd,n+3,x,vi,k+2*j);
//  ms8(ve,n+3,x/ms8(ve,n+7,x-t,vd,j+3,-y+ms8(ve,k+3,-t,vd,j+3*k,x-ms8(ve,j+3,t,vd,j+n,t+x,vi,n+2*j),vi,k+j),vi,n+2*k),vd,j+k,x*ms8(ve,n+7,t/ms8(ve,j+6,x-t,vd,j+n-1,x-y,vi,n+3*k+j),vd,j+9,x+ms8(ve,n,t,vd,k,y,vi,j),vi,j+5),vi,n+k+j)/ms8(ve,k+3,t,vd,n+3,x,vi,k+2*j);
//  pc8(ve,n+3,x/pc8(ve,n+7,x-t,vd,j+3,-y+pc8(ve,k+3,-t,vd,j+3*k,x-pc8(ve,j+3,t,vd,j+n,t+x,vi,n+2*j),vi,k+j),vi,n+2*k),vd,j+k,x*pc8(ve,n+7,t/pc8(ve,j+6,x-t,vd,j+n-1,x-y,vi,n+3*k+j),vd,j+9,x+pc8(ve,n,t,vd,k,y,vi,j),vi,j+5),vi,n+k+j)/pc8(ve,k+3,t,vd,n+3,x,vi,k+2*j);

//kf1(x)*kf2(x,y)-(-kf1(-kf2(-kf2(2*kf1(-x),3*kf1(-y)+1),2*kf1(-y))))-(kf2(5*kf1(8*kf1(y)-3),7-kf2(kf1(x)/kf1(y),2*kf1(-x)*kf1(y)))*2-1)*(kf2(4*kf1(-y)-5,4-kf1(-x))*3-4-7*kf1(x)/kf1(y))
//in1(x)*in2(x,y)-(-in1(-in2(-in2(2*in1(-x),3*in1(-y)+1),2*in1(-y))))-(in2(5*in1(8*in1(y)-3),7-in2(in1(x)/in1(y),2*in1(-x)*in1(y)))*2-1)*(in2(4*in1(-y)-5,4-in1(-x))*3-4-7*in1(x)/in1(y))
//fp1(x)*fp2(x,y)-(-fp1(-fp2(-fp2(2*fp1(-x),3*fp1(-y)+1),2*fp1(-y))))-(fp2(5*fp1(8*fp1(y)-3),7-fp2(fp1(x)/fp1(y),2*fp1(-x)*fp1(y)))*2-1)*(fp2(4*fp1(-y)-5,4-fp1(-x))*3-4-7*fp1(x)/fp1(y))
//ma1(x)*ma2(x,y)-(-ma1(-ma2(-ma2(2*ma1(-x),3*ma1(-y)+1),2*ma1(-y))))-(ma2(5*ma1(8*ma1(y)-3),7-ma2(ma1(x)/ma1(y),2*ma1(-x)*ma1(y)))*2-1)*(ma2(4*ma1(-y)-5,4-ma1(-x))*3-4-7*ma1(x)/ma1(y))
//pc1(x)*pc2(x,y)-(-pc1(-pc2(-pc2(2*pc1(-x),3*pc1(-y)+1),2*pc1(-y))))-(pc2(5*pc1(8*pc1(y)-3),7-pc2(pc1(x)/pc1(y),2*pc1(-x)*pc1(y)))*2-1)*(pc2(4*pc1(-y)-5,4-pc1(-x))*3-4-7*pc1(x)/pc1(y))


//in1(2*in1(-x-1)-1)-in1(-1-x)/((in1(2*in1(-x-1)-1)*3-5)+(-(-(-in1(-1+2*in1(-x-1)))))-(-in1(-2*in1(-x-1)+1)-5)*(in1(1-2*in1(-x-1))))+(-in1(2*in1(-x-1)-1)-5)*(-2*in1(1-2*in1(-x-1))-3)/(in1(-1+2*in1(-x-1))*3-in1(2*in1(-x-1)-1)*5)/in1(2*in1(-x-1)-1)-(-in1(2*in1(-x-1)-1)/in1(x+1))
//in1(-x)/(-(-(-1-in2(-1-x,in1(x))))-in1(-in1(-x)-1)*(2-in2(-x,-1)*3))/(-in1(in1(-x)*2-3)*3-5)/(in1(-x-1)*3-5)+(-(-in1(-1-x))*(-(-(-in1(-x)*2+5)))*(-in1(x+1)))
//in2(-x,x)+2*in2(x,-x)/(-in2(-x-1,x+1)-5*in2(x+1,-x-1)*in1(in2(x+1,-x-1)))*(in1(in2(x+1,-x-1))-in1(in2(1-2*in1(-x-1),-1-x)))-in2(x+1,2*in1(-x)-1)/(-(-3*in2(1-2*in1(-x-1),-1-x)))*((-2*in2(in1(x+1)*2-1,-1-2*in1(x+1))-(-5*in2(-in1(x+1)*2-1,1-in1(-x-1)*2))))
//in2(-x,x)+2*in2(x,-x)/(-in2(-x-1,x+1)-5*in2(x+1,-x-1)*in1(in2(x+1,-x-1)))*(in1(in2(x+1,-x-1))-in1(in2(1-2*in1(-x-1),-1-x)))-in2(x+1,2*in1(-x)-1)/(-(-3*in2(1-2*in1(-x-1),-1-x)))*((-2*in2(in1(x+1)*2-1,-1-2*in1(x+1))-(-5*in2(-in1(x+1)*2-1,1-in1(-x-1)*2))))+(-in2(-x,x)+(7-3*in2(x,-x)-5)/(-in2(-x-1,x+1))/in2(x+1,-x-1))/(-9/in2(1-2*in1(-x-1),-1-x)-in1(-7*in2(x+1,2*in1(-x)-1))-3)+(-in1(-in2(in1(x+1)*2-1,-1-2*in1(x+1))-7)+(3*in2(-in1(x+1)*2-1,1-in1(-x-1)*2)-5))

//in1(2*in1(-x-1)-1)-in1(-1-x)/((in1(2*in1(-x-1)-1)*3-5)+(-(-(-in1(-1+2*in1(-x-1)))))-(-in1(-2*in1(-x-1)+1)-5)*(in1(1-2*in1(-x-1))))+(-in1(2*in1(-x-1)-1)-5)*(-2*in1(1-2*in1(-x-1))-3)/(in1(-1+2*in1(-x-1))*3-in1(2*in1(-x-1)-1)*5)/in1(2*in1(-x-1)-1)-(-in1(2*in1(-x-1)-1)/in1(x+1))+in2(-x,x)+2*in2(x,-x)/(-in2(-x-1,x+1)-5*in2(x+1,-x-1)*in1(in2(x+1,-x-1)))*(in1(in2(x+1,-x-1))-in1(in2(1-2*in1(-x-1),-1-x)))-in2(x+1,2*in1(-x)-1)/(-(-3*in2(1-2*in1(-x-1),-1-x)))*((-2*in2(in1(x+1)*2-1,-1-2*in1(x+1))-(-5*in2(-in1(x+1)*2-1,1-in1(-x-1)*2))))+(-in2(-x,x)+(7-3*in2(x,-x)-5)/(-in2(-x-1,x+1))/in2(x+1,-x-1))/(-9/in2(1-2*in1(-x-1),-1-x)-in1(-7*in2(x+1,2*in1(-x)-1))-3)+(-in1(-in2(in1(x+1)*2-1,-1-2*in1(x+1))-7)+(3*in2(-in1(x+1)*2-1,1-in1(-x-1)*2)-5))
//sp1(2*sp1(-x-1)-1)-sp1(-1-x)/((sp1(2*sp1(-x-1)-1)*3-5)+(-(-(-sp1(-1+2*sp1(-x-1)))))-(-sp1(-2*sp1(-x-1)+1)-5)*(sp1(1-2*sp1(-x-1))))+(-sp1(2*sp1(-x-1)-1)-5)*(-2*sp1(1-2*sp1(-x-1))-3)/(sp1(-1+2*sp1(-x-1))*3-sp1(2*sp1(-x-1)-1)*5)/sp1(2*sp1(-x-1)-1)-(-sp1(2*sp1(-x-1)-1)/sp1(x+1))+sp2(-x,x)+2*sp2(x,-x)/(-sp2(-x-1,x+1)-5*sp2(x+1,-x-1)*sp1(sp2(x+1,-x-1)))*(sp1(sp2(x+1,-x-1))-sp1(sp2(1-2*sp1(-x-1),-1-x)))-sp2(x+1,2*sp1(-x)-1)/(-(-3*sp2(1-2*sp1(-x-1),-1-x)))*((-2*sp2(sp1(x+1)*2-1,-1-2*sp1(x+1))-(-5*sp2(-sp1(x+1)*2-1,1-sp1(-x-1)*2))))+(-sp2(-x,x)+(7-3*sp2(x,-x)-5)/(-sp2(-x-1,x+1))/sp2(x+1,-x-1))/(-9/sp2(1-2*sp1(-x-1),-1-x)-sp1(-7*sp2(x+1,2*sp1(-x)-1))-3)+(-sp1(-sp2(sp1(x+1)*2-1,-1-2*sp1(x+1))-7)+(3*sp2(-sp1(x+1)*2-1,1-sp1(-x-1)*2)-5))

//in1(-x)/(-(-(-1-in2(-1-x,in1(x))))-in1(-in1(-x)-1)*(2-in2(-x,-1)*3))/(-in1(in1(-x)*2-3)*3-5)/(in1(-x-1)*3-5)+(-(-in1(-1-x))*(-(-(-in1(-x)*2+5)))*(-in1(x+1)))+in1(2*in1(-x-1)-1)-in1(-1-x)/((in1(2*in1(-x-1)-1)*3-5)+(-(-(-in1(-1+2*in1(-x-1)))))-(-in1(-2*in1(-x-1)+1)-5)*(in1(1-2*in1(-x-1))))+(-in1(2*in1(-x-1)-1)-5)*(-2*in1(1-2*in1(-x-1))-3)/(in1(-1+2*in1(-x-1))*3-in1(2*in1(-x-1)-1)*5)/in1(2*in1(-x-1)-1)-(-in1(2*in1(-x-1)-1)/in1(x+1))+in2(-x,x)+2*in2(x,-x)/(-in2(-x-1,x+1)-5*in2(x+1,-x-1)*in1(in2(x+1,-x-1)))*(in1(in2(x+1,-x-1))-in1(in2(1-2*in1(-x-1),-1-x)))-in2(x+1,2*in1(-x)-1)/(-(-3*in2(1-2*in1(-x-1),-1-x)))*((-2*in2(in1(x+1)*2-1,-1-2*in1(x+1))-(-5*in2(-in1(x+1)*2-1,1-in1(-x-1)*2))))+(-in2(-x,x)+(7-3*in2(x,-x)-5)/(-in2(-x-1,x+1))/in2(x+1,-x-1))/(-9/in2(1-2*in1(-x-1),-1-x)-in1(-7*in2(x+1,2*in1(-x)-1))-3)+(-in1(-in2(in1(x+1)*2-1,-1-2*in1(x+1))-7)+(3*in2(-in1(x+1)*2-1,1-in1(-x-1)*2)-5))
//kf1(-x)/(-(-(-1-kf2(-1-x,kf1(x))))-kf1(-kf1(-x)-1)*(2-kf2(-x,-1)*3))/(-kf1(kf1(-x)*2-3)*3-5)/(kf1(-x-1)*3-5)+(-(-kf1(-1-x))*(-(-(-kf1(-x)*2+5)))*(-kf1(x+1)))+kf1(2*kf1(-x-1)-1)-kf1(-1-x)/((kf1(2*kf1(-x-1)-1)*3-5)+(-(-(-kf1(-1+2*kf1(-x-1)))))-(-kf1(-2*kf1(-x-1)+1)-5)*(kf1(1-2*kf1(-x-1))))+(-kf1(2*kf1(-x-1)-1)-5)*(-2*kf1(1-2*kf1(-x-1))-3)/(kf1(-1+2*kf1(-x-1))*3-kf1(2*kf1(-x-1)-1)*5)/kf1(2*kf1(-x-1)-1)-(-kf1(2*kf1(-x-1)-1)/kf1(x+1))+kf2(-x,x)+2*kf2(x,-x)/(-kf2(-x-1,x+1)-5*kf2(x+1,-x-1)*kf1(kf2(x+1,-x-1)))*(kf1(kf2(x+1,-x-1))-kf1(kf2(1-2*kf1(-x-1),-1-x)))-kf2(x+1,2*kf1(-x)-1)/(-(-3*kf2(1-2*kf1(-x-1),-1-x)))*((-2*kf2(kf1(x+1)*2-1,-1-2*kf1(x+1))-(-5*kf2(-kf1(x+1)*2-1,1-kf1(-x-1)*2))))+(-kf2(-x,x)+(7-3*kf2(x,-x)-5)/(-kf2(-x-1,x+1))/kf2(x+1,-x-1))/(-9/kf2(1-2*kf1(-x-1),-1-x)-kf1(-7*kf2(x+1,2*kf1(-x)-1))-3)+(-kf1(-kf2(kf1(x+1)*2-1,-1-2*kf1(x+1))-7)+(3*kf2(-kf1(x+1)*2-1,1-kf1(-x-1)*2)-5))
//fp1(-x)/(-(-(-1-fp2(-1-x,fp1(x))))-fp1(-fp1(-x)-1)*(2-fp2(-x,-1)*3))/(-fp1(fp1(-x)*2-3)*3-5)/(fp1(-x-1)*3-5)+(-(-fp1(-1-x))*(-(-(-fp1(-x)*2+5)))*(-fp1(x+1)))+fp1(2*fp1(-x-1)-1)-fp1(-1-x)/((fp1(2*fp1(-x-1)-1)*3-5)+(-(-(-fp1(-1+2*fp1(-x-1)))))-(-fp1(-2*fp1(-x-1)+1)-5)*(fp1(1-2*fp1(-x-1))))+(-fp1(2*fp1(-x-1)-1)-5)*(-2*fp1(1-2*fp1(-x-1))-3)/(fp1(-1+2*fp1(-x-1))*3-fp1(2*fp1(-x-1)-1)*5)/fp1(2*fp1(-x-1)-1)-(-fp1(2*fp1(-x-1)-1)/fp1(x+1))+fp2(-x,x)+2*fp2(x,-x)/(-fp2(-x-1,x+1)-5*fp2(x+1,-x-1)*fp1(fp2(x+1,-x-1)))*(fp1(fp2(x+1,-x-1))-fp1(fp2(1-2*fp1(-x-1),-1-x)))-fp2(x+1,2*fp1(-x)-1)/(-(-3*fp2(1-2*fp1(-x-1),-1-x)))*((-2*fp2(fp1(x+1)*2-1,-1-2*fp1(x+1))-(-5*fp2(-fp1(x+1)*2-1,1-fp1(-x-1)*2))))+(-fp2(-x,x)+(7-3*fp2(x,-x)-5)/(-fp2(-x-1,x+1))/fp2(x+1,-x-1))/(-9/fp2(1-2*fp1(-x-1),-1-x)-fp1(-7*fp2(x+1,2*fp1(-x)-1))-3)+(-fp1(-fp2(fp1(x+1)*2-1,-1-2*fp1(x+1))-7)+(3*fp2(-fp1(x+1)*2-1,1-fp1(-x-1)*2)-5))
//ma1(-x)/(-(-(-1-ma2(-1-x,ma1(x))))-ma1(-ma1(-x)-1)*(2-ma2(-x,-1)*3))/(-ma1(ma1(-x)*2-3)*3-5)/(ma1(-x-1)*3-5)+(-(-ma1(-1-x))*(-(-(-ma1(-x)*2+5)))*(-ma1(x+1)))+ma1(2*ma1(-x-1)-1)-ma1(-1-x)/((ma1(2*ma1(-x-1)-1)*3-5)+(-(-(-ma1(-1+2*ma1(-x-1)))))-(-ma1(-2*ma1(-x-1)+1)-5)*(ma1(1-2*ma1(-x-1))))+(-ma1(2*ma1(-x-1)-1)-5)*(-2*ma1(1-2*ma1(-x-1))-3)/(ma1(-1+2*ma1(-x-1))*3-ma1(2*ma1(-x-1)-1)*5)/ma1(2*ma1(-x-1)-1)-(-ma1(2*ma1(-x-1)-1)/ma1(x+1))+ma2(-x,x)+2*ma2(x,-x)/(-ma2(-x-1,x+1)-5*ma2(x+1,-x-1)*ma1(ma2(x+1,-x-1)))*(ma1(ma2(x+1,-x-1))-ma1(ma2(1-2*ma1(-x-1),-1-x)))-ma2(x+1,2*ma1(-x)-1)/(-(-3*ma2(1-2*ma1(-x-1),-1-x)))*((-2*ma2(ma1(x+1)*2-1,-1-2*ma1(x+1))-(-5*ma2(-ma1(x+1)*2-1,1-ma1(-x-1)*2))))+(-ma2(-x,x)+(7-3*ma2(x,-x)-5)/(-ma2(-x-1,x+1))/ma2(x+1,-x-1))/(-9/ma2(1-2*ma1(-x-1),-1-x)-ma1(-7*ma2(x+1,2*ma1(-x)-1))-3)+(-ma1(-ma2(ma1(x+1)*2-1,-1-2*ma1(x+1))-7)+(3*ma2(-ma1(x+1)*2-1,1-ma1(-x-1)*2)-5))
//ms1(-x)/(-(-(-1-ms2(-1-x,ms1(x))))-ms1(-ms1(-x)-1)*(2-ms2(-x,-1)*3))/(-ms1(ms1(-x)*2-3)*3-5)/(ms1(-x-1)*3-5)+(-(-ms1(-1-x))*(-(-(-ms1(-x)*2+5)))*(-ms1(x+1)))+ms1(2*ms1(-x-1)-1)-ms1(-1-x)/((ms1(2*ms1(-x-1)-1)*3-5)+(-(-(-ms1(-1+2*ms1(-x-1)))))-(-ms1(-2*ms1(-x-1)+1)-5)*(ms1(1-2*ms1(-x-1))))+(-ms1(2*ms1(-x-1)-1)-5)*(-2*ms1(1-2*ms1(-x-1))-3)/(ms1(-1+2*ms1(-x-1))*3-ms1(2*ms1(-x-1)-1)*5)/ms1(2*ms1(-x-1)-1)-(-ms1(2*ms1(-x-1)-1)/ms1(x+1))+ms2(-x,x)+2*ms2(x,-x)/(-ms2(-x-1,x+1)-5*ms2(x+1,-x-1)*ms1(ms2(x+1,-x-1)))*(ms1(ms2(x+1,-x-1))-ms1(ms2(1-2*ms1(-x-1),-1-x)))-ms2(x+1,2*ms1(-x)-1)/(-(-3*ms2(1-2*ms1(-x-1),-1-x)))*((-2*ms2(ms1(x+1)*2-1,-1-2*ms1(x+1))-(-5*ms2(-ms1(x+1)*2-1,1-ms1(-x-1)*2))))+(-ms2(-x,x)+(7-3*ms2(x,-x)-5)/(-ms2(-x-1,x+1))/ms2(x+1,-x-1))/(-9/ms2(1-2*ms1(-x-1),-1-x)-ms1(-7*ms2(x+1,2*ms1(-x)-1))-3)+(-ms1(-ms2(ms1(x+1)*2-1,-1-2*ms1(x+1))-7)+(3*ms2(-ms1(x+1)*2-1,1-ms1(-x-1)*2)-5))
//pc1(-x)/(-(-(-1-pc2(-1-x,pc1(x))))-pc1(-pc1(-x)-1)*(2-pc2(-x,-1)*3))/(-pc1(pc1(-x)*2-3)*3-5)/(pc1(-x-1)*3-5)+(-(-pc1(-1-x))*(-(-(-pc1(-x)*2+5)))*(-pc1(x+1)))+pc1(2*pc1(-x-1)-1)-pc1(-1-x)/((pc1(2*pc1(-x-1)-1)*3-5)+(-(-(-pc1(-1+2*pc1(-x-1)))))-(-pc1(-2*pc1(-x-1)+1)-5)*(pc1(1-2*pc1(-x-1))))+(-pc1(2*pc1(-x-1)-1)-5)*(-2*pc1(1-2*pc1(-x-1))-3)/(pc1(-1+2*pc1(-x-1))*3-pc1(2*pc1(-x-1)-1)*5)/pc1(2*pc1(-x-1)-1)-(-pc1(2*pc1(-x-1)-1)/pc1(x+1))+pc2(-x,x)+2*pc2(x,-x)/(-pc2(-x-1,x+1)-5*pc2(x+1,-x-1)*pc1(pc2(x+1,-x-1)))*(pc1(pc2(x+1,-x-1))-pc1(pc2(1-2*pc1(-x-1),-1-x)))-pc2(x+1,2*pc1(-x)-1)/(-(-3*pc2(1-2*pc1(-x-1),-1-x)))*((-2*pc2(pc1(x+1)*2-1,-1-2*pc1(x+1))-(-5*pc2(-pc1(x+1)*2-1,1-pc1(-x-1)*2))))+(-pc2(-x,x)+(7-3*pc2(x,-x)-5)/(-pc2(-x-1,x+1))/pc2(x+1,-x-1))/(-9/pc2(1-2*pc1(-x-1),-1-x)-pc1(-7*pc2(x+1,2*pc1(-x)-1))-3)+(-pc1(-pc2(pc1(x+1)*2-1,-1-2*pc1(x+1))-7)+(3*pc2(-pc1(x+1)*2-1,1-pc1(-x-1)*2)-5))
//sp1(-x)/(-(-(-1-sp2(-1-x,sp1(x))))-sp1(-sp1(-x)-1)*(2-sp2(-x,-1)*3))/(-sp1(sp1(-x)*2-3)*3-5)/(sp1(-x-1)*3-5)+(-(-sp1(-1-x))*(-(-(-sp1(-x)*2+5)))*(-sp1(x+1)))+sp1(2*sp1(-x-1)-1)-sp1(-1-x)/((sp1(2*sp1(-x-1)-1)*3-5)+(-(-(-sp1(-1+2*sp1(-x-1)))))-(-sp1(-2*sp1(-x-1)+1)-5)*(sp1(1-2*sp1(-x-1))))+(-sp1(2*sp1(-x-1)-1)-5)*(-2*sp1(1-2*sp1(-x-1))-3)/(sp1(-1+2*sp1(-x-1))*3-sp1(2*sp1(-x-1)-1)*5)/sp1(2*sp1(-x-1)-1)-(-sp1(2*sp1(-x-1)-1)/sp1(x+1))+sp2(-x,x)+2*sp2(x,-x)/(-sp2(-x-1,x+1)-5*sp2(x+1,-x-1)*sp1(sp2(x+1,-x-1)))*(sp1(sp2(x+1,-x-1))-sp1(sp2(1-2*sp1(-x-1),-1-x)))-sp2(x+1,2*sp1(-x)-1)/(-(-3*sp2(1-2*sp1(-x-1),-1-x)))*((-2*sp2(sp1(x+1)*2-1,-1-2*sp1(x+1))-(-5*sp2(-sp1(x+1)*2-1,1-sp1(-x-1)*2))))+(-sp2(-x,x)+(7-3*sp2(x,-x)-5)/(-sp2(-x-1,x+1))/sp2(x+1,-x-1))/(-9/sp2(1-2*sp1(-x-1),-1-x)-sp1(-7*sp2(x+1,2*sp1(-x)-1))-3)+(-sp1(-sp2(sp1(x+1)*2-1,-1-2*sp1(x+1))-7)+(3*sp2(-sp1(x+1)*2-1,1-sp1(-x-1)*2)-5))
//ps1(-x)/(-(-(-1-ps2(-1-x,ps1(x))))-ps1(-ps1(-x)-1)*(2-ps2(-x,-1)*3))/(-ps1(ps1(-x)*2-3)*3-5)/(ps1(-x-1)*3-5)+(-(-ps1(-1-x))*(-(-(-ps1(-x)*2+5)))*(-ps1(x+1)))+ps1(2*ps1(-x-1)-1)-ps1(-1-x)/((ps1(2*ps1(-x-1)-1)*3-5)+(-(-(-ps1(-1+2*ps1(-x-1)))))-(-ps1(-2*ps1(-x-1)+1)-5)*(ps1(1-2*ps1(-x-1))))+(-ps1(2*ps1(-x-1)-1)-5)*(-2*ps1(1-2*ps1(-x-1))-3)/(ps1(-1+2*ps1(-x-1))*3-ps1(2*ps1(-x-1)-1)*5)/ps1(2*ps1(-x-1)-1)-(-ps1(2*ps1(-x-1)-1)/ps1(x+1))+ps2(-x,x)+2*ps2(x,-x)/(-ps2(-x-1,x+1)-5*ps2(x+1,-x-1)*ps1(ps2(x+1,-x-1)))*(ps1(ps2(x+1,-x-1))-ps1(ps2(1-2*ps1(-x-1),-1-x)))-ps2(x+1,2*ps1(-x)-1)/(-(-3*ps2(1-2*ps1(-x-1),-1-x)))*((-2*ps2(ps1(x+1)*2-1,-1-2*ps1(x+1))-(-5*ps2(-ps1(x+1)*2-1,1-ps1(-x-1)*2))))+(-ps2(-x,x)+(7-3*ps2(x,-x)-5)/(-ps2(-x-1,x+1))/ps2(x+1,-x-1))/(-9/ps2(1-2*ps1(-x-1),-1-x)-ps1(-7*ps2(x+1,2*ps1(-x)-1))-3)+(-ps1(-ps2(ps1(x+1)*2-1,-1-2*ps1(x+1))-7)+(3*ps2(-ps1(x+1)*2-1,1-ps1(-x-1)*2)-5))


//(-sp1(-(-x)/(-t))-(-sp2(-(-sp2(-x,-x-t)-sp2(-sp1(-1.1-x),-(-1.2-sp2(-x-1.3,-y-1.4)*(-1.5)))/sp1(-1.7-x)),-(-1.8-(-x-1.9/(-t-2.1))))))*(-2.2-x*(-2.3-(-y-(-2.4-(-y-x)))/(2.5*x*y*sp2(2.8,-2.9-x)*t/(-2.6-(2.7*x)))))*(sp1(3.1)*sp1(3.2)/sp2(3.3,3.4)-x/(-x*3.5*y*(-3.6)-3.8))+x*(-1.1-y*(2.3*sp2(-1.1,x+y)-sp2(-y,1.1)/2.3)*t)*(-sp2(1.1,x+y)*3.3-sp1(-1.7-x)/(3.5)+sp1(-1.1-x)*(-3.9)-sp2(sp2(1.1,x+y)*7.1,sp2(-y,1.1)/2.5))*((sp2(-sp2(-1.1,x+y)*5.1,-sp2(-1.1,x+y)*3.1-7.9))+sp2(-sp2(-y,1.1)/3.2,-5.7-sp2(-y,1.1)*2.9))
//(-ps1(-(-x)/(-t))-(-ps2(-(-ps2(-x,-x-t)-ps2(-ps1(-1.1-x),-(-1.2-ps2(-x-1.3,-y-1.4)*(-1.5)))/ps1(-1.7-x)),-(-1.8-(-x-1.9/(-t-2.1))))))*(-2.2-x*(-2.3-(-y-(-2.4-(-y-x)))/(2.5*x*y*ps2(2.8,-2.9-x)*t/(-2.6-(2.7*x)))))*(ps1(3.1)*ps1(3.2)/ps2(3.3,3.4)-x/(-x*3.5*y*(-3.6)-3.8))+x*(-1.1-y*(2.3*ps2(-1.1,x+y)-ps2(-y,1.1)/2.3)*t)*(-ps2(1.1,x+y)*3.3-ps1(-1.7-x)/(3.5)+ps1(-1.1-x)*(-3.9)-ps2(ps2(1.1,x+y)*7.1,ps2(-y,1.1)/2.5))*((ps2(-ps2(-1.1,x+y)*5.1,-ps2(-1.1,x+y)*3.1-7.9))+ps2(-ps2(-y,1.1)/3.2,-5.7-ps2(-y,1.1)*2.9))
//(-kf1(-(-x)/(-t))-(-kf2(-(-kf2(-x,-x-t)-kf2(-kf1(-1.1-x),-(-1.2-kf2(-x-1.3,-y-1.4)*(-1.5)))/kf1(-1.7-x)),-(-1.8-(-x-1.9/(-t-2.1))))))*(-2.2-x*(-2.3-(-y-(-2.4-(-y-x)))/(2.5*x*y*kf2(2.8,-2.9-x)*t/(-2.6-(2.7*x)))))*(kf1(3.1)*kf1(3.2)/kf2(3.3,3.4)-x/(-x*3.5*y*(-3.6)-3.8))+x*(-1.1-y*(2.3*kf2(-1.1,x+y)-kf2(-y,1.1)/2.3)*t)*(-kf2(1.1,x+y)*3.3-kf1(-1.7-x)/(3.5)+kf1(-1.1-x)*(-3.9)-kf2(kf2(1.1,x+y)*7.1,kf2(-y,1.1)/2.5))*((kf2(-kf2(-1.1,x+y)*5.1,-kf2(-1.1,x+y)*3.1-7.9))+kf2(-kf2(-y,1.1)/3.2,-5.7-kf2(-y,1.1)*2.9))
//(-in1(-(-x)/(-t))-(-in2(-(-in2(-x,-x-t)-in2(-in1(-1.1-x),-(-1.2-in2(-x-1.3,-y-1.4)*(-1.5)))/in1(-1.7-x)),-(-1.8-(-x-1.9/(-t-2.1))))))*(-2.2-x*(-2.3-(-y-(-2.4-(-y-x)))/(2.5*x*y*in2(2.8,-2.9-x)*t/(-2.6-(2.7*x)))))*(in1(3.1)*in1(3.2)/in2(3.3,3.4)-x/(-x*3.5*y*(-3.6)-3.8))+x*(-1.1-y*(2.3*in2(-1.1,x+y)-in2(-y,1.1)/2.3)*t)*(-in2(1.1,x+y)*3.3-in1(-1.7-x)/(3.5)+in1(-1.1-x)*(-3.9)-in2(in2(1.1,x+y)*7.1,in2(-y,1.1)/2.5))*((in2(-in2(-1.1,x+y)*5.1,-in2(-1.1,x+y)*3.1-7.9))+in2(-in2(-y,1.1)/3.2,-5.7-in2(-y,1.1)*2.9))
//(-fp1(-(-x)/(-t))-(-fp2(-(-fp2(-x,-x-t)-fp2(-fp1(-1.1-x),-(-1.2-fp2(-x-1.3,-y-1.4)*(-1.5)))/fp1(-1.7-x)),-(-1.8-(-x-1.9/(-t-2.1))))))*(-2.2-x*(-2.3-(-y-(-2.4-(-y-x)))/(2.5*x*y*fp2(2.8,-2.9-x)*t/(-2.6-(2.7*x)))))*(fp1(3.1)*fp1(3.2)/fp2(3.3,3.4)-x/(-x*3.5*y*(-3.6)-3.8))+x*(-1.1-y*(2.3*fp2(-1.1,x+y)-fp2(-y,1.1)/2.3)*t)*(-fp2(1.1,x+y)*3.3-fp1(-1.7-x)/(3.5)+fp1(-1.1-x)*(-3.9)-fp2(fp2(1.1,x+y)*7.1,fp2(-y,1.1)/2.5))*((fp2(-fp2(-1.1,x+y)*5.1,-fp2(-1.1,x+y)*3.1-7.9))+fp2(-fp2(-y,1.1)/3.2,-5.7-fp2(-y,1.1)*2.9))
//(-ms1(-(-x)/(-t))-(-ms2(-(-ms2(-x,-x-t)-ms2(-ms1(-1.1-x),-(-1.2-ms2(-x-1.3,-y-1.4)*(-1.5)))/ms1(-1.7-x)),-(-1.8-(-x-1.9/(-t-2.1))))))*(-2.2-x*(-2.3-(-y-(-2.4-(-y-x)))/(2.5*x*y*ms2(2.8,-2.9-x)*t/(-2.6-(2.7*x)))))*(ms1(3.1)*ms1(3.2)/ms2(3.3,3.4)-x/(-x*3.5*y*(-3.6)-3.8))+x*(-1.1-y*(2.3*ms2(-1.1,x+y)-ms2(-y,1.1)/2.3)*t)*(-ms2(1.1,x+y)*3.3-ms1(-1.7-x)/(3.5)+ms1(-1.1-x)*(-3.9)-ms2(ms2(1.1,x+y)*7.1,ms2(-y,1.1)/2.5))*((ms2(-ms2(-1.1,x+y)*5.1,-ms2(-1.1,x+y)*3.1-7.9))+ms2(-ms2(-y,1.1)/3.2,-5.7-ms2(-y,1.1)*2.9))


//((sp3(x/y,-y/x,-sp2(-x/(x+y),y/(x-y))*2.1)-sp2(-sp1(-y/(y-x))/(x-y/(x-y)),-sp2(x/sp1(x/y),-y/sp1(-y/x))/(x/y-y/x)))/(x/(1.5-sp1(x/(x-y)))-sp2(-x/y,-y/(x+y))/sp3(x/(x+y),-y/(x+y),-2.5+3.1*sp1(x/(x-y)))))/(sp3(x/sp2(x/sp1(x/y),-y/sp1(-y/x)),y/sp2(-x/(x+y),y/(x-y)),-2.5/sp1(x/(x-y)))-sp3(sp1(-y/(y-x))*3.1,sp1(1.5-2.1*sp1(x/(x-y))),sp2(x/y,y/(x+y))/sp2(-x/y,-y/(x+y)))+sp2(3.5-1.7*sp3(x/y,-y/x,-sp2(-x/(x+y),y/(x-y))),3.9-sp1(-y/(y-x))/sp1(-y/x))*sp3(sp2(x/sp1(-y/(x-y)),-sp2(-x/y,-y/(x+y))),sp1(x/(x-y))/sp2(-x/y,-y/(x+y)),sp1(-x/(x-y))/sp1(-y/(x-y))))
//((ps3(x/y,-y/x,-ps2(-x/(x+y),y/(x-y))*2.1)-ps2(-ps1(-y/(y-x))/(x-y/(x-y)),-ps2(x/ps1(x/y),-y/ps1(-y/x))/(x/y-y/x)))/(x/(1.5-ps1(x/(x-y)))-ps2(-x/y,-y/(x+y))/ps3(x/(x+y),-y/(x+y),-2.5+3.1*ps1(x/(x-y)))))/(ps3(x/ps2(x/ps1(x/y),-y/ps1(-y/x)),y/ps2(-x/(x+y),y/(x-y)),-2.5/ps1(x/(x-y)))-ps3(ps1(-y/(y-x))*3.1,ps1(1.5-2.1*ps1(x/(x-y))),ps2(x/y,y/(x+y))/ps2(-x/y,-y/(x+y)))+ps2(3.5-1.7*ps3(x/y,-y/x,-ps2(-x/(x+y),y/(x-y))),3.9-ps1(-y/(y-x))/ps1(-y/x))*ps3(ps2(x/ps1(-y/(x-y)),-ps2(-x/y,-y/(x+y))),ps1(x/(x-y))/ps2(-x/y,-y/(x+y)),ps1(-x/(x-y))/ps1(-y/(x-y))))
//((ms3(x/y,-y/x,-ms2(-x/(x+y),y/(x-y))*2.1)-ms2(-ms1(-y/(y-x))/(x-y/(x-y)),-ms2(x/ms1(x/y),-y/ms1(-y/x))/(x/y-y/x)))/(x/(1.5-ms1(x/(x-y)))-ms2(-x/y,-y/(x+y))/ms3(x/(x+y),-y/(x+y),-2.5+3.1*ms1(x/(x-y)))))/(ms3(x/ms2(x/ms1(x/y),-y/ms1(-y/x)),y/ms2(-x/(x+y),y/(x-y)),-2.5/ms1(x/(x-y)))-ms3(ms1(-y/(y-x))*3.1,ms1(1.5-2.1*ms1(x/(x-y))),ms2(x/y,y/(x+y))/ms2(-x/y,-y/(x+y)))+ms2(3.5-1.7*ms3(x/y,-y/x,-ms2(-x/(x+y),y/(x-y))),3.9-ms1(-y/(y-x))/ms1(-y/x))*ms3(ms2(x/ms1(-y/(x-y)),-ms2(-x/y,-y/(x+y))),ms1(x/(x-y))/ms2(-x/y,-y/(x+y)),ms1(-x/(x-y))/ms1(-y/(x-y))))
//((pc3(x/y,-y/x,-pc2(-x/(x+y),y/(x-y))*2.1)-pc2(-pc1(-y/(y-x))/(x-y/(x-y)),-pc2(x/pc1(x/y),-y/pc1(-y/x))/(x/y-y/x)))/(x/(1.5-pc1(x/(x-y)))-pc2(-x/y,-y/(x+y))/pc3(x/(x+y),-y/(x+y),-2.5+3.1*pc1(x/(x-y)))))/(pc3(x/pc2(x/pc1(x/y),-y/pc1(-y/x)),y/pc2(-x/(x+y),y/(x-y)),-2.5/pc1(x/(x-y)))-pc3(pc1(-y/(y-x))*3.1,pc1(1.5-2.1*pc1(x/(x-y))),pc2(x/y,y/(x+y))/pc2(-x/y,-y/(x+y)))+pc2(3.5-1.7*pc3(x/y,-y/x,-pc2(-x/(x+y),y/(x-y))),3.9-pc1(-y/(y-x))/pc1(-y/x))*pc3(pc2(x/pc1(-y/(x-y)),-pc2(-x/y,-y/(x+y))),pc1(x/(x-y))/pc2(-x/y,-y/(x+y)),pc1(-x/(x-y))/pc1(-y/(x-y))))

//sp2(x*sp1(x-y),y*sp1(y-x))*sp2(x*sp2(x-sp1(x*y),y-sp2(y*x,x*(x+y)))-y*sp1(x*(x-y)),y*sp2(y*(x-y),t*(x+y))-x*sp1(t*(x-y)))/(2.23*sp2(1.51*sp1(t-x*(t-y))-1.73,-3.21*sp1(t-y))-1.24*sp2(1.74*x-1.85*sp1(y-t),y-1.96*sp1(t-x)))
//ps2(x*ps1(x-y),y*ps1(y-x))*ps2(x*ps2(x-ps1(x*y),y-ps2(y*x,x*(x+y)))-y*ps1(x*(x-y)),y*ps2(y*(x-y),t*(x+y))-x*ps1(t*(x-y)))/(2.23*ps2(1.51*ps1(t-x*(t-y))-1.73,-3.21*ps1(t-y))-1.24*ps2(1.74*x-1.85*ps1(y-t),y-1.96*ps1(t-x)))
//ma2(x*ma1(x-y),y*ma1(y-x))*ma2(x*ma2(x-ma1(x*y),y-ma2(y*x,x*(x+y)))-y*ma1(x*(x-y)),y*ma2(y*(x-y),t*(x+y))-x*ma1(t*(x-y)))/(2.23*ma2(1.51*ma1(t-x*(t-y))-1.73,-3.21*ma1(t-y))-1.24*ma2(1.74*x-1.85*ma1(y-t),y-1.96*ma1(t-x)))
//pc2(x*pc1(x-y),y*pc1(y-x))*pc2(x*pc2(x-pc1(x*y),y-pc2(y*x,x*(x+y)))-y*pc1(x*(x-y)),y*pc2(y*(x-y),t*(x+y))-x*pc1(t*(x-y)))/(2.23*pc2(1.51*pc1(t-x*(t-y))-1.73,-3.21*pc1(t-y))-1.24*pc2(1.74*x-1.85*pc1(y-t),y-1.96*pc1(t-x)))
//kf2(x*kf1(x-y),y*kf1(y-x))*kf2(x*kf2(x-kf1(x*y),y-kf2(y*x,x*(x+y)))-y*kf1(x*(x-y)),y*kf2(y*(x-y),t*(x+y))-x*kf1(t*(x-y)))/(2.23*kf2(1.51*kf1(t-x*(t-y))-1.73,-3.21*kf1(t-y))-1.24*kf2(1.74*x-1.85*kf1(y-t),y-1.96*kf1(t-x)))
//fp2(x*fp1(x-y),y*fp1(y-x))*fp2(x*fp2(x-fp1(x*y),y-fp2(y*x,x*(x+y)))-y*fp1(x*(x-y)),y*fp2(y*(x-y),t*(x+y))-x*fp1(t*(x-y)))/(2.23*fp2(1.51*fp1(t-x*(t-y))-1.73,-3.21*fp1(t-y))-1.24*fp2(1.74*x-1.85*fp1(y-t),y-1.96*fp1(t-x)))
//in2(x*in1(x-y),y*in1(y-x))*in2(x*in2(x-in1(x*y),y-in2(y*x,x*(x+y)))-y*in1(x*(x-y)),y*in2(y*(x-y),t*(x+y))-x*in1(t*(x-y)))/(2.23*in2(1.51*in1(t-x*(t-y))-1.73,-3.21*in1(t-y))-1.24*in2(1.74*x-1.85*in1(y-t),y-1.96*in1(t-x)))





void __fastcall TForm1::RadioButton1Click(TObject *Sender)
{
   flSetVar("x",&xd,fl_DOUBLE);
   flSetVar("y",&yd,fl_DOUBLE);
   flSetVar("t",&td,fl_DOUBLE);


}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton2Click(TObject *Sender)
{
   flSetVar("x",&xe,fl_EXTENDED);
   flSetVar("y",&ye,fl_EXTENDED);
   flSetVar("t",&te,fl_EXTENDED);


}
//---------------------------------------------------------------------------


void __fastcall TForm1::RadioButton3Click(TObject *Sender)
{
 flSet(fl_DATA_TYPE,fl_DOUBLE,0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton4Click(TObject *Sender)
{
 flSet(fl_DATA_TYPE,fl_EXTENDED,0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
 Int32       Error,IDF;
 TStringType Expr;
 AnsiString  ans;

   #ifdef PANSICHAR
	ans =(AnsiString)(E_EF->Text);
	Expr = ans.c_str();
  #else
	Expr = E_EF->Text;
  #endif;

  flSetFunction(Expr,0,IDF);
  flGetErrorCode(Error);
  if (Error != 0) { ShowError();}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton5Click(TObject *Sender)
{
 flSet(fl_PARAM_TYPE,fl_DOUBLE,0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton6Click(TObject *Sender)
{
 flSet(fl_PARAM_TYPE,fl_EXTENDED,0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
//Int32 *Func1;
   Pointer32 Func1;
   //Int32 FuncAddr ;
   Pointer32 PS;
   Extended res;

   TStringType Expr,ErStr;
   Int32 ECode,ct,rt;
   String SRez,S1r,S2r,S1,S2,DiffStr;
   Int32  ni,NC,T1,T2,nd;
   AnsiString ans;


//*****************************************************************************

   SetVarValue();

   //NC = 10000000;
   NC = StrToInt(ENC->Text);
   res = 0;


   Func1 = NULL;




  #ifdef PANSICHAR
	ans=(AnsiString)(EF->Text);
	Expr = ans.c_str();
  #else
	Expr = EF->Text;
  #endif;


  nd=StrToInt(Form1->E_dx->Text);
  flCompileDiff(Expr, nd, Func1);

  if (CB_OM->Checked) { NC=1;} else {NC=abs(trunc(StrToFloat(ENC->Text,G_FMT)));};

  flGetErrorCode(ECode);

   if ((CB_DS->Checked) && (ECode == 0))
   {
	 flGetDiffString(PS);
	 ConvStr(PS,DiffStr);
	 MessageDlg(DiffStr,mtInformation,TMsgDlgButtons() << mbOK,0);
   } ;





  if (ECode != 0)
  {
	  ShowError();
  }
  else
  {
   flGet(fl_RETURN_NUMBER,Int32(Func1),rt);

   if (rt == fl_NO)            //no return number: return result in inner 'result' or 'res' variable  ( x1: ext=x+y; x1=x1*x; result=x1  )
   {
	  T1=GetTickCount();

	  for(ni = 0; ni <= NC; ni++)
	  {
		//flResult(Func1);
		//Result(Func1);
		 _asm
		 {
		  call Func1
		 };
	  };
	 T2=GetTickCount();

	 res=resf;

   }
   else
   {

	   T1=GetTickCount();
	   for(ni = 0; ni <= NC; ni++)
	   {

		 //flResultE(Func1,res);
		 //res=ResultF(Func1);
		 _asm
		 {
		  call Func1
		  fstp tbyte ptr res
		};

       }
	   T2=GetTickCount();

  }


  S1=FloatToStrF(res,ffGeneral,20,4,G_FMT);


  LDR->Caption=S1;

  if ((T2-T1) != 0)
	   { LDPf->Caption=IntToStr((Int32)(NC/(T2-T1))); }
	   else { LDPf->Caption="no defined" ; };



  flPerform(fl_FREE,(Int32)Func1);

 }

endp:
}
//---------------------------------------------------------------------------



