
#include  "FBForevaldll.bas"
Declare Sub CopyMem Lib "kernel32" Alias "RtlMoveMemory" (ByVal Dst As Long, ByVal Src As Long, ByVal Length As Long)



Type TExtArg3
     TypeArg1 As Long
     TypeArg2 As Long
     TypeArg3 As Long
End Type

Type TExtArg4
     TypeArg1 As Long
     TypeArg2 As Long
     TypeArg3 As Long
     TypeArg4 As Long
End Type

Type TDiffFunc4
     Addr1 As Long
     Addr2 As Long
     Addr3 As Long
     Addr4 As Long
End Type

Type TFunc2
      Expr   As String
      Addr   As Long
      res    As Double
      x      As Double
      y      As Double
End Type

Type TFunc3
      Expr   As String
      Addr   As Long
      res    As Double
      x      As Double
      y      As Double
      z      As Double
End Type

Type TFunc1
      Expr   As String
      Addr   As Long
      res    As Double
      x      As Double
End Type

Dim Shared an(16) As Double
Dim Shared bn(16) As Double
Dim Shared P_Integral As Long
Dim Shared N_Integral As Long


Public Function sp0() As Double
 sp0 = 3.14159265358979324
End Function

Public Function sp1(ByVal arg As Double) As Double
 sp1 = arg * arg
End Function

Public Function sp2(ByVal arg1 As Double, ByVal arg2 As Double) As Double
 sp2 = arg1 - arg2
End Function

Public Function sp3(ByVal arg1 As Double, ByVal arg2 As Double, ByVal arg3 As Double) As Double
 sp3 = arg1 + arg2 - arg3
End Function

'pcvd3(vd:array double; n:integer; x:double)=vd[n]*x
Public Function fvd3(ByVal adrV As Long, ByVal argi As Long, ByVal argf As Double) As Double
 Dim rd As Double
 Dim lenV As Long
 
 
 
 'flGetArrayValueD(@adrv, argi, rd)   'transfer address of address !!!
 rd=Peek(Double,Adrv+argi*8) '8-size of double
 
  'flGetArrayValueD(VarPtr(adrV), argi, rd)   'transfer address of address !!!
  'Call flGet(fl_ARRAY_LENGTH, VarPtr(adrV), lenV)
  
  fvd3 = rd * argf
End Function

Public Function ps0() As Double
 ps0 = 3.14159265358979324
End Function

Public Function ps1(ByRef arg As Double) As Double
 ps1 = arg * arg
End Function

Public Function ps2(ByRef arg1 As Double, ByRef arg2 As Double) As Double
 ps2 = arg1 - arg2
End Function

Public Function ps3(ByRef arg1 As Double, ByRef arg2 As Double, ByRef arg3 As Double) As Double
 ps3 = arg1 + arg2 - arg3
End Function


Public Function pvd3(ByRef adrV As Long, ByRef argi As Long, ByRef argf As Double) As Double
 Dim rd As Double
 Dim lenV As Long
 
 
 
 'flGetArrayValueD(@adrv, argi, rd)   'transfer address of address !!!
 rd=Peek(Double,Adrv+argi*8) '8-size of double
 
  'flGetArrayValueD(VarPtr(adrV), argi, rd)   'transfer address of address !!!
  'Call flGet(fl_ARRAY_LENGTH, VarPtr(adrV), lenV)
  
  pvd3 = rd * argf
End Function




'ms1(argr: double)=argr^2
Public Function ms1(ByVal Addr As Long) As Double
Dim r As Double

 'Addr    ->   AddrOf(argr)
  
   'r=Peek(Double,Addr)
   flGetVarValueD(Addr, r)
   

  ms1 = r * r
End Function

Public Function ms2(ByVal Addr As Long) As Double
Dim r1 As Double
Dim r2 As Double



 'Addr    ->   AddrOf(r1)
 'Addr+16 ->   AddrOf(r2)
  
   'r1=Peek(Double,Addr)
   'r2=Peek(Double,Addr+16)
   flGetVarValueD(Addr, r1)
   flGetVarValueD(Addr + 16, r2)
     
   
  ms2 = r1 - r2
End Function


Public Function ms3(ByVal Addr As Long) As Double
Dim r1 As Double
Dim r2 As Double
Dim r3 As Double



 'Addr    ->   AddrOf(r1)
 'Addr+16 ->   AddrOf(r2)
 'Addr+32 ->   AddrOf(r3)
  
   'r=Peek(Double,Addr)
   'r=Peek(Double,Addr+16)
   'r=Peek(Double,Addr+32)
   
   flGetVarValueD(Addr, r1)
   flGetVarValueD(Addr + 16, r2)
   flGetVarValueD(Addr + 32, r3)
     
   
  ms3 = r1 + r2 - r3
End Function


'msd3(vd:array double; n:integer;  x:double )=vd[n]*x
Public Function msd3(ByVal Addr As Long) As Double
 Dim rd As Double
 Dim x As Double
 Dim lenV As Long
 Dim n As Long
 
 
 'Addr    ->   AddrOf(vd)
 'Addr+16 ->   AddrOf(n)
 'Addr+32 ->   AddrOf(x)

   
    flGetVarValueI(Addr + 16, n)
    flGetArrayValueD(Addr, n, rd)
   'flGet(fl_ARRAY_LENGTH, Addr, lenV)
    flGetVarValueD(Addr + 32, x)
   
  msd3 = rd * x
End Function


'Functions wih identifier:
Public Function idfunc(ByVal arg As Double, ByVal id As Long) As Double
 
    Select Case id
            Case 1
                 idfunc = Sin(arg)
            Case 2
                 idfunc = Cos(arg)
    End Select
End Function



'copyV(VS,VD): VS->VD; only array of double type !!!
Public Sub CopyV(ByVal adrVS As Long, ByVal adrVD As Long)
 Dim rd As Double
 Dim lenV As Long
 Dim lenVS As Long
 Dim lenVD As Long
 Dim i As Long
 Dim adrVD0 As Long
 Dim adrVS0 As Long  
  
  'copy(vd,vd1); 1
  'copy(svdy,vd); 1
  'copy(vd,svdy); 1
  
  
  
  
  
  '************* 1 - slow way ***********
  'flGet(fl_ARRAY_LENGTH, VarPtr(adrVS), lenVS)
  'flGet(fl_ARRAY_LENGTH, VarPtr(adrVD), lenVD)
  
  'If lenVS < lenVD Then lenV = lenVS Else lenV = lenVD
  
  'For i = 0 To lenV - 1
    'flGetArrayValueD(VarPtr(adrVS), i, rd) 'transfer address of address !!!
    'flSetArrayValueD(VarPtr(adrVD), i, rd) 'transfer address of address !!!
  'Next
  
  '*************************************
  
  
  
  '************* 2 - much fast ***********
  
   'If adrVD <> 0 Then 
    	'adrVD0=Peek(Integer,VarPtr(adrVD)) 'adrVD0=@vd[0] ;transfer address of address !!!
    	'LenVD=Peek(Integer,adrVD0-4)       '+1 if Foreval compiled in FPC !!!!!!
    	' 'LenVD=LenVD+1                    'if Foreval compiled in FPC !!!!!!
    'Else
    	'LenVD=0
   'EndIf
   
   'If adrVS <> 0 Then 
      'adrVS0=Peek(Integer,VarPtr(adrVS)) 'adrVD0=@vd[0] ;transfer address of address !!!
      'LenVS=Peek(Integer,adrVS0-4)       '+1 if Foreval compiled in FPC !!!!!!
      ' 'LenVS=LenVS+1                    'if Foreval compiled in FPC !!!!!!
    'Else
    	'LenVS=0
   'EndIf
  
   'If lenVS < lenVD Then lenV = lenVS Else lenV = lenVD
         
    
   'CopyMem adrVD0, adrVS0, lenV * 8   '8-sizeOf(double)
  
 '*************************************
 
 
 
 '************* 3 - most fast ***********
 Asm
 	push eax 
 	push ecx
 	push esi
 	push edi
 	
   
 	cld
   mov esi, dword Ptr [adrVS]  
   cmp esi, 0    
   jz  @@endp1
   mov edi, dword Ptr [adrVD]  
   cmp edi, 0    
   jz  @@endp1
   mov ecx, dword Ptr [edi-4] 'Len -> ecx   'ecx+1 if Foreval compiled in FPC !!!!!!
   mov eax, dword Ptr [esi-4] 'Len -> ecx   'eax+1 if Foreval compiled in FPC !!!!!!
   'add ecx,1   'if Foreval compiled in FPC !!!!!!
   'add eax,1   'if Foreval compiled in FPC !!!!!!
   cmp ecx,eax
   jl @@ckl1
   mov ecx,eax   'ecx=min(lenVD,lenVS)
   @@ckl1:
   lea ecx, [ecx*2]    '64(double)=32*2
 	rep movsd
   
   @@endp1:
 	pop  edi
 	pop  esi
 	pop  ecx
 	pop  eax
 End Asm
 '*************************************
  
End Sub



'FillArray(VD): VD[all]=x
Public Sub FillArray(ByVal adrVD As Long, ByVal x As Double)

 Dim lenV As Long
 Dim adrVD0 As Long
 Dim i As Long
 
  'FillArray(vd,t); 1
  
'******************* 1 - slow way ******************************  
  'flGet(fl_ARRAY_LENGTH, VarPtr(adrVD), lenV)
  'For i = 0 To lenV - 1
   'flSetArrayValueD(VarPtr(adrVD), i, x)
  'Next
'****************************************************************    
  
    
'*********************2 - much fast ******************************   
    'If adrVD <> 0 Then 
    	'adrVD0=Peek(Integer,VarPtr(adrVD)) 'adrVD0=@vd[0] ;transfer address of address !!!
    	'LenV=Peek(Integer,adrVD0-4)        '+1 if Foreval compiled in FPC !!!!!!
    	' 'LenV=LenV+1                      'if Foreval compiled in FPC !!!!!!
    'Else
    	'Lenv=0
    'EndIf
  
   
    'For i = 0 To lenV - 1
     'Poke Double, (adrVD0 + i * 8), x  '8-sizeOf(double)
    'Next
'***************************************************************  


'******************3 - most fast *******************************    

  Asm
 	push eax 
 	push ecx
 	push edx
 	
 	
   mov eax, dword Ptr [adrVD]
   cmp eax, 0    
   jz  @@endp
   
   mov edx, dword Ptr [eax-4]  'edx <- Len
   'add edx,1                   ' <- edx+1 if Foreval compiled in FPC !!!!!!
   fld qword Ptr [x]
   Xor ecx, ecx
         
   @@ckl:
   fst qword Ptr [eax+8*ecx]
   inc ecx
   cmp ecx, edx
   jnz @@ckl
   
   fstp st(0)
   
   @@endp:
   pop  edx 	
   pop  ecx
   pop  eax
 	
  End Asm
  
'*************************************************************************    

End Sub



'sum of infinite arg:
Public Function InfSum(ByVal AdrL As Long, ByVal LenL As Long) As Double
 Dim i As Long
 Dim S As Double
 Dim VArg As Double
 Dim Vaddr As Long
 
 S = 0
 
 For i = 1 To LenL
  Vaddr = AdrL + 16 * (i - 1)      'calc. addr. of current arg.
  'flGetVarValueD(Vaddr, VArg) 'get arg. on addr.
  VArg=Peek(Double,Vaddr) 
  
  S = S + VArg
 Next

 InfSum = S
End Function

'external. func. with derivatives: x^3
Public Function fp3(ByVal arg As Double) As Double
 fp3 = arg * arg * arg
End Function
'1-deriv.
Public Function fp3d1(ByVal arg As Double) As Double
 fp3d1 = 3 * arg * arg
End Function
'2-deriv.
Public Function fp3d2(ByVal arg As Double) As Double
 fp3d2 = 6 * arg
End Function
'3-deriv.
Public Function fp3d3(ByVal arg As Double) As Double
 fp3d3 = 6
End Function
'4-deriv.
Public Function fp3d4(ByVal arg As Double) As Double
 fp3d4 = 0
End Function



'readmxd(mx:arrayd; i,j: integer):dbl = mx[(i-1)*mx[1]+j+1];
Public Function readmxd(ByVal adrM As Long, ByVal argi As Long, ByVal argj As Long) As Double
 Dim rd As Double
 Dim r1 As Double
 
 
  flGetArrayValueD(VarPtr(adrM), 1, r1)
  flGetArrayValueD(VarPtr(adrM), (argi - 1) * r1 + argj + 1, rd) 'transfer address of address !!!
  
  
  'r1=Peek(Double,adrM+8)
  'rd=Peek(Double,adrM + 8 * ((argi - 1) * (r1) + argj + 1))
  
  'GetMem8 (adrM + 8 * 1), r1   '8-size of double
  'GetMem8 (adrM + 8 * ((argi - 1) * (r1) + argj + 1)), rd  '8-size of double
  
  
    
  readmxd = rd
End Function

'writemxd(mx:arrayd; i,j: integer; val:double):none= mx[(i-1)*mx[1]+j+1]=val
Public Sub writemxd(ByVal adrM As Long, ByVal argi As Long, ByVal argj As Long, ByVal argf As Double)
 Dim rd As Double
 Dim r1 As Double
 Dim indx As Long
 
  
  flGetArrayValueD(VarPtr(adrM), 1, r1)
  flSetArrayValueD(VarPtr(adrM), (argi - 1) * (r1) + argj + 1, argf)
  
   
  'GetMem8 (adrM + 8 * 1), r1   '8-size of double
  'PutMem8 (adrM + 8 * ((argi - 1) * r1 + argj + 1)), val   '8-size of double
  
    
End Sub


'rmx=mx1+mx2
'summxd(mx1,mx2,rmx: arrayd):none=  st:integer=mx1[0]; cl:integer=mx1[1]; i:int=0; j:int=0; indx:int=0; for(i,1,st,for(j,1,cl,indx=(i-1)*cl+j+1; rmx[indx]=mx2[indx]+mx1[indx]))

Public Sub summxd(ByVal adrM1 As Long, ByVal adrM2 As Long, ByVal adrMR As Long)
 Dim r1 As Double
 Dim r2 As Double
 Dim st As Double
 Dim cl As Double
 Dim i As Long
 Dim j As Long
 Dim indx As Long
 
 'dimensions of matrix is equal !
 
 flGetArrayValueD(VarPtr(adrM1), 0, st)
 flGetArrayValueD(VarPtr(adrM1), 1, cl)
 
 
 For i = 1 To st
    For j = 1 To cl
      indx = (i - 1) * cl + j + 1
      
      flGetArrayValueD(VarPtr(adrM1), indx, r1)
      flGetArrayValueD(VarPtr(adrM2), indx, r2)
      flSetArrayValueD(VarPtr(adrMR), indx, r1 + r2)
    Next
 Next
    
End Sub


Sub InitInt
	
'Gausse on 15 nodes:

    an(1)=0.03075324199611726835 
    an(2)=0.07036604748810812471
    an(3)=0.10715922046717193501
    an(4)=0.13957067792615431445
    an(5)=0.16626920581699393355
    an(6)=0.18616100001556221103
    an(7)=0.19843148532711157646 
    an(8)=0.20257824192556127288
    an(9)=an(7)
    an(10)=an(6) 
    an(11)=an(5)
    an(12)=an(4)
    an(13)=an(3) 
    an(14)=an(2) 
    an(15)=an(1)
    bn(1)=0.98799251802048542849 
    bn(2)=0.93727339240070590431
    bn(3)=0.84820658341042721620
    bn(4)=0.72441773136017004742
    bn(5)=0.57097217260853884754
    bn(6)=0.39415134707756336990
    bn(7)=0.20119409399743452230 
    bn(8)=0
    bn(9)=-bn(7)
    bn(10)=-bn(6)
    bn(11)=-bn(5)
    bn(12)=-bn(4)
    bn(13)=-bn(3)
    bn(14)=-bn(2)
    bn(15)=-bn(1)
    
    P_Integral=10 'partition on each integral: 1...2^31; 
    N_Integral=15

End Sub



function Integral3FF (ByVal Func  As Long,  ByVal PV1 As Long, ByVal PV2 As Long, ByVal PV3 As Long, ByVal a As Double, ByVal b As Double,  ByVal Func1 As Long, ByVal Func2 As Long, ByVal Func3 As Long, ByVal Func4 As Long) As Double

Dim As Long R,j1,i1,j2,i2,j3,i3,n1,n2,n3 
Dim As Double Int1,Int2,Int3,HV1,HV2,HV3,h1,h2,h3,x1,x2,c,d,e,f,h 
Dim As Double ax1,ax2,ax3,sx1,sx2,sx3 



Int3=0


n1 = abs(P_Integral)
if n1 = 0 then n1=1
n2 = abs(P_Integral)
if n2 = 0 then n2 = 1
n3 = abs(P_Integral)
if n3 = 0 then n3 = 1
h3 = (b-a)/n3

for j3 = 0 to n3-1 

 x1 =  a+j3*h3 
 x2 =  a+(j3+1)*h3
 ax3 = (x1+x2)*0.5 
 sx3 = (x2-x1)*0.5
 
  for i3 = 1 to N_Integral 
  
   
   
   Poke Double, PV1, sx3*bn(i3)+ax3 'more fast than
   'flSetVarValueD(PV1,sx3*bn(i3)+ax3)
    
   Int2 = 0
   d = flResultF(Func2)
   c = flResultF(Func1) 
   h2 = (d-c)/n2
   
   for j2 = 0 to n2-1 
 
    x1 = c+j2*h2
    x2 = c+(j2+1)*h2
    ax2 = (x1+x2)*0.5
    sx2 = (x2-x1)*0.5
    
    for i2 = 1 to N_Integral 
 
     
     
     Poke Double, PV2, sx2*bn(i2)+ax2  'more fast than
     'flSetVarValueD(PV2,sx2*bn(i2)+ax2)

     Int1 = 0
     f = flResultF(Func4)
     e = flResultF(Func3)
     h1 = (f-e)/n1
  
     for j1 = 0 to n1-1 
  
       x1 = e+j1*h1
       x2 = e+(j1+1)*h1
       ax1 = (x1+x2)*0.5
       sx1 = (x2-x1)*0.5
  
       for i1 = 1 to N_Integral   
        
        
        Poke Double, PV3, sx1*bn(i1)+ax1 'more fast than
        'flSetVarValueD(PV3,sx1*bn(i1)+ax1)
        
        Int1 = Int1+an(i1)*flResultF(Func)*sx1
       Next i1
   
     Next j1

     Int2 = Int2+an(i2)*Int1*sx2
 
    Next i2
   Next j2

  Int3 = Int3+an(i3)*Int2*sx3
  Next i3
Next j3


Integral3FF = Int3

End Function


InitInt
