﻿Imports System.Runtime.InteropServices.Marshal
Imports System.Math


Public Module ExternalFunc


    Structure TExtArg3
        Public TypeArg1 As Integer
        Public TypeArg2 As Integer
        Public TypeArg3 As Integer 
    End Structure

    Structure TExtArg4
        Public TypeArg1 As Integer
        Public TypeArg2 As Integer
        Public TypeArg3 As Integer
        Public TypeArg4 As Integer
    End Structure

    Structure TDiffFunc4
        Public Addr1 As Integer
        Public Addr2 As Integer
        Public Addr3 As Integer
        Public Addr4 As Integer
    End Structure

    Structure TFunc1
        Public Expr As String
        Public Addr As Integer
        Public res As Double
        Public x As Double
        Public adrX As UInteger
        Public adrRes As UInteger
    End Structure

    Structure TFunc2
        Public Expr As String
        Public Addr As UInteger
        Public res As Double
        Public x As Double
        Public y As Double
        Public adrX As UInteger
        Public adrY As UInteger
        Public adrRes As UInteger
    End Structure

    Structure TFunc3
        Public Expr As String
        Public Addr As UInteger
        Public res As Double
        Public x As Double
        Public y As Double
        Public z As Double
        Public adrX As UInteger
        Public adrY As UInteger
        Public adrZ As UInteger
        Public adrRes As UInteger
    End Structure

    Dim an(16) As Double
    Dim bn(16) As Double
    Dim P_Integral As Integer
    Dim N_Integral As Integer


    Public Declare Sub CopyMem Lib "kernel32" Alias "RtlMoveMemory" (ByVal Dst As UInteger, ByVal Src As UInteger, ByVal Length As Integer)


    '******************************************************************************************
    'Delegate: for each kind of external function:
    Public Delegate Function FuncByValD1(ByVal arg As Double) As Double
    Public Delegate Function FuncByValD2(ByVal arg1 As Double, ByVal arg2 As Double) As Double
    Public Delegate Function FuncByValD3(ByVal arg1 As Double, ByVal arg2 As Double, ByVal arg3 As Double) As Double
    Public Delegate Function FuncByRefD1(ByRef arg1 As Double) As Double
    Public Delegate Function FuncByRefD2(ByRef arg1 As Double, ByRef arg2 As Double) As Double
    Public Delegate Function FuncByRefD3(ByRef arg1 As Double, ByRef arg2 As Double, ByRef arg2 As Double) As Double
    Public Delegate Function FuncByValFVD3(ByVal adrV As UInteger, ByVal argi As Integer, ByVal argf As Double) As Double
    Public Delegate Function InfArg(ByVal AdrL As UInteger, ByVal LenL As Integer) As Double
    Public Delegate Sub SubAdr2(ByVal adrVS As UInteger, ByVal adrVD As UInteger)
    Public Delegate Sub SubAdrDbl(ByVal adrVD As UInteger, ByVal x As Double)
    Public Delegate Function FuncDblInt(ByVal arg As Double, ByVal id As Integer) As Double
    Public Delegate Function FuncAdrIntInt(ByVal adrM As UInteger, ByVal argi As Integer, ByVal argj As Integer) As Double
    Public Delegate Sub SubAdrIntIntDbl(ByVal adrM As UInteger, ByVal argi As Integer, ByVal argj As Integer, ByVal val As Double)
    Public Delegate Sub SubAdr3(ByVal adrM1 As UInteger, ByVal adrM2 As UInteger, ByVal adrMR As UInteger)


    

    '****************** flGetAdr: for each description of type: ******************

    Public Function GetAddr(ByRef Subj As Double) As UInteger

        Dim Addr As UInteger

        Call flGetAdr(fl_ADDRESS_OBJECT, Subj, Addr)
        GetAddr = Addr

    End Function


    Public Function GetAddr(ByRef Subj As Integer) As UInteger

        Dim Addr As UInteger

        Call flGetAdr(fl_ADDRESS_OBJECT, Subj, Addr)
        GetAddr = Addr

    End Function

    Public Function GetAddr(ByRef Subj As UInteger) As UInteger

        Dim Addr As UInteger

        Call flGetAdr(fl_ADDRESS_OBJECT, Subj, Addr)
        GetAddr = Addr

    End Function



    Public Function GetAddr(ByRef Subj As TAddFuncStruct) As UInteger

        Dim Addr As UInteger

        Call flGetAdr(fl_ADDRESS_OBJECT, Subj, Addr)
        GetAddr = Addr

    End Function

    Public Function GetAddr(ByRef Subj As TExtArg3) As UInteger

        Dim Addr As UInteger

        Call flGetAdr(fl_ADDRESS_OBJECT, Subj, Addr)
        GetAddr = Addr

    End Function

    Public Function GetAddr(ByRef Subj As TAttrib) As UInteger

        Dim Addr As UInteger

        Call flGetAdr(fl_ADDRESS_OBJECT, Subj, Addr)
        GetAddr = Addr

    End Function

    Public Function GetAddr(ByRef Subj As TDiffFunc4) As UInteger

        Dim Addr As UInteger

        Call flGetAdr(fl_ADDRESS_OBJECT, Subj, Addr)
        GetAddr = Addr

    End Function

    Public Function GetAddr(ByRef Subj As TExtArg4) As UInteger

        Dim Addr As UInteger

        Call flGetAdr(fl_ADDRESS_OBJECT, Subj, Addr)
        GetAddr = Addr

    End Function


    '******************* GetAddr : for each kind of external function: *******************************

    Public Function GetAddr(ByVal Subj As FuncByValD1) As UInteger

        Dim Addr As UInteger

        Call flGetAdr(fl_ADDRESS_OBJECT, Subj, Addr)
        GetAddr = Addr

    End Function




    Public Function GetAddr(ByVal Subj As FuncByValD2) As UInteger

        Dim Addr As UInteger

        Call flGetAdr(fl_ADDRESS_OBJECT, Subj, Addr)
        GetAddr = Addr

    End Function

    Public Function GetAddr(ByVal Subj As FuncByValD3) As UInteger

        Dim Addr As UInteger

        Call flGetAdr(fl_ADDRESS_OBJECT, Subj, Addr)
        GetAddr = Addr

    End Function


    Public Function GetAddr(ByVal Subj As FuncByRefD1) As UInteger

        Dim Addr As UInteger

        Call flGetAdr(fl_ADDRESS_OBJECT, Subj, Addr)
        GetAddr = Addr

    End Function

    Public Function GetAddr(ByVal Subj As FuncByRefD2) As UInteger

        Dim Addr As UInteger

        Call flGetAdr(fl_ADDRESS_OBJECT, Subj, Addr)
        GetAddr = Addr

    End Function

    Public Function GetAddr(ByVal Subj As FuncByRefD3) As UInteger

        Dim Addr As UInteger

        Call flGetAdr(fl_ADDRESS_OBJECT, Subj, Addr)
        GetAddr = Addr

    End Function

    Public Function GetAddr(ByVal Subj As FuncByValFVD3) As UInteger

        Dim Addr As UInteger

        Call flGetAdr(fl_ADDRESS_OBJECT, Subj, Addr)
        GetAddr = Addr

    End Function

    Public Function GetAddr(ByVal Subj As InfArg) As UInteger

        Dim Addr As UInteger

        Call flGetAdr(fl_ADDRESS_OBJECT, Subj, Addr)
        GetAddr = Addr

    End Function

    Public Function GetAddr(ByVal Subj As SubAdr2) As UInteger

        Dim Addr As UInteger

        Call flGetAdr(fl_ADDRESS_OBJECT, Subj, Addr)
        GetAddr = Addr

    End Function

    Public Function GetAddr(ByVal Subj As SubAdrDbl) As UInteger

        Dim Addr As UInteger

        Call flGetAdr(fl_ADDRESS_OBJECT, Subj, Addr)
        GetAddr = Addr

    End Function

    Public Function GetAddr(ByVal Subj As FuncDblInt) As UInteger

        Dim Addr As UInteger

        Call flGetAdr(fl_ADDRESS_OBJECT, Subj, Addr)
        GetAddr = Addr

    End Function


    Public Function GetAddr(ByVal Subj As FuncAdrIntInt) As UInteger

        Dim Addr As UInteger

        Call flGetAdr(fl_ADDRESS_OBJECT, Subj, Addr)
        GetAddr = Addr

    End Function

    Public Function GetAddr(ByVal Subj As SubAdrIntIntDbl) As UInteger

        Dim Addr As UInteger

        Call flGetAdr(fl_ADDRESS_OBJECT, Subj, Addr)
        GetAddr = Addr

    End Function

    Public Function GetAddr(ByVal Subj As SubAdr3) As UInteger

        Dim Addr As UInteger

        Call flGetAdr(fl_ADDRESS_OBJECT, Subj, Addr)
        GetAddr = Addr

    End Function



    Public Function sp1(ByVal arg As Double) As Double
        sp1 = arg * arg
    End Function

    Public Function sp2(ByVal arg1 As Double, ByVal arg2 As Double) As Double
        sp2 = arg1 - arg2
    End Function

    Public Function sp3(ByVal arg1 As Double, ByVal arg2 As Double, ByVal arg3 As Double) As Double
        sp3 = arg1 + arg2 - arg3
    End Function

    Public Function ps1(ByRef arg As Double) As Double
        ps1 = arg * arg
    End Function

    Public Function ps2(ByRef arg1 As Double, ByRef arg2 As Double) As Double
        ps2 = arg1 - arg2
    End Function

    Public Function ps3(ByRef arg1 As Double, ByRef arg2 As Double, ByRef arg3 As Double) As Double
        ps3 = arg1 + arg2 - arg3
    End Function



    'pvd3(vd:array double; n:integer; x:double)=vd[n]*x
    Public Function fvd3(ByVal adrV As UInteger, ByVal argi As Integer, ByVal argf As Double) As Double
        Dim rd As Double
        Dim lenV As Integer
        Dim i64 As Int64

        Call flGetArrayValueD(GetAddr(adrV), argi, rd)   'transfer address of address !!!

        'or:
        'CopyMem(GetAddr(rd), adrV + 8 * argi, 8)          '8-sizeof double = 64bit

        'or:
        'i64 = ReadInt64(adrV + 8 * argi)
        'WriteInt64(GetAddr(rd), i64)


        'Call flGet(fl_ARRAY_LENGTH, VarPtr(adrV), lenV)


        fvd3 = rd * argf
    End Function


    'sum of infinite arg:
    Public Function InfSum(ByVal AdrL As UInteger, ByVal LenL As Integer) As Double
        Dim i As Long
        Dim S As Double
        Dim VArg As Double
        Dim Vaddr As Long

        S = 0

        For i = 1 To LenL
            Vaddr = AdrL + 16 * (i - 1)      'calc. addr. of current arg.

            Call flGetVarValueD(Vaddr, VArg) 'get arg. on addr.

            'or:
            'CopyMem(GetAddr(VArg), Vaddr, 8)          '8-sizeof double = 64bit

            S = S + VArg
        Next

        InfSum = S
    End Function


    'copyV(VS,VD): VS->VD
    Public Sub CopyV(ByVal adrVS As UInteger, ByVal adrVD As UInteger)
        Dim rd As Double
        Dim lenV As Integer
        Dim lenVS As Integer
        Dim lenVD As Integer
        Dim adrVD0 As UInteger
        Dim adrVS0 As UInteger
        Dim i As Integer
        Dim res As Double




        'copy(vd,vd1); 1

        '************* 1 - slow way ***********
        'Call flGet(fl_ARRAY_LENGTH, GetAddr(adrVS), lenVS)
        'Call flGet(fl_ARRAY_LENGTH, GetAddr(adrVD), lenVD)

        'If lenVS < lenVD Then lenV = lenVS Else lenV = lenVD

        'For i = 0 To lenV - 1
        'Call flGetArrayValueD(GetAddr(adrVS), i, rd) 'transfer address of address !!!
        'Call flSetArrayValueD(GetAddr(adrVD), i, rd) 'transfer address of address !!!
        'Next

        '*************************************






        '************* 3 - most fast ***********

        If adrVD <> 0 Then

            adrVD0 = ReadInt32(GetAddr(adrVD)) 'adrVD0=@vd[0] ;transfer address of address !!!
            lenVD = ReadInt32(adrVD0 - 4) '+1 if Foreval compiled in FPC !!!!!!

        Else
            lenVD = 0
        End If

        If adrVS <> 0 Then

            adrVS0 = ReadInt32(GetAddr(adrVS)) 'adrVS0=@vs[0] ;transfer address of address !!!
            lenVS = ReadInt32(adrVS0 - 4) '+1 if Foreval compiled in FPC !!!!!!

        Else
            lenVS = 0
        End If

        If lenVS < lenVD Then lenV = lenVS Else lenV = lenVD

        CopyMem(adrVD0, adrVS0, lenV * 8)   '8-sizeOf(double)

        '*************************************



    End Sub

    'FillArray(VD): VD[all]=x
    Public Sub FillArray(ByVal adrVD As UInteger, ByVal x As Double)

        Dim lenV As Integer
        Dim adrVD0, adrX As UInteger
        Dim i As Integer
        Dim i64 As Int64


        '******************* 1 - slow way ******************************
        'Call flGet(fl_ARRAY_LENGTH, GetAddr(adrVD), lenV)
        'For i = 0 To lenV - 1
        'Call flSetArrayValueD(GetAddr(adrVD), i, x)
        'Next
        '****************************************************************



        '************* 2 - more fast ***********
        If adrVD <> 0 Then
            adrVD0 = ReadInt32(GetAddr(adrVD)) 'adrVD0=@vd[0] ;transfer address of address !!!
            lenV = ReadInt32(adrVD0 - 4) '+1 if Foreval compiled in FPC !!!!!!
        Else
            lenV = 0
        End If

        adrX = GetAddr(x)
        i64 = ReadInt64(adrX) 'sizeof double = 64bit

        For i = 0 To lenV - 1
            WriteInt64(adrVD0 + i * 8, i64) '8-sizeOf(double)
        Next

        '****************************************************************
    End Sub


    'Functions wih identifier:
    Public Function idfunc(ByVal arg As Double, ByVal id As Integer) As Double

        Select Case id
            Case 1
                idfunc = Sin(arg)
            Case 2
                idfunc = Cos(arg)
        End Select
    End Function



    'external. func. with derivatives: x^3
    Public Function fp3(ByVal arg As Double) As Double
        fp3 = arg * arg * arg
    End Function
    '1-deriv.
    Public Function fp3d1(ByVal arg As Double) As Double
        fp3d1 = 3 * arg * arg
    End Function
    '2-deriv.
    Public Function fp3d2(ByVal arg As Double) As Double
        fp3d2 = 6 * arg
    End Function
    '3-deriv.
    Public Function fp3d3(ByVal arg As Double) As Double
        fp3d3 = 6
    End Function
    '4-deriv.
    Public Function fp3d4(ByVal arg As Double) As Double
        fp3d4 = 0
    End Function




    'readmxd(mx:arrayd; i,j: integer):dbl = mx[(i-1)*mx[1]+j+1];
    Public Function readmxd(ByVal adrM As UInteger, ByVal argi As Integer, ByVal argj As Integer) As Double
        Dim rd As Double
        Dim r1 As Double


        Call flGetArrayValueD(GetAddr(adrM), 1, r1)
        Call flGetArrayValueD(GetAddr(adrM), (argi - 1) * r1 + argj + 1, rd) 'transfer address of address !!!

        'GetMem8 (adrM + 8 * 1), r1   '8-size of double
        'GetMem8 (adrM + 8 * ((argi - 1) * (r1) + argj + 1)), rd  '8-size of double



        readmxd = rd
    End Function

    'writemxd(mx:arrayd; i,j: integer; val:double):none= mx[(i-1)*mx[1]+j+1]=val
    Public Sub writemxd(ByVal adrM As UInteger, ByVal argi As Integer, ByVal argj As Integer, ByVal val As Double)
        Dim rd As Double
        Dim r1 As Double


        Call flGetArrayValueD(GetAddr(adrM), 1, r1)
        Call flSetArrayValueD(GetAddr(adrM), (argi - 1) * r1 + argj + 1, val)


        'GetMem8 (adrM + 8 * 1), r1   '8-size of double
        'PutMem8 (adrM + 8 * ((argi - 1) * r1 + argj + 1)), val   '8-size of double


    End Sub


    'rmx=mx1+mx2
    'summxd(mx1,mx2,rmx: arrayd):none=  st:integer=mx1[0]; cl:integer=mx1[1]; i:int=0; j:int=0; indx:int=0; for(i,1,st,for(j,1,cl,indx=(i-1)*cl+j+1; rmx[indx]=mx2[indx]+mx1[indx]))

    Public Sub summxd(ByVal adrM1 As UInteger, ByVal adrM2 As UInteger, ByVal adrMR As UInteger)
        Dim r1 As Double
        Dim r2 As Double
        Dim st As Double
        Dim cl As Double
        Dim i As Integer
        Dim j As Integer
        Dim indx As Integer

        'dimensions of matrix is equal !

        Call flGetArrayValueD(GetAddr(adrM1), 0, st)
        Call flGetArrayValueD(GetAddr(adrM1), 1, cl)


        For i = 1 To st
            For j = 1 To cl
                indx = (i - 1) * cl + j + 1

                Call flGetArrayValueD(GetAddr(adrM1), indx, r1)
                Call flGetArrayValueD(GetAddr(adrM2), indx, r2)
                Call flSetArrayValueD(GetAddr(adrMR), indx, r1 + r2)
            Next
        Next

    End Sub




    Sub InitInt()

        'Gausse on 15 nodes:

        an(1) = 0.0307532419961173
        an(2) = 0.0703660474881081
        an(3) = 0.107159220467172
        an(4) = 0.139570677926154
        an(5) = 0.166269205816994
        an(6) = 0.186161000015562
        an(7) = 0.198431485327112
        an(8) = 0.202578241925561
        an(9) = an(7)
        an(10) = an(6)
        an(11) = an(5)
        an(12) = an(4)
        an(13) = an(3)
        an(14) = an(2)
        an(15) = an(1)
        bn(1) = 0.987992518020485
        bn(2) = 0.937273392400706
        bn(3) = 0.848206583410427
        bn(4) = 0.72441773136017
        bn(5) = 0.570972172608539
        bn(6) = 0.394151347077563
        bn(7) = 0.201194093997435
        bn(8) = 0
        bn(9) = -bn(7)
        bn(10) = -bn(6)
        bn(11) = -bn(5)
        bn(12) = -bn(4)
        bn(13) = -bn(3)
        bn(14) = -bn(2)
        bn(15) = -bn(1)

        P_Integral = 10 'partition on each integral: 1...2^31
        N_Integral = 15

    End Sub


    Function Integral3FF(ByVal Func As Long, ByVal PV1 As Long, ByVal PV2 As Long, ByVal PV3 As Long, ByVal a As Double, ByVal b As Double, ByVal Func1 As Long, ByVal Func2 As Long, ByVal Func3 As Long, ByVal Func4 As Long) As Double

        Dim R, j1, i1, j2, i2, j3, i3, n1, n2, n3 As Long
        Dim Int1, Int2, int3, HV1, HV2, HV3, h1, h2, h3, x1, x2, c, d, e, f, h As Double
        Dim ax1, ax2, ax3, sx1, sx2, sx3 As Double



        int3 = 0


        n1 = Abs(P_Integral)
        If n1 = 0 Then n1 = 1
        n2 = Abs(P_Integral)
        If n2 = 0 Then n2 = 1
        n3 = Abs(P_Integral)
        If n3 = 0 Then n3 = 1
        h3 = (b - a) / n3

        For j3 = 0 To n3 - 1

            x1 = a + j3 * h3
            x2 = a + (j3 + 1) * h3
            ax3 = (x1 + x2) * 0.5
            sx3 = (x2 - x1) * 0.5

            For i3 = 1 To N_Integral

                Call flSetVarValueD(PV1, sx3 * bn(i3) + ax3)

                Int2 = 0
                d = flResultF(Func2)
                c = flResultF(Func1)
                h2 = (d - c) / n2

                For j2 = 0 To n2 - 1

                    x1 = c + j2 * h2
                    x2 = c + (j2 + 1) * h2
                    ax2 = (x1 + x2) * 0.5
                    sx2 = (x2 - x1) * 0.5

                    For i2 = 1 To N_Integral

                        Call flSetVarValueD(PV2, sx2 * bn(i2) + ax2)

                        Int1 = 0
                        f = flResultF(Func4)
                        e = flResultF(Func3)
                        h1 = (f - e) / n1

                        For j1 = 0 To n1 - 1

                            x1 = e + j1 * h1
                            x2 = e + (j1 + 1) * h1
                            ax1 = (x1 + x2) * 0.5
                            sx1 = (x2 - x1) * 0.5

                            For i1 = 1 To N_Integral

                                Call flSetVarValueD(PV3, sx1 * bn(i1) + ax1)

                                Int1 = Int1 + an(i1) * flResultF(Func) * sx1
                            Next i1

                        Next j1

                        Int2 = Int2 + an(i2) * Int1 * sx2

                    Next i2
                Next j2

                int3 = int3 + an(i3) * Int2 * sx3
            Next i3
        Next j3


        Integral3FF = int3

    End Function

End Module


