unit ForevalZ;

{******************************************************************************}
{                                                                              }
{                     SOREL  (C)CopyRight -2000- Russia                        }
{                                                                              }
{                        TForevalZ interface unit (component)                  }
{                                                                              }
{                               ver. 1.3.5.231                                 }
{******************************************************************************}

{      "USEDLL"   ForevalZ_Lib.pas}

{At package compilation o disable  key "USEDLL" in ForevalZ_Lib.pas unit}

// {$ZEROBASEDSTRINGS Off}

interface


uses
Classes,ForevalZ_Lib;




const
fz_DISABLE              = 0;
fz_ENABLE               = 1;
fz_REAL                 = 2;  //result type
fz_COMPLEX              = 3;  //result type
fz_REAL_DOUBLE          = 4;  //var type
fz_REAL_EXTENDED        = 5;  //var type
fz_REAL_INTEGER         = 6;  //var type
fz_COMPLEX_DOUBLE       = 7;  //var type
fz_COMPLEX_EXTENDED     = 8;  //var type
fz_ARRAY_REAL_DOUBLE    = 9;  //var type
fz_ARRAY_REAL_EXTENDED  = 10; //var type
fz_DIFFER_DOUBLE        = 11; //var type
fz_DIFFER_EXTENDED      = 12; //var type
fz_STACK_VAL            = 13; //call func
fz_STACK_ADR            = 14; //call func
fz_EAX                  = 15; //call func
fz_ESP                  = 16; //call func
fz_CDECL                = 17; //call type
fz_STDCALL              = 18; //call type
fz_PASCAL               = 19; //call type
fz_DOUBLE               = 20; //stack type
fz_EXTENDED             = 21; //stack type
fz_SHOW_EXCEPTION       = 22;
fz_OPTIMIZATION         = 23;
fz_STACK_TYPE           = 24;
fz_STACK_DEEP           = 25;
fz_CALC_TYPE            = 26;
fz_RESULT_TYPE          = 27;
fz_DIFFER               = 28;
fz_INFINITE             = 29;
fz_FREE                 = 30;
fz_CLEAR                = 31;
fz_VAR_LIST             = 32;
fz_CMPL_FUNC_LIST       = 33;
fz_STRING               = 32;
fz_STRING_UTF16         = 32;
fz_PCHAR                = 33;
fz_ANSISTRING           = 34;
fz_STRING_INTERNAL      = 35;
fz_UNKNOWN              = 36;
fz_STRING_TYPE          = 37;
fz_SYNTAX_EXTENSION     = 38;
fz_PRESENT_COMPLEX_NUMBER = 39;
fz_YES                  = 60;
fz_NO                   = 61;
fz_PRECOMPILED          = 62;
fz_COMPILE_STACK_DEEP   = 63;
fz_COMPILE_OVFL         = 64;
fz_DINAMIC_LOAD_NUM     = 65;
fz_PANSICHAR            = 66;
fz_PESENT_VAR           = 67;
fz_NONE                 = 68;  //result type
fz_WIDESTRING           = 69;
fz_ARRAY_LENGTH         = 70;
fz_VERSION                         = 71;
fz_MAJOR                           = 72;
fz_MINOR                           = 73;
fz_RELEASE                         = 74;
fz_ABOUT                           = 75;
fz_BUILD                           = 76;
fz_AUTHOR                          = 77;
fz_EXTENDED_COMMAND                = 78;
fz_STRING_UTF8                     = 79;
fz_ERROR_CODE                      = 80;
fz_ARRAY_REAL_INTEGER              = 81;
fz_SAVE                            = 82;
fz_RESTORE                         = 83;
fz_COMPILED_BY                     = 84;
fz_ENABLE_FUNCTION                 = 85;   {.191}
fz_DISABLE_FUNCTION                = 86;   {.191}
fz_REPLACE_FUNCTIONS               = 87;   {.193}
fz_REPLACE_FUNCTIONS_NUM           = 88;    {.193}
fz_REPLACE_DIV                     = 89;  {.193}
fz_REPLACE_MUL                     = 90;   {.193}
fz_REPLACE_ADDSUB                  = 91;   {.193}
fz_REPLACE_OPERATIONS              = 92;    {.193}
fz_REPLACE_OPERATIONS_NUM          = 93;    {.193}
fz_REPLACE_MULTI_EXPR              = 94;    {.193}
fz_USE_VIRTUAL_ALLOC               = 95;   //only for exe code
fz_LENGTH_CODE                     = 96;   {.193}
fz_SAVE_EAX                        = 97;   {.193}
fz_SAVE_EBX                        = 98;   {.193}
fz_SAVE_ECX                        = 99;   {.193}
fz_SAVE_EDX                        = 100;  {.193}
fz_SAVE_ESP                        = 101;   {.193}
fz_SAVE_EBP                        = 102;  {.193}
fz_SAVE_ESI                        = 103;  {.193}
fz_SAVE_EDI                        = 104;  {.193}
fz_ACCURATE_SPEC_FUNC              = 105;
fz_DINAMIC_LOAD                    = 106;
fz_CHECK_INCORRECT_SPACE           = 107; {.195}
fz_POWER_SYMBOL                    = 108; {.195}
fz_REPLACE_AT_IF                   = 109; {.197}
fz_LOAD_STACK_AFTER_CALC           = 110;  {.197}
fz_ADDRESS_OBJECT                  = 111;  {.197}
fz_FPU_CW                          = 112; {.203}
fz_FPU_CW_DEFAULT                  = 113; {.203} { = $1372 }
fz_FAST_DIV                        = 114; {.205}
fz_COMMENT                         = 115; {.213}
fz_ENABLE_REPLACE_FUNCTION         = 116; {.215}
fz_DISABLE_REPLACE_FUNCTION        = 117; {.215}
fz_ENABLE_CALC_CONST               = 118; {.215}
fz_DISABLE_CALC_CONST              = 119; {.215}
fz_REPLACE_COMPOSITE_FUNCTIONS                 = 120; {.217}
fz_REPLACE_COMPOSITE_FUNCTIONS_COMPLEX         = 121; {.217}
fz_REPLACE_COMPOSITE_FUNCTIONS_REAL            = 122; {.217}
fz_DISABLE_REPLACE_FUNCTION_COMPLEX            = 123; {.217}
fz_DISABLE_REPLACE_FUNCTION_REAL               = 124; {.217}
fz_ENABLE_REPLACE_FUNCTION_COMPLEX             = 125; {.217}
fz_ENABLE_REPLACE_FUNCTION_REAL                = 126; {.217}
fz_OPTIMIZATION_MUL_DIV                        = 127; {.217A}
fz_OPTIMIZATION_A1                             = 128;
fz_OPTIMIZATION_A2                             = 129;
fz_CALC_CONST_EXPRESSION                       = 130;
fz_LEAD_TO_LOWER_CASE                          = 131; {.221}
fz_SKIPPED_IF                                  = 132;  {.221}
fz_CALC_CONST_EXPR_IN_MULTI_EXPR               = 133;   {.221}
fz_PRECISION                                   = 134;
fz_MASK_FPU_EXCEPTION                          = 135;  {.229}
fz_CLEAR_FPU_EXCEPTION                         = 136;  {.229}
fz_IS_FPU_EXCEPTION                            = 137;  {.229}
fz_FREE_CODE_AT_REPLACE                        = 138; {.229}
fz_ADDRESS_EXCEPTION_FLAG                      = 139; {.231}






fz_UNKNOWN_SYMBOL                 = 40;
fz_MISSING_ROUND_BRACKET          = 41;
fz_MISSING_OPERATION              = 43;
fz_WRONG_NUMBER_ARGUMENTS         = 44;
fz_MISSING_EXPRESSION             = 45;
fz_UNKNOWN_FUNCTION               = 46;
fz_ERROR_AT_ADDITION_FUNCTION     = 47;
fz_NOT_DEFINED_OPERATOR           = 48;
fz_NOT_DEFINED_FUNCTION           = 49;
fz_INCORRECT_ARGUMENT             = 50;
fz_MISSING_ARGUMENT               = 51;
fz_INTERNAL_ERROR                 = 52;
fz_INCORRECT_TYPE                 = 53;
fz_MISSING_SEPARATOR              = 54;
fz_WRONG_NAME                     = 55;
fz_CALCULATION_ERROR              = 56;
fz_ABSENT_LOAD_FUNCTION_FOR_TYPE  = 57;
fz_MISSING_SQUARE_BRACKET         = 58;
fz_MISSING_CURLY_BRACKET          = 59;
fz_MISSING_ABS_BRACKET            = 60;
fz_WRONG_EXPRESSION               = 61;
fz_INCORRECT_SPACE                = 62; {.195}
fz_VARIABLE_REDECLARED            = 63;  {.221}



_Real = 1;
_Complex = 2;


type TArrayC = ForevalZ_Lib.TArrayC;


type TComplexD = ForevalZ_Lib.TComplexD;
type TComplexE = ForevalZ_Lib.TComplexE;
type PComplexD = ForevalZ_Lib.PComplexD;
type PComplexE = ForevalZ_Lib.PComplexE;
type TArrayD =   ForevalZ_Lib.TArrayD;
type TArrayE =   ForevalZ_Lib.TArrayE;
type TArrayI =   ForevalZ_Lib.TArrayI;

type PArrayD =   ForevalZ_Lib.PArrayD;
type PArrayE =   ForevalZ_Lib.PArrayE;
type PArrayI =   ForevalZ_Lib.PArrayI;

type TZAddFuncStruct = ForevalZ_Lib.TZAddFuncStruct;




 type
  TForevalZ = class(TComponent)
  private

  protected

  public
    { Public declarations }

        procedure fzCompile(Expr: String; var Func: Pointer);             stdcall;
        procedure fzSetVar(Name: String; Addr: Pointer; TV: Cardinal);    stdcall;
        procedure fzSetFunction(Name: String; FAdr: Pointer);             stdcall;
        procedure fzSet(mode: Cardinal; value: Cardinal);                                                      stdcall;
        procedure fzGet(mode,subj: Cardinal; var value: Cardinal);                                             stdcall;
        procedure fzGetSyntaxErrorCode(var CError: Cardinal);                                                  stdcall;
        procedure fzGetSyntaxErrorString(var SError:String);              stdcall;
        procedure fzRenameFunction(Name,NewName: String);                 stdcall;
        procedure fzAddNameFunction(IDF: Integer; Name: String);          stdcall;
        procedure fzPerform(act,subj: Cardinal);                                                               stdcall;
        procedure fzResultCxD(Func: Pointer; var Re,Im: Double);                                                stdcall;
        procedure fzResultCxE(Func: Pointer; var Re,Im: Extended);                                                stdcall;
        procedure fzResultCxDP(Func: Pointer;  Res: Pointer);                                                    stdcall;
        procedure fzResultCxEP(Func: Pointer;  Res: Pointer);                                                    stdcall;
        procedure fzResultD(Addr: Pointer;  var Res: double);                                                  stdcall;
        procedure fzResultE(Addr: Pointer;  var Res: extended);                                                stdcall;
        procedure fzResult(Func: Pointer);                                                                     stdcall;
        procedure fzResultSafe(Func: Pointer);                                                                  stdcall;
        procedure fzResultDSafe(Addr: Pointer;  var Res: double);                                               stdcall;
        procedure fzResultCxDPSafe(Addr: Pointer;  Res: Pointer);                                               stdcall;
        procedure fzResultCxDSafe(Addr: Pointer;  var Re,Im: double);                                           stdcall;
        procedure fzPolarDP(pz: Pointer;   pz1: Pointer);                                                      stdcall;
        procedure fzPolarEP(pz: Pointer;   pz1: Pointer);                                                      stdcall;
        procedure fzDecartDP(pz: Pointer;  pz1: Pointer);                                                      stdcall;
        procedure fzDecartEP(pz: Pointer;  pz1: Pointer);                                                      stdcall;
        procedure fzSetVarIntrnl(Name: String;  VType: Cardinal; var ExAddr: Pointer);   stdcall;
        procedure fzSetVarValueD(Addr: Pointer;  Val: Double);       stdcall;
        procedure fzSetVarValueE(Addr: Pointer;  Val: Extended);       stdcall;
        procedure fzSetVarValueI(Addr: Pointer;  Val: Integer);       stdcall;
        procedure fzSetVarValueCxD(Addr: Pointer;  ValRe,ValIm: Double);       stdcall;
        procedure fzSetVarValueCxE(Addr: Pointer;  ValRe,ValIm: Extended);       stdcall;
        procedure fzSetLength(AdrV: Pointer; TypeV: Cardinal; Len: Cardinal);  stdcall;
        procedure fzSetArrayValueI(AdrV: Pointer; indx: Cardinal; Val: integer);  stdcall;
        procedure fzSetArrayValueD(AdrV: Pointer; indx: Cardinal; Val: double);  stdcall;
        procedure fzSetArrayValueE(AdrV: Pointer; indx: Cardinal; Val: extended);  stdcall;
        procedure fzGetVarValueE(Addr: Pointer; var Val: Extended);       stdcall;
        procedure fzGetVarValueI(Addr: Pointer; var Val: Integer);       stdcall;
        procedure fzGetVarValueD(Addr: Pointer; var Val: Double);       stdcall;
        procedure fzGetArrayValueI(AdrV: Pointer; indx: Cardinal; var Val: integer);  stdcall;
        procedure fzGetArrayValueD(AdrV: Pointer; indx: Cardinal; var Val: double);  stdcall;
        procedure fzGetArrayValueE(AdrV: Pointer; indx: Cardinal; var Val: extended);  stdcall;
        procedure fzGetVarValueCxD(Addr: Pointer;  var ValRe,ValIm: Double);       stdcall;
        procedure fzGetVarValueCxE(Addr: Pointer;  var ValRe,ValIm: Extended);       stdcall;

        procedure fzSetNameImUnit(Name: String);   stdcall;
        procedure fzGetFuncID(Name: String; var IDF: Integer);   stdcall;

        procedure fzLoadFPUD(RE: Double; Im: Double);  stdcall;
        procedure fzLoadFPUE(RE: Extended; Im: Extended);  stdcall;
        procedure fzLoadFPUDP(Adr: Pointer);  stdcall;
        procedure fzLoadFPUEP(Adr: Pointer);  stdcall;

     

        procedure zInitFuncStruct(var FS: TZAddFuncStruct);

     published

  end;

  procedure Register;


implementation

procedure  Register;
begin
  RegisterComponents('ForevalZ',[TForevalZ]);
end;



procedure TForevalZ.zInitFuncStruct(var FS: TZAddFuncStruct);
begin
  FS.addr:=nil;
  FS.CallType:=fz_StdCall;
  FS.Arg:=0;
  FS.ArgType:=fz_Differ;
  FS.ArgTypeList:=nil;
  FS.CallFunc:=0;
  FS.ResultType:=0;
  FS.CalcConst:=fz_YES;
  FS.DeepFPU:=8;   //fz_UNKNOWN
  FS.SaveReg:=15;  //=15: save eax,ebx,ecx,edx (RECOMMEND.);  =255 save all reg; see .doc if there are any error
  FS.ReplFunc:=fz_Yes;
  FS.Resrv2:=0;
  FS.Resrv3:=0;
end;



procedure TForevalZ.fzCompile(Expr: String; var Func: Pointer);                       stdcall;
begin
  ForevalZ_Lib.fzCompile(Expr,Func);
end;


procedure TForevalZ.fzPerform(act,subj: Cardinal);                                stdcall;
begin
  ForevalZ_Lib.fzPerform(act,subj);
end;




procedure TForevalZ.fzSetVar(Name:String; Addr: Pointer; TV: Cardinal);           stdcall;
begin
  ForevalZ_Lib.fzSetVar(Name,Addr,TV);
end;



procedure TForevalZ.fzResultD(Addr: Pointer; var Res: double);                    stdcall;
asm
  push eax
  call Addr
  mov eax, [res]
  fstp qword ptr [eax]
  pop eax
end;
{begin
  ForevalZ_Lib.fzResultD(Addr,Res);
end;}


procedure TForevalZ.fzResultE(Addr: Pointer; var Res: Extended);                  stdcall;
asm
  push eax
  call Addr
  mov eax, [res]
  fstp tbyte ptr [eax]
  pop eax
end;
{begin
  ForevalZ_Lib.fzResultE(Addr,Res);
end; }


procedure TForevalZ.fzResultCxDP(Func: Pointer;  Res: Pointer);                   stdcall;
asm
   push eax
   call Func
   mov eax, [res]
   fstp qword ptr [eax]
   fstp qword ptr [eax+8]
   pop  eax
end;
{begin
  ForevalZ_Lib.fzResultCxDP(Func,Res);
end;  }


procedure TForevalZ.fzResultCxEP(Func: Pointer;  Res: Pointer);                   stdcall;
asm
   push eax
   call Func
   mov eax, [res]
   fstp tbyte ptr [eax]
   fstp tbyte ptr [eax+16]
   pop  eax
end;
{begin
  ForevalZ_Lib.fzResultCxEP(Func,Res);
end;  }


procedure TForevalZ.fzResultCxD(Func: Pointer;  var Re,Im: double);               stdcall;
var
p:TComplexD;
begin
  asm
   call Func
   push eax
   mov  eax, [re]
   fstp qword ptr [eax]
   mov  eax, [Im]
   fstp qword ptr [eax]
   pop  eax
  end;
end;
{begin
  ForevalZ_Lib.fzResultCxD(Func,Re,Im);
end;}


procedure TForevalZ.fzResultCxE(Func: Pointer;  var Re,Im: extended);              stdcall;
var
p:TComplexE;
begin
 asm
   call Func
   push eax
   mov  eax, [Re]
   fstp tbyte ptr [eax]
   mov  eax, [Im]
   fstp tbyte ptr [eax]
   pop  eax
  end;
end;
{begin
  ForevalZ_Lib.fzResultCxE(Func,Re,Im);
end;  }



procedure TForevalZ.fzResult(Func: Pointer);                                       stdcall;
asm
    call Func
end;




procedure TForevalZ.fzSetFunction(Name: String; FAdr: Pointer);                     stdcall;
begin
  ForevalZ_Lib.fzSetFunction(Name,FAdr);
end;


procedure TForevalZ.fzGet(mode,subj: Cardinal; var value: Cardinal);               stdcall;
begin
  ForevalZ_Lib.fzGet(mode,subj,value);
end;


procedure TForevalZ.fzGetSyntaxErrorString(var SError: String);                   stdcall;
begin
  ForevalZ_Lib.fzGetSyntaxErrorString(SError);
end;



procedure TForevalZ.fzRenameFunction(Name,NewName:String);                          stdcall;
begin
  ForevalZ_Lib.fzRenameFunction(Name,NewName);
end;


procedure TForevalZ.fzAddNameFunction(IDF: Integer; Name: String);              stdcall;
begin
  ForevalZ_Lib.fzAddNameFunction(IDF, Name);
end;



procedure TForevalZ.fzGetSyntaxErrorCode(var CError: Cardinal);                    stdcall;
begin
  ForevalZ_Lib.fzGetSyntaxErrorCode(CError);
end;



procedure TForevalZ.fzSet(mode: Cardinal; value: Cardinal);                        stdcall;
begin
  ForevalZ_Lib.fzSet(mode,value);
end;


procedure TForevalZ.fzPolarDP(pz: Pointer;  pz1: Pointer);                        stdcall;
begin
  ForevalZ_Lib.fzPolarDP(pz,pz1);
end;


procedure TForevalZ.fzPolarEP(pz: Pointer;  pz1: Pointer);                         stdcall;
begin
  ForevalZ_Lib.fzPolarEP(pz,pz1);
end;



procedure TForevalZ.fzDecartDP(pz: Pointer;  pz1: Pointer);                        stdcall;
begin
  ForevalZ_Lib.fzDecartDP(pz,pz1);
end;



procedure TForevalZ.fzDecartEP(pz: Pointer;  pz1: Pointer);                        stdcall;
begin
  ForevalZ_Lib.fzDecartEP(pz,pz1);
end;


procedure TForevalZ.fzSetNameImUnit(Name: String);                                  stdcall;
begin
   ForevalZ_Lib.fzSetNameImUnit(Name);
end;



procedure TForevalZ.fzSetVarIntrnl(Name: String;  VType: Cardinal; var ExAddr: Pointer); stdcall;
begin
  ForevalZ_Lib.fzSetVarIntrnl(name,VType,ExAddr);
end;

procedure TForevalZ.fzSetVarValueD(Addr: Pointer;  Val: Double);                  stdcall;
begin
  PDouble(Addr)^:=Val
  //ForevalZ_Lib.fzSetVarValueD(Addr,Val);
end;

procedure TForevalZ.fzSetVarValueE(Addr: Pointer;  Val: Extended);                stdcall;
begin
 PExtended(Addr)^:=Val
  //ForevalZ_Lib.fzSetVarValueE(Addr,Val);
end;

procedure TForevalZ.fzSetVarValueI(Addr: Pointer;  Val: Integer);                 stdcall;
begin
 PInteger(Addr)^:=Val
  //ForevalZ_Lib.fzSetVarValueI(Addr,Val);
end;

procedure TForevalZ.fzSetVarValueCxD(Addr: Pointer;  ValRe,ValIm: Double);         stdcall;
begin
  PDouble(Addr)^:=ValRe;
  PDouble(Cardinal(Addr)+8)^:=ValIm;
  //ForevalZ_Lib.fzSetVarValueCxD(Addr,ValRe,ValIm);
end;

procedure TForevalZ.fzSetVarValueCxE(Addr: Pointer;  ValRe,ValIm: Extended);       stdcall;
begin
  ValRe:=PExtended(Addr)^;
  ValIm:=PEXtended(Cardinal(Addr)+16)^;
   //ForevalZ_Lib.fzSetVarValueCxE(Addr,ValRe,ValIm);
end;

procedure TForevalZ.fzSetLength(AdrV: Pointer; TypeV: Cardinal; Len: Cardinal);   stdcall;
begin
  ForevalZ_Lib.fzSetLength(AdrV,TypeV,Len);
end;

procedure TForevalZ.fzSetArrayValueD(AdrV: Pointer; indx: Cardinal; Val: double);  stdcall;
begin
  PArrayD(AdrV)^[indx]:=Val;
  //ForevalZ_Lib.fzSetArrayValueD(AdrV,indx,Val);
end;

procedure TForevalZ.fzSetArrayValueE(AdrV: Pointer; indx: Cardinal; Val: extended);  stdcall;
begin
 PArrayE(AdrV)^[indx]:=Val;
  //ForevalZ_Lib.fzSetArrayValueE(AdrV,indx,Val);
end;


procedure TForevalZ.fzSetArrayValueI(AdrV: Pointer; indx: Cardinal; Val: integer);  stdcall;
begin
  PArrayI(AdrV)^[indx]:=Val;
  //ForevalZ_Lib.fzSetArrayValueI(AdrV,indx,Val);
end;


procedure TForevalZ.fzGetVarValueE(Addr: Pointer; var Val: Extended);       stdcall;
begin
  Val:=PExtended(Addr)^
  //ForevalZ_Lib.fzGetVarValueE(Addr,Val);
end;

procedure TForevalZ.fzGetVarValueI(Addr: Pointer; var Val: Integer);       stdcall;
begin
  Val:=PInteger(Addr)^
  //ForevalZ_Lib.fzGetVarValueI(Addr,Val);
end;

procedure TForevalZ.fzGetVarValueD(Addr: Pointer; var Val: Double);       stdcall;
begin
  Val:=PDouble(Addr)^
  //ForevalZ_Lib.fzGetVarValueD(Addr,Val);
end;

procedure TForevalZ.fzGetArrayValueI(AdrV: Pointer; indx: Cardinal; var Val: integer);  stdcall;
begin
  Val:=PArrayI(AdrV)^[indx];
  //ForevalZ_Lib.fzGetArrayValueI(AdrV,indx,Val);
end;

procedure TForevalZ.fzGetArrayValueD(AdrV: Pointer; indx: Cardinal; var Val: double);  stdcall;
begin
  Val:=PArrayD(AdrV)^[indx];
  //ForevalZ_Lib.fzGetArrayValueD(AdrV,indx,Val);
end;

procedure TForevalZ.fzGetArrayValueE(AdrV: Pointer; indx: Cardinal; var Val: extended);  stdcall;
begin
  Val:=PArrayE(AdrV)^[indx];
  //ForevalZ_Lib.fzGetArrayValueE(AdrV,indx,Val);
end;

procedure TForevalZ.fzGetVarValueCxD(Addr: Pointer;  var ValRe,ValIm: Double);       stdcall;
begin
  ValRe:=PDouble(Addr)^;
  ValIm:=PDouble(Cardinal(Addr)+8)^;
  //ForevalZ_Lib.fzGetVarValueCxD(Addr,ValRe,ValIm);
end;


procedure TForevalZ.fzGetVarValueCxE(Addr: Pointer;  var ValRe,ValIm: Extended);       stdcall;
begin
  ValRe:=PExtended(Addr)^;
  ValIm:=PEXtended(Cardinal(Addr)+16)^;
  //ForevalZ_Lib.fzGetVarValueCxE(Addr,ValRe,ValIm);
end;



procedure TForevalZ.fzLoadFPUD(RE: Double; Im: Double);  stdcall;
asm
  fld qword ptr Im
  fld qword ptr Re
end;
{begin
  ForevalZ_Lib.fzLoadFPUD(RE,Im);
end;}

procedure TForevalZ.fzLoadFPUE(RE: Extended; Im: Extended);  stdcall;
asm
  fld tbyte ptr Im
  fld tbyte ptr Re
end;
{begin
  ForevalZ_Lib.fzLoadFPUE(RE,Im);
end;  }

procedure TForevalZ.fzLoadFPUDP(Adr: Pointer);  stdcall;
asm         //Adr=@TComplexD
  push eax
  mov eax,Adr
  fld qword ptr [eax+8]
  fld qword ptr [eax]
  pop eax
end;
{begin
  ForevalZ_Lib.fzLoadFPUDP(Adr);
end;  }

procedure TForevalZ.fzLoadFPUEP(Adr: Pointer);  stdcall;
asm         //Adr=@TComplexE
  push eax
  mov eax,Adr
  fld tbyte ptr [eax+16]
  fld tbyte ptr [eax]
  pop eax
end;
{begin
  ForevalZ_Lib.fzLoadFPUEP(Adr);
end;  }


procedure TForevalZ.fzResultSafe(Func: Pointer);                                                                 stdcall;
begin
  ForevalZ_Lib.fzResultSafe(Func);
end;

procedure TForevalZ.fzResultDSafe(Addr: Pointer;  var Res: double);                                             stdcall;
begin
   ForevalZ_Lib.fzResultDSafe(Addr,Res);
end;

procedure TForevalZ.fzResultCxDSafe(Addr: Pointer;  var Re,Im: double);                                        stdcall;
begin
  ForevalZ_Lib.fzResultCxDSafe(Addr,Re,Im);
end;

procedure TForevalZ.fzResultCxDPSafe(Addr: Pointer;  Res: Pointer);                                              stdcall;
begin
  ForevalZ_Lib.fzResultCxDPSafe(Addr,Res);
end;



procedure TForevalZ.fzGetFuncID(Name: String; var IDF: Integer);   stdcall;
begin
  ForevalZ_Lib.fzGetFuncID(Name, IDF);
end;




end.






