#Include "windows.bi"
#include  "FBExtternalFuncZ.bas"


Dim Shared x As Double
Dim Shared y As Double
Dim Shared t As Double
Dim Shared a As Double
Dim Shared b As Double
Dim Shared c As Double
Dim Shared d As Double
Dim Shared n As Long
Dim Shared k As Long
Dim Shared i As Long
Dim Shared j As Long
Dim Shared z1 As TComplex
Dim Shared z2 As TComplex
Dim Shared z3 As TComplex

Dim Shared resf As TComplex
Dim Shared adrVD As Long
Dim Shared AdrVI As Long
Dim Shared AdrVD1 As Long

Dim Shared FBA1() As Double

Dim Shared fnc1 As TFuncExt4
Dim Shared fnc2 As TFuncExt4

Dim Shared VBF() As Double
Dim Shared AdrVBF As Long
Dim Shared LenVBF As Long
Dim Shared FDyn As Long
Dim Shared GLT As Long




Function calcRe(adr As Long) As Double
	Dim res As Double
	Asm		
		Call dword Ptr [adr]
		fstp qword Ptr [res]		
	End Asm
	
	Return res
	
End Function

Function calcCx(adr As Long) As TComplex
	Dim res As TComplex
	Asm
		Call dword Ptr [adr]
		fstp qword Ptr [res]
		fstp qword Ptr [res+8]		
	End Asm
	
	Return res
	
End Function


Public Sub ErrorHandle()
  Dim ECode As Long
  Dim S As String
  Dim ErStr As String
  Dim ErStrTmp As String
  Dim PErZStr As ZString Ptr
  
  
  fzGetSyntaxErrorCode(ECode)


Select Case ECode
  
  
 Case fz_INTERNAL_ERROR
  S = "INTERNAL ERROR or UNCATCHABLE SYNTAX ERROR"
  
 Case fz_UNKNOWN_SYMBOL
  S = "UNKNOWN SYMBOL or INCORRECT ARGUMENT or  WRONG EXPRESSION"
  
 Case fz_WRONG_NUMBER_ARGUMENTS
  S = "INCOINCIDENCE NUMBER OF   ARGUMENTS"
  
 Case fz_MISSING_OPERATION
  S = "MISSING OPERATION"
  
 Case fz_MISSING_EXPRESSION
  S = "MISSING EXPRESSION"
  
 Case fz_UNKNOWN_FUNCTION
  S = "UNKNOWN FUNCTION"
  
 Case fz_ERROR_AT_ADDITION_FUNCTION
  S = "ERROR AT ADDITION FUNCTION"
  
 Case fz_INCORRECT_ARGUMENT
  S = "INCORRECT ARGUMENT"
  
 Case fz_MISSING_ARGUMENT
  S = "MISSING ARGUMENT"
  
 Case fz_INCORRECT_TYPE
  S = "WRONG TYPE OF ARGUMENT"
  
 Case fz_MISSING_SEPARATOR
  S = "MISSING SEPARATOR "
  
 Case fz_WRONG_NAME
  S = "WRONG NAME"
  
 Case fz_MISSING_ABS_BRACKET
  S = "MISSING ABS BRACKET"
  
 Case fz_MISSING_SQUARE_BRACKET
  S = "MISSING SQUARE BRACKET"
  
 Case fz_MISSING_CURLY_BRACKET
  S = "MISSING CURLY BRACKET"
  
 Case fz_MISSING_ROUND_BRACKET
  S = "MISSING ROUND BRACKET"
  
 Case fz_NOT_DEFINED_OPERATOR
   S = "NOT DEFINED OPERATOR"
 
 Case fz_NOT_DEFINED_FUNCTION
   S = "NOT DEFINED FUNCTION"
   
 Case fz_CALCULATION_ERROR
  S = "INTERNAL ERROR AT CALCULATION"
  
 Case fz_WRONG_EXPRESSION
  S = "WRONG EXPRESSION"
     
 Case fz_ABSENT_LOAD_FUNCTION_FOR_TYPE
  S = "ABSENT LOAD FUNCTION FOR TYPE"
  
 Case fz_CHECK_INCORRECT_SPACE
  S = "INCORRECT SPACE"  
  
 Case fz_VARIABLE_REDECLARED
  S = "VARIABLE REDECLARED"
           
 Case Else: S = "UNKNOWN SYNTAX ERROR"

End Select


 
 
 fzGetSyntaxErrorString(PErZStr)
 ErStrTmp=*PErZStr
 ErStr = ErStrTmp
 ErStrTmp = ""    
 
 '  it's better: at first,  copying of a string then reset - will help to avoid the possible mistakes connected with transfer of strings  (the conflict of different managers of memory)

  
 Print "ForevalZ SyntaxError:  " + S 
 Print ErStr
 
 
 
End Sub







Sub OnLoad()
 Dim IDF As Long
 Dim FZHandle As TZAddFuncStruct
 Dim AdrFS As Long
 Dim ECode As Long
 Dim lenVD As Long
 Dim fi As Long
 Dim rd As Double
 Dim ri As Long
 Dim TArg4 As TExtArg4
 Dim FS As Long
 Dim Vaddr As Long
 Dim Str1 As String
 Dim StrV As String
 Dim ID As Long
 Dim ArgZ As TComplex
 Dim CXres As TComplex
 Dim FCAddr As Long
 Dim AdrVD0 As Long
 Dim res As Double
 Dim PZStr1 As ZString Ptr
 Dim StrTmp1 As String
 Dim SizeVBF As Long
 
 
    fzGet(fz_COMPILED_BY, 0, ID)
    
    'GLT=1(Delphi); GLT=2(FPC)
    If ID >= 100 Then
      GLT = 2
    Else
      GLT = 1
    End If
   
   
 
   'First of all need to set type of strings !!!!!!!!!!!!!!!
   'To set type of string (ANSISTRING) in forevalz.dll:
   'in FreeBasic string passed as PAnsiChar
   
   fzSet(fz_STRING_TYPE, fz_ANSISTRING)  
   'fzSet(fz_ENABLE, fz_SHOW_EXCEPTION)
   'fzSet(fz_Enable,fz_CHECK_INCORRECT_SPACE)
   
    If GLT = 2 Then
      fzSet(fz_ENABLE,fz_MASK_FPU_EXCEPTION)  ' <- if ForevalZ is compiled in FPC, then need to set it.
      
      'If will crash program at catching of computational exception in parsing  (x/(2-2), sqrt(-2)*x, pow(-2.1,7.8),...) then also set it.
   End If
   
   
   'to check the correct of transmission strings enable error messages commando fzSet (fz_ENABLE, fz_SHOW_EXCEPTION)
   'and pass the string with the error, such as: fzCompile(@"1+2+3+",FS);
   'has to be a message with this string without distortions
     
    
   'type all constants and results of intermediate calculations (on default - extended (fz_EXTENDED)):
   'higher speed , but lower accuracy
    fzSet(fz_STACK_TYPE, fz_DOUBLE) 'now - double
   
   


  '******************************************************************************************** 
 'External Function:
 
 'if any arg. in function is complex, that all arg. passed  ByRef and CallType=fz_STACK_ADR !!!
 
 '*********************************************************************************************
 

 'ps1(z1*ps1(x))*ps2(x,z1)+ps2(z1,z2)*ps2(z2,y)-ps2(x,y*x)/ps2(z1*ps1(z1/x),-y*i)
 
 
 'ms1(x*ms1(x-y))*ms2(z1-z2,ms1(z1+z2)*ms1(z2-x))-ms2(x-y,z1+z2)*ms2(z2*z1,x-ms1(x+y))+ms2(x-y,x*t)*z1
 'ps1(x*ps1(x-y))*ps2(z1-z2,ps1(z1+z2)*ps1(z2-x))-ps2(x-y,z1+z2)*ps2(z2*z1,x-ps1(x+y))+ps2(x-y,x*t)*z1
 'pc1(x*pc1(x-y))*pc2(z1-z2,pc1(z1+z2)*pc1(z2-x))-pc2(x-y,z1+z2)*pc2(z2*z1,x-pc1(x+y))+pc2(x-y,x*t)*z1
   
 
   
   'sp1(x)
   zInitFuncStruct(FZHandle)
   FZHandle.Addr = @sp1
   FZHandle.arg = 1
   FZHandle.ArgType = fz_REAL_DOUBLE
   FZHandle.DeepFPU = 1
   AdrFS = VarPtr(FZHandle)
   fzSetFunction(@"sp1", AdrFS)
   
    'sp2(x,y)
   zInitFuncStruct(FZHandle)
   FZHandle.Addr = @sp2
   FZHandle.arg = 2
   FZHandle.ArgType = fz_REAL_DOUBLE
   FZHandle.DeepFPU = 1
   AdrFS = VarPtr(FZHandle)
   fzSetFunction(@"sp2", AdrFS)
   
   'sp3(x,y,t)
   zInitFuncStruct(FZHandle)
   FZHandle.Addr = @sp3
   FZHandle.arg = 3
   FZHandle.ArgType = fz_REAL_DOUBLE
   FZHandle.DeepFPU = 1
   AdrFS = VarPtr(FZHandle)
   fzSetFunction(@"sp3", AdrFS)
   
   
   
   'ps1(x)
   zInitFuncStruct(FZHandle)
   FZHandle.Addr = @ps1
   FZHandle.arg = 1
   FZHandle.ArgType = fz_REAL_DOUBLE
   FZHandle.CallFunc = fz_STACK_ADR
   FZHandle.DeepFPU = 1
   AdrFS = VarPtr(FZHandle)
   fzSetFunction(@"ps1", AdrFS)
   
   'ps1(z)
   zInitFuncStruct(FZHandle)
   FZHandle.Addr = @ps1z
   FZHandle.arg = 1
   FZHandle.ArgType = fz_COMPLEX_DOUBLE
   FZHandle.DeepFPU = 2
   FZHandle.CallFunc = fz_STACK_ADR
   FZHandle.ResultType = fz_COMPLEX
   AdrFS = VarPtr(FZHandle)
   fzSetFunction(@"ps1", AdrFS)
   
   'ps2(z1,z2)
   zInitFuncStruct(FZHandle)
   FZHandle.Addr = @ps2z
   FZHandle.arg = 2
   FZHandle.ArgType = fz_COMPLEX_DOUBLE
   FZHandle.DeepFPU = 2
   FZHandle.CallFunc = fz_STACK_ADR
   FZHandle.ResultType = fz_COMPLEX
   AdrFS = VarPtr(FZHandle)
   fzSetFunction(@"ps2", AdrFS)
   
   'ps2(x,y)
   zInitFuncStruct(FZHandle)
   FZHandle.Addr = @ps2r
   FZHandle.arg = 2
   FZHandle.ArgType = fz_REAL_DOUBLE
   FZHandle.DeepFPU = 1
   FZHandle.CallFunc = fz_STACK_ADR
   FZHandle.ResultType = fz_REAL
   AdrFS = VarPtr(FZHandle)
   fzSetFunction(@"ps2", AdrFS)
   
   
   'ps2(x,z)
   zInitFuncStruct(FZHandle)
   FZHandle.ArgType = fz_DIFFER
   TArg4.TypeArg1 = fz_REAL_DOUBLE
   TArg4.TypeArg2 = fz_COMPLEX_DOUBLE
   FZHandle.ArgTypeList = VarPtr(TArg4)
   FZHandle.Addr = @ps2rz
   FZHandle.arg = 2
   FZHandle.DeepFPU = 2
   FZHandle.CallFunc = fz_STACK_ADR
   FZHandle.ResultType = fz_COMPLEX
   AdrFS = VarPtr(FZHandle)
   fzSetFunction(@"ps2", AdrFS)
   
   'ps2(z,x)
   zInitFuncStruct(FZHandle)
   FZHandle.ArgType = fz_DIFFER
   TArg4.TypeArg1 = fz_COMPLEX_DOUBLE
   TArg4.TypeArg2 = fz_REAL_DOUBLE
   FZHandle.ArgTypeList = VarPtr(TArg4)
   FZHandle.Addr = @ps2zr
   FZHandle.arg = 2
   FZHandle.DeepFPU = 2
   FZHandle.CallFunc = fz_STACK_ADR
   FZHandle.ResultType = fz_COMPLEX
   AdrFS = VarPtr(FZHandle)
   fzSetFunction(@"ps2", AdrFS)
   
   'fvd3                             fvd3(vd,n+1,x*y)
   zInitFuncStruct(FZHandle)
   TArg4.TypeArg1 = fz_ARRAY_REAL_DOUBLE
   TArg4.TypeArg2 = fz_REAL_INTEGER
   TArg4.TypeArg3 = fz_REAL_DOUBLE
   FZHandle.Addr = @fvd3
   FZHandle.arg = 3
   FZHandle.ArgType = fz_DIFFER
   FZHandle.ArgTypeList = VarPtr(TArg4)
   FZHandle.DeepFPU = 1
   AdrFS = VarPtr(FZHandle)
   fzSetFunction(@"fvd3", AdrFS)
   
  'fvd4                             fvd4(vd,n,z1,x)
   zInitFuncStruct(FZHandle)
   FZHandle.ArgType = fz_DIFFER
   TArg4.TypeArg1 = fz_ARRAY_REAL_DOUBLE
   TArg4.TypeArg2 = fz_REAL_INTEGER
   TArg4.TypeArg3 = fz_COMPLEX_DOUBLE
   TArg4.TypeArg4 = fz_REAL_DOUBLE
   FZHandle.Addr = @fvd4
   FZHandle.arg = 4
   FZHandle.CallFunc = fz_STACK_ADR
   FZHandle.ArgTypeList = VarPtr(TArg4)
   FZHandle.DeepFPU = 2
   FZHandle.ResultType = fz_COMPLEX
   AdrFS = VarPtr(FZHandle)
   fzSetFunction(@"fvd4", AdrFS)
   
   
   'ms1(x) = x^2
   zInitFuncStruct(FZHandle)
   FZHandle.Addr = @ms1r
   FZHandle.arg = 1
   FZHandle.ArgType = fz_REAL_DOUBLE
   FZHandle.CallFunc = fz_ESP
   FZHandle.DeepFPU = 1
   AdrFS = VarPtr(FZHandle)
   fzSetFunction(@"ms1", AdrFS)
   
   'ms1(z)
   zInitFuncStruct(FZHandle)
   FZHandle.Addr = @ms1z
   FZHandle.arg = 1
   FZHandle.ArgType = fz_COMPLEX_DOUBLE
   FZHandle.DeepFPU = 2
   FZHandle.CallFunc = fz_ESP
   FZHandle.ResultType = fz_COMPLEX
   AdrFS = VarPtr(FZHandle)
   fzSetFunction(@"ms1", AdrFS)
   
   'ms2(z1,z2) = z1-z2
   zInitFuncStruct(FZHandle)
   FZHandle.Addr = @ms2z
   FZHandle.arg = 2
   FZHandle.ArgType = fz_COMPLEX_DOUBLE
   FZHandle.DeepFPU = 2
   FZHandle.CallFunc = fz_ESP
   FZHandle.ResultType = fz_COMPLEX
   AdrFS = VarPtr(FZHandle)
   fzSetFunction(@"ms2", AdrFS)
   
   'ms2(x,y) = x-y
   zInitFuncStruct(FZHandle)
   FZHandle.Addr = @ms2r
   FZHandle.arg = 2
   FZHandle.ArgType = fz_REAL_DOUBLE
   FZHandle.DeepFPU = 1
   FZHandle.CallFunc = fz_ESP
   FZHandle.ResultType = fz_REAL
   AdrFS = VarPtr(FZHandle)
   fzSetFunction(@"ms2", AdrFS)
   
   
   'ms2(x,z) = x-z
   zInitFuncStruct(FZHandle)
   FZHandle.ArgType = fz_DIFFER
   TArg4.TypeArg1 = fz_REAL_DOUBLE
   TArg4.TypeArg2 = fz_COMPLEX_DOUBLE
   FZHandle.ArgTypeList = VarPtr(TArg4)
   FZHandle.Addr = @ms2rz
   FZHandle.arg = 2
   FZHandle.DeepFPU = 2
   FZHandle.CallFunc = fz_ESP
   FZHandle.ResultType = fz_COMPLEX
   AdrFS = VarPtr(FZHandle)
   fzSetFunction(@"ms2", AdrFS)
   
   'ms2(z,x) = z-x
   zInitFuncStruct(FZHandle)
   FZHandle.ArgType = fz_DIFFER
   TArg4.TypeArg1 = fz_COMPLEX_DOUBLE
   TArg4.TypeArg2 = fz_REAL_DOUBLE
   FZHandle.ArgTypeList = VarPtr(TArg4)
   FZHandle.Addr = @ms2zr
   FZHandle.arg = 2
   FZHandle.DeepFPU = 2
   FZHandle.CallFunc = fz_ESP
   FZHandle.ResultType = fz_COMPLEX
   AdrFS = VarPtr(FZHandle)
   fzSetFunction(@"ms2", AdrFS)
   
   
   'msd4 = vd[n]+x+z                          msd4(vd,n+4,z1,x)
   zInitFuncStruct(FZHandle)
   FZHandle.ArgType = fz_DIFFER
   TArg4.TypeArg1 = fz_ARRAY_REAL_DOUBLE
   TArg4.TypeArg2 = fz_REAL_INTEGER
   TArg4.TypeArg3 = fz_COMPLEX_DOUBLE
   TArg4.TypeArg4 = fz_REAL_DOUBLE
   FZHandle.Addr = @msd4
   FZHandle.arg = 4
   FZHandle.CallFunc = fz_ESP
   FZHandle.ArgTypeList = VarPtr(TArg4)
   FZHandle.DeepFPU = 2
   FZHandle.ResultType = fz_COMPLEX
   AdrFS = VarPtr(FZHandle)
   fzSetFunction(@"msd4", AdrFS)
   
   
    'vd1: array double=len(vd); copy(vd,vd1); sum(vd1)
   'pccopy(vs,vd: array double):none = l:int=0; ls:int=len(vs); ld:int=len(vd); l=min(ls,ld); i:int=0; for(i,0,l-1,vd[i]=vs[i])
   
   'copy(VS,VD): VS->VD
   zInitFuncStruct(FZHandle)
   FZHandle.ArgType = fz_ARRAY_REAL_DOUBLE
   FZHandle.Addr = @CopyV
   FZHandle.ResultType = fz_NONE 'sub
   FZHandle.arg = 2
   FZHandle.DeepFPU = 1
   FZHandle.SaveReg = 207 'eax,ebx,ecx,edx,esi,edi
   AdrFS = VarPtr(FZHandle)
   fzSetFunction(@"Copy", AdrFS)
   
   
   'res:dbl=0; vd1: array double=10; fillarray(vd1,1); res=sum(vd1);setlen(vd1,20); fillarray(vd1,2); res+sum(vd1)
   'pcfillarray(vd: array double; x: double):none = l:int=len(vd); i:int=0; for(i,0,l-1,vd[i]=x)
   
   'FillArray(VD,x): VD[all]=x
   zInitFuncStruct(FZHandle)
   FZHandle.ArgType = fz_DIFFER
   FZHandle.arg = 2
   TArg4.TypeArg1 = fz_ARRAY_REAL_DOUBLE
   TArg4.TypeArg2 = fz_REAL_DOUBLE
   FZHandle.ArgTypeList = VarPtr(TArg4)
   FZHandle.Addr = @FillArray
   FZHandle.ResultType = fz_NONE 'sub
   FZHandle.DeepFPU = 1
   FZHandle.SaveReg = 207 'eax,ebx,ecx,edx,esi,edi
   AdrFS = VarPtr(FZHandle)
   fzSetFunction(@"FillArray", AdrFS)
   
   'infs - with infinite number of arg.
   'infs(re)
   zInitFuncStruct(FZHandle)
   FZHandle.Addr = @InfSum
   FZHandle.ArgType = fz_REAL_DOUBLE
   FZHandle.CallFunc = fz_INFINITE
   FZHandle.DeepFPU = 2
   AdrFS = VarPtr(FZHandle)
   fzSetFunction(@"infsum", AdrFS)
   
   
   'infs - with infinite number of arg.
   zInitFuncStruct(FZHandle)
   FZHandle.Addr = @InfSumZ
   FZHandle.ArgType = fz_COMPLEX_DOUBLE
   FZHandle.CallFunc = fz_INFINITE
   FZHandle.ResultType = fz_COMPLEX
   FZHandle.DeepFPU = 2
   AdrFS = VarPtr(FZHandle)
   fzSetFunction(@"infsum", AdrFS)
   
   
   
   'fzGetSyntaxErrorCode(ECode)
   'If ECode <> 0 Then ErrorHandle
   
  
   
   'set the same functions with precompiled call
    fzSetFunction(@"pc1(x:  double)=x^2", 0)
    fzSetFunction(@"pc1(z: complex double):complex=z*z", 0)
    fzSetFunction(@"pc2(x,y:  double)=x-y", 0)
    fzSetFunction(@"pc2(z1,z2: complex double):complex=z1-z2", 0)
    fzSetFunction(@"pc2(x:  double; z: complex double):complex=x-z", 0)
    fzSetFunction(@"pc2(z: complex double; x:  double):complex=z-x", 0)
    fzSetFunction(@"pvd4(vd:array double; n:integer; z: complex double; x:double ):complex=vd[n]+x+z", 0)
    fzSetFunction(@"pvd3(vd:array double; n:integer; x:double)=vd[n]*x", 0)
    fzSetFunction(@"{$CC-}pccopy(vs,vd: array double):none = l:int=0; ls:int=len(vs); ld:int=len(vd); l=min(ls,ld); i:int=0; for(i,0,l-1,vd[i]=vs[i])", 0)
    fzSetFunction(@"{$CC-}pcfillarray(vd: array double; x: double):none = l:int=len(vd); i:int=0; for(i,0,l-1,vd[i]=x)", 0)
    
   'pc2(z1*pc1(x*y),z2+pc2(x,y*x))+pc1(z1*i)/pc1(x*pc2(x,-y))+pc2(x*y,z1*z2)*pc2(z1*i,x+y)
   'ps2(z1*ps1(x*y),z2+ps2(x,y*x))+ps1(z1*i)/ps1(x*ps2(x,-y))+ps2(x*y,z1*z2)*ps2(z1*i,x+y)
   'fvd3(vd,n+5,x*y)*fvd4(vd,n+k,z1+z2,x+y)
   'pvd3(vd,n+5,x*y)*pvd4(vd,n+k,z1+z2,x+y)
   'infsum(x,y)/infsum(z1,z2,z1*i)-infsum(x,y,x+y,x-y)*infsum(z1-z2,z1,z2,z1*i)
   '(x+y)/(z1+z2+z1*i)-(x+y+x+y+x-y)*(z1-z2+z1+z2+z1*i)
       
   '************************Set common internal var.**********************************************
   
   
   fzSetVar(@"x", VarPtr(x), fz_REAL_DOUBLE)
   fzSetVar(@"y", VarPtr(y), fz_REAL_DOUBLE)
   fzSetVar(@"t", VarPtr(t), fz_REAL_DOUBLE)
   fzSetVar(@"n", VarPtr(n), fz_REAL_INTEGER)
   fzSetVar(@"k", VarPtr(k), fz_REAL_INTEGER)
   fzSetVar(@"j", VarPtr(j), fz_REAL_INTEGER)
  
   fzSetVar(@"a", VarPtr(a), fz_REAL_DOUBLE)
   fzSetVar(@"b", VarPtr(b), fz_REAL_DOUBLE)
   fzSetVar(@"c", VarPtr(c), fz_REAL_DOUBLE)
   fzSetVar(@"d", VarPtr(c), fz_REAL_DOUBLE)
   
   fzSetVar(@"z1", VarPtr(z1), fz_COMPLEX_DOUBLE)
   fzSetVar(@"z2", VarPtr(z2), fz_COMPLEX_DOUBLE)
   fzSetVar(@"z3", VarPtr(z3), fz_COMPLEX_DOUBLE)
   fzSetVar(@"res", VarPtr(resf), fz_COMPLEX_DOUBLE)
   fzSetVar(@"result", VarPtr(resf), fz_COMPLEX_DOUBLE)
   
   
   fzSetVarIntrnl(@"vd", fz_ARRAY_REAL_DOUBLE, adrVD)
   fzSetVarIntrnl(@"vi", fz_ARRAY_REAL_INTEGER, AdrVI)
        lenVD = 100
   fzSetLength(adrVD, fz_ARRAY_REAL_DOUBLE, lenVD)
   fzSetLength(AdrVI, fz_ARRAY_REAL_INTEGER, lenVD)
   
   fzGet(fz_ARRAY_LENGTH, adrVD, lenVD)
 
   a = 2
   b = -3
   c = 4.12345
   d = -5.6789
   x = 2.123
   y = 5.456
   t = -3.789
   n = 1
   k = 2
   j = 5
   z1.re = 2.123
   z1.im = -1.456
   z2.re = 5.456
   z2.im = 2.789
   z3.re = -3.789
   z3.im = -3.123
   
   
   
   
  'Vaddr = @z1
  'fzGetVarValueCxD(Vaddr, ArgZ.re, ArgZ.im)
  'StrV = Str(ArgZ.re) + "+" + Str(ArgZ.im) + "i"
  'Print StrV
   
   
   For fi = 0 To lenVD - 1  'array - dinamic count from 0 to length - 1
    rd = ((-1) ^ (fi + 1)) * (fi + 1) * 0.5
    fzSetArrayValueD(adrVD, fi, rd)
  
    ri = Fix((-1) ^ (fi + 5) * (fi + 5) * 0.5)
    fzSetArrayValueI(AdrVI, fi, ri)

   Next
   
   'in the work, you can dynamically change the size of the array without recompiling the function containing it:
   fzSetVarIntrnl(@"vd1", fz_ARRAY_REAL_DOUBLE, AdrVD1)
   fzCompile(@"sum(vd1)*len(vd1)", FCAddr)
   fzSetLength(AdrVD1, fz_ARRAY_REAL_DOUBLE, 3)
    fzSetArrayValueD(AdrVD1, 0, 1.1)
     fzSetArrayValueD(AdrVD1, 1, 2.2)
      fzSetArrayValueD(AdrVD1, 2, 3.3)
   fzResultCxDP(FCAddr, CXres)
   
     Str1 = Str(CXres.re) + "  + " + Str(CXres.im) + "*i"
     'Print Str1  '=(1.1+2.2+3.3)*3=19.8
    
   fzSetLength(AdrVD1, fz_ARRAY_REAL_DOUBLE, 5)
    fzSetArrayValueD(AdrVD1, 3, 4.4)
     fzSetArrayValueD(AdrVD1, 4, 5.5)
   fzResultCxDP(FCAddr, CXres)
   
     Str1 = Str(CXres.re) + "  + " + Str(CXres.im) + "*i"
     'Print Str1  '=(1.1+2.2+3.3+4.4+5.5)*5=82.5
   
   
    
        
    '*************** How to work with Foreval dinamic array ********************************
   
   'adrVD - address of address of vd[0]
   'If Length of array = 0 then adrVD = 0 !!!
   'If adrVD <> 0 then:
           
   adrVD0=Peek(Integer,adrVD)      'adrVD0=@vd[0]  
   res=Peek(Double,adrVD0)         'res=vd[0] 
   res=Peek(Double,adrVD0+75*8)    'res=vd[75];  8- sizeof(double)     
   ri=Peek(Integer,adrVD0-4)       'ri=Length(vd) ; '+1 if Foreval compiled in FPC !!!!!!
   'Print Res
   'Print ri
   
  
   
   
   'set and copy FB dinamic array (FBA1) to Foreval dinamic array  (VD1)
    fzSetLength(AdrVD1, fz_ARRAY_REAL_DOUBLE, lenVD)
    
    ReDim FBA1(lenVD - 1)
    For i = 0 To lenVD - 1
     FBA1(i) = i
    Next
        
                         
    adrVD0=Peek(Integer,adrVD1)                    'adrVD0=@vd1[0]
    CopyMem (adrVD0, VarPtr(FBA1(0)), lenVD * 8)   'FBA1->VD1; 8- sizeof(double) 
    
    
    

'********************  Fast connecting dynamic arrays *************************************
    
    'VBF()
    'in VB count from "1"; in Foreval count from "0"
    'in zero element writes it length (in last four bytes of element !!)
    
    fzSetVar(@"vbf", VarPtr(AdrVBF), fz_ARRAY_REAL_DOUBLE) 'transfer address of address: VarPtr(AdrVBF)
    'This pointer: AdrVBF (address and value) is used at compiling, so it should not change !!  for all usage time of an array in the compiled expressions
    
    fzCompile(@"k:int=0; len:int=len(vbf); s:dbl=0; for(k,0,len-1,s=s+vbf[k]; vbf[k]=1.0); s",  FDyn)
  
    'fill of array:
    LenVBF = 3   'in real: Length(VBF) = 2, in VBF(0) - writes it length,
    ReDim VBF(LenVBF)
    VBF(1) = 1.1
    VBF(2) = 2.2
    'connecting - set pointer to array:
    AdrVBF = VarPtr(VBF(1))          'begin of vbf for Foreval: count from "1"
    'PutMem4 AdrVBF - 4, LenVBF - 1   'writes it length in last four bytes of zero element !!
    Poke Integer,  AdrVBF - 4, LenVBF - 1
    
    'GLT=1(Delphi); GLT=2(FPC),  in FPC Length=High
    If GLT = 1 Then
     SizeVBF = LenVBF - 1
    Else
     SizeVBF = LenVBF - 2
    End If
    
    Poke Integer,  AdrVBF - 4,  SizeVBF    'writes it length in last four bytes of zero element !!
   
    
    fzResultCxDP(FDyn, Cxres)
   
    
    'Print Cxres.re  '1.1+2.2
    
    res = 0
    For fi = 1 To LenVBF - 1  'count from "1"
     res = res + VBF(fi)
    Next
    
    'Print res  '1.0+1.0
    
    
    'changing of size
    LenVBF = 5
    ReDim VBF(LenVBF)
    VBF(1) = 1.1
    VBF(2) = 2.2
    VBF(3) = 3.3
    VBF(4) = 4.4
    'connecting - set new pointer to array: (so placing in memory is changed)
    AdrVBF = VarPtr(VBF(1))  
    'Poke Integer,  AdrVBF - 4, LenVBF - 1
    
    'GLT=1(Delphi); GLT=2(FPC),  in FPC Length=High
    If GLT = 1 Then
     SizeVBF = LenVBF - 1
    Else
     SizeVBF = LenVBF - 2
    End If
    
    Poke Integer,  AdrVBF - 4,  SizeVBF    'writes it length in last four bytes of zero element !!
    
    
    
    fzResultCxDP(FDyn, CXres)
   
    
    'Print Cxres.re   '1.1+2.2+3.3+4.4
    
    res = 0
    For fi = 1 To LenVBF - 1  'count from "1"
     res = res + VBF(fi)
    Next
    
    'Print res  '=4*1.0
    
    
   
  '********************* several expressions **********************************************'
   'save global var.
   fzPerform(fz_SAVE, fz_VAR_LIST)
   'fnc1(z1,z2,n,x) = z1+z2+n*x;
   'fnc2(z1,z2,n,x)=  z1*z2+(i*n+x);
   'fnc2(fnc1(2-i,5+3i,3,1.1),1-i,5,fnc1(2-i,5+3i,3,1.1).re)=
   
   fnc1.Expr = "z1+z2+n*x"
   fzSetVar(@"x", VarPtr(fnc1.x), fz_REAL_DOUBLE)
   fzSetVar(@"n", VarPtr(fnc1.n), fz_REAL_INTEGER)
   fzSetVar(@"z1", VarPtr(fnc1.z1), fz_COMPLEX_DOUBLE)
   fzSetVar(@"z2", VarPtr(fnc1.z2), fz_COMPLEX_DOUBLE)
   fzCompile(StrPtr(fnc1.Expr), fnc1.Addr)
   
   fnc2.Expr = "z1*z2+(i*n+x)"
   fzSetVar(@"x", VarPtr(fnc2.x), fz_REAL_DOUBLE)
   fzSetVar(@"n", VarPtr(fnc2.n), fz_REAL_INTEGER)
   fzSetVar(@"z1", VarPtr(fnc2.z1), fz_COMPLEX_DOUBLE)
   fzSetVar(@"z2", VarPtr(fnc2.z2), fz_COMPLEX_DOUBLE)
   fzCompile(StrPtr(fnc2.Expr), fnc2.Addr)
  
   'restore global var.
   fzPerform(fz_RESTORE, fz_VAR_LIST)
     
   fnc1.x = 1.1
   fnc1.n = 3
   fnc1.z1.re = 2#
   fnc1.z1.im = -1#
   fnc1.z2.re = 5#
   fnc1.z2.im = 3#
   
   
   fnc2.x = 1.1
   fnc2.n = 5
   fnc2.z1.re = 2#
   fnc2.z1.im = -1#
   fnc2.z2.re = 1#
   fnc2.z2.im = -1#
   
    fzResultCxDP(fnc1.Addr, fnc1.res) 'fnc1.res=fnc1(2-i,5+3i,3,1.1)
    fnc2.z1 = fnc1.res
    fnc2.x = fnc1.res.re

    fzResultCxDP(fnc2.Addr, fnc2.res)
   
    Str1 = Str(fnc2.res.re) + "  + " + Str(fnc2.res.im) + "*i"
    'Print Str1
   
    'fnc1.res*fnc2.z2+(i*fnc2.n+Re(fnc1.res))=(10.3+2*i)*(1-i)+(i*5+10.3)=22.6-3.3i

   
  '**************************************************************************
   
  
  fzGet(fz_VERSION, fz_MAJOR, ID)
  Str1 = Str(ID)

  fzGet(fz_VERSION, fz_MINOR, ID)
  Str1 = Str1 + "." + Str(ID)

  fzGet(fz_VERSION, fz_RELEASE, ID)
  Str1 = Str1 + "." + Str(ID)
  
  fzGet(fz_VERSION, fz_BUILD, ID)
  Str1 = Str1 + "." + Str(ID)

  
  Str1 = "ForevalZ.dll v." + Str1
 
  
  fzGet(fz_COMPILED_BY, 0, ID)
  
  If ID >= 100 Then
   Str1 = Str1+".  Compiled by FPC v." + Str(ID)
  Else
    If ID = 7 Then Str1 = Str1+".  Compiled by Delphi7" 
    If ID = 12 Then Str1 = Str1+".  Compiled by Delphi 2009"
    If ID = 16 Then Str1 = Str1+".  Compiled by Delphi XE3"
  End If
  
  
  
  Print Str1
  
  fzGetStr(fz_COMMENT, 0, PZStr1) 
  StrTmp1=*PZStr1
  Str1 = StrTmp1
  StrTmp1 = ""  
  'Print Str1
  
  
  fzGetStr(fz_ABOUT, 0, PZStr1)
  StrTmp1=*PZStr1
  Str1 = StrTmp1
  StrTmp1 = ""  
  'Print Str1
  
  Print
  
  Print "Test  ForevalZ.dll on FreeBasic"
  Print "*****************************************"
  Print "on default:" 
  Print "" 
  Print "  real var.: x=2.123; y=5.456; t=-3.789"
  Print ""
  Print "  int. var.: n=1; k=2; j=5" 
  Print ""
  Print "  complex var.: z1.re=2.123; z1.im= -1.456; z2.re=5.456; z2.im=2.789; "
  Print "  z3.re= -3.789; z3.im= -3.123;"
  Print ""
  Print "  array of double: vd (0-99)"
  Print "  array of int.: vi (0-99)"
  Print ""
  Print "*****************************************"
  Print "examples:"
  Print ""
  Print "  root(z1,3)+(z2.re/z1.im)^2"
  Print ""
  Print "  zi1:dblCx = |z1|^n*cossin(arg(z1)*n); zi2:dblCx = |z1|*exp(i*arg(z1)); zi1/zi2"
  Print ""
  Print "  z1:dblCx = 1+2i; z2:dblCx = 3-5i; result = z1^log(z1,z2)/z2 "
   
   
End Sub

   
   
   
   


Sub SetVarValue()
	a = 2
   b = -3
   c = 4.12345
   d = -5.6789
   x = 2.123
   y = 5.456
   t = -3.789
   n = 1
   k = 2
   j = 5
   z1.re = 2.123
   z1.im = -1.456
   z2.re = 5.456
   z2.im = 2.789
   z3.re = -3.789
   z3.im = -3.123
End Sub






Sub CalculationsSafe(FS As Long, ct As Long, rt As Long, nc As Long)

  Dim ResR As Double
  Dim ErStr As String
  Dim SPtr As Long
  Dim perf As Double
  Dim res As TComplex
  Dim Sre As String
  Dim Sim As String
  Dim SRez As String
  
  
  Dim FS1  As Long
  Dim FStr As String  
  Dim AStr As String Ptr  
  Dim EStr As String
  Dim AEStr As String Ptr
  Dim Pstr As Any Ptr
  Dim PZStr As ZString Ptr


  Dim FStr1 As String  
  Dim FStr2 As String  

  Dim EStr1 As String
  Dim EStr2 As String
  Dim TCStr As String
 
  Dim ECode As ULong 
  Dim ECode1 As ULong 
  Dim T1 As ULong
  Dim T2 As ULong
  
  Dim nc1 As Long
  Dim adrF As Long


  Dim i As Long
  Dim ServStr As String 
  Dim nd  As Long
  Dim FCalcException As Long
  Dim CErrStr As String

 
 

 
 resf.re=0
 resf.im=0
 
 fzSet(fz_ADDRESS_EXCEPTION_FLAG, @FCalcException)
 
 FCalcException = 0
   
     
   If rt = fz_NONE Then   'no return number   'z1=1+i; z2= z1*i; result=z1/z2
                                                       'x=1; y=x*2; result=x/y
                T1 = GetTickCount
                For i = 1 To nc                  
                     fzResultSafe(FS)
                     If FCalcException <> 0 Then GoTo OnError  '<- exception catched straightway
                Next
                T2 = GetTickCount

              

            Else  'rt <> fz_none
                If ct = fz_REAL Then  'result - real number

                    T1 = GetTickCount
                    For i = 1 To nc                     
                        resf.re = fzResultRSafe(FS)
                       'fzResultDSafe(FS, resf.re)
                        If FCalcException <> 0 Then GoTo OnError  '<- exception catched straightway
                    Next
                    T2 = GetTickCount

                Else                  'result - complex number
                    'ct = fz_Complex; rt = fz_Real,fz_Complex

                    T1 = GetTickCount
                    For i = 0 To nc                   
                        'fzResultCxDSafe(FS, resf.re, resf.im)
                        fzResultCxDPSafe(FS, resf)
                        If FCalcException <> 0 Then GoTo OnError  '<- exception catched straightway
                    Next
                    T2 = GetTickCount

                End If
            End If

     
    
    perf=0
   
    If Abs(T2 - T1) <>  0 Then
      Perf = ((nc / (T2 - T1)) / 1)       
    EndIf
      
    Sre = Str(resf.re)
    Sim = Str(resf.im)
    If resf.im < 0 Then SRez = Sre + Sim + "i" Else: SRez = Sre + " + " + Sim + "i"  
   
   
      Print "Result = ",SRez
      If perf = 0 Then
   	  Print "Performance no define"
      Else
   	  Print "Performance (Expr/ms): ",Int(Perf)
      EndIf 
      
      
      
onError: 'with straight catched errors:
  If FCalcException <> 0 Then
         
     Select Case FCalcException
     	Case 1
           CErrStr = "Invalid Operation"   ' sqrt(-x)
      Case 4
           CErrStr = "Division On Zero"    ' x/sin(x-x)
      Case 5
           CErrStr = "Division On Zero"    ' z1/sin(z1-z1)
      Case 8
           CErrStr = "Floating Overflow"   ' x=1000; x^x
     	Case Else: CErrStr = "Invalid Operation"
    End Select
    Print "ERROR AT CALCULATIONS:  ",CErrStr
 
  End If      
End Sub







Sub Calculations(FS As Long, ct As Long, rt As Long, nc As Long)
 
  Dim ResR As Double
  Dim ErStr As String
  Dim SPtr As Long
  Dim perf As Double
  Dim res As TComplex
  Dim Sre As String
  Dim Sim As String
  Dim SRez As String
  
 
  
  Dim FS1  As Long
  Dim FStr As String  
  Dim AStr As String Ptr  
  Dim EStr As String
  Dim AEStr As String Ptr
  Dim Pstr As Any Ptr
  Dim PZStr As ZString Ptr


  Dim FStr1 As String  
  Dim FStr2 As String  

  Dim EStr1 As String
  Dim EStr2 As String
  Dim TCStr As String
 
  Dim ECode As ULong 
  Dim ECode1 As ULong 
  Dim T1 As ULong
  Dim T2 As ULong
 
  Dim nc1 As Long
  Dim adrF As Long


  Dim i As Long
  Dim ServStr As String 
  Dim nd  As Long
  
  Dim CErrStr As String
  Dim Answer As Long
  

 
 
 resf.re=0
 resf.im=0
 
  
  fzPerform(fz_MASK_FPU_EXCEPTION, 0) '<- exception catched after calculations:  
  
   
    If rt = fz_NONE Then   'no return number   'z1=1+i; z2= z1*i; result=z1/z2
                                                       'x=1; y=x*2; result=x/y
                T1 = GetTickCount
                For i = 1 To nc                  
                     fzResult(FS)                     
                Next
                T2 = GetTickCount

              

    Else  'rt <> fz_none
                If ct = fz_REAL Then  'result - real number

                    T1 = GetTickCount
                    For i = 1 To nc    
                    	  resf.re = fzResultR(FS)
                       'fzResultD(FS, resf.re)                     
                    Next
                    T2 = GetTickCount

                Else                  'result - complex number
                    'ct = fz_Complex; rt = fz_Real,fz_Complex

                    T1 = GetTickCount
                    For i = 0 To nc                   
                        'fzResultCxD(FS, resf.re, resf.im)
                        fzResultCxDP(FS, resf)                      
                    Next
                    T2 = GetTickCount

                End If
            End If

     
    
    perf=0
   
    If Abs(T2 - T1) <>  0 Then
      Perf = ((nc / (T2 - T1)) / 1)       
    EndIf
     
     
  
   fzGet(fz_IS_FPU_EXCEPTION, 0, Answer) '<- exception catched after calculations:
  
   If Answer = fz_NO Then
        Sre = Str(resf.re)
        Sim = Str(resf.im)
        If resf.im < 0 Then SRez = Sre + Sim + "i" Else: SRez = Sre + " + " + Sim + "i"  
     
        Print "Result = ",SRez
        If perf = 0 Then
   	    Print "Performance no define"
        Else
   	    Print "Performance (Expr/ms): ",Int(Perf)
        EndIf 
   Else               
      Print "ERROR AT CALCULATIONS"
   End If
   
   
    endp:
   'Sleep
End Sub





Sub Main()
  Dim FS  As Long
  Dim ResR As Double
  Dim ErStr As String
  Dim SPtr As Long
  Dim perf As Double
  Dim res As TComplex
  Dim Sre As String
  Dim Sim As String
  Dim SRez As String
  Dim ct  As Long
  Dim rt  As Long
  
  Dim FS1  As Long
  Dim FStr As String  
  Dim AStr As String Ptr  
  Dim EStr As String
  Dim AEStr As String Ptr
  Dim Pstr As Any Ptr
  Dim PZStr As ZString Ptr


  Dim FStr1 As String  
  Dim FStr2 As String  

  Dim EStr1 As String
  Dim EStr2 As String
  Dim TCStr As String
 
  Dim ECode As ULong 
  Dim ECode1 As ULong 
  Dim T1 As ULong
  Dim T2 As ULong
  Dim nc As Long
  Dim nc1 As Long
  Dim adrF As Long


  Dim i As Long
  Dim ServStr As String 
  Dim nd  As Long
  Dim FCalcException As Long
  Dim F_SafeCalc As Long

  
'examples:
  'root(z1,3)+(z2.re/z1.im)^2
  'zi1:dblCx = |z1|^n*cossin(arg(z1)*n); zi2:dblCx = |z1|*exp(i*arg(z1)); zi1/zi2
  'z1:dblCx = 1+2i; z2:dblCx = 3-5i; result = z1^log(z1,z2)/z2
   
  
' First way catch errors at calculations: Suppress FPU Exceptions: fzPerform(fz_MASK_FPU_EXCEPTION, 0)
'   and then (after calculations) read error code  fzGet(fz_IS_FPU_EXCEPTION, 0, Answer)
'   for calculations use flResultP,fzResultF,fzResultCxD,fzResultCxDP (more fast than safe proc.)
'   or safe proc. fzResultPSafe, fzResultFSafe (for get error code in FCalcException after calc.)
    
' Second way: set var. for error code (FCalcException) fzSet(fz_ADDRESS_EXCEPTION_FLAG, VarPtr(FCalcException))
'   and read error code in each itteration (If FCalcException <> 0 Then GoTo OnError)
'   for calculations use safe proc.! fzResultPSafe,fzResultFSafe,fzResultCxDSafe,fzResultCxDPSafe. work more slow, but catch error straight
   
F_SafeCalc=0   '=1 CalculationsSafe
 
nc=10000000
Fstr="0"


NxtF:

 
 SetVarValue
  
 Print "********************************"
 Print
 
 Line Input "Set expression:", Fstr1
 If Fstr1 = "" Then Fstr1=Fstr
 Fstr=Fstr1

 Input "Set num. loop (on default 10000000):" , nc1
 If nc1 = 0 Then nc1=nc
 nc=nc1
 
 
 'Input "Type of calc. complex/real (c/r):" , TCStr
 
 If TCStr = "" Then 
 	ct=fz_COMPLEX
 ElseIf TCStr = "c" Then 
 	ct=fz_COMPLEX
 ElseIf TCStr = "r" Then 
 	ct=fz_REAL
 EndIf
   
 ct=fz_COMPLEX
   
 
   
   


    fzSet(fz_CALC_TYPE, ct)
    fzCompile(StrPtr(Fstr), FS)
    fzGetSyntaxErrorCode(ECode)
    if ECode <> 0 Then 
        ErrorHandle 
        GoTo NxtF	
    EndIf

   Print "Wait for calculation"
    
   fzGet(fz_RESULT_TYPE, FS, rt)
   
   If F_SafeCalc = 0 Then
   	Calculations(FS,ct,rt,nc)
   Else
   	CalculationsSafe(FS,ct,rt,nc)
   EndIf  
      



   
fzPerform(fz_FREE, FS)
GoTo NxtF	



 endp:
   Sleep
End Sub



' ************************* Main ************************************
OnLoad
Main




