
#pragma once
#include "ForevalZdll.h"

#define EXTENDED_VAR    ///  <- x,y,t: Extended; z1,z2,z3: TComplexE;  STACK&CONST in ForevalZ : Extended;

//---------------------------------------------------------------------------



#ifdef   EXTENDED_VAR
 typedef  Extended  TFloatType;
  #else
 typedef  double TFloatType;
#endif // EXTENDED_VAR




typedef  __float80 Extended;


struct TSpacer6
			  {
				WORD  spacer1; ///alignment on 16 byte for compliance to Delphi
				WORD  spacer2; ///alignment on 16 byte for compliance to Delphi
				WORD  spacer3; ///alignment on 16 byte for compliance to Delphi
			  } ;

struct TComplexD
			  {
				double re;
				double im;
			  } ;


struct TComplexE
			  {
				Extended re;
				INT32  spacer; ///alignment on 16 byte for compliance to Delphi
				Extended im;
			  } ;


struct TComplexFE
			  {
				Extended re;
				double spacer1;
				double spacer2;
				Extended im;
			  } ;

/**
  In Delphi TComplexE type has .RE(16 bytes) & .IM(16 bytes) . IN GCC  TComplexE type has .RE(12 bytes) & .IM(12 bytes)
  For compliance to Delphi type, need insert spacer 4byte between .RE & .IM fields.
  This work with GCC 4.9.2 version with all optimizations(O1,O2,O3), but  other versions may change size of fields or permute their;

**/


#ifdef   EXTENDED_VAR
  typedef  Extended    TFloatType;
  typedef  TComplexE   TComplex;
  typedef  TComplexFE  TComplexF;
#else
  typedef  double TFloatType;
  typedef  TComplexD  TComplex;
  typedef  TComplexD  TComplexF;
#endif // EXTENDED_VAR

/*
struct TComplex
			  {
				TFloatType re;
				TFloatType im;
			  } ;
*/

typedef TComplexD*   PComplexD ;
typedef TComplexE*   PComplexE ;
typedef TFloatType*  PFloatType ;
