unit ForevalZdll;

{******************************************************************************}
{                                                                              }
{               SOREL  (C)CopyRight 2000. Russia                               }
{                                                                              }
{                          ForevalZ.dll interface unit                         }
{                               ver. 1.3.5.231                                 }
{******************************************************************************}




interface

{$IFDEF FPC}
  {$MODE DELPHI}
{$ENDIF}


{
      (STRING, ANSISTRING, WIDESTRING, UTF8, PANSICHAR) c   
    ForevalZ.dll      :

When connecting to a project need to install a key (STRING, ANSISTRING, WIDESTRING, UTF8, PANSICHAR) corresponding type of passed strings
In the project  at initialization ForevalZ.dll set the same key corresponding commands:

fzSet(fz_STRING_TYPE,fz_STRING_UTF16)
fzSet(fz_STRING_TYPE,fz_ANSISTRING)
fzSet(fz_STRING_TYPE,fz_WIDESTRING)
fzSet(fz_STRING_TYPE,fz_STRING_UTF8)
fzSet(fz_STRING_TYPE,fz_ANSISTRING)
}

 {.$DEFINE STRING}
 {.$DEFINE ANSISTRING}
 {.$DEFINE WIDESTRING}
 {$DEFINE PANSICHAR}
 {.$DEFINE UTF8}



{$IFDEF STRING}       type TStringType = String;       {$ENDIF}   {set fzSet(fz_STRING_TYPE,fz_STRING)} //UTF16 only for delphi2009+

{$IFDEF ANSISTRING}   type TStringType = AnsiString;   {$ENDIF}   {set fzSet(fz_STRING_TYPE,fz_ANSISTRING)}

{$IFDEF WIDESTRING}   type TStringType = WideString;    {$ENDIF}  {set fzSet(fz_STRING_TYPE,fz_WIDESTRING)}

{$IFDEF PANSICHAR}    type TStringType = PAnsiChar;    {$ENDIF}  {set fzSet(fz_STRING_TYPE,fz_PAnsiChar)}

{$IFDEF UTF8}         type TStringType = UTF8String;       {$ENDIF}   {set fzSet(fz_STRING_TYPE,fz_STRING_UTF8) }






const
MathDll = 'ForevalZ.dll';


const
fz_DISABLE              = 0;
fz_ENABLE               = 1;
fz_REAL                 = 2;  //result type
fz_COMPLEX              = 3;  //result type
fz_REAL_DOUBLE          = 4;  //var type
fz_REAL_EXTENDED        = 5;  //var type
fz_REAL_INTEGER         = 6;  //var type
fz_COMPLEX_DOUBLE       = 7;  //var type
fz_COMPLEX_EXTENDED     = 8;  //var type
fz_ARRAY_REAL_DOUBLE    = 9;  //var type
fz_ARRAY_REAL_EXTENDED  = 10; //var type
fz_DIFFER_DOUBLE        = 11; //var type
fz_DIFFER_EXTENDED      = 12; //var type
fz_STACK_VAL            = 13; //call func
fz_STACK_ADR            = 14; //call func
fz_EAX                  = 15; //call func
fz_ESP                  = 16; //call func
fz_CDECL                = 17; //call type
fz_STDCALL              = 18; //call type
fz_PASCAL               = 19; //call type
fz_DOUBLE               = 20; //stack type
fz_EXTENDED             = 21; //stack type
fz_SHOW_EXCEPTION       = 22;
fz_OPTIMIZATION         = 23;
fz_STACK_TYPE           = 24;
fz_STACK_DEEP           = 25;
fz_CALC_TYPE            = 26;
fz_RESULT_TYPE          = 27;
fz_DIFFER               = 28;
fz_INFINITE             = 29;
fz_FREE                 = 30;
fz_CLEAR                = 31;
fz_VAR_LIST             = 32;
fz_CMPL_FUNC_LIST       = 33;
fz_STRING               = 32;
fz_STRING_UTF16         = 32;
fz_PCHAR                = 33;
fz_ANSISTRING           = 34;
fz_STRING_INTERNAL      = 35;
fz_UNKNOWN              = 36;
fz_STRING_TYPE          = 37;
fz_SYNTAX_EXTENSION     = 38;
fz_PRESENT_COMPLEX_NUMBER = 39;
fz_YES                  = 60;
fz_NO                   = 61;
fz_PRECOMPILED          = 62;
fz_COMPILE_STACK_DEEP   = 63;
fz_COMPILE_OVFL         = 64;
fz_DINAMIC_LOAD_NUM     = 65;
fz_PANSICHAR            = 66;
fz_PESENT_VAR           = 67;
fz_NONE                 = 68;  //result type
fz_WIDESTRING           = 69;
fz_ARRAY_LENGTH         = 70;
fz_VERSION                         = 71;
fz_MAJOR                           = 72;
fz_MINOR                           = 73;
fz_RELEASE                         = 74;
fz_ABOUT                           = 75;
fz_BUILD                           = 76;
fz_AUTHOR                          = 77;
fz_EXTENDED_COMMAND                = 78;
fz_STRING_UTF8                     = 79;
fz_ERROR_CODE                      = 80;
fz_ARRAY_REAL_INTEGER              = 81;
fz_SAVE                            = 82;
fz_RESTORE                         = 83;
fz_COMPILED_BY                     = 84;
fz_ENABLE_FUNCTION                 = 85;   {.191}
fz_DISABLE_FUNCTION                = 86;   {.191}
fz_REPLACE_FUNCTIONS               = 87;   {.193}
fz_REPLACE_FUNCTIONS_NUM           = 88;    {.193}
fz_REPLACE_DIV                     = 89;  {.193}
fz_REPLACE_MUL                     = 90;   {.193}
fz_REPLACE_ADDSUB                  = 91;   {.193}
fz_REPLACE_OPERATIONS              = 92;    {.193}
fz_REPLACE_OPERATIONS_NUM          = 93;    {.193}
fz_REPLACE_MULTI_EXPR              = 94;    {.193}
fz_USE_VIRTUAL_ALLOC               = 95;   //only for exe code
fz_LENGTH_CODE                     = 96;   {.193}
fz_SAVE_EAX                        = 97;   {.193}
fz_SAVE_EBX                        = 98;   {.193}
fz_SAVE_ECX                        = 99;   {.193}
fz_SAVE_EDX                        = 100;  {.193}
fz_SAVE_ESP                        = 101;   {.193}
fz_SAVE_EBP                        = 102;  {.193}
fz_SAVE_ESI                        = 103;  {.193}
fz_SAVE_EDI                        = 104;  {.193}
fz_ACCURATE_SPEC_FUNC              = 105;
fz_DINAMIC_LOAD                    = 106;
fz_CHECK_INCORRECT_SPACE           = 107; {.195}
fz_POWER_SYMBOL                    = 108; {.195}
fz_REPLACE_AT_IF                   = 109; {.197}
fz_LOAD_STACK_AFTER_CALC           = 110;  {.197}
fz_ADDRESS_OBJECT                  = 111;  {.197}
fz_FPU_CW                          = 112; {.203}
fz_FPU_CW_DEFAULT                  = 113; {.203} { = $1372 }
fz_FAST_DIV                        = 114; {.205}
fz_COMMENT                         = 115; {.213}
fz_ENABLE_REPLACE_FUNCTION         = 116; {.215}
fz_DISABLE_REPLACE_FUNCTION        = 117; {.215}
fz_ENABLE_CALC_CONST               = 118; {.215}
fz_DISABLE_CALC_CONST              = 119; {.215}
fz_REPLACE_COMPOSITE_FUNCTIONS                 = 120; {.217}
fz_REPLACE_COMPOSITE_FUNCTIONS_COMPLEX         = 121; {.217}
fz_REPLACE_COMPOSITE_FUNCTIONS_REAL            = 122; {.217}
fz_DISABLE_REPLACE_FUNCTION_COMPLEX            = 123; {.217}
fz_DISABLE_REPLACE_FUNCTION_REAL               = 124; {.217}
fz_ENABLE_REPLACE_FUNCTION_COMPLEX             = 125; {.217}
fz_ENABLE_REPLACE_FUNCTION_REAL                = 126; {.217}
fz_OPTIMIZATION_MUL_DIV                        = 127; {.217A}
fz_OPTIMIZATION_A1                             = 128;
fz_OPTIMIZATION_A2                             = 129;
fz_CALC_CONST_EXPRESSION                       = 130;
fz_LEAD_TO_LOWER_CASE                          = 131; {.221}
fz_SKIPPED_IF                                  = 132;  {.221}
fz_CALC_CONST_EXPR_IN_MULTI_EXPR               = 133;   {.221}
fz_PRECISION                                   = 134;
fz_MASK_FPU_EXCEPTION                          = 135;  {.229}
fz_CLEAR_FPU_EXCEPTION                         = 136;  {.229}
fz_IS_FPU_EXCEPTION                            = 137;  {.229}
fz_FREE_CODE_AT_REPLACE                        = 138; {.229}
fz_ADDRESS_EXCEPTION_FLAG                      = 139; {.231}















fz_UNKNOWN_SYMBOL                 = 40;
fz_MISSING_ROUND_BRACKET          = 41;
fz_MISSING_OPERATION              = 43;
fz_WRONG_NUMBER_ARGUMENTS         = 44;
fz_MISSING_EXPRESSION             = 45;
fz_UNKNOWN_FUNCTION               = 46;
fz_ERROR_AT_ADDITION_FUNCTION     = 47;
fz_NOT_DEFINED_OPERATOR           = 48;
fz_NOT_DEFINED_FUNCTION           = 49;
fz_INCORRECT_ARGUMENT             = 50;
fz_MISSING_ARGUMENT               = 51;
fz_INTERNAL_ERROR                 = 52;
fz_INCORRECT_TYPE                 = 53;
fz_MISSING_SEPARATOR              = 54;
fz_WRONG_NAME                     = 55;
fz_CALCULATION_ERROR              = 56;
fz_ABSENT_LOAD_FUNCTION_FOR_TYPE  = 57;
fz_MISSING_SQUARE_BRACKET         = 58;
fz_MISSING_CURLY_BRACKET          = 59;
fz_MISSING_ABS_BRACKET            = 60;
fz_WRONG_EXPRESSION               = 61;
fz_INCORRECT_SPACE                = 62; {.195}
fz_VARIABLE_REDECLARED            = 63;  {.221}



const
 _Complex  = 2; //=T_Complex  !!!
 _Real  = 1;    //=T_Real     !!!
 _Array = 3;  //=T_Array   !!!
 _Integer = 4; //=T_Integer

type TArrayC = array of Cardinal;
type TArrayI = array of Integer;

type
TComplexD =  record
               re: double;
               im: double;
              end;

type
TComplexE = record
            re: extended;
            im: extended;
           end;

type
PComplexE = ^TComplexE;

type
PComplexD = ^TComplexD;

type TArrayD = array of Double;
type TArrayE = array of extended;
type PArrayD = ^TArrayD;
type PArrayE = ^TArrayE;

type
TZAddFuncStruct = record
                    addr:  Pointer;
                CallType:  Cardinal;  //stdcall, cdecl, pascal
                     Arg:  Cardinal;
                 ArgType:  Cardinal;  //
             ArgTypeList:  Pointer;   //
                CallFunc:  Cardinal;
              ResultType:  Cardinal;
                 DeepFPU:  Cardinal;
               CalcConst:  Cardinal;
                 SaveReg:  Cardinal;
                ReplFunc:  Cardinal;   {.193}
                  Resrv1:  Cardinal;
                  Resrv2:  Cardinal;
                  Resrv3:  Cardinal;
                   end;




 //     ForevalZ.dll      Pointer:
 // String(UTF16)  : AnsiString (PAnsiChar) ,WideString, UTF8
//-  String(UTF16)  delphi2009+

 //In real templates of functions in ForevalZ.dll variables of string types are transferred through Pointer:
 //instead of String(UTF16) may use: AnsiString (PAnsiChar),  WideString, UTF8
//The default is set String(UTF16) for  delphi2009+

 //fzSet(fz_STRING_TYPE,fz_ANSISTRING),  fzSet(fz_STRING_TYPE,fz_WIDESTRING),  fzSet(fz_STRING_TYPE,fz_STRING_UTF16),  fzSet(fz_STRING_TYPE,fz_STRING_UTF8),



        procedure fzCompile(Expr: TStringType; var Func: Pointer);                                            stdcall; external MathDll;
        procedure fzSetVar(Name: TStringType; Addr: Pointer; TV: Cardinal);                                    stdcall; external MathDll;
        procedure fzSetFunction(Name: TStringType; FAdr: Pointer);                                              stdcall; external MathDll;
        procedure fzSet(mode: Cardinal; value: Cardinal);                                                      stdcall; external MathDll;
        procedure fzGet(mode,subj: Cardinal; var value: Cardinal);                                                  stdcall; external MathDll;
        procedure fzGetSyntaxErrorCode(var CError: Cardinal);                                                  stdcall; external MathDll;
        procedure fzGetSyntaxErrorString(var SError: {TStringType}Pointer);                                    stdcall; external MathDll;
        //procedure fzRenameFunction(Name,NewName: TStringType);                                                  stdcall; external MathDll;
        procedure fzGetFuncID(Name: TStringType; var IDF: Integer);                                                  stdcall; external MathDll; {.191}
        procedure fzAddNameFunction(IDF: Integer; Name: TStringType);                                               stdcall;  external MathDll;  {.191}
        procedure fzPerform(act,subj: Cardinal);                                                               stdcall; external MathDll;
        procedure fzResultCxD(Func: Pointer; var Re,Im: Double);                                                stdcall;  external MathDll;
        procedure fzResultCxE(Func: Pointer; var Re,Im: Extended);                                                stdcall; external MathDll;
        procedure fzResultCxDP(Func: Pointer;  Res: Pointer);                                                    stdcall; external MathDll;
        procedure fzResultCxEP(Func: Pointer;  Res: Pointer);                                                    stdcall; external MathDll;
        procedure fzResultD(Addr: Pointer;  var Res: double);                                                   stdcall;   external MathDll;
        procedure fzResultE(Addr: Pointer;  var Res: extended);                                                 stdcall; external MathDll;
        procedure fzResult(Func: Pointer);                                                                      stdcall; external MathDll;
        procedure fzResultSafe(Func: Pointer);                                                                  stdcall;  external MathDll;
        procedure fzResultDSafe(Addr: Pointer;  var Res: double);                                               stdcall;  external MathDll;
        procedure fzResultCxDPSafe(Func: Pointer;  Res: Pointer);                                               stdcall; external MathDll;
        procedure fzResultCxDSafe(Addr: Pointer;  var Re,Im: double);                                           stdcall;  external MathDll;
        procedure fzPolarDP(pz: Pointer;  pz1: Pointer);                                                        stdcall; external MathDll;
        procedure fzPolarEP(pz: Pointer;  pz1: Pointer);                                                        stdcall; external MathDll;
        procedure fzDecartDP(pz: Pointer; pz1: Pointer);                                                        stdcall; external MathDll;
        procedure fzDecartEP(pz: Pointer; pz1: Pointer);                                                        stdcall; external MathDll;
        procedure fzSetVarIntrnl(Name: TStringType;  VType: Cardinal; var ExAddr: Pointer);                     stdcall; external MathDll;
        procedure fzSetVarValueD(Addr: Pointer;  Val: Double);                                                  stdcall; external MathDll;
        procedure fzSetVarValueE(Addr: Pointer;  Val: Extended);                                                stdcall; external MathDll;
        procedure fzSetVarValueI(Addr: Pointer;  Val: Integer);                                                 stdcall; external MathDll;
        procedure fzSetVarValueCxD(Addr: Pointer;  ValRe,ValIm: Double);                                        stdcall; external MathDll;
        procedure fzSetVarValueCxE(Addr: Pointer;  ValRe,ValIm: Extended);                                      stdcall; external MathDll;
        procedure fzSetLength(AdrV: Pointer; TypeV: Cardinal; Len: Cardinal);                                   stdcall; external MathDll;
        procedure fzSetArrayValueD(AdrV: Pointer; indx: Cardinal; Val: double);                                 stdcall; external MathDll;
        procedure fzSetArrayValueI(AdrV: Pointer; indx: Cardinal; Val: integer);                                stdcall; external MathDll;
        procedure fzSetArrayValueE(AdrV: Pointer; indx: Cardinal; Val: extended);                               stdcall; external MathDll;
        procedure fzGetArrayValueI(AdrV: Pointer; indx: Cardinal; var Val: integer);                            stdcall; external MathDll;
        procedure fzGetArrayValueD(AdrV: Pointer; indx: Cardinal; var Val: double);                             stdcall; external MathDll;
        procedure fzGetArrayValueE(AdrV: Pointer; indx: Cardinal; var Val: extended);                           stdcall; external MathDll;
        procedure fzGetVarValueE(Addr: Pointer; var Val: Extended);                                             stdcall; external MathDll;
        procedure fzGetVarValueI(Addr: Pointer; var Val: Integer);                                              stdcall; external MathDll;
        procedure fzGetVarValueD(Addr: Pointer; var Val: Double);                                               stdcall; external MathDll;
        procedure fzGetVarValueCxD(Addr: Pointer;  var ValRe,ValIm: Double);                                    stdcall; external MathDll;
        procedure fzGetVarValueCxE(Addr: Pointer;  var ValRe,ValIm: Extended);                                  stdcall; external MathDll;
        procedure fzSetNameImUnit(Name: TStringType);                                                           stdcall; external MathDll;
        procedure fzLoadFPUD(RE: Double; Im: Double);                                                           stdcall; external MathDll;
        procedure fzLoadFPUE(RE: Extended; Im: Extended);                                                       stdcall; external MathDll;
        procedure fzLoadFPUDP(Adr: Pointer);                                                                    stdcall; external MathDll;
        procedure fzLoadFPUEP(Adr: Pointer);                                                                    stdcall; external MathDll;

//internal:
procedure zInitFuncStruct(var FS: TZAddFuncStruct);
function  zCalcFunctionD(Func: Pointer): double;
function  zCalcFunctionE(Func: Pointer): extended;
function  zCalcFunctionZD(Func: Pointer):TComplexD;
function  zCalcFunctionZE(Func: Pointer): TComplexE;





implementation

procedure zInitFuncStruct(var FS: TZAddFuncStruct);
begin
  FS.addr:=nil;
  FS.CallType:=fz_StdCall;
  FS.Arg:=0;
  FS.ArgType:=fz_Differ;
  FS.ArgTypeList:=nil;
  FS.CallFunc:=0;
  FS.ResultType:=0;
  FS.CalcConst:=fz_YES;
  FS.DeepFPU:=8;   //fz_UNKNOWN   //max value = 8 !
  FS.SaveReg:=15;  //=15: save eax,ebx,ecx,edx (RECOMMEND.);  =255 save all reg; see .doc if there are any error
  FS.ReplFunc:=fz_Yes;{.193}
  FS.Resrv2:=0;
  FS.Resrv3:=0;
end;


function zCalcFunctionD(Func: Pointer): double;
  asm
   Call Func
  end;

function zCalcFunctionE(Func: Pointer): extended;
  asm
   Call Func
  end;



function  zCalcFunctionZD(Func: Pointer):TComplexD;
begin
asm
   call Func
   push eax
   mov  eax, [result]
   fstp qword ptr [eax]
   fstp qword ptr [eax+8]
   pop  eax
end;
end;




function zCalcFunctionZE(Func: Pointer): TComplexE;
begin
asm
   call Func
   push eax
   mov  eax, [result]
   fstp tbyte ptr [eax]
   fstp tbyte ptr [eax+16]
   pop  eax
end;
end;



(*
function  zCalcFunctionZD(Func: Pointer):TComplexD;
var
p: TComplexD;
begin
  asm
   call Func
   fstp p.re
   fstp p.im
  end;
result:=p;
end;



function zCalcFunctionZE(Func: Pointer): TComplexE;
var
p: TComplexE;
begin
  asm
   call Func
   fstp p.re
   fstp p.im
  end;
result:=p;
end;
*)


end.






