Attribute VB_Name = "Module1"
'Interface module of ForevallZ.dll for vb6  Lib "ForevalZ.dll"  ( v.1.3.5.231)


Type TZAddFuncStruct
                    Addr    As Long
                CallType    As Long  'stdcall, cdecl, pascal
                     arg    As Long
                 ArgType    As Long
             ArgTypeList    As Long
                CallFunc    As Long
              ResultType    As Long
                 DeepFPU    As Long
               CalcConst    As Long
                 SaveReg    As Long
                ReplFunc    As Long
                  Resrv2    As Long
                  Resrv3    As Long
End Type


Type TComplex
     re As Double
     im As Double
End Type



Public Const fz_DISABLE              As Long = 0
Public Const fz_ENABLE               As Long = 1
Public Const fz_REAL                 As Long = 2   'result type
Public Const fz_COMPLEX              As Long = 3   'result type
Public Const fz_REAL_DOUBLE          As Long = 4   'var type
Public Const fz_REAL_EXTENDED        As Long = 5   'var type
Public Const fz_REAL_INTEGER         As Long = 6   'var type
Public Const fz_COMPLEX_DOUBLE       As Long = 7   'var type
Public Const fz_COMPLEX_EXTENDED     As Long = 8   'var type
Public Const fz_ARRAY_REAL_DOUBLE    As Long = 9   'var type
Public Const fz_ARRAY_REAL_EXTENDED  As Long = 10  'var type
Public Const fz_DIFFER_DOUBLE        As Long = 11  'var type
Public Const fz_DIFFER_EXTENDED      As Long = 12  'var type
Public Const fz_STACK_VAL            As Long = 13  'call func
Public Const fz_STACK_ADR            As Long = 14  'call func
Public Const fz_EAX                  As Long = 15  'call func
Public Const fz_ESP                  As Long = 16  'call func
Public Const fz_CDECL                As Long = 17  'call type
Public Const fz_STDCALL              As Long = 18  'call type
Public Const fz_PASCAL               As Long = 19  'call type
Public Const fz_DOUBLE               As Long = 20  'stack type
Public Const fz_EXTENDED             As Long = 21  'stack type
Public Const fz_SHOW_EXCEPTION       As Long = 22
Public Const fz_OPTIMIZATION         As Long = 23
Public Const fz_STACK_TYPE           As Long = 24
Public Const fz_STACK_DEEP           As Long = 25
Public Const fz_CALC_TYPE            As Long = 26
Public Const fz_RESULT_TYPE          As Long = 27
Public Const fz_DIFFER               As Long = 28
Public Const fz_INFINITE             As Long = 29
Public Const fz_FREE                 As Long = 30
Public Const fz_CLEAR                As Long = 31
Public Const fz_VAR_LIST             As Long = 32
Public Const fz_CMPL_FUNC_LIST       As Long = 33
Public Const fz_VAR_NAME_LOWER_CASE  As Long = 30
Public Const fz_FUNC_NAME_LOWER_CASE As Long = 31
Public Const fz_STRING               As Long = 32
Public Const fz_STRING_UTF16         As Long = 32
Public Const fz_PCHAR                As Long = 33
Public Const fz_ANSISTRING           As Long = 34
Public Const fz_STRING_INTERNAL      As Long = 35
Public Const fz_UNKNOWN              As Long = 36
Public Const fz_STRING_TYPE          As Long = 37
Public Const fz_SYNTAX_EXTENSION     As Long = 38
Public Const fz_PRESENT_COMPLEX_NUMBER As Long = 39
Public Const fz_YES                  As Long = 60
Public Const fz_NO                   As Long = 61
Public Const fz_PRECOMPILED          As Long = 62
Public Const fz_COMPILE_STACK_DEEP   As Long = 63
Public Const fz_COMPILE_OVFL         As Long = 64
Public Const fz_DINAMIC_LOAD_NUM     As Long = 65
Public Const fz_PANSICHAR            As Long = 66
Public Const fz_PESENT_VAR           As Long = 67
Public Const fz_NONE                 As Long = 68   'result type
Public Const fz_WIDESTRING           As Long = 69
Public Const fz_ARRAY_LENGTH         As Long = 70
Public Const fz_VERSION                         As Long = 71
Public Const fz_MAJOR                           As Long = 72
Public Const fz_MINOR                           As Long = 73
Public Const fz_RELEASE                         As Long = 74
Public Const fz_ABOUT                           As Long = 75
Public Const fz_BUILD                           As Long = 76
Public Const fz_AUTHOR                          As Long = 77
Public Const fz_EXTENDED_COMMAND                As Long = 78
Public Const fz_STRING_UTF8                     As Long = 79
Public Const fz_ERROR_CODE                      As Long = 80
Public Const fz_ARRAY_REAL_INTEGER              As Long = 81
Public Const fz_SAVE                            As Long = 82
Public Const fz_RESTORE                         As Long = 83
Public Const fz_COMPILED_BY                     As Long = 84
Public Const fz_ENABLE_FUNCTION                 As Long = 85
Public Const fz_DISABLE_FUNCTION                As Long = 86
Public Const fz_REPLACE_FUNCTIONS               As Long = 87
Public Const fz_REPLACE_FUNCTIONS_NUM           As Long = 88
Public Const fz_REPLACE_DIV                     As Long = 89
Public Const fz_REPLACE_MUL                     As Long = 90
Public Const fz_REPLACE_ADDSUB                  As Long = 91
Public Const fz_REPLACE_OPERATIONS              As Long = 92
Public Const fz_REPLACE_OPERATIONS_NUM          As Long = 93
Public Const fz_REPLACE_MULTI_EXPR              As Long = 94
Public Const fz_USE_VIRTUAL_ALLOC               As Long = 95
Public Const fz_LENGTH_CODE                     As Long = 96
Public Const fz_SAVE_EAX                        As Long = 97
Public Const fz_SAVE_EBX                        As Long = 98
Public Const fz_SAVE_ECX                        As Long = 99
Public Const fz_SAVE_EDX                        As Long = 100
Public Const fz_SAVE_ESP                        As Long = 101
Public Const fz_SAVE_EBP                        As Long = 102
Public Const fz_SAVE_ESI                        As Long = 103
Public Const fz_SAVE_EDI                        As Long = 104
Public Const fz_ACCURATE_SPEC_FUNC              As Long = 105
Public Const fz_DINAMIC_LOAD                    As Long = 106
Public Const fz_CHECK_INCORRECT_SPACE           As Long = 107
Public Const fz_POWER_SYMBOL                    As Long = 108
Public Const fz_REPLACE_AT_IF                   As Long = 109
Public Const fz_LOAD_STACK_AFTER_CALC           As Long = 110
Public Const fz_ADDRESS_OBJECT                  As Long = 111
Public Const fz_FPU_CW                          As Long = 112
Public Const fz_FPU_CW_DEFAULT                  As Long = 113
Public Const fz_FAST_DIV                        As Long = 114
Public Const fz_COMMENT                         As Long = 115
Public Const fz_ENABLE_REPLACE_FUNCTION         As Long = 116
Public Const fz_DISABLE_REPLACE_FUNCTION        As Long = 117
Public Const fz_ENABLE_CALC_CONST               As Long = 118
Public Const fz_DISABLE_CALC_CONST              As Long = 119
Public Const fz_REPLACE_COMPOSITE_FUNCTIONS            As Long = 120
Public Const fz_REPLACE_COMPOSITE_FUNCTIONS_COMPLEX    As Long = 121
Public Const fz_REPLACE_COMPOSITE_FUNCTIONS_REAL       As Long = 122
Public Const fz_DISABLE_REPLACE_FUNCTION_COMPLEX       As Long = 123
Public Const fz_DISABLE_REPLACE_FUNCTION_REAL          As Long = 124
Public Const fz_ENABLE_REPLACE_FUNCTION_COMPLEX        As Long = 125
Public Const fz_ENABLE_REPLACE_FUNCTION_REAL           As Long = 126
Public Const fz_OPTIMIZATION_MUL_DIV                   As Long = 127
Public Const fz_OPTIMIZATION_A1                        As Long = 128
Public Const fz_OPTIMIZATION_A2                        As Long = 129
Public Const fz_CALC_CONST_EXPRESSION                  As Long = 130
Public Const fz_LEAD_TO_LOWER_CASE                     As Long = 131
Public Const fz_SKIPPED_IF                             As Long = 132
Public Const fz_CALC_CONST_EXPR_IN_MULTI_EXPR          As Long = 133
Public Const fz_PRECISION                              As Long = 134
Public Const fz_MASK_FPU_EXCEPTION                     As Long = 135
Public Const fz_CLEAR_FPU_EXCEPTION                    As Long = 136
Public Const fz_IS_FPU_EXCEPTION                       As Long = 137
Public Const fz_FREE_CODE_AT_REPLACE                   As Long = 138
Public Const fz_ADDRESS_EXCEPTION_FLAG                 As Long = 139









Public Const fz_UNKNOWN_SYMBOL                 As Long = 40
Public Const fz_MISSING_ROUND_BRACKET          As Long = 41
Public Const fz_MISSING_OPERATION              As Long = 43
Public Const fz_WRONG_NUMBER_ARGUMENTS         As Long = 44
Public Const fz_MISSING_EXPRESSION             As Long = 45
Public Const fz_UNKNOWN_FUNCTION               As Long = 46
Public Const fz_ERROR_AT_ADDITION_FUNCTION     As Long = 47
Public Const fz_NOT_DEFINED_OPERATOR           As Long = 48
Public Const fz_NOT_DEFINED_FUNCTION           As Long = 49
Public Const fz_INCORRECT_ARGUMENT             As Long = 50
Public Const fz_MISSING_ARGUMENT               As Long = 51
Public Const fz_INTERNAL_ERROR                 As Long = 52
Public Const fz_INCORRECT_TYPE                 As Long = 53
Public Const fz_MISSING_SEPARATOR              As Long = 54
Public Const fz_WRONG_NAME                     As Long = 55
Public Const fz_CALCULATION_ERROR              As Long = 56
Public Const fz_ABSENT_LOAD_FUNCTION_FOR_TYPE  As Long = 57
Public Const fz_MISSING_SQUARE_BRACKET         As Long = 58
Public Const fz_MISSING_CURLY_BRACKET          As Long = 59
Public Const fz_MISSING_ABS_BRACKET            As Long = 60
Public Const fz_WRONG_EXPRESSION               As Long = 61
Public Const fz_INCORRECT_SPACE                As Long = 62
Public Const fz_VARIABLE_REDECLARED            As Long = 63





 
 
Public Declare Sub fzCompile Lib "ForevalZ.dll" (ByVal Expr As String, ByRef Func As Long)
Public Declare Sub fzSetVar Lib "ForevalZ.dll" (ByVal Name As String, ByVal Addr As Long, ByVal TV As Long)
Public Declare Sub fzSetFunction Lib "ForevalZ.dll" (ByVal Name As String, ByVal FAdr As Long)
Public Declare Sub fzSet Lib "ForevalZ.dll" (ByVal mode As Long, ByVal value As Long)
Public Declare Sub fzGet Lib "ForevalZ.dll" (ByVal mode As Long, ByVal Subj As Long, ByRef value As Long)
Public Declare Sub fzGetStr Lib "ForevalZ.dll" Alias "fzGet" (ByVal mode As Long, ByVal Subj As Long, ByRef StrInfo As String)
Public Declare Sub fzGetSyntaxErrorCode Lib "ForevalZ.dll" (ByRef CError As Long)
Public Declare Sub fzGetSyntaxErrorString Lib "ForevalZ.dll" (ByRef SError As String)
Public Declare Sub fzGetFuncID Lib "ForevalZ.dll" (ByVal NameF As String, ByRef IDF As Long)
Public Declare Sub fzAddNameFunction Lib "ForevalZ.dll" (ByVal IDF As Long, ByVal NameF As String)
'Public Declare Sub fzRenameFunction Lib "ForevalZ.dll" (ByVal Name As String, ByVal NewName As String)
Public Declare Sub fzPerform Lib "ForevalZ.dll" (ByVal act As Long, ByVal Subj As Long)
Public Declare Sub fzResultCxD Lib "ForevalZ.dll" (ByVal Func As Long, ByRef re As Double, ByRef im As Double)
'Public Declare Sub  fzResultCxE Lib "ForevalZ.dll"  (ByVal Func As Long ByRef Re,Im Extended)
Public Declare Sub fzResultCxDP Lib "ForevalZ.dll" (ByVal Func As Long, ByRef res As TComplex)
'Public Declare Sub  fzResultCxEP Lib "ForevalZ.dll"  (ByVal Func As Long  Res As Long)
Public Declare Sub fzResultD Lib "ForevalZ.dll" (ByVal Addr As Long, ByRef res As Double)
'Public Declare Sub  fzResultE Lib "ForevalZ.dll"  (ByVal Addr As Long  ByRef Res extended)
Public Declare Sub fzResult Lib "ForevalZ.dll" (ByVal Func As Long)
Public Declare Function fzResultR Lib "ForevalZ.dll" Alias "fzResult" (ByVal Addr As Long) As Double
Public Declare Function fzResultFSafe Lib "ForevalZ.dll" Alias "fzResultSafe" (ByVal Addr As Long) As Double
Public Declare Sub fzResultPSafe Lib "ForevalZ.dll" Alias "fzResultSafe" (ByVal Func As Long)
Public Declare Sub fzResultCxDSafe Lib "ForevalZ.dll" (ByVal Func As Long, ByRef re As Double, ByRef im As Double)
Public Declare Sub fzResultCxDPSafe Lib "ForevalZ.dll" (ByVal Func As Long, ByRef res As TComplex)

                        

Public Declare Sub fzPolarDP Lib "ForevalZ.dll" (ByVal pz As Long, ByVal pz1 As Long)
'Public Declare Sub  fzPolarEP Lib "ForevalZ.dll"  (ByVal pz As Long  pz1 As Long)
Public Declare Sub fzDecartDP Lib "ForevalZ.dll" (ByVal pz As Long, ByVal pz1 As Long)
'Public Declare Sub  fzDecartEP Lib "ForevalZ.dll"  (ByVal pz As Long pz1 As Long)
Public Declare Sub fzSetVarIntrnl Lib "ForevalZ.dll" (ByVal Name As String, ByVal VType As Long, ByRef ExAddr As Long)
Public Declare Sub fzSetVarValueD Lib "ForevalZ.dll" (ByVal Addr As Long, ByVal Val As Double)
'Public Declare Sub  fzSetVarValueE Lib "ForevalZ.dll"  (ByVal Addr As Long  Val Extended)
Public Declare Sub fzSetVarValueI Lib "ForevalZ.dll" (ByVal Addr As Long, ByVal Val As Long)
Public Declare Sub fzSetVarValueCxD Lib "ForevalZ.dll" (ByVal Addr As Long, ByVal re As Double, ByVal im As Double)
'Public Declare Sub  fzSetVarValueCxE Lib "ForevalZ.dll"  (ByVal Addr As Long  ValRe,ValIm Extended)
Public Declare Sub fzSetLength Lib "ForevalZ.dll" (ByVal adrV As Long, ByVal TypeV As Long, ByVal lenV As Long)
Public Declare Sub fzSetArrayValueD Lib "ForevalZ.dll" (ByVal adrV As Long, ByVal indx As Long, ByVal Val As Double)
Public Declare Sub fzSetArrayValueI Lib "ForevalZ.dll" (ByVal adrV As Long, ByVal indx As Long, ByVal Val As Long)

'Public Declare Sub  fzSetArrayValueE Lib "ForevalZ.dll"  (ByVal AdrV As Long indx As Long Val extended)
Public Declare Sub fzGetArrayValueD Lib "ForevalZ.dll" (ByVal adrV As Long, ByVal indx As Long, ByRef Val As Double)
Public Declare Sub fzGetArrayValueI Lib "ForevalZ.dll" (ByVal adrV As Long, ByVal indx As Long, ByRef Val As Long)
'Public Declare Sub  fzGetArrayValueE Lib "ForevalZ.dll"  (ByVal AdrV As Long indx As Long ByRef Val extended)
Public Declare Sub fzSetNameImUnit Lib "ForevalZ.dll" (ByVal Name As String)

 Public Declare Sub fzGetVarValueD Lib "ForevalZ.dll" (ByVal Addr As Long, ByRef Val As Double)

'Public Declare Sub fzGetVarValueE Lib "ForevalZ.dll"  (Addr: Pointer; ByRef Val: Extended);
Public Declare Sub fzGetVarValueI Lib "ForevalZ.dll" (ByVal Addr As Long, ByRef Val As Long)
Public Declare Sub fzGetVarValueCxD Lib "ForevalZ.dll" (ByVal Addr As Long, ByRef ValRe As Double, ByRef ValIm As Double)
'Public Declare Sub fzGetVarValueCxE Lib "ForevalZ.dll"  (Addr: Pointer;  ByRef ValRe,ValIm: Extended);
       
Public Declare Sub fzLoadFPUD Lib "ForevalZ.dll" (ByVal VRe As Double, ByVal VIm As Double)
'Public Declare Sub  fzLoadFPUE Lib "ForevalZ.dll"  (ByVal RE Extended Im Extended)
Public Declare Sub fzLoadFPUDP Lib "ForevalZ.dll" (ByRef AdrZ As TComplex)
'Public Declare Sub  fzLoadFPUEP Lib "ForevalZ.dll"  (ByVal RE As Long{Extended} Im As Long{Extended})
        
        
 
'if any arg. in function is complex that all arg. passed  ByRef and CallType=fz_STACK_ADR !!!
'for stdcall only with real double args return real value
Public Sub zInitFuncStruct(ByRef FZHandle As TZAddFuncStruct)
 FZHandle.Addr = 0
 FZHandle.CallType = fz_STDCALL    'As stdcall
 FZHandle.arg = 0
 FZHandle.ArgType = fz_REAL_DOUBLE      'arg. only real
 FZHandle.ArgTypeList = 0
 FZHandle.CallFunc = fz_STACK_VAL  'ByVal
 FZHandle.ResultType = fz_REAL     'return real
 FZHandle.CalcConst = fz_YES
 FZHandle.DeepFPU = 8             'max=8: better then fz_UNKNOWN; if return complex than  >=2
 FZHandle.SaveReg = 15            '=15: save eax,ebx,ecx,edx (RECOMMEND.);  =255 save all reg; see .doc if there are any error
 FZHandle.ReplFunc = fz_YES
 FZHandle.Resrv2 = 0
 FZHandle.Resrv3 = 0
End Sub





